<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" indent="no" encoding="UTF-8" />
	<xsl:param name="num_fact" />
	<xsl:param name="feuille" />
	<xsl:param name="co_fact" select="EDI/FACTURE/FACT_HEADER/COFACT" />

	<!-- Construction de la facture  					-->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	-->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	-->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	-->
	<!-- Début Construction de la structure de la page -->

	<xsl:template match="EDI">
		<head>
			<xsl:text disable-output-escaping="yes">
				&lt;LINK HREF='
			</xsl:text>
			<xsl:choose>
				<xsl:when test="FACTURE/FACT_HEADER/TYPE='BLEU'">
					bleu.css
				</xsl:when>
			</xsl:choose>
			<xsl:text disable-output-escaping="yes">
				' TYPE='text/css' REL='stylesheet' /&gt;
			</xsl:text>

			<title>Facture EDF</title>
			<xsl:choose>
				<xsl:when test="FACTURE/FACT_HEADER/TYPE='JAUNE'">
					<style type="text/css">
						.bg { background-color:#FFFFFF; color : #000000;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; }

						.txtEDF { background-color:#FFFFFF; color :
						#0000FF; font-size: 12pt; font-family : verdana;
						text-decoration: none; } .txtEDFW {
						background-color:#0000FF; color : #FFFFFF;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; }

						.txtEDFpetitpetitW { background-color:#0000FF;
						color : #FFFFFF; font-size: 7pt; font-family :
						verdana; text-decoration: none; } .txt {
						background-color:#FFFFAA; color : #000000;
						font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetit { background-color:#FFFFAA; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetit { background-color:#FFFFAA; color
						: #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }

						.txtBGW { background-color:#FFFFFF; color :
						#000000; font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitBGW { background-color:#FFFFFF; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetitBGW { background-color:#FFFFFF;
						color : #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }

						.txtBGG { background-color:#E9EABF; color :
						#000000; font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitBGG { background-color:#E9EABF; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; } .txtpetitBGGW {
						background-color:#DDDDDD; color : #000000;
						font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetitBGG { background-color:#E9EABF;
						color : #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }
					</style>
				</xsl:when>
				<xsl:when test="FACTURE/FACT_HEADER/TYPE='BLEU'">
					<style type="text/css">
						.bg { background-color:#FFFFFF; color : #000000;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; }

						.txtEDF { background-color:#FFFFFF; color :
						#0000FF; font-size: 12pt; font-family : verdana;
						text-decoration: none; } .txtEDFW {
						background-color:#0000FF; color : #FFFFFF;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; }

						.txtEDFpetitpetitW { background-color:#0000FF;
						color : #FFFFFF; font-size: 7pt; font-family :
						verdana; text-decoration: none; } .txt {
						background-color:#AABBFF; color : #000000;
						font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetit { background-color:#AABBFF; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetit { background-color:#AABBFF; color
						: #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }

						.txtBGW { background-color:#FFFFFF; color :
						#000000; font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitBGW { background-color:#FFFFFF; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetitBGW { background-color:#FFFFFF;
						color : #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }

						.txtBGG { background-color:#C4CFE6; color :
						#000000; font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitBGG { background-color:#C4CFE6; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; } .txtpetitBGGW {
						background-color:#DDDDDD; color : #000000;
						font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetitBGG { background-color:#C4CFE6;
						color : #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }
					</style>
				</xsl:when>
				<xsl:when test="FACTURE/FACT_HEADER/TYPE='VERT'">
					<style type="text/css">
						.bg { background-color:#FFFFFF; color : #000000;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; } .txtEDF {
						background-color:#FFFFFF; color : #0000FF;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; } .txtEDFW {
						background-color:#0000FF; color : #FFFFFF;
						font-size: 12pt; font-family : verdana;
						text-decoration: none; } .txtEDFpetitpetitW {
						background-color:#0000FF; color : #FFFFFF;
						font-size: 7pt; font-family : verdana;
						text-decoration: none; } .txt {
						background-color:#C1E7C2; color : #000000;
						font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetit { background-color:#C1E7C2; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetit { background-color:#C1E7C2; color
						: #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }

						.txtBGW { background-color:#FFFFFF; color :
						#000000; font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitBGW { background-color:#FFFFFF; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetitBGW { background-color:#FFFFFF;
						color : #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }

						.txtBGG { background-color:#CCDDCC; color :
						#000000; font-size: 10pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitBGG { background-color:#CCDDCC; color :
						#000000; font-size: 9pt; font-family : verdana;
						text-decoration: none; } .txtpetitBGGW {
						background-color:#DDDDDD; color : #000000;
						font-size: 9pt; font-family : verdana;
						text-decoration: none; }

						.txtpetitpetitBGG { background-color:#CCDDCC;
						color : #000000; font-size: 7pt; font-family :
						verdana; text-decoration: none; }
					</style>
				</xsl:when>
			</xsl:choose>

		</head>
		<body class="bg">
			<table border='0' width="650" cellspacing="0"
				cellpadding="0">
				<tr>
					<td width="50" class="txtEDFW" align="center">
						<b>
							<i>EDF</i>
						</b>
					</td>
					<td width="800" class="txtEDF" align="center">
						<b>
							<i>Electricité de France</i>
						</b>
					</td>
					<td width="300" align="right">
						<i>FACTURE</i>
					</td>
				</tr>
				<tr height="1">
					<td width="50" class="txtEDFW">
						<hr color="#FF0000" />
					</td>
					<td colspan="2" height="1">
						<hr color="#FF0000" />
					</td>
				</tr>
				<tr>
					<td class="txtEDFpetitpetitW" align="center">
						<i>
							Electricité
							<br />
							de France
						</i>
					</td>
					<td class="txtEDF"></td>
					<td class="txtEDF"></td>
				</tr>
				<tr>
					<td colspan="3">
						<xsl:apply-templates
							select="FACTURE/FACT_HEADER" />
						<xsl:apply-templates
							select="FACTURE/FACT_LIGNE" />
						<xsl:apply-templates select="FACTURE/FACT_FOOT" />
					</td>
				</tr>
			</table>
		</body>
	</xsl:template>
	<!-- Fin Construction de la structure de la page   -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	-->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	-->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 	-->
	<!-- Début Construction de l'en tête  				-->

	<xsl:template match="FACT_HEADER">
		<table border='0' width="100%" cellspacing="1"
			cellpadding="1">
			<tr>
				<td class="txtpetitBGW">
					<xsl:choose>
						<xsl:when test="COFACT=1">
							FACTURATION SUR RELEVE
						</xsl:when>
						<xsl:when test="COFACT=2">
							FACTURATION INTERMEDIAIRE
						</xsl:when>
						<xsl:when test="COFACT=3">
							FACTURATION ESTIMATIVE
						</xsl:when>
						<xsl:when test="COFACT=4">
							FACTURATION DE RESILIES
						</xsl:when>
						<xsl:when test="COFACT=5">
							FACTURATION FRAIS FIXES
						</xsl:when>
						<xsl:when test="COFACT=6">
							FACTURATION RECTIFICATION AUTOMATIQUE 1
						</xsl:when>
						<xsl:when test="COFACT=7">
							FACTURATION RECTIFICATION AUTOMATIQUE 2
						</xsl:when>
						<xsl:when test="COFACT=8">
							FACTURATION RECTIFICATION AUTOMATIQUE 3
						</xsl:when>
						<xsl:when test="COFACT=20">
							FACTURATION AVOIR AUTOMATIQUE 1
						</xsl:when>
						<xsl:when test="COFACT=21">
							FACTURATION AVOIR AUTOMATIQUE 2
						</xsl:when>
						<xsl:when test="COFACT=22">
							FACTURATION AVOIR AUTOMATIQUE 3
						</xsl:when>
						<xsl:when test="COFACT=40">
							FACTURATION AVOIR SEUL
						</xsl:when>
						<xsl:when test="COFACT=50">
							FACTURE DEBUT DE CONTRAT
						</xsl:when>
						<xsl:when test="COFACT=51">
							FACTURE REGULARISATION DE MENSUALITE
						</xsl:when>
						<xsl:when test="COFACT=99">
							<xsl:choose>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=1">
									FACTURE SUR RELEVE
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=2">
									FACTURE SUR INDEX ESTIME
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=3">
									FACTURE SUR DEBUT DE CONTRAT
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=4">
									FACTURE SUR FIN DE CONTRAT
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=5">
									FACTURE SUR REGULARISATION DE
									MENSUALITE
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=6">
									CONTRAT EN COURS-SITUATION AVANT
									CHANGEMENT
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=7">
									CONTRAT EN COURS-SITUATION APRES
									CHANGEMENT
								</xsl:when>
								<xsl:when
									test="../FACT_LIGNE/CALCUL_PRIME/TYPE_FACT=9">
									FACTURE SANS CONSOMMATION FACTUREE
								</xsl:when>
							</xsl:choose>
						</xsl:when>
					</xsl:choose>
					<br />
					N°
					<xsl:value-of select="NUM_FACT" />
					DU
					<xsl:value-of select="substring(DATE, 7, 2)" />
					/
					<xsl:value-of select="substring(DATE, 5, 2)" />
					/
					<xsl:value-of select="substring(DATE, 1, 4)" />
					<br />
					<span class="txtpetitpetitBGW">
						Votre service local:
						<br />
					</span>
					<xsl:for-each select="SERVICE">
						<xsl:value-of select="SERVICE_NOM" />
						<xsl:if test="SERVICE_NOM">
							<br />
						</xsl:if>
						<xsl:value-of select="SERVICE_ADR1" />
						<xsl:if test="SERVICE_ADR1">
							<br />
						</xsl:if>
						<xsl:value-of select="SERVICE_ADR2" />
						<xsl:if test="SERVICE_ADR2">
							<br />
						</xsl:if>
						<xsl:value-of select="SERVICE_CPVILLE" />
						<xsl:if test="SERVICE_CPVILLE">
							<br />
						</xsl:if>
					</xsl:for-each>
					<span class="txtpetitpetitBGW">
						Tel. renseignements:
					</span>
					<xsl:value-of select="TEL" />
					<br />
					<xsl:value-of select="COLLABO" />
					<br />
					<table border='1' width="100%" cellspacing="0"
						cellpadding="0">
						<tr>
							<td class="txtpetitBGW">
								MONTANT
								<xsl:value-of select="PAIEMENT" />
							</td>
							<td class="txtpetitBGW">LE</td>
						</tr>
						<tr>
							<td class="txtpetitBGGW" align="center">
								<xsl:value-of select="MONTANT" />
							</td>
							<td class="txtpetitBGGW" align="center">
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
								<xsl:value-of
									select="substring(DATE_PRELEV, 7, 2)" />
								<xsl:if
									test="not(substring(DATE_PRELEV, 7, 2)='')">
									/
								</xsl:if>
								<xsl:value-of
									select="substring(DATE_PRELEV, 5, 2)" />
								<xsl:if
									test="not(substring(DATE_PRELEV, 7, 2)='')">
									/
								</xsl:if>
								<xsl:value-of
									select="substring(DATE_PRELEV, 1, 4)" />
							</td>
						</tr>
					</table>
				</td>
				<td class="txtpetitBGW">
					<span class="txtpetitpetitBGW">
						Nom et adresse du lieu de consommation:
						<br />
					</span>
					<xsl:for-each select="LIEU_CONSO">
						<xsl:value-of select="LIEU_CONSO_NOM" />
						<br />
						<xsl:value-of select="LIEU_CONSO_ADR1" />
						<br />
						<xsl:value-of select="LIEU_CONSO_CPVILLE" />
						<br />
					</xsl:for-each>
					<span class="txtpetitpetitBGW">
						Nom et adresse du destinataire de la facture:
						<br />
					</span>
					<xsl:value-of select="PAYEUR/PAYEUR_NOM" />
					<br />
					<xsl:value-of select="CODE_PAYEUR" />
					*
					<xsl:value-of select="CODE_PAYEUR2" />
					<br />
					<xsl:value-of select="PAYEUR/PAYEUR_ADR1" />
					<br />
					<xsl:value-of select="PAYEUR/PAYEUR_ADR2" />
					<br />
					<xsl:value-of select="PAYEUR/PAYEUR_CPVILLE" />
					<br />
					<br />
					<span class="txtpetitpetitBGW">
						Notre référence:
					</span>
					<xsl:value-of select="REFERENCE" />
				</td>
			</tr>

		</table>
	</xsl:template>

	<!-- Fin Construction de l'en tête  			-->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- Début Construction des lignes  			-->


	<xsl:template match="FACT_LIGNE">
		<table width="100%" border="1" cellspacing="0"
			cellpadding="0">
			<tr>
				<th class="txtpetitBGG">
					CONTRAT DE FOURNITURE
					<xsl:if test='FTX_PRODUITS_DATE'>
						venant à échéance le
						<xsl:value-of
							select="substring(FTX_PRODUITS_DATE, 7, 2)" />
						/
						<xsl:value-of
							select="substring(FTX_PRODUITS_DATE, 5, 2)" />
						/
						<xsl:value-of
							select="substring(FTX_PRODUITS_DATE, 1, 4)" />
					</xsl:if>
				</th>
			</tr>
			<tr>
				<td class="txtpetit">
					<xsl:if test="PRIME_FIXE_VERT">
						<xsl:for-each select="PRIME_FIXE_VERT">
							<xsl:if test="not(DUREE='')">
								PRIME FIXE
								<xsl:if test="COEFF">
									(MINOREE DE
									<xsl:value-of select="COEFF" />
									%
									<xsl:if test="DUREE">
										POUR CONTRAT DE
										<xsl:value-of select="DUREE" />
										ans
									</xsl:if>
									)
								</xsl:if>
								<br />
							</xsl:if>
						</xsl:for-each>
					</xsl:if>
					TARIF
					<xsl:value-of select="TARIF" />
					<br />
					PUISSANCE SOUSCRITE :
					<xsl:choose>
						<xsl:when test="../FACT_HEADER/TYPE='BLEU'">
							<xsl:value-of
								select="CALCUL_PRIME/PUISSANCE" />
							KVA
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="QTY_PRODUITS" />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
							<xsl:value-of select="QTY_UNITE_PRODUITS" />
						</xsl:otherwise>
					</xsl:choose>
					<br />
					HORAIRE DES HEURES CREUSES :
					<xsl:value-of select="HORAIRE" />
				</td>
			</tr>
		</table>
		<table width="100%" border="1" cellspacing="0"
			cellpadding="0">
			<tr>
				<th class="txtpetitBGG">DETAIL DE LA FACTURATION</th>
				<th class="txtpetitpetitBGG">Quantité</th>
				<th class="txtpetitpetitBGG">Prix unitaire</th>
				<th class="txtpetitpetitBGG">TVA</th>
				<th class="txtpetitpetitBGG">Montant hors taxes</th>
			</tr>
			<xsl:if test="LIB_CONSO!=''">
				<tr>
					<td class="txtpetit">
						<b>CONSOMMATIONS</b>
						<xsl:for-each select="LIB_CONSO">
							<br />
							<xsl:value-of select="text()" />
							<xsl:variable name="text_lib_conso"
								select="text()">
							</xsl:variable>
							<xsl:for-each
								select="../CONSO_EA_VERT_BASE/NOM">
								<xsl:if
									test="substring($text_lib_conso,27,3)=text()">
									<font class="txtpetitpetit">
										<br />
										<xsl:if test="../CONSO!=''">
											Conso:
										</xsl:if>
										<xsl:value-of select="../CONSO" />
										<xsl:text
											disable-output-escaping="yes">
											&amp;nbsp;&amp;nbsp;
										</xsl:text>
										<xsl:if
											test="../PERTE_FER!=''">
											Pertes Fer:
										</xsl:if>
										<xsl:value-of
											select="../PERTE_FER" />
										<xsl:text
											disable-output-escaping="yes">
											&amp;nbsp;&amp;nbsp;
										</xsl:text>
										<xsl:if
											test="../PERTE_JOUL!=''">
											Pertes Joules:
										</xsl:if>
										<xsl:value-of
											select="../PERTE_JOUL" />
										<xsl:text
											disable-output-escaping="yes">
											&amp;nbsp;&amp;nbsp;
										</xsl:text>
										<xsl:if
											test="../CONSO_DE!=''">
											Conso en décompte:
										</xsl:if>
										<xsl:value-of
											select="../CONSO_DE" />
									</font>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<table border="0" align="right">
							<tr>
								<td class="txtpetit" align="right">
									<xsl:for-each select="QTY_CONSO">
										<br />
										<xsl:value-of select="text()" />
										<xsl:if
											test="../CONSO_EA_VERT_BASE/NOM!=''">
											<br />
										</xsl:if>
									</xsl:for-each>
								</td>
								<td class="txtpetit" align="right">
									<xsl:for-each
										select="QTY_UNITE_CONSO">
										<br />
										<xsl:value-of select="text()" />
										<xsl:if
											test="../CONSO_EA_VERT_BASE/NOM!=''">
											<br />
										</xsl:if>
									</xsl:for-each>
								</td>
							</tr>
						</table>
						<xsl:if test="CONSO_EA_VERT_BASE/NOM!=''">
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
						</xsl:if>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_CONSO">
							<br />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
							<xsl:value-of select="text()" />
							<xsl:if
								test="../CONSO_EA_VERT_BASE/NOM!=''">
								<br />
							</xsl:if>
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_CONSO">
							<br />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
							<xsl:value-of select="text()" />
							<xsl:if
								test="../CONSO_EA_VERT_BASE/NOM!=''">
								<br />
							</xsl:if>
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_CONSO">
							<br />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
							<xsl:value-of select="text()" />
							<xsl:if
								test="../CONSO_EA_VERT_BASE/NOM!=''">
								<br />
							</xsl:if>
						</xsl:for-each>

					</td>
				</tr>
			</xsl:if>
			<xsl:if test="LIB_CONSO_ACC!=''">
				<tr>
					<td class="txtpetit">
						<xsl:for-each select="LIB_CONSO_ACC">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_CONSO_ACC">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>

					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_CONSO_ACC">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_CONSO_ACC">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_CONSO_ACC">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="MOA_CONSO_DEP!='0.00'">
				<tr>
					<td class="txtpetit">
						<xsl:for-each select="LIB_CONSO_DEP">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_CONSO_DEP">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>

					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_CONSO_DEP">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_CONSO_DEP">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_CONSO_DEP">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="LIB_CONSO_REA">
				<tr>
					<td class="txtpetit">
						<xsl:for-each select="LIB_CONSO_REA">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_CONSO_REA">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_CONSO_REA">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_CONSO_REA">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_CONSO_REA">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="LIB_CONSO_QE and not(QTY_CONSO_QE=0)">
				<tr>
					<td class="txtpetit">
						<xsl:for-each select="LIB_CONSO_QE">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_CONSO_QE">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>

					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_CONSO_QE">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_CONSO_QE">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_CONSO_QE">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>

			<tr>
				<td class="txtpetit">
					<b>PUISSANCES</b>
					<table border="0">
						<tr>
							<td class="txtpetit">
								<xsl:for-each select="LIB_PRODUITS">
									<xsl:value-of select="text()" />
									<br />
								</xsl:for-each>
							</td>
							<td class="txtpetit">
								<xsl:for-each
									select="FTXDTM_PRODUITS_DATE">
									<xsl:if test="DATE_DEB"></xsl:if>
									<xsl:value-of
										select="substring(DATE_DEB, 7, 2)" />
									<xsl:if test="DATE_DEB">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_DEB, 5, 2)" />
									<xsl:if test="DATE_DEB">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_DEB, 1, 4)" />
									<xsl:if test="DATE_FIN">AU</xsl:if>
									<xsl:value-of
										select="substring(DATE_FIN, 7, 2)" />
									<xsl:if test="DATE_FIN">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_FIN, 5, 2)" />
									<xsl:if test="DATE_FIN">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_FIN, 1, 4)" />
									<br />
								</xsl:for-each>
							</td>
						</tr>
						<tr>
							<td class="txtpetitpetit" colspan="2">
								<xsl:for-each
									select="FTXDTM_CONSO_DATE">
									<xsl:if test="DATE_DEB">
										Consommation:
									</xsl:if>
									<xsl:value-of
										select="substring(DATE_DEB, 7, 2)" />
									<xsl:if test="DATE_DEB">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_DEB, 5, 2)" />
									<xsl:if test="DATE_DEB">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_DEB, 1, 4)" />
									<xsl:if test="DATE_FIN">AU</xsl:if>
									<xsl:value-of
										select="substring(DATE_FIN, 7, 2)" />
									<xsl:if test="DATE_FIN">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_FIN, 5, 2)" />
									<xsl:if test="DATE_FIN">/</xsl:if>
									<xsl:value-of
										select="substring(DATE_FIN, 1, 4)" />
									<br />
								</xsl:for-each>
							</td>
						</tr>
					</table>
				</td>
				<td class="txtpetit" align="right">
					<xsl:for-each select="QTY_PRODUITS">
						<br />
						<xsl:value-of select="text()" />
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
						<xsl:value-of select="../QTY_UNITE_PRODUITS" />
					</xsl:for-each>

				</td>
				<td class="txtpetit" align="right">
					<xsl:for-each select="PRI_PRODUITS">
						<br />
						<xsl:value-of select="text()" />
					</xsl:for-each>
				</td>
				<td class="txtpetit" align="right">
					<xsl:for-each select="TAX_PRODUITS">
						<br />
						<xsl:value-of select="text()" />
					</xsl:for-each>
				</td>
				<td class="txtpetit" align="right">
					<xsl:for-each select="MOA_PRODUITS">
						<br />
						<xsl:value-of select="text()" />
					</xsl:for-each>
				</td>
			</tr>
			<xsl:if test="LIB_DIVERS!=''">
				<tr>
					<td class="txtpetit">
						<b>DIVERS</b>
						<xsl:for-each select="LIB_DIVERS">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_DIVERS">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_DIVERS">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>

					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_DIVERS">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_DIVERS">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<xsl:for-each select="MINORATION">
				<tr>
					<td class="txtpetit" colspan="4">
						<b>
							<xsl:value-of select="LIB_MINORATION" />
						</b>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
						<xsl:value-of select="POUR_MINORATION" />
						%
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="MONTANT_MINORATION" />
					</td>
				</tr>
			</xsl:for-each>
			<xsl:if test="LIB_TAXE_OCTROI!=''">
				<tr>
					<td class="txtpetit">
						<xsl:for-each select="LIB_TAXE_OCTROI">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_TAXE_OCTROI">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>

					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="PRI_TAXE_OCTROI">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;&amp;nbsp;
						</xsl:text>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_TAXE_OCTROI">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_TAXE_OCTROI">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="LIB_CONSO_ADD">
				<tr>
					<td class="txtpetit">
						<xsl:for-each select="LIB_CONSO_ADD">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="QTY_CONSO_ADD">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="RPI_CONSO_ADD">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;&amp;nbsp;
						</xsl:text>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="TAX_CONSO_ADD">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
					<td class="txtpetit" align="right">
						<xsl:for-each select="MOA_CONSO_ADD">
							<br />
							<xsl:value-of select="text()" />
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<tr>
				<td class="txtpetit">
					<xsl:value-of select="LIB_TAXE_DEPARTEMENT" />
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="QTY_TAXE_DEPARTEMENT" />
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="PRI_TAXE_DEPARTEMENT" />
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="TAX_TAXE_DEPARTEMENT" />
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="MOA_TAXE_DEPARTEMENT" />
				</td>
			</tr>
			<tr>
				<td class="txtpetit">
					<xsl:value-of select="LIB_TAXE_MUNICIPALE" />
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="QTY_TAXE_MUNICIPALE" />
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="PRI_TAXE_MUNICIPALE" />
				</td>
				<td class="txtpetit" align="right">
					<xsl:text disable-output-escaping="yes">
						&amp;nbsp;
					</xsl:text>
					<xsl:value-of select="TAX_TAXE_MUNICIPALE" />
				</td>
				<td class="txtpetit" align="right">
					<xsl:value-of select="MOA_TAXE_MUNICIPALE" />
				</td>
			</tr>
			<tr>
				<td class="txtpetit" colspan="5">
					TAXES MUNICIP.
					<xsl:value-of
						select="FTXT01_TAXE_DEPARTEMENT/FTXT01_TAUX_MUNICIPALE" />
					% et DEPART.
					<xsl:value-of
						select="FTXT01_TAXE_DEPARTEMENT/FTXT01_TAUX_DEPARTEMENT" />
					% SUR
					<xsl:value-of
						select="FTXT01_TAXE_DEPARTEMENT/FTXT01_TAUX_ASSIETTE" />
					% TOTAL ENERGIE
				</td>
			</tr>
		</table>
		<table width="100%" border="1" cellspacing="0"
			cellpadding="0">
			<xsl:if test="CONSO_ENERGIE">
				<tr>
					<th class="txtpetitBGG">Numéro de compteur</th>
					<th class="txtpetitBGG">Coefficient</th>
					<th class="txtpetitpetitBGG">Ancien index</th>
					<th class="txtpetitpetitBGG">Nouvel index</th>
					<th class="txtpetitpetitBGG">Différence</th>
				</tr>
				<xsl:for-each select="CONSO_ENERGIE">
					<tr>
						<td class="txtpetit">
							<xsl:for-each select="NO_COMPTEUR">
								<br />
								<xsl:value-of select="text()" />
							</xsl:for-each>
						</td>
						<td class="txtpetit" align="right">
							<xsl:for-each select="COEFF">
								<br />
								<xsl:value-of select="text()" />
							</xsl:for-each>

						</td>
						<td class="txtpetit" align="right">
							<xsl:for-each select="ANCIEN_INDEX">
								<br />
								<xsl:value-of select="text()" />
							</xsl:for-each>
						</td>
						<td class="txtpetit" align="right">
							<xsl:for-each select="NOUVEL_INDEX">
								<br />
								<xsl:value-of select="text()" />
							</xsl:for-each>
						</td>
						<td class="txtpetit" align="right">
							<xsl:for-each select="DIFF_INDEX">
								<br />
								<xsl:value-of select="text()" />
							</xsl:for-each>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
		</table>
		<table width="100%" border="1" cellspacing="0"
			cellpadding="0">
			<xsl:for-each select="FTXJ11_CONSO">
				<tr>
					<th class="txtpetitBGG">
						Détails des consommations
					</th>
					<th class="txtpetitpetitBGG">HPH</th>
					<th class="txtpetitpetitBGG">HCH</th>
					<th class="txtpetitpetitBGG">HPE</th>
					<th class="txtpetitpetitBGG">HCE</th>
					<xsl:if test="../CALCUL_HORAIRE_DEP">
						<th class="txtpetitpetitBGG">
							<xsl:if
								test="not(../CALCUL_HORAIRE_DEP/NOM='')">
								Seuil
							</xsl:if>
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/NOM" />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
						</th>
					</xsl:if>
				</tr>
				<tr>
					<td class="txtpetitpetit">
						Nouvel index
						<br />
						Ancien index
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HPH_CONSO/HPH_NOUVEL_I" />
						<br />
						<xsl:value-of select="HPH_CONSO/HPH_ANCIEN_I" />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HCH_CONSO/HCH_NOUVEL_I" />
						<br />
						<xsl:value-of select="HCH_CONSO/HCH_ANCIEN_I" />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HPE_CONSO/HPE_NOUVEL_I" />
						<br />
						<xsl:value-of select="HPE_CONSO/HPE_ANCIEN_I" />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HCE_CONSO/HCE_NOUVEL_I" />
						<br />
						<xsl:value-of select="HCE_CONSO/HCE_ANCIEN_I" />
					</td>
					<xsl:if test="../CALCUL_HORAIRE_DEP">
						<td class="txtpetit" align="right">
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/NOUVEL_I" />
							<br />
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/ANCIEN_I" />
						</td>
					</xsl:if>
				</tr>
				<tr>
					<td class="txtpetitpetit">
						Différence
						<br />
						Coefficient de lecture
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HPH_CONSO/HPH_DIFF" />
						<br />
						<xsl:value-of select="HPH_CONSO/HPH_COEFF" />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HCH_CONSO/HCH_DIFF" />
						<br />
						<xsl:value-of select="HCH_CONSO/HCH_COEFF" />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HPE_CONSO/HPE_DIFF" />
						<br />
						<xsl:value-of select="HPE_CONSO/HPE_COEFF" />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of select="HCE_CONSO/HCE_DIFF" />
						<br />
						<xsl:value-of select="HCE_CONSO/HCE_COEFF" />
					</td>
					<xsl:if test="../CALCUL_HORAIRE_DEP">
						<td class="txtpetit" align="right">
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/DIFF" />
							<br />
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/COEFF" />
						</td>
					</xsl:if>
				</tr>
				<tr>
					<td class="txtpetitpetit">
						Consommation
						<br />
						Consommation sur compteur déposé
						<br />
						Forfait
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of
							select="HPH_CONSO/HPH_CONSO_CADRAN" />
						<br />
						<xsl:value-of
							select="HPH_CONSO/HPH_CONSO_COMPTEUR" />
						<br />
						<xsl:value-of select="HPH_CONSO/HPH_FORFAIT" />
						<br />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of
							select="HCH_CONSO/HCH_CONSO_CADRAN" />
						<br />
						<xsl:value-of
							select="HCH_CONSO/HCH_CONSO_COMPTEUR" />
						<br />
						<xsl:value-of select="HCH_CONSO/HCH_FORFAIT" />
						<br />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of
							select="HPE_CONSO/HPE_CONSO_CADRAN" />
						<br />
						<xsl:value-of
							select="HPE_CONSO/HPE_CONSO_COMPTEUR" />
						<br />
						<xsl:value-of select="HPE_CONSO/HPE_FORFAIT" />
						<br />
					</td>
					<td class="txtpetit" align="right">
						<xsl:value-of
							select="HCE_CONSO/HCE_CONSO_CADRAN" />
						<br />
						<xsl:value-of
							select="HCE_CONSO/HCE_CONSO_COMPTEUR" />
						<br />
						<xsl:value-of select="HCE_CONSO/HCE_FORFAIT" />
						<br />
					</td>
					<xsl:if test="../CALCUL_HORAIRE_DEP">
						<td class="txtpetit" align="right">
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/CONSO_CADRAN" />
							<br />
							<xsl:value-of
								select="../CALCUL_HORAIRE_DEP/NOUVEL_I_COMPT" />
							<br />
						</td>
					</xsl:if>
				</tr>
				<tr>
					<td class="txtpetitpetitBGG">Total</td>
					<td class="txtpetit" align="right">
						<b>
							<xsl:value-of
								select="HPH_CONSO/HPH_CONSO_TOTAL" />
						</b>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
					</td>
					<td class="txtpetit" align="right">
						<b>
							<xsl:value-of
								select="HCH_CONSO/HCH_CONSO_TOTAL" />
						</b>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
					</td>
					<td class="txtpetit" align="right">
						<b>
							<xsl:value-of
								select="HPE_CONSO/HPE_CONSO_TOTAL" />
						</b>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
					</td>
					<td class="txtpetit" align="right">
						<b>
							<xsl:value-of
								select="HCE_CONSO/HCE_CONSO_TOTAL" />
						</b>
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
					</td>
					<xsl:if test="../CALCUL_HORAIRE_DEP">
						<td class="txtpetit" align="right">
							<b>
								<xsl:value-of
									select="../CALCUL_HORAIRE_DEP/CONSO_TOTAL" />
							</b>
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
						</td>
					</xsl:if>
				</tr>
			</xsl:for-each>
		</table>
		<xsl:if test="CALCUL_REA_VERT/ENERG_REA!=''">
			<table width="100%" border="1" cellspacing="0"
				cellpadding="0">
				<tr>
					<th class="txtpetitBGG" colspan="8">
						ENERGIE REACTIVE (en kvarh)
					</th>
				</tr>
				<tr>
					<th class="txtpetitBGG" rowspan="2">
						Energie réactive mesurée en P+HP
					</th>
					<th class="txtpetitBGG" rowspan="2">
						Energie active mesurée en P+HP
					</th>
					<th class="txtpetitBGG" colspan="2">
						Tangente PHI au
					</th>
					<th class="txtpetitBGG" rowspan="2">
						kvarh consommées
					</th>
					<th class="txtpetitBGG" rowspan="2">
						kvarh en franchise
					</th>
					<th class="txtpetitBGG" rowspan="2">
						kvarh à facturer
					</th>
					<th class="txtpetitBGG" rowspan="2">
						Prix unitaires en centimes
					</th>
				</tr>
				<tr>
					<th class="txtpetitBGG">secondaire</th>
					<th class="txtpetitBGG">primaire</th>
				</tr>
				<xsl:for-each select="CALCUL_REA_VERT">
					<xsl:if test="ENERG_REA!=''">
						<tr>
							<td class="txtpetit" align="right">
								<xsl:value-of select="ENERG_REA" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="ENERG_ACT" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="TANGENTE_SEC" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="TANGENTE_PRI" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="KVARH_1" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="KVARH_2" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="../QTY_CONSO_REA" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="../PRI_CONSO_REA" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
						</tr>
					</xsl:if>
				</xsl:for-each>
			</table>
		</xsl:if>
		<xsl:if test="CALCUL_PUISSANCE_VERT/NOM!=''">
			<table width="100%" border="1" cellspacing="0"
				cellpadding="0">
				<tr>
					<th class="txtpetitBGG" colspan="6">
						<xsl:value-of
							select="LIBEL_CALCUL_PUISSANCE_VERT" />
					</th>
				</tr>
				<tr>
					<th class="txtpetitBGG">Poste horaire</th>
					<th class="txtpetitBGG">Valeur relevée</th>
					<th class="txtpetitBGG">Coefficient de lecture</th>
					<th class="txtpetitBGG">Valeur mesurée</th>
					<th class="txtpetitBGG">Forfait (+ ou -)</th>
					<th class="txtpetitBGG">Valeur retenue</th>
				</tr>
				<xsl:for-each select="CALCUL_PUISSANCE_VERT">
					<xsl:if test="NOM!=''">
						<tr>
							<td class="txtpetit">
								<xsl:value-of select="NOM" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="VAL" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="COEFF" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="VAL_M" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="SIGNE" />
								<xsl:value-of select="FORFAIT" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="VAL_R" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
						</tr>
					</xsl:if>
				</xsl:for-each>
			</table>
		</xsl:if>
		<xsl:if test="DEP_TARIF_VERT/NOM!=''">
			<table width="100%" border="1" cellspacing="0"
				cellpadding="0">
				<tr>
					<th class="txtpetitBGG" rowspan="2">
						Période tarifaire
					</th>
					<th class="txtpetitBGG" rowspan="2">
						Puissance souscrite
					</th>
					<th class="txtpetitBGG" colspan="4">
						Puissance en kW
					</th>
					<th class="txtpetitBGG" rowspan="2">Dépassement</th>
				</tr>
				<tr>
					<th class="txtpetitBGG">Retenues</th>
					<th class="txtpetitBGG">Pertes</th>
					<th class="txtpetitBGG">Décompte</th>
					<th class="txtpetitBGG">Atteinte</th>
				</tr>
				<xsl:for-each select="DEP_TARIF_VERT">
					<xsl:if test="NOM!=''">
						<tr>
							<td class="txtpetit">
								<xsl:value-of select="NOM" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit">
								<xsl:variable name="text_nom"
									select="NOM" />
								<xsl:for-each
									select="../PRIME_FIXE_VERT/DETAIL/NOM">
									<xsl:if test="text()=$text_nom">
										<xsl:value-of
											select="../PUISSANCE" />
									</xsl:if>
								</xsl:for-each>
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="PUISSANCE_R" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="PERTE" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="DECOMPTE" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="ATTEINTE" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
							</td>
							<td class="txtpetit">
								<xsl:variable name="text_nom"
									select="NOM" />
								<xsl:value-of select="PUISSANCE" />
								<xsl:text
									disable-output-escaping="yes">
									&amp;nbsp;
								</xsl:text>
								<xsl:for-each
									select="../CALCUL_DEP_VERT/NOM">
									<xsl:if test="text()=$text_nom">
										<xsl:if
											test="../QUANTITE!=''">
											Qté:
											<xsl:value-of
												select="../QUANTITE" />
											<xsl:text
												disable-output-escaping="yes">
												&amp;nbsp;
											</xsl:text>
										</xsl:if>
										<xsl:if test="../NOMBRE!=''">
											Nbre:
											<xsl:value-of
												select="../NOMBRE" />
											<xsl:text
												disable-output-escaping="yes">
												&amp;nbsp;
											</xsl:text>
										</xsl:if>
										<xsl:if test="../PRIX!=''">
											Prix:
											<xsl:value-of
												select="../PRIX" />
											<xsl:text
												disable-output-escaping="yes">
												&amp;nbsp;
											</xsl:text>
										</xsl:if>
										<xsl:if
											test="../DEP_CADRAN!=''">
											Dep. Quadra:
											<xsl:value-of
												select="../DEP_CADRAN" />
										</xsl:if>
									</xsl:if>
								</xsl:for-each>
							</td>
						</tr>
					</xsl:if>
				</xsl:for-each>
			</table>
		</xsl:if>

		<xsl:if test="CALCUL_EA_VERT/LIBEL!=''">
			<table width="100%" border="1" cellspacing="0"
				cellpadding="0">
				<xsl:for-each select="CALCUL_EA_VERT">
					<tr>
						<th class="txtpetitBGG" colspan="2">
							ENERGIE ACTIVE
						</th>
						<th class="txtpetitBGG">
							<xsl:value-of select="LIBEL" />
						</th>
					</tr>
					<xsl:for-each select="MONOPHASE">
						<tr>
							<td class="txtpetit">COMPTEUR MONOPHASE</td>
							<td class="txtpetitpetit">
								Nouvel index
								<br />
								Ancien index
								<br />
								Coefficient
								<br />
								Correction forfait
								<br />
								Sous-Total
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="NOUVEL_INDEX" />
								<br />
								<xsl:value-of select="ANCIEN_INDEX" />
								<br />
								<xsl:value-of select="COEFF" />
								<br />
								<xsl:value-of select="CORRECTION" />
								<br />
								<xsl:value-of select="SOUS_TOTAL" />
							</td>
						</tr>
					</xsl:for-each>
					<tr>
						<td class="txtpetit" colspan="2">
							TOTAL MONOPHASE
						</td>
						<td class="txtpetit" align="right">
							<xsl:value-of select="TOTAL_MONOPHASE" />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
						</td>
					</tr>
					<xsl:for-each select="TRIPHASE">
						<tr>
							<td class="txtpetit">COMPTEUR TRIPHASE</td>
							<td class="txtpetitpetit">
								Nouvel index
								<br />
								Ancien index
								<br />
								Coefficient
								<br />
								Correction forfait
								<br />
								Sous-Total
							</td>
							<td class="txtpetit" align="right">
								<xsl:value-of select="NOUVEL_INDEX" />
								<br />
								<xsl:value-of select="ANCIEN_INDEX" />
								<br />
								<xsl:value-of select="COEFF" />
								<br />
								<xsl:value-of select="CORRECTION" />
								<br />
								<xsl:value-of select="SOUS_TOTAL" />
							</td>
						</tr>
					</xsl:for-each>
					<tr>
						<td class="txtpetit" colspan="2">
							TOTAL TRIPHASE
						</td>
						<td class="txtpetit" align="right">
							<xsl:value-of select="TOTAL_TRIPHASE" />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
						</td>
					</tr>
					<tr>
						<td class="txtpetit">ENERGIE REPARTIE</td>
						<td class="txtpetitpetit">
							Pointe (P)
							<br />
							H. pleine (HP)
							<br />
							P + HP
							<br />
							H. creuses (HC)
						</td>
						<td class="txtpetit">
							<xsl:value-of select="ENERGIE_POINTE" />
							<br />
							<xsl:value-of select="HEURE_PLEINE" />
							<br />
							<xsl:value-of select="POINTE_HEURE_PLEINE" />
							<br />
							<xsl:value-of select="HEURE_CREUSE" />
						</td>
					</tr>
					<tr>
						<td class="txtpetit" colspan="2">TOTAL</td>
						<td class="txtpetit" align="right">
							<xsl:value-of select="TOTAL" />
							<xsl:text disable-output-escaping="yes">
								&amp;nbsp;
							</xsl:text>
						</td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:if>
	</xsl:template>






	<!-- Fin Construction des lignes               -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- Début Construction du pied	 			-->

	<xsl:template match="FACT_FOOT">

		<table border="1" cellspacing="0" cellpadding="0"
			width="100%">
			<tr>
				<th class="txtpetitBGG">MONTANT HT</th>
				<th class="txtpetitBGG">TVA</th>
				<th class="txtpetitBGG">MONTANT TVA</th>
			</tr>
			<tr>
				<td class="txtpetit" align="right">
					<xsl:for-each select="TOTAL_TAXE_PAR_TAUX">
						<br />
						<xsl:value-of select="MONTANT_HT" />
					</xsl:for-each>
				</td>
				<td class="txtpetit" align="right">
					<xsl:for-each select="TOTAL_TAXE_PAR_TAUX">
						<br />
						<xsl:value-of select="TAXE" />
					</xsl:for-each>
				</td>
				<td class="txtpetit" align="right">
					<xsl:for-each select="TOTAL_TAXE_PAR_TAUX">
						<br />
						<xsl:value-of select="MONTANT_TVA" />
					</xsl:for-each>
				</td>
			</tr>
		</table>
		<xsl:if test="DEDUCTION">
			<table border="1" cellspacing="0" cellpadding="0"
				width="100%">
				<tr>
					<th class="txtpetitBGG">
						<xsl:text disable-output-escaping="yes">
							&amp;nbsp;
						</xsl:text>
					</th>
					<th class="txtpetitBGG">MONTANT TTC déjà payé</th>
					<th class="txtpetitBGG">MONTANT HT</th>
					<th class="txtpetitBGG">MONTANT TVA déjà payé</th>
					<th class="txtpetitBGG">
						MONTANT Taxe locale déjà payé
					</th>
				</tr>
				<xsl:for-each select="DEDUCTION">
					<tr>
						<td class="txtpetit" align="right">
							<xsl:value-of select="LIB_DEDUCTION" />
						</td>
						<td class="txtpetit" align="right">
							<xsl:value-of select="TTC_PAYE_AVANCE" />
						</td>
						<td class="txtpetit" align="right">
							<xsl:value-of select="MONTANT_HORS_TVA" />
						</td>
						<td class="txtpetit" align="right">
							<xsl:value-of select="TVA_DEJA_PAYE" />
						</td>
						<td class="txtpetit" align="right">
							<xsl:value-of
								select="MONTANT_TAXE_DEJA_PAYE" />
						</td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:if>
		<table border="1" cellspacing="0" cellpadding="0"
			width="100%">
			<tr>
				<th class="txtpetitBGG">MONTANT HT TOTAL</th>
				<th class="txtpetitBGG">MONTANT TTC TOTAL</th>
			</tr>
			<tr>
				<td class="txtpetit" align="right">
					<xsl:value-of select="MONTANT_HT" />
				</td>
				<td class="txtpetit" align="right">
					<b>
						<xsl:value-of select="MONTANT_TTC" />
					</b>
				</td>
			</tr>
		</table>
		<xsl:if test="$co_fact=2 or $co_fact=3">
			<center>
				<span class="txtpetitBGW">
					Ce montant sera déduit de la prochaine facture sur
					relevé
				</span>
			</center>
		</xsl:if>
	</xsl:template>

	<!-- Fin Construction du pied                  -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->
	<!--                                           -->

</xsl:stylesheet>
