<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:hpd="http://www.ebics.org/H003" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:s001="http://www.ebics.org/S001" xmlns:h000="http://www.ebics.org/H000" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.ebics.org/H003 http://www.ebics.org/H003/ebics_response.xsd">
	<xsl:output method="html" encoding="ISO-8859-1" />

	<xsl:template match="hpd:HPDResponseOrderData">
		<HTML>
			<HEAD>
				<style>
					body, th, td,.DocumentTitre, .Label, .Value, .Title
					{ font-family: arial; font-size: 12px;
					color:#0084BD; } body { background-color:#FFFFFF; }
					.DocumentTitre { font-weight:bold;
					text-align:center; font-size: 18px; } .Entete {
					width:100%; } .Block, .Entete { empty-cells: show;
					width:100%; } .Title { font-size: 14px;
					font-weight:bold; color:#0084BD; } .Grid {
					empty-cells:show; border:2px solid #D0D0BF;
					border-collapse:collapse; border-spacing:10px;
					width:100%; } td, .Label, .Value { text-align:left;
					padding:2px 4px 2px 4px; white-space: nowrap;
					color:#0084BD; } .Label { text-align:right;
					color:#0084BD; } .Value { width:100%;
					font-weight:bold; color:#0084BD; } table#liste {
					background-color:#FFFFFF; } th {
					background-color:#C4BBB2; color:#000000; } tr.impair
					{ background-color:#E8E4DF; } table#liste td {
					border:1px solid #000000; }
				</style>
			</HEAD>
			<BODY>
				<p class="DocumentTitre">
					Paramtres Serveur bancaire
				</p>
				<xsl:apply-templates select="hpd:AccessParams" />
				
				<br/><br/>
				<xsl:apply-templates select="hpd:ProtocolParams" />
			</BODY>
		</HTML>
	</xsl:template>


	<xsl:template match="hpd:AccessParams">
		<h3>Paramtres d'accs:</h3>
		<ul>
			<li>
				<b><u>URL </u></b>:<xsl:value-of select="hpd:URL"/>
			</li>
			<li>
				<b><u>Institut </u></b>: <xsl:value-of select="hpd:Institute"/>
			</li>
			<li>
				<b><u>HostID </u></b>: <xsl:value-of select="hpd:HostID"/>
			</li>
		</ul>
	</xsl:template>
	
	
	<xsl:template match="hpd:ProtocolParams">
		<h3>Paramtres de protocole:</h3>
		<ul>
			<li>
				<b><u>Versions: </u></b>: <xsl:apply-templates select="hpd:Version" />
			</li>
			<li>
				<b><u>Reprise </u></b>: <xsl:value-of select="hpd:Recovery/@supported"/>
			</li>
			<li>
				<b><u>Prvalidation </u></b>: <xsl:value-of select="hpd:PreValidation/@supported"/>
			</li>
			<li>
				<b><u>Donnes X509 </u></b>: <xsl:value-of select="hpd:X509Data/@supported"/>
			</li>
			<li>
				<b><u>Donnes client tlchargeables </u></b>: <xsl:value-of select="hpd:ClientDataDownload/@supported"/>
			</li>
			<li>
				<b><u>OrderData tlchargeables</u></b>: <xsl:value-of select="hpd:DownloadableOrderData/@supported"/>
			</li>
		</ul>
	</xsl:template>
	
	<xsl:template match="hpd:Version">
		<ul>
			<li>
				Protocole :<xsl:value-of select="hpd:Protocol"/>
			</li>
			<li>
				Authentification : <xsl:value-of select="hpd:Authentication"/>
			</li>
			<li>
				Cryptage : <xsl:value-of select="hpd:Encryption"/>
			</li>
			<li>
				Signature : <xsl:value-of select="hpd:Signature"/>
			</li>
		</ul>
	</xsl:template>
</xsl:stylesheet>
