<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" encoding="UTF-8" />

	<xsl:template match="PrologueBancaireOperationDeRemise">
		<HTML>
			<HEAD>
				<style>
					body, th, td,.DocumentTitre, .Label, .Value, .Title
					{ font-family: arial; font-size: 12px;
					color:#0084BD; } body { background-color:#FFFFFF; }
					.DocumentTitre { font-weight:bold;
					text-align:center; font-size: 18px; } .Entete {
					width:100%; } .Block, .Entete { empty-cells: show;
					width:100%; } .Title { font-size: 14px;
					font-weight:bold; color:#0084BD; } .Grid {
					empty-cells:show; border:2px solid #D0D0BF;
					border-collapse:collapse; border-spacing:10px;
					width:100%; } td, .Label, .Value { text-align:left;
					padding:2px 4px 2px 4px; white-space: nowrap;
					color:#0084BD; } .Label { text-align:right;
					color:#0084BD; } .Value { width:100%;
					font-weight:bold; color:#0084BD; } table#liste {
					background-color:#FFFFFF; } th {
					background-color:#C4BBB2; color:#000000; } tr.impair
					{ background-color:#E8E4DF; } table#liste td {
					border:1px solid #000000; }
				</style>
			</HEAD>
			<BODY>
				<p class="DocumentTitre">
					<xsl:choose>
						<xsl:when test="@CodeOperation='02'">
							Virement
						</xsl:when>
						<xsl:when test="@CodeOperation='08'">
							Prélèvement ordinaire
						</xsl:when>
						<xsl:when test="@CodeOperation='20'">
							Virement
						</xsl:when>
						<xsl:when test="@CodeOperation='27'">
							Virement à échéance
						</xsl:when>
						<xsl:when test="@CodeOperation='28'">
							Virement à échéance
						</xsl:when>
						<xsl:when test="@CodeOperation='85'">
							Prélèvement accéléré
						</xsl:when>
					</xsl:choose>
				</p>
				<xsl:apply-templates select="Emetteur" />
				<BR />
				<span class="Title">OPERATIONS</span>
				<table id="liste" rules="all" class="Grid">
					<thead>
						<tr>
							<th>Bénéficiaire</th>
							<th>Montant</th>
							<th>Banque</th>
							<th>Référence</th>
							<th>Motif</th>
						</tr>
					</thead>
					<tbody>
						<xsl:apply-templates select="Destinataires">
							<xsl:sort select="@Nom" data-type="text"
								order="ascending" />
							<!--<xsl:sort select="@Montant" data-type="number" order="descending"/>-->
						</xsl:apply-templates>
					</tbody>
				</table>
			</BODY>
		</HTML>
	</xsl:template>

	<xsl:template match="Emetteur">
		<table class="Entete">
			<tr>
				<td style="width:50%;">
					<span class="Title">VOS REFERENCES</span>
					<table class="Grid">
						<tr>
							<td class="Label">Nom :</td>
							<td class="Value">
								<xsl:value-of select="@RaisonSociale" />
							</td>
						</tr>
						<tr>
							<td class="Label">Date d'échéance :</td>
							<td class="Value">
								<xsl:call-template name="formatDate">
									<xsl:with-param name="dte">
										<xsl:value-of
											select="/PrologueBancaireOperationDeRemise/@DateEcheance" />
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
						<tr>
							<td class="Label">Numéro de remise :</td>
							<td class="Value">
								<xsl:value-of
									select="/PrologueBancaireOperationDeRemise/@NumeroRemise" />
							</td>
						</tr>
						<tr>
							<td class="Label">Montant total :</td>
							<td class="Value">
								<xsl:call-template name="formatMoney">
									<xsl:with-param name="value">
										<xsl:value-of
											select="/PrologueBancaireOperationDeRemise/@Total" />
									</xsl:with-param>
								</xsl:call-template>
							</td>
						</tr>
					</table>
				</td>
				<td style="width:50%;">
					<xsl:call-template name="Banque" />
				</td>
			</tr>
		</table>
	</xsl:template>

	<xsl:template match="Destinataires">
		<tr>
			<xsl:choose>
				<xsl:when test="position() mod 2 = 0">
					<xsl:attribute name="class">impair</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="class">pair</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<td>
				<xsl:value-of select="@Nom" />
			</td>
			<td style="text-align:right;">
				<xsl:call-template name="formatMoney">
					<xsl:with-param name="value">
						<xsl:value-of select="@Montant" />
					</xsl:with-param>
				</xsl:call-template>
			</td>
			<td>
				<xsl:call-template name="BanqueReduit" />
			</td>
			<td>
				<xsl:value-of select="@Reference" />
			</td>
			<td>
				<xsl:value-of select="@Libelle" />
			</td>
		</tr>
	</xsl:template>

	<xsl:template name="BanqueReduit">
		<xsl:value-of select="Banque/@CodeBanque" />
		/
		<xsl:value-of select="Banque/@CodeGuichet" />
		/
		<xsl:value-of select="Banque/@NumeroCompte" />
		/
		<xsl:value-of select="@Domiciliation" />
	</xsl:template>

	<xsl:template name="Banque">
		<span class="Title">Banque</span>
		<table class="Grid">
			<tr>
				<td class="Label">Nom :</td>
				<td class="Value">
					<xsl:value-of select="@Domiciliation" />
				</td>
			</tr>
			<tr>
				<td class="Label">Code Banque :</td>
				<td class="Value">
					<xsl:value-of select="Banque/@CodeBanque" />
				</td>
			</tr>
			<tr>
				<td class="Label">Code Guichet :</td>
				<td class="Value">
					<xsl:value-of select="Banque/@CodeGuichet" />
				</td>
			</tr>
			<tr>
				<td class="Label">No de compte :</td>
				<td class="Value">
					<xsl:value-of select="Banque/@NumeroCompte" />
				</td>
			</tr>
		</table>
	</xsl:template>

	<xsl:template name="formatDate">
		<xsl:param name="dte" />
		<xsl:if test="string-length($dte)=10">
			<xsl:value-of select="substring($dte,9,2)" />
			/
			<xsl:value-of select="substring($dte,6,2)" />
			/
			<xsl:value-of select="substring($dte,1,4)" />
		</xsl:if>
	</xsl:template>

	<xsl:template name="formatMoney">
		<xsl:param name="value" />
		<xsl:if test="string-length($value)>2">
			<xsl:value-of
				select="substring($value,1,string-length($value)-2)" />
			,
			<xsl:value-of
				select="substring($value,string-length($value)-1,2)" />
			&#160;
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
