<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");

$droitRole = ALE; //droit de gestion des alertes
$lmcse = DROIT_LECT + DROIT_CREAT + DROIT_MODIF + DROIT_SUPPR;

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$where = "";
$f_type = pget('f_type');
$f_etat = pget('f_etat');
$f_dest = pget('f_dest');
$f_destcc = pget('f_destcc');
$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

$clt_id = $_SESSION['CLT_ID'];

switch($f_type)
{
	case ALT_TYPE_SYS : 	
		$where .= " AND TAL_TYPE = ".ALT_TYPE_SYS; 	
		break;
	case ALT_TYPE_APPLI : 	
		$where .= " AND TAL_TYPE = ".ALT_TYPE_APPLI; 	
		break;
}

switch($f_etat)
{
	case ETAT_ACTIF : 	
		$where .= " AND TAL_ETAT = ".ETAT_ACTIF; 	
		break;
	case ETAT_INACTIF : 
		$where .= " AND TAL_ETAT = ".ETAT_INACTIF; 
		break;
}

if($f_dest)
	$where .= " AND TAL_DEST_ID = ".$f_dest;

if($f_destcc)
	$where .= " AND TAL_DESTCC_ID = ".$f_destcc;
		
$req = "SELECT SQL_CALC_FOUND_ROWS TAL_LIBEL, TAL_ID, TAL_TYPE, TAL_ETAT, U1.UTR_NOM DEST,
			U2.UTR_NOM DESTCC, TAL_PRINCIPAL 
		FROM TYP_ALERTE LEFT JOIN UTILISATEUR U2 ON TAL_DESTCC_ID = U2.UTR_ID, UTILISATEUR U1 
		WHERE TYP_ALERTE.CLT_ID = $clt_id 
			AND TAL_DEST_ID = U1.UTR_ID
			AND TAL_ETAT != ".ETAT_SUPPR." 
			$where
		ORDER BY TAL_LIBEL";

//echo $req;
	
$champs = array();
$champs[] = array("nom" => $lang_admin_alert_grid_head_libelle, "toolTip" => $lang_admin_alert_grid_head_libelle, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_alert_grid_head_type, "toolTip" => $lang_admin_alert_grid_head_type, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_alert_grid_head_etat, "toolTip" => $lang_admin_alert_grid_head_etat, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_alert_grid_head_dest, "toolTip" => $lang_admin_alert_grid_head_dest, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_alert_grid_head_destcc, "toolTip" => $lang_admin_alert_grid_head_destcc, "sortMode" => "1");
//$champs[] = array("nom" => ' ', "toolTip" => '', "sortMode" => "1");
//$champs[] = array("nom" => ' ', "toolTip" => '', "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';

echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{
	echo '<row>';
	$icon = $pathStyle."imgs/icons/alert.gif";
	
	$params = array();
	$params['tal_id'] = $row['TAL_ID'];
	$params['droits'] = array('modif' => (droit($droitRole, DROIT_MODIF,null,null,null,null)),
							'suppr' => (droit($droitRole, DROIT_SUPPR,null,null,null,null)));
	
	echo '<item caption="'.hi_disp($row['TAL_LIBEL']).'" toolTip="'.$lang_admin_alert_grid_act_detail.'" icon="'.$icon.'" value="'.row_encode_JSON($params).'"/>';
	
	$icon = "";
	$caption = "";
	switch($row['TAL_TYPE'])
	{
		case ALT_TYPE_SYS :
			$icon = $pathStyle."imgs/icons/system.gif";
			$caption = $lang_admin_alert_grid_lbl_type_system;
			break;
		case ALT_TYPE_APPLI :
			$icon = $pathStyle."imgs/icons/appli.gif";
			$caption = $lang_admin_alert_grid_lbl_type_appli;
			break;
	}
	echo '<item caption="'.$caption.'" icon="'.$icon.'" toolTip="" value="'.$row['TAL_PRINCIPAL'].'"/>';
	
	$icon = "";
	$caption = "";
	switch($row['TAL_ETAT'])
	{
		case ETAT_ACTIF :
			$icon = $pathStyle."imgs/icons/lamp_on.png";
			$caption = $lang_admin_alert_grid_lbl_etat_actif;
			$tooltip=$lang_flux_gest_grid_lbl_etat_actif;
			break;
		case ETAT_INACTIF :
			$icon = $pathStyle."imgs/icons/lamp_off.png";
			$caption = $lang_admin_alert_grid_lbl_etat_inactif;
			$tooltip=$lang_flux_gest_grid_lbl_etat_inactif;
			break;
	}
	echo '<item caption="'.$caption.'" icon="'.$icon.'" toolTip="'.$tooltip.'"/>';
	echo '<item caption="'.hi_disp($row['DEST']).'"/>';
	echo '<item caption="'.hi_disp($row['DESTCC']).'"/>';
	echo '</row>';
}
$gDb->SQLFermeQuery(1);

echo '</databind>';
?>