<?php
$DEFAULT_PATH = "../../../";
require_once ($DEFAULT_PATH."struct.php");

$droitRole = SAD;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

require_once($DEFAULT_PATH."tableau.php");			//class tableau
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template
require_once($DEFAULT_PATH."msg.php");				//prototype des messages d'erreur
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$page_courante = "admin/confav/addact/admin_confav_addact.php";

include($DEFAULT_PATH."header.php");
echo "<html><head>".$page_headers;

define ("OS_WIN", 1);
define ("OS_LINUX", 2);
define ("OS_SOLARIS", 3);
define ("OS_AIX", 4);

$new_act = pget("new_act");
$msg_reponse = null;
$msg_type = null;

// Bz 4486 : BG : 19/04/2012 : augmentation de la dure maximale d'xcution lors de l'install des activits (par dfaut php.ini : max_execution_time =30)
// Oracle a besoin de plus longtemps pour excuter le bloc de requtes (transformations du pdo.inc.php plus coteuses)
set_time_limit(300); 

function version_os()
{
	if (preg_match("/Win/", $_SERVER["SERVER_SOFTWARE"]))
		return 1;
	else
		return 2;
}

function sep_car()
{
	if (version_os() == OS_WIN)
		return "\\";
	else
		return "/";
}

function liste_activite(&$activites)
{
	global $gDb, $nomBase,$ini_typeBase;

	$req = "SHOW TABLES FROM ".$nomBase;
 	if (!$gDb->SQLQuery($req, 1)) 
	{
		echo $lang_admin_confav_addact_act_list_msg_err." ($req)";
		return false; 
	}
	
	if($ini_typeBase == 'mysql')
	{
	 	while($row = $gDb->SQLNextRow(1))
			if (preg_match("/^E_/", strtoupper($row["Tables_in_".$nomBase])))
			$activites .= strtoupper($row["Tables_in_".$nomBase])."|";
			$gDb->SQLFermeQuery(1);
	}
	else
	{
		if($ini_typeBase == 'mssql')
			$table_name="name";
		else
			$table_name="TABLE_NAME";
		
		while($row = $gDb->SQLNextRow(1))
			if (preg_match("/^E_/", strtoupper($row[$table_name])))
			$activites .= strtoupper($row[$table_name])."|";
			$gDb->SQLFermeQuery(1);
	}

	if (!$activites)
		$activites = "";
	return true;
}

function type_station()
{
	global $gDb;
	
	$req = "SELECT FCO_STATION_TYPE FROM FLOWCONF";
	if (!$gDb->SQLQuery($req, 1)) 
	{
		echo $lang_admin_confav_addact_act_typestation_msg_err." ($req)";
		return false; 
	}
 	$row = $gDb->SQLNextRow(1);
	if (!$row["FCO_STATION_TYPE"]) $station = 1; else $station = $row["FCO_STATION_TYPE"];
	$gDb->SQLFermeQuery(1);
	return $station;
}

function apply_xsl($xsl_file, $xml_file, $xslt_params, &$result)
{
	if(!($xml_handle = @fopen($xml_file, "r")))
	{
		$result = $lang_admin_confav_addact_act_applyxsl_msg_err_nofic." : $xml_file";
		return false;
	}
	if(!($xsl_handle = @fopen($xsl_file, "r")))
	{
		$result = $lang_admin_confav_addact_act_applyxsl_msg_err_cantopen." $xsl_file";
		return false;
	}
	if(!($xml_content = @fread($xml_handle, @filesize($xml_file))))
	{
		$result = $lang_admin_confav_addact_act_applyxsl_msg_err_cantread." $xml_file";
		return false;
	}
	if(!($xsl_content = @fread($xsl_handle, @filesize($xsl_file))))
	{
		$result = $lang_admin_confav_addact_act_applyxsl_msg_err_cantread." $xsl_file";
		return false;
	}
	@fclose($xml_handle);
	@fclose($xsl_handle);
		
	//traduction du fichier XML par le remplacement des $lang_...
	
	//import de variables
	preg_match_all('/\$(\w+)/', $xml_content, $listeMatch);
	foreach($listeMatch[1] as $var)
		global ${$var};
		
	//Remplacement dans le XML des noms de vaiables par leur valeur
	//low_disp => cpnversion UTF-8 => ISO
	$xml_content = preg_replace('/\$(\w+)/e', 'low_disp(${"\\1"})', $xml_content);
	
	$xslt_args = array('/_xml' => $xml_content, '/_xsl' => $xsl_content);
	if (!($xh = @xslt_create()))
	{
		$result = $lang_admin_confav_addact_act_applyxsl_msg_err_cantinit;
		return false;
	}
	if(!($result = @xslt_process($xh, 'arg:/_xml', 'arg:/_xsl', NULL, $xslt_args, $xslt_params)))
	{
		$result = str_replace(array("fic.xsl", "fic.xml"), array($xsl_file, $xml_file), $lang_admin_confav_addact_act_applyxsl_msg_err_cantapply);
		return false;
	}
	@xslt_free($xh);	
	return true;
}

// Ajout LTK le 27/05/11 : Bugzilla #3996
// Appliquer une requete issue d'un template  
function apply_sql($req,$typeDB)
{
	global $ini_typeBase, $gDb, $eval_ok, $msg_err;
	$return = true;
	// TypeDB = SQL --> a faire pour chaque type de base
	// sinon tester si on est sur le meme type de base
	if (($typeDB == 'SQL') || (strtolower($typeDB) == $ini_typeBase))
	{
		// Executer la requete 
	    if (!$gDb->SQLQuery($req, 1)) 
		{
			// Retour en erreur
			$eval_ok = false;
			$return = false;
			$msg_err.= "Erreur : Requete SQL '$req'&lt;br&gt;\r\n"; 
		}
		// Fermeture de la requete
		$gDb->SQLFermeQuery(1);
	}
	return $return;	
}

$install_ok = false;

if (!isset($ini_language))
{
	$ini_language = "fr-FR";
}
if ($new_act)
{
	$param = array(
		"TABLE" 		=> $new_act,
		"TYPE_STATION"	=> type_station()
	);
	
	#Update for MSSQL and ORACLE
	
	if($ini_typeBase == 'mysql')
		$installfile="install_activite_".$ini_language.".xml";
	else	
		$installfile="install_activite_".$ini_language."_".strtoupper($ini_typeBase).".xml";

	if (!apply_xsl("install_activite.xsl", $installfile, $param, $result)) 
	{
		echo message(str_replace("fic.xsl", "install_activite.xsl", $lang_admin_confav_addact_act_newact_msg_err_fatal), "erreur");
		return;
	}
	
	$SEP_CAR = preg_replace('/\\{1,}/', "\\", sep_car());
	$result = str_replace("[@SEP_CAR]", dblQ($SEP_CAR), $result);

	$req = "SELECT FCO_REPBIN_IHM 
			FROM FLOWCONF";
			
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);

	$fco_repbin_ihm = $row[0];

	$gDb->SQLFermeQuery(1);
	$rep_bin = str_replace("\\","\\\\", str_replace("'","''", $fco_repbin_ihm));
	$result = str_replace("[@FCO_REPBIN_IHM]", $rep_bin, $result);
	
	eval ($result);
	if ($eval_ok) 
	{
		//$msg_reponse = $lang_admin_confav_addact_act_newact_msg_ok;
		$install_ok = true;
		$msg_type = "msgi";
	}
	else 
	{
		$msg_reponse = $lang_admin_confav_addact_act_newact_msg_err;
		
		$msg_type = "msgr";
	}
	
	$new_act = null;
}


if (!liste_activite($activites))
{
	echo message($lang_admin_confav_addact_act_listact_msg_err, "erreur");
	return;
}

$param = array(
	"TYPE_OS" 			=> version_os(),
	"LISTE_ACTIVITE" 	=> $activites,
	"STYLE"				=> $pathStyle,
	"MSG_REPONSE"		=> $msg_reponse,
	"MSG_TYPE"			=> $msg_type,
	"TYPE_STATION"		=> type_station(),
	"INSTALL_OK"		=> $install_ok,
	"LBL_DEJAINSTALL"	=> $lang_admin_confav_addact_lbl_dejainstall,
	"LBL_DOINSTALL"		=> $lang_admin_confav_addact_lbl_doinstall
);

#Update for MSSQL and ORACLE

if($ini_typeBase == 'mysql')
		$installfile="install_activite_".$ini_language.".xml";
	else	
		$installfile="install_activite_".$ini_language."_".strtoupper($ini_typeBase).".xml";

if (!apply_xsl("liste_activite.xsl", $installfile, $param, $result)) 
{
	echo message(str_replace("fic.xsl", "liste_activite.xsl", $lang_admin_confav_addact_act_newact_msg_err_fatal), "erreur");
	return;
}

$header = "<script language=\"JavaScript\" type=\"text/javascript\">
					top.help.id = 'rajout_activite';
					parent.setMainTitle('".addslashes($lang_admin_confav_addact_title)."', '${pathStyle}imgs/icons/title/admin_confav_addact.gif');
					var panel_title = '".addslashes($lang_admin_confav_addact_paneltitle)."';
				</script>
				<SCRIPT FOR=window EVENT=onload LANGUAGE=\"JScript\">
			  		prlPage.elementCalcPosition();
				</SCRIPT>
				<SCRIPT FOR=window EVENT=onresize LANGUAGE=\"JScript\">
			  		prlPage.elementCalcPosition();
				</SCRIPT>
			</head>
			<body onLoad=\"prlPage.elementCalcPosition();\" onResize=\"prlPage.elementCalcPosition();\">
				<div id=\"div_grid\" class=\"fond\">";

$footer = "		</div>
			</body>
		</html>";
echo $header.$result.$footer;
?>