<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="text" encoding="ISO-8859-1" />

	<xsl:param name="TABLE" />

	<xsl:param name="TYPE_STATION" />

	<xsl:template match="/SCRIPT">

		$msg_err = null; $eval_ok = true;

		<xsl:apply-templates select="SECTION[@TABLE = $TABLE and contains(@TYPE, $TYPE_STATION)]" />

	</xsl:template>

	<xsl:template match="SECTION">

		$lib_activite = "<xsl:value-of select="@LIB" />";

		<xsl:apply-templates />

	</xsl:template>

	<xsl:template match="FIC">

		<xsl:if test="@ACTION='C'">

			if (!($file = @fopen("<xsl:value-of select="@DEST" /><xsl:value-of select="@NAME" />", "w"))) {
				$eval_ok = false; 
				$msg_err .= "Erreur : Impossible d'ouvrir le fichier <xsl:value-of select="@DEST" /><xsl:value-of select="@NAME" />&lt;br&gt;\r\n"; 
				return;
			} 
			$res = dblS("<xsl:apply-templates select="TEXT" />");
			if (!@fwrite($file, $res)) {
				$eval_ok = false; 
				$msg_err.= "Erreur : Impossible de crer le fichier	<xsl:value-of select="@DEST" /><xsl:value-of select="@NAME" />&lt;br&gt;\r\n"; 
				return;
			} 
			@fclose($file); 
			unset($file);

			unset($res);

		</xsl:if>

		<xsl:if test="@ACTION='A'">

			if (!($file = @fopen("<xsl:value-of select="@DEST" /><xsl:value-of select="@NAME" />", "a"))) {
				$eval_ok = false; 
				$msg_err .= "Erreur : Impossible d'ouvrir le fichier <xsl:value-of select="@DEST" /><xsl:value-of select="@NAME" />&lt;br&gt;\r\n"; 
				return;
			}
			$res = dblS("<xsl:apply-templates select="TEXT" />"); 
			if (!@fwrite($file, $res)) {
				$eval_ok = false; 
				$msg_err.= "Erreur : Impossible de modifier le fichier <xsl:value-of select="@DEST" /><xsl:value-of select="@NAME" />&lt;br&gt;\r\n"; 
				return;
			} 
			@fclose($file); 
			unset($file);

			unset($res);

		</xsl:if>

	</xsl:template>

	<xsl:template match="CMD|TEXT">

		<xsl:apply-templates />

	</xsl:template>

	<xsl:template match="EXEC">

		$cmd = "<xsl:apply-templates />"; 
		$res_cmd = exec($cmd, $tab, $res); 

		<xsl:choose>

			<xsl:when test="@ERR='no'">
				if ($res != 0) {
					$msg_err .= "Warning : Excution de la commande	'$cmd'&lt;br&gt;\r\n"; 
				}

			</xsl:when>

			<xsl:otherwise>
				if ($res != 0) {
					$eval_ok = false; 
					$msg_err .= "Erreur : Excution de la commande '$cmd'&lt;br&gt;\r\n"; 
					return;
				}

			</xsl:otherwise>

		</xsl:choose>

	</xsl:template>

	<xsl:template match="SQL|MYSQL|MSSQL|ORACLE">
	    if (!apply_sql("<xsl:apply-templates />","<xsl:value-of select="name(.)"/>")) return;
	</xsl:template>

</xsl:stylesheet>