<?php
if (!isset($DEFAULT_PATH))$DEFAULT_PATH ="../../../";
require_once ($DEFAULT_PATH."XPath.class.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once ($DEFAULT_PATH."struct.php");
$droitRole = SAD; 
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template

$page_courante = "admin/confav/demat/recup_demat.php";

//recuperation des donnees
$action	   = pget('action');			// action
$chem_arch = pget('chem_arch');
$new_clt_id    = pget('clt_id');

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = 0;

function apply_xsl($xsl_file, $xml_file, $xslt_params, &$result)
{

	if (!($xml_handle = @fopen($xml_file, "r"))) {
		$result = str_replace('%xml_file%', $xml_file, $lang_admin_confav_inv_act_import_msg_err_file_open_xml); return false;
	}
	if (!($xsl_handle = @fopen($xsl_file, "r"))) {
		$result = str_replace('%xsl_file%', $xsl_file, $lang_admin_confav_inv_act_import_msg_err_file_open_xsl); return false;
	}
	if (!($xml_content 	= @fread($xml_handle, @filesize($xml_file))))  {
		$result = str_replace('%xml_file%', $xml_file, $lang_admin_confav_inv_act_import_msg_err_file_read_xml); return false;
	}
	if (!($xsl_content 	= @fread($xsl_handle, @filesize($xsl_file))))  {
		$result = str_replace('%xsl_file%', $xsl_file, $lang_admin_confav_inv_act_import_msg_err_file_read_xsl); return false;
	}

	@fclose($xml_handle);
	@fclose($xsl_handle);
	$xml_content = str_replace("\\","\\\\",$xml_content);
	$xml_content = str_replace("'","\\'",$xml_content);
	//echo "xmlcontent";
	//echo $xml_content;
	$xslt_args = array('/_xml' => $xml_content, '/_xsl' => $xsl_content);
	if (!($xh = @xslt_create())) {
		$result = $lang_admin_confav_inv_act_import_msg_err_init_proc_xsl; return false;
	}
	if (!($result = @xslt_process($xh, 'arg:/_xml', 'arg:/_xsl', NULL, $xslt_args, $xslt_params))) {
		$result = str_replace('%xsl_file%', $xsl_file, str_replace('%xml_file%', $xml_file, $lang_admin_confav_inv_act_import_msg_err_style_xsl_xml)); return false;
	}
	@xslt_free($xh);
	return true;
}

function liste_pereMM($fils_id)
{
	global $gDb;
	global $ListePere;
	$requete="select GRP_ID from PART where PAR_ID = ".$fils_id;
	$gDb->SQLQuery($requete, 9);
	$res = $gDb->SQLNextRow(9);

	if ($res['GRP_ID']) {
		if (!$ListePere){
			$ListePere=$res['GRP_ID'];
		} else {
			$ListePere.=",".$res['GRP_ID'];
		}
		liste_pereMM($res['GRP_ID'], $ListePere);
	}
	$gDb->SQLFermeQuery(9);
}

function insert_part(&$part_id, $proto, $i, $pere_id, &$msg_err)
{
	global $gDb, $tab_recap, $new_clt_id;

	switch ($proto)
	{
		case "TMA_EMET_DEMAT" :
			$lib_nom = "TMA_EMET_DEMAT";
			$lib_id = "";
			$par_type = 1;
			$pere_id = "null";
			break;
		case "TMA_DEST_DEMAT" :
			$lib_nom = "TMA_DEST_DEMAT";
			$lib_id = "";
			$par_type = 1;
			$pere_id = "null";
			break;
		case "EMET" :
			$lib_nom = "TMA_EMET_NOM";
			$lib_id = "TMA_TELE_EMET";
			$par_type = 0;
			break;
		case "DEST" :
			$lib_nom = "TMA_DEST_NOM";
			$lib_id = "TMA_TELE_DEST";
			$par_type = 0;
			break;
			/*case "EMET" :
			 $lib_nom = "TMA_EMET_NOM";
			 $lib_id = "TMA_TELE_EMET";
			 $par_type = 1;
			 $pere_id = "null";
			 break;
			 case "DEST" :
			 $lib_nom = "TMA_DEST_NOM";
			 $lib_id = "TMA_TELE_DEST";
			 $par_type = 1;
			 $pere_id = "null";
			 break;*/
		case "FACT_A" :
			$lib_nom = "TMA_NOM_FACT_A";
			$lib_id = "TMA_CODE_FACT_A";
			$par_type = 0;
			break;
		case "FACT_PAR" :
			$lib_nom = "TMA_NOM_FACT_PAR";
			$lib_id = "TMA_CODE_FACT_PAR";
			$par_type = 0;
			break;
	}
	// MMMMM
	$part_id='NULL';
	// if ($proto=="FACT_A" || $proto=="FACT_PAR")
	//return true;

	//On cherche le partenaire à partir de son nom
	$req = "select PAR_ID
			from PART 
			where PAR_NOM = '".dblQ($tab_recap[$i][$lib_nom])."' 
			and CLT_ID = $new_clt_id 
			and PAR_ETAT != ".ETAT_SUPPR;
	if (!$gDb->SQLQuery($req, 1))
	{
		$msg = $lang_admin_confav_inv_act_export_msg_err_comp_part.$proto;
		return false;
	}
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	$part_id = $row['PAR_ID'];

	if ($part_id)
	{
		$gDb->SQLFermeQuery(1);
		if ($lib_id!='' && strlen($tab_recap[$i][$lib_id]) != 0)
		{
			$req = "select IDE_ID from IDENT
					where PAR_ID = ".$row['PAR_ID']." 
					and IDE_VAL = '".dblQ($tab_recap[$i][$lib_id])."' 
					and CLT_ID = $new_clt_id";
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);

			if ($row['IDE_ID']) $gDb->SQLFermeQuery(1);
			else
			{
				$gDb->SQLFermeQuery(1);
				$req = "insert into IDENT (CLT_ID, PAR_ID, IDE_VAL)
						values ($new_clt_id, $part_id, '".dblQ($tab_recap[$i][$lib_id])."')";
				$gDb->SQLQuery($req, 1);
			}
		}
	}
	//Sinon on le créer ainsi que sont identifiant
	else
	{
		$gDb->SQLFermeQuery(1);
		$req = "insert into PART (CLT_ID, PAR_TYPE, PAR_NOM, PAR_ETAT, GRP_ID)
				values ($new_clt_id, $par_type, '".dblQ($tab_recap[$i][$lib_nom])."', ".ETAT_ACTIF.", $pere_id)";

		//if ($proto=="TMA_DEST_DEMAT")
		//echo "<br>req=".$req;
		$gDb->SQLQuery($req, 1);
		$part_id = $gDb->SQLlastID();
		$gDb->SQLFermeQuery(1);
		if (strlen($tab_recap[$i][$lib_id]) != 0)
		{
			$req = "insert into IDENT (CLT_ID, PAR_ID, IDE_VAL)
					values ($new_clt_id, $part_id, '".dblQ($tab_recap[$i][$lib_id])."')";
			$gDb->SQLQuery($req, 1);
			$gDb->SQLFermeQuery(1);
		}
	}
	return true;
}

function recap_to_tab($chem, &$tab_recap,&$msg_err)
{
	global $lang_admin_confav_inv_act_export_msg_err_no_path, $lang_admin_confav_inv_act_export_msg_err_no_demat_fic,
	       $lang_act_listingficl_msgerr_openxml;
	if (!$chem)	{
		$msg_err = $lang_admin_confav_inv_act_export_msg_err_no_path;
		return false;
	}
	//MMM compatibilite csv xml $typeDemat="xml";
	$fic = $chem."/demat.xml";
	if (!file_exists($fic))
	{
		$msg_err = $lang_admin_confav_inv_act_export_msg_err_no_demat_fic;
		return false;
	}
	if ($xml_fic = @fopen($fic, "r"))
	{
		$xslt_params = array();
		$xsl_file = "Import_demat.xsl";
		$xml_file = $fic;
		if (!apply_xsl($xsl_file, $xml_file, $xslt_params, $result))
		{
			$msg_err = $result;
			return false;
		}
		else
		{
			//echo $result;
			eval($result);
		}
		@fclose($id_fic);
	}
	else
	{
		$msg_err = str_replace('%XMLFILE%',$import_chem,$lang_act_listingficl_msgerr_openxml); 
	}
	return true;
}

/************************************************************/
/* DEBUT ACTION = LIRE_RECAP	 							*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = VALID		 							*/
/************************************************************/

if ($action == "valid" && droit($droitRole, DROIT_CREAT,null,null,null,null))
{
	$err = false;
	$nbtotal = 0;

	$msg = "";

	$ret = recap_to_tab($chem_arch, $tab_recap, $msg);
	if ($ret && ($nbtotal = count($tab_recap)) == 0)
	$msg = $lang_admin_confav_inv_act_export_msg_err_no_recap_li;

	if ($new_clt_id)
	{
		$req = "select CLT_ID from CLIENT where CLT_ID = $new_clt_id";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		if ($row['CLT_ID'] != $new_clt_id)
		{
			$nbtotal = 0;
			$msg = $lang_admin_confav_inv_act_export_msg_err_no_cli_spe;
		}
		$gDb->SQLFermeQuery(1);
	}
	else
	{
		$nbtotal = 0;
		$msg = $lang_admin_confav_inv_act_export_msg_err_no_cli;
	}
	
	if ($nbtotal > 0)
	{
		// Ajout LTK le 25/10/11 : Bugzilla #4196
		// Verifier que le chemin d'import correspond au chemin initial de l'archive
		// On assume que toutes les factures archivees sont bien dans un meme repertoire
		$chemin_initial =  realpath(sprintf("%s/%s",$tab_recap[1]['TMA_CHEMIN'],$tab_recap[1]['NOM_ARCH']));
		if ($chemin_initial != realpath($chem_arch))
		{
			$nbtotal = 0;
			$msg = sprintf($lang_admin_confav_inv_act_export_msg_rep_differents,$chemin_initial);
		}
	}
	$rapport = "";
	$nb_err = 0;

	for ($i = 1; $i <= $nbtotal; $i++)
	{
		// TMA_DATE_EMI = TMA_DATE_TRAIT = CUR_DATE
		// Mysql accèpte le format date 20130306112233 sans transfomrtaion
		// ce n'est pas le cas avec SQL server et ORAcle
		if($ini_typeBase == "mssql" or $ini_typeBase == "oracle")
		{
			// TMA_DATE_TRAIT //
			if (strlen($tab_recap[$i]['TMA_DATE_TRAIT']) == 14)
			{
				list($year, $month, $day, $hour, $min, $sec) = sscanf($tab_recap[$i]['TMA_DATE_TRAIT'], "%4s%2s%2s%2s%2s%2s");
				$tab_recap[$i]['TMA_DATE_TRAIT']= $year.'-'.$month.'-'.$day.' '.$hour.':'.$min.':'.$sec;
			}
			elseif (strlen($tab_recap[$i]['TMA_DATE_TRAIT']) != 19)
			{
				$tab_recap[$i]['TMA_DATE_TRAIT']='0000-00-00 00:00:00'; // ne doit pas se produire (servira d'avertissement)
			}
			// TMA_DATE_SORTIE //
			if (strlen($tab_recap[$i]['TMA_DATE_SORTIE']) == 14)
			{
				list($year, $month, $day, $hour, $min, $sec) = sscanf($tab_recap[$i]['TMA_DATE_SORTIE'], "%4s%2s%2s%2s%2s%2s");
				$tab_recap[$i]['TMA_DATE_SORTIE']= $year.'-'.$month.'-'.$day.' '.$hour.':'.$min.':'.$sec;
			} 
			elseif (strlen($tab_recap[$i]['TMA_DATE_SORTIE']) != 19)
			{
				$tab_recap[$i]['TMA_DATE_SORTIE']='0000-00-00 00:00:00'; // peut se produire
			}
			// TMA_DATE_ENTREE //
			if (strlen($tab_recap[$i]['TMA_DATE_ENTREE']) == 14)
			{
				list($year, $month, $day, $hour, $min, $sec) = sscanf($tab_recap[$i]['TMA_DATE_ENTREE'], "%4s%2s%2s%2s%2s%2s");
				$tab_recap[$i]['TMA_DATE_ENTREE']= $year.'-'.$month.'-'.$day.' '.$hour.':'.$min.':'.$sec;
			} 
			elseif (strlen($tab_recap[$i]['TMA_DATE_ENTREE']) != 19)
			{
				$tab_recap[$i]['TMA_DATE_ENTREE']='0000-00-00 00:00:00'; // ne doit pas se produire (servira d'avertissement)
			}
		}

		//Verifier qu'aucune ligne ne correspond dans la table des matieres
		$req = "select count(*) AS nb from TABLE_MATIERE
				where TMA_ARCHIVE = '".dblQ($tab_recap[$i]['TMA_ARCHIVE'])."' 
				and TMA_CODE_ERR = ".$tab_recap[$i]['TMA_CODE_ERR']."  
				and TMA_DATE_TRAIT = '".dblQ($tab_recap[$i]['TMA_DATE_TRAIT'])."' 
				and TMA_NUM_FACT = '".trim($tab_recap[$i]['TMA_NUM_FACT'])."'";

		if (!$gDb->SQLQuery($req, 1))
		{
			$err = true;
			$msg = $lang_admin_confav_inv_act_export_msg_err_comp_tma;
			break;
		}
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);

		if ($row['nb'] > 0)
		{
			$rapport[$nb_err] = $tab_recap[$i]['TMA_ID'];
			$nb_err++;
			continue;
		}

		if (!insert_part($emet_id, "EMET", $i, "NULL", $msg_err)) break;
		if (!insert_part($dest_id, "DEST", $i, "NULL", $msg_err)) break;
		if (!insert_part($TMA_EMET_DEMAT_ID, "TMA_EMET_DEMAT", $i, "NULL", $msg_err)) break;
		if (!insert_part($TMA_DEST_DEMAT_ID, "TMA_DEST_DEMAT", $i, "NULL", $msg_err)) break;
		if ($tab_recap[$i]['TMA_SENS'] == EMISSION) $pere_id = $TMA_DEST_DEMAT_ID;
		else $pere_id = $TMA_EMET_DEMAT_ID;
		if (!insert_part($fact_a_id, "FACT_A", $i, $pere_id, $msg_err)) break;
		if ($tab_recap[$i]['TMA_SENS'] == EMISSION) $pere_id = $TMA_EMET_DEMAT_ID;
		else $pere_id = $TMA_DEST_DEMAT_ID;
		if (!insert_part($fact_par_id, "FACT_PAR", $i, $pere_id, $msg_err)) break;

		$date = date("Y-m-d H:i:s");

		$ListePere=$TMA_DEST_DEMAT_ID;
		liste_pereMM($TMA_DEST_DEMAT_ID);
		$ListePereD=$ListePere;

		$ListePere=$TMA_EMET_DEMAT_ID;
		liste_pereMM($TMA_EMET_DEMAT_ID);
		$ListePereE=$ListePere;

		$req = "select PTP_ID, PTP_DATE_SORTIE from PART_TO_PART
				where (PTP_DEST_ID in ($ListePereE) 
				and PTP_EMET_ID in ($ListePereD)) 
				or (PTP_DEST_ID in ($ListePereD )
				and PTP_EMET_ID in ($ListePereE)) 
				and PTP_DATE_ENTREE='".$tab_recap[$i]['TMA_DATE_ENTREE']."'";

		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);

		if ($row['PTP_ID'] > 0)
		{
			if (! $row['PTP_DATE_SORTIE'] && $tab_recap[$i]['TMA_DATE_SORTIE'])
			{
				if($ini_typeBase == "mysql")
					$req = "update PART_TO_PART set PTP_STATUT = 2, PTP_DATE_SORTIE='".$tab_recap[$i]['TMA_DATE_SORTIE']."' where PTP_ID = ".$row['PTP_ID'];
				if($ini_typeBase == "mssql")
					$req = "update PART_TO_PART set PTP_STATUT = 2, PTP_DATE_SORTIE=convert(datetime,'".$tab_recap[$i]['TMA_DATE_SORTIE']."',120) where PTP_ID = ".$row['PTP_ID'];
				if($ini_typeBase == "oracle")
					$req = "update PART_TO_PART set PTP_STATUT = 2, PTP_DATE_SORTIE=TIMESTAMP'".$tab_recap[$i]['TMA_DATE_SORTIE']."' where PTP_ID = ".$row['PTP_ID'];
					
				$gDb->SQLQuery($req, 1);
			}

		}
		else
		{
			// vérifie que les partenaires soient sorties de demat !!! cela ne devrait pas se produire ...
			if ($tab_recap[$i]['TMA_DATE_SORTIE'] != '0000-00-00 00:00:00'
			 and $tab_recap[$i]['TMA_DATE_SORTIE'] != '')
			{
				if($ini_typeBase == "mysql")
					$req = "insert into PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_DATE_SORTIE, PTP_HISTO, CLT_ID)
						values ($TMA_EMET_DEMAT_ID, $TMA_DEST_DEMAT_ID, '".$tab_recap[$i]['TMA_STATUT']."' , '".$tab_recap[$i]['TMA_DATE_ENTREE']."', '".$tab_recap[$i]['TMA_DATE_SORTIE']."', 1, $new_clt_id)";
				if($ini_typeBase == "mssql")
					$req = "insert into PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_DATE_SORTIE, PTP_HISTO, CLT_ID)
						values ($TMA_EMET_DEMAT_ID, $TMA_DEST_DEMAT_ID, '".$tab_recap[$i]['TMA_STATUT']."' , convert(datetime,'".$tab_recap[$i]['TMA_DATE_ENTREE']."',120), convert(datetime,'".$tab_recap[$i]['TMA_DATE_SORTIE']."',120), 1, $new_clt_id)";
				if($ini_typeBase == "oracle")
					$req = "insert into PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_DATE_SORTIE, PTP_HISTO, CLT_ID)
						values ($TMA_EMET_DEMAT_ID, $TMA_DEST_DEMAT_ID, '".$tab_recap[$i]['TMA_STATUT']."' , TIMESTAMP'".$tab_recap[$i]['TMA_DATE_ENTREE']."', TIMESTAMP'".$tab_recap[$i]['TMA_DATE_SORTIE']."', 1, $new_clt_id)";
			}
			else
			{
				if($ini_typeBase == "mysql")
					$req = "insert into PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_HISTO, CLT_ID)
						values ($TMA_EMET_DEMAT_ID, $TMA_DEST_DEMAT_ID, '".$tab_recap[$i]['TMA_STATUT']."' , '".$tab_recap[$i]['TMA_DATE_ENTREE']."', 1, $new_clt_id)";
				if($ini_typeBase == "mssql")
					$req = "insert into PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_HISTO, CLT_ID)
						values ($TMA_EMET_DEMAT_ID, $TMA_DEST_DEMAT_ID, '".$tab_recap[$i]['TMA_STATUT']."' , convert(datetime,'".$tab_recap[$i]['TMA_DATE_ENTREE']."',120), 1, $new_clt_id)";
				if($ini_typeBase == "oracle")
					$req = "insert into PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_HISTO, CLT_ID)
						values ($TMA_EMET_DEMAT_ID, $TMA_DEST_DEMAT_ID, '".$tab_recap[$i]['TMA_STATUT']."' , TIMESTAMP'".$tab_recap[$i]['TMA_DATE_ENTREE']."', 1, $new_clt_id)";						
			}
			$gDb->SQLQuery($req, 1);
			$gDb->SQLFermeQuery(1);
		}
		

		$nom_arch = explode("\\", $tab_recap[$i]['TMA_ARCHIVE']);
		$nom_arch = explode("/", $nom_arch[0]);
		$num_arch = substr($nom_arch[0], strlen($nom_arch[0]) - 6, strlen($nom_arch[0])) + 0;
		$nom_arch = substr($nom_arch[0], 0, strlen($nom_arch[0]) - 6);
		
		if ($tab_recap[$i]['TMA_SENS'] == EMISSION) $part_arch_id = $emet_id;
		else $part_arch_id = $dest_id;

		$req = "select max(PAD_NUM_ARCH) as max_arch from PART_DEMAT 
				where PAR_ID = $part_arch_id";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$max_arch = $row['max_arch'];
		$gDb->SQLFermeQuery(1);

		if (intval($max_arch) > 0)
		{
			if (intval($num_arch) > intval($max_arch))
			{
				if($ini_typeBase == "mysql")
					$req = "update PART_DEMAT set PAD_NUM_ARCH = $num_arch,PAD_DATE_CREAT_ARCH = '$date' where PAR_ID = $part_arch_id";
				if($ini_typeBase == "mssql")
					$req = "update PART_DEMAT set PAD_NUM_ARCH = $num_arch,PAD_DATE_CREAT_ARCH = convert(datetime,'$date',120) where PAR_ID = $part_arch_id";
				if($ini_typeBase == "oracle")
					$req = "update PART_DEMAT set PAD_NUM_ARCH = $num_arch,PAD_DATE_CREAT_ARCH = TIMESTAMP '$date' where PAR_ID = $part_arch_id";
					
				$gDb->SQLQuery($req, 1);
				$gDb->SQLFermeQuery(1);
			}
		}
		else
		{
			$num_arch = 1;
			if($ini_typeBase == "mysql")
				$req = "insert into PART_DEMAT (PAR_ID, PAD_NOM_ARCH, PAD_NUM_ARCH, PAD_CHEM_ARCH, PAD_CHEM_ARCH_MOT, PAD_DATE_CREAT_ARCH, PAD_TAILLE_ARCH, PAD_DELAI_CLOT_ARCH, CLT_ID) 
						values ($part_arch_id, '".dblQ($nom_arch)."', $num_arch, '".dblQ($tab_recap[$i]['TMA_CHEMIN'])."', 
						'".dblQ($tab_recap[$i]['TMA_CHEMIN_MOT'])."', '$date', 700, 30, $new_clt_id)";
			if($ini_typeBase == "mssql")
				$req = "insert into PART_DEMAT (PAR_ID, PAD_NOM_ARCH, PAD_NUM_ARCH, PAD_CHEM_ARCH, PAD_CHEM_ARCH_MOT, PAD_DATE_CREAT_ARCH, PAD_TAILLE_ARCH, PAD_DELAI_CLOT_ARCH, CLT_ID) 
						values ($part_arch_id, '".dblQ($nom_arch)."', $num_arch, '".dblQ($tab_recap[$i]['TMA_CHEMIN'])."', 
						'".dblQ($tab_recap[$i]['TMA_CHEMIN_MOT'])."', convert(datetime,'$date',120), 700, 30, $new_clt_id)";
			if($ini_typeBase == "oracle")
				$req = "insert into PART_DEMAT (PAR_ID, PAD_NOM_ARCH, PAD_NUM_ARCH, PAD_CHEM_ARCH, PAD_CHEM_ARCH_MOT, PAD_DATE_CREAT_ARCH, PAD_TAILLE_ARCH, PAD_DELAI_CLOT_ARCH, CLT_ID) 
						values ($part_arch_id, '".dblQ($nom_arch)."', $num_arch, '".dblQ($tab_recap[$i]['TMA_CHEMIN'])."', 
						'".dblQ($tab_recap[$i]['TMA_CHEMIN_MOT'])."', TIMESTAMP '$date', 700, 30, $new_clt_id)";
						
			$gDb->SQLQuery($req, 1);
			$gDb->SQLFermeQuery(1);
		}
		if (!$tab_recap[$i]['TMA_FONC']) $tab_recap[$i]['TMA_FONC']='null';
		if (!$tab_recap[$i]['TMA_SENS']) $tab_recap[$i]['TMA_SENS']='null';
		if (!$tab_recap[$i]['TMA_MODE']) $tab_recap[$i]['TMA_MODE']='null';
		
		// MySQL SQL server et ORAcle
		// DATE_INTER //
		if (strlen($tab_recap[$i]['DATE_INTER']) == 11)
		{
			list($year, $month, $day, $hour, $min) = sscanf($tab_recap[$i]['DATE_INTER'], "%2s%2s%2s:%2s%2s");
			$tab_recap[$i]['DATE_INTER']= '20'.$year.'-'.$month.'-'.$day.' '.$hour.':'.$min.':00';
		}
		// SQL server et ORAcle
		else if (strlen($tab_recap[$i]['DATE_INTER']) == 14)
		{
			list($year, $month, $day, $hour, $min, $sec) = sscanf($tab_recap[$i]['DATE_INTER'], "%4s%2s%2s%2s%2s%2s");
			$tab_recap[$i]['DATE_INTER']= $year.'-'.$month.'-'.$day.' '.$hour.':'.$min.':'.$sec;
		}
		else if(strlen($tab_recap[$i]['DATE_INTER']) != 19)
		{
			$tab_recap[$i]['DATE_INTER']='0000-00-00 00:00:00'; // ne doit pas se produire (servira d'avertissement)
		}		
		// TMA_DATE_EMI //
		if (strlen($tab_recap[$i]['TMA_DATE_EMI']) == 14)
		{
			list($year, $month, $day, $hour, $min, $sec) = sscanf($tab_recap[$i]['TMA_DATE_EMI'], "%4s%2s%2s%2s%2s%2s");
			$tab_recap[$i]['TMA_DATE_EMI']= $year.'-'.$month.'-'.$day.' '.$hour.':'.$min.':'.$sec;
		}
		else if(strlen($tab_recap[$i]['TMA_DATE_EMI']) != 19)
		{
			$tab_recap[$i]['TMA_DATE_EMI']='0000-00-00 00:00:00'; // peut se produire
		}
		// TMA_DATE_FACT // oracle n'accepte pas le format '20120101' comme timestamp
		if (strlen($tab_recap[$i]['TMA_DATE_FACT']) == 8)
		{
			list($year, $month, $day, $hour, $min, $sec) = sscanf($tab_recap[$i]['TMA_DATE_FACT'], "%4s%2s%2s");
			$tab_recap[$i]['TMA_DATE_FACT']= $year.'-'.$month.'-'.$day.' 00:00:00';
		}
		else if(strlen($tab_recap[$i]['TMA_DATE_FACT']) != 19)
		{
			$tab_recap[$i]['TMA_DATE_FACT']='0000-00-00 00:00:00'; // peut se produire
		}

		if($ini_typeBase == "mysql" )
		{
			$req = "insert into TABLE_MATIERE 
					(TMA_NUM_FACT, TMA_DATE_FACT, TMA_TYPE, TMA_FONC, TMA_DATE_REC, TMA_DATE_EMI, 
					TMA_DATE_TRAIT, TMA_CODE_FACT_A, TMA_NOM_FACT_A, TMA_PAR_ID_FACT_A, 
					TMA_CODE_FACT_PAR, TMA_NOM_FACT_PAR, TMA_PAR_ID_FACT_PAR, 
					TMA_MONT_HT, TMA_MONT_TTC, TMA_DEVISE, TMA_STATUT, TMA_SENS, TMA_LOGICIEL,
					TMA_CODE_ERR, TMA_LIBEL_ERR, TMA_ARCHIVE, TMA_CHEMIN, TMA_CHEMIN_MOT,
					TMA_EMET_NOM, TMA_EMET_ID, TMA_TELE_EMET, TMA_TELE_DEST,
					TMA_DEST_NOM, TMA_DEST_ID, TMA_MODE, TMA_FORM, CLT_ID, TMA_DATE_ENTREE, TMA_DATE_SORTIE, 
					TMA_SCEAU_EDI, TMA_SCEAU_XML, TMA_CPT, TMA_EMET_DEMAT, TMA_DEST_DEMAT, TMA_DATE_UNB, 
					TMA_ADR_FACT_A,TMA_SIREN_FACT_A,TMA_TVA_FACT_A,TMA_ADR_FACT_PAR,TMA_SIREN_FACT_PAR,TMA_TVA_FACT_PAR) 
					values (
					'".dblQ($tab_recap[$i]['TMA_NUM_FACT'])."','".dblQ($tab_recap[$i]['TMA_DATE_FACT'])."', 
					".dblQ($tab_recap[$i]['TMA_TYPE']).",".dblQ($tab_recap[$i]['TMA_FONC']).", 
					'".dblQ($tab_recap[$i]['TMA_DATE_REC'])."','".dblQ($tab_recap[$i]['TMA_DATE_EMI'])."', 
					'".dblQ($tab_recap[$i]['TMA_DATE_TRAIT'])."','".dblQ($tab_recap[$i]['TMA_CODE_FACT_A'])."', 
					'".dblQ($tab_recap[$i]['TMA_NOM_FACT_A'])."',$fact_a_id,".
					((($tab_recap[$i]['TMA_CODE_FACT_PAR'] + 1) == 1)?("null"):("'".dblQ($tab_recap[$i]['TMA_CODE_FACT_PAR'])."'")).",
					'".dblQ($tab_recap[$i]['TMA_NOM_FACT_PAR'])."',$fact_par_id, 
					'".dblQ($tab_recap[$i]['TMA_MONT_HT'])."','".dblQ($tab_recap[$i]['TMA_MONT_TTC'])."', 
					'".dblQ($tab_recap[$i]['TMA_DEVISE'])."','".dblQ($tab_recap[$i]['TMA_STATUT'])."', 
					".dblQ($tab_recap[$i]['TMA_SENS']).",'".dblQ($tab_recap[$i]['TMA_LOGICIEL'])."',
					'".dblQ($tab_recap[$i]['TMA_CODE_ERR'])."','".dblQ($tab_recap[$i]['TMA_LIBEL_ERR'])."', 
					'".dblQ($tab_recap[$i]['TMA_ARCHIVE'])."','".dblQ($tab_recap[$i]['TMA_CHEMIN'])."', 
					'".dblQ($tab_recap[$i]['TMA_CHEMIN_MOT'])."','".dblQ($tab_recap[$i]['TMA_EMET_NOM'])."', 
					$emet_id,'".dblQ($tab_recap[$i]['TMA_TELE_EMET'])."','".dblQ($tab_recap[$i]['TMA_TELE_DEST'])."',
					'".dblQ($tab_recap[$i]['TMA_DEST_NOM'])."',$dest_id,".dblQ($tab_recap[$i]['TMA_MODE']).", 
					'".dblQ($tab_recap[$i]['TMA_FORM'])."',$new_clt_id,'".dblQ($tab_recap[$i]['TMA_DATE_ENTREE'])."',	
					'".dblQ($tab_recap[$i]['TMA_DATE_SORTIE'])."','".dblQ($tab_recap[$i]['SCEAU_EDI'])."', 
					'".dblQ($tab_recap[$i]['SCEAU_XML'])."','".dblQ($tab_recap[$i]['TMA_CPT'])."',		
					'".dblQ($tab_recap[$i]['TMA_EMET_DEMAT'])."','".dblQ($tab_recap[$i]['TMA_DEST_DEMAT'])."',
					'".dblQ($tab_recap[$i]['DATE_INTER'])."',
					'".dblQ($tab_recap[$i]['TMA_ADR_FACT_A'])."','".dblQ($tab_recap[$i]['TMA_SIREN_FACT_A'])."',
					'".dblQ($tab_recap[$i]['TMA_TVA_FACT_A'])."',
					'".dblQ($tab_recap[$i]['TMA_ADR_FACT_PAR'])."','".dblQ($tab_recap[$i]['TMA_SIREN_FACT_PAR'])."',
					'".dblQ($tab_recap[$i]['TMA_TVA_FACT_PAR'])."'
					)";
		}
		if($ini_typeBase == "mssql")
		{
			$req = "insert into TABLE_MATIERE 
					(TMA_NUM_FACT, TMA_DATE_FACT, TMA_TYPE, TMA_FONC, TMA_DATE_REC, TMA_DATE_EMI, 
					TMA_DATE_TRAIT, TMA_CODE_FACT_A, TMA_NOM_FACT_A, TMA_PAR_ID_FACT_A, 
					TMA_CODE_FACT_PAR, TMA_NOM_FACT_PAR, TMA_PAR_ID_FACT_PAR, 
					TMA_MONT_HT, TMA_MONT_TTC, TMA_DEVISE, TMA_STATUT, TMA_SENS, TMA_LOGICIEL,
					TMA_CODE_ERR, TMA_LIBEL_ERR, TMA_ARCHIVE, TMA_CHEMIN, TMA_CHEMIN_MOT,
					TMA_EMET_NOM, TMA_EMET_ID, TMA_TELE_EMET, TMA_TELE_DEST,
					TMA_DEST_NOM, TMA_DEST_ID, TMA_MODE, TMA_FORM, CLT_ID, TMA_DATE_ENTREE, TMA_DATE_SORTIE, 
					TMA_SCEAU_EDI, TMA_SCEAU_XML, TMA_CPT, TMA_EMET_DEMAT, TMA_DEST_DEMAT, TMA_DATE_UNB,
					TMA_ADR_FACT_A,TMA_SIREN_FACT_A,TMA_TVA_FACT_A,TMA_ADR_FACT_PAR,TMA_SIREN_FACT_PAR,TMA_TVA_FACT_PAR) 
					values (
					'".dblQ($tab_recap[$i]['TMA_NUM_FACT'])."',convert(datetime,'".$tab_recap[$i]['TMA_DATE_FACT']."',120), 
					".dblQ($tab_recap[$i]['TMA_TYPE']).",".dblQ($tab_recap[$i]['TMA_FONC']).", 
					convert(datetime,'".$tab_recap[$i]['TMA_DATE_REC']."',120),convert(datetime,'".$tab_recap[$i]['TMA_DATE_EMI']."',120), 
					convert(datetime,'".$tab_recap[$i]['TMA_DATE_TRAIT']."',120),'".dblQ($tab_recap[$i]['TMA_CODE_FACT_A'])."', 
					'".dblQ($tab_recap[$i]['TMA_NOM_FACT_A'])."',$fact_a_id,".
					((($tab_recap[$i]['TMA_CODE_FACT_PAR'] + 1) == 1)?("null"):("'".dblQ($tab_recap[$i]['TMA_CODE_FACT_PAR'])."'")).",
					'".dblQ($tab_recap[$i]['TMA_NOM_FACT_PAR'])."',$fact_par_id, 
					'".dblQ($tab_recap[$i]['TMA_MONT_HT'])."','".dblQ($tab_recap[$i]['TMA_MONT_TTC'])."', 
					'".dblQ($tab_recap[$i]['TMA_DEVISE'])."','".dblQ($tab_recap[$i]['TMA_STATUT'])."', 
					".dblQ($tab_recap[$i]['TMA_SENS']).",'".dblQ($tab_recap[$i]['TMA_LOGICIEL'])."',
					'".dblQ($tab_recap[$i]['TMA_CODE_ERR'])."','".dblQ($tab_recap[$i]['TMA_LIBEL_ERR'])."', 
					'".dblQ($tab_recap[$i]['TMA_ARCHIVE'])."','".dblQ($tab_recap[$i]['TMA_CHEMIN'])."', 
					'".dblQ($tab_recap[$i]['TMA_CHEMIN_MOT'])."','".dblQ($tab_recap[$i]['TMA_EMET_NOM'])."', 
					$emet_id,'".dblQ($tab_recap[$i]['TMA_TELE_EMET'])."','".dblQ($tab_recap[$i]['TMA_TELE_DEST'])."',
					'".dblQ($tab_recap[$i]['TMA_DEST_NOM'])."',$dest_id,".dblQ($tab_recap[$i]['TMA_MODE']).", 
					'".dblQ($tab_recap[$i]['TMA_FORM'])."',$new_clt_id,convert(datetime,'".$tab_recap[$i]['TMA_DATE_ENTREE']."',120),	
					convert(datetime,'".$tab_recap[$i]['TMA_DATE_SORTIE']."',120),'".dblQ($tab_recap[$i]['SCEAU_EDI'])."', 
					'".dblQ($tab_recap[$i]['SCEAU_XML'])."','".dblQ($tab_recap[$i]['TMA_CPT'])."',		
					'".dblQ($tab_recap[$i]['TMA_EMET_DEMAT'])."','".dblQ($tab_recap[$i]['TMA_DEST_DEMAT'])."',
					convert(datetime,'".$tab_recap[$i]['DATE_INTER']."',120),
					'".dblQ($tab_recap[$i]['TMA_ADR_FACT_A'])."','".dblQ($tab_recap[$i]['TMA_SIREN_FACT_A'])."',
					'".dblQ($tab_recap[$i]['TMA_TVA_FACT_A'])."',
					'".dblQ($tab_recap[$i]['TMA_ADR_FACT_PAR'])."','".dblQ($tab_recap[$i]['TMA_SIREN_FACT_PAR'])."',
					'".dblQ($tab_recap[$i]['TMA_TVA_FACT_PAR'])."'
					)";
		}
		if($ini_typeBase == "oracle")
		{
			$req = "insert into TABLE_MATIERE 
					(CLT_ID,TMA_NUM_FACT,TMA_DATE_FACT,TMA_DATE_UNB,TMA_TYPE, TMA_FONC,TMA_CODE_FACT_A,
					TMA_NOM_FACT_A, TMA_PAR_ID_FACT_A,TMA_CODE_FACT_PAR, TMA_NOM_FACT_PAR, TMA_PAR_ID_FACT_PAR, 
					TMA_MONT_HT, TMA_MONT_TTC, TMA_DEVISE, TMA_STATUT, TMA_SENS, TMA_LOGICIEL,
					TMA_CODE_ERR, TMA_LIBEL_ERR, TMA_ARCHIVE, TMA_CHEMIN, TMA_CHEMIN_MOT,
					TMA_EMET_NOM, TMA_EMET_ID, TMA_TELE_EMET, TMA_TELE_DEST,TMA_DEST_NOM, TMA_DEST_ID, TMA_MODE) 
					values ($new_clt_id,'".dblQ($tab_recap[$i]['TMA_NUM_FACT'])."', 
					TIMESTAMP'".$tab_recap[$i]['TMA_DATE_FACT']."',TIMESTAMP'".$tab_recap[$i]['DATE_INTER']."' ,   
					".dblQ($tab_recap[$i]['TMA_TYPE']).",".dblQ($tab_recap[$i]['TMA_FONC']).", 
					'".dblQ($tab_recap[$i]['TMA_CODE_FACT_A'])."', '".dblQ($tab_recap[$i]['TMA_NOM_FACT_A'])."',$fact_a_id,".
					((($tab_recap[$i]['TMA_CODE_FACT_PAR'] + 1) == 1)?("null"):("'".dblQ($tab_recap[$i]['TMA_CODE_FACT_PAR'])."'")).",
					'".dblQ($tab_recap[$i]['TMA_NOM_FACT_PAR'])."',$fact_par_id, 
					'".dblQ($tab_recap[$i]['TMA_MONT_HT'])."','".dblQ($tab_recap[$i]['TMA_MONT_TTC'])."', 
					'".dblQ($tab_recap[$i]['TMA_DEVISE'])."','".dblQ($tab_recap[$i]['TMA_STATUT'])."', 
					".dblQ($tab_recap[$i]['TMA_SENS']).",'".dblQ($tab_recap[$i]['TMA_LOGICIEL'])."',
					'".dblQ($tab_recap[$i]['TMA_CODE_ERR'])."','".dblQ($tab_recap[$i]['TMA_LIBEL_ERR'])."', 
					'".dblQ($tab_recap[$i]['TMA_ARCHIVE'])."','".dblQ($tab_recap[$i]['TMA_CHEMIN'])."', 
					'".dblQ($tab_recap[$i]['TMA_CHEMIN_MOT'])."','".dblQ($tab_recap[$i]['TMA_EMET_NOM'])."', 
					$emet_id,'".dblQ($tab_recap[$i]['TMA_TELE_EMET'])."','".dblQ($tab_recap[$i]['TMA_TELE_DEST'])."',
					'".dblQ($tab_recap[$i]['TMA_DEST_NOM'])."',$dest_id,".dblQ($tab_recap[$i]['TMA_MODE'])."
					)";
			// chaine trop longue pour une seule transaction (requête <1000 caractères) donc insert+update
			$req1 = "update table_matiere set 
					TMA_DATE_REC=TIMESTAMP'".$tab_recap[$i]['TMA_DATE_REC']."'
					,TMA_DATE_EMI=TIMESTAMP'".$tab_recap[$i]['TMA_DATE_EMI']."'
					,TMA_DATE_TRAIT=TIMESTAMP'".$tab_recap[$i]['TMA_DATE_TRAIT']."'
					,TMA_DATE_ENTREE=TIMESTAMP'".$tab_recap[$i]['TMA_DATE_ENTREE']."'	
					,TMA_TVA_FACT_A='".dblQ($tab_recap[$i]['TMA_TVA_FACT_A'])."'
					,TMA_ADR_FACT_PAR='".dblQ($tab_recap[$i]['TMA_ADR_FACT_PAR'])."'
					,TMA_SIREN_FACT_PAR='".dblQ($tab_recap[$i]['TMA_SIREN_FACT_PAR'])."'
					,TMA_TVA_FACT_PAR='".dblQ($tab_recap[$i]['TMA_TVA_FACT_PAR'])."'
					,TMA_EMET_DEMAT='".dblQ($tab_recap[$i]['TMA_EMET_DEMAT'])."'
					,TMA_DEST_DEMAT='".dblQ($tab_recap[$i]['TMA_DEST_DEMAT'])."'
					,TMA_ADR_FACT_A='".dblQ($tab_recap[$i]['TMA_ADR_FACT_A'])."'
					,TMA_SIREN_FACT_A='".dblQ($tab_recap[$i]['TMA_SIREN_FACT_A'])."'
					,TMA_FORM='".dblQ($tab_recap[$i]['TMA_FORM'])."'
					,TMA_SCEAU_EDI='".dblQ($tab_recap[$i]['SCEAU_EDI'])."'
					,TMA_SCEAU_XML='".dblQ($tab_recap[$i]['SCEAU_XML'])."'
					,TMA_CPT='".dblQ($tab_recap[$i]['TMA_CPT'])."'
					where TMA_NUM_FACT='".dblQ($tab_recap[$i]['TMA_NUM_FACT'])."' 
					and TMA_MONT_TTC='".dblQ($tab_recap[$i]['TMA_MONT_TTC'])."'";
		}
		
		$gDb->SQLQuery($req, 1);
		$gDb->SQLFermeQuery(1);	
		
		if($ini_typeBase == "oracle")
		{
			$gDb->SQLQuery($req1, 1);
			$gDb->SQLFermeQuery(1);	
		}

	}
	
	
	$req = "update PART_TO_PART set PTP_HISTO = 1";
	$gDb->SQLQuery($req, 1);
	$gDb->SQLFermeQuery(1);	
	$req = "select PTP_EMET_ID, PTP_DEST_ID, max(PTP_DATE_ENTREE) as MAX_DATE_ENTREE from PART_TO_PART group by PTP_EMET_ID , PTP_DEST_ID";
	$gDb->SQLQuery($req, 1);
	while ($row = $gDb->SQLNextRow(1))
	{
		if($ini_typeBase == "mysql")
		{
			$req="select PTP_ID from PART_TO_PART
				where PTP_EMET_ID=".$row['PTP_EMET_ID']." and PTP_DEST_ID=".$row['PTP_DEST_ID']." 
				and PTP_DATE_ENTREE='".$row['MAX_DATE_ENTREE']."'";
		}
		if($ini_typeBase == "mssql")
		{
			$req="select PTP_ID from PART_TO_PART
				where PTP_EMET_ID=".$row['PTP_EMET_ID']." and PTP_DEST_ID=".$row['PTP_DEST_ID']." 
				and PTP_DATE_ENTREE=convert(datetime,'".$row['MAX_DATE_ENTREE']."',120)";
		}
		if($ini_typeBase == "oracle")
		{
			$req="select PTP_ID from PART_TO_PART
				where PTP_EMET_ID=".$row['PTP_EMET_ID']." and PTP_DEST_ID=".$row['PTP_DEST_ID']." 
				and PTP_DATE_ENTREE=TIMESTAMP '".$row['MAX_DATE_ENTREE']."'";           
		}
		$gDb->SQLQuery($req, 2);
		while ($row2 = $gDb->SQLNextRow(2))
		{
			$req = "update PART_TO_PART set PTP_HISTO = 0 where PTP_ID=".$row2['PTP_ID'];
			$gDb->SQLQuery($req, 3);
			$gDb->SQLFermeQuery(3);
		}
		$gDb->SQLFermeQuery(2);
	}
	$gDb->SQLFermeQuery(1);
	
	if ($msg == "") 
		$msg = str_replace(array('%NBLI%','%TOTALLI%'),array(($nbtotal - $nb_err),$nbtotal),$lang_admin_confav_inv_act_export_msg_li_trait); 
				
	if ($nb_err > 0)
	{
		$msg .= $lang_admin_confav_inv_act_export_msg_li_exist;
		for ($i = 0; $i < $nb_err; $i++)
		{
			$msg .= " ".$rapport[$i];
		}
	}
	
	$action = null; 
}
/************************************************************/
/* FIN ACTION = VALID 									*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
if (pget('Mode')=='ws') {
	$res=encode_JSON($reponse);
} else {
	echo encode_JSON($reponse);
}
?>
