<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");

$droitRole = ALE; //droit de gestion des Logs
$lmcse = DROIT_LECT + DROIT_CREAT + DROIT_MODIF + DROIT_SUPPR;

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$where = "";

$f_etat = pget('f_etat');
$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

switch($f_etat)
{
	case ETAT_ACTIF : 	
		$where .= " AND CMD_ETAT = ".ETAT_ACTIF; 	
		break;
	case ETAT_INACTIF : 
		$where .= " AND CMD_ETAT = ".ETAT_INACTIF; 
		break;
}

$req = "SELECT SQL_CALC_FOUND_ROWS CMD_ID, CMD_LIBEL, CMD_INTERVAL, CMD_DATE, CMD, CMD_ETAT  
		FROM PAR_CMD_LOG 
		WHERE CMD_ETAT != ".ETAT_SUPPR." 
			$where
		ORDER BY CMD_LIBEL";

$champs = array();
$champs[] = array("nom" => $lang_admin_log_grid_head_libelle, "toolTip" => $lang_admin_log_grid_head_libelle, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_log_grid_head_etat, "toolTip" => $lang_admin_log_grid_head_etat, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_log_grid_head_interval, "toolTip" => $lang_admin_log_grid_head_interval, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_log_grid_head_der_date, "toolTip" => $lang_admin_log_grid_head_der_date, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';

echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{

	$params = array();
	$params['cmd_id'] = $row['CMD_ID'];
	$params['droits'] = array('modif' => (droit($droitRole, DROIT_MODIF,null,null,null,null)),
							'suppr' => (droit($droitRole, DROIT_SUPPR,null,null,null,null)),
							'exec' => (droit($droitRole, DROIT_EXEC,null,null,null,null))
	);
	
	echo '<row detail="&lt;b&gt;'.$lang_admin_log_aff_lbl_commande.' : &lt;/b&gt;'.hi_disp($row['CMD']).'">';
		
	$toolTip = "";
	$urlDetail = "#";
	$icon = $pathStyle."imgs/icons/log.gif";

	echo '<item caption="'.hi_disp($row['CMD_LIBEL']).'" toolTip="'.$lang_admin_log_grid_act_detail.'" icon="'.$icon.'" value="'.row_encode_JSON($params).'"/>';
	
	$icon = "";
	$caption = "";

	switch($row['CMD_ETAT'])
	{
		case ETAT_ACTIF :
			$icon = $pathStyle."imgs/icons/lamp_on.png";
			$caption = $lang_admin_log_grid_lbl_etat_actif;
			break;
		case ETAT_INACTIF :
			$icon = $pathStyle."imgs/icons/lamp_off.png";
			$caption = $lang_admin_log_grid_lbl_etat_inactif;
			break;
	}
	echo '<item caption="'.$caption.'" icon="'.$icon.'" toolTip=""/>';
	echo '<item caption="'.hi_disp($row['CMD_INTERVAL']).'"/>';
	echo '<item caption="'.sql2Date($row['CMD_DATE']).'"/>';
	echo '</row>';
}
$gDb->SQLFermeQuery(1);

echo '</databind>';
?>