<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "suivi\historique\admin_purge_hist_dSGrid.php";

$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;
if (droit(HIS,$lmcse,null,null,null,null))
	$droitRole = HIS;
else
	$droitRole = SDO;
$where = "";
$restrict = "";

$cptID = $_SESSION['CPT_ID'];
$cltID = $_SESSION['CLT_ID'];


//paramètres généraux (aussi utilisés par les autres niveaux de suivi)
$typeDoc	= pget('typeDoc'); //Type de document
$numDoc		= pget('numDoc'); //No de document
$numCol		= pget('numCol'); //No de collecte
$numPres	= pget('numPres'); //No de présentation
$numAlt		= pget('numAlt'); //No d'alerte = SUI_ID
$nivHist	= pget('nivHist'); //Histo ou Histo Détaillé : 1 = normal; 2 = détaillé

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

//Traitement du type de document
$f_tdoc = pget('f_tdoc');
if($f_tdoc)
	$where .= " AND PRG_TDOC = $f_tdoc ";
else
{
	// On doit egalement filtrer sur les types de documents auxquels l'utilisateur a acces
	if (!droit(HIS, $lmcse,null,null,null,null) && !droit(SDO, $lmcse,null,null,1,null))	//on verifie les droits sur tous les documents
	{
		$req = "SELECT TDOC_ID, TDOC_NOM, TDOC_ETAT  
				FROM TYPE_DOC 
				WHERE TYPE_DOC.CLT_ID =".$cltID." AND TDOC_NOM != ' TOUS'";
		$gDb->SQLQuery($req, 1);
		while ($row = $gDb->SQLNextRow(1))
		{
			if (droit(SDO, $lmcse,null,null,$row['TDOC_ID'],null))	//on verifie les droits sur le type de documents TDOC_ID
			{
				$where .= " AND PRG_TDOC IN (".$row['TDOC_ID'];
				while($row = $gDb->SQLNextRow(1))
				{
					if (droit(SDO, $lmcse,null,null,$row['TDOC_ID'],null))	//on verifie les droits sur le type de documents TDOC_ID
						$where .= ",".$row['TDOC_ID'];
				}
				$where .= ") ";
				break;
			}
		}
		$gDb->SQLFermeQuery(1);
	}
}

// Criteres partenaires	
$f_emetteur		= pget('f_emetteur');		//filtre émetteur
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$fromPE 		= pget('fromPE');
$fromPD 		= pget('fromPD');

if ($fromPD>0 && $f_destinataire)
{
	if ($fromPD==2)// part + fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		if ($fils)
		$filsD=$f_destinataire.", ".$fils;
		else $filsD=$f_destinataire;

	}
	if ($fromPD==3) // que les fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		$filsD=$fils;

	}
	if ($fromPD==4) //que le part
	{
		$filsD=$f_destinataire;
	}
}
if ($fromPE>0 && $f_emetteur)
{
	if ($fromPE==2)// part + fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		if ($fils)
		$filsE=$f_emetteur.", ".$fils;
		else $filsE=$f_emetteur;
	}
	if ($fromPE==3) // que les fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		$filsE=$fils;
	}
	if ($fromPE==4) //que le part
	{
		$filsE=$f_emetteur;
	}
}

//Traitement de l'émetteur	
if ($fromPD>0){	if ($f_destinataire) $where .=" and PRG_DEST in ($filsD)";}
else {if ($f_destinataire) $where .= " and PRG_DEST = '".dblQ($f_destinataire)."'";}

if ($fromPE>0){ if ($f_emetteur) $where .=" and PRG_EMET in ($filsE)";}
else {if ($f_emetteur)	$where .= " and PRG_EMET = '".dblQ($f_emetteur)."'";}

if (!droit(HIS,$lmcse,null,null,null,null))
	Construit_restriction(SDO, "PRG_EMET", "PRG_DEST", null, null, $restrict, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);
	

//Traitement de la date
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND PRG_DATE BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND PRG_DATE BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND PRG_DATE >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND PRG_DATE >= '".date2Sql($f_date_deb, "23:59:59")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND PRG_DATE <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND PRG_DATE <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}
	
//Traitement de la date	de traitement
$f_date_traitdeb = pget('f_date_traitdeb');
$f_date_traitfin = pget('f_date_traitfin');
if($f_date_traitdeb) {
	if($f_date_traitfin) {
			//$date_deb_sql = date2Sql($f_date_traitdeb, "00:00:00");
            //$date_fin_sql = date2Sql($f_date_traitfin, "23:59:59");
		if($ini_typeBase == "oracle"){
				$date_traitdeb_sql = "TO_DATE('$f_date_traitdeb','DD/MM/YYYY HH24:MI:SS')";
				$date_traitfin_sql = "TO_DATE('$f_date_traitfin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND PRG_DATE_TRAIT BETWEEN $date_traitdeb_sql AND $date_traitfin_sql";
		}
		else{
			$where .= " AND PRG_DATE_TRAIT BETWEEN '".date2Sql($f_date_traitdeb, "00:00:00")."' AND '".date2Sql($f_date_traitfin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND PRG_DATE_TRAIT >= TO_DATE('$f_date_traitdeb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND PRG_DATE_TRAIT >= '".date2Sql($f_date_traitdeb, "00:00:00")."'";
		}
	}
}
else if($f_date_traitfin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND PRG_DATE_TRAIT <= TO_DATE('$f_date_traitfin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND PRG_DATE_TRAIT <= '".date2Sql($f_date_traitfin, "23:59:59")."'";
	}		
}	


//Traitement du mode (auto ou manuel)
$f_mode = pget('f_mode');
if($f_mode)
{
	if ($f_mode==2)
		$where .= " AND PRG_MANUEL = '0' ";
	else if($f_mode==1)
		$where .= " AND PRG_MANUEL = '1' ";
}
	

//Traitement de l'état
$f_etat = pget('f_etat');
if ($f_etat==0 || $f_etat == 1) {
	$where .= " AND PRG_RESULT = '$f_etat' ";
} else {
    if($f_etat==2) {
        $where .= " AND PRG_DATE_TRAIT IS NULL ";
    } 
    if($f_etat==3){
        $where .= " AND PRG_DATE_TRAIT IS NOT NULL AND PRG_RESULT IS NULL ";
    }
}


//Récupération des types de documents
$tab_tdoc = array();
if($ini_typeBase == "mysql")	
	$req = "SELECT FOR_ID, TDOC_NOM, TDOC_ETAT, FOR_ETAT, TDOC_ID
		FROM TYPE_DOC JOIN `FORMAT` USING (TDOC_ID)";
else
	$req = "SELECT FOR_ID, TDOC_NOM, TDOC_ETAT, FOR_ETAT, TYPE_DOC.TDOC_ID
		FROM TYPE_DOC JOIN FORMAT ON TYPE_DOC.TDOC_ID=FORMAT.TDOC_ID";

$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_tdoc[$row['FOR_ID']] = array("TDOC_NOM" => $row['TDOC_NOM'],
										"TDOC_ETAT" => $row['TDOC_ETAT'],
										"FOR_ETAT" => $row['FOR_ETAT'],
										"TDOC_ID" => $row['TDOC_ID']);
$gDb->SQLFermeQuery(1);

// Premiere requete pour obtenir le nombre d'enregistrements
$reqCount = "SELECT count(*) AS MAX_ROW
		    FROM PURGES 
			WHERE CLT_ID = $cltID $where $restrict";

	        	
$gDb->SQLQuery($reqCount, 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

// Calcul du nombre de pages
$pagesNumber = (int)($maxRow / $pageSize);

if($ini_typeBase == "mysql")
		$req = "SELECT PRG_ID, PRG_DATE, PRG_DATE_TRAIT, PRG_MANUEL, PRG_EMET, PRG_DEST, PRG_TDOC, PRG_LIBEL_LOG, PRG_RESULT, PRG_TDOC, PRG_CPT_ERR, CPT_ID FROM PURGES WHERE CLT_ID = $cltID $where $restrict";
else
		$req = "SELECT PRG_ID, PRG_DATE, PRG_DATE_TRAIT, PRG_MANUEL, PRG_EMET, PRG_DEST, PRG_TDOC, PRG_LIBEL_LOG, PRG_RESULT, PRG_TDOC t, PRG_CPT_ERR, CPT_ID FROM PURGES WHERE CLT_ID = $cltID $where $restrict";

// Si la page a affichee est dans la premiere partie de l'historique
if ($pageNum < (int)($pagesNumber / 2))
{
	// On ordonne selon PRG_DATE inverse
	$req .= " ORDER BY PRG_DATE DESC";
	$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);
}
else
{
	$req .= " ORDER BY PRG_DATE";
	$lastRows = $maxRow - ($pagesNumber * $pageSize);
	if ($pageNum > $pagesNumber)
		$gDb->SQLQuery($req, 1, 0, $lastRows);
	else
		$gDb->SQLQuery($req, 1, $lastRows + ($pageSize*($pagesNumber-$pageNum)), $pageSize);
}	

$champs = array();
$champs[] = array("nom" => $lang_sui_hist_grid_head_doc, "toolTip" => $lang_sui_hist_grid_head_doc, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_date, "toolTip" => $lang_sui_hist_grid_head_date, "sortMode" => "3");
$champs[] = array("nom" => $lang_sui_hist_grid_head_date_trait, "toolTip" => $lang_sui_hist_grid_head_date_trait, "sortMode" => "3");
$champs[] = array("nom" => $lang_sui_hist_grid_head_mode, "toolTip" => $lang_sui_hist_grid_head_mode, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_emet, "toolTip" => $lang_sui_hist_grid_head_emet, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_dest, "toolTip" => $lang_sui_hist_grid_head_dest, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_etat, "toolTip" => $lang_sui_hist_grid_head_etat, "sortMode" => "2");

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

$displayedRows = array();
$index = 0;

while ($row = $gDb->SQLNextRow(1))
{
	$detail_tmp='<tr><td><b><i>'.$lang_sui_hist_grid_act_nbre_exec. '</i></b>'.$row['PRG_CPT_ERR'].'</td></tr>';

	if($row['PRG_MANUEL']==1)
		$detail_tmp .= "<tr><td><b><i>$lang_utr_utr_lbl_user : </i></b>".getUserLogin($row['CPT_ID']).'</td></tr>';

	$detail = hi_disp("<table>$detail_tmp</table>");
	$displayedRows[$index] = '<row detail="'.$detail.'">';
	
	$caption = $lang_db_type_doc_tdoc_nom_tous;
	$icon = $pathFlow."style/imgs/icons/doc_new.gif";
	if (isset($row['PRG_TDOC']) && $row['PRG_TDOC']!=0 && $row['PRG_TDOC']!=-1)
	{		
      	//$deb = "";
		//$fin = "";
		
		$req = "SELECT TDOC_NOM 
			FROM TYPE_DOC 
				WHERE TDOC_ID = ".$row['PRG_TDOC'];
		$gDb->SQLQuery($req, 2);
		$row2 = $gDb->SQLNextRow(2);
		$gDb->SQLFermeQuery(2);
		
     	//$caption = hi_disp($deb.$tab_tdoc[$row['FOR_ID']]['TDOC_NOM'].$fin);
     	$caption = hi_disp($row2['TDOC_NOM']);
		if($caption=='') // Cas d'un type de document supprimé => on n'a plus son nom
		{
			$icon = '';
			$caption = $lang_admin_purge_lbl_typeDoc_suppr;
		}
      	$gDb->SQLFermeQuery(2);
	}
	
	$displayedRows[$index] .= '<item caption="'.$caption.'" icon="'.$icon.'" toolTip=""/>';

	$displayedRows[$index] .= '<item caption="'.sql2Date($row['PRG_DATE']).'"/>';
	
	if(empty($row['PRG_DATE_TRAIT']))
	{
		$displayedRows[$index] .= '<item caption=" "/>';
	}
	else
	{
		$displayedRows[$index] .= '<item caption="'.sql2Date($row['PRG_DATE_TRAIT']).'"/>';
	}
	

	
	$displayedRows[$index] .= '<item';	
	switch($row['PRG_MANUEL'])
	{
		case 1 :
			$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/menu/avance.png" toolTip="'.$lang_admin_purge_pnl_title_manuel.'" caption="'.$lang_admin_purge_pnl_title_manuel.'"';
			break;
		case 0 :
			$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/exec.png" toolTip="'.$lang_admin_purge_pnl_title_auto.'" caption="'.$lang_admin_purge_pnl_title_auto.'"';
			break;
		default :
	}
	$displayedRows[$index] .= '/>';
	
	
	
	
	$req = "SELECT PAR_NOM
			FROM PART 
				WHERE PAR_ID = '".$row['PRG_EMET']."'";
		$gDb->SQLQuery($req, 2);
		$row2 = $gDb->SQLNextRow(2);
		$gDb->SQLFermeQuery(2);
		
	$displayedRows[$index] .= '<item caption="'.hi_disp($row2['PAR_NOM']).'"/>';
		
	$req = "SELECT PAR_NOM
			FROM PART 
				WHERE PAR_ID = '".$row['PRG_DEST']."'";
		$gDb->SQLQuery($req, 2);
		$row2 = $gDb->SQLNextRow(2);
		$gDb->SQLFermeQuery(2);
	
	$displayedRows[$index] .= '<item caption="'.hi_disp($row2['PAR_NOM']).'"/>';
	

	$displayedRows[$index] .= '<item';	
	$etat_purge=$row['PRG_RESULT'];
	if ($row['PRG_DATE_TRAIT'] != null) {
        if ($etat_purge==='1') {
            $displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/rond_rouge.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_err.'" caption="'.hi_disp($row['PRG_LIBEL_LOG']).'"';
        } else {
            if ($etat_purge==='0') {
              	$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/rond_vert.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_ok.'" caption="Purge OK"';  
            } else {
                $displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/rond_jaune.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_info.'" caption="'.$lang_ds_etat_interrompu.'"';
            }
        }    
    } else {
        $displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/rond_jaune.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_info.'" caption="'.$lang_ds_etat_en_attente.'"';
    }
	$displayedRows[$index] .= '/>';
	
	$displayedRows[$index] .= '</row>';
	$index++;
}	
$gDb->SQLFermeQuery(1);

if ($pageNum < (int)($pagesNumber / 2))
	for ($i = 0; $i < $index; $i++)	echo $displayedRows[$i];		
else
	for ($i = ($index-1); $i >= 0; $i--) echo $displayedRows[$i];		

echo '</databind>';

if ((!isset($_SESSION['PURGE_FILTER']['remember'])) || ($_SESSION['PURGE_FILTER']['remember']))
{
	$_SESSION['PURGE_FILTER'] = array (
	'remember'		=> true,
	'pageNum'		=> $pageNum,
	'pageSize' 		=> $pageSize,
	'nivHist'		=> $nivHist,
//	'f_afx' 		=> $f_afx,
	'f_tdoc' 		=> $f_tdoc,
	'f_emetteur' 	=> $f_emetteur,
	'f_destinataire'=> $f_destinataire,
	'fromPE' 		=> $fromPE,
	'fromPD'		=> $fromPD,
	'f_date_deb'	=> $f_date_deb,
	'f_date_fin' 	=> $f_date_fin,
	'f_date_traitdeb'	=> $f_date_traitdeb,
	'f_date_traitfin' 	=> $f_date_traitfin,
	'f_mode' 		=> $f_mode,
	'f_etat' 		=> $f_etat,	
//	'f_rejoue'		=> $f_rejoue);
		);
}
?>