<?php
if (!isset($DEFAULT_PATH))$DEFAULT_PATH ="../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once($DEFAULT_PATH."struct.php");
$droitRole = TAB;	//droits de traitement des flux
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC; 	//droits en lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."req_ed.php");

$page_courante = "admin/alert/admin_tab_actAction.php";


$tab_id = pget('tab_id');
$tab_nom = pget('tab_nom');
$tab_libel = pget('tab_libel');
$tab_req = pget('tab_req');
$tab_nbre_ligne	= pget('tab_nbre_ligne');
$tab_type_graphique = pget('tab_type_graphique');
$tab_taille = pget('tab_taille');

$action	= pget('action');
$clt_id = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

if ($action == "suppr")
{
	if (droit($droitRole, DROIT_SUPPR,null,null,null,null))
	{
		$fatal = false;
		if ($gDb->SQLTransact() == false)
			$fatal = true;
		
		$req = "DELETE FROM TABLEAU_BORD 
				WHERE TAB_ID = $tab_id";
		
		if ($gDb->SQLQuery($req, 1) == false)
			$fatal = true;
		$gDb->SQLFermeQuery(1);
		
		if ($fatal) //FATAL --> Impossible de supprimer
		{
			$msg = $lang_admin_tab_act_suppr_msg_err;
			$return = 1;
			$gDb->SQLRollBack();
		}
		else //Tous s'est bien passé
		{
			$msg = $lang_admin_tab_act_suppr_msg_ok;
			$return = 0;
			$gDb->SQLCommit();
		}
	}
	else
	{
		$msg = $lang_admin_tab_act_msg_err_droit;
		$return = 1;
	}
}
else if ($action == "create")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null))
	{
		$fatal = false;
		$req = "SELECT COUNT(*) AS NB 
				FROM TABLEAU_BORD
				WHERE TAB_NOM = '".dblQ($tab_nom)."'";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);
				 
		if ($row['NB'] != 0)
		{
			$msg = $lang_admin_tab_act_create_msg_mm_nom;
			$return = 1;
			$fatal = true;
		}
		
		if (!$fatal && !reqValide($tab_req, $msg, $null))
			$fatal = true;
		
		if (!$fatal)
		{
			if ($gDb->SQLTransact() == false)
				$fatal = true;
	
				$req = "INSERT INTO TABLEAU_BORD (CLT_ID, TAB_NOM, TAB_LIBEL, TAB_REQ, TAB_NBRE_LIGNE, TAB_GRAPH_TYPE, TAB_GRAPH_TAILLE)
					VALUES 
					('".$_SESSION['CLT_ID']."',
					'".dblQ($tab_nom)."',
					'".dblQ($tab_libel)."',
					'".dblQ(trim($tab_req))."',
					$tab_nbre_ligne,$tab_type_graphique,$tab_taille)";
			 
			if ($gDb->SQLQuery($req, 1) == false)
				$fatal = true;
				
			$gDb->SQLFermeQuery(1);
			$tab_id = $gDb->SQLLastID();
	
			if ($fatal) 
			{
				$msg = $lang_admin_tab_act_create_msg_err;
				$return = 1;
				$gDb->SQLRollBack();
			}
			else 
			{
				$msg = $lang_admin_tab_act_create_msg_ok;
				$return = 0;
				$gDb->SQLCommit();
			}
		}
	}
	else
	{
		$msg = $lang_admin_tab_act_msg_err_droit;
		$return = 1;
	}
}
else if ($action == "modif")
{
	if (droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$fatal = false;
		$req = "SELECT COUNT(*) AS NB 
				FROM TABLEAU_BORD
				WHERE TAB_NOM = '".dblQ($tab_nom)."' 
					AND TAB_ID != $tab_id";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);
		
		if ($row['NB'] != 0)
		{
			$msg = $lang_admin_tab_act_modif_msg_mm_nom;
			$return = 1;
			$fatal = true;
		}
			
		if (!$fatal && !reqValide($tab_req, $msg, $null))
		{
			$fatal = true;
		}
		
		if (!$fatal)
		{
			if ($gDb->SQLTransact() == false)
				$fatal = true;
	
			$req = "UPDATE TABLEAU_BORD 
					SET TAB_LIBEL = '".dblQ($tab_libel)."',
						TAB_REQ = '".dblQ(trim($tab_req))."',
						TAB_NBRE_LIGNE = $tab_nbre_ligne,
 						TAB_GRAPH_TYPE = $tab_type_graphique,
						TAB_GRAPH_TAILLE = $tab_taille
					WHERE TAB_ID = $tab_id";
			
			if ($gDb->SQLQuery($req, 1) == false)
				$fatal = true;
			$gDb->SQLFermeQuery(1);
	
			if ($fatal) 
			{
				$msg = $lang_admin_tab_act_modif_msg_err;
				$return = 1;
				$gDb->SQLRollBack();
			}
			else 
			{
				$msg = $lang_admin_tab_act_modif_msg_ok;
				$return = 0;
				$gDb->SQLCommit();
			}
		}
	}
	else
	{
		$msg = $lang_admin_tab_act_msg_err_droit;
		$return = 1;
	}
}

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
if (pget('Mode')=='ws') {
	$res=encode_JSON($reponse);
} else {
	echo encode_JSON($reponse);
}
?>