<?php
 function rrmdir($dir) {
   if (is_dir($dir)) {
     $objects = scandir($dir);
     foreach ($objects as $object) {
       if ($object != "." && $object != "..") {
         if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object); else unlink($dir."/".$object);
       }
     }
     reset($objects);
     rmdir($dir);
   }
 }

class UIFWebService {
      
    private $auth ="false" ;
    private $login="";
    private $password="";
    
	/**
     * Constructeur
     *
     * @param string $hdr
     */
    public function __construct($hdr){
    	global $gDb;
        $header = simplexml_load_string($hdr);
        $req = 'SELECT CPT_PWD FROM COMPTE WHERE CPT_LOGIN="'.$header->login.'";';
        $gDb->SQLQuery($req, 1);
        $row = $gDb->SQLNextRow(1);
        $gDb->SQLFermeQuery(1);  
    	if($header->password == $row['CPT_PWD'] ){
			$this->auth=true;
            $this->login=$header->login;
            $this->password=$header->password;
        } else {
			$this->auth=false;
		}
	}
 
	/**
     * Retourne les informations des tables FORMAT, FLUX, SUIVI, ALERTE ou JOURNAL
     *
     * @param string $string indique la table
	 * @param int $nb indique le nombre de ligne à retourner
	 * @return string
     */
	public function get_data($string, $nb=100){
		if($this->auth==false){
		   	return "-2";
		}
 	   	global $gDb;
        $list = array("FORMAT","FLUX","SUIVI","ALERTE","JOURNAL");
        if (is_numeric(array_search(strtoupper($string),$list)) AND $nb < 100) {
            $req = "SELECT * FROM `".$string."` ORDER BY 1 DESC LIMIT ".$nb.";";
            $gDb->SQLQuery($req, 1);
            while ($row = $gDb->SQLNextRow(1)){
                $ret[]=$row;
            }
            $gDb->SQLFermeQuery(1);  
            return $ret;
        } else {
            $gDb->SQLFermeQuery(1);  
            return $string;
        }   
	}
    
	/**
     * Fonctin d'exécution d'un flux
     *
	 * @param int $id_flux
	 * @return int
     */
    public function exec_flux($id_flux){
		if($this->auth==false){
		   	return "-2";
		}
 	   	global $gDb;
        $req = "SELECT FLX_ID FROM FLUX WHERE FLX_ACTIF='1' AND FLX_ETAT='1';";
        $gDb->SQLQuery($req, 1);
        while ($row = $gDb->SQLNextRow(1)){
            $ret[]=$row[0];
        }
        $gDb->SQLFermeQuery(1);  
        if (is_numeric(array_search($id_flux,$ret))) {
        	$req = "INSERT INTO PLANIF (PLA_ID,CLT_ID,FLX_ID,PLA_ACTIF,PLA_MOIS,PLA_JOUR,PLA_JOURSEM,PLA_HEURE,PLA_MINUTE,PLA_DELAIDEM,PLA_DATEDER,PLA_IMMEDIAT) VALUES ( NULL,'1','".$id_flux."','1','*','*','*','*','*','1',NULL,'1');";
        	if ($gDb->SQLQuery($req, 1)) {
        		$gDb->SQLFermeQuery(1);
        		return "0";
        	}
        }
        $gDb->SQLFermeQuery(1);
        return "-1";
    }

	/**
     * Exécution de fonction interne
     *
	 * @param string $obj indique l'action
	 * @param string $action indique la commande relative à l'action
	 * @param anytype $param indique le paramètrage à utiliser
	 * @return anytype
     */
    public function exec_uif($obj, $action, $param) {
    	if($this->auth==false){
		   	return "-2";
    	}
    	global $DEFAULT_PATH;
    	global $culture_folder;
    	global $gDb;
    	global $res;
		global $ini_typeBase;
    	require_once('actions.php');
    	$_POST['UIFlogin']=$this->login;
    	$_POST['UIFpwd']=$this->password;
    	$_POST['Mode']='ws';
    	require_once('../connexion_bd.php');
    	$param=explode("&",$param);
    	foreach($param as $par) {
    		$val=explode("=",$par);
            $_GET[$val[0]]=$val[1];
        }
        $_GET['action']=$action;
        $_GET['Mode']='ws';
		require_once($Actions[$obj][0]);
        return $res;
    }

    /**
     * Affichage d'une page du site
     *
	 * @param string $page indique la page à afficher
     */
    public function get_page($page) {
    	if($this->auth==false){
		   	return "-2";
    	}
    	global $DEFAULT_PATH;
    	global $culture_folder;
    	global $gDb;
    	global $res;
		global $ini_typeBase;
		global $pathFlow;
    	$_POST['UIFlogin']=$this->login;
    	$_POST['UIFpwd']=$this->password;
    	$_POST['Mode']='ws';
		require_once('../connexion_bd.php');
		header('location:../'.urldecode($page));
    }

    /**
     * Execute un select dont la requête est passée en paramètre. Retourne un tableau de données
     *
	 * @param string $req indique la requête SELECT à effectuer
	 * @param string $retType indique le type de retour 'array' ou 'xml'
	 * @param string $root indique le tag du noeud racine dans le cas d'un retour XML
	 * @return anytype
     */
	public function sql_select($req, $retType = 'array', $root = 'xml') {
    	if($this->auth==false)
		   	return "-2";

    	global $DEFAULT_PATH;
		global $_SESSION;
    	global $culture_folder;
		global $pathFlow;
    	global $gDb;
    	global $res;
		global $ini_typeBase;
    	$_POST['UIFlogin']=$this->login;
    	$_POST['UIFpwd']=$this->password;
    	$_POST['Mode']='ws';

		require_once('../req_ed.php');
		if (preg_match("/".mb_sql_regcase("UPDATE|INSERT|DELETE|GRANT|ALTER|REPLACE")."/", $req))	
		{
			if($retType == 'array')
				return array($retType."$lang_reqvalide_msgerr_selectonly\n$lang_reqvalide_msgerr_cantotherstat");
			else
				return '<?xml version="1.0" encoding="UTF-8"?><err>'.$lang_reqvalide_msgerr_selectonly.'. '.$lang_reqvalide_msgerr_cantotherstat.'</err>';
		}
		
		require_once('../connexion_bd.php');
		$gDb->SQLQuery($req, 1);
		
		if($retType=='array')
		{
			$ret = array();
			while($row=$gDb->SQLNextRow(1))
				array_push($ret, $row);
		}
		else if($retType=='xml')
		{
			$ret = "<$root>";
			while($row=$gDb->SQLNextRow(1))
			{
				$ret .= '<row>';
				foreach($row as $key => $val)
				{
					if(is_string($key))
						$ret .= "<$key>$val</$key>";
				}
				$ret .= '</row>';
			}
			$ret .= "</$root>";
		}
		
		$gDb->SQLFermeQuery(1);
		return $ret;
	}
	
	/**
     * Webservices spécifiques Asalae 
	 * Réception d'une réponse à un transfert (TransferReply)
     *
	 * @param string $transferReply
	 * @return int
	 */ 
    public function asalae_transfer_reply($transferReply) {
    	// Verification de l'authentification
    	if($this->auth==false){
		   	return "-2";
    	}
    	// Chargement du XML de la reponse
    	$transferReplyXML = simplexml_load_string(base64_decode($transferReply));
    	// Recherche du code de reponse
		$transferReplyXML->registerXPathNamespace('seda','fr:gouv:ae:archive:draft:standard_echange_v0.2'); 
		$replyCodes = $transferReplyXML->xpath('//seda:ReplyCode');
		$replyCode = sprintf("%s",$replyCodes[0]);
		// Recherche de l'identifiant du transfert
		$transferIdentifiers = $transferReplyXML->xpath('//seda:TransferIdentifier');
		$transferIdentifier  = sprintf("%s",$transferIdentifiers[0]);
		// Si l'identifiant est valide
 	   	if (preg_match('/^(.+)([0-9]{6})$/i',$transferIdentifier,$res))
 	   	{
			global $gDb;
			// Recuperation du nom de l'archive
			$vrs_archive_name = $res[1];
			// Recuperation du numero de l'archive
			$vrs_archive_nb = $res[2];
			// L'etat de l'archive depend du code de reponse
			if ($replyCode == "000")
			{
				// Transfert en cours de traitement
				$vrs_etat="2";
			}
			else
			{
				// Transfert refuse
				$vrs_etat="4";
			}
			// Mise a jour de la table des versements aux archives
	       	$req = "UPDATE VERSEMENTS_ARCHIVES SET VRS_ETAT=$vrs_etat WHERE VRS_ARCHIVE_NAME='$vrs_archive_name' AND VRS_ARCHIVE_NB=$vrs_archive_nb;";
       		$gDb->SQLQuery($req, 1);
	        $gDb->SQLFermeQuery(1);
 	   	}
		return 0;
    }

    /**
     * Réception d'un accord de versement (TransferAcceptance)
     *
	 * @param string $transferAcceptance
	 * @return int
	 */
    public function asalae_transfer_acceptance($transferAcceptance) {
    	// Verification de l'authentification
    	if($this->auth==false){
		   	return "-2";
    	}
    	// Chargement du XML de l'accord
    	$transferAcceptanceXML = simplexml_load_string(base64_decode($transferAcceptance));
    	// Recherche de l'identifiant du transfer 
		$transferAcceptanceXML->registerXPathNamespace('seda','fr:gouv:ae:archive:draft:standard_echange_v0.2'); 
    	$transferIdentifiers = $transferAcceptanceXML->xpath('//seda:TransferIdentifier');
		$transferIdentifier  = sprintf("%s",$transferIdentifiers[0]);
		// Si l'identifiant est valide
		if (preg_match('/^(.+)([0-9]{6})$/i',$transferIdentifier,$res))
 	   	{
			global $gDb;
			// Recuperation du nom de l'archive
			$vrs_archive_name = $res[1];
			// Recuperation du numero de l'archive
			$vrs_archive_nb = $res[2];
			// Mise a jour de la table des versements aux archives
	       	$req = "UPDATE VERSEMENTS_ARCHIVES SET VRS_ETAT=5 WHERE VRS_ARCHIVE_NAME='$vrs_archive_name' AND VRS_ARCHIVE_NB=$vrs_archive_nb;";
       		$gDb->SQLQuery($req, 1);
	        $gDb->SQLFermeQuery(1);
	        // Insertion dans la table des archives demat des lignes de la table des matieres
	        // de l'archive acceptee
			$req = "INSERT INTO ARCHIVE_TABLE_MATIERE SELECT * FROM TABLE_MATIERE WHERE TMA_ARCHIVE LIKE '$transferIdentifier%';";
       		$gDb->SQLQuery($req, 1);
	        $gDb->SQLFermeQuery(1);
	        // Suppression de la table des matieres 
	        $req = "SELECT VPG_VAL FROM VAL_PAR_GEN WHERE PFL_ID=2758";
       		$gDb->SQLQuery($req, 1);
       		if (($row=$gDb->SQLNextRow(1)) && ($row['VPG_VAL']=='1'))
       		{
	        	$gDb->SQLFermeQuery(1);
       			// Suppression des lignes de la table des matieres de l'archive acceptee
				$req = "DELETE FROM TABLE_MATIERE  WHERE TMA_ID IN (SELECT TMA_ID FROM ARCHIVE_TABLE_MATIERE WHERE TMA_ARCHIVE LIKE '$transferIdentifier%');";	        
	       		$gDb->SQLQuery($req, 1);
		        $gDb->SQLFermeQuery(1);
       		}
	        $gDb->SQLFermeQuery(1);
		    // Suppression des fichiers 
	        $req = "SELECT VPG_VAL FROM VAL_PAR_GEN WHERE PFL_ID=2755";
       		$gDb->SQLQuery($req, 1);
       		if (($row=$gDb->SQLNextRow(1)) && ($row['VPG_VAL']=='1'))
       		{
	        	$gDb->SQLFermeQuery(1);
       			$req = "SELECT VRS_ARCHIVE_DIR FROM VERSEMENTS_ARCHIVES WHERE VRS_ARCHIVE_NAME='$vrs_archive_name' AND VRS_ARCHIVE_NB=$vrs_archive_nb";
       			$gDb->SQLQuery($req, 1);
       			if ($row=$gDb->SQLNextRow(1))
       			{
       				error_log($row['VRS_ARCHIVE_DIR']);
       				rrmdir($row['VRS_ARCHIVE_DIR'].'/'.$transferIdentifier);
       			}
       		}
	        $gDb->SQLFermeQuery(1);
       		
 	   	}
		return 0;
    }
}


?>
