<?php
/**
* Access the HTTP Request
*/
class http_request {
 
/** additional HTTP headers not prefixed with HTTP_ in $_SERVER superglobal */
var $add_headers = array('CONTENT_TYPE', 'CONTENT_LENGTH');
 
/**
* Construtor
* Retrieve HTTP Body
* @param Array Additional Headers to retrieve
*/
function http_request($add_headers = false) {
 
$this->retrieve_headers($add_headers);
$this->body = @file_get_contents('php://input');
}
 
/**
* Retrieve the HTTP request headers from the $_SERVER superglobal
* @param Array Additional Headers to retrieve
*/
function retrieve_headers($add_headers = false) {
 
if ($add_headers) {
$this->add_headers = array_merge($this->add_headers, $add_headers);
}
 
if (isset($_SERVER['HTTP_METHOD'])) {
$this->method = $_SERVER['HTTP_METHOD'];
unset($_SERVER['HTTP_METHOD']);
} else {
$this->method = isset($_SERVER['REQUEST_METHOD']) ? $_SERVER['REQUEST_METHOD'] : false;
}
$this->protocol = isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : false;
$this->request_method = isset($_SERVER['REQUEST_METHOD']) ? $_SERVER['REQUEST_METHOD'] : false;
 
$this->headers = array();
foreach($_SERVER as $i=>$val) {
if (strpos($i, 'HTTP_') === 0 || in_array($i, $this->add_headers)) {
$name = str_replace(array('HTTP_', '_'), array('', '-'), $i);
$this->headers[$name] = $val;
}
}
}
 
/**
* Retrieve HTTP Method
*/
function method() {
return $this->method;
}
 
/**
* Retrieve HTTP Body
*/
function body() {
return $this->body;
}
 
/**
* Retrieve an HTTP Header
* @param string Case-Insensitive HTTP Header Name (eg: "User-Agent")
*/
function header($name) {
$name = strtoupper($name);
return isset($this->headers[$name]) ? $this->headers[$name] : false;
}
 
/**
* Retrieve all HTTP Headers
* @return array HTTP Headers
*/
function headers() {
return $this->headers;
}
 
/**
* Return Raw HTTP Request (note: This is incomplete)
* @param bool ReBuild the Raw HTTP Request
*/
function raw($refresh = false) {
 
if (isset($this->raw) && !$refresh) {
return $this->raw; // return cached
}
 
$headers = $this->headers();
$this->raw = "{$this->method}\r\n";
 
foreach($headers as $i=>$header) {
$this->raw .= "$i: $header\r\n";
}
 
$this->raw .= "\r\n{$http_request->body}";
 
return $this->raw;
}
 
}
 
/**
* Echos the HTTP Request back to the client/browser
*/
 
$http_request = new http_request();
 
$res = $http_request->raw();
//echo nl2br($res);

$res .= "\r\nHTTP_RAW_POST_DATA : \r\n";

$res .= file_get_contents("php://input");  // $HTTP_RAW_POST_DATA

$res .= "\r\n_POST : \r\n";

foreach($_POST as $key => $val)
	$res .= "\r\n $key = $val";
	
$res .= "\r\n_FILES : \r\n";

foreach($_FILES as $name => $file)
{
	$info = $_FILES[$name]['tmp_name'];
	$res .= "\r\n $name : \r\n";
	$res .= file_get_contents($info);
}

file_put_contents('c:/flow/fmoteur/tmp/out.txt', $res);

exit(0);

?>