<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");

$droitRole = FRM;// droit de saisie de formulaire
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$where = "";
$pageNum 		= pget('pageNum');
$pageSize 		= pget('pageSize');
$f_emetteur		= pget('f_emetteur');		//filtre emetteur  
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$f_date_deb     = pget('f_date_deb');
$f_date_fin     = pget('f_date_fin');
$cltID  		= $_SESSION['CLT_ID'];

Construit_restriction($droitRole, 'E_FORM.PAR_EMET_ID', 'E_FORM.PAR_DEST_ID', null, null, $restrict, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);

//Traitement de la date
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND E_DATECREAT BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND E_DATECREAT BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND E_DATECREAT >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND E_DATECREAT >= '".date2Sql($f_date_deb, "23:59:59")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND E_DATECREAT <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND E_DATECREAT <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}


// Criteres partenaires
$f_emetteur		= pget('f_emetteur');		//filtre émetteur
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$fromPE 		= pget('fromPE');
$fromPD 		= pget('fromPD');

if ($fromPD>0 && $f_destinataire)
{
	if ($fromPD==2)// part + fils
	{
		$fils='';
		trouve_fils($f_destinataire);
		if ($fils)
		$filsD=$f_destinataire.', '.$fils;
		else $filsD=$f_destinataire;

	}
	if ($fromPD==3) // que les fils
	{
		$fils='';
		trouve_fils($f_destinataire);
		$filsD=$fils;

	}
	if ($fromPD==4) //que le part
	{
		$filsD=$f_destinataire;
	}
}
if ($fromPE>0 && $f_emetteur)
{
	if ($fromPE==2)// part + fils
	{
		$fils='';
		trouve_fils($f_emetteur);
		if ($fils)
		$filsE=$f_emetteur.', '.$fils;
		else $filsE=$f_emetteur;
	}
	if ($fromPE==3) // que les fils
	{
		$fils='';
		trouve_fils($f_emetteur);
		$filsE=$fils;
	}
	if ($fromPE==4) //que le part
	{
		$filsE=$f_emetteur;
	}
}

if ($fromPD>0){	if ($f_destinataire) $where .=" and PAR_DEST_ID in ($filsD)";}
else {if ($f_destinataire) $where .= " and PAR_DEST_ID = '".dblQ($f_destinataire)."'";}

if ($fromPE>0){ if ($f_emetteur) $where .=" and PAR_EMET_ID in ($filsE)";}
else {if ($f_emetteur)	$where .= " and PAR_EMET_ID = '".dblQ($f_emetteur)."'";}

// Le FIC_ID doit être alloué car sinon l'activité de collecte de flowma n'a pas encore fait son travail (= préparation du fichier de sortie)
$req = "SELECT SQL_CALC_FOUND_ROWS E_ID, E_DATECREAT, PAR_EMET_ID, PAR_DEST_ID, FIC_ID, E_FRM_ID, FRM_TITRE, FORMULAIRE.FOR_ID, `FORMAT`.TDOC_ID
		FROM E_FORMULAIRE, FORMULAIRE, `FORMAT`, TYPE_DOC 
		WHERE E_FORMULAIRE.CLT_ID = $cltID 
		AND FIC_ID > 0
		AND E_ETATTRAIT = 0	
		AND FORMULAIRE.FRM_ID = E_FRM_ID
		AND FORMULAIRE.FOR_ID = `FORMAT`.FOR_ID 
		AND `FORMAT`.TDOC_ID = TYPE_DOC.TDOC_ID 
		$where 
		$restrict 
		ORDER BY E_ID";

$champs = array();
$champs[] = array("nom" => $lang_lbl_date, "toolTip" => $lang_lbl_date, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_frm_titre, "toolTip" => $lang_lbl_frm_titre_toolTip, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_emet, "toolTip" => $lang_sui_col_grid_head_emet_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_dest, "toolTip" => $lang_sui_col_grid_head_dest_tooltip, "sortMode" => "1");

$gDb->SQLQuery($req, 1,($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';
foreach ($champs as $col) echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
echo '</header>';

if($maxRow)
{
	while ($row = $gDb->SQLNextRow(1))
	{
		echo '<row>';
		
		$params = array();
		$params['e_id'] = $row['E_ID'];
		$params['frm_id'] = $row['E_FRM_ID'];
		$params['droits'] = array('saisir' => (droit($droitRole, DROIT_MODIF,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $typeDoc,null)),
									'valider' => (droit($droitRole, DROIT_MODIF,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $typeDoc,null)),
									'rejeter' => (droit($droitRole, DROIT_MODIF,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $typeDoc,null)));
				
		if ($row['PAR_EMET_ID'])
		{
			$req = "SELECT PAR_NOM, PAR_ETAT  
					FROM PART 
					WHERE PAR_ID = ".$row['PAR_EMET_ID'];
			$gDb->SQLQuery($req, 2);
			$rowEmet = $gDb->SQLNextRow(2);
			$gDb->SQLFermeQuery(2);
		}
		
		if ($row['PAR_DEST_ID'])
		{
			$req = "SELECT PAR_NOM, PAR_ETAT  
					FROM PART 
					WHERE PAR_ID = ".$row['PAR_DEST_ID'];
			$gDb->SQLQuery($req,2);
			$rowDest = $gDb->SQLNextRow(2);
			$gDb->SQLFermeQuery(2);
		}
		
		$date = sql2Date($row['E_DATECREAT']);
		echo '<item caption="'.$date.'" value="'.row_encode_JSON($params).'"/>';
		
		echo '<item caption="'.hi_disp($row['FRM_TITRE']).'"/>';
		
		$deb = $fin = "";
		switch($rowEmet['PAR_ETAT'])
		{
			case ETAT_SUPPR:
				$deb = AFF_SUPPR_DEB;
				$fin = " $lang_lbl_etat_suppr_ini ";
				break;
			case ETAT_INACTIF:
				$deb = AFF_INACTIF_DEB;
				$fin = " $lang_lbl_etat_inact_ini ";
				break;
		}
		$emet = hi_disp($deb.$rowEmet['PAR_NOM'].$fin);
		
		$deb = $fin = "";
		switch($rowDest['PAR_ETAT'])
		{
			case ETAT_SUPPR:
				$deb = AFF_SUPPR_DEB;
				$fin = " $lang_lbl_etat_suppr_ini ";
				break;
			case ETAT_INACTIF:
				$deb = AFF_INACTIF_DEB;
				$fin = " $lang_lbl_etat_inact_ini ";
				break;
		}
		$dest = hi_disp($deb.$rowDest['PAR_NOM'].$fin); 
		
		echo '<item caption="'.$emet.'"/>';
		echo '<item caption="'.$dest.'"/>';
		
		echo '</row>';
	}
	$gDb->SQLFermeQuery(1);
}
echo '</databind>';
?>