<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$droitRole = SDO;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_SUPPR + DROIT_EXEC;

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');
$where = "";

// param�tres
$action=pget('action');
$limit	= pget('limit');
$f_emetteur		= pget('f_emetteur');		//filtre �metteur  
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$f_tdoc 	= pget("f_tdoc");
$f_etat 	= pget("f_etat");
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget("f_date_fin");
$cltID = $_SESSION['CLT_ID'];

Construit_restriction($droitRole, "SIGNATUREEBXTS.PAR_EMET_ID", "SIGNATUREEBXTS.PAR_DEST_ID", "SIGNATUREEBXTS.TDOC_ID", null, $restrict, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);
if($f_tdoc)
{
	$req = "SELECT FOR_ID
			FROM `FORMAT`
				WHERE TDOC_ID = $f_tdoc
				AND FOR_ETAT != ".ETAT_SUPPR;
	$gDb->SQLQuery($req, 1);
	if($row = $gDb->SQLNextRow(1))
	{
		$liste_format = $row["FOR_ID"];
		while($row = $gDb->SQLNextRow(1))
			$liste_format .= ",".$row["FOR_ID"];
	
		$where .= " AND SIGNATUREEBXTS.FOR_ID IN($liste_format) ";
	}
}	

//Traitement de la date
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SIG_DATECREAT BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SIG_DATECREAT BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SIG_DATECREAT >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SIG_DATECREAT >= '".date2Sql($f_date_deb, "23:59:59")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SIG_DATECREAT <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SIG_DATECREAT <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}


switch ($f_etat)
{
	case 1 :
		$where .= " AND (SIGNATUREEBXTS.SIG_ETATSIG = ".ETAT_A_SIGNER." OR SIGNATUREEBXTS.SIG_ETATSIG = ".ETAT_A_SIGNER_2EME_FOIS.") ";
		break;
	case 2 :
		$where .= " AND SIGNATUREEBXTS.SIG_ETATSIG = ".ETAT_A_SIGNER;
		break;
	case 3 : 
		$where .= " AND SIGNATUREEBXTS.SIG_ETATSIG = ".ETAT_A_SIGNER_2EME_FOIS;		
		break;
	case 4 :
		$where .= " AND SIGNATUREEBXTS.SIG_ETATSIG != ".ETAT_A_SIGNER." AND SIGNATUREEBXTS.SIG_ETATSIG != ".ETAT_A_SIGNER_2EME_FOIS." AND SIGNATUREEBXTS.SIG_RESULT = ".NIV_OK;
		break;
	case 5 :
		$where .= " AND SIGNATUREEBXTS.SIG_ETATSIG != ".ETAT_A_SIGNER." AND SIGNATUREEBXTS.SIG_ETATSIG != ".ETAT_A_SIGNER_2EME_FOIS." AND SIGNATUREEBXTS.SIG_RESULT = ".NIV_ERR;	
		break;
}

// Criteres partenaires

$f_emetteur		= pget('f_emetteur');		//filtre émetteur
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$fromPE 		= pget('fromPE');
$fromPD 		= pget('fromPD');

if ($fromPD>0 && $f_destinataire)
{
	if ($fromPD==2)// part + fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		if ($fils)
		$filsD=$f_destinataire.", ".$fils;
		else $filsD=$f_destinataire;

	}
	if ($fromPD==3) // que les fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		$filsD=$fils;

	}
	if ($fromPD==4) //que le part
	{
		$filsD=$f_destinataire;
	}
}
if ($fromPE>0 && $f_emetteur)
{
	if ($fromPE==2)// part + fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		if ($fils)
		$filsE=$f_emetteur.", ".$fils;
		else $filsE=$f_emetteur;
	}
	if ($fromPE==3) // que les fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		$filsE=$fils;
	}
	if ($fromPE==4) //que le part
	{
		$filsE=$f_emetteur;
	}
}

//Traitement de l'émetteur

if ($fromPD>0){	if ($f_destinataire) $where .=" and PAR_DEST_ID in ($filsD)";}
else {if ($f_destinataire) $where .= " and PAR_DEST_ID = '".dblQ($f_destinataire)."'";}

if ($fromPE>0){ if ($f_emetteur) $where .=" and PAR_EMET_ID in ($filsE)";}
else {if ($f_emetteur)	$where .= " and PAR_EMET_ID = '".dblQ($f_emetteur)."'";}

if($f_tdoc)
{
	//Recup Champs facultatifs
	$req = "SELECT TDOC_SUI
	        FROM TYPE_DOC
	        WHERE TDOC_ID = $f_tdoc";
	        
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$TDOC_SUI = $row['TDOC_SUI'];
	$SUI = explode(";;", $TDOC_SUI);
	$i = 0;
	
	foreach($SUI as $zone){
	    $zz = explode("::", $zone);
		${"SUI_LIB_".$i} = $zz[0];
		${"SUI_AFF_".$i} = $zz[1];
		${"SUI_REC_".$i} = $zz[2];
		$i++;
	}
	$gDb->SQLFermeQuery(1);
}
/*
$req = "SELECT COUNT(*) AS MAXROW
	    FROM SIGNATUREEBXTS, PART AS PARD, PART AS PARE
			WHERE SIGNATUREEBXTS.PAR_EMET_ID = PARE.PAR_ID
			AND SIGNATUREEBXTS.PAR_DEST_ID = PARD.PAR_ID
			$where
			$restrict";
*/
//request for mysql/MSSQL/ORACLE
$req = "SELECT COUNT(*) AS MAXROW
	    FROM SIGNATUREEBXTS, PART PARD, PART PARE
			WHERE SIGNATUREEBXTS.PAR_EMET_ID = PARE.PAR_ID
			AND SIGNATUREEBXTS.PAR_DEST_ID = PARD.PAR_ID
			$where
			$restrict";
	
$gDb->SQLQuery($req, 1);
$row = $gDb->SQLNextRow(1);
$maxRow = $row['MAXROW'];
$gDb->SQLFermeQuery(1);

// Recup params du boitier a carte (-1 si pas de boitier paramétré)
$req = "select CPT_NOMLECTEBX from COMPTE where CPT_ID = ".$_SESSION['CPT_ID'];
$gDb->SQLQuery($req, 1);
$row = $gDb->SQLNextRow(1);
$typeLecteur = $row['CPT_NOMLECTEBX'];
$gDb->SQLFermeQuery(1);

$req = "SELECT SIGNATUREEBXTS.AFX_ID,
SIGNATUREEBXTS.CLT_ID,
SIGNATUREEBXTS.E_ID,
SIGNATUREEBXTS.FIC_ID,
SIGNATUREEBXTS.FIC_SIGN_ID,
SIGNATUREEBXTS.FOR_ID,
SIGNATUREEBXTS.PAR_DEST_ID,
SIGNATUREEBXTS.PAR_EMET_ID,
SIGNATUREEBXTS.SIG_DATECREAT,
SIGNATUREEBXTS.SIG_DATESIG_1,
SIGNATUREEBXTS.SIG_DATESIG_2,
SIGNATUREEBXTS.SIG_ETATSIG,
SIGNATUREEBXTS.SIG_FIC_ID_SIGN1,
SIGNATUREEBXTS.SIG_FIC_ID_SIGN2,
SIGNATUREEBXTS.SIG_FIC_ID_TRANS,
SIGNATUREEBXTS.SIG_FORMAT,
SIGNATUREEBXTS.SIG_HOSTID,
SIGNATUREEBXTS.SIG_ID,
SIGNATUREEBXTS.SIG_LIBELLE,
SIGNATUREEBXTS.SIG_LIBELLE_SIGN1,
SIGNATUREEBXTS.SIG_NUMERO,
SIGNATUREEBXTS.SIG_NUMERR,
SIGNATUREEBXTS.SIG_NUMPROC,
SIGNATUREEBXTS.SIG_NUMSIGN,
SIGNATUREEBXTS.SIG_PARTID,
SIGNATUREEBXTS.SIG_RESULT,
SIGNATUREEBXTS.SIG_TEST,
SIGNATUREEBXTS.SIG_TRACE,
SIGNATUREEBXTS.SIG_TYPNUM,
SIGNATUREEBXTS.SIG_USERID1,
SIGNATUREEBXTS.SIG_USERID2,
SIGNATUREEBXTS.SIG_USERIDS,
SIGNATUREEBXTS.TDOC_ID,
PARE.PAR_NOM EMETTEUR, PARD.PAR_NOM DESTINATAIRE
		FROM SIGNATUREEBXTS";
// MSSQL/ORACLE VERSION
/*		
		INNER JOIN PART PARE
		INNER JOIN PART PARD
		INNER JOIN TYPE_DOC
			WHERE SIGNATUREEBXTS.TDOC_ID = TYPE_DOC.TDOC_ID";
		if($f_tdoc)
		{
			$req .=" AND SIGNATUREEBXTS.TDOC_ID = $f_tdoc";
		}
		$req .=" AND SIGNATUREEBXTS.CLT_ID  = $cltID
			AND SIGNATUREEBXTS.PAR_EMET_ID = PARE.PAR_ID
			AND SIGNATUREEBXTS.PAR_DEST_ID = PARD.PAR_ID
			$where
			$restrict
		ORDER BY SIG_DATECREAT DESC" ;
*/
/*
	. "INNER JOIN PART PARE ON PARE.PAR_ID = PAR_EMET_ID
		INNER JOIN PART PARD ON PARD.PAR_ID = PAR_DEST_ID
		INNER JOIN TYPE_DOC ON  TYPE_DOC.TDOC_ID = SIGNATUREEBXTS.TDOC_ID
		WHERE SIGNATUREEBXTS.CLT_ID  = 1"	
*/
	$req .=" INNER JOIN PART PARE ON PARE.PAR_ID = PAR_EMET_ID
		INNER JOIN PART PARD ON PARD.PAR_ID = PAR_DEST_ID
		INNER JOIN TYPE_DOC ON  TYPE_DOC.TDOC_ID = SIGNATUREEBXTS.TDOC_ID";
	
	$req .=" WHERE SIGNATUREEBXTS.TDOC_ID = TYPE_DOC.TDOC_ID";
	if($f_tdoc)
	{
		$req .=" AND SIGNATUREEBXTS.TDOC_ID = $f_tdoc";
	}
	
	$req .=" $where
			$restrict
		ORDER BY SIG_DATECREAT DESC" ;

if($limit)
	$req .= " LIMIT $limit";

	
$champs = array();
$champs[] = array("nom" => "Date", "toolTip" => "Date", "sortMode" => "3");
$champs[] = array("nom" => "Emetteur", "toolTip" => "Emetteur", "sortMode" => "1");
$champs[] = array("nom" => "Destinataire", "toolTip" => "Destinataire", "sortMode" => "1");
$champs[] = array("nom" => "Format", "toolTip" => "Format", "sortMode" => "1");
$champs[] = array("nom" => "Etat", "toolTip" => "Etat", "sortMode" => "2");
$champs[] = array("nom" => "Libellé", "toolTip" => "Libellé", "sortMode" => "1");


// Reference / montant / devise /...
for($i=0; $i<=8; $i++)
{
	if(isset(${"SUI_AFF_".$i}) && ${"SUI_AFF_".$i} == 1)	
		$champs[] = array("nom" => ${"SUI_LIB_".$i}, "toolTip" => ${"SUI_LIB_".$i}, "sortMode" => "1");
}

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

	$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);
	while ($row = $gDb->SQLNextRow(1))
	{
		echo '<row>';
		
//		if ($row['FIC_XML_ID'])
//		{
	
			//L'utilisateur peut signer ?
			$canSign = ($row['SIG_FIC_ID_TRANS'] && (($row['SIG_ETATSIG'] == ETAT_A_SIGNER) || ($row['SIG_ETATSIG'] == ETAT_A_SIGNER_2EME_FOIS)));
            //L'utilisateur peut visualiser ?
			$canView = ($row['SIG_FIC_ID_TRANS'] && droit(SDO, DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null));
			$info=array();
			$info['action']=$action;
			$info['droits'] = array('visualiser' => $canView,
									'signer' => (($typeLecteur>-1) && $canSign  && (droit(SDO, DROIT_EXEC,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null))),
									'annuler_traitement' => ($canSign  && droit(SDO, DROIT_SUPPR,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null))
                                    );
			if($canSign)
			{
				//typeLecteur
				$info['typeLecteur']  = $typeLecteur;
			}
			
			if($canView)
			{
				//sigId
				$info['sigId']  = $row['SIG_ID'];
				
				//nomFicTrace
				$info['nomFicTrace'] =" ";
				
				//typeInit => signature en dur
				$info['typeInit'] = "2";
		        
				//Download du srv Fic_ID
				$info['ficId'] = (($row['SIG_ETATSIG'] == ETAT_A_SIGNER_2EME_FOIS)? $row['SIG_FIC_ID_TRANS']: $row['FIC_ID']);
							
				//forFicDis
				//$info['forFicDis'] = $row['SIG_FORFICDIS'];
				
				//codDonDis
				//$info['codDonDis'] = $row['SIG_CODDONDIS'];
				
				//typFicEt5
				//$info['typFicEt5'] = $row['SIG_TYPFICET5'];
				
				//nomFicCom
				//$info['nomFicCom'] = $row['SIG_NOMFICCOM'];
				
				//firstsignid
				$info['firstsignid'] = $row['SIG_FIC_ID_SIGN1'];
				
				//sigEtatSig
				$info['sigEtatSig'] = $row['SIG_ETATSIG'];
				
				//lgArt
				//$info['lgArt'] = $row['SIG_LGART'];
				
				//libelle1
				$info['hostid'] = $row['SIG_HOSTID'];
				
				//Part1
				$info['partid'] = $row['SIG_PARTID'];
				
				//idUsers
				$info['userids'] = $row['SIG_USERIDS'];
				
				//idUser2
				$info['numsign'] = $row['SIG_NUMSIGN'];
				
				//Libelle_Sign1
				$info['libelle_sign1'] = $row['SIG_LIBELLE_SIGN1'];
				 
				
				//typSce
				//$info['typSce'] = $row['SIG_TYPSCE'];
				
				//typChi
				//$info['typChi'] = $row['SIG_TYPCHI'];
		            
				//forId
				//$info['forId'] = $row['FOR_XML_ID'];
				
				//ficXmlId
				//$info['ficXmlId'] = $row['FIC_XML_ID'];

				
			}
//		}
		
				
		
		$date = "";
		if($row['SIG_DATECREAT'])
			$date = sql2Date($row['SIG_DATECREAT']);
			
		echo '<item caption="'.$date.'" value="'.row_encode_JSON($info).'"/>';
			
		echo '<item icon="'.$pathFlow.'style/imgs/icons/menu/user.png" caption="'.hi_disp($row['EMETTEUR']).'"/>';
		echo '<item icon="'.$pathFlow.'style/imgs/icons/menu/user.png" caption="'.hi_disp($row['DESTINATAIRE']).'"/>';
		
		echo '<item caption="'.hi_disp($row['SIG_FORMAT']).'"/>';
		
		$icon = "";
		$libel = "";
		switch ($row['SIG_ETATSIG'])
		{
			case ETAT_A_SIGNER :
				$icon = $pathFlow."style/imgs/icons/clock.png";
				$libel = "Attente de signature";
				break;
				
			case ETAT_A_SIGNER_2EME_FOIS :
				$icon = $pathFlow."style/imgs/icons/certif.png";
				$libel = "Attente de 2eme signature";
				break;
				
			case ETAT_SIGNATURE_1_OK :
				if($row['SIG_RESULT'] == NIV_ERR)
				{
					$icon = $pathFlow."style/imgs/icons/error.png";
					$libel = "Erreur 1ere signature";
				}
				else
				{
					$icon = $pathFlow."style/imgs/icons/certif.png";
					$libel = "Signé une fois";
				}
				break;
				
			case ETAT_SIGNATURE_2_OK :
				if($row['SIG_RESULT'] == NIV_ERR)
				{
					$icon = $pathFlow."style/imgs/icons/error.png";
					$libel = "Erreur 2eme signature";
				}
				else
				{
					$icon = $pathFlow."style/imgs/icons/certif.png";
					$libel = "Signé deux fois";
				}
				break;
				
			case ETAT_FINI :
				if($row['SIG_RESULT'] == NIV_ERR)
				{
					$icon = $pathFlow."style/imgs/icons/error.png";
					$libel = "Erreur";
				}
				else
				{
					$icon = $pathFlow."style/imgs/icons/valid.png";
					$libel = "Terminé";
				}
				break;
		}
		echo '<item icon="'.$icon.'" caption="'.$libel.'" toolTip="'.$libel.'"/>';
		echo '<item caption="'.hi_disp($row['SIG_LIBELLE']).'"/>';
		
		
/*		
		// Reference / montant / devise /...
		for($i=0; $i<=8; $i++)
		{
			$value = "";
			if(${"SUI_AFF_".$i} == 1)
			{
				switch ($i)
				{
					case 0:
						$value = $row['EMETTEUR'];
						break;
					case 1:
						$value = $row['DESTINATAIRE'];
						break;
					case 2:
						$value = $row['SIG_OBJ'];
						break;
					case 3:
						$value = $row['SIG_REF'];
						break;
					default:
						$value = $row["SIG_DON_APP_".($i-3)];
						break;
				}
			echo '<item caption="'.hi_disp($value).'"/>';
			}
		}
*/		
		echo '</row>';
	}	
	$gDb->SQLFermeQuery(1);

echo '</databind>';
?>