<?php
if (!isset($DEFAULT_PATH))$DEFAULT_PATH ="./";
//$DEFAULT_PATH = "./";
require_once("flow.php");
require_once("struct.php");
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

function LDAPUserExists($login, &$msg)
{
	global $gDb;
	global $lang_utr_lbl_import_ldap_err_host, $lang_utr_lbl_import_ldap_err_filtre, $lang_ldap_err_connect_login;
	
	$ret = 0;
	
	$req = "SELECT LDA_ADRESSE, LDA_PORT, LDA_DN, LDA_LOGIN FROM LDAP WHERE CLT_ID = ".$_SESSION['CLT_ID'];
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);

	if($row['LDA_ADRESSE'] && $row['LDA_PORT'])
	{
		$ds = @ldap_connect($row['LDA_ADRESSE'], $row['LDA_PORT']);
		if($ds)
		{
			// Version 3 du protocole
			ldap_set_option ($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
				
			// Compatibilité pour Active Directory
			ldap_set_option($ds, LDAP_OPT_REFERRALS, 0);
				
			if(@ldap_bind($ds))
			{
				$filtre = '('.$row['LDA_LOGIN']."=$login)";
				$sr = ldap_search($ds, $row['LDA_DN'], $filtre);
				if($sr)
				{
					if(ldap_first_entry($ds, $sr)!=false)
						$ret = 1;
					else
						$ret = -3;
				}
				else
					$ret = -2;
					
				ldap_unbind($ds);
			}
			else
				$ret = -1;
		}
		else
			$ret = -1;
	}
	else
		$ret = 1; // pas de LDAP configuré donc pas de vérif
		
	if($ret==-1)
		$msg = addslashes(str_replace('%ldapHost%', $row['LDA_ADRESSE'], $lang_utr_lbl_import_ldap_err_host));
	else if($ret==-2)
		$msg = addslashes(str_replace(array('%filtre%', '%ldapDN%'), array($filtre, $row['LDA_DN']), $lang_utr_lbl_import_ldap_err_filtre));
	else if($ret==-3)
		$msg = addslashes(str_replace('%login%', $login, $lang_ldap_err_connect_login));
	
	return $ret;
}

$login       = "";
$pwd         = "";

if (isset($_SERVER['REDIRECT_SSL_CLIENT_S_DN_CN'])) {
	$query = "select CPT_PWD, CPT_LOGIN
                  from COMPTE
                  where CPT_IDNAT = '$_SERVER[REDIRECT_SSL_CLIENT_S_DN_CN]'";
	if ($gDb->SQLQuery($query,1)) {
		if ($row = $gDb->SQLNextRow(1)) {
			$_POST['UIFlogin'] = $row['CPT_LOGIN'];
			$_POST['UIFpwd']   = $row['CPT_PWD'];
		}
	}
}
if($ini_typeBase == 'mysql')
{
	if (isset($_POST['UIFlogin']))
	$login       = mysql_real_escape_string(htmlspecialchars($_POST['UIFlogin']));
	if (isset($_POST['UIFpwd']))
	$pwd         = mysql_real_escape_string(htmlspecialchars($_POST['UIFpwd']));
}
else
{
	if (isset($_POST['UIFlogin']))
	$login       = $gDb->Quote(htmlspecialchars($_POST['UIFlogin']));
	if (isset($_POST['UIFpwd']))
	$pwd         = $gDb->Quote(htmlspecialchars($_POST['UIFpwd']));
}

	
if (strlen($pwd) < 32) $pwd = md5($pwd);

// BG : 19/12/2012 : bgz4796 gestion de la casse du PWD dans le if statement plus bas 
// if ($row['CPT_PWD'] == $pwd or $row['CPT_PWD'] == strtoupper($pwd)
/*
if($ini_typeBase == 'oracle')
	$pwd=strtoupper($pwd);
*/

if ($login)
{
	$query = "select CPT_PWD, CPT_ID, COMPTE.CLT_ID, CPT_ETAT, UTR_ETAT, FAM_ETAT, CPT_DATE_TRAIT, CPT_PWD_PERIODE 
					from COMPTE, UTILISATEUR, FAMILLE
					where CPT_LOGIN like binary '".$login."'
					and COMPTE.UTR_ID = UTILISATEUR.UTR_ID
					and UTILISATEUR.FAM_ID = FAMILLE.FAM_ID";
	$errBase=false;
	if (!$gDb->SQLQuery($query,1))
		$errBase=true;

   if ($row = $gDb->SQLNextRow(1))
	{
		if ($row['CPT_ETAT'] == ETAT_ACTIF && $row['UTR_ETAT'] == ETAT_ACTIF && $row['FAM_ETAT'] == ETAT_ACTIF)
		{
			if (strlen($row['CPT_PWD'])<32)
				$row['CPT_PWD']=md5($row['CPT_PWD']);
			// BG : 19/12/2012 : bgz 4796 : oracle 
			// le pwd a été formaté en majuscule lors l'insertion de l'install
			// mais il sera en minuscule lors de la duplication 
			// (différence simple/double quote ' ou " dans les requêtes respectives)
			if ($row['CPT_PWD'] == $pwd or $row['CPT_PWD'] == strtoupper($pwd))
			{
				$_SESSION['CLT_ID'] = $row['CLT_ID'];
				$_SESSION['CPT_ID'] = $row['CPT_ID'];
				$_SESSION['HEURE'] = date("Y:m:d:H:i:s");

				if (version_compare(PHP_VERSION,'5.3','<'))
				{
					@session_register("CLT_ID");
					@session_register("CPT_ID");
					@session_register("HEURE");
				}
				$query2 = "select DISTINCT ROLE.TDOC_ID, ROLE.ROL_LECTURE,
							ROLE.ROL_MODIF, ROLE.ROL_CREAT, ROLE.ROL_SUPPR, ROLE.ROL_EXEC,
							ROLE.FAM_ID, TYPE_ROLE.TROL_NUM, ROLE.EXPEDITEUR, ROLE.DESTINATAIRE
							from ROLE, TYPE_ROLE, COMPTE_ROLE
							where ROLE.TROL_ID = TYPE_ROLE.TROL_ID
							and ROLE.ROL_ID = COMPTE_ROLE.ROL_ID
							and ROLE.ROL_ETAT = ".ETAT_ACTIF."
							and COMPTE_ROLE.CPT_ID = ".$row['CPT_ID']." ";

				$gDb->SQLQuery($query2,2);
				$droits = "";
				$nbreRole = 0;
				
				while ($row2 = $gDb->SQLNextRow(2))
				{
					$nbreRole++;
					if ($row2['ROL_LECTURE'] == 1) $l = 1;
					else $l = 0;
					
					if ($row2['ROL_MODIF'] == 1) $m = 2;
					else $m = 0;
					
					if ($row2['ROL_CREAT'] == 1) $c = 4;
					else $c = 0;
					
					if ($row2['ROL_SUPPR'] == 1) $s = 8;
					else $s = 0;
					
					if ($row2['ROL_EXEC'] == 1) $e = 16;
					else $e = 0;
					
					$lmcse = $l + $m + $c + $s + $e;
					
					if ($row2['FAM_ID'] == null) $row2['FAM_ID'] = 0;
					if ($row2['TDOC_ID'] == null) $row2['TDOC_ID'] = 0;
					if ($row2['EXPEDITEUR'] == null) $row2['EXPEDITEUR'] = 0;
					if ($row2['DESTINATAIRE'] == null) $row2['DESTINATAIRE'] = 0;

					$droits .= "/".$row2['TROL_NUM'].".".$lmcse.".".$row2['FAM_ID'].".".$row2['TDOC_ID'].".".$row2['EXPEDITEUR'].".".$row2['DESTINATAIRE'];
				}
				
				// Verif LDAP sauf pr compte type Master (TROL_NUM = 21)
				$LDAP_ok = 1;
				if(substr($droits, 0, 4)!='/21.')
					$LDAP_ok = LDAPUserExists($login, $msg);
				
				if($LDAP_ok==1)
				{
					// vérification de la période de validité du password
					if($row['CPT_PWD_PERIODE']!='' && $row['CPT_PWD_PERIODE']>0)
					{
						$nbJours = round((strtotime(date('Y-m-d h:i:s')) - strtotime($row['CPT_DATE_TRAIT']))/(60*60*24)-1);
						if($nbJours >= $row['CPT_PWD_PERIODE'])
						{
							$req = 'UPDATE COMPTE SET CPT_CHANGE_PWD=1 WHERE CPT_ID='.$row['CPT_ID'];
							$gDb->SQLQuery($req,1);
							$gDb->SQLFermeQuery(1);
						}
					}

					$_SESSION['DROITS'] = $droits;
					$_SESSION['NbreROLES'] = $nbreRole;
					if (version_compare(PHP_VERSION,'5.3','<'))
					{
						@session_register("DROITS");
						@session_register("NbreROLES");
					}
					if (@$_POST['Mode']!="ws"){
						include "main.php";
						exit;
					}
				}
			}
			else $msg = $lang_lbl_motdepasse_incorrect_err;
		}
		else
		{
			$msg = $lang_lbl_connexion_impossible_err;
			
			if ($row['CPT_ETAT'] == ETAT_INACTIF)
				$msg .= $lang_lbl_compte_inactif_err;
			
			if ($row['CPT_ETAT'] == ETAT_SUPPR)
				$msg .= $lang_lbl_compte_supprime_err;

			if ($row['UTR_ETAT'] == ETAT_INACTIF)
				$msg .= $lang_lbl_profil_inactif_err;
				
			if ($row['UTE_ETAT'] == ETAT_SUPPR)
				$msg .= $lang_lbl_profil_supprime_err;

			if ($row['FAM_ETAT'] == ETAT_INACTIF)
				$msg .= $lang_lbl_groupe_inactif_err;
				
			if ($row['FAM_ETAT'] == ETAT_SUPPR)
				$msg .= $lang_lbl_compte_supprime_err;
		}
	}
	else 
	{
		if ($errBase)
			$msg = $lang_lbl_connexion_base_err;
		else
			$msg = $lang_lbl_pas_de_compte_err;
	}
}
else $msg = $lang_lbl_pas_de_login_err;

if (@$_POST['Mode']!="ws"){
	include "index.php";
	echo "<script language=Javascript>alert('$msg');</script>";
}
?>