<?php
$DEFAULT_PATH = "../";
require_once($DEFAULT_PATH."struct.php");
$DROITS = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC;

require_once($DEFAULT_PATH."flow.php"); //session_start, inclusions, cr�ations des variables $gDb et $erreur_connect
include($DEFAULT_PATH."flow_tools.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$cltID = $_SESSION['CLT_ID'];
$cpt_id = $_SESSION['CPT_ID'];

//Récupération du PAR_ID pour le partenaire particulier ' TOUS'
$gDb->SQLQuery("SELECT PAR_ID FROM PART WHERE PAR_NOM = ' TOUS' AND CLT_ID = $cltID", 1);
$row = $gDb->SQLNextRow(1);
$gDb->SQLFermeQuery(1);
$partAllID = $row['PAR_ID'];

//Récupération de l'état des menus
$gDb->SQLQuery("SELECT CPT_MENU_SUIVI, CPT_MENU_BUSPROC, CPT_MENU_FLUX, CPT_MENU_ADMIN FROM COMPTE WHERE CPT_ID = $cpt_id", 1);
$etatMenus = $gDb->SQLNextRow(1);
$gDb->SQLFermeQuery(1);

//Vérification de la présence des types d'activités utiles à la construction du menu
$TACPresent = array();
$TACPresent[TAC_NUM_RAPPROCH] = isTACPresent(TAC_NUM_RAPPROCH);
$TACPresent[TAC_NUM_COLAS2]   = isTACPresent(TAC_NUM_COLAS2);
$TACPresent[TAC_NUM_COLSRVPESIT]   = isTACPresent(TAC_NUM_COLSRVPESIT);
$TACPresent[TAC_NUM_VALID]    = isTACPresent(TAC_NUM_VALID);
$TACPresent[TAC_NUM_SIGNEET5] = isTACPresent(TAC_NUM_SIGNEET5);
$TACPresent[TAC_NUM_DEMAT]    = isTACPresent(TAC_NUM_DEMAT);
$TACPresent[TAC_NUM_SIGNEEBXTS] = isTACPresent(TAC_NUM_SIGNEEBXTS);
$TACPresent[TAC_NUM_FORMULAIRE] = isTACPresent(TAC_NUM_FORMULAIRE);
$TACPresent[TAC_NUM_APPELWS] = isTACPresent(TAC_NUM_APPELWS);


//Vérifaction de la présence des droits utiles à la construction du menu
$droitsMenu = array();	//tableau contenant les droits utilisés pour le menu

//Suivi
$droitsMenu [] = SDO;
$droitsMenu [] = SDM;
$droitsMenu [] = SDR;
$droitsMenu [] = TAB;
$droitsMenu [] = CTA;
$droitsMenu [] = CMA;
$droitsMenu [] = HIS;
$droitsMenu [] = PRO;
$droitsMenu [] = VAL;
$droitsMenu [] = EXT;

//Flux
$droitsMenu [] = FLX;
$droitsMenu [] = PAR;
$droitsMenu [] = DOC;
$droitsMenu [] = SDR;
$droitsMenu [] = PDM;
$droitsMenu [] = CERT;
$droitsMenu [] = RES;
$droitsMenu [] = TRA;
$droitsMenu [] = SAD;
$droitsMenu [] = FRM;

//Utilisateurs
$droitsMenu [] = FAM;
$droitsMenu [] = UTR;
$droitsMenu [] = DRO;

//Administration
$droitsMenu [] = ACT;
$droitsMenu [] = ALE;
$droitsMenu [] = TAB;
$droitsMenu [] = COP;
$droitsMenu [] = PUR;
$droitsMenu [] = ANN;
$droitsMenu [] = SAD;
$droitsMenu [] = RSS;

//Informations
$droitsMenu [] = INFO;
$droitsMenu [] = CPT;
$droitsMenu [] = LIC;

$droitPresent = array();	//tableau indiquant le présence ou pas de chacun des droits du menu pour l'utilisateur

foreach ($droitsMenu as $droit)
	$droitPresent[$droit] = droit($droit, $DROITS, null, null, null, null);
	

//Variable dans laquelle sera construit le XML du menu
echo '<?xml version="1.0" encoding="UTF-8"?><databind>';

//Menu Suivi		SDO || SDM || TAB || CTA || CMA || HIS || PRO || SDR
if ($droitPresent[SDO] || $droitPresent[SDM] || $droitPresent[TAB] ||
	$droitPresent[CTA] || $droitPresent[CMA] || $droitPresent[HIS] ||
	$droitPresent[PRO] || $droitPresent[SDR])
{
	echo '<row><item caption="'.$lang_menu_lbl_suivi_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/loupe.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_suivi_tooltip.'" '.($etatMenus['CPT_MENU_SUIVI']==ETAT_ACTIF?'open="1"':'').'/>';
	
	//Droits d'accès Documents		SDO
	if ($droitPresent[SDO])
	{
		//Menu Récapitulatif		SDO
		echo '<row><item caption="'.$lang_menu_lbl_recap_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/recap.png" value="'.$pathFlow.'suivi/recap/sui_recap.php?ini_date=1" toolTip="'.$lang_menu_lbl_recap_tooltip.'"/></row>';

		//Menu Documents		SDO
		echo '<row><item caption="'.$lang_menu_lbl_docs_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/documents.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_docs_tooltip.'"/>';
		$req = "SELECT TDOC_NOM, TDOC_ID
				FROM TYPE_DOC
				WHERE CLT_ID = $cltID
				AND TDOC_NOM != ' TOUS'
				AND TDOC_ETAT != ".ETAT_SUPPR."
				AND TDOC_MASQUE != 1 
				ORDER BY TDOC_NOM";
		
		$gDb->SQLQuery($req, 1);
		
		//Menus Types de documents		TDOC_ID => TYPE_DOC
		while ($row = $gDb->SQLNextRow(1))
			if (droit(SDO, $DROITS,null,null,$row['TDOC_ID'],null))	//on vérifie les droits sur le type de documents TDOC_ID
			{
				$value = 'suivi/documents/sui_doc.php?ini_date=1&typeDoc='.$row['TDOC_ID'].'&suiTYPE=1';
				$url = urlencode($value);
				echo '<row><item caption="'.hi_disp($row['TDOC_NOM']).'" icon="'.$pathFlow.'style/imgs/icons/menu/document.png" value="'.$url.'" toolTip="'.$row['TDOC_NOM'].'"/></row>';
			}
			
		$gDb->SQLFermeQuery(1);
		echo '</row>';	//fin Documents
	}
	
	//Menu Invoice Manager		SDM
	if ($droitPresent[SDM] && $TACPresent[TAC_NUM_DEMAT])
		echo '<row><item caption="'.$lang_menu_lbl_invoice_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/invoice.gif" value="'.$pathFlow.'suivi/invoice/sui_inv.php?ini_date=1" toolTip="'.$lang_menu_lbl_invoice_caption.'"/></row>';
	//Menu Collecte		SDR
	if ($droitPresent[SDR])
	{
		$value = $pathFlow.'suivi/collecte/sui_col.php?ini_date=1&suiType='.SUI_TYPE_COL;
		$url = urlencode($value);
		echo '<row><item caption="'.$lang_menu_lbl_collecte_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/collect.png" value="'.$url.'" toolTip="'.$lang_menu_lbl_collecte_caption.'"/></row>';
	}
	
	//Menu Rapprochement		SDO && TAC_NUM_RAPPROCH
	if ($droitPresent[SDO] && $TACPresent[TAC_NUM_RAPPROCH])
	{
		
		$req = "SELECT TRAP_ID, TRAP_LIBELLE, TRAP_SENS, TRAP_ETAT
				FROM TYPE_RAPPROCH
				WHERE CLT_ID = $cltID
				ORDER BY TRAP_LIBELLE";
				
		$gDb->SQLQuery($req, 1);
		$first = true;
		//Menus Types de rapprochements		TRAP_ID=>TYPE_RAPPROCH
		while ($row = $gDb->SQLNextRow(1))
		{
			if($first)
			{
				echo '<row><item caption="'.$lang_menu_lbl_rapproch_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/flux.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_rapproch_caption.'"/>';
				$first = false;
			}
			
			$fin = "";
			$icon = $pathFlow."style/imgs/icons/menu/";
			
			//on rajoute la mention (S) si le type de rapprochement est en état supprimé sinon on rajoute la mention selon son sens
			if($row['TRAP_ETAT'] == ETAT_SUPPR)
			{
				$fin = " (S)";
				$icon .= "suppr";
			}
			else
			{
				if ($row['TRAP_SENS'] == TRAP_SENS_ALLER)
				{
					$fin = " - ".$lang_lbl_aller;
					$icon .= "aller";
				}
				else
				{
					$fin = " - ".$lang_lbl_retour;
					$icon .= "retour";
				}
			}
			$icon .= '.gif';
			$libelle = $row['TRAP_LIBELLE'].$fin;
			$url = urlencode($pathFlow.'suivi/rapproch/sui_rap.php?TRAP_ID='.$row['TRAP_ID'].'&TRAP_SENS='.$row['TRAP_SENS']);
			echo '<row><item caption="'.$row['TRAP_LIBELLE'].$fin.'" icon="'.$icon.'" value="'.$url.'" toolTip="'.hi_disp($libelle).'"/></row>';
		}
	
		$gDb->SQLFermeQuery(1);
		if($first==false)
			echo '</row>';	//fin Rapprochement
	}
	
	//Menu Tableau de bord		TAB
	if ($droitPresent[TAB])
		echo '<row><item caption="'.$lang_menu_lbl_dashboard_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/control.gif" value="'.$pathFlow.'suivi/tableaubord/sui_tab.php" toolTip="'.$lang_menu_lbl_dashboard_caption.'"/></row>';
	
	//Menu Alertes		CTA ou CMA
	if ($droitPresent[CTA] || $droitPresent[CMA])
	{
		$url = urlencode($pathFlow.'suivi/alertes/sui_alt.php');
		echo '<row><item caption="'.$lang_menu_lbl_alert_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/alertes.gif" value="'.$url.'" toolTip="'.$lang_menu_lbl_alert_tooltip.'"/></row>';
	}

	//Menu Historique des traitements		HIS ou SDO
	if ($droitPresent[HIS] || $droitPresent[SDO])
	{
		$url = urlencode($pathFlow.'suivi/historique/sui_hist.php?ini_date=1&pageNum=1');
		echo '<row><item caption="'.$lang_menu_lbl_histo_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/histo.gif" value="'.$url.'" toolTip="'.$lang_menu_lbl_histo_tooltip.'"/></row>';
		
		if($ini_typeBase == "mysql")
		{
			function mysql_table_exists($table , $db) {
				$requete = 'SHOW TABLES FROM '.$db.' LIKE \''.$table.'\'';
				$exec = mysql_query($requete);
				return mysql_num_rows($exec);
			}
		}
		else
		{
			function mysql_table_exists($table , $db)
			{		
				global $ini_typeBase, $gDb;
				
				if($ini_typeBase == 'mssql')
					$gDb->SQLQuery("select name from sysobjects where xtype = 'U' and name = '$table';", 1);
				else
					$gDb->SQLQuery("SELECT TABLE_NAME FROM USER_TABLES WHERE table_name = '$table';", 1);
					
				$row = $gDb->SQLNextRow(1);
				$ret=0;
				
				if(is_array($row))
					$ret=1;	
	
				return $ret;
			}
		}
		
		$archives = mysql_table_exists("ARCHIVE_PER_MONTH_SUIVI",$ini_nomBase); 
		if (($archives) || ($TACPresent[TAC_NUM_DEMAT]))
		{
	        $archivesEntries = "";        	
			if ($TACPresent[TAC_NUM_DEMAT])
			{
				// Le service d'archives est-il utilise ?
				$req = "SELECT VPG_VAL FROM VAL_PAR_GEN WHERE PFL_ID = 2751";
				$gDb->SQLQuery($req, 1);
				$row = $gDb->SQLNextRow(1);
				$gDb->SQLFermeQuery(1);
				if ($row['VPG_VAL']=='1')
				{
		        	$archivesEntries = '<row><item caption="'.'Archives'.'" icon="'.$pathFlow.'style/imgs/icons/menu/documents.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_docs_tooltip.'"/>';
		            $archivesEntries.= '<row><item caption="'.$lang_menu_lbl_invoice_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/invoice.gif" value="'.$pathFlow.'suivi/archive/invoice/sui_archive_invoice.php?ini_date=1" toolTip="'.$lang_menu_lbl_invoice_caption.'"/></row>';
				}
			}
			
			if ($archives)
			{
		        $req = "SELECT TDOC_NOM, TYPE_DOC.TDOC_ID
		                FROM TYPE_DOC JOIN ARCHIVE_PER_MONTH_SUIVI ON (ARCHIVE_PER_MONTH_SUIVI.TDOC_ID=TYPE_DOC.TDOC_ID)
		                WHERE CLT_ID = $cltID
		                AND TDOC_NOM != ' TOUS'
		                AND TDOC_ETAT != ".ETAT_SUPPR."
		                AND TDOC_MASQUE != 1 
		                ORDER BY TDOC_NOM";
		        
		        $gDb->SQLQuery($req, 1);
		        
		        //Menus Types de documents      TDOC_ID => TYPE_DOC
		        while ($row = $gDb->SQLNextRow(1))
		            if (droit(SDO, $DROITS,null,null,$row['TDOC_ID'],null)) //on vérifie les droits sur le type de documents TDOC_ID
		            {
		                $value = 'suivi/archive/sui_archive.php?ini_date=1&typeDoc='.$row['TDOC_ID'].'&suiTYPE=1';
		                $url = urlencode($value);
		                if ($archivesEntries == "")
		                {
		                	$archivesEntries = '<row><item caption="'.'Archives'.'" icon="'.$pathFlow.'style/imgs/icons/menu/documents.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_docs_tooltip.'"/>';
		                }
		                $archivesEntries.= '<row><item caption="'.hi_disp($row['TDOC_NOM']).'" icon="'.$pathFlow.'style/imgs/icons/menu/document.png" value="'.$url.'" toolTip="'.$row['TDOC_NOM'].'"/></row>';
		            }
		        $gDb->SQLFermeQuery(1);
			}
	        if ($archivesEntries != "")
	        {    
	            $archivesEntries.= '</row>';  //fin Archives
	            echo $archivesEntries;
	        }
	}    
	}
	
	//Menu Suivi des processus		PRO
	if ($droitPresent[PRO])
		echo '<row><item caption="'.$lang_menu_lbl_process_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/traitement.gif" value="'.$pathFlow.'suivi/proc/sui_proc.php" toolTip="'.$lang_menu_lbl_process_tooltip.'"/></row>';
	
	// Suivi de processus externes
	if ($droitPresent[EXT])
	{
		$first = true;
		
		$req = "SELECT EXT_ID, EXT_TITRE 
				FROM EXTERNE
				WHERE CLT_ID = $cltID AND EXT_ACTIF = ".ETAT_ACTIF." 
				ORDER BY EXT_TITRE";
						
		$gDb->SQLQuery($req, 1);
		while ($row = $gDb->SQLNextRow(1))
		{
			if($first)
			{
				echo '<row><item caption="'.$lang_menu_lbl_extern_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/externlog.png"  onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_extern_tooltip.'"/>';
				$first = false;
			}
			echo '<row><item caption="'.$row['EXT_TITRE'].'" icon="'.$pathFlow.'style/imgs/icons/menu/externlog.png" value="'.$pathFlow.'suivi/externe/sui_externe.php?ext_id='.$row['EXT_ID'].'" toolTip="'.$row['EXT_TITRE'].'"/></row>';
		}
		$gDb->SQLFermeQuery(1);
		if($first==false)
			echo '</row>';	//fin processus externes
	}
	
	//Menu Serveurs		SDR && TAC_NUM_COLAS2
	//SDR => on doit vérifier si utilisateur a les droits SDR pour le PAR_ID du partenaire particulier ' TOUS'
	//TAC_NUM_COLAS2 => pour l'instant il n'y a qu'un type de serveur : AS2, donc le menu "Serveurs" ne s'affiche que si AS2 est présent
	//La 2e conditon sera obsolète lorsqu'on rajoutera d'autres types de serveurs
	if (droit(SDR, $DROITS,$partAllID,$partAllID,null,null) && ($TACPresent[TAC_NUM_COLAS2] || $TACPresent[TAC_NUM_COLSRVPESIT]))
	{
		echo '<row><item caption="'.$lang_menu_lbl_server_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/serveur.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_server_caption.'"/>';
		
		if($TACPresent[TAC_NUM_COLAS2])
		{
			$value = $pathFlow.'suivi/serveurs/as2/sui_as2.php?ini_date=1&f_etat=aFF'.ETAT_ATRAITER;	//utilisation de urlencode pour encoder les caractéres '&' qui ne sont pas acceptés en XML
			$url = urlencode($value);
			echo '<row><item caption="'.$lang_menu_lbl_serverAS2_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/serveur.gif" value="'.$url.'" toolTip="'.$lang_menu_lbl_serverAS2_caption.'"/></row>';
		}
		if($TACPresent[TAC_NUM_COLSRVPESIT])
		{
			echo '<row><item caption="'.$lang_menu_lbl_serverPESIT_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/srv_pesit.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_serverPESIT_caption.'"/>';
			$value = $pathFlow.'suivi/serveurs/pesit/sui_pesit_transactions.php?ini_date=1';	
			$url = urlencode($value);
			echo '<row><item caption="'.$lang_sui_pesit_page_transactions.'" icon="'.$pathFlow.'style/imgs/icons/menu/flux.gif" value="'.$url.'" toolTip="'.$lang_sui_pesit_page_transactions.'"/></row>';
			$value = $pathFlow.'suivi/serveurs/pesit/sui_pesit_fichiers.php?ini_date=1';	
			$url = urlencode($value);
			echo '<row><item caption="'.$lang_sui_pesit_page_fichiers.'" icon="'.$pathFlow.'style/imgs/icons/menu/document.png" value="'.$url.'" toolTip="'.$lang_sui_pesit_page_fichiers.'"/></row>';
			echo '</row>';	//fin PeSIT
		}
		echo '</row>';	//fin Serveurs
	}
	echo '</row>';	//fin Suivi
}


//Menu Business Process	(VAL && TAC_NUM_VALID) || (SDO && TAC_NUM_SIGNEET5) || (FRM && TAC_NUM_FORMULAIRE)
if (($droitPresent[VAL] && $TACPresent[TAC_NUM_VALID]) || ($droitPresent[SDO] && $TACPresent[TAC_NUM_SIGNEET5]) || ($droitPresent[FRM] && $TACPresent[TAC_NUM_FORMULAIRE]) || ($droitPresent[SDO] && $TACPresent[TAC_NUM_SIGNEEBXTS]) || ($droitPresent[VAL] && $TACPresent[TAC_NUM_APPELWS]))
{
	echo '<row><item caption="'.$lang_menu_lbl_busproc_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/graph.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_busproc_caption.'" '.($etatMenus['CPT_MENU_BUSPROC']==ETAT_ACTIF?'open="1"':'').'/>';
	
	if ($droitPresent[VAL] && $TACPresent[TAC_NUM_VALID])
	{
		echo '<row><item caption="'.$lang_menu_lbl_valid_caption.'" icon="'.$pathFlow.'style/imgs/icons/valid.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_valid_caption.'"/>';
		
		$req = "SELECT TDOC_NOM, TDOC_ID, TDOC_ETAT
				FROM TYPE_DOC
				WHERE CLT_ID = $cltID
				AND TDOC_NOM != ' TOUS'
				ORDER BY TDOC_NOM";
						
		$gDb->SQLQuery($req, 1);
		while ($row = $gDb->SQLNextRow(1))
		{
			if (droit(VAL, $DROITS,null,null,$row['TDOC_ID'],null)) //on verifie les droits sur le type de documents TDOC_ID
            {
                if ($row['TDOC_ETAT'] == ETAT_SUPPR)
                {
                    $deb = AFF_SUPPR_DEB;
                    $fin = " $lang_lbl_etat_suppr_ini ";
                }
                else $deb = $fin = "";
				
				echo '<row><item caption="'.$deb.$row['TDOC_NOM'].$fin.'" icon="'.$pathFlow.'style/imgs/icons/valid.png" value="'.$pathFlow.'business/valid/bus_val.php?typeDoc='.$row['TDOC_ID'].'" toolTip="'.$row['TDOC_NOM'].'"/></row>';
			}
		}
		$gDb->SQLFermeQuery(1);
		echo '</row>';	//fin Validation Manuelle
	}
	//Validations par web service en attente
	if ($droitPresent[VAL] && $TACPresent[TAC_NUM_APPELWS])
	{
		echo '<row><item caption="'.$lang_menu_lbl_appelws_caption.'" icon="'.$pathFlow.'style/imgs/icons/valid.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_appelws_caption.'"/>';
		
		$req = "SELECT TDOC_NOM, TDOC_ID, TDOC_ETAT
				FROM TYPE_DOC
				WHERE CLT_ID = $cltID
				AND TDOC_NOM != ' TOUS'
				ORDER BY TDOC_NOM";
						
		$gDb->SQLQuery($req, 1);
		while ($row = $gDb->SQLNextRow(1))
		{
			if (droit(VAL, $DROITS,null,null,$row['TDOC_ID'],null)) //on verifie les droits sur le type de documents TDOC_ID
            {
                if ($row['TDOC_ETAT'] == ETAT_SUPPR)
                {
                    $deb = AFF_SUPPR_DEB;
                    $fin = " $lang_lbl_etat_suppr_ini ";
                }
                else $deb = $fin = "";
				
				echo '<row><item caption="'.$deb.$row['TDOC_NOM'].$fin.'" icon="'.$pathFlow.'style/imgs/icons/valid.png" value="'.$pathFlow.'business/appelws/bus_aws.php?typeDoc='.$row['TDOC_ID'].'" toolTip="'.$row['TDOC_NOM'].'"/></row>';
			}
		}
		$gDb->SQLFermeQuery(1);
		echo '</row>';	//fin Validation ws
	}	//fin validation par ws
	
	if($droitPresent[FRM] && $TACPresent[TAC_NUM_FORMULAIRE])
		echo '<row><item caption="'.$lang_menu_lbl_frm_vierge.'" icon="'.$pathFlow.'style/imgs/icons/menu/form.png" value="'.$pathFlow.'business/form/bus_form.php" toolTip="'.$lang_menu_lbl_frm_tooltip.'"/></row>';
	
	if ($droitPresent[SDO] && $TACPresent[TAC_NUM_SIGNEET5])
	echo '<row><item caption="'.$lang_menu_lbl_signet5_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/certif.png" value="'.$pathFlow.'business/signeet5/bus_et.php" toolTip="'.$lang_menu_lbl_signet5_caption.'"/></row>';
	
	if ($droitPresent[SDO] && $TACPresent[TAC_NUM_SIGNEEBXTS])
	echo '<row><item caption="'.$lang_menu_lbl_signebxts_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/certif.png" value="'.$pathFlow.'business/signebxts/bus_eb.php" toolTip="'.$lang_menu_lbl_signebxts_caption.'"/></row>';
	
	echo '</row>';	//fin Business Process
}

//Menu FLux		FLX || PAR || DOC || PDM || CERT || RES || TRA || SAD
if ($droitPresent[FLX] || $droitPresent[PAR] || $droitPresent[DOC] ||
	$droitPresent[SAD] || $droitPresent[PDM] || $droitPresent[CERT] ||
	$droitPresent[RES] || $droitPresent[TRA])
{
	echo '<row><item caption="'.$lang_menu_lbl_flux_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/flux.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_flux_caption.'" '.($etatMenus['CPT_MENU_FLUX']==ETAT_ACTIF?'open="1"':'').'/>';
	
	//Menu Gestion des flux	FLX
	if($droitPresent[FLX])
		echo '<row><item caption="'.$lang_menu_lbl_gestflux_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/gest_flux.gif" value="'.$pathFlow.'flux/gest/flux_gest.php?pageNum=1" toolTip="'.$lang_menu_lbl_gestflux_caption.'"/></row>';
	
	//Menu Partenaires		PAR
	if($droitPresent[PAR])
	echo '<row><item caption="'.$lang_menu_lbl_part_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/partenaires.gif" value="'.$pathFlow.'flux/part/flux_part.php" toolTip="'.$lang_menu_lbl_part_caption.'"/></row>';
	
	//Menu Types de documents		DOC
	if($droitPresent[DOC])
		echo '<row><item caption="'.$lang_menu_lbl_tdoc_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/type_doc.gif" value="'.$pathFlow.'flux/tdoc/flux_tdoc.php" toolTip="'.$lang_menu_lbl_tdoc_caption.'"/></row>';
	
	//Menu Paramétres généraux		PDM || FLX || CERT || RES || TRA || SAD
	$droitFlux = droit(FLX, DROIT_LECT + DROIT_CREAT + DROIT_MODIF + DROIT_SUPPR,null,null,null,null);
	if ($droitPresent[PDM] || ($droitFlux && $TACPresent[TAC_NUM_RAPPROCH]) ||
		$droitPresent[CERT] || $droitPresent[RES] || $droitPresent[TRA] ||
		$droitPresent[SAD])
	{
		echo '<row><item caption="'.$lang_menu_lbl_paramgen_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/param_gen.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_paramgen_caption.'"/>';
		
		//Menu Paramétrages AS2		RES && TAC_NUM_COLAS2
		if ($droitPresent[RES] && $TACPresent[TAC_NUM_COLAS2])
			echo '<row><item caption="'.$lang_menu_lbl_serverAS2_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/serveur.gif" value="'.$pathFlow.'flux/pargen/as2/flux_pargen_as2.php" toolTip="'.$lang_menu_lbl_AS2_tooltip.'"/></row>';
			
		//Menu Paramétrages Serveur PESIT		RES && TAC_NUM_COLSRVPESIT
		if ($droitPresent[RES] && $TACPresent[TAC_NUM_COLSRVPESIT])
			echo '<row><item caption="'.$lang_menu_lbl_serverPESIT_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/srv_pesit.png" value="'.$pathFlow.'flux/pargen/pesit/flux_pargen_pesit.php" toolTip="'.$lang_menu_lbl_PESIT_tooltip.'"/></row>';
		
		//Menu Invoice Manager		PDM
		if ($droitPresent[PDM] && $TACPresent[TAC_NUM_DEMAT])
		{
			echo '<row><item caption="'.$lang_menu_lbl_paraminvoice_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/invoice.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_paraminvoice_caption.'"/>';
			echo '<row><item caption="'.$lang_menu_lbl_parampart_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/partenaires.gif" value="'.$pathFlow.'flux/pargen/demat/p2p/p2p_gest.php" toolTip="'.$lang_menu_lbl_parampart_caption.'"/></row>';
			echo '<row><item caption="'.$lang_menu_lbl_archiv_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/archiv.gif" value="'.$pathFlow.'flux/pargen/demat/archiv/arc_gest.php" toolTip="'.$lang_menu_lbl_archiv_caption.'"/></row>';
			echo '</row>';
		}
		
		//Menu Rapprochements		FLX && TAC_NUM_RAPPROCH
		if ($droitFlux && $TACPresent[TAC_NUM_RAPPROCH])
		{
			echo '<row><item caption="'.$lang_menu_lbl_paramrapproch_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/flux.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_paramrapproch_caption.'"/>';
			echo '<row><item caption="'.$lang_menu_lbl_typerapproch_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/type.gif" value="'.$pathFlow.'flux/pargen/rapproch/types/typrapp_gest.php" toolTip="'.$lang_menu_lbl_typerapproch_tooltip.'"/></row>';
			echo '<row><item caption="'.$lang_menu_lbl_rulerapproch_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/regle.gif" value="'.$pathFlow.'flux/pargen/rapproch/regles/reglrapp_gest.php" toolTip="'.$lang_menu_lbl_rulerapproch_tooltip.'"/></row>';
			echo '</row>';
		}
		    
		//Menu Certificats		CERT
		if ($droitPresent[CERT])
			echo '<row><item caption="'.$lang_menu_lbl_certif_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/certif.png" value="'.$pathFlow.'flux/pargen/certificat/crt_gest.php" toolTip="'.$lang_menu_lbl_certif_caption.'"/></row>';

		//Menu Formulaires		FRM
		if ($droitPresent[FRM] && $TACPresent[TAC_NUM_FORMULAIRE])
			echo '<row><item caption="'.$lang_menu_lbl_frm_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/form.png" value="'.$pathFlow.'flux/pargen/form/frm_gest.php" toolTip="'.$lang_menu_lbl_frm_tooltip.'"/></row>';
			
		//Menu Surveillance de Dossier
		if($droitFlux)
			echo '<row><item caption="'.$lang_menu_lbl_surveillance_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/folder_find.png" value="'.$pathFlow.'flux/pargen/surveillance/sve_gest.php" toolTip="'.$lang_menu_lbl_surveillance_tooltip.'"/></row>';
		
		//Menu Parametres generaux	(RES && (ID_COLLECTE || ID_PRESENT)) || (TRA && (ID_PRETRAIT || ID_TRAITEMENT || ID_POSTTRAIT))
		// TPG_NUM => TYP_PAR_GEN
		if ($droitPresent[RES] || $droitPresent[TRA])
		{
			$req = "SELECT TPG_LIBEL, TYP_PAR_GEN.TPG_NUM, TAC_ROLE
					FROM TYP_PAR_GEN, TYPE_ACT, ACTIVITE
					WHERE CLT_ID= $cltID
					AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM
					AND TYPE_ACT.TPG_NUM = TYP_PAR_GEN.TPG_NUM
					ORDER BY TPG_LIBEL";
							
			$gDb->SQLQuery($req, 1);
			
			$tab_TPG = array();
			
			while ($row = $gDb->SQLNextRow(1)) //Recuperations des types de parametres generaux
			{
				$tab_TPG[$row['TPG_NUM']]['NUM']		= $row['TPG_NUM'];
				$tab_TPG[$row['TPG_NUM']]['LIBEL']		= $row['TPG_LIBEL'];
                if (isset($tab_TPG[$row['TPG_NUM']]['TAC_ROLE']))
                {
                    $tab_TPG[$row['TPG_NUM']]['TAC_ROLE']	.= ".".$row['TAC_ROLE'];	//un meme TPG_NUM peut avoir plusieurs TAC_ROLE
                }
                else
                {
                    $tab_TPG[$row['TPG_NUM']]['TAC_ROLE']   = ".".$row['TAC_ROLE'];    //un meme TPG_NUM peut avoir plusieurs TAC_ROLE
                }
			}
			$gDb->SQLFermeQuery(1);
			
			foreach ($tab_TPG as $TPG)	//Recuperations des parametres dans un tableau
			{
				$tac_role = 0;
				
				if (preg_match("/.".ID_COLLECTE."|.".ID_PRESENT."/", $TPG['TAC_ROLE']) && $droitPresent[RES])
					$tac_role += 1;        //droit sur les param reseau
					
				if (preg_match("/.".ID_PRETRAIT."|.".ID_TRAITEMENT."|.".ID_POSTTRAIT."/", $TPG['TAC_ROLE']) &&
					$droitPresent[TRA])
					$tac_role += 2;      //droit sur les param de traitement
					
				if ($tac_role > 0)		//on doit avoir au moins un des droits
				{
					$value = $pathFlow.'flux/pargen/pargen_gest.php?tpg_num='.$TPG['NUM'].'&p_role='.$tac_role;;
					$url = urlencode($value);
					echo '<row><item caption="'.hi_disp($TPG['LIBEL']).'" icon="'.$pathFlow.'style/imgs/icons/menu/param_autres.png" value="'.$url.'"  toolTip="'.hi_disp($TPG['LIBEL']).'"/></row>';
				}
			}
		}
		echo '</row>';	//fin Parametres generaux
		
		//Menu Avance		SAD
		if ($droitPresent[SAD])
		{
			echo '<row><item caption="'.$lang_menu_lbl_avance_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/avance.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_avance_caption.'"/>';
			echo '<row><item caption="'.$lang_menu_lbl_import_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/import.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_import_caption.'"/>';
			echo '<row><item caption="'.$lang_menu_lbl_impflux_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/flux.gif" value="'.$pathFlow.'flux/avance/import/flux_import/flux_import.php" toolTip="'.$lang_menu_lbl_impflux_tooltip.'"/></row>';
			echo '<row><item caption="'.$lang_menu_lbl_imppart_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/partenaires.gif" value="'.$pathFlow.'flux/avance/import/part_import/part_import.php" toolTip="'.$lang_menu_lbl_imppart_tooltip.'"/></row>';
			echo '</row>';	//fin Import
			echo '<row><item caption="'.$lang_menu_lbl_export_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/export.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_export_caption.'"/>';
			echo '<row><item caption="'.$lang_menu_lbl_expflux_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/flux.gif" value="'.$pathFlow.'flux/avance/export/flux_export/flux_export.php" toolTip="'.$lang_menu_lbl_expflux_tooltip.'"/></row>';
			echo '<row><item caption="'.$lang_menu_lbl_exppart_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/partenaires.gif" value="'.$pathFlow.'flux/avance/export/part_export/part_export.php" toolTip="'.$lang_menu_lbl_exppart_tooltip.'"/></row>';
			echo '</row>';	//fin Export
			echo '</row>';	//fin Avance
		}
	}
	
	echo '</row>';	//fin Flux
}

//Menu Utilisateurs		FAM || UTR || DRO
if ($droitPresent[FAM] || $droitPresent[UTR] || $droitPresent[DRO])
{
	echo '<row><item caption="'.$lang_menu_lbl_user_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/users.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_user_caption.'"/>';
	
	if ($droitPresent[FAM])
		echo '<row><item caption="'.$lang_menu_lbl_fam_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/user_group.png" value="'.$pathFlow.'utilisateurs/familles/utr_fam.php" toolTip="'.$lang_menu_lbl_fam_tooltip.'"/></row>';
	
	if ($droitPresent[UTR])
		echo '<row><item caption="'.$lang_menu_lbl_gestuser_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/user.png" value="'.$pathFlow.'utilisateurs/utilisateurs/utr_utr.php" toolTip="'.$lang_menu_lbl_gestuser_tooltip.'"/></row>';
	
	if ($droitPresent[DRO])
		echo '<row><item caption="'.$lang_menu_lbl_droit_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/user_right.png" value="'.$pathFlow.'utilisateurs/droits/utr_drt.php?evenement=first" toolTip="'.$lang_menu_lbl_droit_tooltip.'"/></row>';
	
	echo '</row>';	//fin Utilisateurs
}

//Menu Administration		ACT || ALE || TAB || COP || PUR || ANN || SAD || RSS
if ($droitPresent[ACT] || $droitPresent[ALE] || $droitPresent[TAB] ||
	$droitPresent[COP] || $droitPresent[PUR] || $droitPresent[ANN] ||
	$droitPresent[SAD] || $droitPresent[RSS] || $droitPresent[EXT])
{
	echo '<row><item caption="'.$lang_menu_lbl_admin_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/admin.gif" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_admin_caption.'" '.($etatMenus['CPT_MENU_ADMIN']==ETAT_ACTIF?'open="1"':'').'/>';
	
	//Menu Traitements en cours		ACT
	if($droitPresent[ACT])
	echo '<row><item caption="'.$lang_menu_lbl_trait_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/traitement.gif" value="'.$pathFlow.'admin/trait/admin_trait.php" toolTip="'.$lang_menu_lbl_trait_caption.'"/></row>';

	//Menu Alertes		ALE
	if($droitPresent[ALE])
		echo '<row><item caption="'.$lang_menu_lbl_gestalert_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/alertes.gif" value="'.$pathFlow.'admin/alert/admin_alert.php" toolTip="'.$lang_menu_lbl_gestalert_tooltip.'"/></row>';
	
	//Menu Gestion des Logs		ALE	
	if($droitPresent[ALE])
		echo '<row><item caption="'.$lang_menu_lbl_gestlog_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/log.gif" value="'.$pathFlow.'admin/log/admin_log.php" toolTip="'.$lang_menu_lbl_gestlog_tooltip.'"/></row>';	
		
	//Menu Gestion du journal		ALE	
	if($droitPresent[ALE])
		echo '<row><item caption="Journal" icon="'.$pathFlow.'style/imgs/icons/menu/journal.png" value="'.$pathFlow.'admin/journal/admin_journal.php" toolTip="'.$lang_menu_lbl_gestlog_tooltip.'"/></row>';	
			
	//Menu Tableaux de bord		TAB(lect) || TAB(mod) || TAB(crea) || TAB(suppr)
	//On a seulement besoin des droits de Lecture, Modification, Creation et Suppression
	//Pour l'execution il faut se referer au menu "Tableau de bord" dans le "Suivi"
	if(droit(TAB, DROIT_LECT,null,null,null,null) || droit(TAB, DROIT_MODIF,null,null,null,null) || droit(TAB, DROIT_CREAT,null,null,null,null) || droit(TAB, DROIT_SUPPR,null,null,null,null))
		echo '<row><item caption="'.$lang_menu_lbl_gestdashboard_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/control.gif" value="'.$pathFlow.'admin/tab/admin_tab.php" toolTip="'.$lang_menu_lbl_gestdashboard_tooltip.'"/></row>';
	
	//Menu Gestion des annonces		ANN
	if($droitPresent[ANN])
		echo '<row><item caption="'.$lang_menu_lbl_gestannonc_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/quote.png" value="'.$pathFlow.'admin/annonce/admin_annonce.php" toolTip="'.$lang_menu_lbl_gestannonc_toolTip.'"/></row>';
	
	//Menu Gestion des flux RSS		RSS
	if($droitPresent[RSS])
		echo '<row><item caption="'.$lang_menu_lbl_gestrss_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/rss.png" value="'.$pathFlow.'admin/rss/admin_rss.php" toolTip="'.$lang_menu_lbl_gestrss_toolTip.'"/></row>';
	
	//Menu Compteurs		COP
	if($droitPresent[COP])
		echo '<row><item caption="'.$lang_menu_lbl_gestcpt_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/compt.gif" value="'.$pathFlow.'admin/cpteur/admin_cpteur.php" toolTip="'.$lang_menu_lbl_gestcpt_toolTip.'"/></row>';
		
	// Suivi de processus externes
	if ($droitPresent[EXT])
		echo '<row><item caption="'.$lang_menu_lbl_admin_extern_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/add_externlog.png" value="'.$pathFlow.'admin/suivi/admin_suivi.php" toolTip="'.$lang_menu_lbl_extern_tooltip.'"/></row>';
	
	//Menu Purge		PUR
//	if($droitPresent[PUR])
//		echo '<row><item caption="'.$lang_menu_lbl_gestpurg_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/recycle.png" value="'.$pathFlow.'admin/purge/admin_purge.php" toolTip="'.$lang_menu_lbl_gestpurg_toolTip.'"/></row>';
	if($droitPresent[PUR])
	{
		echo '<row><item caption="'.$lang_menu_lbl_gestpurg_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/recycle.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_gestpurg_toolTip.'"/>';
		echo '<row><item caption="'.$lang_menu_lbl_gestpurg_toolTip.'" icon="'.$pathFlow.'style/imgs/icons/menu/traitement.gif" value="'.$pathFlow.'admin/purge/admin/admin_purge.php" toolTip="'.$lang_menu_lbl_gestpurg_toolTip.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestpurg_histo.'" icon="'.$pathFlow.'style/imgs/icons/menu/histo.gif" value="'.$pathFlow.'admin/purge/historique/admin_purge_hist.php" toolTip="'.$lang_menu_lbl_gestpurg_histo.'"/></row>';
		echo '</row>';
	}
	
	//Menus Exploitation et Configuration avancee		SAD
	if($droitPresent[SAD])
	{
		echo '<row><item caption="'.$lang_menu_lbl_gestexploit_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/exploitation.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_gestexploit_caption.'"/>';
		echo '<row><item caption="'.$lang_menu_lbl_gestBDD_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/bdd.png" toolTip="'.$lang_menu_lbl_gestBDD_caption.'" onClick="prlTreeView.expandNode(this.parentNode);" />';
		echo '<row><item caption="'.$lang_menu_lbl_gesttables_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/bdd_opt.png" value="'.$pathFlow.'admin/exploitation/gestdb/admin_exp_gestdb.php" toolTip="'.$lang_menu_lbl_gesttables_caption.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestSQL_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/bdd_req.png" value="'.$pathFlow.'admin/exploitation/sqledit/admin_exp_sqled.php" toolTip="'.$lang_menu_lbl_gestSQL_caption.'"/></row>';
		echo '<row><item caption="'.$lang_admin_exp_sauvegarde_menu.'" icon="'.$pathFlow.'style/imgs/icons/save.png" value="'.$pathFlow.'admin/exploitation/save/admin_exp_save.php" toolTip="'.$lang_admin_exp_sauvegarde_title.'"/></row>';
		echo '<row><item caption="'.$lang_admin_exp_restauration_menu.'" icon="'.$pathFlow.'style/imgs/icons/restore.png" value="'.$pathFlow.'admin/exploitation/restore/admin_exp_restore.php" toolTip="'.$lang_admin_exp_restauration_title.'"/></row>';
		echo '<row><item caption="'.$lang_admin_exp_migration_menu.'" icon="'.$pathFlow.'style/imgs/icons/dbCopy.png" value="'.$pathFlow.'admin/exploitation/dupliq/admin_exp_dupliq.php" toolTip="'.$lang_admin_exp_migration_title.'"/></row>';
		echo '</row>';	//fin BdD
		echo '<row><item caption="'.$lang_menu_lbl_gestEditeurs_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/editeurs.png" toolTip="'.$lang_menu_lbl_gestEditeurs_caption.'" onClick="prlTreeView.expandNode(this.parentNode);" />';
		echo '<row><item caption="'.$lang_menu_lbl_gestPython_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/python.png" value="'.$pathFlow.'admin/exploitation/editeurs/edit_actAffich.php?type=1" toolTip="'.$lang_menu_lbl_gestPython_caption.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestRegEx_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/regex.png" value="'.$pathFlow.'admin/exploitation/editeurs/edit_actAffich.php?type=2" toolTip="'.$lang_menu_lbl_gestRegEx_caption.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestXML_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/xml.png" value="'.$pathFlow.'admin/exploitation/editeurs/edit_actAffich.php?type=3" toolTip="'.$lang_menu_lbl_gestXML_caption.'"/></row>';
		// on verifie si FileViewer est accessible
		$req = "SELECT FCO_FILEVIEWER FROM FLOWCONF";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$fileviewer = $row['FCO_FILEVIEWER'];
		$gDb->SQLFermeQuery(1);
		if($fileviewer!='')
		{
			$ch = curl_init($fileviewer);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 0);
			curl_setopt($ch, CURLOPT_TIMEOUT, 5); // 5 secondes
			$resultat = curl_exec($ch);
			curl_close($ch);
			if ($resultat)
			{
				echo '<row><item caption="'.$lang_admin_confav_confgen_lbl_fileviewer.'" icon="'.$pathFlow.'style/imgs/icons/menu/mapping.png" value="'.$pathFlow.'admin/exploitation/editeurs/edit_actAffich.php?type=4" toolTip="'.$lang_admin_confav_confgen_lbl_fileviewer.'"/></row>';
			}
		}
		echo '</row>';	//fin Editeurs
		//Référentiel
		echo '<row><item caption="'.$lang_menu_lbl_gestReferentiel_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/bdd_ref.png" toolTip="'.$lang_menu_lbl_gestReferentiel_caption.'" onClick="prlTreeView.expandNode(this.parentNode);" />';
		echo '<row><item caption="'.$lang_admin_confav_confgen_pnl_title_conf.'" icon="'.$pathFlow.'style/imgs/icons/menu/notes.gif" value="'.$pathFlow.'admin/exploitation/referentiel/admin_exp_confRef.php" toolTip="'.$lang_admin_confav_confgen_pnl_title_conf.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_import_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/import.gif" value="'.$pathFlow.'admin/exploitation/referentiel/admin_exp_gestRef.php" toolTip="'.$lang_menu_lbl_import_ref_tooltip.'"/></row>';
		echo '</row>';	//fin Référentiel
		echo '</row>';	//fin Exploitation
		echo '<row><item caption="'.$lang_menu_lbl_gestavanc_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/avance.png" onClick="prlTreeView.expandNode(this.parentNode);" toolTip="'.$lang_menu_lbl_gestavanc_tooltip.'"/>';
		echo '<row><item caption="'.$lang_menu_lbl_gestgene_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/notes.gif" value="'.$pathFlow.'admin/confav/confgen/admin_confav_confgen.php" toolTip="'.$lang_menu_lbl_gestgene_tooltip.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_admin_ldap_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/ldap.png" value="'.$pathFlow.'admin/confav/ldap/admin_confav_ldap.php" toolTip="'.$lang_menu_lbl_admin_ldap_tooltip.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestaddact_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/add.gif" value="'.$pathFlow.'admin/confav/addact/admin_confav_addact.php" toolTip="'.$lang_menu_lbl_gestaddact_caption.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestactiv_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/param_autres.png" value="'.$pathFlow.'admin/confav/activite/admin_confav_act.php" toolTip="'.$lang_menu_lbl_gestactiv_tooltip.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestclient_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/client.gif" value="'.$pathFlow.'admin/confav/client/admin_confav_cli.php" toolTip="'.$lang_menu_lbl_gestclient_caption.'"/></row>';
		echo '<row><item caption="'.$lang_menu_lbl_gestproc_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/traitement.gif" value="'.$pathFlow.'admin/confav/proc/admin_confav_proc.php" toolTip="'.$lang_menu_lbl_gestproc_caption.'"/></row>';
		if ($TACPresent[TAC_NUM_DEMAT])
		{
			echo '<row><item caption="'.$lang_menu_lbl_gestinvoice_caption.'" icon="'.$pathFlow.'style/imgs/icons/menu/invoice.gif" onClick="prlTreeView.expandNode(this.parentNode);" />';
			// Recherche du parametre general associe a la demat fiscale
			// (il n'y en a qu'un seul cree par l'installation de l'activite)
			$req = "SELECT PGE_ID FROM PAR_GEN WHERE TPG_NUM = 20";
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			$pge_id = $row['PGE_ID'];
			$url = urlencode($pathFlow.'flux/pargen/pargen_actAffich.php?tpg_num=20&pge_id='.$pge_id.'&action=modif');
        	echo '<row><item caption="'.$lang_admin_confav_demat_configuration.'" icon="'.$pathFlow.'style/imgs/icons/menu/notes.gif" value="'.$url.'" toolTip="'.$lang_admin_confav_demat_configuration.'"/></row>';
			echo '<row><item caption="'.$lang_admin_confav_demat_import.'" icon="'.$pathFlow.'style/imgs/icons/menu/import.gif" value="'.$pathFlow.'admin/confav/demat/recup_demat.php" toolTip="'.$lang_menu_lbl_gestinvoice_tooltip.'"/></row>';
        	echo '</row>';	//fin Invoice Manager
		}
		echo '</row>';	//fin Configuration avancee
	}	
	echo '</row>';	//fin Administrateurs
}

echo '</databind>';
?>