<?php
$DEFAULT_PATH = "../";
require_once($DEFAULT_PATH."struct.php");
$DROITS = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC;
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."inc/php/datasource.class.php");

//$src = pget('src');
$src ='xml';
$cache = pget('cache');

/***************************************************************************/
//Vérifaction de la présence des droits utiles à la construction du menu
$droitsMenu = array();	//tableau contenant les droits utilisés pour le menu

//Suivi
$droitsMenu [] = SDO;
$droitsMenu [] = SDM;
$droitsMenu [] = SDR;
$droitsMenu [] = TAB;
$droitsMenu [] = CTA;
$droitsMenu [] = CMA;
$droitsMenu [] = HIS;
$droitsMenu [] = PRO;
$droitsMenu [] = VAL;

//Flux
$droitsMenu [] = FLX;
$droitsMenu [] = PAR;
$droitsMenu [] = DOC;
$droitsMenu [] = SDR;
$droitsMenu [] = PDM;
$droitsMenu [] = CERT;
$droitsMenu [] = RES;
$droitsMenu [] = TRA;
$droitsMenu [] = SAD;

//Utilisateurs
$droitsMenu [] = FAM;
$droitsMenu [] = UTR;
$droitsMenu [] = DRO;

//Administration
$droitsMenu [] = ACT;
$droitsMenu [] = ALE;
$droitsMenu [] = TAB;
$droitsMenu [] = COP;
$droitsMenu [] = PUR;
$droitsMenu [] = ANN;
$droitsMenu [] = SAD;

//Informations
$droitsMenu [] = INFO;
$droitsMenu [] = CPT;
$droitsMenu [] = LIC;

$droitPresent = array();	//tableau indiquant le présence ou pas de chacun des droits du menu pour l'utilisateur

foreach ($droitsMenu as $droit)
	$droitPresent[$droit] = droit($droit, $DROITS, null, null, null, null);
	
//Affichage des processus seulement si on a les droits disponibles (master & admin)
if ($droitPresent[PRO])
{	
	// Idée de mise en cache
	$exec = true;
	if($cache == '1')
	{
		$buf = "";
		$cache_file = $DEFAULT_PATH."proc_stat.tmp";
	
		if(file_exists($cache_file) && (filemtime($cache_file) + 10 > time())) {
			header("Content-Type: text/xml; charset=utf-8");
			readfile($cache_file);
			$exec = false;
		}
	}
	if ($exec)
	{
		$req = "SELECT FCO_OS_WEB
		        FROM FLOWCONF";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$fco_os_web = $row['FCO_OS_WEB'];
		$gDb->SQLFermeQuery(1);
		
		$req = "SELECT PRO_OS_MOTEUR, PRO_NOM
				FROM PROCESSUS";
		
		$gDb->SQLQuery($req, 1);
		$procs = array();
	
	    session_write_close();
		if ($fco_os_web == FCO_OS_WEB_WIN)
	        exec("net start", $buf, $res);
	            
	    if ($fco_os_web == FCO_OS_WEB_LINUX)
	        exec("ps -A", $buf, $res);
	    if ($res == 1)
	        $etat = null;
		
		while ($row = $gDb->SQLNextRow(1))
		{
			$fco_os_moteur	= $row['PRO_OS_MOTEUR'];	
			
			if ($res != 1)
			{
				$etat = false;
				
				foreach($buf as $rr)
					if (preg_match("/".$row['PRO_NOM']."$/", $rr))
					{
						$etat = true;
						break;
					}
			}
			$procs[$row['PRO_NOM']] = $etat;
		}
		$gDb->SQLFermeQuery(1);
	
		//JSON
		if($src == 'json')
		{
			header("Content-Type: text/plain");
			$buf = encode_JSON($procs);
		}
		else
		{
			header("Content-Type: text/xml; charset=utf-8");
			$dataSrc = new datasource;
			foreach($procs as $k => $v)
			{
				$icon = (is_null($v)? $pathStyle.'/imgs/icons/help.png':
								($v? $pathStyle.'/imgs/icons/rond_vert.png':
								$pathStyle.'/imgs/icons/rond_rouge.png'));
							
				$dataSrc->add_row(new ds_row(new ds_item(array("caption" => $k, "icon" => $icon))));
			}
			$buf = $dataSrc->get_dump();
		}
		
		if($cache == '1')
		{
			//	Mise en cache:
			$file =	fopen($cache_file, 'w');
			fwrite($file, $buf);
			fclose($file);
		}
		echo $buf;
	}
}
//Si pas les droits sur les process affichage d'un message "Droits insuffisants"
else
{
	header("Content-Type: text/xml; charset=utf-8");
	//JSON
		if($src == 'json')
		{
			$procs = array();
			$procs[$lang_menu_lbl_droits] = false;
			header("Content-Type: text/plain");
			$buf = encode_JSON($procs);
		}
		else
		{
			$dataSrc = new datasource;
			$icon =	$pathStyle.'/imgs/icons/error.png';
			$dataSrc->add_row(new ds_row(new ds_item(array("caption" => $lang_menu_lbl_droits, "icon" => $icon))));				
			$buf = $dataSrc->get_dump();
		}
		
		echo $buf;
}

?>