<?php
// création de la base de donnée et de l'utilisateur (fmuser)
// sous Oracle la base cible doit déjà exister, car créée par le sysdba
// sous Oracle BG : on se sert du login/password de la base source afin de créer l'utilisateur/schéma.
// (recopie des requetes des fichiers XML cree_base et cree_user correspondant)
function createDB($Db, $name, $login, $pwd)
{
	$res = false;
	$req = '';
	if($Db->TypeBase=='mysql')
	{
		$req = "BEGIN";
		$res = $Db->SQLQuery($req, 5);
		$Db->SQLFermeQuery(5);
		if($res)
		{
			$req = "CREATE DATABASE $name";
			$res = $Db->SQLQuery($req, 5);
			$Db->SQLFermeQuery(5);
			if($res)
			{
				$req = "GRANT ALL PRIVILEGES ON $name.* TO '$login'@'%' IDENTIFIED BY '$pwd'";
				$res = $Db->SQLQuery($req, 5);
				$Db->SQLFermeQuery(5);
				if($res)
				{
					$req = "GRANT ALL PRIVILEGES ON $name.* TO '$login'@'localhost' IDENTIFIED BY '$pwd'";
					$res = $Db->SQLQuery($req, 5);
					$Db->SQLFermeQuery(5);
					if($res)
					{
						$req = "UPDATE mysql.user SET SUPER_PRIV='Y' WHERE USER='$login'";
						$res = $Db->SQLQuery($req, 5);
						$Db->SQLFermeQuery(5);
						if($res)
						{
							$req = "USE $name";
							$res = $Db->SQLQuery($req, 5);
							$Db->SQLFermeQuery(5);
							if($res)
							{
								$req = "COMMIT";
								$res = $Db->SQLQuery($req, 5);
								$Db->SQLFermeQuery(5);
							}
						}
					}
				}
			}
		}
	}
	else if($Db->TypeBase=='mssql')
	{
		$req = "CREATE DATABASE $name";
		$res = $Db->SQLQuery($req, 5);
		$Db->SQLFermeQuery(5);
		if($res)
		{
			$req = "IF NOT EXISTS(SELECT name FROM master.dbo.syslogins WHERE name = '$login')
				BEGIN
					CREATE LOGIN $login WITH PASSWORD=N'$pwd', DEFAULT_DATABASE=[$name], CHECK_EXPIRATION=OFF, CHECK_POLICY=OFF
					ALTER LOGIN $login WITH DEFAULT_LANGUAGE = English
				END";
			$res = $Db->SQLQuery($req, 5);
			$Db->SQLFermeQuery(5);
			if($res)
			{
				$req = "USE $name";
				$Db->SQLQuery($req, 5);
				$Db->SQLFermeQuery(5);
				$req = "CREATE USER $login FOR LOGIN $login WITH DEFAULT_SCHEMA=[dbo]";
				$res = $Db->SQLQuery($req, 5);
				$Db->SQLFermeQuery(5);
				if($res)
				{
					$req = "sp_addrolemember db_owner, $login";
					$res = $Db->SQLQuery($req, 5);
					$Db->SQLFermeQuery(5);
				}
			}
		}
	}
	else if($Db->TypeBase=='oracle')
	{
		$req = "BEGIN";
		$res = $Db->SQLQuery($req, 5);
		$Db->SQLFermeQuery(5);
		if($res)
		{
			$req = "create user $login identified by $pwd default tablespace users temporary tablespace temp quota unlimited on users";
			$res = $Db->SQLQuery($req, 5);
			$Db->SQLFermeQuery(5);
			if($res)
			{
				$req = "grant connect to $login";
				$res = $Db->SQLQuery($req, 5);
				$Db->SQLFermeQuery(5);
				if($res)
				{
					$req = "grant resource to $login";
					$res = $Db->SQLQuery($req, 5);
					$Db->SQLFermeQuery(5);
					if($res)
					{
						$req = "alter user $login default role all";
						$res = $Db->SQLQuery($req, 5);
						$Db->SQLFermeQuery(5);
						if($res)
						{
							$req = "grant select_catalog_role to $login";
							$res = $Db->SQLQuery($req, 5);
							$Db->SQLFermeQuery(5);
							if($res)
							{
								$req = "COMMIT";
								$res = $Db->SQLQuery($req, 5);
								$Db->SQLFermeQuery(5);
							}
						}
					}
				}
			}
		}
	}
	return $res;
}

// retourne un tableau avec le nom des tables de la base $Db
function getTables($Db)
{
	$req = '';
	if($Db->TypeBase=='mysql')
		$req = "SELECT TABLE_NAME 
				FROM INFORMATION_SCHEMA.TABLES 
				WHERE TABLE_SCHEMA='$Db->DatabaseName'";
	else if($Db->TypeBase=='mssql')
		$req = "SELECT TABLE_NAME 
				FROM INFORMATION_SCHEMA.TABLES 
				WHERE TABLE_CATALOG='$Db->DatabaseName'";
	else if($Db->TypeBase=='oracle')
		$req = "SELECT TABLE_NAME 
				FROM USER_TABLES";

	$ret = array();
	
	$Db->SQLQuery($req, 5);
	while ($row = $Db->SQLNextRow(5))
	{
		$ret[] = strtoupper($row['TABLE_NAME']);
	}
	$Db->SQLFermeQuery(5);
	
	return $ret;
}

// retourne un tableau descriptif des colonnes d'une table
// name
// type
// length
// default
// unsigned (false pour Oracle)
// notnull
// autoincrement (false pour Oracle)
// convert : true si champs à convertir pour MSSQL (cas des varnibary) valeur positionnée lors de la construction du CREATE
function getColumns($Db, $table)
{
	$req = '';
	if($Db->TypeBase=='mysql')
	{
		// info : COALESCE retourne la 1ere colonne non null
		$req = "SELECT COLUMN_NAME, DATA_TYPE, COALESCE(CHARACTER_MAXIMUM_LENGTH, NUMERIC_PRECISION) AS LENGTH, IS_NULLABLE AS NULLABLE, COLUMN_DEFAULT AS VALDEFAULT, COLUMN_TYPE, EXTRA 
				FROM INFORMATION_SCHEMA.COLUMNS 
				WHERE TABLE_SCHEMA='$Db->DatabaseName' AND TABLE_NAME='$table' ORDER BY ORDINAL_POSITION";
	}else if($Db->TypeBase=='mssql')
	{
		$req = "SELECT COLUMN_NAME, DATA_TYPE, COALESCE(CHARACTER_MAXIMUM_LENGTH, NUMERIC_PRECISION) AS LENGTH, IS_NULLABLE AS NULLABLE, COLUMN_DEFAULT AS VALDEFAULT 
				FROM INFORMATION_SCHEMA.COLUMNS 
				WHERE TABLE_CATALOG='$Db->DatabaseName' AND TABLE_NAME='$table' ORDER BY ORDINAL_POSITION";
	}else if($Db->TypeBase=='oracle')
	{
		$req = "SELECT COLUMN_NAME, DATA_TYPE, DATA_LENGTH AS LENGTH, DATA_DEFAULT AS VALDEFAULT, NULLABLE 
				FROM USER_TAB_COLUMNS 
				WHERE TABLE_NAME='$table' ORDER BY COLUMN_ID";
	}
	$ret = array();
	
	$Db->SQLQuery($req, 5);
	while ($row = $Db->SQLNextRow(5))
	{
		if($row['LENGTH']=='NULL') $length = 0;
		else $length = $row['LENGTH'];
		
		$unsigned = false;
		$autoinc = false;
		$convert = false;
		$datetime = false;
		$valdefault = false;
		if($Db->TypeBase=='mysql')
		{
			$datetime = strtolower($row['DATA_TYPE'])=='datetime' ? true : false;
			$unsigned = stripos($row['COLUMN_TYPE'], 'unsigned')!==FALSE ? true : false;
			$autoinc = stripos($row['EXTRA'], 'auto_increment')!==FALSE ? true : false;
			$valdefault = $row['VALDEFAULT'];
		}
		else if($Db->TypeBase=='mssql')
		{
			$datetime = strtolower($row['DATA_TYPE'])=='datetime' ? true : false;
			$unsigned = strtolower($row['DATA_TYPE'])=='int' ? true : false;
			$req = "SELECT is_identity FROM sys.columns WHERE [object_id] = object_id('$table') AND name='${row['COLUMN_NAME']}'";
			$Db->SQLQuery($req, 6);
			$tmp = $Db->SQLNextRow(6);
			$autoinc = $tmp[0]=='1' ? true : false;
			$Db->SQLFermeQuery(6);
			// bgz 4899 : Mssql entoure la valeur par défaut de '(' et ')'
			//  mais on peut insérer les lignes sans les parenthèses donc on les supprime (évite les pb pour dupliq et restore en multi-base)
			$valdefault = str_replace("')","",str_replace("('","",$row['VALDEFAULT']));
			$valdefault = str_replace("))","",str_replace("((","",$valdefault));
			$valdefault = str_replace(")","",str_replace("(","",$valdefault));
		}
		else if($Db->TypeBase=='oracle')
		{
			$datetime = strtolower($row['DATA_TYPE'])=='date' ? true : false;
			$valdefault = $row['VALDEFAULT'];
		}
		$notnull = stripos($row['NULLABLE'], 'y')!==FALSE ? false : true;
		
		$ret[] = array( 'name' => strtoupper($row['COLUMN_NAME']),
						'type' => $row['DATA_TYPE'],
						'length' => $length,
						'default' => $valdefault,
						'unsigned' => $unsigned,
						'notnull' => $notnull,
						'autoincrement' => $autoinc,
						'convert' => $convert,
						'date' => $datetime);
	}
	$Db->SQLFermeQuery(5);
	
	return $ret;
}

// retourne un tableau décrivant les contraintes d'une table
// name
// type
// col
// ref_table
// ref_col
function getConstraints($Db, $table, $tk, $secuIns)
{
	$req = '';
	if($Db->TypeBase=='mysql')
		$req = "SELECT CONSTRAINT_NAME, CONSTRAINT_TYPE 
				FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS 
				WHERE TABLE_SCHEMA='$Db->DatabaseName' AND TABLE_NAME='$table'";
	else if($Db->TypeBase=='mssql')
		$req = "SELECT CONSTRAINT_NAME, CONSTRAINT_TYPE 
				FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS 
				WHERE TABLE_CATALOG='$Db->DatabaseName' AND TABLE_NAME='$table'";
	else if($Db->TypeBase=='oracle')
		$req = "SELECT CONSTRAINT_NAME, CONSTRAINT_TYPE 
				FROM USER_CONSTRAINTS 
				WHERE TABLE_NAME='$table'";

	$ret = array();
	
	// restriction en fonction de la clé à créer
	if($tk == 'P')        // PK 
		$req .=" AND CONSTRAINT_TYPE='PRIMARY KEY'";
	else if($tk == 'R')   // FK
		$req .=" AND CONSTRAINT_TYPE='FOREIGN KEY'";
	else if($tk == 'U')   // UNIQ
	{
		$req .=" AND CONSTRAINT_TYPE='UNIQUE'";
		if($Db->TypeBase=='mysql') // dans le cas des index sous MySQL, la contrainte unique est déclarée à la création de l'index
			$req .=	" AND CONSTRAINT_NAME NOT IN (SELECT INDEX_NAME FROM INFORMATION_SCHEMA.STATISTICS WHERE TABLE_SCHEMA='$Db->DatabaseName' AND TABLE_NAME='$table')";
	}
	$type = $tk;
	$Db->SQLQuery($req, 7);
	while($row = $Db->SQLNextRow(7))
	{
		// cas particulier ORACLE
		if($row['CONSTRAINT_TYPE'] == 'C')
			continue; // on passe pour l'instant...

		$cst = array('name' => $secuIns.strtoupper($row['CONSTRAINT_NAME']).$secuIns, 'type' => $type, 'col' =>'', 'ref_table'=>'', 'ref_col'=>'');
		if(getContraintDetail($Db, $table, $row['CONSTRAINT_NAME'], $cst, $secuIns))
			$ret[] = $cst;
	}
	$Db->SQLFermeQuery(7);
	
	return $ret;
}

// retourne le détail d'une contrainte 
// col
// ref_table
// ref_col
function getContraintDetail($Db, $table, $name, &$cst, $secuIns)
{
	$req = '';
	if($Db->TypeBase=='mysql') // peu importe le type
		$req = "SELECT COLUMN_NAME AS COL, REFERENCED_TABLE_NAME AS REF_TABLE, REFERENCED_COLUMN_NAME AS REF_COL 
				FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE 
				WHERE TABLE_SCHEMA='$Db->DatabaseName' AND TABLE_NAME='$table' AND CONSTRAINT_NAME='$name'";
	else if($Db->TypeBase=='mssql')
	{
		if($cst['type']=='P')
			$req = "SELECT CC.COLUMN_NAME AS COL FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS TC
					INNER JOIN INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE CC 
						ON TC.CONSTRAINT_NAME = CC.CONSTRAINT_NAME
					WHERE TC.CONSTRAINT_TYPE='PRIMARY KEY' AND TC.CONSTRAINT_CATALOG='$Db->DatabaseName' AND TC.TABLE_NAME='$table' AND TC.CONSTRAINT_NAME='$name'";
		else if($cst['type']=='R')
			$req = "SELECT KCU1.COLUMN_NAME AS COL, KCU2.TABLE_NAME AS REF_TABLE, KCU2.COLUMN_NAME AS REF_COL 
					FROM INFORMATION_SCHEMA.REFERENTIAL_CONSTRAINTS AS RC 
					LEFT JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE AS KCU1 
						ON KCU1.CONSTRAINT_CATALOG = RC.CONSTRAINT_CATALOG  
						AND KCU1.CONSTRAINT_NAME = RC.CONSTRAINT_NAME 
					LEFT JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE AS KCU2 
						ON KCU2.CONSTRAINT_CATALOG = RC.UNIQUE_CONSTRAINT_CATALOG  
						AND KCU2.CONSTRAINT_NAME = RC.UNIQUE_CONSTRAINT_NAME 
					WHERE KCU1.CONSTRAINT_CATALOG='$Db->DatabaseName' KCU1.TABLE_NAME='$table' AND KCU1.CONSTRAINT_NAME='$name'";
		else if($cst['type']=='U')
			$req = "SELECT CC.COLUMN_NAME AS COL FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS TC
					INNER JOIN INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE CC 
						ON TC.CONSTRAINT_NAME = CC.CONSTRAINT_NAME
					WHERE TC.CONSTRAINT_TYPE='UNIQUE' AND TC.CONSTRAINT_CATALOG='$Db->DatabaseName' AND TC.TABLE_NAME='$table' AND TC.CONSTRAINT_NAME='$name'";
	}
	else if($Db->TypeBase=='oracle')
		$req = "";

	$res = $Db->SQLQuery($req, 5);
	if($res)
	{
		if($cst['type']=='U')
		{
			$k = 0;
			while($row = $Db->SQLNextRow(5))
			{
				if($k == 0)
					$cst['col'] = $secuIns.$row['COL'].$secuIns;
				else
					$cst['col'] .= ', '.$secuIns.$row['COL'].$secuIns;
				$k = 1;
				
				$cst['ref_table'] = $secuIns.$row['REF_TABLE'].$secuIns;
				$cst['ref_col'] = $secuIns.$row['REF_COL'].$secuIns;
			}
		}
		else
		{
			$row = $Db->SQLNextRow(5);
			$cst['col'] = $secuIns.$row['COL'].$secuIns;
			$cst['ref_table'] = $secuIns.$row['REF_TABLE'].$secuIns;
			$cst['ref_col'] = $secuIns.$row['REF_COL'].$secuIns;
		}
	}			
	$Db->SQLFermeQuery(5);
	return $res;

}

// retourne un tableau décrivant les index d'une table
// name = nom de l'index
// col = liste des colonnes constituant l'index
function getIndexes($Db, $table)
{
	$req = '';
	if($Db->TypeBase=='mysql')
		$req = "SELECT INDEX_NAME AS NAME, GROUP_CONCAT(COLUMN_NAME ORDER BY SEQ_IN_INDEX) AS COL, (NON_UNIQUE=0) AS IS_UNIQUE
				FROM INFORMATION_SCHEMA.STATISTICS
				WHERE TABLE_SCHEMA='$Db->DatabaseName' AND TABLE_NAME='$table' 
				GROUP BY INDEX_NAME";
	else if($Db->TypeBase=='mssql')
		$req = "SELECT SYS.INDEXES.NAME AS NAME, SYS.COLUMNS.NAME AS COL, SYS.INDEXES.IS_UNIQUE
				FROM SYS.TABLES, SYS.INDEXES, SYS.INDEX_COLUMNS, SYS.COLUMNS 
				WHERE (SYS.TABLES.OBJECT_ID = SYS.INDEXES.OBJECT_ID AND SYS.TABLES.OBJECT_ID = SYS.INDEX_COLUMNS.OBJECT_ID AND SYS.TABLES.OBJECT_ID = SYS.COLUMNS.OBJECT_ID
				AND SYS.INDEXES.INDEX_ID = SYS.INDEX_COLUMNS.INDEX_ID AND SYS.INDEX_COLUMNS.COLUMN_ID = SYS.COLUMNS.COLUMN_ID) 
				AND SYS.TABLES.NAME = '$table' AND SYS.INDEXES.TYPE=2";
	else if($Db->TypeBase=='oracle')
		$req = "SELECT INDEX_NAME AS NAME, LISTAGG(COLUMN_NAME, ',') WITHIN GROUP (ORDER BY COLUMN_NAME) AS COL, 0 AS IS_UNIQUE
				FROM USER_IND_COLUMNS 
				WHERE TABLE_NAME='$table' 
				GROUP BY INDEX_NAME";
	
	$ret = array();
	
	$Db->SQLQuery($req, 5);
	$old = '';
	while ($row = $Db->SQLNextRow(5))
	{
		$name = $row['NAME'];
		$is_unique = $row['IS_UNIQUE'];
		
		if($Db->TypeBase!='mssql') // le groupage est fait dans la requete sauf pour mssql...
			$col = $row['COL'];
		else
		{
			// on regroupe les colonnes tant que c'est le même nom d'index
			$col = '';
			$sep = '';
			do{
				$col .= $sep.$row['COL'];
				$sep = ',';
			}while($old==$name);
			$old = $name;
		}
		$ret[] = array('name'=>$name, 'col'=>$col, 'is_unique'=>$is_unique);
	}
	$Db->SQLFermeQuery(5);
	
	return $ret;
}
/*
// retourne un tableau avec le nom des procédures stockées d'une base
function getProcedures($Db)
{
	$req = '';
	if($Db->TypeBase=='mysql')
		$req = "SELECT ROUTINE_NAME FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_SCHEMA='$Db->DatabaseName'";
	else if($Db->TypeBase=='mssql')
		$req = "SELECT ROUTINE_NAME FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_CATALOG='$Db->DatabaseName'";
	else if($Db->TypeBase=='oracle')
		$req = "SELECT NAME FROM USER_SOURCE WHERE TYPE='PROCEDURE'";

	$ret = array();
	
	$Db->SQLQuery($req, 5);
	while ($row = $Db->SQLNextRow(5))
	{
		$ret[] = strtoupper($row['ROUTINE_NAME']);
	}
	$Db->SQLFermeQuery(5);
	
	return $ret;
}
*/

// retourne le texte d'une procédure stockée déterminée
function getProcedureText($Db, $proc)
{
	$req = '';
	if($Db->TypeBase=='mysql')
		$req = "SELECT ROUTINE_DEFINITION AS TEXT FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_SCHEMA='$Db->DatabaseName' AND ROUTINE_NAME='$proc'";
	else if($Db->TypeBase=='mssql')
		$req = "SELECT ROUTINE_DEFINITION AS TEXT FROM INFORMATION_SCHEMA.ROUTINES WHERE ROUTINE_CATALOG='$Db->DatabaseName' AND ROUTINE_NAME='$proc'";
	else if($Db->TypeBase=='oracle')
		$req = "SELECT TEXT FROM USER_SOURCE WHERE TYPE='PROCEDURE' AND NAME='$proc'";

	$Db->SQLQuery($req, 5);
	$row = $Db->SQLNextRow(5);
	$Db->SQLFermeQuery(5);
	
	return $row['TEXT'];
}

// Création des procédures en fonction du type de base
//		Les procédures ne sont pas recopiées mais recrées en dur car trop de disparités dans la forme
//		et procédures suplémentaires pour Oracle
// retourne un tableau avec :
//		$reponse['return'] = 0 (succes) ou 8 (erreur cf. duplicateDatabase)
//		$reponse['msg'] = complément d'info si erreur
function createProcedures($Db, $bPart)
{
	$reponse = array();
	$reponse['return'] = 0;
	$reponse['msg'] ='';
	
	$codErr = 8; // si jamais le code de retour évolu, une seule modif à faire....
	
	$res = true;
	
	if($Db->TypeBase=='mysql')
	{
		if($bPart)
		{
			$req = "CREATE PROCEDURE REBUILD_PART( one_grp INT, INOUT one_par_left INT )
					BEGIN
						DECLARE one_par_right INT DEFAULT 0;
						DECLARE done, one_par_id INT DEFAULT 0;
						DECLARE cur CURSOR FOR
							SELECT PAR_ID FROM PART WHERE GRP_ID=one_grp;
						DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET done = 1;
						SET one_par_right = one_par_left +1;
						OPEN cur;
						WHILE NOT done DO
							FETCH cur INTO one_par_id;
							IF NOT done THEN
								CALL REBUILD_PART( one_par_id, one_par_right);
							END IF;
						END WHILE;
						CLOSE cur;
						UPDATE PART SET PAR_LEFT=one_par_left, PAR_RIGHT=one_par_right WHERE PAR_ID=one_grp;
						SET one_par_left = one_par_right + 1;
					END";
			$res = $Db->SQLQueryDirect($req, 5);
			$Db->SQLFermeQuery(5);
			if(!$res)
			{
				$reponse['return'] = $codErr;
				$reponse['msg'] = 'REBUILD_PART';
			}
			else
			{
				$req = "CREATE PROCEDURE REBUILD_PART_TREE( )
						BEGIN
							DECLARE one_par_left INT DEFAULT 2;
							DECLARE done, one_par_id INT DEFAULT 0;
							DECLARE cur CURSOR FOR
								SELECT PAR_ID FROM PART WHERE GRP_ID IS NULL AND PAR_ID>1;
							DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET done = 1;
							OPEN cur;
							WHILE NOT done DO
								FETCH cur INTO one_par_id;
								IF NOT done THEN
									CALL REBUILD_PART( one_par_id, one_par_left );
								END IF;
							END WHILE;
							CLOSE cur;
							UPDATE PART SET PAR_LEFT=1, PAR_RIGHT=one_par_left WHERE PAR_ID=1;
						END";
				$res = $Db->SQLQueryDirect($req, 5);
				$Db->SQLFermeQuery(5);
				if(!$res)
				{
					$reponse['return'] = $codErr;
					$reponse['msg'] = 'REBUILD_PART_TREE';
				}
			}
		}
	}
	else if($Db->TypeBase=='mssql')
	{
		if($bPart)
		{
			$req = "CREATE PROCEDURE REBUILD_PART
				@one_grp INT,
				@one_par_left INT OUT
				AS
				BEGIN
					DECLARE @one_par_id INT
					DECLARE @one_par_right INT
					SET @one_par_id = 0
					SET @one_par_right = @one_par_left +1
					DECLARE REBUILD_PART_cur CURSOR FOR
						SELECT PAR_ID FROM PART WHERE GRP_ID=@one_grp
					OPEN REBUILD_PART_cur
					FETCH NEXT FROM REBUILD_PART_cur INTO @one_par_id
					WHILE @@FETCH_STATUS = 0
						BEGIN
							EXECUTE REBUILD_PART @one_par_id, @one_par_right
							FETCH NEXT FROM REBUILD_PART_cur INTO @one_par_id
						END
					CLOSE REBUILD_PART_cur
					DEALLOCATE REBUILD_PART_cur 	
					UPDATE PART SET PAR_LEFT=@one_par_left, PAR_RIGHT=@one_par_right WHERE PAR_ID=@one_grp
					SET @one_par_left = @one_par_right + 1
				END";
			$res = $Db->SQLQueryDirect($req, 5);
			$Db->SQLFermeQuery(5);
			if(!$res)
			{
				$reponse['return'] = $codErr;
				$reponse['msg'] = 'REBUILD_PART';
			}
			else
			{
				$req = "CREATE PROCEDURE REBUILD_PART_TREE
						AS
						BEGIN
							DECLARE @one_par_left INT
							DECLARE @one_par_id INT
							SET @one_par_left = 2
							SET @one_par_id = 0
							DECLARE REBUILD_PART_TREE_cur CURSOR FOR
								SELECT PAR_ID FROM PART WHERE GRP_ID IS NULL AND PAR_ID>1
							OPEN REBUILD_PART_TREE_cur
							FETCH NEXT FROM REBUILD_PART_TREE_cur INTO @one_par_id
							WHILE @@FETCH_STATUS = 0
								BEGIN
									EXECUTE REBUILD_PART @one_par_id, @one_par_left
									FETCH NEXT FROM REBUILD_PART_TREE_cur INTO @one_par_id
								END
							CLOSE REBUILD_PART_TREE_cur
							DEALLOCATE REBUILD_PART_TREE_cur 	
							UPDATE PART SET PAR_LEFT=1, PAR_RIGHT=@one_par_left WHERE PAR_ID=1
						END";
				$res = $Db->SQLQueryDirect($req, 5);
				$Db->SQLFermeQuery(5);
				if(!$res)
				{
					$reponse['return'] = $codErr;
					$reponse['msg'] = 'REBUILD_PART_TREE';
				}
			}
		}
	}
	else if($Db->TypeBase=='oracle')
	{
		if($bPart)
		{
			$req = "CREATE OR REPLACE PROCEDURE REBUILD_PART (
				one_grp IN NUMBER,
				one_par_left IN OUT NUMBER) IS
				one_par_id NUMBER;
				one_par_right NUMBER;
				CURSOR REBUILD_PART_cur IS 
					SELECT PAR_ID FROM PART WHERE GRP_ID=one_grp;
				REBUILD_PART_rec REBUILD_PART_cur%ROWTYPE;
				BEGIN
					one_par_right := one_par_left +1;
					OPEN REBUILD_PART_cur;
					LOOP
						FETCH REBUILD_PART_cur INTO REBUILD_PART_rec;
						EXIT WHEN REBUILD_PART_cur%NOTFOUND;
						REBUILD_PART(REBUILD_PART_rec.par_id, one_par_right);
					END LOOP;
					CLOSE REBUILD_PART_cur;
					UPDATE PART SET PAR_LEFT=one_par_left, PAR_RIGHT=one_par_right WHERE PAR_ID=one_grp;
					one_par_left := one_par_right + 1;
				END;";
			$res = $Db->SQLQueryDirect($req, 5);
			$Db->SQLFermeQuery(5);
			if(!$res)
			{
				$reponse['return'] = $codErr;
				$reponse['msg'] = 'REBUILD_PART';
			}
			else
			{
				$req = "CREATE OR REPLACE PROCEDURE REBUILD_PART_TREE IS
						one_par_left NUMBER;
						one_par_id NUMBER;
						CURSOR REBUILD_PART_TREE_cur IS 
							SELECT PAR_ID FROM PART WHERE GRP_ID IS NULL AND PAR_ID>1;
						REBUILD_PART_TREE_rec REBUILD_PART_TREE_cur%ROWTYPE;
						BEGIN
							one_par_left := 2;
							one_par_id := 0;
							OPEN REBUILD_PART_TREE_cur;
							LOOP
								FETCH REBUILD_PART_TREE_cur INTO REBUILD_PART_TREE_rec;
								EXIT WHEN REBUILD_PART_TREE_cur%NOTFOUND;
								REBUILD_PART(REBUILD_PART_TREE_rec.par_id, one_par_left);
							END LOOP;
							CLOSE REBUILD_PART_TREE_cur;
							UPDATE PART SET PAR_LEFT=1, PAR_RIGHT=one_par_left WHERE PAR_ID=1;
						END;";
				$res = $Db->SQLQueryDirect($req, 5);
				$Db->SQLFermeQuery(5);
				if(!$res)
				{
					$reponse['return'] = $codErr;
					$reponse['msg'] = 'REBUILD_PART_TREE';
				}
			}
		}
		
		// Procédures suplémentaires pour Oracle
		// BG 01-02-2013 : ATTENTION pour les types FUNCTION IL FAUT TOUJOURS FINALISER PAR "END;"
		$req = "CREATE OR REPLACE FUNCTION GETNEXTVAL(nom_seq IN varchar2)
				RETURN NUMBER
				IS 
				id NUMBER;
				BEGIN
				EXECUTE IMMEDIATE 'SELECT '||nom_seq||'.NEXTVAL FROM DUAL' INTO id;
				RETURN(id);
				END;";
		$res = $Db->SQLQueryDirect($req, 5);
		$Db->SQLFermeQuery(5);

		if(!$res)
		{
			$reponse['return'] = $codErr;
			$reponse['msg'] = 'GETNEXVAL';
		}
		else
		{
			$req = "CREATE OR REPLACE FUNCTION table_exist(nom_table IN varchar2)
					RETURN number
					IS 
					temp varchar2(50);
					BEGIN
						SELECT TABLE_NAME into temp from ALL_TABLES WHERE TABLE_NAME=upper(nom_table);
						IF temp IS NOT NULL THEN
							RETURN(1);
						END IF;
					END;";
			$res = $Db->SQLQueryDirect($req, 5);
			$Db->SQLFermeQuery(5);
			if(!$res)
			{
				$reponse['return'] = $codErr;
				$reponse['msg'] = 'table_exist';
			}
			else
			{
				$req = "CREATE OR REPLACE FUNCTION trigger_exist(nom_trigger IN varchar2)
						RETURN number
						IS 
						temp varchar2(50);
						BEGIN
							SELECT TRIGGER_NAME into temp from ALL_TRIGGERS WHERE TRIGGER_NAME=upper(nom_trigger);
							IF temp IS NOT NULL THEN
								RETURN(1);
							END IF;
						END;";
				$res = $Db->SQLQueryDirect($req, 5);
				$Db->SQLFermeQuery(5);
				if(!$res)
				{
					$reponse['return'] = $codErr;
					$reponse['msg'] = 'trigger_exist';
				}
			}
		}
	}
	
	return $reponse;
}

// retourne la déclaration d'une colonne pour CREATE en fonction du type de base
// $secu et $champ sont passés par référence car sont modifiés ici
function formatCreate(&$champ, $typeBase, &$secu)
{
	if($typeBase=='mysql')
	{
		$secu = '`';
		switch(strtolower($champ['type']))
		{
			case 'int': $type = 'INT'; break;
			case 'integer': $type = 'INT'; break;
			case 'tinyint': $type = 'TINYINT'; break;
			case 'smallint': $type = 'SMALLINT'; break;
			case 'number': $type = 'INT'; break;
			case 'numeric': $type = 'INT'; break;
			case 'varchar': $type = 'VARCHAR'; break;
			case 'varchar2': $type = 'VARCHAR'; break;
			case 'char': $type = 'CHAR'; break;
			case 'text': $type = 'TEXT'; $champ['length'] = NULL; break;
			case 'longtext': $type = 'LONGTEXT'; $champ['length'] = NULL; break;
			case 'blob': $type = 'BLOB'; $champ['length'] = NULL; break;
			case 'varbinary': $type = 'VARBINARY'; break;
			case 'longblob': $type = 'LONGBLOB'; $champ['length'] = NULL; break;
			case 'clob': $type = 'TEXT'; $champ['length'] = NULL; break;
			case 'date': $type = 'DATE'; $champ['length'] = NULL; break;
			case 'datetime': $type = 'DATETIME'; $champ['length'] = NULL; break;
		}
	}
	else if($typeBase=='mssql')
	{
		$secu = '"';
		switch(strtolower($champ['type']))
		{
			case 'int': if($champ['unsigned']) { $type = 'INT'; $champ['length']=NULL; } else $type = 'NUMERIC'; break;
			case 'integer': if($champ['unsigned']) { $type = 'INT'; $champ['length']=NULL; } else $type = 'NUMERIC'; break;
			case 'tinyint': if($champ['unsigned']) { $type = 'TINYINT'; $champ['length']=NULL; } else $type = 'NUMERIC'; break;
			case 'smallint': if($champ['unsigned']) { $type = 'SMALLINT'; $champ['length']=NULL; } else $type = 'NUMERIC'; break;
			case 'number': $type = 'NUMERIC'; break;
			case 'numeric': $type = 'NUMERIC'; break;
			case 'varchar': $type = 'VARCHAR'; break;
			case 'varchar2': $type = 'VARCHAR'; break;
			case 'char': $type = 'CHAR'; break;
			case 'text': $type = 'TEXT'; $champ['length'] = NULL; break;
			case 'longtext': $type = 'VARCHAR'; $champ['length'] = 'MAX'; break;
			case 'blob': $type = 'VARBINARY'; $champ['length'] = 'MAX'; $champ['convert'] = true; break;
			case 'varbinary': $type = 'VARBINARY'; $champ['length'] = 'MAX'; $champ['convert'] = true; break;
			case 'longblob': $type = 'VARBINARY'; $champ['length'] = 'MAX'; $champ['convert'] = true; break;
			case 'clob': $type = 'VARCHAR'; $champ['length'] = 'MAX'; break;
			case 'date': $type = 'DATE'; $champ['length'] = NULL; break;
			case 'datetime': $type = 'DATETIME'; $champ['length'] = NULL; break;
		}
	}
	else if($typeBase=='oracle')
	{
		$secu = '"';
		switch(strtolower($champ['type']))
		{
			case 'int': $type = 'NUMBER'; break;
			case 'integer': $type = 'NUMBER'; break;
			case 'tinyint': $type = 'NUMBER'; break;
			case 'smallint': $type = 'NUMBER'; break;
			case 'number': $type = 'NUMBER'; break;
			case 'numeric': $type = 'NUMBER'; break;
			case 'varchar': $type = 'VARCHAR2'; break;
			case 'varchar2': $type = 'VARCHAR2'; break;
			case 'char': $type = 'CHAR'; break;
			case 'text': $type = 'CLOB'; $champ['length'] = NULL; break;
			case 'longtext': $type = 'CLOB'; $champ['length'] = NULL; break;
			case 'blob': $type = 'BLOB'; $champ['length'] = NULL; $champ['convert'] = true; break;
			case 'varbinary': $type = 'BLOB'; $champ['convert'] = true; break;
			case 'longblob': $type = 'BLOB'; $champ['length'] = NULL; $champ['convert'] = true; break;
			case 'clob': $type = 'CLOB'; $champ['length'] = NULL; break;
			case 'date': $type = 'DATE'; $champ['length'] = NULL; break;
			case 'datetime': $type = 'DATE'; $champ['length'] = NULL; break;
		}
	}

	$ret = $secu.$champ['name'].$secu.' '.$type;
	
	if($champ['length']!=NULL)
		$ret .= '('.$champ['length'].')';
	if($champ['unsigned']==true && $typeBase=='mysql')
		$ret .= ' UNSIGNED';
	if($champ['default']!='')
		$ret .= " DEFAULT '".$champ['default']."'";
	if($champ['notnull']==true)
		$ret .= ' NOT NULL';
	if($champ['autoincrement']==true)
	{
		if($typeBase=='mssql')
		{
			$ret .= ' IDENTITY';
		}
		// BG : 18/12/2012 : bgz 4796
		// rien pour oracle => gérer par les SEQUENCE + table SEQUENCES
		// rien pour mysql  => gérer par un alter table après les insertions
	}
	
	return $ret;
}

// Spécifique MySQL pour la création de contrainte PRIMARY KEY
// Car si la colonne est AUTO_INCREMENT la contrainte PRIMARY KEY est faite lors du CREATE TABLE
function isAutoIncrement($Db, $table, $col)
{
	$req = "SELECT EXTRA FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='$Db->DatabaseName' AND TABLE_NAME='$table' AND COLUMN_NAME = '$col'";
	$Db->SQLQuery($req, 6);
	$row = $Db->SQLNextRow(6);
	$Db->SQLFermeQuery(6);
	
	return (strtolower($row['EXTRA'])=='auto_increment');
}

// Fontion principale de duplication
// 
// Paramètres d'entrée :
//	chemin = chemin d'accès aux fichiers pdo.in.php et sql.inc.php
//	typeSrc = type de SGBD source : mysql, mssql, oracle
//	srvSrc = adresse du serveur source
//	drvSrc = nom du driver ODBC d'accès au SGBD source pour mssql et oracle
//	portSrc = port de connexion au SGBD source
//	loginSrc = login de connexion au SGBD source
//	pwdSrc = mot de passe de connexion au SGBD source
//	baseSrc = nom de la base source
//	typeDst = type de SGBD cible : mysql, mssql, oracle
//	srvDst = adresse du serveur cible
//	drvDst = nom du driver ODBC d'accès au SGBD cible pour mssql et oracle
//	portDst = port de connexion au SGBD cible
//	loginDst = login de connexion au SGBD cible
//	pwdDst = mot de passe de connexion au SGBD cible
//	baseDst = nom de la base cible (doit exister sous oracle)
//	test = mode test :
//		true : seules les connexions sont faites
//		false : duplication entière
//		
// Retourne un tableau :
//	return = code d'erreur
//		0 : la duplication ou le test s'est terminé correctement
//		1 : Erreur connexion base source
//		2 : Erreur connexion base destination
//		3 : Erreur de création de la base destination
//		4 : Erreur création table (msg contient le nom de la table)
//		5 : Erreur d'insertion de valeur (msg contient le nom de la table)
//		6 : Erreur de création de contrainte (msg contient le nom de la table)
//		7 : Erreur de création d'index (msg contient le nom de la table)
//		8 : Erreur de création de procédure
//		9 : Erreur autre
//		10: Erreur liée à la colonne Autoincrement
//	msg = élément sur lequel l'erreur s'est produite
//
function duplicateDatabase($path, $typeSrc, $srvSrc, $drvSrc, $portSrc, $loginSrc, $pwdSrc, $baseSrc, $typeDst, $srvDst, $drvDst, $portDst, $loginDst, $pwdDst, $baseDst, $test=false, $callback=null)
{
	global $DEFAULT_PATH; // nécessaire pour le site mais non utilisé en install
	global $ORACLE; // pour le transport de la variable globale dans pdo.inc.php
	set_time_limit(0); // L'execution ne doit pas etre stoppe par le timeout php
	$cptCallback = 0;
	
	// ********* Début bidouille pour utiliser en même temps 2 définitions différentes d'une même classe Db ********* 
	$include_sql = str_replace('class Db', 'class uifsqlDb', file_get_contents($path."sql.inc.php"));
	$include_sql = str_replace('<?php', '', $include_sql);
	$include_sql = str_replace('?>', '', $include_sql);
	eval($include_sql);
	include ($path."pdo.inc.php");
	// ********* fin bidouille => une classe nommée Db et une autre uifsqlDb *********

	if($typeSrc=='mysql')
		$srcDb = new uifsqlDb();
	else
	{
		if($typeSrc=='oracle')
			$ORACLE = 1;
		else
			$ORACLE = 0;
		$srcDb = new Db();
	}

	if($typeSrc == 'mysql')
		$retSrc = $srcDb->SQLConnect($srvSrc.":".$portSrc, $loginSrc, $pwdSrc, $baseSrc);
	else
		$retSrc = $srcDb->SQLConnect($drvSrc, $srvSrc.":".$portSrc, $loginSrc, $pwdSrc, $baseSrc);

	if($typeDst=='mysql')
		$dstDb = new uifsqlDb();
	else
	{
		if($typeDst=='oracle')
			$ORACLE = 1;
		else
			$ORACLE = 0;
		$dstDb = new Db();
	}

	if($typeDst == 'mysql')
		$retDst = $dstDb->SQLConnect($srvDst.":".$portDst, $loginDst, $pwdDst, '');
	else
	{
		if($typeDst == 'mssql')
			$retDst = $dstDb->SQLConnect($drvDst, $srvDst.":".$drvDst, $loginDst, $pwdDst, '');
		else 
			$retDst = $dstDb->SQLConnect($drvDst, $srvDst.":".$portDst, $loginDst, $pwdDst, $baseDst); // la base doit déjà exister
	}
	$reponse = array();
	$reponse['return'] = 0;
	$reponse['msg'] ='';

	if($retSrc==0)
		$reponse['return']=1;
	else if($retDst==0)
		$reponse['return']=2;

	if($retSrc && $retDst && $test==false)
	{
		$res = createDB($dstDb, $baseDst, $loginSrc, $pwdSrc);

		if($res)
		{
			// on force la reconnexion sur cette nouvelle base
			// cas particulier ORACLE
			// on se connecte avec l'utilisateur créé précédemment (cf. Src)
			$dstDb->dbh = null;
			if($typeDst == 'oracle')
				$dstDb->SQLConnect($drvDst, $srvDst.":".$portDst, $loginSrc, $pwdSrc, $baseDst);
			else
				$dstDb->SQLSelectDatabase($baseDst);

				// Cas particulier ORACLE
				// création de la table SEQUENCES
				if($dstDb->TypeBase=='oracle')
				{
					$reqCreate = 'CREATE TABLE SEQUENCES (TABLE_NAME varchar2(64) NOT NULL,FIELD_NAME varchar2(64) NOT NULL,INIT_VALUE int NOT NULL)';
					$res = $dstDb->SQLQueryDirect($reqCreate, 5);
					$dstDb->SQLFermeQuery(5);                          
				}
				
				if(!$res)
				{
					$reponse['return'] = 4;
					$reponse['msg'] = $table;
					break;
				}

			// Dans l'ordre pour éviter les problèmes de contraintes : 
			//		Création des tables -> import des valeurs -> création des contraintes
			$secuSel = '"';
			if($srcDb->TypeBase=='mysql')
				$secuSel = '`';
			
			if($callback) $callback($cptCallback++);

			$tablesListSrc = getTables($srcDb);
			foreach($tablesListSrc as $table)
			{
				$champsListIns = '';
				$champsListSel = '';
				$champsListSrc = getColumns($srcDb, $table);
				$sep = '';
				$decl = '';
				$nbChamp = 0;
				$toConvert = NULL;
				$FlagAutoInc = 0;
				$tableSeq = '';
				$champSeq = '';
				$maxValSeq = 0;
				$tempValSeq = 0;
				$champDate = array();
				$j = 0;

				foreach($champsListSrc as $champ)
				{
					$secuIns = '';
					$champType = formatCreate($champ, $dstDb->TypeBase, $secuIns);
					$decl .= $sep.$champType;

					// cas particulier ORACLE : 
					// modification à la volée du type de colonne FCO_VALID (bgz4628)
					if($dstDb->TypeBase=='oracle')
					{
						if($champ['name']=='FCO_VALID')
						{
							$decl = str_replace('BLOB','CLOB',$decl);
						}
					}

					// si colonne date on flag les indices dans un tableau
					if($champ['date']==true)
					{
						array_push($champDate,$j);
					}
					$j=$j+1;
					
					// si colonne auto_increment(MySQL) ou identity(MsSQL)
					if($champ['autoincrement']==true)
					{
						// enregistre la présence d'une colonne de type AUTOINCREMENT
						$FlagAutoInc = 1;

						//MySQL auto_increment : l'exécution sera effectuée à la fin des insert
						if($dstDb->TypeBase=='mysql')
							$reqAutoInc = "ALTER TABLE ".$secuIns.$table.$secuIns." MODIFY $champType AUTO_INCREMENT PRIMARY KEY; ";
						//Oracle auto increment : pour insert dans la table SEQUENCES
						if($dstDb->TypeBase=='oracle')
						{
							$tableSeq = $table;
							$champSeq = $champ['name'];
						}
					}

					// pour chaque colonne
					if($champsListIns=='')
					{
						$champsListSel = $secuSel.$champ['name'].$secuSel;
						$champsListIns = $secuIns.$champ['name'].$secuIns;
					}
					else
					{
						$champsListSel .= ','.$secuSel.$champ['name'].$secuSel;
						$champsListIns .= ','.$secuIns.$champ['name'].$secuIns;
					}

					$toConvert[$nbChamp] = $champ['convert'];

					$nbChamp++;

					$sep = ',';
				}
				// creation des TABLES
                $test = $table;
				$reqCreate = 'CREATE TABLE '.$secuIns.$table.$secuIns.' ('.$decl.')';
				$res = $dstDb->SQLQuery($reqCreate, 5);
				$dstDb->SQLFermeQuery(5);

				if($res)
				{
					$dstDb->SQLCommit();
					$reqSelect = "SELECT $champsListSel FROM ".$secuSel.$table.$secuSel;
					$srcDb->SQLQuery($reqSelect, 5);
					
					if($callback) $callback($cptCallback++);

					// insertion des LIGNES entières
					while($row = $srcDb->SQLNextRow(5))
					{
						// Oracle  : récupération de la valeur max du champ auto-increment
						if($champSeq!='')
						{
							$tempValSeq = $row[$champSeq];
							if($tempValSeq > $maxValSeq)
								$maxValSeq = $tempValSeq;
						}

						$resOn  = NULL;
						$resOff = NULL;
						$resIns = NULL;
						$resAuto = NULL;
						$valuesList = '';

						for($i=0; $i<$nbChamp; $i++)
						{
							// scrute colonne type date
							$FlagDate = false;
							foreach($champDate as $cdate)
							{
								if($cdate == $i)
									$FlagDate = true;
							}
							if($valuesList!='')
								$valuesList .= ",";

							if($row[$i]===null)
								$valuesList .= "NULL";
							else
							{
								if($dstDb->TypeBase=='mssql')
								{
									if($row[$i] == '0000-00-00 00:00:00')
										$row[$i] = NULL;

									if($FlagDate  && $row[$i]!= NULL)
									{
										$temp = "CONVERT (datetime,'".$row[$i]."',120)";
										$row[$i]=$temp;
									}

									if($toConvert[$i])
										$valuesList .= "CONVERT(varbinary,'".dblQ($row[$i])."')";
									else
										if($FlagDate && $row[$i]!= NULL )
											$valuesList .= $row[$i]; // si date alors pas de dblQ pour avoir seulement des simples quotes 
										else
											$valuesList .= "'".dblQ($row[$i])."'";
								}
								if($dstDb->TypeBase=='oracle')
								{
									// Cas particulier sur la valeur des dates
									if($row[$i] == '0000-00-00 00:00:00')
										$row[$i] = NULL;
								  
									if($FlagDate && $row[$i]!= NULL )
									{
										$temp = "TIMESTAMP '".$row[$i]."'";
										$row[$i] = $temp;
									}

									// Cas particulier sur les colonnes de type BLOB
									// BG : 20-12-2012: temporairement la colonne FCO_VALID de la table FLOWCONF est mis à vide 
									// il reste des problèmes de conversion avec la fct "RAWTOHEX" pour le type BLOB
									// certains caractères ne sont pas interprétés correctement.
									// BG : 29-01-2013 : ORACLE : la variable $champ['convert']' reste à TRUE pour FCO_VALID
									if($toConvert[$i]) 
									{
										if($table == 'FLOWCONF')
										{
											$valuesList .= "''";
										}
										else
										{
											$valuesList .= "RAWTOHEX('".dblQ($row[$i])."')";
										}
									}
									else
										if($FlagDate && $row[$i]!= NULL )
											$valuesList .= $row[$i]; // si date alors pas de dblQ pour avoir seulement des simples quotes 
										else
											$valuesList .= "'".dblQ($row[$i])."'";
								}
								if($dstDb->TypeBase=='mysql') // TO DO  si besoin futur
								{
									$valuesList .= "'".dblQ($row[$i])."'";
								}
							}
						}

						if($callback) $callback($cptCallback++);

						// cas particulier MsSQL
						// BG : on debloque le verrou sur la colonne identity, on fait l'insert, on recré le verrou
						if($dstDb->TypeBase=='mssql')
						{
							if($FlagAutoInc) // si la table possède une colonne identity
							{
								$reqOn  = "SET IDENTITY_INSERT ".$secuIns.$table.$secuIns." ON";
								$resOn = $dstDb->SQLQuery($reqOn, 6);
							}
							
							$reqIns = "INSERT INTO ".$secuIns.$table.$secuIns." ($champsListIns) VALUES ($valuesList)";
							$resIns = $dstDb->SQLQuery($reqIns, 6);

							if($FlagAutoInc) // si la table possède une colonne identity
							{
								$reqOff = "SET IDENTITY_INSERT ".$secuIns.$table.$secuIns." OFF";
								$resOff = $dstDb->SQLQuery($reqOff, 6);
							}
							
							$dstDb->SQLFermeQuery(6);
						}
						else
						{
							$reqIns = "INSERT INTO ".$secuIns.$table.$secuIns." ($champsListIns) VALUES ($valuesList)";
							$resIns = $dstDb->SQLQuery($reqIns, 6);
							$dstDb->SQLFermeQuery(6);
						}
						if(!$resIns)
						{
							$reponse['return'] = 10;
							$reponse['msg'] = $table;
							break;
						}
					}
					// cas particulier MySQL
					// on ajoute auto_increment/primary key à la colonne àprès les insert
					if($FlagAutoInc)
					{
						if($dstDb->TypeBase=='mysql')
						{
							$resAuto = $dstDb->SQLQuery($reqAutoInc, 10);
							$dstDb->SQLFermeQuery(10);

							if(!$resAuto)
							{
								$reponse['return'] = 10;
								$reponse['msg'] = $table;
								break;
							}
						}
					}
				}
				else
				{
					$reponse['return'] = 4;
					$reponse['msg'] = $table;
					break;
				}

				// Cas particulier Oracle : Table SEQUENCES
				if($dstDb->TypeBase=='oracle')
				{
					if($FlagAutoInc)
					{
						$startValSeq = (int)($maxValSeq + 1);
						$reqInsSeq = "INSERT INTO SEQUENCES (TABLE_NAME,FIELD_NAME,INIT_VALUE) VALUES ('".$tableSeq."','".$champSeq."',0)";
						$reqCreSeq = "CREATE SEQUENCE ".$tableSeq."_SEQ INCREMENT BY 1 START WITH ".$startValSeq;
						$resInsSeq = $dstDb->SQLQueryDirect($reqInsSeq, 6);
						$resCreSeq = $dstDb->SQLQueryDirect($reqCreSeq, 6);
						$dstDb->SQLFermeQuery(6);

						if(!$resInsSeq || !$resCreSeq)
						{
							$reponse['return'] = 4;
							$reponse['msg'] = $tableSeq;
							return ($reponse);
							break;
						}
					}
				}
				if($reponse['return']!=0)
					break;
			}

			if($reponse['return']==0) // pas eu d'erreur
			{
				// Index   
				foreach($tablesListSrc as $table)
				{
					// Index
					$indexList = getIndexes($srcDb, $table);

					foreach($indexList as $index)
					{
						if($callback) $callback($cptCallback++);

						// cas particulier : 
						// MySQL : une contrainte PRIMARY crée aussi un index
						// Inutile de le créer sous MySQL et aucune raison d'exister sous MsSQL et ORACLE
						if(strtolower($index['name'])=='primary')
							continue;

						// on ajoute le nom de la table pour différencier les index
						$index['name'] = $index['name']."_".$table;
						if(strlen($index['name']) > 30)
						{
							$temp = $index['name'];
							$index['name'] = substr($temp,0,29);
						}

						$is_unique ='';
						if($index['is_unique']==1)
							$is_unique = 'UNIQUE';

						// cas particulier ORACLE
						// la création d'index unique ne sait pas gérer les valeurs multiples NULL et renvoie une erreur SQL
						// duplicate value violation ... qui ne permet pas de valider la création (bgz 5055)
						// le remède : la commande NVL qui remplace les 'null' par une autre valeur:
                        if($dstDb->TypeBase=='oracle')
                        {
                            if($index['is_unique']==1)
                            {
								
                                $uniqChamp = $index['col'];						
                                $uniqChampSplit = split(',',$uniqChamp);
                                $nbUniq = count($uniqChampSplit)-1;
								
								// on rajoute la fonction miracle NVL
								$index['col'] = "NVL(".$uniqChampSplit[0].",'')";
									
                                if($nbUniq>0)
                                {
                                    for ($i=1; $i<=$nbUniq; $i++)
										$index['col'] .= ", NVL(".$uniqChampSplit[$i].",'')";
                                }
                            }
                        }	
							
						$req = "CREATE $is_unique INDEX ".$secuIns.$index['name'].$secuIns.' ON '.$secuIns.$table.$secuIns.' ('.$index['col'].')';
                        
                        // Cas particulier SQL server
                        // gestion du caractère NULL pour ne pas être inclus dans les contraintes d'unicité
                        if($dstDb->TypeBase=='mssql')
                        {
                            $whereUniq = '';
                            if($index['is_unique']==1)
                            {
                                $uniqChamp = $index['col'];						
                                $uniqChampSplit = split(',',$uniqChamp);
                                $whereUniq = ' WHERE '.$uniqChampSplit[0].' IS NOT NULL';
                                $nbUniq = count($uniqChampSplit)-1;
                                if($nbUniq>0)
                                {
                                    for ($i=1; $i<=$nbUniq; $i++)
                                        $whereUniq .= ' AND '.$uniqChampSplit[$i].' IS NOT NULL';
                                }
                                $req .= $whereUniq;
                            }
                        }
                        
						$res = $dstDb->SQLQuery($req, 5);
						$dstDb->SQLFermeQuery(5);
						if(!$res)
						{
							$reponse['return'] = 7;
							$reponse['msg'] = $table;
							break;
						}
					}
					if(!$res) // Erreur sur le create index
						break;
				} // fin index
			}

			if($reponse['return']==0) // pas eu d'erreur
			{
				// Contraintes 
				// P : PrimaryKey, R : ForeignKey, U : UniqueKey
				$typeKey = array('P','R','U');
				foreach($typeKey as $tk)
				{                        
					foreach($tablesListSrc as $table)
					{
						$constraintList = getConstraints($srcDb, $table, $tk, $secuIns);
						foreach($constraintList as $constraint)
						{
							if($callback) $callback($cptCallback++);

							$req = 'ALTER TABLE '.$secuIns.$table.$secuIns.' ADD CONSTRAINT ';
							if($constraint['type']=='P')
							{
								// cas particulier MySQL
								if($dstDb->TypeBase=='mysql')
								{
									// auto_increment : la contrainte PRIMARY KEY est déclarée lors de la création de la table
									if(isAutoIncrement($dstDb, $table, trim($constraint['col'], $secuIns)))
										continue;
									else // sous MySQL la contrainte PRIMARY KEY ne doit pas être nommée
										$req .= 'PRIMARY KEY ('.$constraint['col'].')';
								}
								else
								{
									// cas particulier MySQL : on nomme les contraintes PK car pas de nom spécifié sous MySQL
									if($srcDb->TypeBase=='mysql')
									{
										$constraint['name'] = "PK_".$table;
									}
									$req .= $constraint['name'].' PRIMARY KEY ('.$constraint['col'].')';
								}
							}
							else if($constraint['type']=='R')
							{
								$req .= $constraint['name'].' FOREIGN KEY ('.$constraint['col'].') REFERENCES '.strtoupper($constraint['ref_table']).'('.$constraint['ref_col'].')';
							}
							else if($constraint['type']=='U')
							{
								$req .= $constraint['name'].' UNIQUE ('.$constraint['col'].')';
							}
							$res = $dstDb->SQLQuery($req, 5);
							$dstDb->SQLFermeQuery(5);
							if(!$res)
							{
								$reponse['return'] = 6;
								$reponse['msg'] = $table;
								break;
							}
						}
						if(!$res) // Erreur sur le alter table
							break;
					}
					if(!$res) // Erreur
						break;
				}// fin contrainte
			}
			
			// Procédures
			if($reponse['return']==0)
			{
				$bPart = (getProcedureText($srcDb, 'REBUILD_PART_TREE')!=null);
				$reponse = createProcedures($dstDb, $bPart);

				$req = "COMMIT";
				$res = $dstDb->SQLQuery($req, 5);
				$dstDb->SQLFermeQuery(5);
			}
			
			// drop tables "journal" et "key" générées au démarrage de flowmf
			$req = 'drop table "JOURNAL"';
			$res = $dstDb->SQLQuery($req, 5);
			$dstDb->SQLFermeQuery(5);    
			$req = 'drop table "KEY"';
			$res = $dstDb->SQLQuery($req, 5);
			$dstDb->SQLFermeQuery(5);            	
			if(!$res) // Erreur sur le drop table
				break;			
		}
		else
			$reponse['return'] = 3;

		if($reponse['return']==0 && !$res)
			$reponse['return'] = 9;
	}
	return $reponse;
}
?>