<?php
if ((!isset($restore)) || ($restore != 1))
	$DEFAULT_PATH = "../../../../";

require_once ($DEFAULT_PATH."XPath.class.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once ($DEFAULT_PATH."struct.php");

$droitRole = SAD; 
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");

require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template

$page_courante = "flux/avance/import/flux_import/flux_importAction.php";

$action		 = pget('action');			// action
$import_chem = pget('import_chem');		// chemin du xml a importer
$id_clt	     = pget("id_clt");          // id client
$liste 	     = pget("liste");

// L'execution de ce script ne doit pas etre stoppe par le timeout php
set_time_limit(0);

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = 0;
$export_version = 300000;

// Indique si la liste chainee doit etre regeneree
$need_rebuild = false;

if ($action=='verif')
{
	if (!(is_readable($import_chem))) 
	{
		$msg = $lang_flux_av_imp_flux_act_msg_err_ouv_fic.$import_chem;
		$return = 1;
	}
	else
	{
		if (!($xp = new XPath($import_chem)))
		{
			$msg = $lang_flux_av_imp_flux_act_msg_err_no_xpath;
			$return = 1;
		}
			
		if ($xp->evaluate("EXPORT_FLUX/VERSION_BASE"))
		{
			$VERSION_BASE_XML=$xp->getData("EXPORT_FLUX/VERSION_BASE");
			$req = "SELECT FCO_VERSION FROM FLOWCONF";
			$gDb->SQLQuery($req,1);
			$base = $gDb->SQLNextRow(1);
			$VERSION_BASE_FCO=$base['FCO_VERSION'];
			if ($VERSION_BASE_XML>$VERSION_BASE_FCO)
			{
				$msg = str_replace("%DBNOM%",$VERSION_BASE_FCO,$lang_flux_av_imp_flux_act_msg_err_wrong_version);
				$msg =  str_replace("%NUMVER%",$VERSION_BASE_XML,$msg);
				$return = 1;
			}
		}
	}
} // fin if ($action=='verif')

if ($action=='import_flux')
{
	function version_to_int($version)
    {
        $i_ver = str_replace(".", "", $version);
        if (strlen($i_ver) == 1) $i_ver .= "00";
        else if (strlen($i_ver) == 2) $i_ver .= "0";
        return $i_ver;
    }
	
	function remplaceInverse($monChamp)
	{ 
		$monChamp=@str_replace("&gt;",">",$monChamp);
		$monChamp=@str_replace("&lt;","<",$monChamp);
		$monChamp=@str_replace("&amp;","&",$monChamp);
		return $monChamp;
	}
		
	function parse_xml($nbreFlux)
	{
		global $xp;
		global $parse_xml;
		$cpt=1;
		while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/PAR_NOM"))
		{
			$PAR_NOM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/PAR_NOM");
			$type = $xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/PAR_TYPE");
			$grp = $xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/GRP_ID");
			$id = $xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/PAR_ID");
			$parse_xml[$cpt]['PAR_NOM']=$PAR_NOM;
			$parse_xml[$cpt]['PAR_TYPE']=$type;
			$parse_xml[$cpt]['GRP_ID']=$grp;
			$parse_xml[$cpt]['PAR_ID']=$id;
			$cpt++;
		}
		return true;
	}

	function insert_part($id_part, $fils_de, $type_part, $nbreFlux)
	{
	
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $PAR_EMET_ID;
		global $PAR_DEST_ID;
		global $parse_xml;
		global $cpt;
		global $lang_flux_av_imp_flux_act_lbl_part;
		global $lang_flux_av_imp_flux_act_insert_msg_err_dup;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $need_rebuild;
		
		$cpt=1;

		while ($parse_xml[$cpt]['PAR_ID'] != $id_part)
		{
			$cpt++;
			if ($cpt==30000) break; // securite au cas ou
		}
		$req="SELECT PAR_ID, GRP_ID from PART WHERE PAR_NOM='".dblQ(remplaceInverse($parse_xml[$cpt]['PAR_NOM']))."' and CLT_ID=$id_clt ";
		$gDb->SQLQuery($req,1);
		$nbrPart = $gDb->SQLNextRow(1);	
		if ($nbrPart[0]>0)
		{
			$msg.= $lang_flux_av_imp_flux_act_lbl_part.remplaceInverse(hi_disp($parse_xml[$cpt]['PAR_NOM'])).$lang_flux_av_imp_flux_act_insert_msg_err_dup."<br/>";
			if (!$nbrPart['GRP_ID'])
			{
				$req = "update PART set GRP_ID = ".$fils_de." where PAR_ID = ".$nbrPart['PAR_ID'];
				$res=$gDb->SQLQuery($req, 1);
				$need_rebuild = true;
			}
			if ($type_part=='emet')
				$PAR_EMET_ID=$nbrPart['PAR_ID'];
			if ($type_part=='dest')
				$PAR_DEST_ID=$nbrPart['PAR_ID'];
			return true;
		}
			
		$req="INSERT INTO PART (PAR_NOM, CLT_ID, PAR_TYPE, PAR_ETAT, GRP_ID ) VALUES
				('".dblQ(remplaceInverse($parse_xml[$cpt]['PAR_NOM']))."', $id_clt, 
				".$parse_xml[$cpt]['PAR_TYPE'].",
				".ETAT_ACTIF." , 
				".$fils_de." )";
		$res=$gDb->SQLQuery($req, 1);
		$need_rebuild = true;
		$tmpLastId = $gDb->SQLlastID();
		if ($type_part=='emet')
			$PAR_EMET_ID=$tmpLastId;
		if ($type_part=='dest')
			$PAR_DEST_ID=$tmpLastId;
		$pere=$tmpLastId;
				
		if ($res==null)
		{
			$transaction=false;
			$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_part.remplaceInverse($PAR_NOM)."<br/>";
			return false;
		}
		if (!(insert_ident($nbreFlux, $id_part, $pere)))
			return false;
		if (!(insert_adr($nbreFlux, $id_part, $pere)))
			return false;
		if (!(insert_demat($nbreFlux, $id_part, $pere)))
			return false;
			
		$k=1;
		$pos=1;
		if ($parse_xml[$cpt]['PAR_TYPE'] == PART_TYPE_GROUPE)
		{
			while ($parse_xml[$k]['PAR_ID'] != null)
			{
				if ($parse_xml[$k]['GRP_ID'] == $id_part)
				{
					if (!$tableauFils[0])
						$tableauFils[0]=$parse_xml[$k]['PAR_ID'];
					elseif (array_search($parse_xml[$k]['PAR_ID'],$tableauFils,false)===false)
					{
						$tableauFils[$pos]=$parse_xml[$k]['PAR_ID'];
						$pos++;
					}
				}
				$k++;
			}
			for ($i=0; $i<=$pos;$i++)
			{
				if ($tableauFils[$i])
					if (!(insert_part($tableauFils[$i], $pere, 'non', $nbreFlux)))
						return false;
			}
		}	
		return true;
	}
	
	function insert_ident($nbreFlux, $id_part, $PAR_ID)
		{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $cpt;
		global $lang_flux_av_imp_flux_act_insert_msg_err_dup;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_av_imp_flux_act_lbl_id;
		
		
		$nbreIdent=1;
		while($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/ident[$nbreIdent]/IDE_VAL"))
		{
			$val=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/ident[$nbreIdent]/IDE_VAL");
			$pwd=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/ident[$nbreIdent]/IDE_PWD");
			
			$req="SELECT IDE_ID from IDENT WHERE IDE_VAL='".dblQ(remplaceInverse($val))."' and CLT_ID=$id_clt ";
			$gDb->SQLQuery($req,1);
			$nbrId = $gDb->SQLNextRow(1);	
			if ($nbrId[0]>0)
			{
				$msg.= remplaceInverse(hi_disp($val)).$lang_flux_av_imp_flux_act_insert_msg_err_dup."<br/>";
			}
			else
			{
				$req="INSERT INTO IDENT (PAR_ID, CLT_ID, IDE_VAL, IDE_PWD) VALUES 
						($PAR_ID, $id_clt, 
						'".dblQ(remplaceInverse($val))."', '".dblQ(remplaceInverse($pwd))."')";
				$res=$gDb->SQLQuery($req, 1);
				if ($res==null)
				{
					$transaction=false;
					$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_id.remplaceInverse($val)."<br/>";
					return false;
				}
			}
			$nbreIdent++;
		}	
		return true;
	}
	
	function insert_adr($nbreFlux, $id_part, $PAR_ID)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $cpt;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_av_imp_flux_act_lbl_pfl_id;
		global $lang_flux_av_imp_flux_act_lbl_adr;
		global $lang_flux_av_imp_flux_act_lbl_val_par_adr;
		
		
		$nbreAdr=1;
		while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/adresse[$nbreAdr]/ADR_ID"))
		{
			$PFL_ID =$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/adresse[$nbreAdr]/val_par_adr[1]/PFL_ID");
			$req="SELECT PFL_ID from PAR_FLOW WHERE PFL_ID=".dblQ(remplaceInverse($PFL_ID));
			$gDb->SQLQuery($req,1);
			$r= $gDb->SQLNextRow(1);	
			if ($r['PFL_ID']!=$PFL_ID)
			{
				$msg.= $lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_pfl_id.remplaceInverse($PFL_ID)."<br/>";
				$transaction=false;
				return false;
			}
			else
			{
				$adr_type =$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/adresse[$nbreAdr]/ADR_TYPE");
				$req="INSERT INTO ADRESSE (PAR_ID, CLT_ID, ADR_TYPE ) VALUES 
					($PAR_ID, $id_clt, 
					".dblQ(remplaceInverse($adr_type)).")";
				$res=$gDb->SQLQuery($req, 1);
				$ADR_ID=$gDb->SQLlastID();
				if ($res==null)
				{
					$transaction=false;
					$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_adr."<br/>";
					return false;
				}
				$nbreVal=1;
				while($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/adresse[$nbreAdr]/val_par_adr[$nbreVal]/PFL_ID"))
				{
					$PFL_ID =$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/adresse[$nbreAdr]/val_par_adr[$nbreVal]/PFL_ID");
					$VPA_VAL =$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/adresse[$nbreAdr]/val_par_adr[$nbreVal]/VPA_VAL");
					$req="INSERT INTO VAL_PAR_ADR (CLT_ID, ADR_ID, PFL_ID, VPA_VAL ) VALUES
						( $id_clt, $ADR_ID, 
						".dblQ(remplaceInverse($PFL_ID)).",
						'".dblQ(remplaceInverse($VPA_VAL))."')";
					$res=$gDb->SQLQuery($req, 1);
					if ($res==null)
					{
						$transaction=false;
						$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_val_par_adr."<br/>";
						return false;
					}
					$nbreVal++;
				}
			}
			$nbreAdr++;
		}
		return true;
	}	
	
	function insert_demat($nbreFlux, $id_part, $PAR_ID)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $cpt;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_av_imp_flux_act_lbl_demat;
		
		if($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_NOM_ARCH"))
		{
			$PAD_NOM_ARCH=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_NOM_ARCH");
			$PAD_NUM_ARCH=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_NUM_ARCH");
			$PAD_CHEM_ARCH=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_CHEM_ARCH");
			$PAD_CHEM_ARCH_MOT=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_CHEM_ARCH_MOT");
			$PAD_DATE_CREAT_ARCH=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_DATE_CREAT_ARCH");
			$PAD_TAILLE_ARCH=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_TAILLE_ARCH");
			$PAD_DELAI_CLOT_ARCH=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_liste/part_$cpt/part_demat/PAD_DELAI_CLOT_ARCH");
			$req="INSERT INTO PART_DEMAT (PAR_ID, CLT_ID, PAD_NOM_ARCH, PAD_NUM_ARCH, PAD_CHEM_ARCH, PAD_CHEM_ARCH_MOT, PAD_DATE_CREAT_ARCH, PAD_TAILLE_ARCH, PAD_DELAI_CLOT_ARCH ) VALUES
						($PAR_ID, $id_clt, 
						'".dblQ(remplaceInverse($PAD_NOM_ARCH))."',
						".dblQ(remplaceInverse($PAD_NUM_ARCH)).",
						'".dblQ(remplaceInverse($PAD_CHEM_ARCH))."',
						'".dblQ(remplaceInverse($PAD_CHEM_ARCH_MOT))."',
						'".dblQ(remplaceInverse($PAD_DATE_CREAT_ARCH))."',
						".dblQ(remplaceInverse($PAD_TAILLE_ARCH)).",
						".dblQ(remplaceInverse($PAD_DELAI_CLOT_ARCH)).")";
			$res=$gDb->SQLQuery($req, 1);
			if ($res==null)
			{
				$transaction=false;
				$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_demat.remplaceInverse($PAD_NOM_ARCH)."<br/>";
				return false;
			}
		}
		return true;
	}	
		
	function insert_flux($nbreFlux)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $PAR_EMET_ID;
		global $PAR_DEST_ID;
		global $FOR_ID;
		global $FLX_ID;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_av_imp_flux_act_lbl_flux;
		global $export_version;
		
		$FLX_ACTIF=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_ACTIF");
		$FLX_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_LIBEL");
		$FLX_SENS=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_SENS");
		$FLX_TRACE=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_TRACE");
		$FLX_TEST=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_TEST");
		$FLX_SIMUL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_SIMUL");
		$FLX_SUPPR_FIC=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_SUPPR_FIC");
		$FLX_ETAT=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_ETAT");
		$FLX_COLLECTE=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_COLLECTE");
        if ($export_version < 400)
        {
            $FLX_LOG="0";
            $FLX_LOG_DETAIL="0";
        }
        else
        {
            $FLX_LOG=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_LOG");
            $FLX_LOG_DETAIL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_LOG_DETAIL");
        }
		if ($export_version < 410)
        {
            $FLX_PRESENTATION="0";
        }
		else
		{
            $FLX_PRESENTATION=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_PRESENTATION");
		}
        if ($export_version < 420)
        {
            $FLX_MULTIMOTEURS="0";
        }
        else
        {
            $FLX_MULTIMOTEURS=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_MULTIMOTEURS");
        }
		
		if ($export_version < 500)
        {
			$FLX_COULEUR = null;
        }
		else
		{
			$FLX_COULEUR = $xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_COULEUR");
		}
		
		// Dernier rang ?
		$req = "SELECT MAX(FLX_RANG) AS MAXRANG FROM FLUX";
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		$new_rang = intval($row['MAXRANG']) + 1;
		$gDb->SQLFermeQuery(1);
		
		$req="SELECT TAL_ID from TYP_ALERTE WHERE TAL_PRINCIPAL=".TAL_PRINCIPAL_OUI." and CLT_ID=$id_clt and TAL_TYPE=".ALT_TYPE_APPLI;
		$gDb->SQLQuery($req,1);
		$TAL_ID = $gDb->SQLNextRow(1);	
		$req="INSERT INTO FLUX (CLT_ID, FLX_ACTIF, FLX_LIBEL, PAR_EMET_ID, PAR_DEST_ID, FOR_ID, FLX_SENS, FLX_TRACE, FLX_TEST, FLX_SIMUL, FLX_SUPPR_FIC, TAL_ID, FLX_ETAT, FLX_COLLECTE, FLX_LOG, FLX_LOG_DETAIL, FLX_PRESENTATION, FLX_MULTIMOTEURS, FLX_COULEUR, FLX_RANG ) VALUES 
						($id_clt, 
						".dblQ(remplaceInverse($FLX_ACTIF)).",
						'".dblQ(remplaceInverse($FLX_LIBEL))."',
						$PAR_EMET_ID, $PAR_DEST_ID,
						".$FOR_ID.",
						".dblQ(remplaceInverse($FLX_SENS)).",
						".dblQ(remplaceInverse($FLX_TRACE)).",
						".dblQ(remplaceInverse($FLX_TEST)).",
						".dblQ(remplaceInverse($FLX_SIMUL)).",
						".dblQ(remplaceInverse($FLX_SUPPR_FIC)).",
						".$TAL_ID['TAL_ID'].",
						".dblQ(remplaceInverse($FLX_ETAT)).",
						".dblQ(remplaceInverse($FLX_COLLECTE)).",
                        ".dblQ(remplaceInverse($FLX_LOG)).",
                        ".dblQ(remplaceInverse($FLX_LOG_DETAIL)).",
                        ".dblQ(remplaceInverse($FLX_PRESENTATION)).",
                        ".dblQ(remplaceInverse($FLX_MULTIMOTEURS)).",
						'".dblQ(remplaceInverse($FLX_COULEUR))."',
						".dblQ(remplaceInverse($new_rang)).")";
						
		$res=$gDb->SQLQuery($req, 1);
		$FLX_ID=$gDb->SQLlastID();
		if ($res==null) 
		{
			$transaction=false;
			$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_flux.remplaceInverse($FLX_LIBEL)."<br/>";
			return false;
		}
			return true;
	}

	function insert_part_to_part($nbreFlux)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $PAR_EMET_ID;
		global $PAR_DEST_ID;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		$nbrePTP=1;
		
		while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/part_to_part[$nbrePTP]/PTP_STATUT"))
		{
			$PTP_STATUT=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_to_part[$nbrePTP]/PTP_STATUT");
			if ($PTP_STATUT)
			{
				$PTP_DATE_ENTREE=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_to_part[$nbrePTP]/PTP_DATE_ENTREE");
				$PTP_DATE_SORTIE=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_to_part[$nbrePTP]/PTP_DATE_SORTIE");
				$PTP_HISTO=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/part_to_part[$nbrePTP]/PTP_HISTO");
				
				$req="INSERT INTO PART_TO_PART (PTP_EMET_ID, PTP_DEST_ID, PTP_STATUT, PTP_DATE_ENTREE, PTP_DATE_SORTIE, 
						PTP_HISTO, CLT_ID) VALUES 
						(
						$PAR_EMET_ID, $PAR_DEST_ID,
						".dblQ(remplaceInverse($PTP_STATUT)).",
						'".dblQ(remplaceInverse($PTP_DATE_ENTREE))."',
						'".dblQ(remplaceInverse($PTP_DATE_SORTIE))."',
						".dblQ(remplaceInverse($PTP_HISTO)).",
						".$id_clt.")";
						
				$res=$gDb->SQLQuery($req, 1);
				if ($res==null)
				{
					$transaction=false;
					$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$PAR_EMET_ID.", ".$PAR_DEST_ID."<br/>";
					return false;
				}
			}
			$nbrePTP++;
		}
		return true;
	}
		
	function insert_planif($nbreFlux)
	{
		global $ini_typeBase;
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_gest_aff_lbl_planif;
		global $FLX_ID;
		$PLA_ID=$xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_ID");
		if ($PLA_ID)
		{
			$PLA_ACTIF=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_ACTIF");
			$PLA_MOIS=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_MOIS");
			$PLA_JOUR=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_JOUR");
			$PLA_JOURSEM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_JOURSEM");
			$PLA_HEURE=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_HEURE");
			$PLA_MINUTE=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_MINUTE");
			$PLA_DELAIDEM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_DELAIDEM");
			$PLA_DATEDER=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_DATEDER");
			// MMM MM 05/04/2005
			//$PLA_IMMEDIAT=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/planif/PLA_IMMEDIAT");
			//if (! $PLA_IMMEDIAT) $PLA_IMMEDIAT=0;
			
			if($ini_typeBase != 'oracle')
				$req="INSERT INTO PLANIF (CLT_ID, FLX_ID, PLA_ACTIF, PLA_MOIS, PLA_JOUR, PLA_JOURSEM, 
					PLA_HEURE, PLA_MINUTE, PLA_DELAIDEM, PLA_DATEDER, PLA_IMMEDIAT) VALUES 
						($id_clt, 
						".$FLX_ID.",
						".dblQ(remplaceInverse($PLA_ACTIF)).",
						'".dblQ(remplaceInverse($PLA_MOIS))."',
						'".dblQ(remplaceInverse($PLA_JOUR))."',
						'".dblQ(remplaceInverse($PLA_JOURSEM))."',
						'".dblQ(remplaceInverse($PLA_HEURE))."',
						'".dblQ(remplaceInverse($PLA_MINUTE))."',
						".dblQ(remplaceInverse($PLA_DELAIDEM)).",
						'".dblQ(remplaceInverse($PLA_DATEDER))."',
						0)";
			else
				$req="INSERT INTO PLANIF (CLT_ID, FLX_ID, PLA_ACTIF, PLA_MOIS, PLA_JOUR, PLA_JOURSEM, 
					PLA_HEURE, PLA_MINUTE, PLA_DELAIDEM, PLA_DATEDER, PLA_IMMEDIAT) VALUES 
						($id_clt, 
						".$FLX_ID.",
						".dblQ(remplaceInverse($PLA_ACTIF)).",
						'".dblQ(remplaceInverse($PLA_MOIS))."',
						'".dblQ(remplaceInverse($PLA_JOUR))."',
						'".dblQ(remplaceInverse($PLA_JOURSEM))."',
						'".dblQ(remplaceInverse($PLA_HEURE))."',
						'".dblQ(remplaceInverse($PLA_MINUTE))."',
						".dblQ(remplaceInverse($PLA_DELAIDEM)).",
						TO_DATE('".dblQ(remplaceInverse($PLA_DATEDER))."','YYYY/MM/DD HH24:MI:SS'),
						0)";
			
			$res=$gDb->SQLQuery($req, 1);
			if ($res==null)
			{
				$transaction=false;
				$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_gest_aff_lbl_planif.remplaceInverse($FLX_LIBEL)."<br/>";
				return false;
			}
		}
		return true;
	}

	function insert_par_gen($nbreFlux,$nbreACTFLUX, $nbrePARGEN)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_av_imp_flux_act_lbl_tpg_num;
		global $lang_flux_av_imp_flux_act_lbl_par_gen;
		global $PGE_ID;
		
		$PGE_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/PGE_LIBEL");			
		$TPG_NUM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/TPG_NUM");
		$PGE_ETAT=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/PGE_ETAT");
		$req="SELECT TPG_NUM from TYP_PAR_GEN WHERE TPG_NUM=".dblQ(remplaceInverse($TPG_NUM));
		$gDb->SQLQuery($req,1);
		$r= $gDb->SQLNextRow(1);	
		if ($r['TPG_NUM']!=$TPG_NUM)
		{
			$msg.= $lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_tpg_num.remplaceInverse($TPG_NUM)."<br/>";
			$transaction=false;
			return false;
		}
		else
		{
			$req="INSERT INTO PAR_GEN (CLT_ID, PGE_ETAT, TPG_NUM, PGE_LIBEL ) VALUES 
						($id_clt, 
						".dblQ(remplaceInverse($PGE_ETAT)).",
						".dblQ(remplaceInverse($TPG_NUM)).",
						'".dblQ(remplaceInverse($PGE_LIBEL))."')";
			$res=$gDb->SQLQuery($req, 1);
			$PGE_ID=$gDb->SQLlastID();
			if ($res==null)
			{
				$transaction=false;
				$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_par_gen.remplaceInverse($PGE_LIBEL)."<br/>";
				return false;
			}
			else
			{
				// on insert les val_par_gen
				if (!(insert_val_par_gen($nbreFlux,$nbreACTFLUX,$PGE_ID, $nbrePARGEN)))
					return false;
			}
		}
		return true;
	}	
		
	function insert_val_par_gen($nbreFlux,$nbreACTFLUX,$PGE_ID, $nbrePARGEN)	
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $lang_flux_av_imp_flux_act_lbl_pfl_id;
		global $lang_flux_av_imp_flux_act_lbl_val_par_gen;
		$nbreVAL_PARGEN=1;
		while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/val_par_gen[$nbreVAL_PARGEN]/VPG_VAL"))
		{
			$VPG_VAL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/val_par_gen[$nbreVAL_PARGEN]/VPG_VAL");
			$PFL_ID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/val_par_gen[$nbreVAL_PARGEN]/PFL_ID");
			$req="SELECT PFL_ID from PAR_FLOW WHERE PFL_ID=".dblQ(remplaceInverse($PFL_ID));
			$gDb->SQLQuery($req,1);
			$r= $gDb->SQLNextRow(1);	
			if ($r['PFL_ID']!=$PFL_ID)
			{
				$msg.= $lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_pfl_id.remplaceInverse($PFL_ID)."<br/>";
				$transaction=false;
				return false;
			}
			else
			{
				/*****************************/
				/* traitement des val_par_gen*/
				/*****************************/
				$req="INSERT INTO VAL_PAR_GEN (CLT_ID, PGE_ID, PFL_ID, VPG_VAL ) VALUES 
						($id_clt, 
						".$PGE_ID.",
						".$PFL_ID.",
						'".dblQ(remplaceInverse($VPG_VAL))."')";
				$res=$gDb->SQLQuery($req, 1);
				if ($res==null)
				{
					$transaction=false;
					$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_val_par_gen.remplaceInverse($VPG_VAL)."<br/>";
					return false;
				}
			}
			$nbreVAL_PARGEN++;
		}
		return true;
	}
	
	function insert_act($nbreFlux,$nbreACTFLUX)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $lang_flux_av_imp_flux_act_insert_msg_err; 
		global $lang_flux_av_imp_flux_act_lbl_tac_num;
		global $lang_flux_av_imp_flux_act_lbl_act;
		global $lang_flux_av_imp_flux_act_insert_msg_err_dup;
		global $ACT_ID;
		$ACT_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/ACT_LIBEL");			
		$TAC_NUM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/TAC_NUM");
		$ACT_ETAT=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/ACT_ETAT");
		$ACT_NUMPROC=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/ACT_NUMPROC");
		$req="SELECT TAC_NUM from TYPE_ACT WHERE TAC_NUM=".dblQ(remplaceInverse($TAC_NUM));
		$gDb->SQLQuery($req,1);
		$r= $gDb->SQLNextRow(1);
		if ($r['TAC_NUM']!=$TAC_NUM)
		{
			$msg.= $lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_tac_num.remplaceInverse($TAC_NUM)."<br/>";
			$transaction=false;
			return false;
		}
		else
		{
			$req="SELECT TAC_NUM from ACTIVITE WHERE TAC_NUM=".dblQ(remplaceInverse($TAC_NUM));
			$gDb->SQLQuery($req,1);
			$r= $gDb->SQLNextRow(1);
			if ($r['TAC_NUM']!=$TAC_NUM)
			{
				$req="INSERT INTO ACTIVITE (CLT_ID, ACT_ETAT, TAC_NUM, ACT_LIBEL, ACT_NUMPROC ) VALUES 
							($id_clt, 
							".dblQ(remplaceInverse($ACT_ETAT)).",
							".dblQ(remplaceInverse($TAC_NUM)).",
							'".dblQ(remplaceInverse($ACT_LIBEL))."',
							".dblQ(remplaceInverse($ACT_NUMPROC)).")";
				$res=$gDb->SQLQuery($req, 1);
				$ACT_ID=$gDb->SQLlastID();
				if ($res==null)
				{
					$transaction=false;
					$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_act.remplaceInverse($ACT_LIBEL)."<br/>";
					return false;
				}
			}
			$msg.= $lang_flux_av_imp_flux_act_lbl_act.remplaceInverse($ACT_LIBEL).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'<br/>';
		}
		return true;
	}	

	function insert_actflux($nbreFlux,$nbreACTFLUX)
	{
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $lang_flux_av_imp_flux_act_insert_msg_err;
		global $PGE_ID;
		//global $AFX_ID;
		global $ACT_ID;
		global $FLX_ID;
		global $tabCorresAFX_ID; // pour mettre les amcros avec le bon AFX_ID
        global $export_version;
		
		$AFX_ACTIF=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_ACTIF");		
		$AFX_ID_old=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_ID");			
		$AFX_NUM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_NUM");
		$AFX_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_LIBEL");
		$AFX_SUIVI=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_SUIVI");
		$testPGE_ID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/PGE_ID");
		if ($testPGE_ID)
			$valPGE_ID=dblQ(remplaceInverse($PGE_ID));
		else $valPGE_ID='NULL';
        if ($export_version < 420)
        {
            $AFX_NUMPROC="0";
        }
        else
        {
            $AFX_NUMPROC=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_NUMPROC");
            if ($AFX_NUMPROC == "")
            {
                $AFX_NUMPROC = '0';
            }
        }
        if ($export_version < 430)
        {
            $AFX_BACKUP_FROM='NULL';
            $AFX_BACKUP_ID='NULL';
        }
        else
        {
            $AFX_BACKUP_FROM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_BACKUP_FROM");
            if ($AFX_BACKUP_FROM == "")
            {
                $AFX_BACKUP_FROM = 'NULL';
            }
            $AFX_BACKUP_ID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_BACKUP_ID");
            if ($AFX_BACKUP_ID == "")
            {
                $AFX_BACKUP_ID = 'NULL';
            }
        }
        
		$req="INSERT INTO ACTFLUX (CLT_ID, AFX_ACTIF, FLX_ID, ACT_ID, AFX_NUM, AFX_LIBEL, AFX_SUIVI, PGE_ID, AFX_NUMPROC, AFX_BACKUP_FROM, AFX_BACKUP_ID ) VALUES 
						($id_clt, 
						".dblQ(remplaceInverse($AFX_ACTIF)).",
						".dblQ(remplaceInverse($FLX_ID)).",
						".dblQ(remplaceInverse($ACT_ID)).",
						".dblQ(remplaceInverse($AFX_NUM)).",
						'".dblQ(remplaceInverse($AFX_LIBEL))."',
						".dblQ(remplaceInverse($AFX_SUIVI)).",
                        ".$valPGE_ID.",
                        ".dblQ(remplaceInverse($AFX_NUMPROC)).",
                        ".dblQ(remplaceInverse($AFX_BACKUP_FROM)).",
                        ".dblQ(remplaceInverse($AFX_BACKUP_ID)).")";
		$res=$gDb->SQLQuery($req, 1);
		$AFX_ID=$gDb->SQLlastID();
		
		$tabCorresAFX_ID[$AFX_ID_old] = $AFX_ID; // pour mettre les amcros avec le bon AFX_ID
		
        if (($AFX_BACKUP_FROM != 'NULL') && isset($tabCorresAFX_ID[$AFX_BACKUP_FROM]))
        {
            $req = "UPDATE ACTFLUX SET AFX_BACKUP_FROM=".$tabCorresAFX_ID[$AFX_BACKUP_FROM].
                   " WHERE AFX_ID=$AFX_ID";
            $gDb->SQLQuery($req,1);
            $req = "UPDATE ACTFLUX SET AFX_BACKUP_ID=".$AFX_ID.
                   " WHERE AFX_ID=".$tabCorresAFX_ID[$AFX_BACKUP_FROM];
            $gDb->SQLQuery($req,1);
        }
		
		if ($res==null)
		{
			$transaction=false;
			$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.remplaceInverse($AFX_LIBEL)."<br/>";
			return false;
		}
		else
		{
			// on insert les val_act_flux
				if (!(insert_val_act_flux($nbreFlux,$nbreACTFLUX,$AFX_ID)))
					return false;
		}
		return true;
	}

	function insert_val_act_flux($nbreFlux,$nbreACTFLUX,$AFX_ID)	
	{
		global $ini_typeBase;
		global $xp;
		global $gDb;
		global $id_clt;
		global $transaction;
		global $msg;
		global $lang_flux_av_imp_flux_act_insert_msg_err; 
		global $lang_flux_av_imp_flux_act_lbl_val_act_flux;
		global $tabCorresAFX_ID; // pour mettre les macros avec le bon AFX_ID
		$nbreVAL_ACT_FLUX=1;
		while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/val_act_flux[$nbreVAL_ACT_FLUX]/VAF_VAL"))
		{
			$VAF_VAL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/val_act_flux[$nbreVAL_ACT_FLUX]/VAF_VAL");
			$PFL_ID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/val_act_flux[$nbreVAL_ACT_FLUX]/PFL_ID");
			$req="SELECT PFL_ID from PAR_FLOW WHERE PFL_ID=".dblQ(remplaceInverse($PFL_ID));
			$gDb->SQLQuery($req,1);
			$r= $gDb->SQLNextRow(1);	
			if ($r['PFL_ID']!=$PFL_ID)
			{
				$msg.= $lang_flux_av_imp_flux_act_insert_msg_err.remplaceInverse($PFL_ID)."<br/>";
				$transaction=false;
				return false;
			}
			else
			{
				/******************************/
				/* traitement des val_act_flux*/
				/******************************/
				$NewVal = $VAF_VAL;
				$resReg=array();
				preg_match_all("/#\{([0-9]+)\.[^\}]+\}/",$NewVal, $resReg );
				$i=0;
				while (isset($resReg[1][$i]))
				{
					$NewVal=preg_replace( "/#\{".$resReg[1][$i]."\.([^\}]+)\}/" , "#{".$tabCorresAFX_ID[$resReg[1][$i]].".\\1}", $NewVal );
					$i++;
				}
				$req="INSERT INTO VAL_ACT_FLUX (CLT_ID, AFX_ID, PFL_ID, VAF_VAL ) VALUES 
						($id_clt, 
						".$AFX_ID.",
						".$PFL_ID.",
						'".dblQ(remplaceInverse($NewVal))."')";
				$res=$gDb->SQLQuery($req, 1);
				if ($res==null)
				{
					$transaction=false;
					$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.$lang_flux_av_imp_flux_act_lbl_val_act_flux.remplaceInverse($VAF_VAL)."<br/>";
					return false;
				}
			}
			$nbreVAL_ACT_FLUX++;
		}
		return true;
	}

	$filename =  $import_chem;	
	//chemin du fichier d'import
	$flagI=false;
	
	if (is_readable($filename)) 
	{
		$flagI=true;
	}
	else
	{
		$msg = $lang_flux_av_imp_flux_act_msg_err_ouv_fic;
		$flagI=false;
	}
	
	if (!($xp = new XPath($filename))) 
	{
		$msg= $lang_flux_av_imp_flux_act_msg_err_no_xpath;
		$return = 1;
		$flagI= false;
	}
	
	// Recuperation de la version de l'export
	$export_version = version_to_int($xp->getData("EXPORT_FLUX/VERSION_BASE"));
	
	if ($flagI)
	{
		$nbreFlux=1;

		/************************************************************/
		/* on va parcourir les flux un par un						*/
		/************************************************************/
					
		$flx_id=@explode("_",$liste);
		
		while (($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_LIBEL"))) 
		{
			$FLX_ID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_ID");
			$flx_select=0;
			$flagFlux=false;
			$transaction=false;
			
			while (isset($flx_id[$flx_select]) && $flx_id[$flx_select]) 
			{
				if($FLX_ID == $flx_id[$flx_select])
				$flagFlux=true;
				$flx_select++;
			}
			
			$flagF=true;
			
			if ($flagFlux || $restore) 
			{
				$transaction=true;
				$gDb->SQLTransact();
				$FLX_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_LIBEL");
				// Si ce flux libel existe deja alors on l'ignore et on passe au suivant
				$req="SELECT count(*) from FLUX WHERE FLX_LIBEL='".dblQ(remplaceInverse($FLX_LIBEL))."' and FLX_ACTIF != ".ETAT_SUPPR." and CLT_ID=$id_clt";
				$gDb->SQLQuery($req,1);
				$nbrFlux = $gDb->SQLNextRow(1);	
				if ($nbrFlux[0]>0) 
				{
					$flagF=false;
					
					$msg.='<b>'.remplaceInverse(hi_disp($FLX_LIBEL)).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'</b><br/>';
				}
				// ce flux_libel n'existe pas, on va le creer
				if ($flagF) 
				{
					/****************************/
					/* traitement des formats	*/
					/****************************/
					$FLX_ID=null;
					$nbreFormat=1;
					while($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_NOM")) 
					{
						$FOR_NOM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_NOM");
						if ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_NORME"))
							$FOR_NORME=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_NORME");
						if ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_VERSION"))
							$FOR_VERSION=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_VERSION");
						$req="SELECT FOR_ID from `FORMAT` WHERE FOR_NOM='".dblQ(remplaceInverse($FOR_NOM))."' 
						AND FOR_NORME='".dblQ(remplaceInverse($FOR_NORME))."' 
						AND FOR_VERSION='".dblQ(remplaceInverse($FOR_VERSION))."' and CLT_ID=$id_clt";
						$gDb->SQLQuery($req,1);
						$for = $gDb->SQLNextRow(1);	
						
						if ($for['FOR_ID'])
						{
							if ($xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FOR_ID")==$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_ID"))
									$FOR_ID=$for['FOR_ID'];
							$msg.=$lang_flux_av_imp_flux_act_lbl_format.remplaceInverse(hi_disp($FOR_NOM)).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'<br/>';
						}
						else
						{
							/****************************/
							/* traitement des tdoc		*/
							/****************************/
							$TDOC_NOM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/type_doc/TDOC_NOM");
						
							$req="SELECT TDOC_ID from TYPE_DOC WHERE TDOC_NOM='".dblQ(remplaceInverse($TDOC_NOM))."' and CLT_ID=$id_clt ";
							$gDb->SQLQuery($req,1);
							$tdoc = $gDb->SQLNextRow(1);
							
							if ($tdoc['TDOC_ID'])
							{
								$TDOC_ID=$tdoc['TDOC_ID'];
								$msg.=remplaceInverse(hi_disp($TDOC_NOM)).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'<br/>';
							}
							else
							{
								$req="INSERT INTO TYPE_DOC (TDOC_NOM, CLT_ID, TDOC_SUI, TDOC_ETAT, TDOC_CONSERV ) VALUES 
								('".dblQ(remplaceInverse($TDOC_NOM))."', $id_clt, 
								'".dblQ(remplaceInverse($xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/type_doc/TDOC_SUI")))."',
								".$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/type_doc/TDOC_ETAT").",
								".$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/type_doc/TDOC_CONSERV").")";
								$res=$gDb->SQLQuery($req, 1); 
								$TDOC_ID=$gDb->SQLlastID(); 
								if ($res==null)
								{
									$transaction=false;
									$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.remplaceInverse($TDOC_NOM).'<br/>';
								}
							} 
							
							$req="INSERT INTO `FORMAT` (FOR_NOM, CLT_ID, FOR_NORME, FOR_VERSION, TDOC_ID, FOR_ETAT ) VALUES 
							('".dblQ(remplaceInverse($FOR_NOM))."', $id_clt, 
							'".$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_NORME")."',
							'".$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_VERSION")."', 
							$TDOC_ID,
							'".$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_ETAT")."')";
							$res=$gDb->SQLQuery($req, 1); 
					
							if ($xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FOR_ID")==$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/format[$nbreFormat]/FOR_ID"))
								$FOR_ID=$gDb->SQLlastID(); 
							
							if ($res==null)
							{
								$transaction=false;
								$msg.=$lang_flux_av_imp_flux_act_insert_msg_err.remplaceInverse($FOR_NOM).'<br/>';
							}
						}
						$nbreFormat++;
					} // Fin boucle WHILE
					
					/****************************/
					/* traitement des part		*/
					/****************************/
					parse_xml($nbreFlux);
			
					if ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/PAR_EMET_ID"))
						$emetID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/PAR_EMET_ID");
					if (! (insert_part($emetID, 'NULL', 'emet', $nbreFlux)))
						$transaction=false;
					if ($transaction) 
					{
						if ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/PAR_DEST_ID"))
							$destID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/PAR_DEST_ID");
						if (! (insert_part($destID, 'NULL', 'dest', $nbreFlux)))
							$transaction=false;
					}
					
					/****************************/
					/* traitement des flux		*/
					/****************************/
			
					if ($transaction)
						if (!(insert_flux($nbreFlux)))
								$transaction=false;
	
					/*****************************/
					/* traitement de part_to_part*/
					/*****************************/
					if ($transaction) 
					{
						$req = "SHOW TABLES FROM `".$nomBase."`";
	 					$gDb->SQLQuery($req, 1);
						$i = 0;
						$flagPTP = false;
						
						if($ini_typeBase == 'mysql')
							$table_name='Tables_in_'.$nomBase;
						else
						{
							if($ini_typeBase == 'mssql')
								$table_name="name";
							else
								$table_name="TABLE_NAME";	
						}
	
	 					while($row = $gDb->SQLNextRow(1)) 
						{
							if ($row[$table_name] == 'PART_TO_PART' || $row[$table_name] == 'part_to_part')
								$flagPTP = true;
							$i++;
						}
			
						if ($flagPTP) 
						{
							$gDb->SQLFermeQuery(1);
							$req="select count(*)      
								from PART_TO_PART   
								where (PTP_EMET_ID=".$PAR_EMET_ID." and PTP_DEST_ID=".$PAR_DEST_ID.") or 
								(PTP_EMET_ID=".$PAR_DEST_ID." and PTP_DEST_ID=".$PAR_EMET_ID.")";
							$gDb->SQLQuery($req,1);
							$nbrePTP = $gDb->SQLNextRow(1);
							if ($nbrePTP[0]>=1)
							{
								$msg.= $lang_flux_av_imp_flux_act_lbl_part_to_part.remplaceInverse(hi_disp($FLX_LIBEL)).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'<br/>';
							}
							else if ($PAR_EMET_ID!=$PAR_DEST_ID) 
							{
								if (!(insert_part_to_part($nbreFlux)))
									$transaction=false;
							}
							else
							{
								$msg.= $lang_flux_av_imp_flux_act_msg_err_part_to_part_same_part.'<br/>';
							}
						}
					}
					/****************************/
					/* traitement des planif	*/
					/****************************/
	
					if ($transaction)
						if (!(insert_planif($nbreFlux)))
								$transaction=false;
	
					/****************************/
					/* traitement des actflux liste*/
					/****************************/
					
					if ($transaction) 
					{
						$nbreACTFLUX=1;
						while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_LIBEL") && $transaction) 
						{
							/****************************/
							/* traitement des par_gen	*/
							/****************************/
							$nbrePARGEN=1;
							while ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/PGE_LIBEL") && $transaction) 
							{
								$PGE_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/par_gen[$nbrePARGEN]/PGE_LIBEL");
								$req="select PGE_ID       
									from PAR_GEN
									where PGE_LIBEL='".dblQ(remplaceInverse($PGE_LIBEL))."'";
								$gDb->SQLQuery($req,1);
								$nbrePGE = $gDb->SQLNextRow(1);
								if ($nbrePGE[0]>=1)
								{
									$msg.= $lang_flux_av_imp_flux_act_lbl_par_gen.remplaceInverse(hi_disp($PGE_LIBEL)).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'<br/>';
									$PGE_ID=$nbrePGE['PGE_ID'];
								}
								else
								{
									// on cree les PAR_GEN puis les valpar_gen
									if (!(insert_par_gen($nbreFlux,$nbreACTFLUX, $nbrePARGEN)))
										$transaction=false;
								}
								$nbrePARGEN++;
							}
	
							/****************************/
							/* traitement des activite	*/
							/****************************/
							if ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/ACT_ID") && $transaction)
							{
								$ACT_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/ACT_LIBEL");
								if ($ACT_LIBEL)
								{
									$TAC_NUM=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/activite/TAC_NUM");
									$req="select ACT_ID      
										from ACTIVITE
										where TAC_NUM=$TAC_NUM
										and CLT_ID=".$id_clt;
									$gDb->SQLQuery($req,1);
									$nbreACT = $gDb->SQLNextRow(1);
									if ($nbreACT[0]>=1)
									{
										$msg.= $lang_flux_av_imp_flux_act_lbl_act.remplaceInverse(hi_disp($ACT_LIBEL)).$lang_flux_av_imp_flux_act_insert_msg_err_dup.'<br/>';
										$ACT_ID=$nbreACT['ACT_ID'];
									}
									else
									{
										// on cree l'activite puis les actflux
										if (!(insert_act($nbreFlux,$nbreACTFLUX)))
											$transaction=false;
									}
								}
							}
					
							/****************************/
							/* traitement des actflux	*/
							/****************************/
							if ($xp->evaluate("EXPORT_FLUX/flux_liste[$nbreFlux]/liste_actflux[$nbreACTFLUX]/actflux/AFX_ID") && $transaction) 
							{
								if (!(insert_actflux($nbreFlux,$nbreACTFLUX)))
								$transaction=false;
							}
	
							$nbreACTFLUX++;
						}
					}
					/****************************/
					/* FIN traitement des actflux*/
					/****************************/
				}
				
				// Modif LTK le 01/03/11 : Bugzilla #2963
				if ($need_rebuild)
				{
					// Les valeurs de la liste chainee des partenaires
					// doivent etre recalculees
					$query= "SET @@SESSION.max_sp_recursion_depth=50";
					$gDb->SQLQuery($query,1);
					$gDb->SQLFermeQuery(1);
					#$query= "CALL REBUILD_PART_TREE()";
					
					if($ini_typeBase == 'mysql')
						$query= "CALL REBUILD_PART_TREE()";
					else
					{	
						if($ini_typeBase == 'mssql')
							$query= "EXEC REBUILD_PART_TREE";
						else
							$query= "BEGIN REBUILD_PART_TREE; END;";
					}
					
					$gDb->SQLQuery($query,1);
					$gDb->SQLFermeQuery(1);
				}
					
				if ($transaction)
				{
					$gDb->SQLCommit();
				}
				else
				{
					$gDb->SQLRollBack();
				}
			}
			$nbreFlux++;
		}
	}
} // fin if ($action=='import_flux')

if ($action == "verif")
{
        // correction car pas d'affichage si msg contient un retour chariot ou une tabulation
	$reponse['msg'] = addslashes(str_replace(array("\r", "\n", "\t"), array("\\r", "\\n", "\\t"), $msg));
	$reponse['return'] = $return;
	$reponse['action'] = $action;
	echo encode_JSON($reponse);
}
else
{
    //ajout de l'appel à reload_menu pour prise en compte des nouveaux types de document
	echo $msg."<script language='JavaScript'>opener.top.reload_menu();</script>";
}

?>