<?php
$DEFAULT_PATH = "../../../../";
require_once($DEFAULT_PATH."struct.php");
require_once ($DEFAULT_PATH."XPath.class.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
$droitRole = SAD; 
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR;  //droits en lmcs

// L'execution de ce script ne doit pas etre stoppe par le timeout php
set_time_limit(0);

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

$tac_role = array();
$tac_role[1] = array("caption" => $lang_flux_gest_aff_title_coll, "icon" => $pathStyle.'imgs/icons/gest_flux/collecte.gif');
$tac_role[2] = array("caption" => $lang_flux_gest_aff_title_pretrait, "icon" => $pathStyle.'imgs/icons/gest_flux/pretrait.gif');
$tac_role[3] = array("caption" => $lang_flux_gest_aff_title_trait, "icon" => $pathStyle.'imgs/icons/gest_flux/traitement.gif');
$tac_role[4] = array("caption" => $lang_flux_gest_aff_title_posttrait, "icon" => $pathStyle.'imgs/icons/gest_flux/posttrait.gif');
$tac_role[5] = array("caption" => $lang_flux_gest_aff_title_present, "icon" => $pathStyle.'imgs/icons/gest_flux/present.gif');
$tac_role[6] = array("caption" => $lang_flux_gest_aff_title_rapproch, "icon" => $pathStyle.'imgs/icons/gest_flux/rapproch.gif');

$filename = pget('import_chem');
$action   = pget('action');
$id_clt   = pget('id_clt');

$xp = new XPath($filename);

$xp->setVerbose(0); // pas de remonte d'erreur pour ne pas poluer le dataSource
	
function getActivities($xreq, &$err)
{
	global $xp, $gDb, $tac_role, $lang_flux_av_imp_flux_act_msg_err_activite;
	
	$activite = array();
	$activiteBackup = array();

	for($i = 1; $i <= 6; ++$i)
		$activite[$i] = array();
		
	$nbreACTFLUX = 1;
	
	$errMsg = '';

	while ($xp->evaluate($xreq."/liste_actflux[$nbreACTFLUX]/activite/TAC_NUM"))
	{
		$tac_num  = $xp->getData($xreq."/liste_actflux[$nbreACTFLUX]/activite/TAC_NUM");

		$req = "SELECT TAC_ROLE FROM TYPE_ACT WHERE TAC_NUM = $tac_num";
		$gDb->SQLQuery($req, 3);
		$row = $gDb->SQLNextRow(3);
		$gDb->SQLFermeQuery(3);
		
		$i = (int) $row['TAC_ROLE'];

		$type = $xp->getData($xreq."/liste_actflux[$nbreACTFLUX]/activite/ACT_LIBEL");
		$libel = $xp->getData($xreq."/liste_actflux[$nbreACTFLUX]/actflux/AFX_LIBEL");
		
		if($i=='')
		{
			$err = 1;
			$errMsg .= '<br/><b style="color:red;">'.str_replace("%ACTIVITE%", $type, $lang_flux_av_imp_flux_act_msg_err_activite).'</b>';
		}
		else
		{
			try
			{
				$isBackup = @$xp->getData($xreq."/liste_actflux[$nbreACTFLUX]/actflux/AFX_BACKUP_FROM")!='' ? true : false;
				$backupID = (int) $xp->getData($xreq."/liste_actflux[$nbreACTFLUX]/actflux/AFX_BACKUP_ID");
			}
			catch(Exception $e)
			{
				// on est sur une version de fichier d'export antrieure  la gestion des activits de backup
				$isBackup = false;
			}
			
			if($i == 5 && $tac_num == TAC_NUM_RAPPROCH)
				$j = 6;
			else $j = $i;
			
			if($isBackup==false)
				$activite[$j][] = array("type" => $type, "libel" => $libel, "backup_id" => $backupID);
			else
				$activiteBackup[(int)$xp->getData($xreq."/liste_actflux[$nbreACTFLUX]/actflux/AFX_ID")] = array("type" => $type, "libel" => $libel);
		}
		
		$nbreACTFLUX++;
	}
	
	if($err==1)
		return hi_disp($errMsg);
	
	$sortie ='<table>';
	for($i = 1; $i <= 6; ++$i)
	{
		if(count($activite[$i])>0)
		{
			$sortie .= '<tr><td><img src="'.$tac_role[$i]["icon"].'">&nbsp;'.$tac_role[$i]["caption"].'</td><td></td><td></td>';
			foreach($activite[$i] as $act)
			{
				$sortie .= '<tr><td></td><td>'.hi_disp($act['type']).' - '.hi_disp($act['libel']).'</td><td></td></tr>';
				
				// prsentation de backup
				if($i==5 && $act['backup_id']!=NULL)
				{
					$backup = $activiteBackup[(int)$act['backup_id']];
					$sortie .= '<tr><td></td><td></td><td>'.hi_disp($backup['type']).' - '.hi_disp($backup['libel']).'</td></tr>';
				}
			}
		}
	}
	$sortie.= '</table>';
	
	return hi_disp($sortie);
}

$pageNum=1;
$maxRow=$xp->evaluate("count(EXPORT_FLUX/flux_liste)");
$pageSize=$maxRow+1;

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';
echo '<item caption="'.$lang_flux_av_imp_flux_act_lbl_flux_libel.'" icon="" onClick="" toolTip="" sortMode="1"/>';
echo '</header>';

for($nbreFlux=1; $nbreFlux<=$maxRow; $nbreFlux++)
{
	$err = 0;
	$detail = getActivities("EXPORT_FLUX/flux_liste[$nbreFlux]", $err);

	$FLX_LIBEL=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_LIBEL");
	$FLX_ID=$xp->getData("EXPORT_FLUX/flux_liste[$nbreFlux]/flux/FLX_ID");

	$params = array();
	$params['flx_id'] = $FLX_ID;
	$params['action'] = $action;
	$params['id_clt'] = $id_clt;
	$params['import_chem'] = urlencode($filename);
	$params['droits'] = array('import_flux' => (droit($droitRole, DROIT_EXEC,null,null,null,null)));
	
	echo '<row detail="'.$detail.'">';
	if($err==1)
		$icon = $pathStyle.'/imgs/icons/alert.gif';
	else
		$icon = $pathStyle.'/imgs/icons/flux.gif';
	echo '<item caption="'.hi_disp($FLX_LIBEL).'" icon="'.$icon.'" value="'.row_encode_JSON($params).'"/></row>';
}

echo '</databind>';

?>