<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");
$droitRole = FLX;												//droits de traitement des flux
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC; 	//droits en lmcs

require_once($DEFAULT_PATH."flow.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

$flx_id =  pget('flx_id');

$req = "SELECT AFX_ID, AFX_NUM, AFX_ACTIF, AFX_LIBEL, AFX_SUIVI, TAC_ROLE, 
			ACTFLUX.ACT_ID, ACT_LIBEL, PGE_ID, AFX_BACKUP_FROM, AFX_BACKUP_ID, TYPE_ACT.TAC_NUM
		FROM ACTFLUX, ACTIVITE, TYPE_ACT
		WHERE FLX_ID = $flx_id
			AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID 
			AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM 
			AND AFX_ACTIF != ".ETAT_SUPPR." 
		ORDER BY TAC_ROLE, AFX_NUM";

$activite = array();
$activiteBackup = array();
$nb_act_backup = 0;

for($i = 1; $i <= 6; ++$i)
	$activite[$i] = array();

$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
{
	$i = (int) $row['TAC_ROLE'];
	
	$type = $row['ACT_LIBEL'];
	$libel = $row['AFX_LIBEL'];
	
	$isBackup = $row['AFX_BACKUP_FROM']!=NULL ? true : false;
	$backupID = (int) $row['AFX_BACKUP_ID'];
	
	switch($row['AFX_ACTIF']) {
		case ETAT_ACTIF:
			$toolTip = $lang_flux_gest_grid_lbl_etat_actif;
			$icon = $pathStyle."imgs/icons/rond_vert.png";
			break;
		case ETAT_INACTIF:
			$toolTip = $lang_flux_gest_grid_lbl_etat_inactif;
			$icon = $pathStyle."imgs/icons/rond_rouge.png";
			break;
		default:
			$toolTip = "";
			$icon = "";
	}
	
	if ($i == ID_TRAITEMENT && $row['AFX_SUIVI'] == MODE_SUIVI)
		$type = "($lang_lbl_suivi) $type";
	
	if($i == 5 && $row['TAC_NUM'] == TAC_NUM_RAPPROCH)
		$j = 6;
	else $j = $i;
	
	if($isBackup==false)
	{
		$activite[$j][] = array("type" => $type, "libel" => $libel, "afx_id" => $row['AFX_ID'],
							"pge_id" => $row['PGE_ID'],
							"backup_id" => $backupID,
							"icon" => $icon, "toolTip" => $toolTip);
	}
	else
	{
		$nb_act_backup++;
		$activiteBackup[(int)$row['AFX_ID']] = array("type" => $type, "libel" => $libel, "afx_id" => $row['AFX_ID'],
							"pge_id" => $row['PGE_ID'],
							"icon" => $icon, "toolTip" => $toolTip);
	}
}
$gDb->SQLFermeQuery(1);

echo '<?xml version="1.0" encoding="UTF-8"?><databind>';

$tac_role = array();
$tac_role[1] = array("caption" => $lang_flux_gest_aff_title_coll,
					"icon" => $pathStyle.'imgs/icons/gest_flux/collecte.gif',
					"value" =>array("tac_role" => 1, "length" => count($activite[1])));
					
$tac_role[2] = array("caption" => $lang_flux_gest_aff_title_pretrait,
					"icon" => $pathStyle.'imgs/icons/gest_flux/pretrait.gif',
					"value" =>array("tac_role" => 2, "length" => count($activite[2])));
					
$tac_role[3] = array("caption" => $lang_flux_gest_aff_title_trait,
					"icon" => $pathStyle.'imgs/icons/gest_flux/traitement.gif',
					"value" =>array("tac_role" => 3, "length" => count($activite[3])));

$tac_role[4] = array("caption" => $lang_flux_gest_aff_title_posttrait,
					"icon" => $pathStyle.'imgs/icons/gest_flux/posttrait.gif',
					"value" =>array("tac_role" => 4, "length" => count($activite[4])));


$tac_role[5] = array("caption" => $lang_flux_gest_aff_title_present,
					"icon" => $pathStyle.'imgs/icons/gest_flux/present.gif',
					"value" =>array("tac_role" => 5, "length" => count($activite[5])));

$TACPresent = array();
$TACPresent[TAC_NUM_RAPPROCH] = isTACPresent(TAC_NUM_RAPPROCH);
					
if ($TACPresent[TAC_NUM_RAPPROCH]){
	$tac_role[6] = array("caption" => $lang_flux_gest_aff_title_rapproch,
						"icon" => $pathStyle.'imgs/icons/gest_flux/rapproch.gif',
						"value" =>array("tac_role" => 6, "length" => count($activite[6])));
	$cpt=6;					
} else {
	$cpt=5;
}

for($i = 1; $i <= $cpt; ++$i) {
	echo '<row>';
	echo '<item caption="'.$tac_role[$i]["caption"].'" icon="'.$tac_role[$i]["icon"].'" onClick="set_info(\''.addslashes(row_encode_JSON($tac_role[$i]["value"])).'\');" open="1"/>';
	$j = 0;
	foreach($activite[$i] as $act)
	{
		if($i==5)
			$nb_act = count($activite[$i]) + $nb_act_backup;
		else
			$nb_act = count($activite[$i]);
		
		$value = array("afx_id" => $act['afx_id'],
						"pge_id" => $act['pge_id'],
						"position" => $j++,
						"tac_role" => $i, //($i == 6? 5: $i),
						"backup_from" => '',
						"backup_id" => $act['backup_id'],
						"length" => $nb_act); //count($activite[($i == 6? 5: $i)]));

		if($act['type']!=$act['libel'])
			$actlibel = hi_disp($act['type'].' - '.$act['libel']);
		else
			$actlibel = hi_disp($act['type']);
			
		echo '<row><item value="'.$act['afx_id'].'" caption="'.$actlibel.'" icon="'.$act['icon'].'" toolTip="'.$act['toolTip'].'" onClick="set_info(\''.addslashes(row_encode_JSON($value)).'\');"';
		
		// présentation de backup
		if($i==5 && $act['backup_id']!=NULL)
		{
			echo ' open="1" />';
			$backup = $activiteBackup[(int)$act['backup_id']];
			$value = array("afx_id" => $backup['afx_id'],
						"pge_id" => $backup['pge_id'],
						"position" => $j++,
						"tac_role" => $i, //($i == 6? 5: $i),
						"backup_from" => $act['afx_id'],
						"backup_id" => '',
						"length" => $nb_act); //count($activite[($i == 6? 5: $i)]));
						
			if($backup['type']!=$backup['libel'])
				$actlibel = hi_disp($backup['type'].' - '.$backup['libel']);
			else
				$actlibel = hi_disp($backup['type']);

			echo '<row><item value="'.$backup['afx_id'].'" caption="'.$actlibel.'" icon="'.$backup['icon'].'" toolTip="'.$backup['toolTip'].'" onClick="set_info(\''.addslashes(row_encode_JSON($value)).'\');" />';
			echo '</row>';
		}
		else
			echo ' />';
		
		echo '</row>';
	
	}
	echo '</row>';	
}

echo '</databind>';
?>