<?php

class activite {
	var $afx_id;
	var $afx_actif;
	var $flx_id;
	var $act_id;
	var $afx_num;
	var $afx_libel;
	var $afx_suivi;
	var $pge_id;
	
	function activite ($afx_id=NULL) {
		if($afx_id) {
			$this->afx_id = $afx_id;
			$this->load();
		}
	}
	
	function load  () {
		global $gDb;
		
		if($this->afx_id) {
			$req = "SELECT AFX_ACTIF, FLX_ID, ACT_ID, AFX_NUM, AFX_LIBEL, AFX_SUIVI, PGE_ID
					FROM ACTFLUX
					WHERE AFX_ID = $this->afx_id";
			$gDb->SQLQuery($req,1);
			$row = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			
			$this->afx_actif = $row['AFX_ACTIF'];
			$this->flx_id = $row['FLX_ID'];
			$this->act_id = $row['ACT_ID'];
			$this->afx_num = $row['AFX_NUM'];
			$this->afx_libel = $row['AFX_LIBEL'];
			$this->afx_suivi = $row['AFX_SUIVI'];
			$this->pge_id = $row['PGE_ID'];
		}
	}
	
	function remove () {
		global $gDb;
		$ok = false;
		
		if($this->afx_id) {
			$req = "UPDATE ACTFLUX
					SET AFX_ACTIF = ".ETAT_SUPPR."
					WHERE AFX_ID = $this->afx_id";
						
			if ($gDb->SQLQuery($req, 1))
				$ok = true;
			$gDb->SQLFermeQuery(1);
		}
		return $ok;
	}
}

/*
class format {
	var $for_id;
	var $for_nom;
	var $for_norme;
	var $for_version;
	var $tdoc_id;
	var $for_etat;
	var $for_style;
	
	function format ($for_id=NULL) {
		if($for_id) {
			$this->for_id = $for_id;
			$this->load();
		}
	}
	
	function load  () {
		global $gDb;
		
		if($this->for_id) {
			$req = "SELECT FOR_NOM, FOR_NORME, FOR_VERSION, TDOC_ID, FOR_ETAT, FOR_STYLE
					FROM `FORMAT`
					WHERE FOR_ID = $this->for_id";
			$gDb->SQLQuery($req,1);
			$row = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			
			$this->for_nom = $row['FOR_NOM'];
			$this->for_norme = $row['FOR_NORME'];
			$this->for_version = $row['FOR_VERSION'];
			$this->tdoc_id = $row['TDOC_ID'];
			$this->for_etat = $row['FOR_ETAT'];
			$this->for_style = $row['FOR_STYLE'];
		}
	}
}
*/

class planification {
	var $pla_id;
	var $pla_actif;
	
	function planification ($pla_id=NULL) {
		if($pla_id) {
			$this->pla_id = $pla_id;
			$this->load();
		}
	}
	
	function load  () {
		global $gDb;
		
		if($this->pla_id) {
			$req = "SELECT PLA_ACTIF
					FROM PLANIF
					WHERE PLA_ID = $this->pla_id";
			$gDb->SQLQuery($req,1);
			$row = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			
			$this->pla_actif = $row['PLA_ACTIF'];
		}
	}
	
	function remove () {
		global $gDb;
		$ok = false;
		
		if($this->pla_id) {
			$req = "UPDATE PLANIF
					SET PLA_ACTIF = ".ETAT_SUPPR."
					WHERE PLA_ID = $this->pla_id";
						
			if ($gDb->SQLQuery($req, 1))
				$ok = true;
			$gDb->SQLFermeQuery(1);
		}
		return $ok;
	}
}

class flux
{			
	var $flx_id;		//ID du flux
	var $flx_actif;		//Flux actif ou pas
	var $flx_libel;		//Libellé du flux
	var $flx_sens;		//Sens du flux
	var $flx_etat;		//Etat du flux
	var $flx_collecte;	//Type de collecte (commune, ...)
	var $flx_presentation;	//Type de présentation (bloquante ou non)
	var $flx_multimoteurs;	//Flux multi moteurs

	var $flx_trace;
	var $flx_test;
	var $flx_simul;
	var $flx_suppr_fic;
	var $par_emet_id;
	var $par_dest_id;
	var $tal_id;
	var $for_id;
	
	var $formats;
	var $planifications = array(); //Listes des planifications
	var $activites = array(); //Listes des activites
	
	function flux ($flx_id=NULL) {

		if($flx_id) {
			$this->flx_id = $flx_id;
			$this->load();
		}
		else {
			$this->flx_actif = ETAT_INACTIF;
			$this->flx_libel = "lib_flux";
			$this->flx_sens = EMISSION;
			$this->flx_etat = FLX_NO_VALIDE;
			$this->flx_collecte = FLX_COLLECTE_COMMUNE;
			$this->flx_presentation = FLX_PRESENTATION_BLOQUANTE;
			$this->flx_multimoteurs = FLX_MOTEURS_PAR_DEFAUT;
		}
	}
	
	function load() {
		global $gDb;
		$req = "SELECT FLX_ACTIF, FLX_LIBEL, EMET.PAR_NOM EMETTEUR, DEST.PAR_NOM DESTINATAIRE, 
					FLX_SENS, FLX_TRACE, FLX_TEST, FLX_SIMUL, TAL_LIBEL, FLX_COLLECTE, FLX_PRESENTATION, FLX_MULTIMOTEURS,
					EMET.PAR_ETAT E_EMET, dest.PAR_ETAT E_DEST, TAL_ETAT, FLX_SUPPR_FIC, FOR_ID
				FROM FLUX, PART AS EMET, PART AS DEST, TYP_ALERTE
				WHERE FLX_ID = $flux_id 
					AND EMET.PAR_ID = PAR_EMET_ID 
					AND DEST.PAR_ID = PAR_DEST_ID 
					AND FLUX.TAL_ID = TYP_ALERTE.TAL_ID";
				
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);
							
		$this->flx_actif = $row['FLX_ACTIF'];
		$this->flx_libel = $row['FLX_LIBEL'];
		$this->flx_sens = $row['FLX_SENS'];
		$this->flx_etat = $row['FLX_ETAT'];
		$this->flx_collecte = $row['FLX_COLLECTE'];
		$this->flx_presentation = $row['FLX_PRESENTATION'];
		$this->flx_multimoteurs = $row['FLX_MULTIMOTEURS'];
	
		$this->flx_trace = $row['FLX_TRACE'];
		$this->flx_test = $row['FLX_TEST'];
		$this->flx_simul = $row['FLX_SIMUL'];
		$this->flx_suppr_fic = $row['FLX_SUPPR_FIC'];
		$this->par_emet_id = $row['PAR_EMET_ID'];
		$this->par_dest_id = $row['PAR_DEST_ID'];
		$this->tal_id = $row['TAL_ID'];
		$this->for_id = $row['FOR_ID'];
		
		$this->format = new format($this->for_id);
	}
	
	function lance_planif() {
		global $gDb;
		global $clt_id;
		$fatal = false;
		$msg = '';
		$ret = -1;
		$reponse = array();
		
		if($this->flx_id) {
			if(droit(FLX, DROIT_EXEC,null,null,null,null)) {
				if (!$gDb->SQLTransact()) {
					$msg = $lang_flux_gest_act_exec_msg_err;
					$ret = 1;
				}
				else {
					$req = "INSERT INTO PLANIF 
						(FLX_ID, PLA_ACTIF, PLA_MOIS, PLA_JOUR, PLA_JOURSEM, PLA_HEURE, 
						PLA_MINUTE, PLA_DELAIDEM, PLA_IMMEDIAT, CLT_ID)
		 				VALUES ($flux_id, 1, '*', '*', '*', '*', '*', 1, 1, $clt_id)";
							
					if (!$gDb->SQLQuery($req, 1))
						$fatal = true;
					$gDb->SQLFermeQuery(1);
					
					if($fatal) {
						$gDb->SQLRollBack();
						$msg = $lang_flux_gest_act_exec_msg_err;
						$ret = 1;
					}
					else {
						$gDb->SQLCommit();
						$msg = $lang_flux_gest_act_exec_msg_ok;
						$ret = 0;
					}
				}
			}
			else {
				$msg = $lang_flux_gest_act_msg_err_droit;
				$ret = 1;
			}
		}
		$reponse['msg'] = addslashes($msg);
		$reponse['return'] = $ret;
		$reponse['action'] = "lance_planif";
		return encode_JSON($reponse);
	}
	
	function remove () {
		global $gDb;
		global $clt_id;
		$fatal = false;
		$msg = '';
		$ret = -1;
		$reponse = array();
		
		if($this->flx_id) {
			if(droit(FLX, DROIT_SUPPR,null,null,null,null)) {
				if (!$gDb->SQLTransact())
				{
					$msg = $lang_flux_gest_act_suppr_msg_err;
					$ret = 1;
				}
				else {
					foreach($this->activites as $activite)
						$fatal = !$activite->remove();
						
					if(!$fatal)
						foreach($this->planifications as $planification)
							$fatal = !$planification->remove();
					else
						$msg = $lang_flux_gest_act_suppr_msg_cant_suppr;
	
					if(!$fatal) {
						$req = "UPDATE FLUX 
							SET FLX_ACTIF = ".ETAT_SUPPR." 
							WHERE FLX_ID = $this->flx_id";
								
						if (!$gDb->SQLQuery($req, 1))
							$fatal = true;
						$gDb->SQLFermeQuery(1);
					}
					else
						$msg = $lang_flux_gest_act_suppr_msg_cant_suppr;
					
					if($fatal) {
						$gDb->SQLRollBack();
						if(!$msg)
							$msg = $lang_flux_gest_act_suppr_msg_err;
						$ret = 1;
					}
					else {
						$gDb->SQLCommit();
						$msg = $lang_flux_gest_act_suppr_msg_ok;
						$ret = 0;
					}
				}
			}
			else {
				$msg = $lang_flux_gest_act_msg_err_droit;
				$ret = 1;
			}
		}
		$reponse['msg'] = addslashes($msg);
		$reponse['return'] = $ret;
		$reponse['action'] = "remove";
		return encode_JSON($reponse);
	}
}
?>