<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "application/json; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";

require_once($DEFAULT_PATH."struct.php");
$droitRole = FLX;	//droits de traitement des flux
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC;	//droits en lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."flux/gest/flux_gest_utils.php");

$page_courante = "flux/gest/flux_gest_actAction.php";

$flx_id = pget('flx_id');
$action = pget('action');

$clt_id = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************************************************/
/* DEBUT ACTION = SUPPRESSION 								*/
/************************************************************/

if ($action == "suppr") //..._ACTIF = 2
{
	if (droit($droitRole, DROIT_SUPPR,null,null,null,null))
	{
		$fatal = false;
		if ($gDb->SQLTransact() == false)
			$fatal = true;
		
		/*//mise à jour de la table SYNCHRO pour le moteur
		if (!synchro( 1, "FLUX", $clt_id))		
			$fatal = true;*/
		
		//suppression des activitées
		$req = "UPDATE ACTFLUX 
				SET AFX_ACTIF = ".ETAT_SUPPR." 
				WHERE FLX_ID = $flx_id";
		if ($gDb->SQLQuery($req, 1) == false) {
			$fatal = true;
			$msg = $lang_flux_gest_act_suppr_msg_cant_suppr;
		}
		$gDb->SQLFermeQuery(1);
		
		//Suppression des planifications
		$req = "UPDATE PLANIF 
				SET PLA_ACTIF = ".ETAT_SUPPR." 
				WHERE FLX_ID = $flx_id";
		if ($gDb->SQLQuery($req, 1) == false) {
			$fatal = true;
			$msg = $lang_flux_gest_act_suppr_msg_cant_suppr;
		}
		$gDb->SQLFermeQuery(1);
		
		// Renuméroter les flux pour FLX_RANG contigu
		$req = "SELECT FLX_RANG FROM FLUX WHERE FLX_ID=$flx_id";
		if ($gDb->SQLQuery($req, 1) == false)
			$fatal = true;
		else
		{
			$flx_rang = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			$req = "UPDATE FLUX SET FLX_RANG=FLX_RANG-1 WHERE FLX_RANG>${flx_rang[0]}";
			if ($gDb->SQLQuery($req, 1) == false)
				$fatal = true;
		}
		$gDb->SQLFermeQuery(1);
		
		//Suppression du flux
		$req = "UPDATE FLUX 
				SET FLX_ACTIF = ".ETAT_SUPPR.", FLX_RANG=0 
				WHERE FLX_ID = $flx_id";
		if ($gDb->SQLQuery($req, 1) == false)
			$fatal = true;
		$gDb->SQLFermeQuery(1);

		if ($fatal)
		{
			if(!$msg)
				$msg = $lang_flux_gest_act_suppr_msg_err;
			$return = 1;
			$gDb->SQLRollBack();
		}
		else
		{
			$msg = $lang_flux_gest_act_suppr_msg_ok;
			$return = 0;
			$gDb->SQLCommit();
		}
	}
	else 
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = SUPPRESSION 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = Lancer la planification immédiatement		*/
/************************************************************/
else if ($action == "exec")
{
	if(droit($droitRole, DROIT_EXEC,null,null,null,null))
	{
		$fatal = false;
		if ($gDb->SQLTransact() == false)
			$fatal = true;
			
		/*//mise à jour de la table SYNCHRO pour le moteur
		if (!synchro( 1, "FLUX", $clt_id))
			$fatal = true;*/
			
			
		//Insertion de la ligne de planification immédiate en base
		$req = "INSERT INTO PLANIF 
						(FLX_ID, PLA_ACTIF, PLA_MOIS, PLA_JOUR, PLA_JOURSEM, PLA_HEURE, 
						PLA_MINUTE, PLA_DELAIDEM, PLA_IMMEDIAT, CLT_ID)
		 				VALUES (
						$flx_id,
						1,
						'*',
						'*',
						'*',
						'*',
						'*',
						1,
						1,
						$clt_id)";		
		if ($gDb->SQLQuery($req, 1) == false)
			$fatal = true;
		
		$gDb->SQLFermeQuery(1);
			
		if ($fatal) 	//FATAL --> Impossible à insérer
		{
			$msg = $lang_flux_gest_act_exec_msg_err;
			$return = 1;
			$gDb->SQLRollBack();
		}
		else 			//Tout s'est bien passé
		{
			$msg = $lang_flux_gest_act_exec_msg_ok;
			$return = 0;
			$gDb->SQLCommit();
		}
	}
	else
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = Lancer la planification immédiatement		*/
/************************************************************/
else if($action == "set_no_valid")
{
	$fatal = false;
	
	if ($gDb->SQLTransact() == false)
		$fatal = true;
		
	/*if (!synchro( 1, "FLUX", $clt_id))
		$fatal = true;*/
		
		
	if(Maj_Etat_Flux($flx_id, $msg, FLX_NO_VALIDE) < 0)
		$fatal = true;
		
	if ($fatal)
	{
		$return = 1;
		$gDb->SQLRollBack();
	}
	else
	{
		$return = 0;
		$gDb->SQLCommit();
	}
}

else if($action == "create")
{
	$fatal = false;
	
	if (droit($droitRole, DROIT_CREAT,null,null,null,null))
	{
		if ($gDb->SQLTransact() == false)
			$fatal = true;
			
		/*if (!synchro( 1, "FLUX", $clt_id))
			$fatal = true;*/
		
		if(!$fatal)
			if (New_Flux($flx_id, $msg) < 0)
				$fatal = true;
				
		if ($fatal)
		{
			if(!$msg)
				$msg = $lang_flux_gest_act_create_msg_err;
			$return = -1;
			$gDb->SQLRollBack();
		}
		else
		{
			//$msg = $lang_flux_gest_act_create_msg_ok;
			$msg = "";
			$return = $flx_id;
			$gDb->SQLCommit();
		}	
	}
	else
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = -1;
	}
}

else if($action == "clone")
{
	$fatal = false;
	
	if (droit($droitRole, DROIT_CREAT,null,null,null,null))
	{
		if ($gDb->SQLTransact() == false)
			$fatal = true;
			
		/*if (!synchro(1, "FLUX", $clt_id))
			$fatal = true;*/
			
		
		if(!$fatal)
			if (Duplic_Flux($flx_id, $msg) < 0)
				$fatal = true;
			
		if ($fatal)
		{
			if(!$msg)
				$msg = $lang_flux_gest_act_dup_msg_err;
				$return = -1;
			$gDb->SQLRollBack();
		}
		else
		{
			$msg = $lang_flux_gest_act_dup_msg_ok;
			$return = $flx_id;
			$gDb->SQLCommit();
		}
	}
	else
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = 1;
	}
}
//Modification => Enregistrement des changements, validation des activités du flux et validation du flux
else if($action == "modif")
{
	$fatal = false;
	
	if (droit($droitRole, DROIT_MODIF + DROIT_CREAT,null,null,null,null))
	{		
		//Fonctions pour la vérification syntaxique et sémantique des Macros
		require_once("macro/macro.php");
		
		if ($gDb->SQLTransact() == false)
			$fatal = true;
			
		/*if (!synchro( 1, "FLUX", $clt_id))
			$fatal = true;*/
			
		$flx_couleur = pget('FLX_COULEUR');
		if($flx_couleur=='none')
			$flx_couleur = "null";
		else
			$flx_couleur = "'$flx_couleur'";
		
		$tab_flux = array (
			'clt_id'		=> $clt_id,
			'flx_id' 		=> $flx_id,
			'flx_libel' 	=> "'".dblQ(pget('FLX_LIBEL'))."'", 
			'flx_actif' 	=> pget('FLX_ACTIF'),
			'par_emet_id' 	=> pget('PAR_EMET_ID'),
			'par_dest_id' 	=> pget('PAR_DEST_ID'),
			'for_id' 		=> pget('FOR_ID'),
			'flx_sens' 		=> pget('FLX_SENS'),
			'flx_trace' 	=> MODE_NTRACE,
			'flx_test' 		=> MODE_NTEST,
			'flx_simul' 	=> MODE_NSIMUL,
			'flx_suppr_fic'	=> pget('FLX_SUPPR_FIC'),
			'tal_id'		=> pget('TAL_ID'),
			'flx_collecte'	=> pget('FLX_COLLECTE'),
			'flx_presentation'	=> pget('FLX_PRESENTATION'),
			'flx_multimoteurs'	=> pget('FLX_MULTIMOTEURS'),
			'flx_log'		=> pget('FLX_LOG'),
			'flx_couleur'	=> $flx_couleur
		);
		
		if(NomFluxUnique($flx_id, $tab_flux['flx_libel'])==false)
		{
			$fatal = true;
			$msg = $lang_flux_gest_act_unique_msg_err;
			$return = 2; //  cas particulier, pour revenir sur le tab Généralités du flux dans verifForm de flux_gest_actAffich.php
		}
		
		if(!$fatal)
			if (Update_Flux($tab_flux, $msg) < 0)
				$fatal = true;
				
        if((!$fatal) && (pget('FLX_MULTIMOTEURS') != FLX_MULTI_MOTEURS))
        {
            $req = "UPDATE ACTFLUX 
                    SET AFX_NUMPROC = ".pget('FLX_MULTIMOTEURS')."
                    WHERE FLX_ID = $flx_id";
            if ($gDb->SQLQuery($req, 1) == false)
            {
                $fatal = true;
			}
            $gDb->SQLFermeQuery(1);
        }
		
		if(!$fatal)
			if (Verif_Flux_Activites($flx_id, $msg) < 0)
				$fatal = true;
	
		if(!$fatal) {
			$return = Verif_Flux($flx_id, $msg);
			if ($return != 1)
				$fatal = true;
		}
		
		if ($fatal)
		{
			if(!$msg)
				$msg = $lang_flux_gest_act_update_msg_err;
			//if($return <-1)
			//	$return = 1;
			$gDb->SQLRollBack();
		}
		else
		{
			$msg = $lang_flux_gest_act_update_msg_ok;
			$return = 0;
			$gDb->SQLCommit();
		}
	}
	else
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = 1;
	}
}
// modification du rang d'un flux
else if($action == "move_up")
{
	$fatal = false;

	if (droit($droitRole, DROIT_MODIF + DROIT_CREAT,null,null,null,null))
	{
		if ($gDb->SQLTransact() == false)
			$fatal = true;
		else
			$fatal = Move_Flux($flx_id, -1);
		
		if ($fatal)
		{
			$msg = $lang_flux_gest_act_update_msg_err;
			$gDb->SQLRollBack();
		}
		else
		{
			$return = 0;
			$gDb->SQLCommit();
		}
	}
	else
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = 1;
	}
}
else if($action == "move_down")
{
	$fatal = false;

	if (droit($droitRole, DROIT_MODIF + DROIT_CREAT,null,null,null,null))
	{
		if ($gDb->SQLTransact() == false)
			$fatal = true;
		else
			$fatal = Move_Flux($flx_id, 1);

		if ($fatal)
		{
			$msg = $lang_flux_gest_act_update_msg_err;
			$gDb->SQLRollBack();
		}
		else
		{
			$return = 0;
			$gDb->SQLCommit();
		}
	}
	else
	{
		$msg = $lang_flux_gest_act_msg_err_droit;
		$return = 1;
	}
}

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
echo encode_JSON($reponse);
?>