<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");
$droitRole = FLX;	//droits de traitement des flux
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC; //droits en lmcs

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template
$page_courante = "flux/gest/flux_gest_actAffich.php";

$vtp = new VTemplate;

$flx_id = pget('flx_id');
$action = pget('action');


$form = $vtp->Open($DEFAULT_PATH."template/gest_flux_form.vtp");
$vtp->addSession($form, "global");

switch($action) {
	case 'create':
		$readOnly = false;
		$panelTitle = $lang_lbl_create;
		$panelIcon = $pathStyle."imgs/icons/add.gif";
		$action = "modif";
		break;
	case 'clone':
		$readOnly = false;
		$panelTitle = $lang_lbl_duplication;
		$panelIcon = $pathStyle."imgs/icons/add.gif";
		$action = "modif";
		break;
	case 'modif':
		$readOnly = false;
		$panelTitle = $lang_lbl_modif;
		$panelIcon = $pathStyle."imgs/icons/admin.gif";
		break;
	case 'detail':
		$readOnly = true;
		$panelTitle = $lang_lbl_detail;
		$panelIcon = $pathStyle."imgs/icons/loupe.gif";
		break;
}

//Variable générales

//Titre et icone pour la barre de titre
$vtp->setVar($form, "global.title", addslashes($lang_flux_gest_title));
$vtp->setVar($form, "global.icon", $pathStyle."imgs/icons/title/flux_gest.gif");

//ID Gemedoc pour l'aide
$vtp->setVar($form, "global.help_id", "20070724152730");

//Le formulaire est-il en lecture seule ?
$vtp->setVar($form, "global.readOnly", (($readOnly)? "true": "false"));

//Action à réaliser en appuyant dur le bouton 'Retour'
//$vtp->setVar($form, "global.back_fct", "history.go(-1);");
$vtp->setVar($form, "global.back_fct", "changePage(Prologue.Flow.path+\'flux/gest/flux_gest.php?selected=$flx_id\');");

//Variables statiques du form (input hidden)
$vtp->addSession($form, "form_input_hidden");
$vtp->setVar($form, "form_input_hidden.name", "action");
$vtp->setVar($form, "form_input_hidden.value", $action);
$vtp->closeSession($form, "form_input_hidden");

$vtp->addSession($form, "form_input_hidden");
$vtp->setVar($form, "form_input_hidden.name", "flx_id");
$vtp->setVar($form, "form_input_hidden.value", $flx_id);
$vtp->closeSession($form, "form_input_hidden");

//Récupération des partenaires
$tab_part = array();
$req = "SELECT PAR_ID, PAR_NOM FROM PART";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_part[$row['PAR_ID']] = $row['PAR_NOM'];
$gDb->SQLFermeQuery(1);

//Récupération des formats de documents
$tab_for = array();
$req = "SELECT FOR_ID, FOR_NORME, FOR_NOM, FOR_VERSION FROM `FORMAT`";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_for[$row['FOR_ID']] = $row['FOR_NORME']." - ".$row['FOR_NOM']." - ".$row['FOR_VERSION'];
$gDb->SQLFermeQuery(1);

//Récupération des types d'alertes
$tab_tal = array();
$req = "SELECT TAL_ID, TAL_LIBEL FROM TYP_ALERTE";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_tal[$row['TAL_ID']] = $row['TAL_LIBEL'];
$gDb->SQLFermeQuery(1);

$req = "SELECT FLX_ACTIF, FLX_LIBEL, PAR_EMET_ID, PAR_DEST_ID, FLX_SENS, FLX_TRACE, FLX_TEST, FLX_SIMUL,
			FLX_COLLECTE, FLX_PRESENTATION, FLX_MULTIMOTEURS, FLX_SUPPR_FIC, FOR_ID, FLX_ETAT, TAL_ID, FLX_LOG, FLX_COULEUR
		FROM FLUX
		WHERE FLX_ID = $flx_id";

$gDb->SQLQuery($req,1);
$row = $gDb->SQLNextRow(1);
$gDb->SQLFermeQuery(1);

switch($row['FLX_ETAT']) {
	case STATUS_NON_VERIF:
		$panelTitle .= "- $lang_ds_statut_noval";
		break;
	case STATUS_OK:
		$panelTitle .= "- $lang_ds_statut_valok";
		break;
	case STATUS_NOK:
		$panelTitle .= "- $lang_ds_statut_valnok";
		break;
}

//Titre et icone pour le sous-titre
$vtp->setVar($form, "global.panelTitle", $panelTitle);
$vtp->setVar($form, "global.panelIcon", $panelIcon);

$vtp->setVar($form, "global.head_javascript", "
	//var saved_history = history;

	var treeView_DS_URL = Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_dSTree.php?flx_id=$flx_id';
	var help = top.help;
	function resize_act_panel () {
		var cs = $('list_act_panel');
		var w = document.body.clientWidth;
		w -= parseInt(cs.borderLeftWidth, 10)||0;
		w -= parseInt(cs.borderRightWidth, 10)||0;
		w -= parseInt(cs.paddingLeft, 10)||0;
		w -= parseInt(cs.paddingRight, 10)||0;
		w -= 320;
		w -= 37;
		w -= parseInt(document.body.currentStyle.marginLeft);
		w -= parseInt(document.body.currentStyle.marginRight);

		var act_panel_content = $('act_panel').rows[1].cells[0].firstChild;
		var list_act_panel_content = $('list_act_panel').rows[1].cells[0].firstChild;

		if(w > 0) {
			act_panel_content.style.width = w + 'px';
			$('ifmParam').style.width = w + 'px';
		}

		var h = document.body.clientHeight;
		h -= parseInt(document.body.currentStyle.marginTop);
		h -= parseInt(document.body.currentStyle.marginBottom);
		h -= 170;

		if(h > 0) {
			act_panel_content.style.height = h + 'px';
			list_act_panel_content.style.height = h + 'px';
			$('ifmParam').style.height = h + 'px';
		}
		
		var tbs = $('tab_gest_flux').rows[1].cells[0].firstChild;
		tbs.style.width = (w+357) + 'px';
	}

	function resize_schema_panel () {
		var cs = $('schema_panel');
		var w = document.body.clientWidth;
		w -= parseInt(cs.borderLeftWidth, 10)||0;
		w -= parseInt(cs.borderRightWidth, 10)||0;
		w -= parseInt(cs.paddingLeft, 10)||0;
		w -= parseInt(cs.paddingRight, 10)||0;
		w -= 37;
		w -= parseInt(document.body.currentStyle.marginLeft);
		w -= parseInt(document.body.currentStyle.marginRight);

		var schema_panel_content = $('schema_panel').rows[1].cells[0].firstChild;
		
		if(w > 0) {
			schema_panel_content.style.width = w + 'px';
			$('ifmShema').style.width = w + 'px';
		}

		var h = document.body.clientHeight;
		h -= parseInt(document.body.currentStyle.marginTop);
		h -= parseInt(document.body.currentStyle.marginBottom);
		h -= 190;

		if(h > 0) {
			schema_panel_content.style.height = h + 'px';
			$('ifmShema').style.height = (h-27) + 'px';
		}
	}

	window.attachEvent('onload', resize_schema_panel);
	window.attachEvent('onload', resize_act_panel);

	window.attachEvent('onresize', resize_schema_panel);
	window.attachEvent('onresize', resize_act_panel);


	function setTitle (title, icon) {
			var item = $('act_panel').rows[0].cells[0].firstChild;
			Prologue.item.setText(item, title||'$lang_flux_part_act_detail_title');
			Prologue.item.setIcon(item, icon||Prologue.Flow.images+'icons/admin.gif');  
		};

	function paramLoadPage (url) {
		var ifm = frames['ifmParam'];
		if(url)
		{
			if (ifm.contentWindow)
			{
                // Special Chrome
    			ifm.contentWindow.location.href = urldecode(url);
			}
			else
			{
                ifm.location.href = urldecode(url);
			}
		}
	}

	function set_info (value) {
		activite.load(value);
		var up = 0;
		var down = 0;
		var create = 0;
		var remove = 0;

		if(".($readOnly? "false": "true").") {
			if(activite.afx_id) {
				if(activite.backup_id=='')
					remove = 1;
				if(activite.position > 0 && activite.backup_from=='')
					up = 1;
				if ((activite.position < activite.length - 1 && activite.backup_from=='' && activite.backup_id=='') ||
                    (activite.position < activite.length - 2 && activite.backup_from=='' && activite.backup_id!=''))
				    down = 1;
			}
			if(activite.tac_role) {
				switch(activite.tac_role) {
					case 3:
						if(activite.afx_id=='')
							create = 1;
						break;
					case 5:
						if(activite.backup_from=='' && activite.backup_id=='')
							create = 1;
						break;
					case 1:
					case 2:
					case 4:
					case 6:
						if(activite.length < 1)
							create = 1;
						break;
				}
				if(create)
					Prologue.list.reload('opt_toolbar', Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_dSDropDown.php?tac_role='+activite.tac_role+'&afx_id='+activite.afx_id);
			}
			Prologue.toolbar.reload('act_tlbr', Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_dSToolBar.php?up='+up+'&down='+down+'&create='+create+'&remove='+remove);
		}
	}

	function act_tree_reload () {
		Prologue.treeView.reload('act_tree', treeView_DS_URL);
		if(frames['ifmShema'].contentWindow) // spécial chrome
			frames['ifmShema'].contentWindow.schema_reload();
		else
			frames['ifmShema'].schema_reload();
		update_toolbar_schema();
	}
	
	var activite = new function () {
		this.afx_id = '';
		this.pge_id = '';
		this.position = '';
		this.tac_role = '';
		this.backup_from = '';
		this.backup_id = '';
		this.length = 0;

		this.load_param = function () {
			var flx_id = '$flx_id';
			var url = Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_actAffich.php';
			url += '?readOnly=".($readOnly? "1": "0")."';
			url += '&pge_id='+this.pge_id;
			url += '&afx_id='+this.afx_id;
			url += '&flx_id='+flx_id;
			url += '&tac_role='+this.tac_role;
			url += '&for_id='+".($readOnly? "${row['FOR_ID']}" : "prlComboList.getSelected('FOR_ID').value").";

			if(this.afx_id)
				paramLoadPage(url);
			else
				paramLoadPage(Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_blank.php');
		}

		this.load = function (value) {
			info = eval('('+value+')');
			this.afx_id = info.afx_id||'';
			this.pge_id = info.pge_id||'';
			this.position = info.position||'';
			this.tac_role = info.tac_role||'';
			this.backup_from = info.backup_from||'';
			this.backup_id = info.backup_id||'';
			this.length = info.length||0;
			
			if(this.afx_id)
				this.load_param();
		}

		this.move = function (direction) {
			var flx_id = '$flx_id';
			var url = 'activite/flux_gest_activite_actAction.php';
			url += '?action=move';
			url += '&afx_id='+this.afx_id;
			url += '&flx_id='+flx_id;
			url += '&sens='+direction;
			url += '&backup_id='+this.backup_id;
			if(prlExec(url) == 0) {
				act_tree_reload();
				//paramLoadPage(Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_blank.php');
				//set_info ('{}');
				Prologue.treeView.selectNodeByValue('act_tree', this.afx_id);
			}
		}

		this.create = function (act_id, pge_id, afx_id, tac_role) {
			toolbar_dropDown_hide();
			act_id = act_id||'';
			pge_id = pge_id||'';

			backup_from = afx_id||'';
			
			var flx_id = '$flx_id';
			var url = 'activite/flux_gest_activite_actAction.php';
			url += '?action=create';
			url += '&flx_id='+flx_id;
			url += '&act_id='+act_id;
			url += '&pge_id='+pge_id;
			url += '&tac_role='+tac_role;
			
			url += '&backup_from='+backup_from;
			
			url += '&length='+this.length;

			var afx_id = prlExec(url); 
			if(afx_id > 0) {
				act_tree_reload();
				Prologue.treeView.selectNodeByValue('act_tree', afx_id);
			}
		}

		this.remove = function () {
			var flx_id = '$flx_id';
			var url = 'activite/flux_gest_activite_actAction.php';
			url += '?action=suppr';
			url += '&afx_id='+this.afx_id;
			url += '&flx_id='+flx_id;

			if(prlExec(url) == 0) {
				act_tree_reload();
				paramLoadPage(Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_blank.php');
				set_info ('{}');
			}
		}
	}

	toolbar_dropDown_hide = function() {
		if (window.current_toolbar_dropDown) {
			window.current_toolbar_dropDown.style.visibility = 'hidden';
			window.current_toolbar_dropDown = null;
			window.detachEvent('onmouseup', toolbar_dropDown_hide);
		}
	};
	
	toolbar_dropDown_onclick = function (table, tacRole) {
		var dD = $('toolbar_dropDown'+(tacRole>0?'2':''));
		if(tacRole>0)
		{
			Prologue.list.reload('opt_toolbar2', Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_dSDropDown.php?tac_role='+tacRole);
		}
		var v = dD.style.visibility == 'visible';
		if(!v) {
			var dDPosition = {top : 0, left : 0};
			dDPosition.top = (parseInt(Prologue.ui.clientToScreen(table).top, 10) + parseInt(table.offsetHeight, 10));
			dDPosition.left = parseInt(Prologue.ui.clientToScreen(table).left, 10);
			if (!Prologue.browser.ie)
				Prologue.ui.screenToClient(dD, dDPosition);

			Prologue.ui.moveTo(dD, dDPosition);
			if (dDPosition.top + dD.offsetHeight > document.body.clientHeight)
			{
				Prologue.ui.setHeight(dD, document.body.clientHeight - dDPosition.top);
			}			
			window.current_toolbar_dropDown = dD;
			window.attachEvent('onmouseup', toolbar_dropDown_hide);
			dD.style.visibility='visible';
			dD.style.zIndex = '1000';
}
		else
			toolbar_dropDown_hide();
	}

	function verifForm ()
	{
		var check = true;

		prlTabStrip.setSelected(\"tab_gest_flux\", 1);
		if(frames['ifmParam'].contentWindow) // Spécial Chrome
		{
			if(frames['ifmParam'].contentWindow.verifForm)
				check = frames['ifmParam'].contentWindow.verifForm(true);
		}
		else if(frames['ifmParam'].verifForm)
			check = frames['ifmParam'].verifForm(true);

		if(check && (err=submitForm(this.document.forms['filtre'], 'flux_gest_actAction.php', prlExec)) == 0)
			changePage(Prologue.Flow.path+'flux/gest/flux_gest.php?selected=$flx_id');
		else if(err==2)
			prlTabStrip.setSelected(\"tab_gest_flux\", 0);
	}
	function update_toolbar_schema()
	{
		var ds = Prologue.Flow.path+'flux/gest/flux_gest_dSToolBarShema.php?';
		var collecte = 0;
		var pretrait = 0;
		var trait = 0;
		var posttrait = 0;
		var pres = 0;
		
		if(".($readOnly? "false": "true").")
		{
			var req = new Prologue.ajax.request(treeView_DS_URL);
			req.send();
			var resp = req.getXML();
			var xRoot = resp.documentElement;
			for (var i=0; i<xRoot.childNodes.length; i++)
			{
				var xNode = xRoot.childNodes[i].firstChild;
				if(xNode.attributes.getNamedItem('caption').value=='$lang_lbl_tac_role_collecte' && xRoot.childNodes[i].childNodes.length<=1)
					collecte = 1;
				else if(xNode.attributes.getNamedItem('caption').value=='$lang_lbl_tac_role_pretrait' && xRoot.childNodes[i].childNodes.length<=1)
					pretrait = 1;
				else if(xNode.attributes.getNamedItem('caption').value=='$lang_lbl_tac_role_posttrait' && xRoot.childNodes[i].childNodes.length<=1)
					posttrait = 1;
			}

			trait = 1;
			pres = 1;
		}
		
		Prologue.toolbar.reload('schema_tlbr', ds+'collecte='+collecte+'&pretrait='+pretrait+'&trait='+trait+'&posttrait='+posttrait+'&pres='+pres);
	}
");

//Onglet généralités

$vtp->addSession($form, "form_tab");
$vtp->setVar($form, "form_tab.type_acte", "generalite");

//Libelle
$FLX_LIBEL = (empty($row['FLX_LIBEL'])? "lib_flux": $row['FLX_LIBEL']);
if($readOnly){
	$content = $FLX_LIBEL;
	$javascript = "";
}
else {
	$FLX_LIBEL = addslashes(hi_disp($FLX_LIBEL));
	$javascript = "
		with(new prlTextBox('FLX_LIBEL', prlTextBox.formats.any, '$FLX_LIBEL')) {
			maxLength  = 50;
			trim = prlTextBox.trimMode.both;
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_libelle);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Actif
$FLX_ACTIF = $row['FLX_ACTIF'];
if($FLX_ACTIF == ETAT_ACTIF) $ETAT = $lang_lbl_oui;
else $ETAT = $lang_lbl_non;
if($readOnly){
	$content = $ETAT;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FLX_ACTIF', '$FLX_ACTIF')) {
			add('$lang_lbl_oui', '', '', '".ETAT_ACTIF."');
			add('$lang_lbl_non', '', '', '".ETAT_INACTIF."');
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_actif);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Sens
$FLX_SENS = $row['FLX_SENS'];
if($FLX_SENS == RECEPTION) $SENS = $lang_lbl_recep;
else $SENS = $lang_lbl_emiss;
if($readOnly){
	$content = $SENS;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FLX_SENS', '$FLX_SENS')) {
			dataSource = Flow.path+'dataSources/dSComboSens.php?showNull=0';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_sens);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Couleur
$FLX_COULEUR = $row['FLX_COULEUR'];
if($readOnly)
{
	if($FLX_COULEUR!='')
		$content = "<img src='${pathFlow}style/imgs/icons/puzzle_${FLX_COULEUR}.png'/>";
	else
		$content = $lang_flux_gest_act_macro_lbl_none;
	$javascript = "";
}
else
{
	$javascript = "
		with(new prlComboImage('FLX_COULEUR', '$FLX_COULEUR', '${pathFlow}style/imgs/icons/puzzle_%VAL%.png', '%VAL%')) {
			dataSource = Flow.path + 'dataSources/dSComboColorImage.php';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_couleur);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Supression des fichiers après traitement
$FLX_SUPPR_FIC = $row['FLX_SUPPR_FIC'];
if($FLX_SUPPR_FIC == SUPPR_FIC) $SUPPR = $lang_lbl_oui;
else $SUPPR = $lang_lbl_non;
if($readOnly){
	$content = $SUPPR;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FLX_SUPPR_FIC', '$FLX_SUPPR_FIC')) {
			add('$lang_lbl_oui', '', '', '".SUPPR_FIC."');
			add('$lang_lbl_non', '', '', '".NSUPPR_FIC."');
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_suppraptrait);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Emetteur
$PAR_EMET_ID = $row['PAR_EMET_ID'];
$EMET = $tab_part[$PAR_EMET_ID];
if($readOnly){
	$content = $EMET;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboTree('PAR_EMET_ID', '$PAR_EMET_ID')) {
			dataSource = Flow.path+'dataSources/dSPartenaires.php?f_ieexcept=1&fonction=".PART_EMET."&droitRole=$droitRole&showNull=0';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_emet);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Destinataire
$PAR_DEST_ID = $row['PAR_DEST_ID'];
$DEST = $tab_part[$PAR_DEST_ID];
if($readOnly){
	$content = $DEST;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboTree('PAR_DEST_ID', '$PAR_DEST_ID')) {
			dataSource = Flow.path+'dataSources/dSPartenaires.php?f_ieexcept=1&fonction=".PART_DEST."&droitRole=$droitRole&showNull=0';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_dest);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Format de document
$FOR_ID = $row['FOR_ID'];
$FORMAT = $tab_for[$FOR_ID];
if($readOnly){
	$content = $FORMAT;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FOR_ID', '$FOR_ID')) {
			dataSource = Flow.path+'dataSources/dSFormatDoc.php?droit=$lmcse&showNull=0';
			dropDown.height = '170';
			dropDown.width = '350';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_fdoc);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//Type d'alerte
$TAL_ID = $row['TAL_ID'];
$ALERTE = $tab_tal[$TAL_ID];
if($readOnly){
	$content = hi_disp($ALERTE);
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('TAL_ID', '$TAL_ID')) {
			dataSource = Flow.path+'dataSources/dSTypeAlert.php?showNull=0&simple=0';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_alert);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Type de collecte
$FLX_COLLECTE = $row['FLX_COLLECTE'];
if($FLX_COLLECTE == FLX_COLLECTE_COMMUNE) $TCOL = $lang_ds_tcol_com;
else $TCOL = $lang_ds_tcol_uniq;
if($readOnly){
	$content = $TCOL;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FLX_COLLECTE', '$FLX_COLLECTE')) {
			dataSource = Flow.path + 'dataSources/dSTypeCol.php';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_tcoll);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Type de présentation
$FLX_PRESENTATION = $row['FLX_PRESENTATION'];
if($FLX_PRESENTATION == FLX_PRESENTATION_BLOQUANTE)
{
	$flx_bloq = "true";
	$TPRES = $lang_ds_tpres_bloq;
}
else
{
	$flx_bloq = "false";
	$TPRES = $lang_ds_tpres_nobloq;
}

if($readOnly){
	$content = $TPRES;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FLX_PRESENTATION', '$FLX_PRESENTATION')) {
			dataSource = Flow.path + 'dataSources/dSTypePres.php';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_tpres);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//Multi moteurs
$FLX_MULTIMOTEURS = $row['FLX_MULTIMOTEURS'];
if($readOnly){
	switch ($FLX_MULTIMOTEURS)
	{
        case FLX_MOTEURS_SELON_CHARGE:
            $content = $lang_ds_moteurs_selon_charge;
            break;
		case FLX_MULTI_MOTEURS:
            $content = $lang_ds_moteurs_par_activite;
            break;
        case FLX_MOTEURS_PAR_DEFAUT:
            $content = $lang_ds_moteurs_par_defaut;
            break;
        default:
	        $reqMoteurs = "SELECT PRO_LIBELLE
	                       FROM PROCESSUS
	                       WHERE PRO_NUMPROC=$FLX_MULTIMOTEURS AND PRO_TYPE_MOTEUR = ".TYPE_MOTEUR_ACT;
	        $gDb->SQLQuery($reqMoteurs,5);
	        $rowMoteur = $gDb->SQLNextRow(5);
	        $content = $rowMoteur['PRO_LIBELLE'];
	        $gDb->SQLFermeQuery(5);
        	break;
	}        	
	$javascript = "";
}
else {
	$javascript = "
		with(new prlComboList('FLX_MULTIMOTEURS', '$FLX_MULTIMOTEURS')) {
			dataSource = Flow.path + 'dataSources/dSMultiMoteurs.php';
            dropDown.height = '260';
			create();
		};";
    $content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_moteurs);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//niveau de log

$FLX_LOG = $row['FLX_LOG'];
if($readOnly){
	switch ($FLX_LOG){
		case AUCUN:
			$content = $lang_admin_log_aff_lbl_aucun;
			$javascript = "";
			break;
		case TXT:
			$content = $lang_admin_log_aff_lbl_txt;
			$javascript = "";
			break;
		case XML:
			$content = $lang_admin_log_aff_lbl_xml;
			$javascript = "";
			break;
		case TXTXML:
			$content = $lang_admin_log_aff_lbl_txtxml;
			$javascript = "";
			break;
	}
} else {
	$javascript = "
		with(new prlComboList('FLX_LOG', '$FLX_LOG')) {
			dataSource = Flow.path + 'dataSources/dSNivLog.php';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_admin_log_aff_lbl_niveau);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//Planification
if(!$readOnly) {
	$row_actions = "
	function planif_grid_reload () {
		Prologue.grid.reload('planifGrid', '${pathFlow}/flux/gest/planif/flux_gest_planif_dSGrid.php?flx_id=$flx_id');
	}

	function prlExecPlanifGrid (url) {
		if(prlExec(url) == 0)
			planif_grid_reload();
	};
	rowAction.add('modif', 'flux/gest/planif/flux_gest_planif_actAffich.php', openPopUp, ['action', 'flx_id', 'pla_id']);
	rowAction.add('remove', 'flux/gest/planif/flux_gest_planif_actAction.php', prlExecPlanifGrid, ['action', 'flx_id', 'pla_id']);

	rowAction.actions.modif.check = function (params) {
		params.action = 'modif';
		params.flx_id = '$flx_id';
		return true;
	};

	rowAction.actions.remove.check = function (params) {
		params.action = 'suppr';
		params.flx_id = '$flx_id';
		return true;
	};";
	
	$action_js = "
	add('$lang_lbl_creer', '${pathStyle}imgs/icons/add.gif', 'openPopUp(\'planif/flux_gest_planif_actAffich.php?action=create&flx_id=$flx_id\',\'\',550,800);');
	add('$lang_lbl_modifier', '${pathStyle}imgs/icons/admin.gif', 'rowAction.grid_id = \'planifGrid\'; rowAction.exec(\'modif\')');
	add('$lang_lbl_supprimer', '${pathStyle}imgs/icons/trash.png', 'rowAction.grid_id = \'planifGrid\'; rowAction.exec(\'remove\')');";
}
else {
$row_actions = "";
$action_js = "";
}

$javascript = "document.write('<center>');
	$row_actions
	with(new Prologue.gridPageToolBar('planifGridTbr')) {
		$action_js
		gridId = 'planifGrid';
		create();
	}
	document.write('</center>');
	with(new prlGrid('planifGrid')) {
		async = true;
		pageSize = 5;
		pageToolBarId = 'planifGridTbr';
		dataSource = '${pathFlow}/flux/gest/planif/flux_gest_planif_dSGrid.php?flx_id=$flx_id&readOnly=".(($readOnly)? "1":"0")."';
		create();
	}
";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_gest_aff_lbl_planif);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->closeSession($form, "form_field");

$vtp->closeSession($form, "form_tab");

//Activités
$vtp->addSession($form, "form_tab");

$content = "
<div id=\"toolbar_dropDown\" style=\"overflow:auto;visibility: hidden; background-color: #FFF; border:1px solid #C4BBB2; position:absolute; width: 255px;\">
	<script language=\"JavaScript\" type=\"text/javascript\">
		new Prologue.list('opt_toolbar').create();
	</script>
</div>
<center>
<table>
	<tr>
		<td style='overflow:auto'>
			<script language=\"JavaScript\" type=\"text/javascript\">
				var act_treeview = new Prologue.treeView('act_tree');
				act_treeview.dataSource = treeView_DS_URL;
	
				var toolBar = new Prologue.toolbar('act_tlbr');
				toolBar.style = Prologue.toolbar.style.button;
				toolBar.dataSource = Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_dSToolBar.php?up=0&down=0&create=0&remove=0';
	
				with(new Prologue.container('$lang_flux_gest_aff_title_list_act', Prologue.Flow.images+'icons/exec.png')) {
					id = 'list_act_panel';
					content = '<div style=\"background-color: #D0C8C1;\">'+toolBar.html()+'</div>';
					content += act_treeview.html();
					clientWidth = '320px';
					create();
				}
				
				Prologue.toolbar.reload('act_tlbr', Prologue.Flow.path+'flux/gest/activite/flux_gest_activite_dSToolBar.php?up=0&down=0&create=0&remove=0');
			</script>
		</td>
		<td>
			<script language=\"JavaScript\" type=\"text/javascript\">
				with(new Prologue.container('$lang_flux_pargen_as2_aff_pnl_title_detail', Prologue.Flow.images+'icons/admin.gif')) {
					id = 'act_panel';
					content = '<iframe id=\"ifmParam\" name=\"ifmParam\" src=\"activite/flux_gest_activite_blank.php\" FRAMEBORDER=\"0\" SCROLLING=\"AUTO\"></iframe>';
					create();
				}
			</script>
		</td>
	</tr>
</table>
</center>
";

$vtp->setVar($form, "form_tab.type_acte", "activite");
$vtp->setVar($form, "form_tab.javascript", "
	function print_schema()
	{
		if(frames['ifmShema'].contentWindow) // spécial chrome
			frames['ifmShema'].contentWindow.print();
		else
			frames['ifmShema'].print();
	}
");
$vtp->setVar($form, "form_tab.content", $content);
$vtp->closeSession($form, "form_tab");

//Schéma
$vtp->addSession($form, "form_tab");
$content = "
<div id=\"toolbar_dropDown2\" style=\"overflow:auto;visibility: hidden; background-color: #FFF; border:1px solid #C4BBB2; position:absolute; width: 255px;\">
	<script language=\"JavaScript\" type=\"text/javascript\">
		new Prologue.list('opt_toolbar2').create();
	</script>
</div>
<center>
	<script language=\"JavaScript\" type=\"text/javascript\">
		var toolBar = new Prologue.toolbar('schema_tlbr');
		toolBar.style = Prologue.toolbar.style.button;
		toolBar.dataSource = Prologue.Flow.path+'flux/gest/flux_gest_dSToolBarShema.php?collecte=0&pretrait=0&trait=0&posttrait=0&pres=0';

		var container = new Prologue.container('$lang_flux_gest_aff_title_panel_schema', Prologue.Flow.images+'icons/eye.png');
		container.id = 'schema_panel';
		container.content = '<div style=\"background-color: #D0C8C1;\">'+toolBar.html()+'</div>';
		container.content +=\"<iframe id='ifmShema' name='ifmShema' src='flux_gest_actSchema.php?flx_id=$flx_id&flx_bloq=$flx_bloq' FRAMEBORDER='0' SCROLLING='AUTO'></iframe>\";
		container.create();
		
		update_toolbar_schema();
	</script>
</center>
";

$vtp->setVar($form, "form_tab.type_acte", "schema");
$vtp->setVar($form, "form_tab.javascript", "");
$vtp->setVar($form, "form_tab.content", $content);
$vtp->closeSession($form, "form_tab");
//fin Schéma

$tab_list_id = "['generalite', 'activite', 'schema']";
$tab_list_title = "['$lang_flux_gest_aff_title_general', '$lang_flux_gest_act_macro_lbl_act', '$lang_flux_gest_aff_title_schema']";
$vtp->setVar($form, "global.tab_list_id", $tab_list_id);
$vtp->setVar($form, "global.tab_list_title", $tab_list_title);

include($DEFAULT_PATH."header.php");
$vtp->setVar($form, "global.page_headers", $page_headers);
$vtp->closeSession($form, "global");
$vtp->Display();
?>