<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
$droitRole = FLX;												//droits de traitement des flux
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR + DROIT_EXEC; 	//droits en lmcs

require_once($DEFAULT_PATH."flow.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

$flx_id =  pget('flx_id');
$flx_bloq =  pget('flx_bloq');

$reqMoteurs = "SELECT FLX_MULTIMOTEURS
                   FROM FLUX
                   WHERE FLX_ID = '".$flx_id."'";
$gDb->SQLQuery($reqMoteurs,5);
$rowMoteur = $gDb->SQLNextRow(5);
$multiMoteurs = $rowMoteur['FLX_MULTIMOTEURS'];
$gDb->SQLFermeQuery(5);

$req = "SELECT AFX_ID, AFX_NUM, AFX_ACTIF, AFX_LIBEL, AFX_SUIVI, AFX_NUMPROC, TAC_ROLE, 
			ACTFLUX.ACT_ID, ACT_LIBEL, PGE_ID, AFX_BACKUP_FROM, AFX_BACKUP_ID, TYPE_ACT.TAC_NUM
		FROM ACTFLUX, ACTIVITE, TYPE_ACT
		WHERE FLX_ID = $flx_id
			AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID 
			AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM 
			AND AFX_ACTIF != ".ETAT_SUPPR." 
		ORDER BY TAC_ROLE, AFX_NUM";

$activite = array();
$activiteBackup = array();
$nb_act_backup = 0;

for($i = 1; $i <= 6; ++$i)
	$activite[$i] = array();

$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
{
	$i = (int) $row['TAC_ROLE'];
	
	$type = $row['ACT_LIBEL'];
	$libel = $row['AFX_LIBEL'];
	$moteur = $row['AFX_NUMPROC'];
	
	if (($moteur == 0) || ($multiMoteurs == FLX_MOTEURS_PAR_DEFAUT))
	{
		// Recuperer le moteur par defaut associe a ce type d'activite
		$reqMoteurs = "SELECT ACT_NUMPROC
				   FROM ACTIVITE
				   WHERE ACT_ID = '".$row['ACT_ID']."'";
		$gDb->SQLQuery($reqMoteurs,5);
		$rowMoteur = $gDb->SQLNextRow(5);
		$moteur = $rowMoteur['ACT_NUMPROC'];
		$gDb->SQLFermeQuery(5);
	}

	$isBackup = $row['AFX_BACKUP_FROM']!=NULL ? true : false;
	$backupID = (int) $row['AFX_BACKUP_ID'];
	
	switch($row['AFX_ACTIF']) {
		case ETAT_ACTIF:
			$actif = true;
			break;
		case ETAT_INACTIF:
			$actif = false;
			break;
		default:
			$actif = false;
	}
	
	if ($i == ID_TRAITEMENT && $row['AFX_SUIVI'] == MODE_SUIVI)
		$type = "($lang_lbl_suivi) $type";
	
	if($i == 5 && $row['TAC_NUM'] == TAC_NUM_RAPPROCH)
		$j = 6;
	else $j = $i;
	
	if($isBackup==false)
	{
		$activite[$j][] = array("type" => $type, "libel" => $libel, "afx_id" => $row['AFX_ID'],
							"pge_id" => $row['PGE_ID'],
							"backup_id" => $backupID,
							"actif" => $actif,
							"moteur" => $moteur);
	}
	else
	{
		$nb_act_backup++;
		$activiteBackup[(int)$row['AFX_ID']] = array("type" => $type, "libel" => $libel, "afx_id" => $row['AFX_ID'],
							"pge_id" => $row['PGE_ID'],
							"actif" => $actif,
							"moteur" => $moteur);
	}
}
$gDb->SQLFermeQuery(1);

$tac_role = array();
$tac_role[1] = array("caption" => $lang_flux_gest_aff_title_coll,
					"icon" => $pathStyle.'imgs/icons/gest_flux/collecte.gif');
					
$tac_role[2] = array("caption" => $lang_flux_gest_aff_title_pretrait,
					"icon" => $pathStyle.'imgs/icons/gest_flux/pretrait.gif');
					
$tac_role[3] = array("caption" => $lang_flux_gest_aff_title_trait,
					"icon" => $pathStyle.'imgs/icons/gest_flux/traitement.gif');

$tac_role[4] = array("caption" => $lang_flux_gest_aff_title_posttrait,
					"icon" => $pathStyle.'imgs/icons/gest_flux/posttrait.gif');


$tac_role[5] = array("caption" => $lang_flux_gest_aff_title_present,
					"icon" => $pathStyle.'imgs/icons/gest_flux/present.gif');

$TACPresent = array();
$TACPresent[TAC_NUM_RAPPROCH] = isTACPresent(TAC_NUM_RAPPROCH);
					
if ($TACPresent[TAC_NUM_RAPPROCH]){
	$tac_role[6] = array("caption" => $lang_flux_gest_aff_title_rapproch,
						"icon" => $pathStyle.'imgs/icons/gest_flux/rapproch.gif');
	$cpt=6;					
} else {
	$cpt=5;
}

$sortie ='';
$nb_pres = 0;
$nb_trait = 0;
for($i = 1; $i <= $cpt; ++$i) {
	$sortie .= '<role name="'.$tac_role[$i]["caption"].'">';
	$j = 0;
	foreach($activite[$i] as $act)
	{
		if($i==5)
		{
			$nb_act = count($activite[$i]) + $nb_act_backup;
			if(count($activite[$i])>$nb_pres)
				$nb_pres = count($activite[$i]);
		}
		else
		{
			$nb_act = count($activite[$i]);
			if(count($activite[$i])>$nb_trait)
				$nb_trait = count($activite[$i]);
		}
		
		/*$value = array("afx_id" => $act['afx_id'],
						"pge_id" => $act['pge_id'],
						"position" => $j++,
						"tac_role" => $i,
						"backup_from" => '',
						"backup_id" => $act['backup_id'],
						"length" => $nb_act);*/
		$sortie .= '<activite value="'.$act['afx_id'].'" caption="'.hi_disp($act['type']).'" param="'.hi_disp($act['libel']).'" icon="'.$tac_role[$i]["icon"].'" actif="'.$act['actif'].'" moteur="'.$act['moteur'].'" afx_id="'.$act['afx_id'].'">';
		
		// présentation de backup
		if($i==5 && $act['backup_id']!=NULL)
		{
			$backup = $activiteBackup[(int)$act['backup_id']];
			/*$value = array("afx_id" => $backup['afx_id'],
						"pge_id" => $backup['pge_id'],
						"position" => $j++,
						"tac_role" => $i,
						"backup_from" => $act['afx_id'],
						"backup_id" => '',
						"length" => $nb_act);*/
			$sortie .= '<activite value="'.$backup['afx_id'].'" caption="'.hi_disp($backup['type']).'" param="'.hi_disp($backup['libel']).'" icon="'.$tac_role[$i]["icon"].'" actif="'.$backup['actif'].'" moteur="'.$backup['moteur'].'" afx_id="'.$backup['afx_id'].'" />';
		}
		
		$sortie .= '</activite>';
	}
	$sortie.= '</role>';	
}

$sortie .= '</flux>';

echo '<?xml version="1.0" encoding="UTF-8"?><flux width="'.($cpt + ($nb_act_backup>0 ? 1 : 0)).'" height="'.($nb_trait>$nb_pres ? $nb_trait : $nb_pres).'" block="'.$flx_bloq.'">'.$sortie;

?>