<?php
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

function New_Flux(&$flux_id, &$msg)
{
	global $gDb, $lang_flux_trait_new_flux_msgerr_nopart,
	$lang_flux_trait_new_flux_msgerr_noformat,
	$lang_flux_trait_new_flux_msgerr_notalt,
	$lang_flux_trait_new_flux_msgerr_generique;

	$clt_id = $_SESSION['CLT_ID'];

	//R�cup�ration du premier partenaire de la table PART
	$req = "SELECT PAR_ID, PAR_NOM
            FROM PART
            WHERE PAR_NOM != ' TOUS'
            AND PAR_ETAT != ".ETAT_SUPPR."
            AND CLT_ID = $clt_id
            ORDER BY PAR_NOM";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);

	if (empty($row['PAR_ID']))
	{
		$msg = $lang_flux_trait_new_flux_msgerr_nopart;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$flux_emetteur      = $row['PAR_ID'];
	$flux_destinataire  = $row['PAR_ID'];
	$gDb->SQLFermeQuery(1);

	//R�cup�ration du premier format de la table FORMAT
	$req = "select FOR_ID, FOR_NOM
            from `FORMAT`
            where CLT_ID = $clt_id
            and FOR_ETAT != ".ETAT_SUPPR."
            order by FOR_NOM";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	if (empty($row['FOR_ID']))
	{
		$msg = $lang_flux_trait_new_flux_msgerr_noformat;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$flux_document = $row['FOR_ID'];
	$gDb->SQLFermeQuery(1);

	//R�cup�ration du 1er type d'alerte de la table TYP_ALERTE
	$req = "select TAL_ID, TAL_LIBEL
            from TYP_ALERTE
            where TAL_ETAT != ".ETAT_SUPPR."
            and CLT_ID = $clt_id
            order by TAL_LIBEL";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	if (empty($row['TAL_ID']))
	{
		$msg = $lang_flux_trait_new_flux_msgerr_notalt;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$flux_alerte = $row['TAL_ID'];
	$gDb->SQLFermeQuery(1);
	
	// Dernier rang ?
	$req = "SELECT MAX(FLX_RANG) AS MAXRANG FROM FLUX";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	$new_rang = intval($row['MAXRANG']) + 1;
	$gDb->SQLFermeQuery(1);

	//Insertion en base du flux dans FLUX
	$req = "INSERT INTO FLUX
            (CLT_ID, FLX_ACTIF, FLX_LIBEL, PAR_EMET_ID, PAR_DEST_ID, FLX_COLLECTE, FLX_PRESENTATION, FLX_MULTIMOTEURS,
            FOR_ID, FLX_SENS, FLX_TRACE, FLX_TEST, FLX_SIMUL, FLX_SUPPR_FIC, TAL_ID, FLX_ETAT, FLX_LOG, FLX_RANG)
            values (
            $clt_id
            , ".ETAT_INACTIF.
            ", 'lib_flux'
            , $flux_emetteur
            , $flux_destinataire
            , 1
            , 0
            , 0
            , $flux_document
            , ".EMISSION.
            ", ".MODE_NTRACE.
            ", ".MODE_NTEST.
            ", ".MODE_NSIMUL.
            ", ".NSUPPR_FIC.
            ", $flux_alerte
            , ".STATUS_NON_VERIF.
            ", 0
			, $new_rang)";

            if ($gDb->SQLQuery($req, 1) == false)
            {
            	$msg = $lang_flux_trait_new_flux_msgerr_generique;
            	$gDb->SQLFermeQuery(1);
            	return -1;
            }

            $gDb->SQLFermeQuery(1);
            $flux_id = $gDb->SQLLastID();
            return 0;
}

function Duplic_Flux(&$flux_id, &$msg)
{
	global $gDb, $tabCorresAFX_ID,
	$lang_flux_trait_duplic_flux_msgerr_generique;
	
	// Dernier rang ?
	$req = "SELECT MAX(FLX_RANG) AS MAXRANG FROM FLUX";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	$new_rang = intval($row['MAXRANG']) + 1;
	$gDb->SQLFermeQuery(1);

	$clt_id = $_SESSION['CLT_ID'];

	$req = "select FLX_ACTIF, FLX_LIBEL, PAR_EMET_ID, PAR_DEST_ID, FOR_ID, FLX_SENS,
            FLX_TRACE, FLX_TEST, FLX_SIMUL, FLX_SUPPR_FIC, TAL_ID, FLX_ETAT, FLX_COLLECTE, FLX_PRESENTATION, FLX_MULTIMOTEURS, FLX_LOG, FLX_COULEUR 
            from FLUX
            where FLX_ID = $flux_id";
	$gDb->SQLQuery($req,1);
	$row=$gDb->SQLNextRow(1);
	$req = "insert into FLUX (CLT_ID, FLX_ACTIF, FLX_LIBEL, PAR_EMET_ID, PAR_DEST_ID, FLX_COLLECTE, FLX_PRESENTATION, FLX_MULTIMOTEURS,
            FOR_ID, FLX_SENS, FLX_TRACE, FLX_TEST, FLX_SIMUL, FLX_SUPPR_FIC, TAL_ID, FLX_ETAT, FLX_LOG, FLX_COULEUR, FLX_RANG) values
            ($clt_id
            , ".$row['FLX_ACTIF'].
            ", '".dblQ($row['FLX_LIBEL'])."'
            , ".$row['PAR_EMET_ID'].
            ", ".$row['PAR_DEST_ID'].
            ", ".$row['FLX_COLLECTE'].
            ", ".$row['FLX_PRESENTATION'].
            ", ".$row['FLX_MULTIMOTEURS'].
            ", ".$row['FOR_ID'].
            ", ".$row['FLX_SENS'].
            ", ".$row['FLX_TRACE'].
            ", ".$row['FLX_TEST'].
            ", ".$row['FLX_SIMUL'].
            ", ".$row['FLX_SUPPR_FIC'].
            ", ".$row['TAL_ID'].
            ", ".STATUS_NON_VERIF.
            ", ".$row['FLX_LOG'].
			", '".$row['FLX_COULEUR']."'
			, $new_rang
			)";
	if ($gDb->SQLQuery($req, 2) == false)
	{
		$msg = $lang_flux_trait_duplic_flux_msgerr_generique;
		$gDb->SQLFermeQuery(2);
		return -1;
	}
	$gDb->SQLFermeQuery(2);
	$new_flux_id = $gDb->SQLLastID();
	$gDb->SQLFermeQuery(1);

	$req = "select AFX_ID, AFX_ACTIF, AFX_LIBEL, AFX_SUIVI, ACT_ID, PGE_ID, AFX_NUM, AFX_NUMPROC, AFX_BACKUP_FROM, AFX_BACKUP_ID, AFX_TYPE_ALERTE
            from ACTFLUX
            where FLX_ID = $flux_id
            and AFX_ACTIF != ".ETAT_SUPPR." order by AFX_NUM";
	$gDb->SQLQuery($req,1);
	while ($row = $gDb->SQLNextRow(1))
	{
		$req = "insert into ACTFLUX (CLT_ID, AFX_ACTIF, FLX_ID, ACT_ID, AFX_NUM, AFX_LIBEL,
                AFX_SUIVI, PGE_ID, AFX_NUMPROC, AFX_TYPE_ALERTE) values
                ($clt_id
                , ".$row['AFX_ACTIF'].
                ", ".$new_flux_id .
                ", ".$row['ACT_ID'].
                ", ".$row['AFX_NUM'].
                ", '".dblQ($row['AFX_LIBEL'])."'
                , ".$row['AFX_SUIVI'].
                ", ".((isset($row['PGE_ID']))?($row['PGE_ID']):("null")).
                ", ".$row['AFX_NUMPROC'].", ".$row['AFX_TYPE_ALERTE'].")"; // Bz4208 : 06/02/2012 : B. Gardes : ajout AFX_TYPE_ALERTE
		if ($gDb->SQLQuery($req, 2) == false)
		{
			$msg = $lang_flux_trait_duplic_flux_msgerr_generique;
			$gDb->SQLFermeQuery(2);
			$gDb->SQLFermeQuery(1);
			return -1;
		}

		$new_afx_id = $gDb->SQLLastID(2);
		$gDb->SQLFermeQuery(2);
		$tabCorresAFX_ID[$row['AFX_ID']] = $new_afx_id;

		if (isset($row['AFX_BACKUP_FROM']) && isset($tabCorresAFX_ID[$row['AFX_BACKUP_FROM']]))
		{
			$req = "UPDATE ACTFLUX SET AFX_BACKUP_FROM=".$tabCorresAFX_ID[$row['AFX_BACKUP_FROM']].
                   " WHERE AFX_ID=$new_afx_id";
			$gDb->SQLQuery($req,2);
			$req = "UPDATE ACTFLUX SET AFX_BACKUP_ID=".$new_afx_id.
                   " WHERE AFX_ID=".$tabCorresAFX_ID[$row['AFX_BACKUP_FROM']];
			$gDb->SQLQuery($req,2);
		}
		$req = "select PFL_ID, VAF_VAL
                from VAL_ACT_FLUX
                where AFX_ID = ".$row['AFX_ID'];
		$gDb->SQLQuery($req,2);
		while ($row2 = $gDb->SQLNextRow(2))
		{
			$NewVal = $row2['VAF_VAL'];
			preg_match_all("/#\{([0-9]+)\.[^\}]+\}/",$NewVal, $resReg );
			$i=0;
			while ($resReg[1][$i])
			{
				$NewVal=preg_replace( "/#\{".$resReg[1][$i]."\.([^\}]+)\}/" , "#{".$tabCorresAFX_ID[$resReg[1][$i]].".\\1}", $NewVal );
				$i++;
			}

			$req = "insert into VAL_ACT_FLUX (CLT_ID, AFX_ID, PFL_ID, VAF_VAL) values
                    ($clt_id
                    , $new_afx_id.
                    , ".$row2['PFL_ID'].
                    ", '".dblQ($NewVal)."')";
			if ($gDb->SQLQuery($req, 3) == false)
			{
				$msg = $lang_flux_trait_duplic_flux_msgerr_generique;
				$gDb->SQLFermeQuery(3);
				$gDb->SQLFermeQuery(2);
				$gDb->SQLFermeQuery(1);
				return -1;
			}
			$gDb->SQLFermeQuery(3);
		}
		$gDb->SQLFermeQuery(2);
	}
	$gDb->SQLFermeQuery(1);

	$req = "select PLA_ACTIF, PLA_MOIS, PLA_JOUR, PLA_JOURSEM, PLA_HEURE,
            PLA_MINUTE, PLA_DELAIDEM
            from PLANIF
            where FLX_ID = $flux_id
            and PLA_ACTIF != ".ETAT_SUPPR."
            order by PLA_ID desc";
	$gDb->SQLQuery($req, 1);
	while ($row = $gDb->SQLNextRow(1))
	{
		$req = "insert into PLANIF (CLT_ID, FLX_ID, PLA_ACTIF, PLA_MOIS, PLA_JOUR, PLA_JOURSEM,
                PLA_HEURE, PLA_MINUTE, PLA_DELAIDEM) values
                ($clt_id
                , $new_flux_id
                , ".$row['PLA_ACTIF'].
                ", '".$row['PLA_MOIS']."'
                , '".$row['PLA_JOUR']."'
                , '".$row['PLA_JOURSEM']."'
                , '".$row['PLA_HEURE']."'
                , '".$row['PLA_MINUTE']."'
                , ".$row['PLA_DELAIDEM'].")";
		if ($gDb->SQLQuery($req, 2) == false)
		{
			$msg = $lang_flux_trait_duplic_flux_msgerr_generique;
			$gDb->SQLFermeQuery(2);
			$gDb->SQLFermeQuery(1);
			return -1;
		}
	}
	$gDb->SQLFermeQuery(1);
	$flux_id = $new_flux_id;
	return 0;
}

function Update_Flux($flux, &$msg)
{
	global $gDb, $lang_flux_trait_update_flux_msgerr_generique;

	$req = "UPDATE FLUX SET
            CLT_ID = ".$flux['clt_id'].
            ", FLX_ACTIF = ".$flux['flx_actif'].
            ", FLX_LIBEL = ".$flux['flx_libel'].
            ", PAR_EMET_ID = ".$flux['par_emet_id'].
            ", PAR_DEST_ID = ".$flux['par_dest_id'].
            ", FLX_COLLECTE = ".$flux['flx_collecte'].
            ", FLX_PRESENTATION = ".$flux['flx_presentation'].
            ", FLX_MULTIMOTEURS = ".$flux['flx_multimoteurs'].
            ", FOR_ID = ".$flux['for_id'].
            ", FLX_SENS = ".$flux['flx_sens'].
            ", FLX_TRACE = ".$flux['flx_trace'].
            ", FLX_TEST = ".$flux['flx_test'].
            ", FLX_SIMUL = ".$flux['flx_simul'].
            ", FLX_SUPPR_FIC = ".$flux['flx_suppr_fic'].
            ", TAL_ID = ".$flux['tal_id'].
            ", FLX_ETAT = ".STATUS_NON_VERIF.
            ", FLX_LOG = ".$flux['flx_log'].
			", FLX_COULEUR = ".$flux['flx_couleur'].
            " where FLX_ID = ".$flux['flx_id'];

	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_update_flux_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	return 0;
}

function Move_Flux($flx_id, $sens)
{
	global $gDb;
	
	$fatal = 0;
	
	$req = "SELECT FLX_RANG FROM FLUX WHERE FLX_ID=$flx_id";
	if ($gDb->SQLQuery($req, 1) == false)
		$fatal = true;
	else
	{
		$flx_rang = $gDb->SQLNextRow(1);
		$flx_rang = $flx_rang[0];
		$gDb->SQLFermeQuery(1);
		$req = "UPDATE FLUX SET FLX_RANG=$flx_rang WHERE FLX_RANG=".(intval($flx_rang)+$sens);
		if ($gDb->SQLQuery($req, 1) == false)
			$fatal = true;
		else
		{
			$gDb->SQLFermeQuery(1);
			$req = 'UPDATE FLUX SET FLX_RANG=FLX_RANG'.($sens>0?'+1':'-1')." WHERE FLX_ID=$flx_id";
			if ($gDb->SQLQuery($req, 1) == false)
				$fatal = true;
		}
	}
	$gDb->SQLFermeQuery(1);
	
	return $fatal;
}

function New_Activite($act, &$msg, &$afx_id)
{
	global $gDb, $lang_flux_trait_new_activite_msgerr_generique,
	$lang_flux_trait_new_activite_msgerr_update_flux;

	if(empty($act['AFX_BACKUP_FROM']))
	$act['AFX_BACKUP_FROM'] = 'NULL';

	$req = "INSERT INTO ACTFLUX (CLT_ID, AFX_ACTIF, FLX_ID, ACT_ID, AFX_NUM,
            AFX_LIBEL, AFX_SUIVI, PGE_ID, AFX_NUMPROC, AFX_BACKUP_FROM, AFX_BACKUP_ID) values
            (".$act['CLT_ID'].
    ", ".$act['AFX_ACTIF'].
    ", ".$act['FLX_ID'].
    ", ".$act['ACT_ID'].
    ", ".$act['AFX_NUM'].
    ", ".$act['AFX_LIBEL'].
    ", ".$act['AFX_SUIVI'].
    ", ".$act['PGE_ID'].
    ", ".$act['AFX_NUMPROC'].
    ", ".$act['AFX_BACKUP_FROM'].
    ", NULL)";
	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_new_activite_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	$afx_id = $gDb->SQLLastID();

	if($act['AFX_BACKUP_FROM']!='NULL')
	{
		$req = "UPDATE ACTFLUX SET
                AFX_BACKUP_ID = ".$afx_id.
                " where FLX_ID = ".$act['FLX_ID'].
                " and AFX_ID = ".$act['AFX_BACKUP_FROM'];

		if ($gDb->SQLQuery($req, 1) == false)
		{
			$msg = $lang_flux_trait_update_flux_msgerr_generique;
			$gDb->SQLFermeQuery(1);
			return -1;
		}
		$gDb->SQLFermeQuery(1);
	}

	$req = "SELECT PFL_ID, PFL_DEFAUT
            FROM PAR_FLOW, ACTIVITE
            WHERE ACT_ID = ".$act['ACT_ID']."
            AND ACTIVITE.TAC_NUM = PAR_FLOW.TAC_NUM
            AND PFL_ROLE = ".PARAM_ROLE_ACTIVITE;
	$gDb->SQLQuery($req, 1);
	while ($row = $gDb->SQLNextRow(1))
	{
		$req = "INSERT INTO VAL_ACT_FLUX (CLT_ID, AFX_ID, PFL_ID, VAF_VAL) values
                (".$act['CLT_ID'].
        ", ".$afx_id.
        ", ".$row['PFL_ID'].
                ", '".$row['PFL_DEFAUT']."')";
		if ($gDb->SQLQuery($req, 2) == false)
		{
			$msg = $lang_flux_trait_new_activite_msgerr_update_flux;
			$gDb->SQLFermeQuery(2);
			$gDb->SQLFermeQuery(1);
			return -1;
		}
		$gDb->SQLFermeQuery(2);
	}
	return 0;
}

function New_Planif($pla, &$msg, &$pla_id)
{
	global $gDb, $lang_flux_trait_new_planif_msgerr_generique;
	$req = "INSERT INTO PLANIF (CLT_ID, FLX_ID, PLA_ACTIF, PLA_MOIS, PLA_JOUR,
            PLA_JOURSEM, PLA_HEURE, PLA_MINUTE, PLA_DELAIDEM, PLA_IMMEDIAT, PLA_DATEDER)
            VALUES (".$pla['CLT_ID'].
            ", ".$pla['FLX_ID'].
            ", ".$pla['PLA_ACTIF'].
            ", ".$pla['PLA_MOIS'].
            ", ".$pla['PLA_JOUR'].
            ", ".$pla['PLA_JOURSEM'].
            ", ".$pla['PLA_HEURE'].
            ", ".$pla['PLA_MINUTE'].
            ", ".$pla['PLA_DELAIDEM'].
            ", ".$pla['PLA_IMMEDIAT'].
            ", ".$pla['PLA_DATEDER'].")";
	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_new_planif_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	$pla_id = $gDb->SQLLastID();

	return 0;
}

function Update_Planif($pla, &$msg)
{
	global $gDb, $lang_flux_trait_update_planif_msgerr_generique;

	$req = "UPDATE PLANIF SET
            PLA_ACTIF       = ".$pla['PLA_ACTIF'].
            ", PLA_MOIS     = ".$pla['PLA_MOIS'].
            ", PLA_JOUR     = ".$pla['PLA_JOUR'].
            ", PLA_JOURSEM  = ".$pla['PLA_JOURSEM'].
            ", PLA_HEURE    = ".$pla['PLA_HEURE'].
            ", PLA_MINUTE   = ".$pla['PLA_MINUTE'].
            ", PLA_IMMEDIAT = ".$pla['PLA_IMMEDIAT'].
            ", PLA_DELAIDEM = ".$pla['PLA_DELAIDEM'].
            " WHERE PLA_ID  = ".$pla['PLA_ID'];

	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_update_planif_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);

	return 0;
}

function Decalle_Activites($flux_id, $afx_num, &$msg, $sens = "plus")
{
	global $gDb, $lang_flux_trait_decale_activites_msgerr_update_flux;

	if ($sens == "moins") $temp = -1; else $temp = 0;
	$req = "SELECT AFX_ID
            FROM ACTFLUX, ACTIVITE, TYPE_ACT
            WHERE FLX_ID = $flux_id
            AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID
            AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM
            AND AFX_ACTIF != ".ETAT_SUPPR."
            AND AFX_NUM >= $afx_num
            ORDER BY TAC_ROLE, AFX_NUM";
	$gDb->SQLQuery($req,1);
	$nb = 0;
	while ($row = $gDb->SQLNextRow(1))
	{
		$nb++;
		$req = "UPDATE ACTFLUX
                SET AFX_NUM = ".($afx_num + $nb + $temp)."
                WHERE AFX_ID = ".$row['AFX_ID'];
		if ($gDb->SQLQuery($req, 2) == false)
		{
			$msg = $lang_flux_trait_decale_activites_msgerr_update_flux;
			$gDb->SQLFermeQuery(2);
			$gDb->SQLFermeQuery(1);
			return -1;
		}
		$gDb->SQLFermeQuery(2);
	}
	$gDb->SQLFermeQuery(1);
	return 0;
}

function Update_Activites(&$activite, &$msg)
{
	global $gDb, $lang_flux_trait_update_activites_msgerr_generique,
	$lang_flux_trait_update_activites_msgerr_update_param;

	$clt_id = $_SESSION["CLT_ID"];

	$nb = 0;

	if ($activite['afx_id'])
	{
		if($activite['afx_suivi'] == MODE_SUIVI) {
			//Recherche si une autre activite de traitement du flux possède le suivi
			//et on lui enlève le suivi
			//(une seule activité de traitement à la fois peut avoir le suivi)
			$req = "SELECT FLX_ID
                    FROM ACTFLUX
                    WHERE AFX_ID = ".$activite['afx_id'];
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);
			$flx_id = $row['FLX_ID'];
			$gDb->SQLFermeQuery(1);

			if($flx_id) {
				$req = "SELECT AFX_ID FROM ACTFLUX
                        WHERE AFX_SUIVI = 1
                        AND FLX_ID = $flx_id";
				$gDb->SQLQuery($req, 1);
				$row = $gDb->SQLNextRow(1);
				$nsuivi_afx_id = $row["AFX_ID"];
				$gDb->SQLFermeQuery(1);

				if($nsuivi_afx_id) {
					$req = "UPDATE ACTFLUX
                            SET AFX_SUIVI = ".MODE_NSUIVI."
                            WHERE AFX_ID = ".$nsuivi_afx_id;
					$gDb->SQLQuery($req, 1);
					$gDb->SQLFermeQuery(1);
				}
			}
		}
		
		// Bz4208 : 06/02/2012 : B. Gardes : ajout AFX_TYPE_ALERTE
		$req = "UPDATE ACTFLUX SET
                    AFX_ACTIF = ".$activite['afx_actif'].",
					AFX_TYPE_ALERTE = ".$activite['afx_type_alerte'].", 
                    AFX_SUIVI = ".$activite['afx_suivi'].",
                    AFX_LIBEL = '".dblQ($activite['afx_libel'])."',
                    PGE_ID = ".$activite['pge_id'].",
                    AFX_NUMPROC = ".$activite['afx_numproc']."
                WHERE AFX_ID = ".$activite['afx_id'];

		if ($gDb->SQLQuery($req, 1) == false)
		{
			$msg = $lang_flux_trait_update_activites_msgerr_generique;
			$gDb->SQLFermeQuery(1);
			return -1;
		}
		$gDb->SQLFermeQuery(1);

		//Parcours des paramètres de l'activité
		if(count($activite["param"]) > 0) {
			$req = "SELECT PFL_ID
                    FROM PAR_FLOW, ACTIVITE
                    WHERE ACT_ID = '".$activite['act_id']."'
                    AND PAR_FLOW.TAC_NUM = ACTIVITE.TAC_NUM
                    AND PFL_ROLE = ".PARAM_ROLE_ACTIVITE;

			$gDb->SQLQuery($req,1);
			while ($row = $gDb->SQLNextRow(1))
			{
				$req = "SELECT COUNT(*) AS NB
                        FROM VAL_ACT_FLUX
                        WHERE AFX_ID = ".$activite['afx_id']."
                        AND PFL_ID = ".$row['PFL_ID'];

				if ($gDb->SQLQuery($req, 2) == false) $fatal = true;
				$existe = $gDb->SQLNextRow(2);
				$gDb->SQLFermeQuery(2);

				if ($existe['NB'] == 0)
				{
					$req = "INSERT INTO VAL_ACT_FLUX (CLT_ID, AFX_ID, PFL_ID, VAF_VAL) VALUES
                            ($clt_id, ".$activite['afx_id'].",
                            ".$row['PFL_ID'].",
                            '".dblQ($activite['param'][$row['PFL_ID']])."')";

					if ($gDb->SQLQuery($req, 2) == false)
					{
						$msg = $lang_flux_trait_update_activites_msgerr_update_param;
						$gDb->SQLFermeQuery(2);
						$gDb->SQLFermeQuery(1);
						return -1;
					}
					$gDb->SQLFermeQuery(2);
				}
				else if ($existe['NB'] > 0)
				{
					$req = "UPDATE VAL_ACT_FLUX SET
                            VAF_VAL = '".dblQ($activite['param'][$row['PFL_ID']])."'
                            WHERE AFX_ID = ".$activite['afx_id']."
                                AND PFL_ID = ".$row['PFL_ID'];

					if ($gDb->SQLQuery($req, 2) == false)
					{
						$msg = $lang_flux_trait_update_activites_msgerr_update_param;
						$gDb->SQLFermeQuery(2);
						$gDb->SQLFermeQuery(1);
						return -1;
					}
					$gDb->SQLFermeQuery(2);
				}
			}
			$gDb->SQLFermeQuery(1);
		}
	}
}

function Verif_Flux_Activites($flx_id, &$msg) {
	global $gDb,$lang_msg_err_no_field;

	$req = "SELECT PFL_LIBEL, AFX_LIBEL
            FROM ACTFLUX JOIN VAL_ACT_FLUX ON (ACTFLUX.AFX_ID = VAL_ACT_FLUX.AFX_ID)
                JOIN PAR_FLOW ON (VAL_ACT_FLUX.PFL_ID = PAR_FLOW.PFL_ID)
            WHERE ACTFLUX.FLX_ID = $flx_id
                AND PFL_OBLIG = 1
                AND AFX_ACTIF != 2
                AND (VAF_VAL = '' OR VAF_VAL IS NULL)";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	if($row['PFL_LIBEL'])
	{
		$msg = str_replace("%FIELDNAME%", $row['PFL_LIBEL']." (".$row['AFX_LIBEL'].")", $lang_msg_err_no_field);
		return -1;
	}
	return 0;
}

function Verif_Flux($flux_id, &$msg)
{
	global $gDb, $lang_flux_trait_verif_flux_msgok,
	$lang_flux_trait_verif_flux_msgwarn_dup_group,
	$lang_flux_trait_verif_flux_msgwarn_dup_degroup,
	$lang_flux_trait_verif_flux_msgwarn_group_before_degroup,
	$lang_flux_trait_verif_flux_msgwarn_suivi_simple_before_degroup,
	$lang_flux_trait_verif_flux_msgwarn_suivi_simple_after_group,
	$lang_flux_trait_verif_flux_msgwarn_no_col,
	$lang_flux_trait_verif_flux_msgwarn_dup_col,
	$lang_flux_trait_verif_flux_msgwarn_col_commun_no_pretrait,
	$lang_flux_trait_verif_flux_msgwarn_no_trait,
	$lang_flux_trait_verif_flux_msgwarn_no_posttrait,
	$lang_flux_trait_verif_flux_msgwarn_no_pres,
	$lang_flux_trait_verif_flux_msgwarn_dup_suivi,
	$lang_flux_trait_verif_flux_msgwarn_err_param,
	$lang_flux_trait_verif_flux_msgwarn_err_param_syntax,
	$lang_flux_trait_verif_flux_msgwarn_err_param_semantic,
	$lang_flux_trait_verif_flux_msgok,
	$lang_flux_trait_verif_flux_msgwarn_err_demat_dernier, //Pour Démat
	$lang_flux_trait_verif_flux_msgwarn_err_demat_premier; //Pour Démat

	//Si le flux est dans l'état inactif pas besoin de vérifier
	$req = "SELECT FLX_ACTIF, FLX_COLLECTE
            FROM FLUX
            WHERE FLX_ID = $flux_id";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	//if ($row['FLX_ACTIF'] == ETAT_INACTIF)
	//{
	//  $gDb->SQLQuery($req,1);
	//  $msg = $lang_flux_trait_verif_flux_msgok;
	//  if (Maj_Etat_Flux($flux_id, $msg, STATUS_OK) < 0) return -1;
	//  return 1;
	//}
	$flx_collecte = $row['FLX_COLLECTE'];
	$gDb->SQLQuery($req,1);

	//Vérification des regles suivantes :
	// N = Activité de traitement de type Normale
	// D = Activité de traitement de type Degroupage
	// G = Activité de traitement de type Groupage
	// N(0..n),     D(0..1)(S),     N(0..n)(S),     G(0..1),    N(0..n)
	$req = "SELECT TAC_FLAG, AFX_SUIVI
            FROM ACTFLUX, ACTIVITE, TYPE_ACT
            WHERE FLX_ID = $flux_id
            AND AFX_ACTIF = ".ETAT_ACTIF."
            AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID
            AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM
            AND TAC_ROLE = ".ID_TRAITEMENT."
            ORDER by AFX_NUM";
	$gDb->SQLQuery($req,1);
	$nb_s = $nb_d = $nb_g = 0;
	$pos_s = $pos_d = $pos_g = 0;
	$i = 0;
	while ($row = $gDb->SQLNextRow(1))
	{
		$i++;
		switch($row['TAC_FLAG'])
		{
			case ACT_SIMPLE :
				if ($nb_s == 0) $pos_s = $i;
				if ($row['AFX_SUIVI'] == MODE_SUIVI) $sui_s = $i;
				$nb_s++;
				break;
			case ACT_DEGROUPE :
				if ($nb_d == 0) $pos_d = $i;
				if ($row['AFX_SUIVI'] == MODE_SUIVI) $sui_d = $i;
				$nb_d++;
				break;
			default :
				if ($nb_g == 0) $pos_g = $i;
				$nb_g++;
		}
	}
	$gDb->SQLQuery($req,1);
	if ($nb_g > 1)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_dup_group;
		$gDb->SQLFermeQuery(1);
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}
	if ($nb_d > 1)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_dup_degroup;
		$gDb->SQLFermeQuery(1);
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}
	if ($nb_g != 0 && $nb_d != 0 && $pos_d > $pos_g)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_group_before_degroup;
		$gDb->SQLFermeQuery(1);
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}
	if ($sui_s != 0 && $sui_s < $pos_d)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_suivi_simple_before_degroup;
		$gDb->SQLFermeQuery(1);
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}
	if ($sui_s != 0 && $nb_g > 0 && $sui_s > $pos_g)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_suivi_simple_after_group;
		$gDb->SQLFermeQuery(1);
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}

	//Au moins une activité par type d'activité
	//Sauf pour l'acitivé de pretraitement si l'activité de collecte est commune à plusieurs flux
	$nb_coll = $nb_pret = $nb_trait = $nb_post = $nb_pres = false;
	$nb_collecte = $nb_pretrait = $nb_traitement = $nb_posttrait = $nb_present = 0;
	$req = "SELECT TYPE_ACT.TAC_ROLE
            FROM ACTFLUX, ACTIVITE, TYPE_ACT
            WHERE ACTFLUX.FLX_ID = $flux_id
            AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID
            AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM
            AND AFX_ACTIF = ".ETAT_ACTIF."
            ORDER BY TYPE_ACT.TAC_ROLE";
	$gDb->SQLQuery($req,1);
	if ($flx_collecte == FLX_COLLECTE_SPEC) $nb_pret = true;
	while ($row = $gDb->SQLNextRow(1))
	{
		switch ($row['TAC_ROLE'])
		{
			case ID_COLLECTE :      $nb_coll = true;    $nb_collecte++;     break;
			case ID_PRETRAIT :      $nb_pret = true;    $nb_pretrait++;     break;
			case ID_TRAITEMENT :    $nb_trait = true;   $nb_traitement++;   break;
			case ID_POSTTRAIT :     $nb_post = true;    $nb_posttrait++;    break;
			case ID_PRESENT :       $nb_pres = true;    $nb_present++;      break;
		}
	}
	$gDb->SQLFermeQuery(1);
	if (!$nb_coll)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_no_col;
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_COLLECTE;
	}
	if ($nb_collecte > 1)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_dup_col;
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_COLLECTE;
	}
	if (!$nb_pret)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_col_commun_no_pretrait;
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_PRETRAIT;
	}
	if (!$nb_trait)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_no_trait;
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}
	//if (!$nb_post)
	if ($nb_posttrait > 1)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_no_posttrait;
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_POSTTRAIT;
	}
	if (!$nb_pres)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_no_pres;
		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_PRESENT;
	}
	/*if ($nb_present > 2)
	 {
	 $msg = "Le flux � �t� trait�, mais dans un flux actif, vous ne pouvez disposer de plus d'une activit� de pr�sentation dans l'�tat actif.
	 [1g-Verif_Flux()]";
	 if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
	 return A_PRESENT;
	 }*/


	//SC modif Démat
	//ctrl demat
	//si demat fiscale, recup de son afx_num
	$req = "SELECT ACTFLUX.AFX_NUM, ACTFLUX.AFX_ID, ACTFLUX.ACT_ID, ACTIVITE.ACT_ID, ACTIVITE.TAC_NUM FROM ACTFLUX, ACTIVITE WHERE ACTFLUX.FLX_ID = $flux_id AND
    ACTFLUX.ACT_ID = ACTIVITE.ACT_ID AND ACTIVITE.TAC_NUM = 27 AND ACTFLUX.AFX_ACTIF = ".ETAT_ACTIF." ORDER BY ACTFLUX.AFX_NUM";
	$gDb->SQLQuery($req,1);
	$afx_num = 0;
	$afx_id = 0;
	$row = $gDb->SQLNextRow(1);
	if ($row['AFX_NUM'])
	{
		$afx_num = $row['AFX_NUM'];
		$afx_id = $row['AFX_ID'];
	}
	$gDb->SQLFermeQuery(1);

	//verif si demat en emission ou en reception
	$req = "SELECT VAF_VAL FROM VAL_ACT_FLUX WHERE AFX_ID = $afx_id AND PFL_ID = 2703";
	$gDb->SQLQuery($req,1);
	$sens = 0;
	$row = $gDb->SQLNextRow(1);
	$sens = $row['VAF_VAL'];
	$gDb->SQLFermeQuery(1);
	if ($sens == 1)
	{
		//si demat fiscale en emission, ctrl que c'est le plus grand afx_num de role 3 du flux
		if ($afx_num > 0)
		{

			$req = "SELECT ACTFLUX.AFX_NUM, ACTFLUX.ACT_ID, ACTIVITE.ACT_ID, ACTIVITE.TAC_NUM, TYPE_ACT.TAC_NUM, TYPE_ACT.TAC_ROLE FROM ACTFLUX,
            ACTIVITE, TYPE_ACT WHERE ACTFLUX.FLX_ID = $flux_id AND ACTFLUX.AFX_ACTIF = ".ETAT_ACTIF." AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID AND
            ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM AND TYPE_ACT.TAC_ROLE = 3 AND ACTFLUX.AFX_NUM > $afx_num ORDER BY ACTFLUX.AFX_NUM";
			$gDb->SQLQuery($req,1);
			$row = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			if ($row['AFX_NUM'])
			{
				$msg = $lang_flux_trait_verif_flux_msgwarn_err_demat_dernier;

				if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
				return A_TRAITEMENT;
			}
		}
	}
	if ($sens == 2)
	{
		//si demat fiscale en reception, ctrl que c'est le plus petit afx_num de role 3 du flux
		if ($afx_num > 0)
		{

			$req = "SELECT ACTFLUX.AFX_NUM, ACTFLUX.ACT_ID, ACTIVITE.ACT_ID, ACTIVITE.TAC_NUM, TYPE_ACT.TAC_NUM, TYPE_ACT.TAC_ROLE FROM ACTFLUX,
            ACTIVITE, TYPE_ACT WHERE ACTFLUX.FLX_ID = $flux_id AND ACTFLUX.AFX_ACTIF = ".ETAT_ACTIF." AND ACTFLUX.ACT_ID = ACTIVITE.ACT_ID AND
            ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM AND TYPE_ACT.TAC_ROLE = 3 AND ACTFLUX.AFX_NUM < $afx_num ORDER BY ACTFLUX.AFX_NUM";
			$gDb->SQLQuery($req,1);
			$row = $gDb->SQLNextRow(1);
			$gDb->SQLFermeQuery(1);
			if ($row['AFX_NUM'])
			{
				$msg = $lang_flux_trait_verif_flux_msgwarn_err_demat_premier;

				if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
				return A_TRAITEMENT;
			}
		}
	}
	//fin ctrl demat





	//Une et une seul activit� de suivi (activite de traitement : degroupage ou simple)
	$req = "SELECT COUNT(*) AS NB
            FROM ACTFLUX
            WHERE AFX_ACTIF = ".ETAT_ACTIF."
            AND FLX_ID = $flux_id
            AND AFX_SUIVI = ".MODE_SUIVI;
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	if ($row['NB'] != 1)
	{
		$msg = $lang_flux_trait_verif_flux_msgwarn_dup_suivi;
		$gDb->SQLFermeQuery(1);

		if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
		return A_TRAITEMENT;
	}
	$gDb->SQLFermeQuery(1);

	//Vérification des macros
	$req = "SELECT ACTFLUX.AFX_ID, VAF_VAL, VAL_ACT_FLUX.PFL_ID, AFX_NUM, PFL_LIBEL, AFX_LIBEL
            FROM ACTFLUX, VAL_ACT_FLUX, PAR_FLOW
            WHERE FLX_ID = $flux_id
            AND VAL_ACT_FLUX.AFX_ID = ACTFLUX.AFX_ID
            AND VAL_ACT_FLUX.PFL_ID = PAR_FLOW.PFL_ID
            AND (PFL_TYPE = ".TYPE_PARACT_MACRO." or
            PFL_TYPE = ".TYPE_PARACT_CHEMIN_MACRO.")
            AND AFX_ACTIF = ".ETAT_ACTIF."
            ORDER BY AFX_NUM";
	$gDb->SQLQuery($req,1);

	require_once("macro/macro.php");

	while ($row = $gDb->SQLNextRow(1))
	{
		$msg = "";
		if (Analyse_Grammaire($row['VAF_VAL'], $msg, 0) == -1)
		{
			$gDb->SQLFermeQuery(1);
			if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
			$msg = str_replace(array("%PARAM_LIBEL%", "%PARAM_VALUE%", "%ACT_NUM%", "%ACT_LIBEL%"),
			array($row['PFL_LIBEL'], $row['VAF_VAL'], $row['AFX_NUM'], $row['AFX_LIBEL']),
			$lang_flux_trait_verif_flux_msgwarn_err_param)."($lang_flux_trait_verif_flux_msgwarn_err_param_syntax)";
			return -1;
		}
		$macros = substr($msg, 0, strlen($msg) - 1);
		$msg = "";
		if (verif_macro($row['VAF_VAL'], $macros, $flux_id, $row['AFX_NUM'], $msg) == -1)
		{
			$gDb->SQLFermeQuery(1);
			if (Maj_Etat_Flux($flux_id, $msg, STATUS_NOK) < 0) return -1;
			$msg = str_replace(array("%PARAM_LIBEL%", "%PARAM_VALUE%", "%ACT_NUM%", "%ACT_LIBEL%"),
			array($row['PFL_LIBEL'], $row['VAF_VAL'], $row['AFX_NUM'], $row['AFX_LIBEL']),
			$lang_flux_trait_verif_flux_msgwarn_err_param)."($lang_flux_trait_verif_flux_msgwarn_err_param_semantic)";
			return -1;
		}
	}
	$gDb->SQLFermeQuery(1);

	//flux valide
	$msg = $lang_flux_trait_verif_flux_msgok;
	if (Maj_Etat_Flux($flux_id, $msg, STATUS_OK) < 0) return -1;
	return 1;
}

function Maj_Etat_Flux($flux_id, &$msg, $etat)
{
	global $gDb, $lang_flux_trait_update_flux_msgerr_generique;
	$req = "UPDATE FLUX
            SET FLX_ETAT = $etat
            WHERE FLX_ID = $flux_id";
	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_update_flux_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	return 0;
}

function Maj_Actif_Activite($afx_id, &$msg, $etat)
{
	global $gDb, $lang_flux_trait_update_activites_msgerr_generique;

	$req = "UPDATE ACTFLUX
            SET AFX_ACTIF = $etat
            WHERE AFX_ID = $afx_id";
	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_update_activites_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	return 0;
}

function Sup_Backup_Activite($afx_id, &$msg)
{
	global $gDb, $lang_flux_trait_update_activites_msgerr_generique;

	$req = "UPDATE ACTFLUX SET
            AFX_BACKUP_ID = NULL
            WHERE AFX_ID = $afx_id";

	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_update_activites_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	return 0;
}

function Maj_Actif_Planif($pla_id, &$msg, $etat)
{
	global $gDb, $lang_flux_trait_update_planif_msgerr_generique;

	$req = "update PLANIF
            set PLA_ACTIF = $etat
            where PLA_ID = $pla_id";
	if ($gDb->SQLQuery($req, 1) == false)
	{
		$msg = $lang_flux_trait_update_planif_msgerr_generique;
		$gDb->SQLFermeQuery(1);
		return -1;
	}
	$gDb->SQLFermeQuery(1);
	return 0;
}

function Defaut_Pargen($act_id, &$pge_id, &$msg)
{
	global $gDb, $lang_flux_trait_defaut_pargen_msgerr_no_pargen;
	$clt_id = $_SESSION["CLT_ID"];

	//Recherche du param�tre g�n�ral (�ventuellement) � ajouter par d�faut dans la nouvelle activit�
	$req = "SELECT TPG_NUM
            FROM TYPE_ACT, ACTIVITE
            WHERE ACT_ID = $act_id
            AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	(empty($row['TPG_NUM']))?($pge_id = "null"):(null);
	$gDb->SQLFermeQuery(1);
	if ($pge_id != "null")
	{
		$req = "SELECT PAR_GEN.PGE_ID pge_id
                FROM PAR_GEN, TYPE_ACT, ACTIVITE
                WHERE ACT_ID = $act_id
                    AND ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM
                    AND TYPE_ACT.TPG_NUM = PAR_GEN.TPG_NUM
                    AND PAR_GEN.CLT_ID = $clt_id
                ORDER BY PAR_GEN.PGE_LIBEL";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		if (empty($row['pge_id']))
		{
			$msg = $lang_flux_trait_defaut_pargen_msgerr_no_pargen;
			return -1;
		}
		$pge_id = $row['pge_id'];
		$gDb->SQLFermeQuery(1);
	}
	return 0;
}

function Pos_Activite($flux_id, $type_act_id, &$afx_suivi, &$afx_num, &$msg)
{
	global $gDb;

	//Recherche de la position de l'activit� dans le flux
	$req = "select AFX_NUM, TAC_ROLE
            from ACTFLUX, ACTIVITE, TYPE_ACT
            where FLX_ID = $flux_id
            and ACTFLUX.ACT_ID = ACTIVITE.ACT_ID
            and ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM
            and TAC_ROLE <= $type_act_id
            and AFX_ACTIF != ".ETAT_SUPPR."
            and AFX_LIBEL != 'Rapprochement'
            order by TAC_ROLE, AFX_NUM";
	$gDb->SQLQuery($req, 1);
	$nb = 0;
	while ($row = $gDb->SQLNextRow(1))
	{
		$afx_num = $row['AFX_NUM'];
		if ($row['TAC_ROLE'] == $type_act_id) $nb++;
	}
	$gDb->SQLFermeQuery(1);

	if ($type_act_id == ID_TRAITEMENT && $nb == 0) {$afx_suivi = MODE_SUIVI;} else {$afx_suivi = MODE_NSUIVI;}
	if (empty($afx_num)) {$afx_num = 1;} else {$afx_num++;}

	return 0;
}

function Change_Activite_Num($afx_id, $afx_num, &$msg)
{
	global $gDb, $lang_flux_trait_update_activites_msgerr_generique, $msg;

	$res = 0;
	// Mettre a jour le numero de l'activite
	// dans la table ACTFLUX
	$req = "update ACTFLUX
                    set AFX_NUM = $afx_num 
                    where AFX_ID = $afx_id";
	if ($gDb->SQLQuery($req, 1) == false)
	{
		$res = -1;
		$msg = $lang_flux_trait_update_activites_msgerr_generique;
	}
	$gDb->SQLFermeQuery(1);
	return $res;

}

function Change_Activite_noverif($flux_id, $afx_id, &$msg, $new_num)
{
	global $gDb, $lang_flux_trait_update_activites_msgerr_generique;

	$req = "select AFX_NUM
            from ACTFLUX 
            where AFX_ID = $afx_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$afx_num = $row['AFX_NUM'];
	$gDb->SQLFermeQuery(1);

	$req = "select AFX_ID, AFX_NUM
            from ACTFLUX 
            where FLX_ID = $flux_id 
            and AFX_ACTIF != ".ETAT_SUPPR." 
            and AFX_NUM = $new_num";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$afx_num_2 = $row['AFX_NUM'];
	$afx_id_2 = $row['AFX_ID'];
	$gDb->SQLFermeQuery(1);

	if (Change_Activite_Num($afx_id, $afx_num_2, $msg) != 0)
	{
		return -1;
	}
    if (Change_Activite_Num($afx_num, $afx_id_2, $msg) != 0)
    {
        return -1;
    }
}

function Change_Activite($flux_id, $afx_id, &$msg, $new_num, $sens = "haut")
{
	global $gDb, $lang_flux_trait_update_activites_msgerr_generique;

	// Recuperation du numero de l'activite a deplacer
	// et eventuellement son backup
	$req = "select AFX_NUM, AFX_BACKUP_ID
            from ACTFLUX 
            where AFX_ID = $afx_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$afx_deplacee_num = $row['AFX_NUM'];
	$afx_deplacee_backup_id = $row['AFX_BACKUP_ID'];
	$afx_deplacee_backup_num = '';
	$gDb->SQLFermeQuery(1);

	// Si l'activite deplacee a un backup
	if(!empty($afx_deplacee_backup_id))
	{
		// Recuperer le numero du backup
		$req = "select AFX_NUM from ACTFLUX where AFX_ID = $afx_deplacee_backup_id";
		if ($gDb->SQLQuery($req, 1) == false)
		{
			$msg = $lang_flux_trait_update_activites_msgerr_generique;
			$gDb->SQLFermeQuery(1);
			return -1;
		}
		$row = $gDb->SQLNextRow(1);
		$afx_deplacee_backup_num = $row['AFX_NUM'];
		$gDb->SQLFermeQuery(1);
	}

	$lib = '';
	$pos = 0;
	if ($sens == "haut")
	{
		$pos = 1;
		// On cherche l'activite principale precedent l'activite a deplacer
		$req = "select AFX_ID, AFX_NUM, AFX_BACKUP_ID
                from ACTFLUX 
                where AFX_NUM = (SELECT MAX(AFX_NUM) from ACTFLUX where AFX_NUM<$afx_deplacee_num 
                    and FLX_ID = $flux_id 
                    and AFX_ACTIF != ".ETAT_SUPPR." 
                    and AFX_BACKUP_FROM is null)
                    and FLX_ID = $flux_id 
                    and AFX_ACTIF != ".ETAT_SUPPR."
                    and AFX_BACKUP_FROM is null";
	}
	else
	{
		$pos = -1;
		// On cherche l'activite principale suivant l'activite a deplacer
		$req = "select AFX_ID, AFX_NUM, AFX_BACKUP_ID
                from ACTFLUX 
                where AFX_NUM = (SELECT MIN(AFX_NUM) from ACTFLUX where AFX_NUM>$afx_deplacee_num 
                    and FLX_ID = $flux_id 
                    and AFX_ACTIF != ".ETAT_SUPPR." 
                    and AFX_BACKUP_FROM is null)
                    and FLX_ID = $flux_id 
                    and AFX_ACTIF != ".ETAT_SUPPR." 
                    and AFX_BACKUP_FROM is null";
	}
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$afx_permutee_num = $row['AFX_NUM'];
	$afx_permutee_id = $row['AFX_ID'];
	$afx_permutee_backup_id = $row['AFX_BACKUP_ID'];
	$afx_permutee_backup_num = '';
	$gDb->SQLFermeQuery(1);

	// Si l'activite permutee a un backup
	if(!empty($afx_permutee_backup_id))
	{
		// Recuperer le numero du backup
		$req = "select AFX_NUM from ACTFLUX where AFX_ID = $afx_permutee_backup_id";
		if ($gDb->SQLQuery($req, 1) == false)
		{
			$msg = $lang_flux_trait_update_activites_msgerr_generique;
			$gDb->SQLFermeQuery(1);
			return -1;
		}
		$row = $gDb->SQLNextRow(1);
		$afx_permutee_backup_num = $row['AFX_NUM'];
		$gDb->SQLFermeQuery(1);
	}

	// Si l'une ou l'autre des activites a un backup
	if (!empty($afx_deplacee_backup_num) || !empty($afx_permutee_backup_num))
	{
		// Si les 2 ont un backup
		if (!empty($afx_deplacee_backup_num) && !empty($afx_permutee_backup_num))
		{
			// Permuter les 2 activites de backup
			if (Change_Activite_Num($afx_permutee_backup_id, $afx_deplacee_backup_num, $msg) != 0)
			{
				return -1;
			}
			if (Change_Activite_Num($afx_deplacee_backup_id, $afx_permutee_backup_num, $msg) != 0)
			{
				return -1;
			}
		}
		// Si seule l'activite deplacee a un backup
		else if (!empty($afx_deplacee_backup_num))
		{
			// Selon le sens
			if ($sens == "haut")
			{
				// Le backup deplace prend la place de l'activite deplacee
				if (Change_Activite_Num($afx_deplacee_backup_id, $afx_deplacee_num, $msg) != 0)
				{
					return -1;
				}
				// L'activite permuttee prend la place du backup deplace
				$afx_deplacee_num = $afx_deplacee_backup_num;
			}
			else
			{
				// Le backup deplace prend la place de l'activite permutee
				if (Change_Activite_Num($afx_deplacee_backup_id, $afx_permutee_num, $msg) != 0)
				{
					return -1;
				}
				// L'activite deplacee prend la place de son backup
				$afx_permutee_num = $afx_deplacee_backup_num;
			}
		}
		// Si seule l'activite permutee a un backup
		else if (!empty($afx_permutee_backup_num))
		{
			// Selon le sens
			if ($sens == "haut")
			{
				// L'activite backup permutee prend la place
				// de l'activite deplacee
				if (Change_Activite_Num($afx_permutee_backup_id, $afx_deplacee_num, $msg) != 0)
				{
					return -1;
				}
				// L'activite permutee (qui descend) prend
				// la place de son backup
				$afx_deplacee_num = $afx_permutee_backup_num;
			}
			else
			{
				// Le backup permutee prend la place de l'activite permutee
				if (Change_Activite_Num($afx_permutee_backup_id, $afx_permutee_num, $msg) != 0)
				{
					return -1;
				}
				// L'activite deplacee prend la place du backup permutee
				$afx_permutee_num = $afx_permutee_backup_num;
			}
		}
	}

	// Modification du numero de l'activite deplacee
	if (Change_Activite_Num($afx_id, $afx_permutee_num, $msg) != 0)
	{
		return -1;
	}

	// Modification du numero de l'activite permutee
	if (Change_Activite_Num($afx_permutee_id, $afx_deplacee_num, $msg) != 0)
	{
		return -1;
	}
	$gDb->SQLFermeQuery(1);

	$new_num = $afx_permutee_num;
}

function CalculDelai($minute, $heure, $delaidem)
{
	$delai = 1;
	if ($minute == "*" || preg_match("/-/", $minute)) return $delai;
	$delai = 60;
	if (preg_match("/,/", $minute))
	{
		$temp = explode(",", $minute);
		$nb = 0;
		foreach($temp as $mm)
		{
			$nb++;
			if ($nb == 1) $first = $last = $mm;
			else
			{
				if ($delai > ($mm - $last)) $delai = $mm - $last;
				$last = $mm;
			}
		}
		if ($delai > ((60 + $first) - $last)) $delai = (60 + $first) - $last;
		return $delai;
	}
	if ($heure == "*" || preg_match("/-/", $heure)) return $delai;
	$delai = 60*24;
	if (preg_match("/,/", $heure))
	{
		$temp = explode(",", $heure);
		$nb = 0;
		foreach($temp as $mm)
		{
			$nb++;
			if ($nb == 1) $first = $last = $mm;
			else
			{
				if ($delai > (60*($mm - $last))) $delai = 60 * ($mm - $last);
				$last = $mm;
			}
		}
		if ($delai > (60*((24 + $first) - $last))) $delai = 60*((24 + $first) - $last);
		return $delai;
	}
	return $delai;
}

function NomFluxUnique($flx_id, $flx_libel)
{
	global $gDb;
	$req = "SELECT COUNT(FLX_ID) AS NB FROM FLUX WHERE FLX_ID!=$flx_id AND FLX_LIBEL=$flx_libel AND FLX_ACTIF!=".ETAT_SUPPR;
	$gDb->SQLQuery($req,5);
	$row = $gDb->SQLNextRow(5);
	$nb = intval($row['NB']);
	$gDb->SQLFermeQuery(5);
	
	return ($nb==0);
}
?>