<?php
$DEFAULT_PATH = "../../../";
$culture_content_type = "application/json; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once($DEFAULT_PATH."struct.php");
$droitRole = FLX;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; //lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."flux/gest/flux_gest_utils.php");

$page_courante = "flux/gest/planif/flux_gest_planif_actAction.php";

//Récupération des paramètres du POST

$action = pget("action");
$pla_id = pget("pla_id");
$flx_id = pget("flx_id");
$pla_actif = pget("PLA_ACTIF");
$pla_mois = pget("PLA_MOIS");
$pla_jour = pget("PLA_JOUR");
$pla_joursem = pget("PLA_JOURSEM");
$pla_heure = pget("PLA_HEURE");
$pla_minute = pget("PLA_MINUTE");
$pla_delaidem = pget("PLA_DELAIDEM");

$clt_id = $_SESSION["CLT_ID"];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************/
/* DEBUT ACTION = SUPPR	*/
/************************/
if ($action == "suppr")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null) || 
		droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$fatal = false;
		$fatal = (Maj_Actif_Planif($pla_id, $msg, ETAT_SUPPR) < 0);
		
		if ($fatal)
		{
			if(!msg)
				$msg = $lang_flux_gest_act_updateplanif_msg_err;
			$return = 1;
		}
		else
		{
			$msg = $lang_flux_gest_act_supprplanif_msg_ok;
			$return = 0;
		}
	}		
}
/************************/
/* FIN ACTION = SUPPR	*/
/************************/

/************************************************************/
/* DEBUT ACTION = MODIF		 								*/
/************************************************************/
if ($action == "modif")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null) || 
		droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$fatal = false;
		
		$delai = CalculDelai($pla_minute, $pla_heure, $pla_delaidem);
		if (($delai < $pla_delaidem) || $delai ==  0) {
			$msg = str_replace("%DELAI%", $delai, $lang_flux_gest_act_delaiplanif_msg_err);
			$return = 1;
		}
		else {
			$fatal = ($gDb->SQLTransact() == false);
			
			//mise à jour de la table SYNCHRO pour le moteur
			/*$fatal = (!synchro( 1, "FLUX", $clt_id));*/
			
			if (!$fatal) {
				$tab_pla = array (
				'CLT_ID'		=> $clt_id,
				'FLX_ID' 		=> $flx_id,
				'PLA_ID'		=> $pla_id,
				'PLA_ACTIF' 	=> $pla_actif,
				'PLA_MOIS' 		=> "'$pla_mois'",
				'PLA_JOUR' 		=> "'$pla_jour'",
				'PLA_JOURSEM' 	=> "'$pla_joursem'",
				'PLA_HEURE' 	=> "'$pla_heure'",
				'PLA_MINUTE'	=> "'$pla_minute'",
				'PLA_DELAIDEM'	=> $pla_delaidem,
				'PLA_IMMEDIAT'  => 0,
				'PLA_DATEDER'	=> "NULL");
				
				$fatal = (Update_Planif($tab_pla, $msg) < 0);
				
				if ($fatal)	//Fatal => Création de la planification impossible
				{
					if(!$msg)
						$msg = $lang_flux_gest_act_updateplanif_msg_err;
					$return = 1;
					$gDb->SQLRollBack();
				}
				else	//Tout s'est bien passé
				{
					$msg = $lang_flux_gest_act_updateplanif_msg_ok;
					$return = 0;
					$gDb->SQLCommit();
				}
			}
		}
	}
	else
	{
		$msg = $lang_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = MODIF		 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = CREATE		 							*/
/************************************************************/
if ($action == "create")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null) || 
		droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$fatal = false;
		
		$delai = CalculDelai($pla_minute, $pla_heure, $pla_delaidem);
		if (!$delai || $delai < $pla_delaidem || $delai ==  0) {
			$msg = str_replace("%DELAI%", $delai, $lang_flux_gest_act_delaiplanif_msg_err);
			$return = 1;
		}
		else {
			$fatal = ($gDb->SQLTransact() == false);
			
			//mise à jour de la table SYNCHRO pour le moteur
			/*$fatal = (!synchro( 1, "FLUX", $clt_id));*/
			
			if (!$fatal) {
				$tab_pla = array (
				'CLT_ID'		=> $clt_id,
				'FLX_ID' 		=> $flx_id,
				'PLA_ACTIF' 	=> $pla_actif,
				'PLA_MOIS' 		=> "'$pla_mois'",
				'PLA_JOUR' 		=> "'$pla_jour'",
				'PLA_JOURSEM' 	=> "'$pla_joursem'",
				'PLA_HEURE' 	=> "'$pla_heure'",
				'PLA_MINUTE'	=> "'$pla_minute'",
				'PLA_DELAIDEM'	=> $pla_delaidem,
				'PLA_IMMEDIAT'  => 0,
				'PLA_DATEDER'	=> "NULL");
								
				$fatal = (New_Planif($tab_pla, $msg, $pla_id) < 0);
				
				if ($fatal)	//Fatal => Création de la planification impossible
				{
					if(!$msg)
						$msg = $lang_flux_gest_act_addplanif_msg_err;
					$return = 1;
					$gDb->SQLRollBack();
				}
				else	//Tout s'est bien passé
				{
					$msg = $lang_flux_gest_act_addplanif_msg_ok;
					$return = 0;
					$gDb->SQLCommit();
				}
			}
		}
	}
	else
	{
		$msg = $lang_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = CREATE		 								*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
echo encode_JSON($reponse);
?>