<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");
$droitRole = FLX;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; //lmcs

require_once($DEFAULT_PATH."flow.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

$flx_id = pget('flx_id');
$pageSize = pget('pageSize');
$pageNum = pget('pageNum');

$req = "SELECT SQL_CALC_FOUND_ROWS PLA_ID, PLA_ACTIF, PLA_DATEDER, PLA_HEURE, PLA_MINUTE, PLA_DELAIDEM, PLA_MOIS, PLA_JOUR, PLA_JOURSEM   
		FROM PLANIF
		WHERE FLX_ID = $flx_id 
		AND PLA_ACTIF != ".ETAT_SUPPR." 
		AND (PLA_IMMEDIAT = 0 OR PLA_IMMEDIAT IS NULL)
		ORDER BY PLA_ID DESC";

$champs = array();
$champs[] = array("nom" => $lang_ds_planif_mois, "toolTip" => $lang_ds_planif_mois, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_planif_jour, "toolTip" => $lang_ds_planif_jour, "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_gest_act_delaiplanif_lbl_joursem, "toolTip" => $lang_flux_gest_act_delaiplanif_lbl_joursem, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_planif_heur, "toolTip" => $lang_ds_planif_heur, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_planif_min, "toolTip" => $lang_ds_planif_min, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_planif_last, "toolTip" => $lang_ds_planif_last, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_planif_delai, "toolTip" => $lang_ds_planif_delai, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_planif_etat, "toolTip" => $lang_ds_planif_etat, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{
	echo '<row>';
		
	if (strlen($row['PLA_MOIS']) > 20)
		$p_mois = substr($row['PLA_MOIS'], 0, 20)."...";
	else
		$p_mois = $row['PLA_MOIS'];
		
	$params = array();
	$params['pla_id'] = $row['PLA_ID'];
	$params['droits'] = array('modif' => droit($droitRole, DROIT_MODIF,null,null,null,null),
							'remove' => droit($droitRole, DROIT_CREAT,null,null,null,null));
	
	echo '<item caption="'.$p_mois.'" value="'.row_encode_JSON($params).'"/>';

	
	if (strlen($row['PLA_JOUR']) > 20)
		$p_jour = substr($row['PLA_JOUR'], 0, 20)."...";
	else
		$p_jour = $row['PLA_JOUR'];
	
		echo '<item caption="'.$p_jour.'"/>';
	
	if (strlen($row['PLA_JOURSEM']) > 20)
		$p_joursem = substr($row['PLA_JOURSEM'], 0, 20)."...";
	else
		$p_joursem = $row['PLA_JOURSEM'];

	echo '<item caption="'.$p_joursem.'"/>';
	
	if (strlen($row['PLA_HEURE']) > 20)
		$p_heure = substr($row['PLA_HEURE'], 0, 20)."...";
	else
		$p_heure = $row['PLA_HEURE'];

	echo '<item caption="'.$p_heure.'"/>';

	
	if (strlen($row['PLA_MINUTE']) > 20)
		$p_minute = substr($row['PLA_MINUTE'], 0, 20)."...";
	else
		$p_minute = $row['PLA_MINUTE'];
		
	echo '<item caption="'.$p_minute.'"/>';

	$date = (($row['PLA_DATEDER'])?sql2Date($row['PLA_DATEDER']):"");
	echo '<item caption="'.$date.'"/>';
	echo '<item caption="'.$row['PLA_DELAIDEM'].'"/>';
	echo '<item caption="'.(($row['PLA_ACTIF'])?($lang_ds_etat_act):($lang_ds_etat_inact)).'"/>';
	
	echo '</row>';
}
$gDb->SQLFermeQuery(1);
echo '</databind>';
?>