<?php
$DEFAULT_PATH = "../../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once ($DEFAULT_PATH."struct.php");
$droitRole = CERT;
$lmcse = DROIT_LECT + DROIT_CREAT + DROIT_MODIF + DROIT_SUPPR;
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once("crt_utils.php");

$page_courante = "flux/pargen/certificat/crt_actAction.php";
$cltID 	 = $_SESSION['CLT_ID'];
$cptID = $_SESSION['CPT_ID'];
if (version_compare(PHP_VERSION,'5.3.0','<'))
{
    if(!@extension_loaded('php_aocl'))
	   @dl('ini_get("extension_dir")php_aocl.dll');
}

$req = "SELECT CLT_REPCLI_IHM FROM CLIENT
			 		where CLT_ID=$cltID";
$gDb->SQLQuery($req, 1);
$res = $gDb->SQLNextRow(1);
$cheminBank = $res['CLT_REPCLI_IHM']."/certificat";

$action	 = pget('action');  // action
$type   = pget('type');    // type de certificat
$crt_id  = pget('crt_id');  // id du certificat
$alias   = pget('alias');   // alias du certificat
$pwd     = pget('pwd');     // password
$crt     = pget('crt');     // certificat lié 
$crt_par = pget('crt_par'); // partenaire lié
$crt_util = pget('crt_util'); //Utilisation certificat pour Ebics (1:Authentification, 2:cryptage, 3:Signature) 
if(!$crt_util)
	$crt_util=0;
$crt_pargen = pget('crt_pargen'); //Utilisation certificat pour Ebics (1:Authentification, 2:cryptage, 3:Signature)
if(!$crt_pargen)
	$crt_pargen=-1;	
$crt_role = pget('crt_role'); //Role de l'utilisateur d'un certificat sur support physique (0:transport, 1:signataire 1 ou 2)	
if(!$crt_role)
	$crt_role=-1;	
	
$pin    = pget('pin');     // password	
	
//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************************************************/
/* DEBUT ACTION = SUPRESSION 								*/
/************************************************************/

function get_ebics_adr($parID, $hostID, $pflID)
{
	global $gDb;
	
	$ebics_adr = '';

	if (!empty($parID))
	{
		$req = "SELECT VPA_VAL	FROM VAL_PAR_ADR 
		            WHERE ADR_ID=(SELECT VAL_PAR_ADR.ADR_ID FROM VAL_PAR_ADR 
		                                                    JOIN ADRESSE ON ADRESSE.ADR_ID=VAL_PAR_ADR.ADR_ID 
		                                                    WHERE ADRESSE.PAR_ID=$parID AND VAL_PAR_ADR.PFL_ID=5650
		                                                    AND VPA_VAL='$hostID') 
		              AND PFL_ID=$pflID";
		$gDb->SQLQuery($req, 6);
		$row = $gDb->SQLNextRow(6);
		$gDb->SQLFermeQuery(6);
		$ebics_adr=$row['VPA_VAL'];
		
		if (empty($ebics_adr))
		{
			// Chercher dans le groupe
			$req = "SELECT GRP_ID FROM PART WHERE PAR_ID=$parID";
			$gDb->SQLQuery($req, 6);
			$row = $gDb->SQLNextRow(6);
			$gDb->SQLFermeQuery(6);
			$ebics_adr=get_ebics_adr($row['GRP_ID'],$hostID,$pflID);
		}
	}
	return $ebics_adr;
}

if($action == "suppr" &&  droit($droitRole, DROIT_SUPPR,null,null,null,null))
{
	$flag = true;
	$req = "SELECT CRT_ID_BANK
			FROM CERTIFICAT 
			where CRT_ID=$crt_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	if (!$row['CRT_ID_BANK']){
		$msg =addslashes($lang_flux_pargen_crt_act_suppr_msg_err);
		$return = 1;
		$flag = false;
	}
	
    // Modif LTK le 28/09/10 : Bugzilla #3573
    // Verifier si une cle est lie au certificat
    if ($type == CRT_FOR_CER)
    {
        $req = "SELECT CRT_ID_BANK
                FROM CERTIFICAT 
                where KEY_CRT_ID=$crt_id";
        $gDb->SQLQuery($req, 2);
        $row2 = $gDb->SQLNextRow(2);
        if ($row2['CRT_ID_BANK']){
            $msg =addslashes($lang_flux_pargen_crt_act_suppr_cle_associee_msg_err);
            $return = 1;
            $flag = false;
        }
        $gDb->SQLFermeQuery(2);
    }
    
	if ($type != CRT_FOR_CERT_TS && $type != CRT_FOR_AUTH && $type != CRT_FOR_ENCR)
    {
		if ($flag)
		{
			// ouverture banque
			php_aocl_open_certificate_bank("$cheminBank");
	
			switch ($type) {
				case CRT_FOR_CER :
					$ret = php_aocl_remove_certificate($row['CRT_ID_BANK']);
					break;
	 		case CRT_FOR_KEY :
	 			$ret = php_aocl_remove_key($row['CRT_ID_BANK']);
	 			break;
	 		case CRT_FOR_CRL :
	 			$ret = php_aocl_remove_crl($row['CRT_ID_BANK']);
	 			break;
			}
			if($ret != 1)
			{
				$msg = $cheminBank.addslashes($lang_flux_pargen_crt_act_suppr_msg_err.php_aocl_get_error());
				$return = 1;
				$flag = false;
			}
			// fermeture banque
			php_aocl_close_certificate_bank();
		}
    }

	if ($flag)
	{
		$req = "DELETE FROM CERTIFICAT WHERE CRT_ID=$crt_id";
		if (!$gDb->SQLQuery($req, 1))
		{
			$msg =addslashes($lang_flux_pargen_crt_act_suppr_msg_err);
			$return = 1;
		}
		else
		{
			$msg =addslashes($lang_flux_pargen_crt_act_suppr_msg_ok);
			$return = 0;
		}
		$gDb->SQLFermeQuery(1);
	}
}

/************************************************************/
/* FIN ACTION = SUPRESSION 									*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = CREATION 									*/
/************************************************************/

if ($action == "create" && droit($droitRole, DROIT_CREAT,$crt_par,null,null,null))
{
	$flag = true;
	if (!$crt_par) $crt_par='NULL';
	if (!$crt) $crt='NULL';
		
	$rep_stock_cer = "";
	$fic=pget('fic');
	
	if ($fic=="" && $type!=CRT_FOR_CERT_TS)
	{
		$msg = addslashes($lang_admin_confav_confgen_msg_err_generique_deb.$lang_flux_pargen_crt_aff_lbl_path.$lang_admin_confav_confgen_msg_err_generique_fin);
		$return = 1;
	}
	else
	{
		// ouverture banque
		php_aocl_open_certificate_bank("$cheminBank");
			
		/************************************************************/
		/* CREATION d'un format=certificat							*/
		/************************************************************/
		if ($type == CRT_FOR_CER)
		{
			$str2 = php_aocl_store_certificate($fic);
		}
			
		/************************************************************/
		/* CREATION d'un format=Liste de revocation					*/
		/************************************************************/
		if ($type == CRT_FOR_CRL)
		{
			$str2 = php_aocl_store_crl($fic);
		}
		/************************************************************/
		/* CREATION d'un format=key									*/
		/************************************************************/
		if ($type == CRT_FOR_KEY)
		{
			$req = "SELECT CRT_ID_BANK
					FROM CERTIFICAT 
					where CRT_ID=$crt
					and CRT_FORMAT=".CRT_FOR_CER;
	
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);

			if (!$row['CRT_ID_BANK'])
			{
				$msg = addslashes($lang_flux_pargen_crt_act_create_msg_err);
				$return = 1;
				$flag = false;
			}
			else
			{
				$str2 = php_aocl_store_key($fic, $row['CRT_ID_BANK'], $pwd, $pwd);
			}
		}
		
		/************************************************************/
		/* CREATION d'un format=Certifiat support physique			*/
		/************************************************************/
		if ($type == CRT_FOR_CERT_TS)
		{
			$str2 = $crt_par.$alias.$crt_role;
		}
		
		if(!$str2 || !$flag)
		{
			if (!$msg)
			{
				$msg = addslashes($lang_flux_pargen_crt_act_create_msg_err);
				//$msg.= addslashes(php_aocl_get_error());
				$return = 1;
			}
		}
		else
		{
			$req = "SELECT CRT_ID_BANK
					FROM CERTIFICAT 
					where CRT_ID_BANK='$str2'
					and CRT_FORMAT=$type";
			
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);
			if ($row['CRT_ID_BANK']==$str2)
			{
				$msg = addslashes($lang_flux_pargen_crt_filtre_format_crt.$lang_flux_av_imp_flux_act_insert_msg_err_dup);
				$return = 1;
			
			}
			else
			{
				$ar['Purposes']=CRT_FOR_UNDEFINED;
				$ar['StartDate'] ="";
				$ar['EndDate'] ="";
				$ar['IssuerName'] ="";
				/************************************************************/
				/* CREATION d'un format=certificat							*/
				/************************************************************/
				if ($type == CRT_FOR_CER)
				{
					$ar =  php_aocl_get_certificate_infos($str2);
					if ($crt_par=='NULL')
					{
						// Pas de partenaire lie
						// If faut verifier si le certificat est bien de type CA
						if (!CertificateIsCA($ar['Purposes']))
						{
							// On ne peut pas integrer un certificat non CA
							// sans y lier un partenaire
							$msg = addslashes($lang_flux_pargen_crt_act_create_msg_err_non_ca);
							$return = 1;
							unset($crt_par);
						}
					}
				}
				else if ($type == CRT_FOR_CRL)
				{
					$ar =  php_aocl_get_crl_infos($str2);
				}
				if ($crt_par)
				{
					if ($type == CRT_FOR_CER) 
					{
						// Le nom du proprietaire et son adresse sont extraits du nom du certificat
						$propMail = ExtractEMail($ar['Name']);
						$propNom = ExtractName($ar['Name']);
					}
										
					// Le nom de l'emetteur et son adresse sont extraits de l'emetteur
					$emetMail = ExtractEMail($ar['IssuerName']);
					$emetNom = ExtractName($ar['IssuerName']);
					
					//Modification pour utiliastion certificat
					if (!$ar['Purposes']) $ar['Purposes']=CRT_FOR_UNDEFINED;					
					if($crt_util==0)
						$crt_purpose=$ar['Purposes'];
					else if($crt_util==CRT_UTIL_AUTH)
					{
						if(($ar['Purposes'] & 69) == 69)
							$crt_purpose= CRT_UTIL_AUTH; //crt_type pour Authentification
						else
						{
							$msg=addslashes($lang_flux_part_act_bad_utilisation_certif_Auth);
							$return = 1;
						}
					}
					else if($crt_util==CRT_UTIL_ENCR)
					{
						if(($ar['Purposes'] & 256) == 256)
							$crt_purpose= CRT_UTIL_ENCR; //crt_type pour Cryptage
						else
						{
							$msg=addslashes($lang_flux_part_act_bad_utilisation_certif_Encr);
							$return = 1;
						}
					}
					else if($crt_util==CRT_UTIL_SIGN)
					{
						if(($ar['Purposes'] & 64) == 64)
							$crt_purpose= CRT_UTIL_SIGN; //crt_type pour Signature
						else
						{
							$msg=addslashes($lang_flux_part_act_bad_utilisation_certif_Sign);
							$return = 1;
						}
					}
					else if($crt_util==CRT_UTIL_ALL) // Forçage du type de certificat à tout usage (pour AS2)
					{
						$crt_purpose= CRT_UTIL_ALL; //crt_type pour tout usage
					}
					
					if($return!=1)
					{
						$tmp = explode(" ",$ar['StartDate']);
						$tmp2 = explode("/",$tmp[0]);
						
						if(!empty($tmp2[2]))
							$dateDeb = "20".$tmp2[2]."/".$tmp2[1]."/".$tmp2[0]." ".$tmp[1];
						else
						{
							if($ini_typeBase != 'mysql')
								$dateDeb=null;
						}
						
						$tmp = explode(" ",$ar['EndDate']);
						$tmp2 = explode("/",$tmp[0]);
						
						if(!empty($tmp2[2]))
							$dateFin = "20".$tmp2[2]."/".$tmp2[1]."/".$tmp2[0]." ".$tmp[1];
						else
						{
							if($ini_typeBase != 'mysql')
								$dateFin=null;		
						}
						
						if($ini_typeBase != 'oracle')
							$req = "INSERT INTO CERTIFICAT (CRT_ID_BANK, CRT_ALIAS, CRT_TYPE, CRT_FORMAT, CRT_PWD, CRT_DATE_VALID_DU,
								CRT_DATE_VALID_AU, CRT_PROP_NOM, CRT_PROP_EMAIL, PAR_ID, CLT_ID, KEY_CRT_ID, CRT_EMET_NOM, CRT_EMET_EMAIL, CRT_ROLE)
	   							VALUES ('$str2','".dblQ($alias)."', $crt_purpose, $type, '".dblQ($pwd)."', '".addslashes($dateDeb)."', 
								'".addslashes($dateFin)."' ,'".dblQ($propNom)."', '".addslashes($propMail)."', $crt_par, $cltID, $crt,'".dblQ($emetNom)."', '".$emetMail."', $crt_role)";	
	   					else
							$req = "INSERT INTO CERTIFICAT (CRT_ID_BANK, CRT_ALIAS, CRT_TYPE, CRT_FORMAT, CRT_PWD, CRT_DATE_VALID_DU,
								CRT_DATE_VALID_AU, CRT_PROP_NOM, CRT_PROP_EMAIL, PAR_ID, CLT_ID, KEY_CRT_ID, CRT_EMET_NOM, CRT_EMET_EMAIL, CRT_ROLE)
	   							VALUES ('$str2','".dblQ($alias)."', $crt_purpose, $type, '".dblQ($pwd)."', TO_DATE ('".addslashes($dateDeb)."', 'YYYY/MM/DD HH24:MI:SS'), 
								TO_DATE ('".addslashes($dateFin)."', 'YYYY/MM/DD HH24:MI:SS'),'".dblQ($propNom)."', '".addslashes($propMail)."', $crt_par, $cltID, $crt,'".dblQ($emetNom)."', '".$emetMail."', $crt_role)";	
	   					$res = $gDb->SQLQuery($req, 1);
					
						if ($res == null)
						{
							$msg = addslashes($lang_flux_pargen_crt_act_create_msg_err);
							$return = 1;
						}
						else
						{
							if ($res[0] == SQL_DUP_CHAMP)
							{
								$msg = addslashes($lang_flux_pargen_crt_grid_head_alias.$lang_flux_av_imp_flux_act_insert_msg_err_dup);
								$return = 1;
							}
							else
							{
								$msg = addslashes($lang_flux_pargen_crt_act_create_msg_ok);
								$return = 0;
							}
						}
					}
				}
			}
		}
			
		// fermeture banque
		php_aocl_close_certificate_bank();
	}
}

/************************************************************/
/* FIN ACTION = CREATION 									*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = MODIF			 							*/
/************************************************************/

if ($action == "modif" && ($type == CRT_FOR_CER || $type == CRT_FOR_CERT_TS ) && droit($droitRole, DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR,null,null,null,null))
{
	if (!empty($crt_id))
	{
		if (empty($crt_par))
		{
			// Pas de partenaire lie
			// If faut verifier si le certificat est bien de type CA
			$req = "SELECT CRT_TYPE
					FROM CERTIFICAT 
					where CRT_ID='$crt_id'";
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);
			if (!CertificateIsCA($row['CRT_TYPE']))
			{
				// On ne peut pas modifier un certificat non CA
				// sans y lier un partenaire
				$msg = addslashes($lang_flux_pargen_crt_act_modif_msg_err_non_ca);
				$return=1;
			}
			else
			{
				$crt_par = 'NULL';
			}
		}
		if (!empty($crt_par))
		{	
			//Modification Utilisation
			$req = "SELECT CRT_ID_BANK
					FROM CERTIFICAT 
					where CRT_ID='$crt_id'";
			$gDb->SQLQuery($req, 1);
			$row = $gDb->SQLNextRow(1);
			
			if($type!=CRT_FOR_CERT_TS)
			{
					// ouverture banque
					php_aocl_open_certificate_bank("$cheminBank");
					
					$ar =  php_aocl_get_certificate_infos($row['CRT_ID_BANK']);
					
				if (!$ar['Purposes']) $ar['Purposes']=CRT_FOR_UNDEFINED;					
				if($crt_util==0)
					$crt_purpose=$ar['Purposes'];
				else if($crt_util==CRT_UTIL_AUTH)
				{
					if(($ar['Purposes'] & 69) == 69)
						$crt_purpose= CRT_UTIL_AUTH; //crt_type pour Authentification
					else
					{
						$msg=addslashes($lang_flux_part_act_bad_utilisation_certif_Auth);
						$return = 1;
					}
				}
				else if($crt_util==CRT_UTIL_ENCR)
				{
					if(($ar['Purposes'] & 256) == 256)
						$crt_purpose= CRT_UTIL_ENCR; //crt_type pour Cryptage
					else
					{
						$msg=addslashes($lang_flux_part_act_bad_utilisation_certif_Encr);
						$return = 1;
					}
				}
				else if($crt_util==CRT_UTIL_SIGN)
				{
					if(($ar['Purposes'] & 64) == 64)
						$crt_purpose= CRT_UTIL_SIGN; //crt_type pour Signature
					else
					{
						$msg=addslashes($lang_flux_part_act_bad_utilisation_certif_Sign);
						$return = 1;
					}
				}
				else if($crt_util==CRT_UTIL_ALL) // Forçage du type de certificat à tout usage (pour AS2)
				{
					$crt_purpose= CRT_UTIL_ALL; //crt_type pour tout usage
				}
			}
			
			if($return!=1)
			{
				$req = "update CERTIFICAT set
						PAR_ID 		= $crt_par,
						CRT_TYPE	= $crt_purpose,
						CRT_ROLE	= $crt_role
						where CRT_ID = $crt_id";
		
				if (! $gDb->SQLQuery($req, 1))
				{
					$msg = addslashes($lang_flux_pargen_crt_act_modif_msg_err);
					$return = 1;
				}
				else
				{
					$msg = addslashes($lang_flux_pargen_crt_act_modif_msg_ok);
					$return=0;
				}
			}
		}
	}
} 

/************************************************************/
/* FIN ACTION = MODIF			 							*/
/************************************************************/
/************************************************************/
/* DEBUT ACTION = IMPRIM_EBICS			 					*/
/************************************************************/

if ($action == "imprim_ebics")
{
	$fic_out=pget('fic');
	$imprim=1;
	$nom_bank=pget('nom_bank');
	if($nom_bank=="")
	{
		$msg = addslashes($lang_admin_confav_confgen_msg_err_generique_deb.$lang_flux_pargen_crt_aff_lbl_nom_bank.$lang_admin_confav_confgen_msg_err_generique_fin);
		$return = 1;
	}
	elseif($crt_pargen==0)
	{
		$msg = addslashes($lang_flux_pargen_crt_aff_lbl_pargen_ebics);
		$return = 1;
	}
	else{
		if (!empty($crt_id))
		{
			if (empty($crt_par))
			{	
				//Récuperation du répertoire temporaire
				$req = "SELECT FCO_REPTMP_IHM
						FROM FLOWCONF 
						where FCO_ID=1";
				$gDb->SQLQuery($req, 1);
				$row = $gDb->SQLNextRow(1);
				$gDb->SQLFermeQuery(1);
				$path_temp=$row['FCO_REPTMP_IHM'];
				
				// Modif LTK le 04/04/11 : Bugzilla #3898
				// On ne peut pas s'appuyer sur le type de certificat 
				// ou sur la difference Proprietaire/Emetteur pour 
				// determiner de quel type de parametre general il s'agit
				// Il faut verifier la validite des paremetres apres requete 
				
				// Récuperation du HostID Ebics
				$param_gen_pfl_id = 5300;
				$req = "SELECT VPG_VAL
						FROM VAL_PAR_GEN where PGE_ID='$crt_pargen' AND PFL_ID=".($param_gen_pfl_id+2);
				$gDb->SQLQuery($req, 1);
				$row = $gDb->SQLNextRow(1);
				$gDb->SQLFermeQuery(1);
				$hostid=$row['VPG_VAL'];
				// Si le HostID n'est pas defini, c'est qu'il s'agit d'un 
				// parametre general Ebics TS	
				if ($hostid == '')
				{
					// Ebics TS
					$param_gen_pfl_id = 5600;
					$req = "SELECT VPG_VAL
							FROM VAL_PAR_GEN where PGE_ID='$crt_pargen' AND PFL_ID=".($param_gen_pfl_id+2);
					$gDb->SQLQuery($req, 1);
					$row = $gDb->SQLNextRow(1);
					$gDb->SQLFermeQuery(1);
					$hostid=$row['VPG_VAL'];
				}
				//Récuperation du PartnerID
				$req = "SELECT VPG_VAL
						FROM VAL_PAR_GEN where PGE_ID='$crt_pargen' AND PFL_ID=".($param_gen_pfl_id+3);
				$gDb->SQLQuery($req, 1);
				$row = $gDb->SQLNextRow(1);
				$gDb->SQLFermeQuery(1);
				$partid=$row['VPG_VAL'];
				
				//Récuperation du UserID
				$req = "SELECT VPG_VAL
						FROM VAL_PAR_GEN where PGE_ID='$crt_pargen' AND PFL_ID=".($param_gen_pfl_id+4);
				$gDb->SQLQuery($req, 1);
				$row = $gDb->SQLNextRow(1);
				$gDb->SQLFermeQuery(1);
				$userid=$row['VPG_VAL'];

				// Modif LTK le 01/07/2011 : bugzilla #4077 
				// En Ebics TS, recuperer les PartID, UserID dans les adresses
				// Ebics du partenaire
				if ($param_gen_pfl_id == 5600)
				{
					$req = "SELECT PAR_ID FROM CERTIFICAT WHERE CRT_ID=$crt_id";
					$gDb->SQLQuery($req, 6);
					$row = $gDb->SQLNextRow(6);
					$gDb->SQLFermeQuery(6);
					$crt_par=$row['PAR_ID'];
						
					if ($partid == '')
					{
						$partid = get_ebics_adr($crt_par,$hostid,5651);
					}
					if ($userid == '')
					{
						$userid = get_ebics_adr($crt_par,$hostid,5652);
					}
				}
				
				if($type!=CRT_FOR_CERT_TS)
				{
					$req = "SELECT CRT_TYPE, CRT_ID_BANK, CRT_PROP_NOM, CRT_EMET_NOM 
							FROM CERTIFICAT 
							where CRT_ID='$crt_id'";
					$gDb->SQLQuery($req, 1);
					$row = $gDb->SQLNextRow(1);
					$util=$row['CRT_TYPE'];
					$crt_id_bank=$row['CRT_ID_BANK'];
					$crt_prop=$row['CRT_PROP_NOM'];
					$crt_emet=$row['CRT_EMET_NOM'];
					
					if($crt_prop != $crt_emet)
					{
						$pin=$crt_prop;
						$nom_dll = $crt_emet;
					}
					
					switch ($util)
					{
						case "28677" 	: $crt_util = 1111;			break;
						case "28948" 	: $crt_util = 2222;			break;
						case "28736" 	: $crt_util = 3333;			break;
						default			: $crt_util = "Erreur";		break;
					}
				
					$open=php_aocl_get_certificate_bank_path("$cheminBank");
					$path_certif=$cheminBank."/".$crt_id_bank.".cer";
					$path_certif_slash=addslashes($path_certif);
				}
				else
				{
					$crt_util = 4444;
					
					//Récuperation du PartnerID
					$req = "SELECT CPT_NOMLECTEBX, CPT_SLOT
							FROM COMPTE 
							where CPT_ID='$cptID'";
					$gDb->SQLQuery($req, 1);
					$row = $gDb->SQLNextRow(1);
					$nomlect=$row['CPT_NOMLECTEBX'];
					$slot=$row['CPT_SLOT'];
					
					switch($nomlect)
					{					
						case "0":
							$nom_dll="gclib.dll";
							break;
						
						case "1":
							$nom_dll="eTPKCS11.dll";
							break;
						
						default:
							$nom_dll="eTPKCS11.dll";
							break;
					}
					if(!$pin)
					{
						$imprim=0;
						$msg="Veuillez saisir un code PIN";
					}
					
				}
				
				$path_temp_slash = addslashes($path_temp);
				$fic_out=addslashes($path_temp."/ebics_imprim.txt");
				
				if($imprim!=0)
				{
					$imprim=php_aocl_imprim_certificate_ebics($crt_util,$fic_out,$path_certif_slash,$path_temp_slash,$hostid,$partid,$userid,$nom_bank, $pin, $slot, $nom_dll);
					$return=$imprim['Retour'];
					if($return==0)
					{
						$imprim=1;
						$msg="OK";
					}
					else if($return==1)
					{	
						$imprim=0;
						$msg=$lang_flux_pargen_crt_aff_err_create_letter_ebics;
					}	
					else if($return==2)
					{	
						$imprim=0;
						$msg=$lang_flux_pargen_crt_aff_err_create_letter_pin;
					}	
					else if($return==3)
					{	
						$imprim=0;
						$msg=$lang_flux_pargen_crt_aff_err_create_letter_slot;
					}	
					else if($return==4)
					{	
						$imprim=0;
						$msg=$lang_flux_pargen_crt_aff_err_create_letter_dll;
					}	
				}
			}
		}
	}
} 

/************************************************************/
/* FIN ACTION = IMPRIM_EBICS	 							*/
/************************************************************/
/************************************************************/
/* DEBUT ACTION = EXTRACT			 					*/
/************************************************************/

if ($action == "extract")
{
	$fic_out=pget('fic');

	//Récuperation du répertoire temporaire
	$req = "SELECT FCO_REPTMP_IHM
			FROM FLOWCONF 
			where FCO_ID=1";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	$path_temp=$row['FCO_REPTMP_IHM'];
			
	//Récuperation du PartnerID
	$req = "SELECT CPT_NOMLECTEBX, CPT_SLOT
			FROM COMPTE 
			where CPT_ID='$cptID'";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$nomlect=$row['CPT_NOMLECTEBX'];
	$slot=$row['CPT_SLOT'];

	switch($nomlect)
	{					
		case "0":
			$nom_dll="gclib.dll";
			break;
					
		case "1":
			$nom_dll=".dll";
			break;
		
		default:
			$nom_dll="";
			break;
	}

	$path_temp_slash = addslashes($path_temp);
	//$fic_out=addslashes($path_temp."/ebics_imprim.txt");

	if(!$pin)
	{
		$imprim=0;
		$msg="Veuillez saisir un code PIN";
	}
	else
	{
		if($type==CRT_FOR_CERT_CA)
			$imprim=php_aocl_extract_certificate_root($fic_out,$path_temp_slash,$pin, $slot, $nom_dll);
		else if	($type==CRT_FOR_CERT_TS)
			$imprim=php_aocl_extract_certificate_ts($fic_out,$path_temp_slash,$pin, $slot, $nom_dll);
			
		$return=$imprim['Retour'];
		if($return==0)
		{
			$imprim=1;
			$msg="OK";
		}
		else if($return==1)
		{	
			$imprim=0;
			$msg=$lang_flux_pargen_crt_aff_err_create_letter_ebics;
		}	
		else if($return==2)
		{	
			$imprim=0;
			$msg=$lang_flux_pargen_crt_aff_err_create_letter_pin;
		}	
		else if($return==3)
		{	
			$imprim=0;
			$msg=$lang_flux_pargen_crt_aff_err_create_letter_slot;
		}	
		else if($return==4)
		{	
			$imprim=0;
			$msg=$lang_flux_pargen_crt_aff_err_create_letter_dll;
		}	
		else if($return==5)
		{	
			$imprim=0;
			$msg=$lang_flux_pargen_crt_aff_err_create_letter_ebics;
		}	
	}
} 

/************************************************************/
/* FIN ACTION = EXTRACT			 							*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
if(isset($imprim) && $imprim!=0)
{
	$reponse['buff'] = $fic_out;
}
$reponse['onsuccess'] = 'top.reload_menu()';
echo encode_JSON($reponse);
?>