<?php
$DEFAULT_PATH = "../../../../";
require_once($DEFAULT_PATH."struct.php");

$droitRole = PDM; //droit de gestion des Logs
$lmcse = DROIT_LECT + DROIT_CREAT + DROIT_MODIF + DROIT_SUPPR;

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

function GetRoleLabel($role)
{
	global $lang_sui_inv_act_im_lbl_part_by, $lang_sui_inv_act_im_lbl_part_se;
	$roleLabel = "";
	if ($role == 'A')
	{
		$roleLabel = $lang_sui_inv_act_im_lbl_part_by;
	}
	elseif ($role == 'V')
	{
		$roleLabel = $lang_sui_inv_act_im_lbl_part_se;
	}
	return $roleLabel;
}

Construit_restriction($droitRole, "p2.PAR_ID", "p1.PAR_ID", null, null, $restrict1, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);
Construit_restriction($droitRole, "p1.PAR_ID", "p2.PAR_ID", null, null, $restrict2, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);

$res1=substr($restrict1,4);
$res2=substr($restrict2,4);
if ($res1 && $res2)
$restriction=" AND ( ( ".$res1." ) OR ( ".$res2." ) )" ;
else $restriction=null;

$f_emet   = pget("f_emet");
$f_dest   = pget("f_dest");
$f_etat   = pget('f_etat');
$f_ad_part1   = pget('f_ad_part1');
$f_ad_part2   = pget('f_ad_part2');
$f_qual_part1   = pget('f_qual_part1');
$f_qual_part2   = pget('f_qual_part2');
$f_entree_demat   = pget('f_entree_demat');
$f_sortie_demat   = pget('f_sortie_demat');
$pageNum  = pget('pageNum');
$pageSize = pget('pageSize');
$cltID 	  = $_SESSION['CLT_ID'];
$where = "";


if (!empty($f_etat)) $where .= " AND PTP_STATUT = $f_etat ";
if (!empty($f_dest)) $where .= " AND p2.PAR_ID= '".dblQ($f_dest)."' ";
if (!empty($f_emet)) $where .= " AND p1.PAR_ID='".dblQ($f_emet)."' ";
if (!empty($f_ad_part1)) $where .= " AND PTP_ADRESSE_EMET='".dblQ($f_ad_part1)."' ";
if (!empty($f_ad_part2)) $where .= " AND PTP_ADRESSE_DEST='".dblQ($f_ad_part2)."' ";
if (!empty($f_qual_part1))
{
	if ($f_qual_part1 == 'Acheteur') $where .= " AND PTP_QUALITE_EMET='A'";
	if ($f_qual_part1 == 'Vendeur') $where .= " AND PTP_QUALITE_EMET='V'";
}
if (!empty($f_qual_part2))
{
	if ($f_qual_part2 == 'Acheteur') $where .= " AND PTP_QUALITE_DEST='A'";
	if ($f_qual_part2 == 'Vendeur') $where .= " AND PTP_QUALITE_DEST='V'";
}
if (!empty($f_entree_demat)) $where .= " AND PTP_DATE_ENTREE='".dblQ($f_entree_demat)."' ";
if (!empty($f_sortie_demat)) $where .= " AND PTP_DATE_SORTIE='".dblQ($f_sortie_demat)."' ";

//ASGS1 09/10/2008: rajout des colonnes adresse et qualit
/*
$req = "SELECT SQL_CALC_FOUND_ROWS PTP_ID, p1.PAR_NOM,PTP_ADRESSE_EMET,PTP_QUALITE_EMET, p2.PAR_NOM,PTP_ADRESSE_DEST,PTP_QUALITE_DEST, PTP_STATUT, PTP_DATE_ENTREE, PTP_DATE_SORTIE,
			PTP_HISTO, PTP_EMET_ID, PTP_DEST_ID, p1.PAR_ID, p2.PAR_ID
   			FROM PART_TO_PART, PART as p1, PART as p2 
			WHERE PART_TO_PART.CLT_ID=".$cltID." 
			AND p1.PAR_ID=PTP_EMET_ID AND p2.PAR_ID=PTP_DEST_ID 
			".$where." ".$restriction;
*/
//request for mysql/MSSQL/ORACLE
//ORA-00918: column ambiguously defined, add column name
$req = "SELECT SQL_CALC_FOUND_ROWS PTP_ID, p1.PAR_NOM as p1_par_nom,PTP_ADRESSE_EMET,PTP_QUALITE_EMET, p2.PAR_NOM as p2_par_nom,PTP_ADRESSE_DEST,PTP_QUALITE_DEST, PTP_STATUT, PTP_DATE_ENTREE, PTP_DATE_SORTIE,
			PTP_HISTO, PTP_EMET_ID, PTP_DEST_ID, p1.PAR_ID as p1_par_id, p2.PAR_ID as p2_par_id
   			FROM PART_TO_PART, PART p1, PART p2 
			WHERE PART_TO_PART.CLT_ID=".$cltID." 
			AND p1.PAR_ID=PTP_EMET_ID AND p2.PAR_ID=PTP_DEST_ID 
			".$where." ".$restriction;
					
//ASGS1 09/10/2008: rajout des colonnes adresse et qualit et changement de l'ordre des colonnes du grid
$champs = array();
$champs[] = array("nom" => $lang_flux_pargen_inv_part_filtre_part1, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_grid_head_adresse, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_grid_head_qualite, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_filtre_part2, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_grid_head_adresse, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_grid_head_qualite, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_filtre_etat, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_grid_head_datedeb, "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_pargen_inv_part_grid_head_datefin, "toolTip" => "", "sortMode" => "1");



$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';

echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{

	$params = array();
	$params['ptp_id'] = $row['PTP_ID'];
	$params['id_emet']=$row['p1_par_id'];
	$params['id_dest']=$row['p2_par_id'];
	$params['add1']=$row['PTP_ADRESSE_EMET'];
	$params['v1']=$row['PTP_QUALITE_EMET'];
	$params['add2']=$row['PTP_ADRESSE_DEST'];
	$params['v2']=$row['PTP_QUALITE_DEST'];
	$params['droits'] = array('modif' => (droit($droitRole, DROIT_MODIF,$row['p1_par_id'],$row['p2_par_id'],null,null))&& ($row['PTP_HISTO'] == 0),
							  'modifad' => (droit($droitRole, DROIT_MODIF,$row['p1_par_id'],$row['p2_par_id'],null,null))&& ($row['PTP_HISTO'] == 0),
							  );

	//detail *******************************************************************************************************************************
	/*$req2 = "SELECT PTP_DATE_ENTREE, PTP_DATE_SORTIE, PTP_NOM_EMET,PTP_ADRESSE_EMET,PTP_QUALITE_EMET, PTP_NOM_DEST,PTP_ADRESSE_DEST,PTP_QUALITE_DEST
   	FROM PART_TO_PART
	WHERE PART_TO_PART.CLT_ID=".$cltID." 
	AND PTP_EMET_ID='".$row[13]."' AND PTP_DEST_ID='".$row[14]."'";
	$gDb->SQLQuery($req2,2);
	
	$detail  = "";
	$detail .= "<table>";
	$detail .= "<tr><td><b>".$lang_flux_pargen_inv_part_filtre_part1."</b></td><td><b>".$lang_flux_pargen_inv_part_grid_head_adresse."</b></td><td><td><td><td><b>".$lang_flux_pargen_inv_part_grid_head_qualite."</b></td><td><b>".$lang_flux_pargen_inv_part_filtre_part2."</b></td><td><b>".$lang_flux_pargen_inv_part_grid_head_adresse."</b></td><td><td><td><td><b>".$lang_flux_pargen_inv_part_grid_head_qualite."</b></td><td><b>".$lang_flux_pargen_inv_part_grid_head_datedeb."</b></td><td><b>".$lang_flux_pargen_inv_part_grid_head_datefin."</b></td></tr>";
	while ($row2 = $gDb->SQLNextRow(2)) {
		$qualite_emet = "";
		if ($row2['PTP_QUALITE_EMET']=="A")
		{
			$qualite_emet = $lang_sui_inv_act_im_lbl_part_by;
		}
		else if ($row2['PTP_QUALITE_EMET']=="V")
		{
				$qualite_emet = $lang_sui_inv_act_im_lbl_part_se;
		}
		$qualite_dest = "";
		if ($row2['PTP_QUALITE_DEST']=="A")
		{
			$qualite_dest = $lang_sui_inv_act_im_lbl_part_by;
		}
		else if ($row2['PTP_QUALITE_DEST']=="V")
		{
				$qualite_dest = $lang_sui_inv_act_im_lbl_part_se;
		}
		$detail .= "<tr><td>".$row2['PTP_NOM_EMET']."</td><td>".$row2['PTP_ADRESSE_EMET']."</td><td><td><td><td>".$qualite_emet."</td><td>".$row2['PTP_NOM_DEST']."</td><td>".$row2['PTP_ADRESSE_DEST']."</td><td><td><td><td>".$qualite_dest."</td><td>".sql2date($row2['PTP_DATE_ENTREE'])."</td><td>".(($row2['PTP_DATE_SORTIE']==0)?"":sql2date($row2['PTP_DATE_SORTIE']))."</td></tr>";
	}
	$detail .= "</table>";
	$gDb->SQLFermeQuery(2);
	$detail = hi_disp($detail);*/
	//fin detail ***************************************************************************************************************************

	//$icon1 = $pathStyle."imgs/icons/part.gif";
	//$icon2 = $pathStyle."imgs/icons/part2.gif";
	
	if ($row['PTP_HISTO'] == 1)
	{
		$icon_etat = $pathStyle."imgs/icons/rond_jaune.png";
	}
	else
	{
		$icon_etat = $pathStyle."imgs/icons/rond_vert.png";
	}
	
	//echo '<row detail="'.$detail.'" >';
	echo '<row>';
	//ASGS1 09/10/2008: affichage des colonnes adresse et qualit emet et dest
	echo '<item caption="'.hi_disp($row['p1_par_nom']).'" toolTip="" icon="'.$icon_etat.'" value="'.row_encode_JSON($params).'"/>';
	echo '<item caption="'.hi_disp($row['PTP_ADRESSE_EMET']).'" toolTip="" icon="" value=""/>';
	echo '<item caption="'.GetRoleLabel($row['PTP_QUALITE_EMET']).'" toolTip="" icon="" value=""/>';
	echo '<item caption="'.hi_disp($row['p2_par_nom']).'" toolTip="" icon="" value=""/>';
	echo '<item caption="'.hi_disp($row['PTP_ADRESSE_DEST']).'" toolTip="" icon="" value=""/>';
	echo '<item caption="'.GetRoleLabel($row['PTP_QUALITE_DEST']).'" toolTip="" icon="" value=""/>';
	echo '<item caption="'.($val=($row['PTP_STATUT']==1)?($lang_flux_pargen_inv_part_filtre_etat_indemat):($lang_flux_pargen_inv_part_filtre_etat_outdemat)).'" toolTip="" icon="" value=""/>';
	echo '<item caption="'.sql2date($row['PTP_DATE_ENTREE']).'" toolTip="" icon="" value=""/>';
	if ($row['PTP_DATE_SORTIE'] != '' && $row['PTP_DATE_SORTIE'] != '0000-00-00 00:00:00')
	{
		// Bz4574 : BG 13/07/2012 : ajout/vrification de la condition pour ORACLE ET MSSQL (date initialisation diffrentes des colonnes de type "date" selon la BdD)
		if ($row['PTP_DATE_SORTIE'] != NULL && $row['PTP_DATE_SORTIE'] != '1900-01-01 00:00:00.000' && $row['PTP_DATE_SORTIE'] != '1900-01-01 00:00:00') //case MSSQL - ORACLE
			echo '<item caption="'.sql2date($row['PTP_DATE_SORTIE']).'" toolTip="" icon="" value=""/>';
		else
			echo '<item caption="pas de date de sortie" toolTip="" icon="" value=""/>';
		
	}
	else
	{
		echo '<item caption="pas de date de sortie" toolTip="" icon="" value=""/>';
	}
	echo '</row>';

	//ASGS1 maj noms si modif dans partenaires
	$req2 = "update PART_TO_PART set PTP_NOM_EMET = '".$row['p1_par_nom']."', PTP_NOM_DEST = '".$row['p2_par_nom']."' where PTP_ID = ".$row['PTP_ID']."";
	$res=$gDb->SQLQuery($req2,2);
	if ($res==null)	{
		$msg = $lang_admin_flux_pargen_inv_maj_nompart_msg_err;
		$return = 1;
					}
	$gDb->SQLFermeQuery(2);
	
}

$gDb->SQLFermeQuery(1);
echo '</databind>';

?>