<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";

require_once($DEFAULT_PATH."struct.php");
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "flux/pargen/pargen_actAction.php";

$p_role    = pget('p_role');
if ($p_role == 5 || $p_role == 1) 	$droitRole = RES;
else 								$droitRole = TRA;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR;//droits en lmcs

$pge_id	   = pget('pge_id');
$pge_libel = pget('pge_libel');
$action	   = pget('action');
$tpg_num   = pget('tpg_num');
$clt_id    = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;
$fatal = false;

if ($action == "suppr")
{
	$req = "select PGE_LIBEL
				from PAR_GEN 
				where PGE_ID = $pge_id";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	$pge_libel = $row['PGE_LIBEL'];
	$gDb->SQLFermeQuery(1);

	$req2 = "select count(*) as nb
				from ACTFLUX 
				where PGE_ID = $pge_id 
				and AFX_ACTIF != ".ETAT_SUPPR;
	$gDb->SQLQuery($req2, 2);
	$row2 = $gDb->SQLNextRow(2);
	$gDb->SQLFermeQuery(2);
	
	if ($row2['nb'] != 0)
	{
		$msg = $lang_flux_pargen_act_suppr_msg_err_act_flux_lie;
		$return = 1;
	}
	else
	{
		if ($gDb->SQLTransact() == false) $fatal = true;

		$req3 = "update PAR_GEN
					set PGE_ETAT = ".ETAT_SUPPR." 
					where PGE_ID = $pge_id";
		
		if ($gDb->SQLQuery($req3, 3) == false) $fatal = true;
		$gDb->SQLFermeQuery(3);

		if ($fatal)
		{
			$msg = addslashes($lang_flux_pargen_act_suppr_msg_err);
			$return =1;
			$gDb->SQLRollBack();
		}
		else
		{
			$msg = addslashes($lang_flux_pargen_act_suppr_msg_ok);
			$return=0;
			$gDb->SQLCommit();
		}
	}
}

if ($action == "create")
{
	$req = "select count(*) as nb
					from PAR_GEN 
					where PGE_LIBEL = '".dblQ($pge_libel)."'";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	if ($row['nb'] != 0)
	{
		$msg = addslashes($lang_flux_pargen_act_create_msg_err_dup);
		$return = 1;
	}
	else
	{
		if ($gDb->SQLTransact() == false) $fatal = true;

		$req = "insert into PAR_GEN
						(CLT_ID, TPG_NUM, PGE_LIBEL, PGE_ETAT) values 
						($clt_id, 
						$tpg_num, 
						'".dblQ($pge_libel)."', 
						".ETAT_ACTIF.")";
		if ($gDb->SQLQuery($req, 1) == false) $fatal = true;
		$gDb->SQLFermeQuery(1);
		$id_form = $gDb->SQLLastID();

		while (list ($key, $val) = each ($_GET))
		{
			$val = pget($key);
			if (preg_match("/form_/", $key))
			{
				$id_par = str_replace("form_", "", $key);

				$req2 = "insert into VAL_PAR_GEN
								(CLT_ID, PGE_ID, PFL_ID, VPG_VAL) values 
								($clt_id, 
								$id_form, 
								$id_par, 
								'".dblQ($val)."')";
				if ($gDb->SQLQuery($req2, 1) == false) $fatal = true;
				$gDb->SQLFermeQuery(1);
			}
		}
		if ($fatal)
		{
			
			$msg = addslashes($lang_flux_pargen_act_create_msg_err);
			$return = 1;
			$action = "create";
			$gDb->SQLRollBack();
		}
		else
		{
			$msg = addslashes($lang_flux_pargen_act_create_msg_ok);
			$return = 0;
			$gDb->SQLCommit();
		}
	}	
}
else if (($action == "modif")||($action == "dupliq"))
{
	$req = "select count(*) as nb
					from PAR_GEN 
					where PGE_LIBEL = '".dblQ($pge_libel)."'
					and PGE_ETAT !='2'
					and PGE_ID ".($action == "modif"? "!=": "=")." $pge_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	if ($row['nb'] != 0)
	{
		$msg = addslashes($lang_flux_pargen_act_create_msg_err_dup);
		$return = 1;
	}
	else
	{
		if ($gDb->SQLTransact() == false) $fatal = true;

		if ($action == "dupliq"){
			$req = "insert into PAR_GEN
							(CLT_ID, TPG_NUM, PGE_LIBEL, PGE_ETAT) values 
							($clt_id, 
							$tpg_num, 
							'".dblQ($pge_libel)."', 
							".ETAT_ACTIF.")";
			if ($gDb->SQLQuery($req, 1) == false) $fatal = true;
			$gDb->SQLFermeQuery(1);
			$pge_id = $gDb->SQLLastID();
		
		} else {
		
			$req = "update PAR_GEN
					set PGE_LIBEL = '".dblQ($pge_libel)."' 
					where PGE_ID = $pge_id";
			if ($gDb->SQLQuery($req, 1) == false) $fatal = true;
			$gDb->SQLFermeQuery(1);
		
		}
		
		while (list ($key, $val) = each ($_GET))
		{
			$val = pget($key);
			if (preg_match("/form_/", $key))
			{
				$id_par = str_replace("form_", "", $key);

				$req = "select count(*) as nb
								from VAL_PAR_GEN 
								where PGE_ID = $pge_id 
								and PFL_ID = $id_par";
				if ($gDb->SQLQuery($req, 1) == false) $fatal = true;
				$existe = $gDb->SQLNextRow(1);
				$gDb->SQLFermeQuery(1);

				if ($existe['nb'] == 0)
				$req = "insert into VAL_PAR_GEN (CLT_ID, PGE_ID, PFL_ID, VPG_VAL)
									values
									($clt_id, 
									$pge_id, 
									$id_par, 
									'".dblQ($val)."')";
				else
				$req = "update VAL_PAR_GEN
									set VPG_VAL = '".dblQ($val)."' 
									where PGE_ID = $pge_id 
									and PFL_ID = $id_par";
					

				if ($gDb->SQLQuery($req, 1) == false) $fatal = true;
				$gDb->SQLFermeQuery(1);
			}
		}
		if ($fatal)
		{
				
			$msg = addslashes($lang_flux_pargen_act_modif_msg_err);
			$return = 1;
			$action = "create";
			$gDb->SQLRollBack();
		}
		else
		{
			$msg = addslashes($lang_flux_pargen_act_modif_msg_ok);
			$return = 0;
			$gDb->SQLCommit();
		}
	}
}

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
$reponse['onsuccess'] = 'top.reload_menu()';
echo encode_JSON($reponse);
?>