<?php
$DEFAULT_PATH = str_repeat("../", (substr_count($_SERVER["PHP_SELF"], "/") - 2));
$culture_content_type = "application/json; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once ($DEFAULT_PATH."struct.php");

$droitRole = RES;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR;

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "flux/pargen/pesit/flux_pargen_pesit_actAction.php";

$spp_id = pget('spp_id');
$action	= pget('action');
$clt_id = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

if ($action == "suppr")
{
	if(!$gDb->SQLQuery("DELETE FROM SRVPESIT_PARAM WHERE SPP_ID = $spp_id", 1)) {
		$msg = $lang_flux_pargen_as2_act_suppr_msg_err;
		$return = 1;
	}
	else {
		$msg = $lang_flux_pargen_as2_act_suppr_msg_ok;
		$return = 0;
	}
	$gDb->SQLFermeQuery(1);
}
else if ($action == "create")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null))
	{
		$spp_port = pget('spp_port');
		$par_id = pget('par_id');
		$pro_id = pget('pro_id');
		$spp_ssl = pget('spp_ssl');
		$spp_auth = pget('spp_auth');
		$spp_meth = pget('spp_meth');
		$spp_log = pget('spp_log');
		$spp_log_taille = pget('spp_log_taille');
		$spp_log_nbfic = pget('spp_log_nbfic');

		if($spp_ssl=='') $spp_ssl = 0;
		if($spp_auth=='') $spp_auth = 0;
		if($spp_meth=='') $spp_meth = 1;
		if($spp_log=='') $spp_log = 0;
		if($spp_log_taille=='') $spp_log_taille = 1000000;
		if($spp_log_nbfic=='') $spp_log_nbfic = 5;

		$req = "INSERT INTO SRVPESIT_PARAM ( SPP_PORT, PAR_ID, CLT_ID, PRO_ID, SPP_SSL, SPP_AUTH, SPP_METH, SPP_LOG, SPP_LOG_TAILLE, SPP_LOG_NBFIC)
                 VALUES ($spp_port, $par_id, $clt_id, $pro_id, $spp_ssl, $spp_auth, $spp_meth, $spp_log, $spp_log_taille, $spp_log_nbfic)";
		$res = $gDb->SQLQuery($req, 1);
		if($res) {
			if ($res[0] == SQL_DUP_CHAMP) {
				$msg = $lang_flux_pargen_as2_act_modif_msg_err_dup;
				$return = 1;
			}
			else {
				$msg = $lang_flux_pargen_as2_act_create_msg_ok;
				$return = 0;
			}
		}
		else {
			$msg = $lang_flux_pargen_as2_act_create_msg_err;
			$return = 1;
		}
		$gDb->SQLFermeQuery(1);
	}
	else
	{
		$msg = $lang_admin_alert_act_msg_err_droit;
		$return = 1;
	}
}
else if ($action == "modif")
{
	if (droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$spp_port = pget('spp_port');
		$par_id = pget('par_id');
		$pro_id = pget('pro_id');
		$spp_ssl = pget('spp_ssl');
		$spp_auth = pget('spp_auth');
		$spp_meth = pget('spp_meth');
		$spp_log = pget('spp_log');
		$spp_log_taille = pget('spp_log_taille');
		$spp_log_nbfic = pget('spp_log_nbfic');

		if($spp_ssl=='') $spp_ssl = 0;
		if($spp_auth=='') $spp_auth = 0;
		if($spp_meth=='') $spp_meth = 1;
		if($spp_log=='') $spp_log = 0;
		if($spp_log_taille=='') $spp_log_taille = 1000000;
		if($spp_log_nbfic=='') $spp_log_nbfic = 5;

		$req = "UPDATE SRVPESIT_PARAM SET SPP_PORT=$spp_port, PAR_ID=$par_id, CLT_ID=$clt_id, PRO_ID=$pro_id, SPP_SSL=$spp_ssl, SPP_AUTH=$spp_auth, SPP_METH=$spp_meth, SPP_LOG=$spp_log, SPP_LOG_TAILLE=$spp_log_taille, SPP_LOG_NBFIC=$spp_log_nbfic WHERE SPP_ID=$spp_id";
		$res = $gDb->SQLQuery($req, 1);
		if($res) {
			if ($res[0] == SQL_DUP_CHAMP) {
				$msg = $lang_flux_pargen_as2_act_modif_msg_err_dup;
				$return = 1;
			}
			else {
				$msg = $lang_flux_pargen_as2_act_modif_msg_ok;
				$return = 0;
			}
		}
		else {
			$msg = $lang_flux_pargen_as2_act_modif_msg_err;
			$return = 1;
		}
		$gDb->SQLFermeQuery(1);
	}
	else
	{
		$msg = $lang_admin_alert_act_msg_err_droit;
		$return = 1;
	}
}

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
$reponse['onsuccess'] = 'top.reload_menu()';
echo encode_JSON($reponse);
?>