<?php
function verif_regle_rapproche($regle, &$msg)
{
	global $msg;
	global $return;
	$txt = $regle;
	$pos = Analyse_Condition($txt, $msg, 0);
	if ($pos == strlen($txt)) 
	{
		$msg ="";
		$return=0;
		return true;
	}
	else return false;
}

function verif_lib_rapproche($regle, &$msg)
{
	global $msg;
	global $return;
	$txt = $regle;
	$pos = Analyse_Libelle($txt, $msg, 0);
	$ret = false;
	if ($pos == strlen($txt)) 
	{
		$msg ="";
		$return=0;
		$ret = true;
	}
	return $ret;
}

function verif_lib_nonret_rapproche($regle, &$msg)
{
	return true;
}

//CONDITION := REGLE ( OPBIN CONDITION )
function Analyse_Condition($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	if ($pos == strlen($txt)) return $pos; //fin de chaine
	
	$pos_fin = Analyse_Regle($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos_fin == $pos) 	return $pos_deb;	//NOK. On renvoie la position de d�but
	$pos = $pos_fin;
	
	//OPBIN est facultatif
	$pos_fin = Analyse_OpBin($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos_fin == $pos) 	return $pos;	//NOK. On renvoie la position valide de la regle pr�c�dente
	$pos = $pos_fin;
	
	//REGLE est obligatoire puisque on a eu OPBIN
	$pos_fin = Analyse_Condition($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos_fin != $pos) 	return $pos_fin;	//OK
	
	return $pos_deb;					//NOK
}

//REGLE := REGLE_1 | REGLE_2 | MACRO
function Analyse_Regle($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	
	$pos_fin = Analyse_Macro($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos_fin != $pos) 	return $pos_fin;
	
	$pos_fin = Analyse_Regle_1($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos_fin != $pos) 	return $pos_fin;
	
	$pos_fin = Analyse_Regle_2($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos_fin != $pos) 	return $pos_fin;

	return $pos_deb;
}


//REGLE_1 = '(' CONDITION ')'
function Analyse_Regle_1($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	
	if ($txt[$pos] != "(") return $pos_deb;
	$pos++;
	
	$pos_fin = Analyse_Condition($txt, $msg, $pos);
	if ($pos_fin == -1) return -1;
	if ($pos_fin == $pos)
	{
		$msg = str_replace('%NUMPOS%',$pos,$lang_flux_macro_msg_err_cond);
		$return= 1 ;
		return -1;
	}
	$pos = $pos_fin;
	
	$pos = Blanc($txt, $pos);
	
	if ($txt[$pos] == ")") return ++$pos;
	
	$msg = str_replace('%NUMPOS%',$pos,$lang_flux_macro_msg_err_parent);
	$return= 1 ;
	return -1;
}

//REGLE_3 = OPUN CONDITION
function Analyse_Regle_2($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	
	$pos_fin = Analyse_OpUn($txt, $msg, $pos);
	if ($pos_fin == $pos) return $pos_deb;
	$pos = $pos_fin;
	
	$pos_fin = Analyse_Condition($txt, $msg, $pos);
	if ($pos_fin == -1) 	return -1;
	if ($pos != $pos_fin) 	return $pos_fin;
	
	$msg = str_replace('%NUMPOS%',$pos,$lang_flux_macro_msg_err_cond);
	$return= 1 ;
	return -1;
}

//OPBIN = '=' | '<>' | '&' | '|'
function Analyse_OpBin($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	
	if ($txt[$pos] == "=" || $txt[$pos] == "&" || $txt[$pos] == "|") 	return ($pos + 1);
	if ($txt[$pos] == "<" && $txt[$pos + 1] == ">") 					return ($pos + 2);
	if ($txt[$pos] == "<") 												return ($pos + 1);
	if ($txt[$pos] == ">") 												return ($pos + 1);

	$msg = str_replace('%NUMPOS%',$pos,$lang_flux_macro_msg_err_op_bin);
	$return= 1 ;
	return $pos_deb;
}

//OPUN = '!'
function Analyse_OpUn($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	
	if ($txt[$pos] == "!") return ($pos + 1);
	
	$msg = str_replace('%NUMPOS%',$pos,$lang_flux_macro_msg_err_op_un);
	$return= 1 ;
	return $pos_deb;
}

function Analyse_Macro($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	
	$macro = false;
	if (preg_match("/^#\\{/", substr($txt, $pos))) $macro = true;
	
	//#{DG_x,type} --> 1 <= x <= 5 et type = [AR] 
	if (preg_match("/^#\\{[ ]*DG_[1-5][ ]*,[ ]*[AR][ ]*\\}/", substr($txt, $pos))) 
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	//#{DT_x,type} --> 1 <= x <= 5 et type = [AR]
	if (preg_match("/^#\\{[ ]*DT_[1-5][ ]*,[ ]*[AR][ ]*\\}/", substr($txt, $pos)))
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	//#{DL_x,type} --> 1 <= x <= 5 et type = [AR]
	if (preg_match("/^#\\{[ ]*DL_[1-5][ ]*,[ ]*[AR][ ]*\\}/", substr($txt, $pos)))
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	//#{DATECOUR[,format]} --> format = [+-][0-9]{1,2}[MJH]
	if (preg_match("/^#\\{[ ]*DATECOUR([ ]*,[ ]*[+-][0-9]{1,2}[MJH]){0,1}[ ]*\\}/", substr($txt, $pos))) 
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	//#{DATEPREC[,format]} --> format = [+-][0-9]{1,2}[MJH]
	if (preg_match("/^#\\{[ ]*DATEPREC([ ]*,[ ]*[+-][0-9]{1,2}[MJH]){0,1}[ ]*\\}/", substr($txt, $pos))) 
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	//#{DATETRAIT,type[,format]} --> type = [AR] et format = [+-][0-9]{1,2}[MJ]
	if (preg_match("/^#\\{[ ]*DATETRAIT[ ]*,[ ]*[AR]([ ]*,[ ]*[+-][0-9]{1,2}[MJH]){0,1}[ ]*\\}/", substr($txt, $pos))) 
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	//#{CONST,txt} --> txt = [^}]
	if (preg_match("/^#\\{[ ]*CONST[ ]*,[ ]*[^\\}]*[ ]*\\}/", substr($txt, $pos))) 
	{
		while ($txt[$pos] != "}") $pos++;
		return $pos + 1;
	}
	
	if ($macro) 
	{
		$msg = str_replace('%NUMPOS%',$pos,$lang_flux_macro_msg_err_wrong_macro);
		$return= 1 ;
		return -1;
	}
	return $pos_deb;
}

function Blanc($txt, $pos)
{
	while ($txt[$pos] == " ") $pos++;
	return $pos;
}

function Analyse_Libelle($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	$pos = Blanc($txt, $pos);
	if ($pos == strlen($txt)) return $pos; //fin de chaine
	
	$pos_fin = Analyse_Macro($txt, $msg, $pos);
	if ($pos_fin == -1) return -1;
	$pos = $pos_fin;
	
	$pos = Blanc($txt, $pos);
	if ($pos == strlen($txt)) return $pos; //fin de chaine
	
	$pos_fin = Analyse_Texte($txt, $msg, $pos);
	
	return Analyse_Libelle($txt, $msg, $pos_fin);
}

function Analyse_Texte($txt, &$msg, $pos)
{
	global $msg;
	global $return;
	$pos_deb = $pos;
	
	while (true)
	{
		if ($pos == strlen($txt)) return $pos;
		if ($txt[$pos] == "#" && $txt[$pos + 1] == "{") return $pos;
		$pos++;
	}
}


?>