<?php
$DEFAULT_PATH = "../../../";
$culture_content_type = "application/json; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once($DEFAULT_PATH."struct.php");

$droitRole = PAR; //droit de gestion des partenaires
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "flux/part/adr/flux_part_adr_actAction.php";

//Récupération des param�tres du POST
$action = pget("action");
$adr_id = pget("adr_id");
$clt_id = $_SESSION["CLT_ID"];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;
$onsuccess = "";

/************************/
/* DEBUT ACTION = SUPPR	*/
/************************/
if ($action == "suppr")
{
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$gDb->SQLTransact();
		
		$req = "DELETE FROM VAL_PAR_ADR 
				WHERE ADR_ID = $adr_id";
		
		if (!$gDb->SQLQuery($req, 1))
		{
			$gDb->SQLRollBack(); 
			$msg = $lang_flux_part_adr_act_suppr_msg_err;
			$return = 1;
		}
		else {
			$req = "DELETE FROM ADRESSE 
					WHERE ADR_ID = $adr_id";
			
			if (!$gDb->SQLQuery($req, 1))
			{
				$gDb->SQLRollBack(); 
				$msg = $lang_flux_part_adr_act_suppr_msg_err;
				$return = 1;
			}
			else {
				$gDb->SQLCommit(); 
				$return = 0;
				$onsuccess = "reloadAdrGrid();";
			}
		}
	}		
}
/************************/
/* FIN ACTION = SUPPR	*/
/************************/

/************************************************************/
/* DEBUT ACTION = MODIF		 								*/
/************************************************************/
if ($action == "modif")
{
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$fatal = false;
		
		$req = "SELECT VPA_ID, PFL_ID FROM VAL_PAR_ADR, ADRESSE 
				WHERE ADRESSE.ADR_ID = $adr_id 
					AND ADRESSE.ADR_ID = VAL_PAR_ADR.ADR_ID";
		
		if(!$gDb->SQLQuery($req,1))
		{
			$gDb->SQLFermeQuery(1);
			$msg = $lang_flux_part_adr_act_modif_msg_err;
			$return = 1;
		}
		else {
			while($row = $gDb->SQLNextRow(1)) {
				$val = pget($row['PFL_ID']."_".$row['VPA_ID']);
				$req = "UPDATE VAL_PAR_ADR 
						SET VPA_VAL = '".dblQ($val)."'
						WHERE VPA_ID = ".$row['VPA_ID'];
				
				$fatal = (!$gDb->SQLQuery($req, 2));
				$gDb->SQLFermeQuery(2);
			}
			$gDb->SQLFermeQuery(1);
		}
		
		if ($fatal == true) {
			$msg = $lang_flux_part_adr_act_modif_msg_err;
			$return = 1;
		}
		else {
			$return = 0;
		}
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = MODIF		 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = CREATE		 							*/
/************************************************************/
if ($action == "create")
{
	$fatal = false;
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$pfl_adr = pget('pfl_adr');
		$par_id = pget('par_id');
		
		$req = "INSERT INTO ADRESSE (PAR_ID, ADR_TYPE, CLT_ID) VALUES ($par_id, $pfl_adr, $clt_id)";
		$res = $gDb->SQLQuery($req, 1);
		
		if($res == null) {
			$gDb->SQLFermeQuery(1);
			$msg = $lang_flux_part_adr_act_create_msg_err;
			$return = 1;
		}
		else
		{
			$adr_id = $gDb->SQLlastID();
			$gDb->SQLFermeQuery(1);
			
			$req = "SELECT PFL_ID
					FROM PAR_FLOW
					WHERE PFL_ROLE = ".PARAM_ROLE_ADRESSE." 
						AND PFL_ADR = $pfl_adr 
					ORDER BY PFL_NUM";
			
			$res = $gDb->SQLQuery($req, 1);
			
			if($res == null) {
				$gDb->SQLFermeQuery(1);
				$msg = $lang_flux_part_adr_act_create_msg_err;
				$return = 1;
			}
			else {
				while ($row_add = $gDb->SQLNextRow(1)) {
					$vpa_val = pget($row_add['PFL_ID']);
					$req = "INSERT INTO VAL_PAR_ADR (PFL_ID, ADR_ID, VPA_VAL, CLT_ID)
           					VALUES ('".$row_add['PFL_ID']."', $adr_id, '".dblQ($vpa_val)."', $clt_id)";
  					$fatal = (!$gDb->SQLQuery($req, 2));
  					$gDb->SQLFermeQuery(2);
				}
				$gDb->SQLFermeQuery(1);
			}
		}
		if ($fatal == true) {
			$msg = $lang_flux_part_adr_act_create_msg_err;
			$return = 1;
		}
		else
			$return = 0;
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = CREATE		 								*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
$reponse['onsuccess'] = $onsuccess;
echo encode_JSON($reponse);
?>