<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");
$droitRole = PAR; //droit de gestion des partenaires
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template
$page_courante = "flux/part/flux_part.php";

$vtp = new VTemplate;

$form = $vtp->Open($DEFAULT_PATH."template/gest_part_form.vtp");
$vtp->addSession($form, "global");

//Variable générales

//Titre et icone pour la barre de titre
$vtp->setVar($form, "global.title", addslashes($lang_flux_part_title));
$vtp->setVar($form, "global.icon", $pathStyle."imgs/icons/title/part.gif");

//ID Gemedoc pour l'aide
$vtp->setVar($form, "global.help_id", "liste_part");

$filtre = array();

//Nom
$filtre[] = array("id_filtre" => "f_nom", "type_filtre" => "prlFiltreField.types.prlTextBox",
"libelle_filtre" => $lang_flux_part_filtre_lbl_nom);

//Groupe pere
$filtre[] = array("id_filtre" => "f_pere", "type_filtre" => "prlFiltreField.types.prlComboTree",
"libelle_filtre" => $lang_flux_part_filtre_lbl_group,
"loadondropdown_filtre" => true,
"ds_filtre" => $pathFlow."dataSources/dSPartenaires.php?groupe=1&showNull=1");

mkFiltre($vtp, $form, $filtre);

//Titre et icone pour le sous-titre

$vtp->setVar($form, "global.head_javascript", "

	var treeView_DS_URL = Prologue.Flow.path+'flux/part/flux_part_dSTree.php';
	var help = top.help;
	
	function resize_act_panel () {
		var list_act_panel = $('list_act_panel');
		var divTreePart = $('divTreePart');
		var list_act_title = list_act_panel.firstChild.firstChild;
		var list_act_tb = divTreePart.previousSibling;
		var act_panel = $('act_panel');
		var act_panel_content = act_panel.rows[1].cells[0].firstChild;
		var ifmParam = $('ifmParam');
		
		var pnlFiltre = $('pnlFiltre');
		
		var w = parseInt(document.body.clientWidth);
		w -= parseInt(list_act_panel.offsetWidth);
		w -= parseInt(list_act_panel.currentStyle.borderLeftWidth)||0;
		w -= parseInt(list_act_panel.currentStyle.borderRightWidth)||0;
		w -= parseInt(list_act_panel.currentStyle.paddingLeft)||0;
		w -= parseInt(list_act_panel.currentStyle.paddingRight)||0;
		w -= parseInt(document.body.currentStyle.marginLeft)*3;
		w -= parseInt(document.body.currentStyle.marginRight)*3;

		act_panel_content.style.width = w + 'px';
		ifmParam.style.width = w + 'px';

		var h = parseInt(document.body.clientHeight);
		h -= parseInt(document.body.currentStyle.marginTop)*4;
		h -= parseInt(document.body.currentStyle.marginBottom)*3;
		h -= parseInt(pnlFiltre.offsetHeight);
		
		act_panel.style.height = h + 'px';
		list_act_panel.style.height = h + 'px';
		
		h -= parseInt(list_act_title.offsetHeight);
		act_panel_content.style.height = h + 'px';
		ifmParam.style.height = h + 'px';
		
		h -= parseInt(list_act_tb.offsetHeight);
		divTreePart.style.height = h +'px';

		divTreePart.focus();
	}

	function setTitle (title, icon) {
		var item = $('act_panel').rows[0].cells[0].firstChild;
		Prologue.item.setText(item, title||'$lang_flux_part_act_detail_title');
		Prologue.item.setIcon(item, icon||Prologue.Flow.images+'icons/admin.gif');  
	};
	
	window.attachEvent('onresize', resize_act_panel);
	window.attachEvent('onload', resize_act_panel);

	function paramLoadPage (url) {
		var ifm = frames['ifmParam'];
		if(url)
			ifm.location.href = urldecode(url);
	}

	function act_tree_reload () {
		Prologue.treeView.reload('act_tree', treeView_DS_URL);
	}

	var partenaire = new function () {
		this.create = function () {
			if(".(droit($droitRole, DROIT_CREAT, null, null, null, null)? "true": "false").") {
				var par_id = prlExec(Prologue.Flow.path+'flux/part/flux_part_actAction.php?action=create'); 
				if(par_id > 0) {
					act_tree_reload();
					Prologue.treeView.selectNodeByValue('act_tree', par_id);
					var part = Prologue.treeView.getSelected('act_tree');
					if(part.index > -1)
						paramLoadPage(Prologue.Flow.path+'flux/part/flux_part_actAffich.php?action=modif&par_id='+part.value);
				}
			}
		}

		this.remove = function () {
			if(".(droit($droitRole, DROIT_SUPPR, null, null, null, null)? "true": "false")."){
				var part = Prologue.treeView.getSelected('act_tree');
				if(part.index > -1 && part.caption!='new_part') {
					var msg_suppr = '".addslashes($lang_flux_part_grid_question_suppr)."';
					msg_suppr = msg_suppr.replace('%PARTNOM%', part.caption); 
					if(confirm(msg_suppr)){
						prlExec(Prologue.Flow.path+'flux/part/flux_part_actAction.php?action=suppr&par_id='+part.value);
						paramLoadPage(Prologue.Flow.path+'flux/part/flux_part_blank.php');
					}
				} else {
					if(part.index > -1 && part.caption=='new_part') alert('".$lang_flux_part_grid_modif_suppr."');
				}
			}
		}
		this.detail = function () {
			if(".(droit($droitRole, DROIT_LECT, null, null, null, null)? "true": "false")."){
				var part = Prologue.treeView.getSelected('act_tree');
				if(part.index > -1)
					paramLoadPage(Prologue.Flow.path+'flux/part/flux_part_actAffich.php?action=detail&par_id='+part.value);
			}
		}
		this.modif = function () {
			if(".(droit($droitRole, DROIT_MODIF, null, null, null, null)? "true": "false")."){
				var part = Prologue.treeView.getSelected('act_tree');
				if(part.index > -1)
					paramLoadPage(Prologue.Flow.path+'flux/part/flux_part_actAffich.php?action=modif&par_id='+part.value);
			}
		}
	};

");


//Activités

$content = "
<center>
<table>
	<tr>
		<td>
			<style type=\"text/css\">
				td.prlContainerContent div { overflow-y:hidden !important; }
			</style>
			
			<script language=\"JavaScript\" type=\"text/javascript\">
				var act_treeview = new Prologue.treeView('act_tree');
				act_treeview.dataSource = treeView_DS_URL;
				act_treeview.onClick = \"partenaire.detail();\";
				act_treeview.hasKeydown = true;

				page.gridReload = function () {
					if(typeof filList != 'undefined')
						url = treeView_DS_URL + '?' + filList.getInfo();
					Prologue.treeView.reload('act_tree', url);
				}

				$('pnlFiltre').prlOnClose = function () {
					var sm = filList.getSummary();
					return sm;
				};
	
				var toolBar = new Prologue.toolbar('act_tlbr');
				toolBar.style = Prologue.toolbar.style.button;
	
				with(new Prologue.container('$lang_flux_part_grid_lbl_type_part', Prologue.Flow.images+'icons/exec.png')) {
					id = 'list_act_panel';
					content = '<div style=\"background-color: #D0C8C1;\">'+toolBar.html()+'</div>';
					content += '<div id=\"divTreePart\" style=\"overflow:auto !important; width:100%;\">'+act_treeview.html()+'</div>';
					clientWidth = '320px';
					create();
				}
				
				Prologue.toolbar.reload('act_tlbr', Prologue.Flow.path+'flux/part/flux_part_dSToolBar.php');
			</script>
		</td>
		<td>
			<script language=\"JavaScript\" type=\"text/javascript\">
				with(new Prologue.container('$lang_flux_part_act_detail_title', Prologue.Flow.images+'icons/admin.gif')) {
					id = 'act_panel';
					content = '<iframe id=\"ifmParam\" name=\"ifmParam\" src=\"flux_part_blank.php\" FRAMEBORDER=\"0\" SCROLLING=\"AUTO\"></iframe>';
					create();
				}
			</script>
		</td>
	</tr>
</table>
</center>
";

$vtp->setVar($form, "global.javascript", "");
$vtp->setVar($form, "global.content", $content);

include($DEFAULT_PATH."header.php");
$vtp->setVar($form, "global.page_headers", $page_headers);
$vtp->closeSession($form, "global");
$vtp->Display();
?>