<?php
$DEFAULT_PATH = "../../../";
$culture_content_type = "application/json; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once($DEFAULT_PATH."struct.php");
$droitRole = PAR; //droit de gestion des partenaires
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "flux/part/id/flux_part_id_actAction.php";

//Récupération des paramètres du POST
$action = pget("action");
$par_id = pget("par_id");
$ide_id = pget("ide_id");
$ide_val = pget("ide_val");
$ide_pwd = pget("ide_pwd");
$clt_id = $_SESSION["CLT_ID"];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;
$onsuccess = "";

/************************/
/* DEBUT ACTION = SUPPR	*/
/************************/
if ($action == "suppr")
{
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$req = "DELETE FROM IDENT
				WHERE IDE_ID = $ide_id";
		
		if (!$gDb->SQLQuery($req, 1))
		{
			$msg = $lang_flux_part_id_act_suppr_msg_err;
			$return = 1;
		}
		else {
			$return = 0;
			$onsuccess = "reloadIdGrid();";
		}
		$gDb->SQLFermeQuery(1);
	}		
}
/************************/
/* FIN ACTION = SUPPR	*/
/************************/

/************************************************************/
/* DEBUT ACTION = MODIF		 								*/
/************************************************************/
if ($action == "modif")
{
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$req = "SELECT COUNT(*) AS NB
				FROM IDENT 
				WHERE IDE_VAL = '".dblQ($ide_val)."' AND IDE_ID != $ide_id";
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);
		
		if ($row['NB'] > 0)
		{
			$msg = str_replace("%ID%", addslashes($ide_val), $lang_flux_part_act_import_msg_err_dup_id);
			$return = 1;
		}
		else
		{
			$req = "UPDATE IDENT SET 
					IDE_VAL = '".dblQ($ide_val)."', IDE_PWD =  '".dblQ($ide_pwd)."'
					WHERE IDE_ID = $ide_id";
			
			if (!$gDb->SQLQuery($req, 1))
			{
				$msg = $lang_flux_part_id_act_modif_msg_err;
				$return = 1;
			}
			else {
				$return = 0;
				$onsuccess = "opener.reloadIdGrid();";
			}
		}
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = MODIF		 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = CREATE		 							*/
/************************************************************/
if ($action == "create")
{
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$req = "INSERT INTO IDENT (IDE_VAL, IDE_PWD, PAR_ID, CLT_ID)
				VALUES ('".dblQ($ide_val)."', '".dblQ($ide_pwd)."', $par_id, $clt_id)";
		$res = $gDb->SQLQuery($req,1);
		$gDb->SQLFermeQuery(1);
		
		if($res == null) {
			$msg = $lang_flux_part_id_act_create_msg_err;
			$return = 1;
		}
		else
		{
			if ($res[0] == SQL_DUP_CHAMP)
			{
				$msg = str_replace("%ID%", addslashes($ide_val), $lang_flux_part_act_import_msg_err_dup_id);
				$return = 1;
			}
			else {
				$return = 0;
				$onsuccess = "opener.reloadIdGrid();";
			}
		}
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = CREATE		 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = IMPORT de fichier CSV                     */
/************************************************************/
if ($action == "import")
{
	header('content-type:text/html;charset=utf-8'); // retour en HTML et non en JSon
	include($DEFAULT_PATH."header.php");
	echo "<html><header>$page_headers</header><body><br/><center>";
	$bClose = true;
	if (droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null))
	{
		$msg = array();
		
		$ide_file_import = pget('ide_file_import');
		$col_num = pget('col_num');
		
		try
		{
			if(is_file($ide_file_import))
			{
				$liste = explode("\n", file_get_contents($ide_file_import));
			
				foreach($liste as $line)
				{
					$items = explode(";", $line);
					if(isset($items[$col_num-1]))
					{
						$ide_val = trim($items[$col_num-1], "\r\n");
						if($ide_val!='')
						{
							$req = "INSERT INTO IDENT (IDE_VAL, IDE_PWD, PAR_ID, CLT_ID)
									VALUES ('".dblQ($ide_val)."', '', $par_id, $clt_id)";
							$res = $gDb->SQLQuery($req,1);
							$gDb->SQLFermeQuery(1);

							if($res == null)
								$msg[] = str_replace("%ID%", '<b>'.addslashes($ide_val).'</b>', $lang_flux_part_act_import_msg_err_creer_id);
							else if ($res[0] == SQL_DUP_CHAMP)
								$msg[] = str_replace("%ID%", '<b>'.addslashes($ide_val).'</b>', $lang_flux_part_act_import_msg_err_dup_id);
						}
					}
				}
			}
			else
			{
				$bClose = false;
				$msg[] = "$lang_flux_av_imp_flux_act_msg_err_ouv_fic<b>$ide_file_import</b>";
			}
		}
		catch(Exception $e)
		{
			$bClose = false;
			$msg[] = "$lang_bus_et_act_majbdd_msg_err <b>$ide_file_import :</b>";
			$msg[] = $e->getMessage();
		}
		
		if(count($msg)>0)
		{
			foreach($msg as $m)
				echo "<br/>$m";
		}
		else
		{
			echo "<b>$lang_flux_part_act_import_msg_ok</b>";
		}
	}
	else
	{
		$bClose = false;
		echo "<b>$lang_flux_tdoc_act_msg_err_droit</b>";
	}

	if($bClose)
		$close = 'opener.reloadIdGrid();window.close();';
	else
		$close = 'history.go(-1);';
	
	echo "<br/><br/><script language='JavaScript' type='text/javascript'>
		new prlButton(lang_lbl_retour, '$close', Prologue.Flow.images+'icons/retour.gif').create();
	</script></center></body></html>";
	
	exit; // dans tous les cas on sort car nous ne sommes plus en JSon
}
/************************************************************/
/* FIN ACTION = IMPORT		 								*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
$reponse['onsuccess'] = $onsuccess;
echo encode_JSON($reponse);
?>