<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "application/json; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";

require_once($DEFAULT_PATH."struct.php");
$droitRole = DOC;//droit de gestion des types de documents
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR;//droits en lmcs
$where = "";

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."flux/tdoc/flux_tdoc_struct.php");

$page_courante = "flux/tdoc/flux_tdoc_actAction.php";

$tdoc_id		= pget('tdoc_id');
$TDOC_NOM		= pget('TDOC_NOM');
$FOR_NOM		= pget("FOR_NOM");
$FOR_NORME		= pget("FOR_NORME");
$FOR_VERSION	= pget("FOR_VERSION");
$FOR_STYLE		= pget("FOR_STYLE");
$TDOC_CONSERV   = pget('TDOC_CONSERV');
$AFFICH   = pget('AFFICH');
$action 		= pget('action');


$i = 0;
//$TDOC_SUI_LIB est declaré dans struct.php
foreach($TDOC_SUI_LIB as $lib_par)
{
	${"SUI_LIB_".$i} = pget("SUI_LIB_".$i);
	${"SUI_AFF_".$i} = pget("SUI_AFF_".$i);
	${"SUI_REC_".$i} = pget("SUI_REC_".$i);
	$i++;
};


//$TDOC_VALID_LIB est declar� dans struc.php
$i = 0;
foreach($TDOC_VALID_LIB as $lib_valid)
{
	${"VALID_LIB_".$i} = pget("VALID_LIB_".$i);
	$i++;
}

$clt_id = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************************************************/
/* DEBUT ACTION = SUPPRESSION		 						*/
/************************************************************/
if ($action == "suppr")
{
	$fatal = false;
	
	/*
	$req = "SELECT TDOC_NOM 
			FROM TYPE_DOC 
			WHERE TDOC_ID = $tdoc_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$TDOC_NOM = $row['TDOC_NOM'];
	$gDb->SQLFermeQuery(1);
	*/

	$req = "SELECT COUNT(*) AS nb 
			FROM FLUX, `FORMAT`  
			WHERE FLX_ACTIF != ".ETAT_SUPPR." 
			AND TDOC_ID = $tdoc_id 
			AND FLUX.FOR_ID = `FORMAT`.FOR_ID 
			AND FOR_ETAT != ".ETAT_SUPPR;
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$nb = $row['nb'];
	$gDb->SQLFermeQuery(1);
	if ($nb > 0)
	{
		$msg = $lang_flux_tdoc_act_suppr_msg_err_assoc_flux;
		$return = 1;
		$fatal = true;
	}
	
	$req = "SELECT COUNT(*) AS nb 
			FROM ROLE  
			WHERE ROL_ETAT != ".ETAT_SUPPR." 
			AND TDOC_ID = $tdoc_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$nb = $row['nb'];
	$gDb->SQLFermeQuery(1);
	if ($nb > 0)
	{
		$msg = $lang_flux_tdoc_act_suppr_msg_err_assoc_role;
		$return = 1;
		$fatal = true;
	}
	
	if (!$fatal)
	{
		$gDb->SQLTransact();
		$req = "UPDATE `FORMAT` 
				SET FOR_ETAT = ".ETAT_SUPPR." 
					WHERE TDOC_ID = $tdoc_id";
		if (!$gDb->SQLQuery($req, 1))
		{
			$msg = $lang_flux_tdoc_act_suppr_msg_err;
			$return = 1;
			$fatal = true;
		}
		$gDb->SQLFermeQuery(1);
		if (!$fatal)
		{
			$req = "UPDATE TYPE_DOC  
					SET TDOC_ETAT = ".ETAT_SUPPR." 
						WHERE TDOC_ID = $tdoc_id";
			if (!$gDb->SQLQuery($req, 1))
			{
				$msg = $lang_flux_tdoc_act_suppr_msg_err;
				$return = 1;
				$fatal = true;
			}
			$gDb->SQLFermeQuery(1);
		}
	
		if ($fatal) $gDb->SQLRollBack();
		else 
		{
			$gDb->SQLCommit();
			$msg = $lang_flux_tdoc_act_suppr_msg_ok;
			$return = 0;
		}
	}
}
/************************************************************/
/* FIN ACTION = SUPPRESSION 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = CREATION		 							*/
/************************************************************/
else if ($action == "create")
{
	$fatal = false;
	if (droit($droitRole, DROIT_CREAT,null,null,null,null))
	{		
		$req = "SELECT count(*) AS nb 
				FROM TYPE_DOC  
				WHERE CLT_ID = $clt_id 
				AND TDOC_NOM = '".dblQ($TDOC_NOM)."'";
		
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		if ($row['nb'] >= 1) 
		{
			$msg = $lang_flux_tdoc_act_create_msg_err_dup_nom;
			$return = 1;
			$falal = true;
		}
		$gDb->SQLFermeQuery(1);
		
		$req = "SELECT COUNT(*) AS nb
				FROM `FORMAT` 
				WHERE CLT_ID = $clt_id 
				AND FOR_NOM = '".dblQ($FOR_NOM)."' 
				AND FOR_NORME = '".dblQ($FOR_NORME)."' 
				AND FOR_VERSION = '".dblQ($FOR_VERSION)."'";
		
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		if ($row['nb'] > 0)
		{
			$msg = $lang_flux_tdoc_act_create_msg_err_dup_format;
			$return = 1;
			$fatal = true;
		}
		$gDb->SQLFermeQuery(1);
		
		if (!$fatal)
		{
			$gDb->SQLTransact();
			$i = 0;
			foreach($TDOC_SUI_LIB as $lib_par)
			{
				if ($i == 0)
					$tdoc_sui = ${"SUI_LIB_".$i}."::".${"SUI_AFF_".$i}."::".${"SUI_REC_".$i};
				else
					$tdoc_sui .= ";;".${"SUI_LIB_".$i}."::".${"SUI_AFF_".$i}."::".${"SUI_REC_".$i};
				$i++;
			}
			
			$i = 0;
			foreach($TDOC_VALID_LIB as $lib_valid)
			{
				if ($i == 0) $tdoc_valid = ${"VALID_LIB_".$i};
				else $tdoc_valid .= ";;".${"VALID_LIB_".$i};
				$i++;
			}
 			 
			$req = "INSERT INTO TYPE_DOC (TDOC_NOM, TDOC_CONSERV, CLT_ID, TDOC_SUI, TDOC_ETAT, TDOC_VALID, TDOC_MASQUE) 
					VALUES ('".dblQ($TDOC_NOM)."',
					$TDOC_CONSERV,
					$clt_id, 
					'".dblQ($tdoc_sui)."',".
					ETAT_ACTIF.", 
					'".dblQ($tdoc_valid)."',
					$AFFICH)";
				
			if (!$gDb->SQLQuery($req, 1)) $fatal = true;
			$tdoc_id = $gDb->SQLlastID();
			
			$req = "INSERT INTO `FORMAT` (FOR_NOM, FOR_NORME, FOR_VERSION, CLT_ID, TDOC_ID, 
					FOR_ETAT, FOR_STYLE) 
					VALUES ('".dblQ($FOR_NOM)."', 
					'".dblQ($FOR_NORME)."', 
					'".dblQ($FOR_VERSION)."',
					$clt_id,
					$tdoc_id, 
					".ETAT_ACTIF.",
					'".dblQ($FOR_STYLE)."')";
						
			if (!$gDb->SQLQuery($req, 1))
				$fatal = true;

			if ($fatal)
			{
				$msg = $lang_flux_tdoc_act_create_msg_err;
				$return = 1;
				$gDb->SQLRollBack();
			}
			else 
			{
				$msg = $lang_flux_tdoc_act_create_msg_ok;
				$return = 0;
				$gDb->SQLCommit();
			}
			$gDb->SQLFermeQuery(1);
		}		
		
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}

/************************************************************/
/* FIN ACTION = CREATION 									*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = MODIFICATION	 							*/
/************************************************************/
if ($action == "modif")
{
	if (droit($droitRole, DROIT_MODIF,null,null,null,null))
	{		
		$req = "SELECT COUNT(*) AS nb 
				FROM TYPE_DOC  
				WHERE CLT_ID = $clt_id 
				AND TDOC_NOM = '".dblQ($TDOC_NOM)."' 
				AND TDOC_ID != $tdoc_id";
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		if ($row['nb'] >= 1) 
		{
			$msg = $lang_flux_tdoc_act_create_msg_err_dup_nom;
			$return = 1;
			$gDb->SQLFermeQuery(1);
		}
		else
		{
			$i = 0;
			foreach($TDOC_SUI_LIB as $lib_par)
			{
				if ($i == 0) $tdoc_sui = ${"SUI_LIB_".$i}."::".${"SUI_AFF_".$i}."::".${"SUI_REC_".$i};
				else $tdoc_sui .= ";;".${"SUI_LIB_".$i}."::".${"SUI_AFF_".$i}."::".${"SUI_REC_".$i};
				$i++;
			}
			
			$i = 0;
			foreach($TDOC_VALID_LIB as $lib_valid)
			{
				if ($i == 0) $tdoc_valid = ${"VALID_LIB_".$i};
				else $tdoc_valid .= ";;".${"VALID_LIB_".$i};
				$i++;
			}
		
			$gDb->SQLFermeQuery(1); 
			$req = "UPDATE TYPE_DOC
					SET TDOC_NOM = '".dblQ($TDOC_NOM)."',
					TDOC_CONSERV = '".dblQ($TDOC_CONSERV)."', 
					TDOC_SUI = '".dblQ($tdoc_sui)."',
					TDOC_VALID = '".dblQ($tdoc_valid)."',
					TDOC_MASQUE =  $AFFICH
					WHERE TDOC_ID = $tdoc_id";
			if (!$gDb->SQLQuery($req, 1))
			{
				$msg = $lang_flux_tdoc_act_modif_nom_msg_err;
				$return = 1;
			}
			else 
			{
				$msg = $lang_flux_tdoc_act_modif_msg_ok;
				$return = 0;
			}
			$gDb->SQLFermeQuery(1);
		}
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}

/************************************************************/
/* FIN ACTION = MODIFICATION 								*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
$reponse['onsuccess'] = 'top.reload_menu()';
echo encode_JSON($reponse);
?>