<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");
$droitRole = DOC; //droit de gestion des types de documents
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; //droits en lmcs

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template
require_once($DEFAULT_PATH."flux/tdoc/flux_tdoc_struct.php");

$page_courante = "flux/tdoc/flux_tdoc_actAffich.php";

$vtp = new VTemplate;

$tdoc_id = pget('tdoc_id');
$action = pget('action');

$form = $vtp->Open($DEFAULT_PATH."template/form.vtp");
$vtp->addSession($form, "global");

switch($action) {
	case 'create':
		$readOnly = false;
		$panelTitle = $lang_lbl_create;
		$panelIcon = $pathStyle."imgs/icons/add.gif";
		break;
	case 'modif':
		$readOnly = false;
		$panelTitle = $lang_lbl_modif;
		$panelIcon = $pathStyle."imgs/icons/admin.gif";
		break;
	case 'detail':
		$readOnly = true;
		$panelTitle = $lang_lbl_detail;
		$panelIcon = $pathStyle."imgs/icons/loupe.gif";
		break;
}

//Variable générales

//Titre et icone pour la barre de titre
$vtp->setVar($form, "global.title", addslashes($lang_flux_tdoc_title_defaut));
$vtp->setVar($form, "global.icon", $pathStyle."imgs/icons/title/flux_tdoc.gif");

//Titre et icone pour le sous-titre
$vtp->setVar($form, "global.panelTitle", $panelTitle);
$vtp->setVar($form, "global.panelIcon", $panelIcon);

//ID Gemedoc pour l'aide
$vtp->setVar($form, "global.help_id", "20040108122335");

//Le formulaire est-il en lecture seule ?
$vtp->setVar($form, "global.readOnly", (($readOnly)? "true": "false"));

//Action à réaliser en appuyant dur le bouton 'Retour'
$vtp->setVar($form, "global.back_fct", "history.go(-1);");

//Variables statiques du form (input hidden)
$vtp->addSession($form, "form_input_hidden");
$vtp->setVar($form, "form_input_hidden.name", "action");
$vtp->setVar($form, "form_input_hidden.value", $action);
$vtp->closeSession($form, "form_input_hidden");

$vtp->addSession($form, "form_input_hidden");
$vtp->setVar($form, "form_input_hidden.name", "tdoc_id");
$vtp->setVar($form, "form_input_hidden.value", $tdoc_id);
$vtp->closeSession($form, "form_input_hidden");

if($action!='create')
{
	$req = "SELECT TDOC_NOM, TDOC_SUI, TDOC_CONSERV, TDOC_VALID, TDOC_MASQUE FROM TYPE_DOC WHERE TDOC_ID = $tdoc_id";
	
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	$TDOC_NOM = $row['TDOC_NOM'];
	$TDOC_CONSERV = $row['TDOC_CONSERV'];
	$TDOC_MASQUE = $row['TDOC_MASQUE'];
	$TDOC_SUI = $row['TDOC_SUI'];
	$TDOC_VALID = $row['TDOC_VALID'];
}
else
{
	$TDOC_NOM = '';
	$TDOC_CONSERV = '60';
	$TDOC_MASQUE = 0;
	$TDOC_SUI = '';
	$TDOC_VALID = '';
}

//Construction de la fonction de vérification du formualaire

// Nombres de paramètres de suivi
$nb_sui_elem = count($TDOC_SUI_LIB);

$fieldListID = "'TDOC_NOM', 'TDOC_CONSERV'";
$fieldListName = "'".addslashes($lang_flux_tdoc_aff_lbl_tdoc_nom)."', '".addslashes($lang_flux_tdoc_aff_lbl_delai)."'";
if($action == "create") {
	$fieldListID .= ",'FOR_NORME', 'FOR_NOM', 'FOR_VERSION', 'FOR_STYLE'";
	$fieldListName .= ",'".addslashes($lang_flux_tdoc_aff_lbl_norme)."'";
	$fieldListName .= ",'".addslashes($lang_flux_tdoc_aff_lbl_msg)."'";
	$fieldListName .= ",'".addslashes($lang_flux_tdoc_aff_lbl_vers)."'";
	$fieldListName .= ",'".addslashes($lang_flux_tdoc_aff_lbl_style)."'";
}

$head_javascript = "
//Liste des champs obligatoires
var fieldListID = new Array($fieldListID);
			
//Liste des libellés de champs obligatoires								
var fieldListName = new Array($fieldListName);

function verifForm() {
	var check = true;
	var msg_field_needed  = '".addslashes($lang_flux_tdoc_aff_msg_err_no_field)."';
		
	for(var i = 0; i < fieldListID.length; ++i) {
		var inpt = $(fieldListID[i]);
		if(fieldListID[i] != 'FOR_STYLE' && inpt.value.length == 0) {
			alert(msg_field_needed.replace('%FIELDNAME%', fieldListName[i]));
			check = false;
			$(fieldListID[i]).focus();
			break;
		}
		else if(false == prlTextBox.checkFormat(inpt) && inpt.value.length != 0) {
			inpt.onchange();
			check = false;
			inpt.focus();
			break;
		}

	}

	var nub_sui_elem = $nb_sui_elem;
	if(check) {
		for(var i = 0; i < nub_sui_elem; ++i) {
			var inpt_sui_lib = $('SUI_LIB_'+i);
			var chkbx_sui_aff = $('SUI_AFF_'+i);
			var chkbx_sui_rec = $('SUI_REC_'+i);

			if (inpt_sui_lib.value.length == 0  &&
				chkbx_sui_aff.checked == true)
			{
				alert('".addslashes($lang_flux_tdoc_aff_msg_err_param_vis_vide)."');
				inpt_sui_lib.focus();
				check = false;
				break;
			}
			if (chkbx_sui_aff.checked == false &&
				chkbx_sui_rec.checked == true)
			{
				alert('".$lang_flux_tdoc_aff_msg_err_param_rech_novis."');
				inpt_sui_lib.focus();
				check = false;
				break;
			}
		}
	}

	if(check && (submitForm(this.document.forms['filtre'], 'flux_tdoc_actAction.php', prlExec) == 0)) {
		changePage('flux_tdoc.php');
	}
}
";
$vtp->setVar($form, "global.head_javascript", $head_javascript);


//Nom du TDOC
if($readOnly){
	$content = $TDOC_NOM;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlTextBox('TDOC_NOM', prlTextBox.formats.any, '".addslashes($TDOC_NOM)."')) {
			maxLength  = 35;
			trim = prlTextBox.trimMode.both;
			onClick = 'if(this.value.length == 0){ alert(\'$lang_flux_tdoc_aff_msg_err_nonom\'); this.focus();}';
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_tdoc_aff_lbl_tdoc_nom.(!$readOnly? " (*)":""));
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//Délai de conservation du TDOC
if($readOnly){
	$content = $TDOC_CONSERV;
	$javascript = "";
}
else {
	$javascript = "
		with(new prlTextBox('TDOC_CONSERV', prlTextBox.formats.uinteger, '$TDOC_CONSERV')) {
			maxLength  = 4;
			create();
		};";
	$content = "";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_tdoc_aff_lbl_delai.(!$readOnly? " (*)":""));
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//Affichage (ou pas) du TDOC
$readOnlyCaption = (($TDOC_MASQUE == 0)? $lang_flux_tdoc_aff_lbl_affich_oui: $lang_flux_tdoc_aff_lbl_affich_masq);
if($readOnly){
	$content = $readOnlyCaption;
	$javascript = "";
}
else {
	$javascript = "
		with(affich = new prlComboList('AFFICH', '$TDOC_MASQUE')) {
			add('$lang_flux_tdoc_aff_lbl_affich_oui', '', '', '0');
			add('".$lang_flux_tdoc_aff_lbl_non."', '', '', '1');
			create();
		}
	";
	$content = "";
}

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_tdoc_aff_lbl_affich);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");



//Préparation de la liste des paramètres de suivi
$SUI = explode(";;", $TDOC_SUI);
$VALID = explode(";;", $TDOC_VALID);

$i = 0;
foreach($SUI as $zone)
{
	$zz = explode("::", $zone);
	${"SUI_LIB_".$i} = $zz[0];
	if(isset($zz[1])) ${"SUI_AFF_".$i} = $zz[1]; else ${"SUI_AFF_".$i} = '';
	if(isset($zz[2])) ${"SUI_REC_".$i} = $zz[2]; else ${"SUI_REC_".$i} = '';
	$i++;
}
	
$i = 0;
foreach($VALID as $zone)
{
	${"VALID_LIB_".$i} = $zone;
	$i++;
}


$i = 0;

//Création du tableau des paramètres de suivi
$content = "
<table cellpadding=\"4\" width=\"100%\" class=\"details\">
	<tr>
		<td>&nbsp;</td>
		<td class=\"detailsCaption\"><b><i>$lang_flux_tdoc_aff_lbl_libel</i></b></td>
		<td class=\"detailsCaption\"><b><i>$lang_flux_tdoc_aff_lbl_toaffich</i></b></td>
		<td class=\"detailsCaption\"><b><i>$lang_flux_tdoc_aff_lbl_tosearch</i></b></td>
	</tr>
";
//$TDOC_SUI_LIB est declaré dans struct.php
foreach($TDOC_SUI_LIB as $lib_par)
{
	/*
	$vtp->addSession($form, "JS_SUI");
	$vtp->setVar($form, "JS_SUI.NUM", $i);
	$vtp->closeSession($form, "JS_SUI");
	*/
	if(!isset(${"SUI_LIB_".$i})) ${"SUI_LIB_".$i} = '';
	if(!isset(${"SUI_AFF_".$i})) ${"SUI_AFF_".$i} = '';
	if(!isset(${"SUI_REC_".$i})) ${"SUI_REC_".$i} = '';
	
	$NOM = str_replace("%NOMZONE%", $lib_par, $lang_flux_tdoc_aff_lbl_zone);
	$content .= "
	<tr>
		<td class=\"detailsCaption\"><b>$NOM</b></td>
		<td class=\"detailsValue\">".($readOnly ? ${"SUI_LIB_".$i}: "<script language=\"JavaScript\" type=\"text/javascript\">
			with(new prlTextBox('SUI_LIB_$i', prlTextBox.formats.any, '".hi_disp(addslashes(${"SUI_LIB_".$i}))."')) {
				maxLength  = 35;
				create();
			}
		</script>")."</td>
		<td align=\"center\" class=\"detailsValue\">".($readOnly ? (${"SUI_AFF_".$i}?$lang_flux_tdoc_aff_lbl_affich_oui: $lang_flux_tdoc_aff_lbl_non):
							"<input type=\"checkbox\" name=\"SUI_AFF_$i\" id=\"SUI_AFF_$i\" value=\"1\" ".(${"SUI_AFF_".$i}?"checked":"")."/>")."</td>
		<td align=\"center\" class=\"detailsValue\">".($readOnly ? (${"SUI_REC_".$i}? $lang_flux_tdoc_aff_lbl_affich_oui: $lang_flux_tdoc_aff_lbl_non):
							"<input type=\"checkbox\" name=\"SUI_REC_$i\" id=\"SUI_REC_$i\" value=\"1\" ".(${"SUI_REC_".$i}? "checked": "")."/>")."</td>
	</tr>
";
	$i++;
}
$content .= "</table>";
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_tdoc_aff_lbl_param);
$vtp->setVar($form, "form_field.javascript", "");
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

$i = 0;

$content = "
<table cellpadding=\"4\" width=\"100%\" class=\"details\">
	<tr>
		<td>&nbsp;</td>
		<td class=\"detailsCaption\"><b><i>$lang_flux_tdoc_aff_lbl_libel</i></b></td>
	</tr>
";

foreach($TDOC_VALID_LIB as $lib_valid)
{
	if(!isset(${"VALID_LIB_".$i})) ${"VALID_LIB_".$i} = '';
	$content .= "
	<tr>
		<td class=\"detailsCaption\"><b>$lib_valid</b></td>
		<td class=\"detailsValue\">".($readOnly ? ${"VALID_LIB_".$i}: ("<script language=\"JavaScript\" type=\"text/javascript\">
			with(new prlTextBox('VALID_LIB_$i', prlTextBox.formats.any, '".hi_disp(addslashes(${"VALID_LIB_".$i}))."')) {
				maxLength  = 35;
				create();
			}
		</script>"))."</td>
	</tr>";
	$i++;
}
$content .= "</table>";
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_tdoc_aff_lbl_param_val);
$vtp->setVar($form, "form_field.javascript", "");
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

if($tdoc_id) {
	if(!$readOnly) {
		$row_actions = "
		function prlExecGridFormat (url) {
			if(prlExec(url) == 0)
				Prologue.grid.reload('formatGrid');
		};
		rowAction.grid_id = 'formatGrid';
		rowAction.add('modif', 'flux/tdoc/flux_tdoc_actFormatAffich.php', openPopUp, ['action', 'for_id', 'tdoc_id']);
		rowAction.add('remove', 'flux/tdoc/flux_tdoc_actFormatAction.php', prlExecGridFormat, ['action', 'for_id']);

		rowAction.actions.modif.check = function (params) {
			params.action = 'modif';
			return true;
		};

		rowAction.actions.remove.check = function (params) {
			params.action = 'suppr';
			var msg_suppr = '".addslashes($lang_flux_tdoc_aff_quest_suppr_format)."';
			msg_suppr = msg_suppr.replace('%NOMFORMAT%', params.for_nom);
			return confirm(msg_suppr);
		};";
		
		$action_js = "
		add('$lang_lbl_creer', '${pathStyle}imgs/icons/add.gif', 'openPopUp(\'flux_tdoc_actFormatAffich.php?action=create&tdoc_id=$tdoc_id\');');
		add('$lang_lbl_modifier', '${pathStyle}imgs/icons/admin.gif', 'rowAction.exec(\'modif\')');
		add('$lang_lbl_supprimer', '${pathStyle}imgs/icons/trash.png', 'rowAction.exec(\'remove\')');";
	}
	else {
	$row_actions = "";
	$action_js = "";
	}
	
	$javascript = "
	$row_actions
	document.write('<center>');
	with(new Prologue.gridPageToolBar('formatGridTbr')) {
		$action_js
		gridId = 'formatGrid';
		create();
	}
	document.write('</center>');
	with(new prlGrid('formatGrid')) {
		async = true;
		pageSize = 5;
		pageToolBarId = 'formatGridTbr';
		dataSource = '${pathFlow}flux/tdoc/flux_tdoc_dSFormatDoc.php?tdoc_id='+$tdoc_id+'&readOnly=".(($readOnly)? "1":"0")."';
		create();
	}
	";
	$content = "";
}
else {
	$javascript = "";
	$content = "
	<table cellpadding=\"4\" width=\"100%\" class=\"details\">
		<tr>
			<td class=\"detailsCaption\"><b>$lang_flux_tdoc_aff_lbl_format_norme (*)</b></td>
			<td class=\"detailsValue\"><script language=\"JavaScript\" type=\"text/javascript\">
				with(new prlTextBox('FOR_NORME', prlTextBox.formats.any)) {
					trim = prlTextBox.trimMode.both;
					maxLength  = 20;
					onClick = 'if(this.value.length == 0){ alert(\'".addslashes($lang_flux_tdoc_aff_msg_err_nonorme)."\'); this.focus();}';
					create();
				}
			</script></td>
		</tr>
		<tr>
			<td class=\"detailsCaption\"><b>$lang_flux_tdoc_aff_lbl_msg (*)</b></td>
			<td class=\"detailsValue\"><script language=\"JavaScript\" type=\"text/javascript\">
				with(new prlTextBox('FOR_NOM', prlTextBox.formats.any)) {
					trim = prlTextBox.trimMode.both;
					maxLength  = 20;
					onClick = 'if(this.value.length == 0){ alert(\'".addslashes($lang_flux_tdoc_aff_msg_err_format_nonom)."\'); this.focus();}';
					create();
				}
			</script></td>
		</tr>
		<tr>
			<td class=\"detailsCaption\"><b>$lang_flux_tdoc_aff_lbl_version (*)</b></td>
			<td class=\"detailsValue\"><script language=\"JavaScript\" type=\"text/javascript\">
				with(new prlTextBox('FOR_VERSION', prlTextBox.formats.any)) {
					trim = prlTextBox.trimMode.both;
					maxLength  = 20;
					onClick = 'if(this.value.length == 0){ alert(\'".addslashes($lang_flux_tdoc_aff_msg_err_format_noversion)."\'); this.focus();}';
					create();
				}
			</script></td>
		</tr>
		<tr>
			<td class=\"detailsCaption\"><b>$lang_flux_tdoc_aff_lbl_style</b></td>
			<td class=\"detailsValue\"><script language=\"JavaScript\" type=\"text/javascript\">
				prlTextBox.formats.style = {'name':'style',
											'key':/./,
											'validate':/^XML::.+$/,
											'maxLength':60,
											'align':'left'};
				with(new prlTextBox('FOR_STYLE', prlTextBox.formats.style)) {
					toolTip = '".addslashes($lang_flux_tdoc_aff_lbl_style_toolTip)."';
					errMesg = '".addslashes($lang_flux_tdoc_aff_lbl_style_toolTip)."';
					trim = prlTextBox.trimMode.both;
					maxLength  = 255;
					create();
				}
			</script></td>
		</tr>
</table>";
}
$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_flux_tdoc_grid_head_formats);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

if($readOnly) {
	$javascript = "new prlButton('$lang_lbl_print', 'changePage(\'flux_tdoc_actPrint.php?tdoc_id=$tdoc_id\');', '".$pathStyle."imgs/icons/printer.png').create();";
	$vtp->addSession($form, "form_button");
	$vtp->setVar($form, "form_button.javascript", $javascript);
	$vtp->closeSession($form, "form_button");
}

include($DEFAULT_PATH."header.php");
$vtp->setVar($form, "global.page_headers", $page_headers);
$vtp->closeSession($form, "global");
$vtp->Display();
?>