<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once($DEFAULT_PATH."struct.php");
$droitRole = DOC;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; //lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php"); 
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "flux/tdoc/flux_tdoc_actFormatAction.php";

//R�cup�ration des param�tres du POST
$action = pget("action");
$TDOC_ID = pget("tdoc_id");
$FOR_ID = pget("for_id");
$FOR_NOM = pget("FOR_NOM");
$FOR_NORME = pget("FOR_NORME");
$FOR_VERSION = pget("FOR_VERSION");
$FOR_STYLE = pget("FOR_STYLE");

$clt_id = $_SESSION["CLT_ID"];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************/
/* DEBUT ACTION = SUPPR	*/
/************************/
if ($action == "suppr")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null) || 
		droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$req = "UPDATE `FORMAT`
					SET FOR_ETAT = ".ETAT_SUPPR." 
					WHERE FOR_ID = $FOR_ID";
		
		if (!$gDb->SQLQuery($req, 1))
		{
			$msg = $lang_flux_tdoc_actformat_suppr_msg_err;
			$return = 1;
		}
		else
		{
			$msg = $lang_flux_tdoc_actformat_suppr_msg_ok;
			$return = 0;
		}
	}		
}
/************************/
/* FIN ACTION = SUPPR	*/
/************************/

/************************************************************/
/* DEBUT ACTION = MODIF		 								*/
/************************************************************/
if ($action == "modif")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null) || 
		droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$req = "SELECT COUNT(*) AS NB
				FROM `FORMAT` 
				WHERE FOR_ID != $FOR_ID 
				AND CLT_ID = $clt_id 
				AND FOR_NOM = '".dblQ($FOR_NOM)."' 
				AND FOR_NORME = '".dblQ($FOR_NORME)."'
				AND FOR_VERSION = '".dblQ($FOR_VERSION)."'";
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		
		if ($row['NB'] > 0)
		{
			$msg = $lang_flux_tdoc_act_create_msg_err_dup_format;
			$return = 1;
			$gDb->SQLFermeQuery(1);
		}
		else
		{
			$gDb->SQLFermeQuery(1);
			$req = "UPDATE `FORMAT` SET 
					FOR_NOM = '".dblQ($FOR_NOM)."', 
					FOR_NORME = '".dblQ($FOR_NORME)."', 
					FOR_VERSION = '".dblQ($FOR_VERSION)."',
					FOR_STYLE = '".dblQ($FOR_STYLE)."' 
					WHERE FOR_ID = $FOR_ID";
			
			if (!$gDb->SQLQuery($req, 1))
			{
				$msg = $lang_flux_tdoc_actformat_modif_msg_err;
				$return = 1;
			}
			else
			{
				$msg = $lang_flux_tdoc_actformat_modif_msg_ok;
				$return = 0;
			}
		}
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = MODIF		 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = CREATE		 							*/
/************************************************************/
if ($action == "create")
{
	if (droit($droitRole, DROIT_CREAT,null,null,null,null) || 
		droit($droitRole, DROIT_MODIF,null,null,null,null))
	{
		$req = "SELECT COUNT(*) AS NB
				FROM `FORMAT` 
				WHERE CLT_ID = $clt_id 
				AND FOR_NOM = '".dblQ($FOR_NOM)."' 
				AND FOR_NORME = '".dblQ($FOR_NORME)."' 
				AND FOR_VERSION = '".dblQ($FOR_VERSION)."'";
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		if ($row['NB'] > 0)
		{
			$msg = $lang_flux_tdoc_act_create_msg_err_dup_format;
			$return = 1;
			$gDb->SQLFermeQuery(1);
		}
		else
		{
			$gDb->SQLFermeQuery(1);
			$gDb->SQLTransact();
			$req = "INSERT INTO `FORMAT` (FOR_NOM, FOR_NORME, FOR_VERSION, CLT_ID, TDOC_ID, 
					FOR_ETAT, FOR_STYLE) 
					VALUES ('".dblQ($FOR_NOM)."', 
					'".dblQ($FOR_NORME)."', 
					'".dblQ($FOR_VERSION)."',
					$clt_id,
					$TDOC_ID, 
					".ETAT_ACTIF.",
					'".dblQ($FOR_STYLE)."')";
			if (!$gDb->SQLQuery($req, 1))
			{
				$gDb->SQLRollBack();
				$msg = $lang_flux_tdoc_actformat_create_msg_err;
				$return = 1;
			}
			else
			{
				$gDb->SQLCommit();
				$msg = $lang_flux_tdoc_actformat_create_msg_ok;
				$return = 0;
			}
		}
	}
	else
	{
		$msg = $lang_flux_tdoc_act_msg_err_droit;
		$return = 1;
	}
}
/************************************************************/
/* FIN ACTION = CREATE		 								*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
echo encode_JSON($reponse);
?>