<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

$tdoc_id = pget('tdoc_id');
$readOnly = pget('readOnly');

$pageSize = pget('pageSize');
$pageNum = pget('pageNum');

$req = "SELECT SQL_CALC_FOUND_ROWS FOR_ID, FOR_NOM, FOR_NORME, FOR_VERSION, FOR_STYLE 
		FROM `FORMAT` 
			WHERE TDOC_ID = $tdoc_id 
			AND FOR_ETAT != ".ETAT_SUPPR;

$champs = array();
$champs[] = array("nom" => $lang_flux_tdoc_aff_lbl_format_norme, "toolTip" => $lang_flux_tdoc_aff_lbl_format_norme, "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_tdoc_aff_lbl_msg, "toolTip" => $lang_flux_tdoc_aff_lbl_msg, "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_tdoc_aff_lbl_version, "toolTip" => $lang_flux_tdoc_aff_lbl_version, "sortMode" => "1");
$champs[] = array("nom" => $lang_flux_tdoc_aff_lbl_style, "toolTip" => $lang_flux_tdoc_aff_lbl_style, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{
	echo '<row>';
	
	$params = array();
	$params['tdoc_id'] = $tdoc_id;
	$params['for_id'] = $row['FOR_ID'];
	$params['for_nom'] = $row['FOR_NOM'];
	
	
	if(!$readOnly) {
		$params['droits'] = array('modif' => true,
							'remove' => true);
	}
			
	echo '<item caption="'.hi_disp($row['FOR_NORME']).'" value="'.row_encode_JSON($params).'"/>';
	echo '<item caption="'.hi_disp($row['FOR_NOM']).'"/>';
	echo '<item caption="'.hi_disp($row['FOR_VERSION']).'"/>';
	echo '<item caption="'.hi_disp($row['FOR_STYLE']).'"/>';
	echo '</row>';
}
$gDb->SQLFermeQuery(1);
echo '</databind>';
?>