/////////////////////////
/// Form Object ///
/////////////////////////
Prologue.forms = {
	form : Array(),
	collection : Array(),
	formField : Array()

}


Prologue.form = function()
{
	Prologue.form.callBaseConstructor(this);
	this.action = '';
	this.method = 'GET'
	this.className = 'prlForm';
	this.fieldClassName = 'prlFormField';
	this.dataSource = '';
	this.dataId = ''; //identifiant ajoute en parametre a dataSource, il indique les datas a charger, 
			//util lors du chargement du formulaire correspondant a la selection dans une liste, grid ou treeview 
	this.sourceId = '';//identifiant ajoute en parametre a dataSource, il indique la source (list,grid ou treeview) conrrespondant a dataId 
	this.updateAction = '';//identifiant ajoute en parametre a dataSource, il permet d'associer et d'indiquer le type d'action a effectuer lors de l'update
				//ex : dupliquer un element de la grille ou de la liste
	this.submitType = Prologue.formSubmit.type.Submit;
	this.asyncSubmit = false;
	this.callBack = 'Prologue.form.asyncLoad';
	this.displayWaitMess = false;
	this.submitButtonId = '';
	
	this.idResponse = '';
	this.errMesg = lang_form_msg_field_empty;
	this.onError = ' if(invalidField.content.select)invalidField.content.select();';
	
	// ajout des donn�es membres et m�thodes de control
	this.id = Prologue.ui.getGUID();
	this.toolTip = '';
	this.onClick = '';
	this.enable = true;
	this.visible = true;
	this.formFieldCenter = false;
	this.formFieldWidth = '';
	this.onLocalAction = ''; //Action à effectuer lorsque submitType = Prologue.formSubmit.type.localAction
	this.attributes = function()
	{
		var tmp = '';		
		if (this.id) tmp+=' id="'+this.id+'"';
		if (this.className) tmp+=' class="'+this.className+'"';
		if (this.toolTip) tmp+=' title="'+this.toolTip+'"';
		if (this.onClick) tmp+=' onClick ="'+this.onClick+'"';
		return tmp;
	};
	
	
};
Prologue.form.extend(Prologue.collection);

Prologue.form.prototype.html = function ()
{
	if (this.dataSource)
	{
		if (this.load())
			this.bind();
	}
	
	var onSubmit = 'var invalidField = Prologue.form.checkInvalid(this);';
	onSubmit += ' if(invalidField != null) {';
	if(this.onError != '') onSubmit += ' '+this.onError;
	if(this.errMesg != '') onSubmit += ' alert(\''+this.errMesg+' \'+invalidField.caption+\'.\');' ;
	onSubmit += ' return false;} else { ';
	if (this.displayWaitMess) onSubmit += ' Prologue.page.console.displayWaitMess();';
	if (this.submitType == Prologue.formSubmit.type.Submit){
		onSubmit += ' this.submit();}';
	}else
	if (this.submitType == Prologue.formSubmit.type.Ajax){
		
		onSubmit += ' var req=Prologue.form.ajaxSubmit(this);';
		if (!this.asyncSubmit) onSubmit += ' Prologue.form.submitResponse(req.getXML());';
		
		onSubmit += 'return false; }';
	}
	else
	if (this.submitType == Prologue.formSubmit.type.localAction){
		onSubmit += ''+this.onLocalAction+'; return false;}';
	}
	var onReset = 'Prologue.form.resetAct(this.id);';
	
	var tmp = '<form action="'+this.action+'" method="'+this.method+'"  asyncSubmit="'+this.asyncSubmit+'" callBack="'+this.callBack+'"';
	if (this.submitType != Prologue.formSubmit.type.localAction) {
		tmp += 'onkeydown="if(getKeyInfo(event).key == 13) ';
		if (this.submitButtonId)
			tmp += ' if ( document.getElementById(\''+this.submitButtonId+'\')) document.getElementById(\''+this.submitButtonId+'\').onmousedown();document.getElementById(\''+this.submitButtonId+'\').onmouseup();"';
		else
			tmp += ' this.onsubmit();"';
	}
	var formfieldcenter = '';
	if (this.formFieldCenter) formfieldcenter = '<center>';
	tmp += ' onsubmit="'+onSubmit+'" '+this.attributes()+' name="'+this.id+'" onreset="'+onReset+'">'+formfieldcenter+'<table cellpadding="0" class='+this.fieldClassName+' width="'+this.formFieldWidth+'" >';
	
	return tmp;
};

Prologue.form.prototype.create = function()
{
	document.write(this.html());
	
	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i){
		if (!this.item(i).formFieldWidth)this.item(i).formFieldWidth = this.formFieldWidth;
		if (!this.item(i).formFieldCenter)this.item(i).formFieldCenter = this.formFieldCenter;
		tmp += this.item(i).create();
	}
	if (this.formFieldCenter) document.write('</center>');
	document.write('</table></form>');

	Prologue.forms.form[this.id] = this;
};

Prologue.form.prototype.add = function (formField)
{
	var pos = this.count();
	this.items[pos] = formField;
	return this.item[pos];
};

Prologue.form.unserialize = function (dataBind)
{
	var data = [];
	var form = dataBind.firstChild;
	if (form.nodeName=='form')	//on est bien dans la balise <form>
	{
		for (var i=0; i<form.childNodes.length; i++)	//on parcourt toutes les balises contenues dans form
		{
			var formField = form.childNodes[i];
			var nameAtt = formField.attributes.getNamedItem('name');	// on r�cup�re l'attribut "name"
			var value = (formField.firstChild)?formField.firstChild.nodeValue:'';	//on r�cup�re le contenu de la balise <formfield> xxx </formfield>
			if (nameAtt)
				data[nameAtt.value] = value;		//on ajoute au tableau le contenu (tableau associatif rep�r� par la valeur de l'attribut "name")
		}
	}
	return data;
};

Prologue.form.prototype.load = function()
{	
	var ds = this.dataSource;
	if (this.dataId){
		var other = (ds.indexOf('?')!=-1);
		ds += (other?'&':'?') + 'dataId=' + encodeURIComponent(this.dataId)+'&sourceId=' + encodeURIComponent(this.sourceId)+'&updateAction=' + encodeURIComponent(this.updateAction);
	}


	var req = new Prologue.ajax.request(ds);
	req.send();
	var result = req.getXML(ds);
	var ret = false;	
	if (result)
	{
		var databind = result.firstChild;
		if(databind!=null)
		{
			while(databind.nodeName != 'databind')
				databind = databind.nextSibling;
			
			this.datas = Prologue.form.unserialize(databind);
			ret = true;
		}
	}
	else
		this.datas=null;
	return ret;
};

Prologue.form.prototype.bind = function()
{
	for (var name in this.datas)
	{
		var data = this.datas[name];
		for (var i=0; i<this.items.length; i++)
		{
			var item = this.items[i];
			//alert('databind : '+item.dataBind+' '+name);
			if (item.dataBind==name && item.type!=Prologue.formField.types.custom)
			{
				item.value = data;
				break;
			}
			else
			if (item.type!=Prologue.formField.types.custom){
				if (item.bind) item.bind(name,data);
			
			}
			
		}
	}
};

Prologue.form.prototype.update = function()
{
	if (this.dataSource)
		{
			if (this.load())
				this.bind();
		}
	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i)
		if (this.item(i).update) this.item(i).update();
	return true;
};

Prologue.form.prototype.reset = function()
{
	/*if (this.dataSource)
		{
			if (this.load())
				this.bind();
		}
	*/
	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i)
		if (this.item(i).reset) this.item(i).reset();
	return true;
};
/*
Prologue.form.checkInvalid = function(form)
{
	var table = form.firstChild;
	for(var i = 0; i < table.rows.length; ++i)
	{
		var tr = table.rows[i];
		if(tr.attributes.getNamedItem('prlRequired').value == '1' && !(eval(tr.attributes.getNamedItem('prlOnValidate').value)))
		{		
			var tableItem = tr.cells[tr.cells.length - 2].firstChild;
			var item = Prologue.item.getItem(tableItem);
			var formFieldContent = tr.cells[tr.cells.length - 1].firstChild;
			return {'caption':item.caption, 'content':formFieldContent};
		}
	}
	var node = form.firstChild;
	var tableNode = false;
	while(node){
		if (node.nodeName.toLowerCase() == 'table'){
			table = node;
			tableNode = true;
		
		}
		if (node.nodeName.toLowerCase() == 'fieldset'){
		
			table = node.firstChild.nextSibling;
			tableNode = true;
			
		}
		for(var i = 0; i < table.rows.length; ++i)
			{
				var tr = table.rows[i];
				if (tr.attributes.getNamedItem('prlRequired'))
				if(tr.attributes.getNamedItem('prlRequired').value == '1' && !(eval(tr.attributes.getNamedItem('prlOnValidate').value)))
				{		
					var tableItem = tr.cells[tr.cells.length - 2].firstChild;
					var item = Prologue.item.getItem(tableItem);
					var formFieldContent = tr.cells[tr.cells.length - 1].firstChild;
					return {'caption':item.caption, 'content':formFieldContent};
				}
			}
		
		tableNode = false;
		node = node.nextSibling;
	
	}
	
	
	return null;
};
*/
Prologue.form.checkInvalid = function(form){
	if (form.attributes.getNamedItem)
		var id = form.attributes.getNamedItem('id').value;
	else
	if (form.id)
		var id = form.id;
	
	var collection = (Prologue.forms.form[id])?Prologue.forms.form[id]:Prologue.forms.collection[id];
	
	var res = null;
	var result = null;
	
	if (collection)
	for (var i=0; i<collection.items.length; i++)
	{
		var item = collection.items[i];
		if (item.onValidate)
		{	
			if (!(eval(item.onValidate)))
			{
				formFieldContent = $(item.id);
				
				return {'caption':item.caption, 'content':formFieldContent};
			
			}
		}
		res = Prologue.form.checkInvalid(item);
		if ((res != null) && (result == null)) result = res;
	}
	return result;
}





//////////////////////////////////
/// Form Field Object ///
/////////////////////////////////
Prologue.formField = function(id, caption, icon, content)
{
	Prologue.formField.callBaseConstructor(this, caption, icon, content);
	this.className = 'prlFormField';
	if(id)
		this.id = id;
	this.readOnly = false;
	this.required = false;
	this.title.alignment = Prologue.item.alignment.left;
	this.type = Prologue.formField.types.custom;
	this.onValidate = 'true';
	this.dataBind = (this.id||'');
	this.caption = (caption||'');
	this.colSpan = false;
	this.center = false;
};
Prologue.formField.extend(Prologue.container);

Prologue.formField.types =
{
	'custom':0,
	'text':1,
	'list':2,
	'date':3,
	'tree':4,
	'path':5,
	'checkbox':6
};

Prologue.formField.prototype.html = function ()
{	
	if(!this.required)
		this.onValidate = true;
	
	var id = this.id;		//on met temporairement this.id � blanc pour ne pas qu'il soit utilis� par attributes() : On veut avoir un id personnalis� id+'_formField'
	this.id = '';			//de mani�re � garder cet id pr l'�l�ment qui sera contenu (combo, textbox,...)
	var onclick = this.onClick; 	//on met temporairement this.onclick � blanc pour ne pas qu'il soit utilis� par attributes()
	this.onClick = '';             //de mani�re � garder cet onclick pr l'�l�ment qui sera contenu (combo, textbox,...)
	
	var tmp = '<tr id="'+id+'_formField" prlType="'+this.type+'" prlRequired="'+((this.required)?'1':'0')+'"'+this.attributes()+' prlOnValidate="'+this.onValidate+'">';
	
	this.id = id;
	this.onClick = onclick;
	if (!this.colSpan){
		tmp += '<td class="'+this.className+'Required">'+((this.required)?'*':'&nbsp')+'</td>'
		
		tmp += '<td';
		tmp += ' class="'+this.className+'Title">';
		tmp += this.title.html()+'</td>';
	}

	tmp += '<td id="'+id+'_formFieldContent" class="'+this.className+'Content"';
	if (this.colSpan) tmp += ' colspan=3 ';
	tmp += '>';
	if (this.center) tmp += '<center>';
	tmp += this.content;
	if (this.center) tmp += '</center>';
	tmp += '<input type=hidden id="'+this.id+'_formFieldInit" value="'+this.value+'" /></td></tr>';
	
	return tmp;
};

Prologue.formField.getContent = function(object)
{
	var cnt = null;
	if (typeof object == 'string') object = document.getElementById(object);
	if (object)
		cnt = object.cells[object.cells.length - 1];
	return cnt;
};

Prologue.formField.prototype.create = function()
{
	Prologue.formField.callBaseMethod(this, 'create');
	var meID = this.id+'_formField';
	var me = document.getElementById(meID);
	if (me && this.contentID)
	{
		var obj = document.getElementById(this.contentID);
		if (obj)
		{
			var cnt = Prologue.formField.getContent(me);
			if (cnt)
			{
				cnt.innerHTML = obj.innerHTML;
				obj.removeNode(true);
			}
		}
	}
	Prologue.forms.formField[this.id] = this;
};

Prologue.formField.prototype.update = function ()
{
	return true;
};

Prologue.formField.prototype.reset = function ()
{
	this.value = $(this.id+'_formFieldInit').value;
	return true;
};

////////////////////////////////////////
/// Form Field Date Object ///
////////////////////////////////////////
Prologue.formFieldDate = function(id, caption, icon, value)
{
	Prologue.formFieldDate.callBaseConstructor(this, id, caption, icon);
	this.onValidate = "document.getElementsByName('"+this.id+"').value!='';";
	this.comboDate = new Prologue.comboDate(this.id, value);
	this.type = Prologue.formField.types.date;
	this.editable = true;
	this.value = value||'';
	this.onClick = '';
};
Prologue.formFieldDate.extend(Prologue.formField);

Prologue.formFieldDate.prototype.html = function ()
{
	if(this.value.length)
		this.comboDate.value = this.value;
		
	this.comboDate.onClick = this.onClick;
	this.content = this.comboDate.html();
	return Prologue.formFieldDate.callBaseMethod(this, 'html');
};
Prologue.formFieldDate.prototype.update = function ()
{
	return Prologue.comboDate.setSelected(Prologue.formFieldDate.getComboTable(this.id), this.value);
};

Prologue.formFieldDate.prototype.reset = function ()
{
	this.value = $(this.id+'_formFieldInit').value;
	return Prologue.comboDate.setSelected(Prologue.formFieldDate.getComboTable(this.id), $(this.id+'_formFieldInit').value);
};

Prologue.formFieldDate.getSelected = function (fFDate)
{
	return Prologue.comboDate.getSelected(Prologue.formFieldDate.getComboTable(fFDate));
};

Prologue.formFieldDate.setSelected = function (fFDate, date)
{
	return Prologue.comboDate.setSelected(Prologue.formFieldDate.getComboTable(fFDate), date);
};

Prologue.formFieldDate.getComboTable = function (tr)
{
	if (typeof tr == 'string')
		tr = document.getElementById(tr+'_formField');
	
	return tr.cells[tr.cells.length - 1].firstChild;
};////////////////////////////////////////
/// Form Field List Object ///
////////////////////////////////////////
Prologue.formFieldList = function(id, caption, icon, value)
{
	Prologue.formFieldList.callBaseConstructor(this, id, caption, icon);
	this.onValidate = "(Prologue.comboList.getSelected('"+this.id+"').index!=-1)";
	this.comboList = new Prologue.comboList(this.id, value);
	this.type = Prologue.formField.types.list;
	this.readOnly = false;
	this.editable = false;
	this.dataSource = '';
	this.value = value||'';
	this.onClick = '';
	this.width = '150px';
	this.dropDownWidth = 200;
};
Prologue.formFieldList.extend(Prologue.formField);

Prologue.formFieldList.prototype.html = function ()
{
	with(this.comboList)
	{
		value = this.value;
		dataSource = this.dataSource;
		readOnly = this.readOnly;
		editable = this.editable;
		onClick = this.onClick;
		width = this.width;
		dropDown.width = this.dropDownWidth;
	}
	this.content = this.comboList.html();
	
	return Prologue.formFieldList.callBaseMethod(this, 'html');
};

Prologue.formFieldList.prototype.add = function(caption, icon, onClick, value)
{
	return this.comboList.add(caption, icon, onClick, value);
};

Prologue.formFieldList.prototype.count = function()
{
	return this.comboList.count();
};
Prologue.formFieldList.prototype.update = function ()
{
	return Prologue.comboList.selectRowByValue(Prologue.formFieldList.getComboTable(this.id), this.value);
};

Prologue.formFieldList.prototype.reset = function ()
{
	this.value = $(this.id+'_formFieldInit').value;
	return Prologue.comboList.selectRowByValue(Prologue.formFieldList.getComboTable(this.id), $(this.id+'_formFieldInit').value);
};

Prologue.formFieldList.getSelected = function(fFList)
{
	return Prologue.comboList.getSelected(Prologue.formFieldList.getComboTable(fFList));
};

Prologue.formFieldList.selectRowByIndex = function(fFList, index)
{
	return Prologue.comboList.selectRowByIndex(Prologue.formFieldList.getComboTable(fFList), index);
};

Prologue.formFieldList.selectRowByValue= function(fFList, value)
{
	return Prologue.comboList.selectRowByValue(Prologue.formFieldList.getComboTable(fFList), value);
};

Prologue.formFieldList.reload = function(fFList, dataSource)
{
	return Prologue.comboList.reload(Prologue.formFieldList.getComboTable(fFList), dataSource);
};

Prologue.formFieldList.getComboTable = function (tr)
{
	if (typeof tr == 'string')
		tr = document.getElementById(tr+'_formField');
	
	return tr.cells[tr.cells.length - 1].firstChild;
};////////////////////////////////////////
/// Form Field Path Object ///
////////////////////////////////////////
Prologue.formFieldPath = function(id, caption, icon, value)
{
	Prologue.formFieldPath.callBaseConstructor(this, id, caption, icon);
	this.onValidate = "(Prologue.comboPath.getSelected('"+this.id+"').index!=-1)";
	this.comboPath = new Prologue.comboPath(this.id, value);
	this.type = Prologue.formField.types.path;
	this.readOnly = false;
	this.editable = false;
	this.dataSource = '';
	this.value = (typeof value != 'undefined')?value:'';
	this.onClick = '';
};
Prologue.formFieldPath.extend(Prologue.formField);

Prologue.formFieldPath.prototype.html = function ()
{
	with(this.comboPath)
	{
		value = this.value;
		dataSource = this.dataSource;
		readOnly = this.readOnly;
		editable = this.editable;
		onClick = this.onClick;
	}
	
	this.content = this.comboPath.html();
	return Prologue.formFieldPath.callBaseMethod(this, 'html');
};
Prologue.formFieldPath.prototype.update = function ()
{
	return Prologue.comboPath.selectNodeByValue(Prologue.formFieldPath.getComboTable(this.id), this.value);
};

Prologue.formFieldPath.prototype.reset = function ()
{
	this.value = $(this.id+'_formFieldInit').value;
	return Prologue.comboPath.selectNodeByValue(Prologue.formFieldPath.getComboTable(this.id), $(this.id+'_formFieldInit').value);
};

Prologue.formFieldPath.getSelected = function(fFPath)
{	
	return Prologue.comboPath.getSelected(Prologue.formFieldPath.getComboTable(fFPath));
};

Prologue.formFieldPath.selectNodeByIndex = function(fFPath, index)
{
	return Prologue.comboPath.selectNodeByIndex(Prologue.formFieldPath.getComboTable(fFPath), index);	
};

Prologue.formFieldPath.selectNodeByValue = function(fFPath, value)
{
	return Prologue.comboPath.selectNodeByValue(Prologue.formFieldPath.getComboTable(fFPath), value);
};

Prologue.formFieldPath.reload = function(fFPath, dataSource)
{
	return Prologue.comboPath.reload(Prologue.formFieldPath.getComboTable(fFPath), dataSource);
};

Prologue.formFieldPath.getComboTable = function (tr)
{
	if (typeof tr == 'string')
		tr = document.getElementById(tr+'_formField');
	return tr.cells[tr.cells.length - 1].firstChild;
};////////////////////////////////////////
/// Form Field Text Object ///
////////////////////////////////////////
Prologue.formFieldText = function(id, caption, icon, format, value)
{
	Prologue.formFieldText.callBaseConstructor(this, id, caption, icon);
	this.onValidate = "(Prologue.textBox.checkFormat(document.getElementById('"+this.id+"')) && document.getElementById('"+this.id+"').value!='');";
	this.textBox = new Prologue.textBox(this.id, format, value);
	this.type = Prologue.formField.types.text;
	this.maxLength = '';
	this.errMesg = lang_msg_wrong_format;
	this.onError = '';
	this.readOnly = false;
	this.password = false;
	this.width = '';
	this.caseMode = Prologue.textBox.caseMode.none;
	this.trim = Prologue.textBox.trimMode.none;
	this.format = format;
	this.value = (value||'');
	this.onClick = '';
};
Prologue.formFieldText.extend(Prologue.formField);

Prologue.formFieldText.prototype.html = function ()
{
	with (this.textBox)
	{
		maxLength = this.maxLength;
		errMesg = this.errMesg;
		onError = this.onError;
		readOnly = this.readOnly;
		password = this.password;
		width = this.width;
		caseMode = this.caseMode;
		trim = this.trim;
		if (this.format) format = this.format;
		value = this.value;
		onClick = this.onClick;
	}	
	
	this.content = this.textBox.html();
	return Prologue.formFieldText.callBaseMethod(this, 'html');
};

Prologue.formFieldText.prototype.update = function ()
{
	return $(this.id).value=this.value;
};
Prologue.formFieldText.prototype.reset = function ()
{
	this.value = $(this.id+'_formFieldInit').value;
	return $(this.id).value=this.value;
};

////////////////////////////////////////
/// Form Field Tree Object ///
////////////////////////////////////////
Prologue.formFieldTree = function(id, caption, icon, value)
{
	Prologue.formFieldTree.callBaseConstructor(this, id, caption, icon);
	this.onValidate = "(Prologue.comboTree.getSelected('"+this.id+"').index!=-1)";
	this.comboTree = new Prologue.comboTree(this.id, value);
	this.type = Prologue.formField.types.tree;
	this.readOnly = false;
	this.editable = false;
	this.dataSource = '';
	this.value = (typeof value != 'undefined')?value:'';
	this.onClick = '';
};
Prologue.formFieldTree.extend(Prologue.formField);

Prologue.formFieldTree.prototype.html = function ()
{
	with(this.comboTree)
	{
		value = this.value;
		dataSource = this.dataSource;
		readOnly = this.readOnly;
		editable = this.editable;
		onClick = this.onClick;
	}
	
	this.content = this.comboTree.html();
	return Prologue.formFieldTree.callBaseMethod(this, 'html');
};

Prologue.formFieldTree.prototype.add = function(caption, icon, onClick, value)
{
	return this.comboTree.add(caption, icon, onClick, value);
};
Prologue.formFieldTree.prototype.update = function ()
{
	return Prologue.comboTree.selectNodeByValue(Prologue.formFieldTree.getComboTable(this.id), this.value);
};

Prologue.formFieldTree.prototype.reset = function ()
{
	this.value = $(this.id+'_formFieldInit').value;
	return Prologue.comboTree.selectNodeByValue(Prologue.formFieldTree.getComboTable(this.id), $(this.id+'_formFieldInit').value);
};

Prologue.formFieldTree.getSelected = function(fFTree)
{	
	return Prologue.comboTree.getSelected(Prologue.formFieldTree.getComboTable(fFTree));
};

Prologue.formFieldTree.selectNodeByIndex = function(fFTree, index)
{
	return Prologue.comboTree.selectNodeByIndex(Prologue.formFieldTree.getComboTable(fFTree), index);	
};

Prologue.formFieldTree.selectNodeByValue = function(fFTree, value)
{
	return Prologue.comboTree.selectNodeByValue(Prologue.formFieldTree.getComboTable(fFTree), value);
};

Prologue.formFieldTree.reload = function(fFTree, dataSource)
{
	return Prologue.comboTree.reload(Prologue.formFieldTree.getComboTable(fFTree), dataSource);
};

Prologue.formFieldTree.getComboTable = function (tr)
{
	if (typeof tr == 'string')
		tr = document.getElementById(tr+'_formField');
	return tr.cells[tr.cells.length - 1].firstChild;
};/////////////////////////////////////
/// prlFormSubmit Object ///
/////////////////////////////////////

Prologue.formSubmit = function(id,submitAction,confirmMess)
{
	
	Prologue.formSubmit.callBaseConstructor(this);
	if (id) this.id = id;
	this.submitAction = (submitAction||'');
	this.confirmMess = (confirmMess||'');
	//if (this.confirmMess) 
	this.onClick = 'if ((this.attributes.getNamedItem(\'prlconfirmMess\').value) && !confirm(\''+this.confirmMess+'\')) return false;';
	this.onClick += 'var form = this.parentNode;';
	this.onClick += ' while(form.nodeName != \'FORM\')';
	this.onClick += ' form = form.parentNode;';
	this.onClick += ' var subActId = form.attributes.getNamedItem(\'id\').value+\'_prlSubmitAct\';';
	this.onClick += ' var action = this.attributes.getNamedItem(\'prlsubmitaction\').value;';
	this.onClick += ' var other = (form.action.indexOf(\'?\')!=-1)';
	this.onClick += ' form.action += (other?\'&\':\'?\') + subActId + \'=\' + action;';
	this.onClick += ' if(form.onsubmit()) form.submit();';
	//this.title.icon = 'framework/images/submit.gif'
	this.title.icon = Prologue.framework.images+'/submit.gif';
	this.title.caption = lang_formReset_lbl_envoyer;
	
	this.attributes = function() {
		return Prologue.window.callBaseMethod(this, 'attributes')
			+ ' prlSubmitAction="' + this.submitAction + '"'
			+ ' prlconfirmMess="' + this.confirmMess + '"';
	};
	
	
};
Prologue.formSubmit.extend(Prologue.button);

Prologue.formSubmit.type = {
	Submit : 0
	,Ajax : 1
	,localAction : 2
}

Prologue.formSubmit.setSubmitAction = function (id,submitAction,confirmMess)
{
	var submitAction = (submitAction || '');
	var confirmMess = (confirmMess || '');
	if (id && $(id))
	{
		$(id).attributes.getNamedItem('prlsubmitaction').value = submitAction;
		$(id).attributes.getNamedItem('prlconfirmMess').value = confirmMess;
	}

}

Prologue.form.ajaxSubmit = function (form){
	var atb = form.attributes.getNamedItem('action');
	if (atb) {
		var action = atb.value;
		atb = form.attributes.getNamedItem('method');
		var method = 'POST';
		if (atb) method = atb.value.toUpperCase();
		
		atb = form.attributes.getNamedItem('asyncSubmit').value;
		var callBack=null;
		if (atb) var callBack = form.attributes.getNamedItem('callBack').value;
		
		var data = Prologue.ajax.form2Req(form);
		var req = new Prologue.ajax.request();
		req.url = action;
		req.method = method;
		req.callBack=eval(callBack);
		req.send(data);
		return req;
	}
	return null;
}
Prologue.form.asyncLoad = function(req) {
	Prologue.form.submitResponse (req.getXML());
}

Prologue.form.submitResponse = function (resp)
{
	if (!resp) return;
	var databind = resp.firstChild;
		while(databind.nodeName != 'databind')
			databind = databind.nextSibling;
//var resp = req.getXML();
		resp = databind;
		
		if (resp)
		{
			//initialisation de la console d'information
			Prologue.page.messages.length = 0;
			var xRoot = resp;
			for (var pResp=0; pResp<xRoot.childNodes.length; pResp++)
			{
				var xResp = xRoot.childNodes[pResp];
				if (xResp.nodeName=='resp')
				{
					var atb = xResp.attributes.getNamedItem('type');
					if (atb) {
						var actType = atb.value;
						for (var xItem,pItem=0; xItem=xResp.childNodes[pItem++];) {
							if (xItem.nodeName=='item'){
								var atbs = {
									id:''
									,type:''
									,datasource:''
									,frame:''
									,value:''
									,message:''
									,execute:''
								}
								bindXmlToObj(atbs, xItem);
								Prologue.page.pageUpdate(actType,atbs);
							}
						
						}
						
					}
				}
			}
			//affichage de la console d'information
			Prologue.page.console.displayMessage();
		}

}

////////////////////////////////////
/// prlFormReset Object ///
////////////////////////////////////
Prologue.formReset = function()
{
	Prologue.formReset.callBaseConstructor(this);
	this.onClick = 'var form = this.parentNode;';
	this.onClick += ' while(form.nodeName != \'FORM\')';
	this.onClick += ' form = form.parentNode;';
	this.onClick += ' form.reset();';
	//this.title.icon = 'framework/images/reset.gif'
	this.title.icon = Prologue.framework.images+'/reset.gif';
	this.title.caption = lang_formReset_lbl_effacer;
};
Prologue.formReset.extend(Prologue.button);

Prologue.form.resetAct = function(id)
{
	if (Prologue.forms.formField[id]) var elem = Prologue.forms.formField[id];
	else
	if (Prologue.forms.form[id]) var elem = Prologue.forms.form[id];
	
	if (elem && elem.reset) {
		elem.reset();
	}


};
////////////////////////////////////////
/// Form Field Text Object ///
////////////////////////////////////////
Prologue.formFieldCheckBox = function(id, caption, icon, value)
{
	Prologue.formFieldCheckBox.callBaseConstructor(this, id, caption, icon);
	this.type = Prologue.formField.types.chekBox;
	this.onValidate = "";
	this.readOnly = false;
	this.value = value; //true|false
	this.onClick = '';
};
Prologue.formFieldCheckBox.extend(Prologue.formField);

Prologue.formFieldCheckBox.prototype.html = function ()
{
	var tmp = '<input type="checkbox" id="'+this.id+'" name="'+this.id+'" ';
	(this.value == 'checked')?tmp +=' checked':tmp +='';
	//(this.readOnly)?tmp +=' readonly="readonly"':tmp +='';
	(this.readOnly)?tmp +=' disabled="disabled"':tmp +='';
	tmp += ' onclick="'+this.onClick+'" />';
	
	this.content = tmp;
	return Prologue.formFieldCheckBox.callBaseMethod(this, 'html');
};

Prologue.formFieldCheckBox.prototype.update = function ()
{

	var value = (this.value=='checked')?true:false;
	return $(this.id).checked=value;
};


/////////////////////////
/// formFieldCollection Object ///
/////////////////////////

Prologue.formFieldCollection = function(id,legend,icon)
{
	Prologue.form.callBaseConstructor(this);
	this.className = 'prlFieldCollection';
	this.fieldClassName = 'prlFormField';
	this.center = false;
	
	// ajout des donn�es membres et m�thodes de control
	this.id = (id||Prologue.ui.getGUID());
	this.legend = (legend||this.id);
	this.icon = (icon||'')
	this.formFieldWidth = '';
	this.formFieldCenter = false;
	
	this.attributes = function()
	{
		var tmp = '';		
		if (this.id) tmp+=' id="'+this.id+'"';
		if (this.className) tmp+=' class="'+this.className+'"';
		return tmp;
	};
	
	
};
Prologue.formFieldCollection.extend(Prologue.collection);

Prologue.formFieldCollection.prototype.add = function (formField)
{
	var pos = this.count();
	this.items[pos] = formField;
	return this.item[pos];
};
Prologue.formFieldCollection.prototype.html = function ()
{
	if (this.formFieldCenter) this.center = this.formFieldCenter;
	var tmp = '<div '+this.attributes()+'><br>';
	if (this.center) tmp += '<center>';
	tmp += '<table  class='+this.fieldClassName+' cellpadding="0" ';
	if (this.formFieldWidth) tmp += ' style="width:'+this.formFieldWidth+';" ';
	tmp += '>';

	return tmp;
};

Prologue.formFieldCollection.prototype.bind = function(name,data)
{

	for (var i=0; i<this.items.length; i++)
	{
		var item = this.items[i];
		//alert('databind : '+item.dataBind+' '+name);
		if (item.dataBind==name && item.type!=Prologue.formField.types.custom)
		{
			item.value = data;
			break;
		}
		else
			if (item.type!=Prologue.formField.types.custom){
				if (item.bind) item.bind(name,data);
			
			}
		
	}

};
Prologue.formFieldCollection.prototype.update = function()
{

	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i)
		if (this.item(i).update) this.item(i).update();
	return true;
};

Prologue.formFieldCollection.prototype.reset = function()
{

	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i)
		if (this.item(i).reset) this.item(i).reset();
	return true;
};

Prologue.formFieldCollection.prototype.create = function()
{
	document.write(this.html());
	
	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i){
		if (!this.item(i).formFieldWidth)this.item(i).formFieldWidth = this.formFieldWidth;
		if (!this.item(i).formFieldCenter)this.item(i).formFieldCenter = this.formFieldCenter;
		tmp += this.item(i).create();
	}
	document.write('</table>');
	if (this.center) document.write('</center>');
	document.write('</div>');
	Prologue.forms.collection[this.id] = this;
};







/////////////////////////
/// formFieldSet Object ///
/////////////////////////

Prologue.formFieldSet = function(id,legend)
{
	Prologue.form.callBaseConstructor(this,id,legend,'');
	this.className = 'prlFieldSet';
	this.center = false;
	this.width = '';
	
	//this.legend = '';
	
	// ajout des donn�es membres et m�thodes de control
	//this.id = Prologue.ui.getGUID();
	
	this.attributes = function()
	{
		var tmp = '';		
		if (this.id) tmp+=' id="'+this.id+'"';
		if (this.className) tmp+=' class="'+this.className+'"';
		return tmp;
	};
	
	
};
Prologue.formFieldSet.extend(Prologue.formFieldCollection);

Prologue.formFieldSet.prototype.html = function ()
{
	if (this.formFieldCenter) this.center = this.formFieldCenter;
	if (this.formFieldWidth) this.width = this.formFieldWidth;
	var tmp = '</table>';
	if (this.center){
		tmp += '<center><table cellpadding="0"';
	if (this.width) 
		tmp += '  style="width:'+this.width+';"';
	else
		tmp += '  style="width:100%;"';
	tmp += ' ><tr><td>';
	}
	var formfieldcenter = '';
	if (this.formFieldCenter) formfieldcenter = '<center>';
	tmp += '<br><fieldset '+this.attributes()+' name="'+this.id+'"';
	if (this.width) tmp += ' style="width:'+this.width+';" ';
	tmp += '><legend>'+this.legend+'</legend>'+formfieldcenter+'<table  class='+this.fieldClassName+' cellpadding="0"';
	if (this.formFieldWidth) tmp += ' style="width:'+this.formFieldWidth+';" ';
	tmp += '>';

	return tmp;
};

Prologue.formFieldSet.prototype.create = function()
{
	document.write(this.html());
	
	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i){
		tmp += this.item(i).create();
	}
	var formfieldcenter = '';
	if (this.formFieldCenter) formfieldcenter = '</center>';
	document.write('</table>'+formfieldcenter+'</fieldset>');
	if (this.center)document.write('</td></tr></table></center>');
	document.write('<table  class='+this.fieldClassName+' cellpadding="0">');
	Prologue.forms.collection[this.id] = this;

};




/////////////////////////
/// formControlSet Object ///
/////////////////////////

Prologue.formControlSet = function()
{
	Prologue.form.callBaseConstructor(this);
	this.className = 'prlFormControlSet';
	this.center = true;
	
	// ajout des donn�es membres et m�thodes de control
	this.id = Prologue.ui.getGUID();
	
	this.attributes = function()
	{
		var tmp = '';		
		if (this.id) tmp+=' id="'+this.id+'"';
		if (this.className) tmp+=' class="'+this.className+'"';
		return tmp;
	};
	
	
};
Prologue.formControlSet.extend(Prologue.collection);

Prologue.formControlSet.prototype.add = function (formField)
{
	var pos = this.count();
	this.items[pos] = formField;
	return this.item[pos];
};

Prologue.formControlSet.prototype.html = function ()
{
	
	var tmp = '</table>';
	if (this.center)
	tmp += '<center><br>';
	tmp += '<table cellspacing="1" cellpadding="1" ><tr '+this.attributes()+' name="'+this.id+'"><td align="'+this.align+'" nowrap>';
	
	return tmp;
};

Prologue.formControlSet.prototype.create = function()
{
	document.write(this.html());
	
	var nbElem = this.count();
	var tmp = '';
	
	for(var i = 0; i < nbElem; ++i)
	{
		tmp += this.item(i).create();
		document.write('</td><td align="'+this.align+'" nowrap>');
	}
	document.write('</td></tr></table>');
	if (this.center)document.write('</center>');
	document.write('<table  class='+this.fieldClassName+' cellpadding="0">');

};




/////////////////////////
/// formGrid Object ///
/////////////////////////

Prologue.formGrid = function()
{
	Prologue.form.callBaseConstructor(this);
	this.className = 'prlFormGrid';
	this.center = false;
	this.width = '500px';
	this.height = '150px';
	
	// ajout des donn�es membres et m�thodes de control
	this.id = Prologue.ui.getGUID();
	
	this.attributes = function()
	{
		var tmp = '';		
		if (this.id) tmp+=' id="'+this.id+'"';
		if (this.className) tmp+=' class="'+this.className+'"';
		return tmp;
	};
	
	
};
Prologue.formGrid.extend(Prologue.collection);

Prologue.formGrid.prototype.add = function (formField)
{
	var pos = this.count();
	this.items[pos] = formField;
	return this.item[pos];
};

Prologue.formGrid.prototype.html = function ()
{
	
	var tmp = '</table>';
	if (this.center)
	tmp += '<center>';
	tmp += '<br><div style="overflow:auto;';
	if (this.width)tmp +='width:'+this.width+';';
	if (this.height)tmp +='height:'+this.height+';';
	tmp +='border:1px inset #00009C;background-color:#ffffff;margin:1;" '+this.attributes()+' >';
	//tmp += '<table cellspacing="1" cellpadding="1" ><tr '+this.attributes()+' name="'+this.id+'"><td align="'+this.align+'" nowrap><div style="overflow:auto;width:500px;">';
	
	return tmp;
};

Prologue.formGrid.prototype.create = function()
{
	document.write(this.html());
	
	var nbElem = this.count();
	var tmp = '';
	
	for(var i = 0; i < nbElem; ++i)
	{
		tmp += this.item(i).create();
		//document.write('</td><td align="'+this.align+'" nowrap>');
	}
	document.write('</div>');
	if (this.center)document.write('</center>');
	document.write('<table  class='+this.fieldClassName+' cellpadding="0">');
	

};

Prologue.formGrid.prototype.reset = function()
{

	var nbElem = this.count();
	var tmp = '';
	for(var i = 0; i < nbElem; ++i)
		if (this.item(i).reset) this.item(i).reset();
	return true;
};


/////////////////////////
/// formFieldTabStrip Object ///
/////////////////////////

Prologue.formFieldTabStrip = function(id)
{
	Prologue.form.callBaseConstructor(this,id,'','');
	this.className = 'prlFormTabStrip';
	this.center = true;
	this.width = '400px';
	this.height = '200px';
	
	// ajout des donn�es membres et m�thodes de control
	this.id = (id||Prologue.ui.getGUID());
	
	this.attributes = function()
	{
		var tmp = '';		
		if (this.id) tmp+=' id="'+this.id+'"';
		if (this.className) tmp+=' class="'+this.className+'"';
		return tmp;
	};
	
	
};
Prologue.formFieldTabStrip.extend(Prologue.formFieldCollection);


Prologue.formFieldTabStrip.prototype.html = function ()
{
	
	var tmp = '</table>';
	if (this.center)
	tmp += '<center><br>';
	
	
	return tmp;
};

Prologue.formFieldTabStrip.prototype.create = function()
{
	if (this.formFieldWidth) this.width = parseInt(this.formFieldWidth)+30+'px';
	if (this.formFieldCenter) this.center = this.formFieldCenter;
	document.write(this.html());
	
	var nbElem = this.count();
	var tmp = '';
	
	for(var i = 0; i < nbElem; ++i)
	{
		if (!this.item(i).formFieldWidth)this.item(i).formFieldWidth = this.formFieldWidth;
		if (!this.item(i).formFieldCenter)this.item(i).formFieldCenter = this.formFieldCenter;
		tmp += this.item(i).create();
		//document.write('</td><td align="'+this.align+'" nowrap>');
	}
	var tab = new Prologue.tabStrip(this.id);
	tab.clientWidth = this.width;
	tab.clientHeight = this.height;
	for(var i = 0; i < nbElem; ++i)
	{
		var page = tab.add(this.item(i).legend,this.item(i).icon);
		page.contentID = this.item(i).id;
	}
	tab.create();
	
	
	//document.write('</div>');
	if (this.center)document.write('</center>');
	document.write('<table  class='+this.fieldClassName+' cellpadding="0">');
	Prologue.forms.collection[this.id] = this;
};


Prologue.windowForm = function(caption, icon, content)
{
	Prologue.windowForm.callBaseConstructor(this, caption, icon, content);
	this.formID = '';
	this.id = '';
	
	this.moveContent = true;


}
Prologue.windowForm.extend(Prologue.window);
//inherit static functions
Prologue.windowForm.setVisible = Prologue.window.setVisible;
Prologue.windowForm.centerScreen = Prologue.window.centerScreen;
Prologue.windowForm.moveTo = Prologue.window.moveTo;
Prologue.windowForm.isVisible = Prologue.window.isVisible;
Prologue.windowForm.open = Prologue.window.open;
Prologue.windowForm.close = Prologue.window.close;

/*Prologue.windowForm.prototype.html = function ()
{
	
	if (this.formID)this.contentID = this.formID;
	else
	if (this.contentID)this.formID = this.contentID;
	
	this.id = this.formID+'_Window';
	
	return Prologue.windowForm.callBaseMethod(this, 'html');
};
*/
Prologue.windowForm.prototype.html = function()
{
	if (this.formID)this.contentID = this.formID;
	else
	if (this.contentID)this.formID = this.contentID;
	
	this.id = this.formID+'_Window';
	
	
	
	var skinPath = (this.skin || Prologue.framework.images) + '/';
	
	var tmp = '<table'+this.attributes()
		+ ' prlMoveContent="'
		+ ((this.moveContent)?'1':'0')
		+ '" '
		+ ' style="z-index:9999;'
		+ ((!this.visible)?'display:none;':'')
		+ '">'
		+ '<tr><td' + ((this.moveable)?' onmousedown="Prologue.windowForm.dragStart(event, this);"':'') + '>';
		
	tmp += '<table cellspacing="0" cellpadding="0"><tr>';
	tmp += '<td><img src="'+skinPath+Prologue.window.images.titleLeft.name+'"/></td>';
	tmp += '<td class="prlTitle" style="background-image:url('+skinPath+Prologue.window.images.titleBkg.name+');background-repeat:repeat-x;">'+this.title.html()+'</td>';
	if (this.closeButton) {
		tmp += '<td onclick="Prologue.window.close(\''+this.id+'\');"';
		tmp += ' style="cursor:pointer;background-image:url('+skinPath+Prologue.window.images.titleBkg.name+');background-repeat:repeat-x;"><img src="'+Prologue.window.images.closeButton+'"/></td>';
	}
	tmp += '<td><img src="'+skinPath+Prologue.window.images.titleRight.name+'"/></td>';
	tmp += '</tr></table>';
	tmp += '</td></tr>';
	
	tmp += '<tr><td class="prlWindowContent"><div class="prlWindowContentDiv" style="';
	if (this.clientHeight || this.clientWidth) {
		tmp += 'overflow:auto;';
		if (this.clientHeight) tmp += 'height:'+this.clientHeight+';';
		if (this.clientWidth) tmp += 'width:'+this.clientWidth+';"';
	}	
	tmp += '">'+this.content+'</div></td></tr>';
	
	
	tmp += '</table>';
	
	return tmp;
};
Prologue.windowForm.drag = function() {
	if (Prologue.windowForm.activeWindow) {
		var table = Prologue.windowForm.activeWindow;
		table.style.left = event.clientX - table.xOffset;
		table.style.top = event.clientY - table.yOffset;
	}
};
Prologue.windowForm.dragStart = function(evt, td) {
	
	var table = td.parentNode.parentNode.parentNode;
	//traitement affichage du contenu lors du deplacement 
	var moveContent = $(table.id).attributes.getNamedItem('prlMoveContent').value;
	if (moveContent == 0){
		var idDiv = Prologue.container.getContent($(table.id));//table.id+'_prlWindowContentDiv';
		
		var formNode = idDiv.firstChild;
		if (!idDiv.style.width)idDiv.style.width = idDiv.offsetWidth;
		if (!idDiv.style.height)idDiv.style.height = idDiv.offsetHeight;
		formNode.style.display = 'none';
		formNode.style.visibility = "hidden";
		table.style.opacity = 0.8;
	}
	
	table.style.position = 'absolute';
	table.xOffset = evt.clientX+document.body.scrollLeft-table.offsetLeft;
	table.yOffset = evt.clientY+document.body.scrollTop-table.offsetTop;
	table.style.cursor = 'move';
	Prologue.windowForm.activeWindow = table;
	document.attachEvent('onmouseup', Prologue.windowForm.dragEnd);
	document.attachEvent('onmousemove', Prologue.windowForm.drag);
	//masquage des iframe  pour eviter la perte des events souris durant le drag
	var ifs = document.getElementsByTagName('IFRAME');
	Prologue.windowForm.hiddenIframes = new Array();
	for (var pIf=0, ifm; ifm=ifs[pIf++];) {
		if (ifm.style.visibility!='hidden') {
			Prologue.windowForm.hiddenIframes.push(ifm);
			ifm.style.visibility='hidden';
		}
	}
};

Prologue.windowForm.dragEnd = function() {
	if (Prologue.windowForm.activeWindow) {
		Prologue.windowForm.activeWindow.style.cursor = 'default';
		//traitement affichage du contenu lors du deplacement 
		var moveContent = $(Prologue.windowForm.activeWindow.id).attributes.getNamedItem('prlMoveContent').value;
		if (moveContent == 0){
			var idDiv = Prologue.container.getContent($(Prologue.windowForm.activeWindow.id));
			
			var formNode = idDiv.firstChild;
			formNode.style.display = '';
			formNode.style.visibility = "visible";
			$(Prologue.windowForm.activeWindow.id).style.opacity = 1;
		}
		
		document.attachEvent('onmouseup', Prologue.windowForm.dragEnd);
		document.detachEvent('onmousemove', Prologue.windowForm.drag);
		Prologue.windowForm.activeWindow = null;
		//affichage de tous les iframes pour eviter la perte des events souris durant le drag
		for (var pIf=0, ifm; ifm=Prologue.windowForm.hiddenIframes[pIf++];)	ifm.style.visibility='visible';
		Prologue.windowForm.hiddenIframes = null;
	}
};



//update d'un formulaire "formId", en tranmettant value comme parametre d'update 
//utilise pour l'update a partir de la selection d'un item dans une liste, grille ou treeview 
Prologue.windowForm.update = function (formId, sourceId, value, action)
{
	action = (action||'');
	sourceId = (sourceId||'');
	if (value){
		if(Prologue.forms.form[formId])
		{
			Prologue.forms.form[formId].dataId = value;
			Prologue.forms.form[formId].sourceId = sourceId;
			Prologue.forms.form[formId].updateAction = action;
			Prologue.forms.form[formId].update();
			Prologue.windowForm.setVisible(formId+'_Window',true);
		}
		//Prologue.window.open(formId+'_Window',false);
	}
}

//*****************************************************

Prologue.windowFormGrid = {};

Prologue.windowFormGrid.update = function (gridId, formId, action)
{
	action = (action||'');
	var sel = Prologue.grid.getSelected(gridId);
	
	var value='';
	if (typeof sel.length =='undefined')
		var value = sel.value;
	else 
		if (sel.length>0) value = sel[0].value;//on prend le premier item selectionne
	
	if (value !=''){
		Prologue.windowForm.update(formId,gridId,value,action);
	}
}

Prologue.windowFormList = {};

Prologue.windowFormList.update = function (listId, formId, action)
{
	action = (action||'');
	var sel = Prologue.list.getSelected(listId);
	
	if (sel.value){
		Prologue.windowForm.update(formId,listId,sel.value,action);
	}
}




Prologue.windowFormTreeView = {};
Prologue.windowFormTreeView.update = function (treeId, formId, action)
{
	action = (action||'');
	var sel = Prologue.treeView.getSelected(treeId);

	if (sel.value){
		Prologue.windowForm.update(formId,treeId,sel.value,action);
	}
}

Array.prototype.inArray = function(val) {
	for(var i = 0; i < this.length; i++) {
		if(this[i] == val){
			return true;
		}
	}
	return false;
}


//**************************
//Prologue.multiSelect
//**************************
Prologue.multiSelect = function(id, value, onClick, className)
{
	Prologue.multiSelect.callBaseConstructor(this, value, onClick);
	this.id = (id||Prologue.ui.getGUID());
	this.className = (className||'prlCombo');
	this.dropDown.width = 220;
	this.list = new Prologue.list('list'+id);
	this.multiple = true;
	this.width = '150px';
	this.size = 10;
	this.title = 'List';
};
Prologue.multiSelect.extend(Prologue.combo);

Prologue.multiSelect.prototype.html = function ()
{
	if (this.list.dataSource) this.list.load();
	
	tmp = '<table><tr><td>';
	tmp += '<select id='+this.id+' name='+this.id+' size='+this.size+' style="width:'+this.width+'" ';
	if (this.multiple) tmp += ' multiple="multiple" ';
	tmp += ' class="'+this.className+'" >';
	
	
	for (var pRow=0; pRow<this.list.items.count(); pRow++)
	{	if (this.list.items.item(pRow).value != ''){
			if ((this.value.length>0) && (this.list.items.item(pRow).value == this.value))
			{
				this.list.items.item(pRow).selected='selected';
				
			}
			else
			this.list.items.item(pRow).selected='';
			
			tmp += '<option value="'+this.list.items.item(pRow).value+'" '+this.list.items.item(pRow).selected+' >'+this.list.items.item(pRow).caption+'</option>';
		}
	}
	tmp +='</section>';
	tmp +='</td></tr></table>';
	
	var selAll=  '<a style="bold;font-weight:bold;color:#00009C;cursor:pointer;font-size:12px;"  onclick="Prologue.selectFromList.select_all(\''+this.id+'\')">'+lang_selectFromList_selectAll+'</a>';
	var container = new Prologue.container(this.title+'<br/>'+selAll);
	
	container.content = tmp;
	
	tmp = container.html();
	
	
	return tmp;

}

//**************************
//Prologue.selectFromList
//**************************

Prologue.selectFromList = function(id, value, onClick, className)
{
	Prologue.selectFromList.callBaseConstructor(this, value, onClick);
	this.id = (id||Prologue.ui.getGUID());
	this.separator='|';
	this.className = (className||'prlContainer');
	this.firstSelect = new Prologue.multiSelect();
	//this.firstSelect.id='l1';
	this.firstSelect.title=lang_selectFromList_firstTitle;
	this.secondSelect = new Prologue.multiSelect();
	//this.secondSelect.id='l2';
	this.secondSelect.title=lang_selectFromList_secondTitle;
	this.selectButton = new Prologue.button('','',Prologue.selectFromList.images.selectValue,Prologue.framework.images+'/button_Transp');
	this.unselectButton = new Prologue.button('','',Prologue.selectFromList.images.unselectValue,Prologue.framework.images+'/button_Transp');
	this.value = (value||'');
	this.dataSource = '';
	this.multiple = true;
	this.size = 10;
	this.width = '150px';

}
Prologue.selectFromList.extend(Prologue.combo);

Prologue.selectFromList.prototype.html = function ()
{
	if (this.dataSource) this.secondSelect.list.dataSource = this.dataSource;
	if (this.secondSelect.list.dataSource){ 
		this.secondSelect.list.load();
		this.secondSelect.list.dataSource = '';
	}
	//traitement du contenu des listes (depend de value et this.secondSelect.list.items) 
	if (this.value){
		var reg=new RegExp("["+this.separator+"]+", "g");
		var members=this.value.split(reg);
		pFLRow=0; //compteur de fisrtSelect.list
		for (var pRow=0; pRow<this.secondSelect.list.items.count(); pRow++){
			
			if (members.inArray(this.secondSelect.list.items.item(pRow).value)) {
				
				this.firstSelect.list.items.add(this.secondSelect.list.items.item(pRow).caption, '', '', this.secondSelect.list.items.item(pRow).value);
				//this.firstSelect.list.items.item(pFLRow).value = this.secondSelect.list.items.item(pRow).value;
				//this.firstSelect.list.items.item(pFLRow).caption = this.secondSelect.list.items.item(pRow).caption;
				this.secondSelect.list.items.item(pRow).value='';
				//pFLRow++;
				
			}
		
		
		}
	
	
	}
	
	with(this.firstSelect)
	{
		size=this.size;
		multiple=this.multiple;
		width=this.width;
	}
	with(this.secondSelect)
	{
		size=this.size;
		multiple=this.multiple;
		width=this.width;
	}
	
	
	
	this.selectButton.onClick='Prologue.selectFromList.addMembers(\''+this.separator+'\',\''+this.id+'\',\''+this.firstSelect.id+'\',\''+this.secondSelect.id+'\');';
	this.unselectButton.onClick='Prologue.selectFromList.deleteMembers(\''+this.separator+'\',\''+this.id+'\',\''+this.firstSelect.id+'\',\''+this.secondSelect.id+'\');';
	
	
	tmp = '<input type="hidden" name="'+this.id+'" id="'+this.id+'" value="'+this.value+'" prlSelectSeparator="'+this.separator+'" prlFirstSelect="'+this.firstSelect.id+'" prlSecondSelect="'+this.secondSelect.id+'" prlDefaultValue="'+this.value+'" />';
	
	tmp +='<table class="'+this.className+'" style="background-color:#FFFFFF" ><tr><td>';

	
	tmp +=this.secondSelect.html();
	tmp +='</td><td>';
	tmp +=this.selectButton.html()+this.unselectButton.html();
	tmp +='</td><td>';
	
	tmp +=this.firstSelect.html();
	
	tmp +='</td></tr></table>';
	
	return tmp;
}
Prologue.selectFromList.prototype.create = function()
{
	Prologue.selectFromList.callBaseMethod(this, 'create');
	//this.update();
	Prologue.selectFromList.update(this.id);
	
}
Prologue.selectFromList.images =
{
	selectValue : {
		name : 'select.gif',
		toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	},
	unselectValue : {
		name : 'unselect.gif',
		toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
};
/*
Prologue.selectFromList.prototype.update1 = function (){
	if (typeof this.value == 'undefined') return;
	var reg=new RegExp("["+this.separator+"]+", "g");
	var members=this.value.split(reg);
	var selectListID_All=this.secondSelect.id;
	all_members=document.getElementById(selectListID_All);
	taille=all_members.length;
	
	for(i=0;i<taille;i++) {
		if (members.inArray(all_members.options[i].value)){
			all_members.options[i].selected=true;
		}
		else
		{
			all_members.options[i].selected=false;
		}
	}
	
	Prologue.selectFromList.addMembers(this.separator,this.id,this.firstSelect.id,this.secondSelect.id);
}
*/
Prologue.selectFromList.update = function (id){

	
	if (typeof id == 'undefined') return;
	
	var selectList = document.getElementById(id);
	var selectListID_All = selectList.attributes.getNamedItem('prlSecondSelect').value;
	var selectListID_Member = selectList.attributes.getNamedItem('prlFirstSelect').value;
	var separator = selectList.attributes.getNamedItem('prlSelectSeparator').value;
	var value = selectList.value;
	if (typeof value == 'undefined') return;
	
	Prologue.selectFromList.select_all(selectListID_Member);
	Prologue.selectFromList.deleteMembers(separator,id,selectListID_Member,selectListID_All);
	
	//var reg=new RegExp("["+this.separator+"]+", "g");
	var reg=new RegExp("["+separator+"]+", "g");
	var members=value.split(reg);
	//var selectListID_All=this.secondSelect.id;
	all_members=document.getElementById(selectListID_All);
	taille=all_members.length;
	
	for(i=0;i<taille;i++) {
		if (members.inArray(all_members.options[i].value)){
			all_members.options[i].selected=true;
		}
		else
		{
			all_members.options[i].selected=false;
		}
	}
	
	//Prologue.selectFromList.addMembers(this.separator,this.id,this.firstSelect.id,this.secondSelect.id);
	Prologue.selectFromList.addMembers(separator,id,selectListID_Member,selectListID_All);
}

Prologue.selectFromList.addMembers = function (separateur,imputResult,selectListID_Member,selectListID_All) 
{
	all_members=document.getElementById(selectListID_All);
    member=document.getElementById(selectListID_Member);
    cpt_all_members=all_members.length;
    cpt_member=member.length;
    
    taille=all_members.length;
    id=0;
    tb=new Array();
    k=0;
	ok=0;
        // r�up�e les id s�ectionn�
    for(i=0;i<taille;i++) {
		if(i>=cpt_all_members && !ok) return;
		if(i>=cpt_all_members) break; 
		if(all_members.options[i].selected && all_members.options[i].text!="") {ok=1;tb[k++]=i;}
	}


	if(ok==1) {
    for(i=0;i<tb.length;i++) {
        txt=all_members.options[tb[i]].text;
        val=all_members.options[tb[i]].value;

        // on ins�e les valeurs ds la liste des membres
        member.options[cpt_member]=new Option();
        member.options[cpt_member].value=val;
        member.options[cpt_member].text=txt;
        member.options[cpt_member].disabled=0;
        cpt_member++;

        // on enl�e les objets de la liste allusers
        all_members.options[tb[i]].text="";
        all_members.options[tb[i]].value="";
        //all_members.options[tb[i]].disabled=1;
        cpt_all_members--;
    }

    // on tri le tableau all_user
    for(i=0;i<taille-1;i++)
        if(all_members.options[i].text=="") {
            for(j=i+1;j<taille;j++)
                if(all_members.options[j].text) {
                    all_members.options[i].text=all_members.options[j].text;
                        all_members.options[i].value=all_members.options[j].value;
                    //all_members.options[i].disabled=0;
                    all_members.options[j].text="";
                    //all_members.options[j].disabled=1;
                    j=taille;
                }
        }
	}

    // on nettoie la liste
    for(i=0;i<taille;i++) {
        if(all_members.options[i].text=="" && all_members.options[i].value=="") all_members.options[i].disabled=1;
        all_members.options[i].selected=0;
    }
//	alert('all : '+cpt_all_members+' - select : '+cpt_member);
all_members.length=cpt_all_members;
member.length=cpt_member;
Prologue.selectFromList.sortSelect(member, true);
	Prologue.selectFromList.put_member(separateur,imputResult,selectListID_Member);
 }

Prologue.selectFromList.deleteMembers = function (separateur,imputResult,selectListID_Member,selectListID_All){
    all_members=document.getElementById(selectListID_All);
    member=document.getElementById(selectListID_Member);
    cpt_all_members=all_members.length;
    cpt_member=member.length;

        taille=member.length;
        id=0;
        tb2=new Array();
    k=0;
	ok2=0;
        // r�up�e les id s�ectionn�
    for(i=0;i<taille;i++) {
		if(i>=cpt_member && !ok2) return;
		if(i>=cpt_member) break; 
        if(member.options[i].selected && member.options[i].text!="") {ok2=1;tb2[k++]=i;}
	}


	if(ok2==1) {
    for(i=0;i<tb2.length;i++) {
        txt=member.options[tb2[i]].text;
        val=member.options[tb2[i]].value;

        // on ins�e les valeurs ds la liste des membres
        all_members.options[cpt_all_members]=new Option();
        all_members.options[cpt_all_members].value=val;
        all_members.options[cpt_all_members].text=txt;
        all_members.options[cpt_all_members].disabled=0;
        cpt_all_members++;

        // on enl�e les objets de la liste allusers
        member.options[tb2[i]].text="";
        member.options[tb2[i]].value="";
        //all_members.options[tb2[i]].disabled=1;
        cpt_member--;
    }

    // on tri le tableau all_user
    for(i=0;i<taille-1;i++)
        if(member.options[i].text=="") {
            for(j=i+1;j<taille;j++)
                if(member.options[j].text) {
                    member.options[i].text=member.options[j].text;
                    member.options[i].value=member.options[j].value;
                    //all_members.options[i].disabled=0;
                    member.options[j].text="";
                    //all_members.options[j].disabled=1;
                    j=taille;
                }
        }
	}

    // on nettoie la liste
    for(i=0;i<taille;i++) {
        if(member.options[i].text=="" && member.options[i].value=="") member.options[i].disabled=1;
        member.options[i].selected=0;
    }
//	alert('all : '+cpt_all_members+' - select : '+cpt_member);
Prologue.selectFromList.sortSelect(all_members, true);
member.length=cpt_member;
all_members.length=cpt_all_members;

	Prologue.selectFromList.put_member(separateur,imputResult,selectListID_Member);
}

Prologue.selectFromList.put_member = function (separateur,imputResult,selectListID) {

    str=new String("");
    d=document.getElementById(selectListID);
    for(i=0;i<d.length;i++)
        if(d.options[i].text) str+=d.options[i].value+separateur;
    str=str.substr(0,str.length-1);
    document.getElementById(imputResult).value=str;
}


Prologue.selectFromList.select_all = function (id) {
	var liste=document.getElementById(id);
	taille=liste.length;
	for(i=0;i<taille;i++) if(liste.options[i].text!="") liste.options[i].selected=true;
}



Prologue.selectFromList.sortSelect = function (selectToSort, ascendingOrder) {
	if (arguments.length == 1) ascendingOrder = true;    // default to ascending sort

	// copy options into an array
	var myOptions = [];
	for (var loop=0; loop<selectToSort.options.length; loop++) {
	myOptions[loop] = { optText:selectToSort.options[loop].text, optValue:selectToSort.options[loop].value };
	}

	// sort array
	if (ascendingOrder) {
	myOptions.sort(Prologue.selectFromList.sortFuncAsc);
	} else {
	myOptions.sort(Prologue.selectFromList.sortFuncDesc);
	}

	// copy sorted options from array back to select box
	selectToSort.options.length = 0;
	for (var loop=0; loop<myOptions.length; loop++) {
	var optObj = document.createElement('option');
	optObj.text = myOptions[loop].optText;
	optObj.value = myOptions[loop].optValue;
	selectToSort.options.add(optObj);
	}
}

// sort function - ascending (case-insensitive)
Prologue.selectFromList.sortFuncAsc = function (record1, record2) {
	var value1 = record1.optText.toLowerCase();
	var value2 = record2.optText.toLowerCase();
	if (value1 > value2) return(1);
	if (value1 < value2) return(-1);
	return(0);
}

// sort function - descending (case-insensitive)
Prologue.selectFromList.sortFuncDesc = function (record1, record2) {
	var value1 = record1.optText.toLowerCase();
	var value2 = record2.optText.toLowerCase();
	if (value1 > value2) return(-1);
	if (value1 < value2) return(1);
	return(0);
}



////////////////////////////////////////
/// Form Field selectList Object ///
////////////////////////////////////////
Prologue.formFieldSelectList = function(id, caption, icon, value)
{
	Prologue.formFieldList.callBaseConstructor(this, id, caption, icon);

	this.onValidate = "(document.getElementById('"+this.id+"').value!='');";
	
	this.selectFromList = new Prologue.selectFromList(this.id, value);
	this.type = Prologue.formField.types.text;
	this.value = (value||'');
	this.dataSource = '';
	this.size = 5;
	this.width = '150px';
	this.id = (id||Prologue.ui.getGUID());
	this.separator='|';
	this.icon = (icon||'');
	
	this.fieldClassName = 'prlFormField';
	
	this.inPanel = false;
	
};
Prologue.formFieldSelectList.extend(Prologue.formField);

Prologue.formFieldSelectList.prototype.html = function ()
{
	with(this.selectFromList)
	{
		value = this.value;
		dataSource = this.dataSource;
		separator = this.separator;
		size = this.size;
		width = this.width;
	}
	this.content = this.selectFromList.html();
	
	if (this.inPanel){
		var tmp='</table><br/><center>';
		var panel = new Prologue.panel (this.caption,this.icon);
		panel.content = '<center>'+this.content+'</center>';
		panel.open = false;
		panel.width = (parseInt(this.selectFromList.width) * 2 ) + 100;
		panel.width = panel.width+'px';
		
		tmp +='<table style="width:'+panel.width+'"><tr><td>'+panel.html()+'</td></tr></table>';
		tmp +='</center><table  class='+this.fieldClassName+' cellpadding="0"  >';
		
		return tmp;
	}
	return Prologue.formFieldSelectList.callBaseMethod(this, 'html');
	
	
};

Prologue.formFieldSelectList.prototype.update = function ()
{
	$(this.id).value=this.value;
	
	return Prologue.selectFromList.update(this.id);
};

Prologue.formFieldSelectList.prototype.reset = function ()
{
	//$(this.id).value=this.value;
	$(this.id).value = $(this.id).attributes.getNamedItem('prlDefaultValue').value;
	
	return Prologue.selectFromList.update(this.id);
};



/////////////////////////////
/// TextBox Object ///
/////////////////////////////
Prologue.textareaBox = function(id, value, onClick)
{
	Prologue.textareaBox.callBaseConstructor(this, id, 'textareaBox', '', onClick);	
	this.value = (typeof value != 'undefined')?value:'';
	
	//this.maxLength = '';
	//this.errMesg = lang_msg_wrong_format;
	this.onError = '';
	this.readOnly = false;
	this.rows = '';
	this.cols = '';
	//this.size = '';
	//this.width = '';
	//this.caseMode = Prologue.textBox.caseMode.none;
	//this.trim = Prologue.textBox.trimMode.none;
	this.onKeyDown = 'Prologue.textareaBox.stopPropagation(event);';
	this.onKeyUp = '';
	this.onBlur = '';
	this.onMouseUp = '';
};
Prologue.textareaBox.extend(Prologue.control);


Prologue.textareaBox.prototype.html = function ()
{
	/*var onChange = 'if(this.value == \'\') { '+this.onClick+' } else { if(Prologue.textBox.checkFormat(this)) { '+this.onClick+' } else {';
	if(this.errMesg != '') onChange += ' alert(\''+this.errMesg+'\');';
	if(this.onError != '') onChange += ' '+this.onError;
	onChange += ' }};';
	*/
	//this.onClick = '';
	//this.maxLength = ((this.format.maxLength == 0)?this.maxLength:this.format.maxLength);
	
	var tmp = '<textarea  '+this.attributes()+' onfocus="this.select();"';
	if(this.id != '')
		tmp += ' name="'+this.id+'"';
	tmp += ' value="'+this.value+'"';
	tmp += ' onclick="'+this.onClick+'" onkeydown="'+this.onKeyDown+'" onkeyup="'+this.onKeyUp+'" onblur="'+this.onBlur+'" onmouseup="'+this.onMouseUp+'"';
	if(this.readOnly)
		tmp += ' readOnly style="cursor:pointer;" onmousedown="return false;" onselectstart="return false;"';
	
	
	if (this.rows != '') tmp += ' rows="'+this.rows+'"';
	if (this.cols != '') tmp += ' cols="'+this.cols+'"';
	
	
	tmp += ' >'+this.value+'</textarea>';
	
	return tmp;
};


Prologue.textareaBox.stopPropagation = function (evenement)
{
	if(getKeyInfo(evenement).key == 13){
	
		evenement.cancelBubble = true;
		if (evenement.stopPropagation) evenement.stopPropagation();
	}

}






////////////////////////////////////////
/// Form Field Textarea Object ///
////////////////////////////////////////
Prologue.formFieldTextarea = function(id, caption, icon, value)
{
	Prologue.formFieldTextarea.callBaseConstructor(this, id, caption, icon);
	this.onValidate = "(document.getElementById('"+this.id+"').value!='');";
	this.textareaBox = new Prologue.textareaBox(this.id, value);
	this.type = Prologue.formField.types.text;
	
	this.errMesg = lang_msg_wrong_format;
	this.onError = '';
	this.readOnly = false;
	
	//this.width = '';
	
	this.value = (value||'');
	this.onClick = '';
	this.rows = '';
	this.cols = '';
};
Prologue.formFieldTextarea.extend(Prologue.formField);

Prologue.formFieldTextarea.prototype.html = function ()
{
	with (this.textareaBox)
	{
		
		errMesg = this.errMesg;
		onError = this.onError;
		readOnly = this.readOnly;
		
		//width = this.width;
		
		value = this.value;
		onClick = this.onClick;
		rows = this.rows;
		cols = this.cols;
	}	
	
	this.content = this.textareaBox.html();
	return Prologue.formFieldTextarea.callBaseMethod(this, 'html');
};

Prologue.formFieldTextarea.prototype.update = function ()
{
	return $(this.id).value=this.value;
};


//permet de recuperer la liste des treeView d'un mainMenu,
//sert à pouvoit reloader une ou plusieurs treeview
Prologue.mainMenu.getTreeChildren = function(mainMenu)
{
	var treeChildren = Array();
	if (typeof mainMenu == 'string')
		mainMenu = document.getElementById(mainMenu);
	if (mainMenu && mainMenu.nodeName=='TABLE')
	{
		for (var r = 0; r < mainMenu.rows.length; r++)
		{
			var pnl = mainMenu.rows[r].cells[1].firstChild;
			treeChildren[treeChildren.length] = Prologue.panel.getContent(pnl).firstChild.attributes.getNamedItem('id').value;
			
		}
	}

	return treeChildren;
};

Prologue.mainMenu.reloadTree = function (mainMenu, rank, dataSource)
{
	var treeChildren = Prologue.mainMenu.getTreeChildren(mainMenu);
	if (dataSource && typeof rank == 'number' && treeChildren[rank])
		Prologue.treeView.reload(treeChildren[rank],dataSource);

}
//namespace page regroupe la gestion d'une page
Prologue.page = {

	messages : Array (),
	type : {
		info : 'information',
		warning : 'warning',
		error : 'error'
	},
	images : {
		info : {
			name : 'info.gif',
			toString : function() {
				return Prologue.framework.images + '/' + this.name;
			}
		},
		warning : {
			name : 'warning.gif',
			toString : function() {
				return Prologue.framework.images + '/' + this.name;
			}
		},
		error : {
			name : 'error.png',
			toString : function() {
				return Prologue.framework.images + '/' + this.name;
			}
		}
		
	}
	
	

}


// composant console : permet l'affichage d'information issue d'un submit par exemple
Prologue.page.console = function ()
{
this.content = '';
this.caption = 'Console';
this.icon = Prologue.page.images.info;
Prologue.windowForm.callBaseConstructor(this, this.caption, this.icon, this.content);
this.visible = false;
this.id = 'prlPageWinConsole';
this.clientHeight = '200px';
this.clientWidth = '350px';
this.modal = true;
this.startUpPosition = Prologue.window.startUpPosition.centerScreen;

}
Prologue.page.console.extend(Prologue.window);

Prologue.page.console.setVisible = Prologue.window.setVisible;
Prologue.page.console.centerScreen = Prologue.window.centerScreen;
Prologue.page.console.moveTo = Prologue.window.moveTo;
Prologue.page.console.isVisible = Prologue.window.isVisible;
Prologue.page.console.close = Prologue.window.close;
Prologue.page.console.open = Prologue.window.open;


// pageUpdate permet la mise a jour des composants de la page affiche a travers different type d'actions
Prologue.page.pageUpdate = function (actType,atbs)
{
	switch (actType)
		{
			case 'display':
				if (atbs.value == '')Prologue.page.display(atbs.id);
				else {
					value = (atbs.value == 'true')?'':'none';
					Prologue.page.display(atbs.id,value);
				}
				break;
			case 'reload':
				frame = (atbs.frame)?eval(atbs.frame):'';
				if ((typeof frame != 'undefined')&& (typeof frame != 'string'))
					frame.Prologue.page.reload(atbs.id,atbs.datasource,atbs.type);
				else
				if ((typeof frame == 'string') && (frame == ''))
					Prologue.page.reload(atbs.id,atbs.datasource,atbs.type,frame);
				break;
			case 'update':
				frame = (atbs.frame)?eval(atbs.frame):'';
				if ((typeof frame != 'undefined')&& (typeof frame != 'string'))
					if (frame.Prologue)
					frame.Prologue.page.update(atbs.id,atbs.datasource,atbs.value);
				else
				if ((typeof frame == 'string') && (frame == ''))
					Prologue.page.update(atbs.id,atbs.datasource,atbs.value);
				break;
			case 'message':
				//$(atbs.id).value = atbs.message;
				Prologue.page.console.addMessage(atbs);
				break;
			case 'custom':
				frame = (atbs.frame)?eval(atbs.frame):'';
				if ((typeof frame != 'undefined')&& (typeof frame != 'string'))
					frame.eval(atbs.execute);
				else
				if ((typeof frame == 'string') && (frame == ''))
					eval(atbs.execute);
				break;
			default:
				break;
			
		
		}


};

//reload : permet de relancer le chargement de donnees de differents type de composant
Prologue.page.reload = function (id, dataSource, type)
{
	
		switch (type)
		{
			case 'list':
				Prologue.list.reload(id,dataSource);
				break;
			case 'comboList':
				Prologue.comboList.reload(id,dataSource);
				break;
			case 'treeView':
				Prologue.treeView.reload(id,dataSource);
				break;
			case 'grid':
				Prologue.grid.reload(id,dataSource);
				break;
			case 'comboTree':
				Prologue.comboTree.reload(id,dataSource);
				break;
			case 'comboPath':
				Prologue.comboPath.reload(id,dataSource);
				break;
			case 'toolbar':
				Prologue.toolbar.reload(id,dataSource);
				break;
			
			default:
				return;
				break;
		}
		
		
	
}

//update : permet la mise a jour d'un formulaire (composant form) ou d'un champs d'un formulaire
Prologue.page.update = function (id,dataSource,value)
{
	dataSource = (dataSource||'');
	
	
	if (Prologue.forms.formField[id]) var elem = Prologue.forms.formField[id];
	else
	if (Prologue.forms.form[id]) var elem = Prologue.forms.form[id];
	
	if (elem && elem.update) {
		if (typeof value != 'undefined') elem.value = value;
		if (dataSource) elem.dataSource = dataSource;
		elem.update();
	}
	
}

//display : permet de modifier le mode d'affichage d'un element de la page identifie par id
Prologue.page.display = function (id,value)
{

	if (Prologue.forms.formField[id]) var id = id+'_formField';
	if (typeof value != 'undefined')  $(id).style.display = value;
	else
	$(id).style.display = ($(id).style.display == '')?'none':'';
	
}


//methode faisant partie de la gestion de la console d'erreur, permet d'ajouter un nouveau message
Prologue.page.console.addMessage = function (atbs)
{
	if (atbs) 
	Prologue.page.messages [Prologue.page.messages.length] = atbs;

}

//methode faisant partie de la gestion de la console d'information, permet de generer le contenu de la console d'information et de l'afficher
Prologue.page.console.displayMessage = function ()
{
	if (Prologue.page.messages.length>0){
		var mess = Prologue.page.messages;
		var img = Prologue.page.images.info;
		var tmp = '<table class="prlItem" cellspacing="1" cellpadding="1" style="width:100%">';
		for (var i=0; i<mess.length; i++){
			img = Prologue.page.images.info;
			mess[i].type = (mess[i].type||Prologue.page.type.info);
			if (mess[i].type == Prologue.page.type.warning) img = Prologue.page.images.warning;
			if (mess[i].type == Prologue.page.type.error) img = Prologue.page.images.error;
			tmp +='<tr><td style="border:1px inset #00009b;width:5%"><img src="'+img+'" ></td><td style="border:1px inset #00009b;">&nbsp;&nbsp;'+mess[i].message+'</td><tr>';
			
		}
		tmp +='</table>';
		
		if ($('prlPageWinConsole')){
			Prologue.container.setContent ('prlPageWinConsole',tmp);
			
			//Prologue.page.console.setVisible('prlPageWinConsole',true);
			Prologue.page.console.close('prlPageWinConsole');
			Prologue.page.console.open('prlPageWinConsole',true);
			Prologue.page.console.centerScreen ('prlPageWinConsole');
		}
	}
	else
	Prologue.page.console.close('prlPageWinConsole');
	//Prologue.page.console.setVisible('prlPageWinConsole',false);
	
}

Prologue.page.console.displayWaitMess = function ()
{
	
	Prologue.container.setContent ('prlPageWinConsole',lang_msg_loading);
	Prologue.page.console.close('prlPageWinConsole');
	Prologue.page.console.open('prlPageWinConsole',true);
	//Prologue.page.console.setVisible('prlPageWinConsole',true);
	Prologue.page.console.centerScreen ('prlPageWinConsole');
}
 
