<?php
//****************************************************************************************
//***** Lecture d'un chapitre � partir d'une documentation GemeDoc
//***** 
//***** Parametres:
//***** 	id = le ou les id(s) des chapitres dans gemedoc, les ids doivent etres separes par un ";"
//***** 	src = URL relative vers le fichier d'aide au format xml
//***** 		ex : /monappli/help/plgDocument.xml
//***** 			=> http://monhost/monappli/help/plgDocument.xml
//*****     lng = langue par defaut (optionel)
//*****
//***** retour : object au format Json
//***** 	retour = code retour
//***** 		0 = Lecture Ok
//***** 		1 = Pas de num�ro de chapitre
//***** 		2 = Fichier non trouv� ou pas de nom de fichier
//***** 		3 = Fichier illisible
//***** 		4 = Au moins 1 chapitre ne peut pas etre trouve
//*****		docs = tableau d'objets
//***** 		titre = titre du chapitre
//***** 		texte = corps du chapitre 
//****************************************************************************************

// Include wrappers domxml si PHP5
if (version_compare(PHP_VERSION,'5','>='))
{
	require_once("domxml-php4-to-php5.php");
}

Header('Content-type: text/plain; charset=utf-8');

$erreur=0;
$title='';
$content='';
$filePath='';
$docs = '';

$id = '';
if (isset($_GET['id']))	$id = $_GET['id'];

$def = '';
if (isset($_GET['lng'])) $def = $_GET['lng'];

$recurse = 0;
if (isset($_GET['recurse'])) $recurse = $_GET['recurse'];

if ($id=='')
	$erreur = 1;
else {	
	$ids = explode(";", $id);
	$fileName = 'plgDocument.xml';
	if (isset($_GET['src'])) $fileName = $_GET['src'];
	$fileName = str_replace("\\", "/", $fileName);
	if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on")
	{
	    $defaultPort = "443";
	    $root = "https://";
	}
	else
	{
	    $defaultPort = "80";
	    $root = "http://";
	}
	// Modif LTK le 04/04/11 : Bugzilla #3889
	// Utilisation de '127.0.0.1' a la place de localhost
	// (Non resolu dans certaines configurations, cf bugzilla)
	// $root .= "localhost";
	$root .= "127.0.0.1";
	if ($_SERVER["SERVER_PORT"] != $defaultPort) $root .= ':'.$_SERVER["SERVER_PORT"];
    $fileName = $root.$fileName;
	$filePath = substr($fileName, 0, strrpos($fileName, "/"));
	
	// Modif LTK le 23/12/10 : Bugzilla #3247
	// Lire le fichier en une fois avec file_get_contents
		$xml = file_get_contents($fileName);
 		if(!$doc = @domxml_open_mem($xml)) //ouverture du fichier xml de doc
 			$erreur = 3;
		else {			
			for ($pid=0; $pid<count($ids); $pid++) {
				$id = $ids[$pid];
				$xReq = "//CHAP[@ID=\"$id\"]"; //requete xpath pour chapitre
				$context = $doc->xpath_new_context(); //creation du contexte
	
				$nodes = $context->xpath_eval($xReq); //lecture du chapitre
				if (count($nodes->nodeset)==0)
					$erreur = 4;
				else {
					$chap = $nodes->nodeset[0];
					$docs.=((strlen($docs))?',':'').getChapter($chap, $context, $xReq);
					if ($recurse) {
						$subs = $context->xpath_eval($xReq.'//CHAP'); //lecture des sous chapitres
						for ($pSub=0; $pSub<count($subs->nodeset); $pSub++) {
							$sub = $subs->nodeset[$pSub];
							$subId = $sub->get_attribute('ID');
							$docs.=','.getChapter($sub, $context, "//CHAP[@ID=\"$subId\"]");
						}
					}
/*					
					if ($chap->has_attribute('LIB'))
						$title = $chap->get_attribute('LIB');
				
					//r�cuperation des langues  de l'utilisateur
					$culture_user = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
					//d�coupage des diff�rentes langues
					preg_match_all("/([a-z]+)(?:\-([a-z]+))?(?:;[^,]+)?(?:,|$)/i", $culture_user, $culture_user_ar, PREG_SET_ORDER);	
					//Analyse des langues de l'utilisateur
					$found=false;
					for ($i=0;$i<count($culture_user_ar) && !$found;$i++) {
						$lang = strtolower($culture_user_ar[$i][1]);
						$found = getText($context, "$xReq/TEXTE[@lang=\"$lang\"]", $title, $content);
					}
					//Lecture avec la langue par defaut
					if (!$found)
						$found = getText($context, "$xReq/TEXTE[@lang=\"$def\"]", $title, $content);
					//lecture sans langue
					if (!$found)
						getText($context, "$xReq/TEXTE[not(@lang)]", $title, $content);
						
					$docs.=((strlen($docs))?',':'').'{titre:'.format($title).',texte:'.format(chgImgPath($content, $filePath)).'}';
*/						
				}
			}
		}
}

//formatage json
echo '{retour:'.$erreur.',docs:['.((strlen($docs))?$docs:"{titre:'',texte:''}").']}';
exit;

function getChapter($chap, $context, $xReq) {
	global $def, $filePath;
	$title = '';
	$content = '';
	if ($chap->has_attribute('LIB'))
		$title = $chap->get_attribute('LIB');

	 //r�cuperation des langues  de l'utilisateur
	$culture_user = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
	//d�coupage des diff�rentes langues
	preg_match_all("/([a-z]+)(?:\-([a-z]+))?(?:;[^,]+)?(?:,|$)/i", $culture_user, $culture_user_ar, PREG_SET_ORDER);	
	//Analyse des langues de l'utilisateur
	$found=false;
	for ($i=0;$i<count($culture_user_ar) && !$found;$i++) {
		$lang = strtolower($culture_user_ar[$i][1]);
		$found = getText2($context, "$xReq/TEXTE[@lang=\"$lang\"]", $title, $content);
	}
	//Lecture avec la langue par defaut
	if (!$found)
		$found = getText2($context, "$xReq/TEXTE[@lang=\"$def\"]", $title, $content);
	//lecture sans langue
	if (!$found)
		getText2($context, "$xReq/TEXTE[not(@lang)]", $title, $content);
		
	return '{titre:'.format($title).',texte:'.format(chgImgPath($content, $filePath)).'}';	
}
function getText2($context, $xReq, &$title, &$content) {
	$found = false;
	$body = $context->xpath_eval($xReq); //lecture du corps du chapitre
	if (count($body->nodeset)!=0) {
		if ($body->nodeset[0]->has_attribute('titre')) {
			$tmp = $body->nodeset[0]->get_attribute('titre');
			if (strlen($tmp)) $title = $tmp;
		}
		$content = str_replace("\\","\\\\", $body->nodeset[0]->get_content());
		$found=true;
	}
	return $found;
}

function format($text) {
	//Remplacement des retours charriot & tabulation
	$text = preg_replace('/[\n\r\t]/i', '', $text);
	//Remplacement des apostrophes
	$text = preg_replace("/[\']/i", "\\\'", $text);
	$text = preg_replace("/&#039;/i", "\\\'", $text);
	return "'$text'";
}

function chgImgPath($text, $docpath) {
	//remplacement du chemin des images
	preg_match_all('/<img\s(.*?)src=".*?([^\/]*?)"/i', $text, $imgMatch, PREG_SET_ORDER);
	if (is_array($imgMatch)) {
		foreach ($imgMatch as $imgPath) {
			$imgTransform = '<img '.$imgPath[1].'src="'.$docpath.'/images/'.$imgPath[2].'"';
			$text = str_replace($imgPath[0], $imgTransform, $text);
		}
	}
	return $text;
}
?>
