<?php

    //************************************************************************************************************************************************
	// @Author : HPG
	// @Created : 22/03/2007
	// @Description : Classe permettant de creer automatiquement une datasource � partir d'une requete SQL
	//************************************************************************************************************************************************
	class dbDataSource {
		var $connection;			//connexion a utiliser pour effectuer la requete ou les proprietes : dbServer, dbPort, dbLogin, dbPassword et dbNewLink
		var $dbServer;				//Nom du serveur mySql pour une nouvelle connexion
		var $dbPort;				//Port du serveur mySql pour une nouvelle connexion
		var $dbLogin;				//Login du serveur mySql pour une nouvelle connexion
		var $dbPassword;			//Mot de passe du serveur mySql pour une nouvelle connexion
		var $dbNewLink;				//Creer une nouvelle connexion ou reutiliser une connexion existante avec les memes parametres
		var $dbName;				//Base a utiliser pour effectuer la requete
		var $encoding;				//Encoding pour flux XML ( La valeur par d�faut est UTF-8)
		var $dateTimeFormat;		//Format de date pour encodage automatique la valeur par defaut est : %d/%m%Y, si vide pas de formatage
		var $colValue;				//nom de la colonne a utiliser comme "Value" de la 1ere colonne du databind, cette colonne ne sera pas affich�e.
		var $rowIcon;				//chemin de l'icone pour la 1ere colonne du databind.
		var $pageSize;				//longueur de la page pour pagination
		var $pageNum;				//numero de la page a afficher commence à 1
		function dbDataSource() {
			$this->connection=null;
			$this->encoding='UTF-8';
			$this->dateTimeFormat='%d/%m/%Y';
			$this->colValue='';
			$this->rowIcon='';
			$this->dbNewLink = false;
			$this->pageSize = 0;
			$this->pageNum = 1;
		}
		function read($sql, &$result) {
			
			function is_str_UTF8($string)
			{
				return (utf8_encode(utf8_decode($string)) == $string);
			}
			
			if ($this->connection)
				$db = $this->connection;
			else
				$db = mysql_connect($this->dbServer.':'.$this->dbPort, $this->dbLogin, $this->dbPassword, $this->dbNewLink);
				
			if (!$db) 
			{ 
                // Retourner une erreur
                $result = mysql_error();				
				return false; 
			}
				
			mysql_select_db($this->dbName, $db);

			if ($this->pageSize) {
				if ($this->pageNum <= 0) $this->pageNum = 1;					
				$pattern = '/^select (.*)/i';
				$replacement = 'select SQL_CALC_FOUND_ROWS \\1';
				$sql = preg_replace($pattern, $replacement, $sql);
				$sql .= ' LIMIT '.$this->pageSize;
				$sql .= ' OFFSET '.(($this->pageNum-1)*$this->pageSize);
				if (is_str_UTF8($sql))
				{
                    $sql=utf8_decode($sql);
				}
			}
			$rs = mysql_unbuffered_query($sql, $db);
			
			if (mysql_errno($db)==0) {
				
				$rowNum = 0;
				$result = '<header>';
				$colNum = 0;
				$fType = array();
				$valueCol = -1;
				while ($colNum < mysql_num_fields($rs)) {
					$field = mysql_fetch_field($rs, $colNum);
					if (strtolower($field->name)==strtolower($this->colValue)) {
						$valueCol = $colNum;
					}
					else {
						$fType[$colNum]='';
						$align = 0;
						if ($field->numeric) {
							$sortMode = "2";
							$align = 2;
						}
						else if ($field->type == 'datetime') {
							$sortMode = "3";
							$align = 1;
							$fType[$colNum]='D';
						}
						else if ($field->type == 'blob') {
							$sortMode = "0";
							$align = 1;
							$fType[$colNum]='B';
						}
						else if ($field->type == 'string')
							$sortMode = "1";
						else
							$sortMode = "0";
						$result .= '<item caption="'.htmlspecialchars($field->name,null,$this->encoding).'" icon="" onClick="" toolTip="" sortMode="'.$sortMode.'" alignment="'.$align.'"/>';
					}
					$colNum++;
				}
				$result .= '</header>';
				while ($row = mysql_fetch_array($rs, MYSQL_NUM)) {
					$result .= '<row>';
					$colNum = 0;
					$firstCol = true;
					foreach ($row as $value) {
						if ($colNum != $valueCol) {
							if ($fType[$colNum]=='D' && strlen($this->dateTimeFormat)>0 && $value!=null)
								$tmp = strftime($this->dateTimeFormat, strtotime($value));
							else if ($fType[$colNum]=='B')
								//$tmp = "";
    							//$tmp=preg_replace("/[^\x20-\xFF]/","",$value);
    							$tmp = "*** Binary Data ***";
							else
								$tmp = $value;
							$val = '';
							if ($firstCol && $valueCol>=0)	$val = $row[$valueCol];
								
							if(is_str_UTF8($tmp))
								$tmp = utf8_decode($tmp);
							$tmp=utf8_encode(htmlspecialchars($tmp, ENT_COMPAT | ENT_HTML401, 'ISO-8859-1'));
																
							$result .= '<item caption="'.$tmp.'" icon="'.(($firstCol)?$this->rowIcon:'').'" onClick="" value="'.$val.'" toolTip=""/>';
							$firstCol = false;
						}
						$colNum++;
					}
					$result .= '</row>';
					$rowNum++;
				}
				mysql_free_result($rs);
				
				$rsCount = mysql_query('select FOUND_ROWS()', $db);
				$rowRsCount = mysql_fetch_array($rsCount, MYSQL_NUM);
				$rowCount = $rowRsCount[0];
				mysql_free_result($rsCount);

				$result = '<?xml version="1.0" encoding="'.$this->encoding.'"?>' .
						  '<databind pageSize="'.$this->pageSize.'" pageNum="'.$this->pageNum.'" maxRow="'.$rowCount.'">' .
						  $result .
						  '</databind>';
    		    mysql_close($db);
				return true;
			}
			else
			{
				// Retourner une erreur
                $result = mysql_error();
                mysql_close($db);
                return false;
			}
		}
	}
?>
