<?php
/*
Copyright (c) Prologue [2007-2009], All Rights Reserved.

Prologue détient tous les droits de propriété intellectuelle attachés aux codes sources et codes objets du présent fichier. Sauf accord écrit entre la société utilisatrice et Prologue, seuls les codes objets sont remis à l'utilisateur. Toute autre  obtention des codes sources du présent fichier est illégale et constitutive de contrefaçon. Les droits d'utilisation des codes objets sont expressément décrits dans le contrat de licence signé entre la société utilisatrice et Prologue. Toute autre utilisation faite sans l'autorisation écrite de Prologue est illicite et constitue une contrefaçon.

Prologue owns all intellectual property rights related to source codes and object codes of this file. Unless otherwise agreed in writing between user's company and Prologue, only object codes are given to the user. Obtaining source code of this file by any other way is not legal and constitutes infringement. Object codes use rights are expressly described in the license agreement signed between user's company and Prologue. Any other use without the written permission of Prologue is not legal and constitutes an infringement.
*/

class prlAdminComponents {
	var $xml;
	var $xmlComponents;
	var $filePath;
	var $DFramework;
	var $DFxml='';
	var $traceComp = false; 
	var $traceCompId = '';
	var $relativeTo;
	var $demo;
	var $cptItem=0;
	
	function prlAdminComponents ($filePath='page.xml',$DFramework='DFramework.xml')
	{
		if (!file_exists($DFramework) ) return;

		//traitement des fichiers formulaires dans un répertoire
		// si on désigne un répertoire, l'ensemble des fichiers xml constituent la description d'un formulaire
		if (is_dir($filePath) ){
			$mainFile = 'page.xml';
			if (!file_exists($filePath.'/'.$mainFile) ) return;
			
			$this->filePath = $filePath.'/'.$mainFile;
			$handle = @fopen($filePath.'/'.$mainFile, 'r');
			$xml = '';
			
			
			while (!feof($handle)) {
				$xml .= fread($handle, 8192);
			}
			fclose($handle);

			$this->xml = $xml;
			//$doc = new DOMDocument('1.0');
			//$doc->loadXML($this->xml);
			$xml = $this->trad_xml($xml);
			$this->xmlComponents = new SimpleXMLElement($xml);

			//boucle sur tous les fichiers
			$fileMenuList = array();
			$dir = opendir($filePath);
			while($file = readdir($dir)) {
				$ext = strtolower(strrchr($file,'.'));
				//echo $file.'<BR>';
				//echo $ext.'<BR>';
				if (strtolower($ext)=='.xml' && $file!=$mainFile) {
					if (file_exists ($filePath.'/'.$file))$fileMenuList[]=$file;
					
				}
			}

			if (count($fileMenuList))
			{
				sort($fileMenuList);
				
				foreach ($fileMenuList as $file){
				//echo $file."<br>";
					$xmlComponentsPart = '';
					$handle = @fopen($filePath.'/'.$file, 'r');
					
					
					
					while (!feof($handle)) {
						$xmlComponentsPart .= fread($handle, 8192);
					}
					fclose($handle);
					//$doc=$this->insertComponents ($doc,$xmlComponentsPart);
					$xmlComponentsPart = $this->trad_xml($xmlComponentsPart);
					$xmlComponentsPart = new SimpleXMLElement($xmlComponentsPart);
					$this->xmlComponents = $this->insertComponents ($this->xmlComponents,$xmlComponentsPart,'',true);
				}
			
			}
			
			//print $this->createXML();exit;
		}else
		// traitement d'un fichier de description xml, il decrit un ensemble de composants
		{
			if (!file_exists($filePath) ) return;
			
			$this->filePath = $filePath;
			$handle = @fopen($filePath, 'r');
			$xml = '';
			
			
			while (!feof($handle)) {
				$xml .= fread($handle, 8192);
			}
			fclose($handle);
			$this->xml = $xml;
			$xml = $this->trad_xml($xml);
			$this->xmlComponents = new SimpleXMLElement($xml);
		}
		$this->demo=false;
		$this->htmlDemo='';
		$this->DFramework = ($DFramework !='')?$DFramework:'';
		if(file_exists ($this->DFramework)){
			$handle = @fopen($DFramework, 'r');
			$DFxml = '';
			while (!feof($handle)) {
				$DFxml .= fread($handle, 8192);
			}
			fclose($handle);
			
			$this->DFxml = new SimpleXMLElement($DFxml);
		}
		
		
	
	}
	function insertComponents ($simpleXmlTo, $simpleXmlFrom, $idParent='', $firstLoop=false){

		if (!$idParent){
				$parent = $simpleXmlFrom->parentNode;
				$idParent = $parent['id'];
		}
		if ($firstLoop) 
			$simplexml_from = $simpleXmlFrom->insertNode;
		else 
			$simplexml_from = $simpleXmlFrom;
		$simplexml_to = $this->searchCollection($idParent,$simpleXmlTo);
		//recherche des fils
		//echo $idParent.'__'.$simplexml_to['id'].'---<br>';
		foreach ($simplexml_from->children() as $simplexml_child)
		    {
		        $simplexml_temp = $simplexml_to->addChild($simplexml_child->getName(), (string) $simplexml_child);
		        foreach ($simplexml_child->attributes() as $attr_key => $attr_value)
		        {
		            $simplexml_temp->addAttribute($attr_key, $attr_value);
		        }

		       $firstLoop=false;

		        
			if ($simplexml_temp['id'])
				$simpleXmlTo = $this->insertComponents ($simpleXmlTo,$simplexml_child, $simplexml_temp['id']);
		    }
		//insertion 


		return $simpleXmlTo;
	}
	

	function trace ($compId=''){// permet de rassembler, dans un tableau, l'ensemble les composants qui seront declares en javascript, 
	//ceci permet d'afficher le fomrulaire de parametrage du composant. 
	//dans cette situation on refait la lecture des données xml sans passer par la localisation
		$this->xmlComponents = new SimpleXMLElement($this->xml);
		$this->traceComp = true; 
		$this->traceCompId = $compId;
		echo "<script>";
		echo "Prologue.editPage = Array();\n";
		echo "</script>";
	
	}
	
	function displComponentList($components='',$parentCompId='',$directParentId=''){ //genere le xml du treeview des composants definis dans le fichier xml "filePath"
		$end = '';
		if(!$components){
			$xmlBuffer = '<?xml version="1.0" encoding="ISO-8859-1"?><databind>';
			$components = $this->xmlComponents;
			$end = '</databind>';
		}
		
		foreach ($components as $component=>$elem) {
			
			$attr = $elem->attributes();
			$endRow= '';
			
			if (!($component == "items" || $component == "row")){
				$xmlBuffer .= '<row>';
				
				$xmlBuffer .= $this->displComponent($elem,$parentCompId,($component=='item'),$this->cptItem,$directParentId);
				
				$endRow= '</row>';
				$this->cptItem++;
			}
			
			
			$parentCompIdOld = $parentCompId;
			if($component == "collection")
			{
				$this->cptItem=0;
				if (!$parentCompId) $parentCompId = $attr['id'];
				$xmlBuffer .= $this->displComponentList($elem,$parentCompId,$directParentId);
			}
			if($component == "component" && count($elem->items))
			{
				$this->cptItem=0;
				if (!$parentCompId) 
					$parentCompId = $attr['id'];
				$directParentId = $attr['id'];
				$xmlBuffer .= $this->displComponentList($elem,$parentCompId,$directParentId);
			}
			if($component == "items" || $component == "row")
			{
				$xmlBuffer .= $this->displComponentList($elem,$parentCompId,$directParentId);
			}
			$parentCompId=$parentCompIdOld;
			
			$xmlBuffer .= $endRow;
			
		}
		
		
		$xmlBuffer .= $end;
		return $xmlBuffer;
	}
	
	function displComponent ($elem,$parentCompId='',$item=false,$cpt=0,$directParentId='') { //genere une ligne du treview des composants 
		$attr = $elem->attributes();
		//if (trim($parentCompId) != '') $parentCompId=' - '.$parentCompId;
		if ($item){
			$xmlBuffer = '<item caption="item - it_FW'.$cpt.'" icon="images/item.png" open="1" value="'.$parentCompId.'|item'.$cpt.'|'.$directParentId.'" />';
			return $xmlBuffer;
		}
		$attrDF = $this->DFxml->$attr['componentName']->attributes();
		$icon = 'images/'.$attrDF['icon'];
		if (!$parentCompId)$parentCompId=trim($attr['id']);
		$cap='';
		if (trim ($attr['caption'])) $cap = ' - '.$attr['caption'];
		$xmlBuffer = '<item caption="'.$attr['componentName'].' - '.$attr['id'].$cap.'" icon="'.$icon.'" open="1" value="'.$parentCompId.'|'.$attr['id'].'" />';
		return $xmlBuffer;
	}
	
	
	
	function display ($id='')
	{
		$present = false;
		foreach ($this->xmlComponents as $component=>$elem) {
			$attr = $elem->attributes();
			
			if (isset ($attr['id']) && $attr['id']==$id){
				$xmlComponent = $elem;
				$componentClass = $component;
				
				$DFComponent = ($this->DFxml != '' )?$this->DFxml->$attr['componentName']:'';
				$present = true;
				
				break;
			}
		}
		
		if ($present){
			//echo $componentClass;
			if ($componentClass == "component")
			{$component = new prlComponent ($xmlComponent, $DFComponent);
			
			}
			if ($componentClass == "collection")
			{$component = new prlCollection ($xmlComponent, $this->DFxml);
			
			}
			if ($componentClass == "container")
			{$component = new prlContainer ($xmlComponent, $DFComponent);
			
			}
			$component->trace=$this->traceComp;
			$component->traceCompId=$this->traceCompId;
			$component->relativeTo=$this->relativeTo;
			$component->demo=$this->demo;
			
			$component->display();
			
		}
		
	
	}

	function trad_xml($xml_content)
	{
		$liste_match = array();
	
		//recherche de tous les mots pr=E9c=E9d=E9s de '$'
		preg_match_all('/\$(\w+)/', $xml_content, $liste_match);
	
		//import de variables
		foreach($liste_match[1] as $var)
			global ${$var};
			
		//Renvoie le XML avec les noms de variables remplac=E9s par leur valeur
		return preg_replace('/\$(\w+)/e', '${"\\1"}', $xml_content); 
	}

	function createXml (){ //retourne les donnees xml, permet de reconstituer le fichier xml de départ après modification
		//return $this->xmlComponents->asXML();
		$doc = new DOMDocument('1.0');
		$doc->preserveWhiteSpace = false;
		$doc->loadXML($this->xmlComponents->asXML());
		$doc->formatOutput = true;
		return  $doc->saveXML();
		
		
		
	
	}
	
	function updateComponent ($attrList, $id, $xmlComp='',$itemNum=''){ //permet de modifier l'ensemble des attributs d'un composant défini dans le fichier xml
		//$id = $attrList['id'];
		if (!$xmlComp) $xmlComp = $this->xmlComponents;
		
		foreach ($xmlComp as $component=>$elem) {
			
			$attr = $elem->attributes();
			//echo $attr['id'].' attr <br>';
			if (isset ($attr['id']) && $attr['id']==$id){
			
				$this->updateAttrComponent($attrList, $id, $elem,$itemNum);
				break;
			}
			if ($component == 'collection')
				$this->updateComponent($attrList, $id, $elem,$itemNum);
			
		}
		
	
	}
	
	function updateAttrComponent ($attrList, $id,$elem,$itemNum=''){ //permet de modifier l'ensemble des attributs d'un composant défini dans le fichier xml
		//$id = $attrList['id'];
			//echo $id.' 2 <br>';
			//echo count($elem->items->row).' _ '.trim($itemNum).' _ '.$elem->items->row[intval($itemNum)]->item['caption'];
			if (trim($itemNum)!= ''){
				//$attr = $elem->items->row[trim($itemNum)]->item->attributes();
				//$elem = $elem->items->row[trim($itemNum)]->item;
				foreach ($attrList as $key=>$value)
				{
					//echo $key.' _ '.$this->xmlComponents->component[$cpt]['id'].'<br>';
					$key=str_replace('_','.',$key);
					if (trim($value)!=''){
						if (!isset($elem->items->row[intval($itemNum)]->item[$key]))
							@$elem->items->row[intval($itemNum)]->item->addAttribute($key, trim($value));
						else
							$elem->items->row[intval($itemNum)]->item[$key]=trim($value);
					}
					else
					//$this->xmlComponents->component[$cpt][$key]=null;
					unset($elem->items->row[intval($itemNum)]->item[$key]);
					
					if (trim($key)=='id')
					$elem->items->row[intval($itemNum)]->item['id']=(trim($value)!='')?trim($value):$id;
				}
			}
			else
			{
				$attr = $elem->attributes();
			
			
			//if (isset ($attr['id']) && $attr['id']==$id){
				foreach ($attrList as $key=>$value)
				{
					//echo $key.' _ '.$this->xmlComponents->component[$cpt]['id'].'<br>';
					$key=str_replace('_','.',$key);
					if (trim($value)!=''){
						if (!isset($elem[$key]))
							@$elem->addAttribute($key, trim($value));
						else
							$elem[$key]=trim($value);
					}
					else
					//$this->xmlComponents->component[$cpt][$key]=null;
					unset($elem[$key]);
					
					if (trim($key)=='id')
					$elem['id']=(trim($value)!='')?trim($value):$id;
				}
				
			//}
			}
			
	
	
	}
	
	
	function addComponent ($id, $componentName, $parentComp='', $xmlComp=''){
		//recherche du type du composant 
		$ret=1;
		//code retour : 1 - le composant est sous une collection 
		// 		2 - le composant est sous la racine
		
		if ($this->DFxml->$componentName)
			$attrDF=$this->DFxml->$componentName->attributes();
		
		$componentType=($attrDF['type'])?$attrDF['type']:'component';
		
	
		if (!$xmlComp) $xmlComp = $this->xmlComponents;
		
		if (!$parentComp){
			$this->addChild($this->xmlComponents,$id,$componentName,$componentType);
			return 2;
		}
		
		//recherche du parentComp
		$xmlParentComp=$this->searchCollection($parentComp,'',$componentName);
		if (!$xmlParentComp) {
			$xmlParentComp = $this->xmlComponents;
			$ret=2;
		}
		
		$this->addChild($xmlParentComp,$id,$componentName,$componentType);
		return $ret;
		
	
	}
	
	function searchCollection($parentComp,$xmlComp='',$componentName=''){
		if (!$xmlComp) $xmlComp = $this->xmlComponents;
		$cpt=0;
		foreach ($xmlComp->collection as $component=>$elem) {
			$attr = $elem->attributes();//echo $attr['id'].$parentComp.'_rrrrr<br>';
//echo (trim($attr['id'])==trim($parentComp))?'true':'false'.'_rrrrr<br>';
			if (isset ($attr['id']) && trim($attr['id'])==trim($parentComp)){//echo $attr['id'].'_dddd<br>';
				return $xmlComp->collection[$cpt];
			}
			else
				$ret=$this->searchCollection($parentComp,$xmlComp->collection[$cpt],$componentName);
				if ($ret) return $ret;
			$cpt++;
		}
		//recherche du composant pour les l'ajout d'un item
		if (trim($componentName) == 'item'){
			$cpt=0;
			foreach ($xmlComp->component as $component=>$elem) {
				$attr = $elem->attributes();
				if (isset ($attr['id']) && $attr['id']==$parentComp){
					return $xmlComp->component[$cpt];
				}
				$cpt++;
			}
		}
		return false;
	
	}
	
	function addChild($node,$id,$componentName,$componentType){
		
		if ($componentType != 'item' ){
			$child=$node->addChild($componentType);
			$child->addAttribute('id', trim($id));
			$child->addAttribute('componentName', $componentName);
		}
		else
		{ 
		
			if (!$node->items) $child=$node->addChild('items');
			$child=$node->items->addChild('row');
			$child->addChild($componentType);
			
		}
		return 1;
	}
	
	function deleteComponent ($id,$xmlComp='',$idItemDelete=''){
	
		if (!$xmlComp) $xmlComp = $this->xmlComponents;
		$cpt=0;
		foreach ($xmlComp->component as $component=>$elem) {
			$attr = $elem->attributes();
			if (isset ($attr['id']) && $attr['id']==$id){
				if (trim($idItemDelete) != '')
					unset($xmlComp->component[$cpt]->items->row[intval($idItemDelete)]);
				else
					unset($xmlComp->component[$cpt]);
				break;
			}
			$cpt++;
		}
		$cpt=0;
		foreach ($xmlComp->collection as $component=>$elem) {
			$attr = $elem->attributes();
			if (isset ($attr['id']) && $attr['id']==$id){
			
				unset($xmlComp->collection[$cpt]);
				break;
			}
			$this->deleteComponent($id, $xmlComp->collection[$cpt],$idItemDelete);
			$cpt++;
		}
		
		
		
	}
	
	


}







class prlCollection {
	var $component;
	var $xmlComponent;
	var $DFxml;
	var $DFComponent;
	var $traceCompId;
	var $trace;
	var $componentName;
	var $html;
	var $addMethod;
	var $relativeTo;
	var $demo;
	var $htmlDemo;

	function prlCollection ($xmlComponent='',$DFxml='')
		{
			$this->xmlComponent = $xmlComponent;
			$this->DFxml = $DFxml;
			$this->html = '';
			$this->demo=false;
			$this->htmlDemo='';
		}
		
		
	function htmlCode(){
	
		$Attr = $this->xmlComponent->attributes();
		$params = $attrList = $functionList = array();
		
		$this->DFComponent = ($this->DFxml != '' )?$this->DFxml->$Attr['componentName']:'';
		//echo "alert('".$DFAttr['addMethod'].$DFAttr['noTextAttrList']."')";
		if ($this->DFComponent) 
		{
			$DFAttr = $this->DFComponent->attributes();
			$params = explode (',',$DFAttr['param']);
			$attrList = explode (',',$DFAttr['noTextAttrList']);
			$functionList = explode (',',$DFAttr['function']);
			$this->addMethod = trim($DFAttr['addMethod']);
			
		}
		
		
		
		
		
		//print_r($DFAttr);print_r($params);
		$componentName = $Attr['componentName'];
		$this->componentVar = $Attr['componentName'];
		
		if ("$componentName" == "") return;
		
		$this->componentVar = 'prlFWork_'.$this->componentVar;
		
		$this->html .= 'var '.$this->componentVar.'= new Prologue.'.$componentName.'(';
		
		
		$this->html .= prlFWparamsDecl ($params,$Attr,$attrList,$this->relativeTo);
		
		$this->html .= ');'."\n";
		
		$this->subComponent();
			
		foreach ($Attr as $attr=>$value) {
			if ($attr != 'componentName'){
				$this->html .= prlFWattrDecl ($this->componentVar,$attr,$value,$attrList,$this->relativeTo);
				
			}
			
			
		}
		
		
		if ($this->trace && ($Attr['id'] == trim($this->traceCompId))) 
		{
			if ($Attr['componentName'] == 'buton' ) 
				$this->html .= 'Prologue.editPage[Prologue.editPage.length]=Prologue.editAtrributes.deepCopy('.$this->componentVar.");\n";
			else
				$this->html .= 'Prologue.editPage[Prologue.editPage.length]='.$this->componentVar.";\n";
		}
	}
	
	function subComponent(){
		if (count($this->xmlComponent))
		foreach ($this->xmlComponent as $component=>$elem) {
			$xmlComponent = $elem;
			$Attr = $elem->attributes();
			$DFComponent = ($this->DFxml != '' )?$this->DFxml->$Attr['componentName']:'';
			if ($component == "component")
			{
				$component = new prlComponent ($xmlComponent, $DFComponent);
				$component->relativeTo=$this->relativeTo;
				$component->trace=$this->trace;
				$component->traceCompId=$this->traceCompId;
				$component->htmlCode();
				$this->html .=$component->html;
				$this->html .=$this->componentVar.'.'.$this->addMethod.'('.$component->componentVar.');'."\n";
			}
			if ($component == "collection")
			{
				$component = new prlCollection ($xmlComponent, $this->DFxml);
				$component->relativeTo=$this->relativeTo;
				$component->trace=$this->trace;
				$component->traceCompId=$this->traceCompId;
				$component->htmlCode();
				$this->html .=$component->html;
				$this->html .=$this->componentVar.'.'.$this->addMethod.'('.$component->componentVar.');'."\n";
			}
			if ($component == "container")
			{
				$component = new prlContainer ($xmlComponent, $DFComponent);
				$component->relativeTo=$this->relativeTo;
				$component->trace=$this->trace;
				$component->traceCompId=$this->traceCompId;
				$component->htmlCode();
				$this->html .=$component->html;
				$this->html .=$this->componentVar.'.'.$this->addMethod.'('.$component->componentVar.');'."\n";
			}
		
		
		}
	
		
	
	}

	function display(){
		if ($this->demo) $this->displayContentID();
		$this->htmlCode();
		if (!$this->html) return;
		if ($this->demo) echo $this->htmlDemo;
		echo '<script>';
		$this->html .= $this->componentVar.".create();\n";
		$this->html .= '</script>';
	
		echo $this->html;
	}

	function displayContentID(){
		$Attr = $this->xmlComponent->attributes();
		
			if ($Attr['contentID'] && trim($Attr['contentID']) != '')
			$this->htmlDemo .= '<div style="width:100px;height:100px;" >'.$Attr['contentID'].'</div>';
		
	}


}

class prlContainer {




}

class prlComponent {
	var $component;
	var $xmlComponent;
	var $DFComponent;
	var $componentName;
	var $html;
	var $relativeTo;
	var $demo;
	var $htmlDemo;
	var $traceCompId;
	var $trace;
	
	function prlComponent ($xmlComponent='',$DFComponent='')
	{
		$this->xmlComponent = $xmlComponent;
		$this->DFComponent = $DFComponent;
		$this->html = '';
		$this->demo=false;
		$this->htmlDemo='';
	}
	
	function htmlCode(){
		$Attr = $this->xmlComponent->attributes();
		
		//recuperer les proprietes des composants
		$params = $attrList = $functionList = array();
		if ($this->DFComponent) 
		{
			$DFAttr = $this->DFComponent->attributes();
			$params = explode (',',$DFAttr['param']); //liste des parametres a l'appel du composant
			$attrList = explode (',',$DFAttr['noTextAttrList']);//liste des attrributs qui seront traités comme des valeurs numériques ou booleennes
			$functionList = explode (',',$DFAttr['function']); //nom de fonction (obsolete)
			
		}
		else
		return;
		
		
		
		
		
		//print_r($DFAttr);print_r($params);
		$componentName = $Attr['componentName'];
		$this->componentVar = $Attr['componentName'];
		
		if ("$componentName" == "") return;
		
		$this->componentVar = 'prlFWork_'.$this->componentVar;
		
		$this->html .= 'var '.$this->componentVar.'= new Prologue.'.$componentName.'(';
		$this->html .= prlFWparamsDecl ($params,$Attr,$attrList,$this->relativeTo);
		
		$this->html .= ');'."\n";
		
		
		foreach ($Attr as $attr=>$value) {
			if ($attr != 'componentName'){
				$this->html .= prlFWattrDecl ($this->componentVar,$attr,$value,$attrList,$this->relativeTo);
				
				
			}
			
			
		}
		
		//traitement des noeuds attr
		if (count($this->xmlComponent->attr))
		foreach ($this->xmlComponent->attr as $attr){
			$property =$attr->attributes();
			$this->html .= prlFWattrDecl ($this->componentVar,$property['name'],$property['value'],$attrList,$this->relativeTo);
			
		}
		
		
		
		//traitement du sous composant "content"
		if (trim($this->xmlComponent->content))
			$this->html .=$this->componentVar.'.content = \''.trim($this->xmlComponent->content)."';\n";
		
		//traitement des items
		if (isset($this->xmlComponent->items))
		$this->loadItems();
		
		if ($this->trace && ($Attr['id'] == trim($this->traceCompId))) 
		{
			if ($Attr['componentName'] == 'button' ) //cas particulier, lors de son affichage certaines proprietes sont initialiees (onclick)
				$this->html .= 'Prologue.editPage[Prologue.editPage.length]=Prologue.editAtrributes.deepCopy('.$this->componentVar.");\n";
			else
				$this->html .= 'Prologue.editPage[Prologue.editPage.length]='.$this->componentVar.";\n";
		}
		
		
		
	}
	
	function loadItems($rows='',$parentRow=''){
		if (!$parentRow) $parentRow = $this->componentVar;
		if (!$rows) $rows = $this->xmlComponent->items->row; //liste des elements de la file
		
		if ($this->DFComponent->items) {
			$DFAttr = $this->DFComponent->items->attributes();
			$params = explode (',',$DFAttr['param']); //liste des parametres a l'appel du composant
			$attrList = explode (',',$DFAttr['noTextAttrList']);//liste des attrributs qui seront traités comme des valeurs numériques ou booleennes
			$functionList = explode (',',$DFAttr['function']); //nom de fonction (obsolete)
			$addMethod = trim($DFAttr['addMethod']);
			$itemobject = (trim($DFAttr['itemObject'])=="false")?false:true;
		}
		else
		return;
		$cpt=0;
		if (count($rows))
		foreach ($rows as $row){
			$Attr = $row->item->attributes();
			//$this->loadRow ($row,$parentRow,$DFAttr);
			
			
			$rowVar = $parentRow.'_newR';
			$this->html .= 'var '.$rowVar.'= '.$parentRow.'.'.$addMethod.'(';
			$this->html .= prlFWparamsDecl ($params,$Attr,$attrList,$this->relativeTo);
			
			$this->html .= ');'."\n";
			
			
			if($itemobject) {
			//si la fonction d'ajout retourne un objet item, on peut declarer l'ensemble des proprietes. sinon on ne fait rien (ex addSource du composant mainmenu)
				foreach ($Attr as $attr=>$value) {
					if ($attr != 'componentName'){
						$this->html .= prlFWattrDecl ($rowVar,$attr,$value,$attrList,$this->relativeTo);
					}
					
					
				}
			}
			
			if ($itemobject && $this->trace && ('it_FW'.$cpt == trim($this->traceCompId))) 
			{
				$this->html .= 'Prologue.editPage[Prologue.editPage.length]=Prologue.editAtrributes.deepCopy('.$rowVar.");\n";
					//$this->html .= 'Prologue.editPage[Prologue.editPage.length]='.$rowVar.";\n";
			}
			else
			if ($this->trace && ('it_FW'.$cpt == trim($this->traceCompId))) //la fonction ne retourne pas un objet item
			//la reference sera donc l'objet parent
			{
				$this->html .= 'Prologue.editPage[Prologue.editPage.length]='.$this->componentVar.";\n";
			}
			$cpt++;
			if (isset($row->row))
			$this->loadItems($row->row,$rowVar);
		
		}
		
		
	
	
	}
	
	
	function display(){
		if ($this->demo) $this->displayContentID();
		$this->htmlCode();
		if (!$this->html) return;
		
		if ($this->demo) echo $this->htmlDemo;
		
		echo '<script>';
		$this->html .= $this->componentVar.".create();\n";
		$this->html .= '</script>';
	
		echo $this->html;
	}
	
	
	function displayContentID(){ //en mode demo on crée les div qui représentent les entites declarees a travers la propriété "contentID"
		$Attr = $this->xmlComponent->attributes();
	
		if ($Attr['contentID'] && trim($Attr['contentID']) != '')
		$this->htmlDemo .= '<div id="'.$Attr['contentID'].'" style="width:100px;height:100px;" >Mode demo <br>Espace : '.$Attr['contentID'].'</div>';
			
		foreach ($this->xmlComponent->attr as $attr){ //recherche au niveau des noeuds "attr"
			$property =$attr->attributes();
			if (trim($property['name'])=='contentID')
			$this->htmlDemo .= '<div id="'.$property['value'].'" style="width:100px;height:100px;" >Mode demo <br>Espace : '.$property['value'].'</div>';
		}
		
		$rows = $this->xmlComponent->items->row;
		if (count($rows))
		foreach ($rows as $row){ //recherche dans les items (ex : items du composant tabStrip
			$property = $row->item->attributes();
			//$this->loadRow ($row,$parentRow,$DFAttr);
			if (trim($property['contentID'])!='')
			$this->htmlDemo .= '<div id="'.$property['contentID'].'" style="width:100px;height:100px;" >Mode demo <br>Espace : '.$property['contentID'].'</div>';
			
		}
		
	}


}







function prlFWattrDecl ($obj,$attr,$value,$attrList,$relativeTo=''){
	$tmp = '';
	
	if (!$obj || !$attr) return $tmp;
	
	if ($attr == "dataSource" || $attr == "menuUrl") $value = $relativeTo.$value;
	
	$tmp .= $obj.'.'.$attr;
	$valueString='';
	if (!in_array($attr,$attrList))// les valeurs non interpretable
		$value = '\''.$value.'\'';
	else { 
	//pour les valeurs qui seront interpretees (pas de chaine de caractere), on declare la meme propriete, avec un suffix mais en mode chaine de caractère
		$valueString = $obj.'.'.$attr.'_FWString=\''.$value.'\''.";\n";
	}
	
	//if(in_array($attr,$functionList)) 
	//	$tmp .= '('.$value.");\n";
	//else
		$tmp .= '='.$value.";\n";
		$tmp .=$valueString;
		
	return $tmp;
}

function prlFWparamsDecl ($params,$Attr,$attrList,$relativeTo) {
		$tmp='';$sep='';
		if (count($params))
		{	
			foreach ($params as $key=>$param) {
				if(trim($Attr[trim($param)]) != ''){
					$tmp .= ($tmp)?',':'';
					
					$tmp .= ($sep)?$sep.',':$sep;
					if (trim($param) == "dataSource" || trim($param) == "menuUrl") $Attr[trim($param)] = $relativeTo.trim($Attr[trim($param)]);
					$value = trim($Attr[trim($param)]);
					if (!in_array(trim($Attr[trim($param)]) ,$attrList))
						$value = '\''.trim($Attr[trim($param)]).'\'';
					$tmp .= $value;
					
				//$tmp .= ($Attr[trim($param)])?'\''.$Attr[trim($param)].'\'':'\'\'';
				$sep='';
				}
				else $sep .=($sep)?",''":"''";
				
			}
			//$this->html .= $tmp;
			//$this->html .= ');'."\n";
		}
		else
			//$this->html .= '\''.$Attr['id'].'\');'."\n";
			$tmp .= '\''.$Attr['id'].'\'';
		
		return $tmp;
}


?>