<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- feuille d'une page d'aide affiche via le site d'install -->
 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="string_back"/>
<xsl:param name="id"/>
<xsl:param name="lang"/>

<!--Construction de la sctucture html globale-->
<xsl:template match="/DOCBOOK">
<html>
	<head>
		<title>Documentation Use it Flow</title>
		<link href="../style/fm.css" rel="stylesheet" type="text/css"/>
		<link href="../style/link_menu.css" rel="stylesheet" type="text/css"/>
		<style type="text/css">
			ol.sommaire, li.sommaire
			{
				font-family: Arial, Helvetica, sans-serif;
				font-weight: bold;
				color: #0084BD;
				text-decoration: none;
				font-size: 8pt;
			}
			ol.sommaire { counter-reset: item }
			li.sommaire { display: block }
			li.sommaire:before
			{
				content: counters(item, "."); 
				counter-increment: item 
			}
		</style>
		<script type="text/javascript">
			var limit = 1;
			var browser=navigator.appName;
			if(browser=="Microsoft Internet Explorer")
				limit = 0;
		</script>
	</head>
	<body leftmargin="0" topmargin="0" marginwidth="10px" marginheight="10px" class="i-fond">
		<img src="../style/imgs/use_it_flow.png"/><img src="../style/imgs/h_logo_prologue.png" style="position:absolute;top:20px;right:20px;"/>
		<br/><br/>
			<xsl:for-each select="//CHAP[contains(@ID, $id)]">
				<xsl:call-template name="Chapitre"/>
			</xsl:for-each>
		<br/>
		<br/>
		<br/>
		<center>
			<xsl:element name="input">
				<xsl:attribute name="type">button</xsl:attribute>
				<xsl:attribute name="class">h-bout</xsl:attribute>
				<xsl:attribute name="onClick">if(history.length>limit) history.back(); else window.close();</xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="$string_back"/></xsl:attribute>
			</xsl:element>
		</center>
		<br/>
		</body>
</html>
</xsl:template>
	
<!--Construction d'une page-->
<xsl:template name="Chapitre">
	<center>
		<span class="h-titre">
			<xsl:choose>
				<xsl:when test="not(@titre)"><xsl:value-of select="@LIB"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="@titre"/></xsl:otherwise>
			</xsl:choose>
		</span>
	</center>
	<br/>
    <xsl:for-each select="//CHAP[contains(@ID, $id)]/TEXTE[@lang=$lang]">
		<xsl:apply-templates/>
    </xsl:for-each>
	<br/>
	<hr/>
	<ol class="sommaire">
		<xsl:for-each select="CHAP">
			<li class="sommaire"><![CDATA[&]]>nbsp;-<![CDATA[&]]>nbsp;
				<xsl:element name="a">
					<xsl:attribute name="href">?installation=on<![CDATA[&]]>id=<xsl:value-of select="@ID"/></xsl:attribute>
					<xsl:value-of select="@LIB"/>
				</xsl:element>
			</li>
		</xsl:for-each>
	</ol>
</xsl:template>

<!--Construction d'une image html-->
<xsl:template match="img">
	<xsl:element name="img">
		<xsl:attribute name="src"><xsl:value-of select="@src"/></xsl:attribute>
		<xsl:if test="@width">
			<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@height">
			<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@border">
			<xsl:attribute name="border"><xsl:value-of select="@border"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@alt">
			<xsl:attribute name="alt"><xsl:value-of select="@alt"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@title">
			<xsl:attribute name="title"><xsl:value-of select="@title"/></xsl:attribute>
		</xsl:if>
	</xsl:element>
</xsl:template>

<!--Construction d'un hyperlien-->
<xsl:template match="a">
	<xsl:element name="a">
		<xsl:if test="@href">
			<xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@name">
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
		</xsl:if>
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:retour  la ligne-->
<xsl:template match="br">
	<xsl:element name="br"></xsl:element>
</xsl:template>

<!--HTML:hr-->
<xsl:template match="hr">
	<xsl:element name="hr"></xsl:element>
</xsl:template>

<!--HTML:Soulign-->
<xsl:template match="u">
	<xsl:element name="u">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:Italique-->
<xsl:template match="i|em">
	<xsl:element name="i">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:ul-->
<xsl:template match="ul">
	<xsl:element name="ul">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:ol-->
<xsl:template match="ol">
	<xsl:element name="ol">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:li-->
<xsl:template match="li">
	<xsl:element name="li">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:gras-->
<xsl:template match="b|strong">
	<xsl:element name="b">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:centr-->
<xsl:template match="center">
	<xsl:element name="center">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:pre-->
<xsl:template match="pre">
	<xsl:element name="pre">
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:p-->
<xsl:template match="p">
	<xsl:element name="p"><xsl:apply-templates/></xsl:element>
</xsl:template>

<!--HTML:table-->
<xsl:template match="table">
	<xsl:element name="table">
		<xsl:if test="@align">
			<xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@width">
			<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@class">
			<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@border">
			<xsl:attribute name="border"><xsl:value-of select="@border"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@cellspacing">
			<xsl:attribute name="cellspacing"><xsl:value-of select="@cellspacing"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@cellpadding">
			<xsl:attribute name="cellpadding"><xsl:value-of select="@cellpadding"/></xsl:attribute>
		</xsl:if>
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:tr-->
<xsl:template match="tr">
	<xsl:element name="tr">
		<xsl:if test="@align">
			<xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@width">
			<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@class">
			<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
		</xsl:if>
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:td-->
<xsl:template match="td">
	<xsl:element name="td">
		<xsl:if test="@align">
			<xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@width">
			<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@class">
			<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@colspan">
			<xsl:attribute name="colspan"><xsl:value-of select="@colspan"/></xsl:attribute>
		</xsl:if>
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:span-->
<xsl:template match="span">
	<xsl:element name="span">
		<xsl:if test="@class">
			<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
		</xsl:if>
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

<!--HTML:font-->
<xsl:template match="font">
	<xsl:element name="font">
		<xsl:if test="@size">
			<xsl:attribute name="size">
			<xsl:choose>
				<xsl:when test="@size='-2'">x-small</xsl:when>
				<xsl:when test="@size='-1'">small</xsl:when>
				<xsl:when test="@size='-0'">medium</xsl:when>
				<xsl:when test="@size='+1'">large</xsl:when>
				<xsl:when test="@size='+2'">x-large</xsl:when>
				<xsl:otherwise><xsl:value-of select="@size"/></xsl:otherwise>
			</xsl:choose>
			</xsl:attribute>
		</xsl:if>
		<xsl:if test="@color">
			<xsl:attribute name="color"><xsl:value-of select="@color"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="@face">
			<xsl:attribute name="face"><xsl:value-of select="@face"/></xsl:attribute>
		</xsl:if>
		<xsl:apply-templates/>
	</xsl:element>
</xsl:template>

</xsl:stylesheet>