<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- feuille de la page Sommaire -->
 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="string_version"/>
<xsl:param name="installation"/>

<!--Construction de la sctucture html globale-->
<xsl:template match="/DOCBOOK">
<html>
	<head>
		<title>Documentation Use it Flow</title>
		<link href="../style/fm.css" rel="stylesheet" type="text/css"/>
		<link href="../style/link_menu.css" rel="stylesheet" type="text/css"/>
		<style type="text/css">
			ol.sommaire, li.sommaire
			{
				font-family: Arial, Helvetica, sans-serif;
				font-weight: bold;
				color: #0084BD;
				text-decoration: none;
				font-size: 8pt;
			}
			ol.sommaire { counter-reset: item }
			li.sommaire { display: block }
			li.sommaire:before
			{
				content: counters(item, "."); 
				counter-increment: item 
			}
		</style>
	</head>
	<body leftmargin="0" topmargin="0" marginwidth="10px" marginheight="10px" class="i-fond">
		<img src="../style/imgs/use_it_flow.png"/>
		<img src="../style/imgs/h_logo_prologue.png" style="position:absolute; right:20px; top:20px;"/>
		<br/><br/>

		<center>
			<!-- note : <![CDATA[&]]> sert  chapper le & -->
			<span class="h-titre"><xsl:value-of select="$string_version"/><![CDATA[&]]>nbsp;<xsl:value-of select="@version"/></span>
		</center>
		<br/>
		<!--Construit les chapitres-->
		<ol class="sommaire">
			<xsl:apply-templates select="CHAP"/>
		</ol>
		<br/>
		</body>
</html>
</xsl:template>

<!--Construction d'un chapitre-->
<xsl:template match="CHAP">
<!--On ne traite pas ce qui ne concerne que EDF et Installation (si $installation n'est pas  on)-->
	<xsl:if test="DEST/@EDF='' and (DEST/@Aide='on' or DEST/@Reference='on' or DEST/@Suivi='on' or DEST/@Utilisation='on' or DEST/@Installation=$installation)">
		<!--lien-->
		<li class="sommaire"><![CDATA[&]]>nbsp;-<![CDATA[&]]>nbsp;
			<xsl:element name="a">
				<xsl:attribute name="name"><xsl:value-of select="@ID"/></xsl:attribute>
				<xsl:attribute name="href">?installation=<xsl:value-of select="$installation"/><![CDATA[&]]>id=<xsl:value-of select="@ID"/></xsl:attribute>
				<xsl:value-of select="@LIB"/>
			</xsl:element>

			<!--Mode SOMMAIRE-->
			<ol class="sommaire">
				<xsl:apply-templates select="CHAP"/>
			</ol>
		</li>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>