<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="UTF-8"/>
<xsl:param name="detail"/>
<xsl:param name="title"/>
<xsl:param name="subTitle"/>
<xsl:param name="pageNum"/>
<xsl:param name="pageCount"/>

<xsl:template match="databind">
	<center>
	<p class="title"><xsl:value-of disable-output-escaping="yes" select="$title"/></p>
	<p class="subTitle">
		<xsl:value-of disable-output-escaping="yes" select="$subTitle"/>
		,&#160;<b>Page</b>&#160;:&#160;<xsl:value-of disable-output-escaping="yes" select="$pageNum"/>&#160;/&#160;<xsl:value-of disable-output-escaping="yes" select="$pageCount"/>
	</p>
	</center>
	<table cellspacing="0">
	<xsl:apply-templates select="header"/>
	<xsl:apply-templates select="row"/>
	</table>
</xsl:template>

<xsl:template match="header">
	<tr>
		<xsl:apply-templates select="item"/>
	</tr>
</xsl:template>

<xsl:template match="row">
	<tr>
		<xsl:if test="position() mod 2 = 0">
			<xsl:attribute name="class">odd</xsl:attribute>
		</xsl:if>
		<xsl:apply-templates select="item"/>
	</tr>
	<xsl:if test="$detail != '0'">
		<tr>
			<xsl:if test="position() mod 2 = 0">
				<xsl:attribute name="class">odd</xsl:attribute>
			</xsl:if>
			<td>
				<xsl:attribute name="colspan"><xsl:value-of select="count(/databind/header/item)"/></xsl:attribute>
				<xsl:value-of disable-output-escaping="yes" select="@detail"/>
			</td>
		</tr>
	</xsl:if>
</xsl:template>

<xsl:template match="item">
	<xsl:choose>
		<xsl:when test="count(ancestor::header)=1">
		<th>
			<xsl:choose>
				<xsl:when test="string-length(normalize-space(@caption))!=0">
					<xsl:value-of select="@caption"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@toolTip"/>
				</xsl:otherwise>
			</xsl:choose>
		</th>
		</xsl:when>
		<xsl:otherwise>
		<td>
			<xsl:choose>
				<xsl:when test="string-length(@caption)!=0">
					<xsl:value-of select="@caption"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@toolTip"/>
				</xsl:otherwise>
			</xsl:choose>
		</td>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>