var PopupMenu = function() {
    this.init();
}
PopupMenu.SEPARATOR = 'PopupMenu.SEPARATOR';
PopupMenu.current = null;
PopupMenu.addEventListener = function(element, name, observer, capture) {
    if (typeof element == 'string') {
        element = document.getElementById(element);
    }
    if (element.addEventListener) {
        element.addEventListener(name, observer, capture);
    } else if (element.attachEvent) {
        element.attachEvent('on' + name, observer);
    }
};
PopupMenu.prototype = {
    init: function() {
        this.items  = [];
		if(document.all) // IE
			this.width  = 120;
		else
			this.width  = 0;
        this.height = 0;
    },
    setSize: function(width, height) {
        this.width  = width;
        this.height = height;
        if (this.element) {
            var self = this;
            with (this.element.style) {
                if (self.width)  width  = self.width  + 'px';
                if (self.height) height = self.height + 'px';
            }
        }
    },
    simulLeftClick: function(e){
        if(document.all) // IE
            window.event.srcElement.click();
        else
        {
            var evt = document.createEvent('MouseEvents');
            evt.initEvent('click', true, true);
            e.target.dispatchEvent(evt);
        }
    },
	bind: function(element, simulLeft) {
        var self = this;
        if (!element) {
            element = document;
        } else if (typeof element == 'string') {
            element = document.getElementById(element);
        }
        this.target = element;
        this.target.oncontextmenu = function(e) {
			if(simulLeft) // pour activer la slection de la ligne du grid
				self.simulLeftClick.call(self, e);
            self.show.call(self, e);
            return false;
        };
        var listener = function() { self.hide.call(self) };
        PopupMenu.addEventListener(top, 'click', listener, true);
		PopupMenu.addEventListener(document, 'click', listener, true);
    },
	add: function(icon, text, enable_fct, callback) {
		this.items.push({ icon: icon, text: text, enabled: enable_fct, callback: callback });
    },
    addSeparator: function() {
        this.items.push(PopupMenu.SEPARATOR);
    },
    setPos: function(e) {
        if (!this.element) return;
        if (!e) e = window.event;
        var x, y;
        if (window.opera) {
            x = e.clientX;
            y = e.clientY;
        } else if (document.all) {
            x = document.body.scrollLeft + event.clientX;
            y = document.body.scrollTop + event.clientY;
        } else if (document.layers || document.getElementById) {
            x = e.pageX;
            y = e.pageY;
        }
        this.element.style.top  = y + 'px';
        this.element.style.left = x + 'px';
    },
    show: function(e) {
        if (PopupMenu.current && PopupMenu.current != this) return;
        PopupMenu.current = this;
        if (this.element) {
			// oblig de recrer le menu pour activation/dsactivation des commandes par appel de enabled()
            //this.setPos(e);
            //this.element.style.display = '';
			document.body.removeChild(this.element);
        } /*else {*/
            this.element = this.createMenu(this.items);
            this.setPos(e);
            document.body.appendChild(this.element);
        //}
    },
    hide: function() {
        PopupMenu.current = null;
        if (this.element) this.element.style.display = 'none';
    },
    createMenu: function(items) {
        var self = this;
        var menu = document.createElement('div');
        with (menu.style) {
            if (self.width)  width  = self.width  + 'px';
            if (self.height) height = self.height + 'px';
            border		= "1px solid gray";
			boxShadow	= "3px 3px 4px darkgray";
            background	= '#FFFFFF';
            position	= 'absolute';
            display		= 'block';
            padding		= '2px';
            cursor		= 'default';
			fontFamily	= 'Verdana';
			fontSize 	= '10pt';
			fontWeight	= 'normal';
        }
        for (var i = 0; i < items.length; i++) {
            var item;
            if (items[i] == PopupMenu.SEPARATOR) {
                item = this.createSeparator();
            } else {
                item = this.createItem(items[i]);
            }
            menu.appendChild(item);
        }
        return menu;
    },
    createItem: function(item) {
        var self = this;
        var elem = document.createElement('div');
        elem.style.padding = '4px';
        var callback = item.callback;
        PopupMenu.addEventListener(elem, 'click', function(_callback) {
            return function() {
                self.hide();
                _callback(self.target);
            };
        }(callback), true);
        PopupMenu.addEventListener(elem, 'mouseover', function(e) {
            elem.style.background = '#B6BDD2';
        }, true);
        PopupMenu.addEventListener(elem, 'mouseout', function(e) {
            elem.style.background = '#FFFFFF';
        }, true);
		if(item.icon)
		{
			var Img = new Image();
	        Img.id = 'Img';
	        Img.src = item.icon;
			if(item.enabled())
				Img.disabled = false;
			else
			{
				Img.disabled = true;
				if(document.all) // IE
					Img.style.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=20)";
				else
					Img.style.opacity = 0.2;
			}
			Img.style.marginRight = '6px';
			Img.style.verticalAlign = 'middle';
	        elem.appendChild(Img);
		}
		elem.style.color = item.enabled() ? 'black' : 'lightgray';
	    elem.appendChild(document.createTextNode(item.text));
        return elem;
    },
    createSeparator: function() {
        var sep = document.createElement('div');
        with (sep.style) {
            borderTop = '1px solid #CCCCCC';
            fontSize  = '0px';
            height    = '0px';
        }
        return sep;
    }
};