/**
* afficher/masquer un élément
*
* @param {string} id
*/
function toggleVisibility (id)
{
	var o = document.getElementById(id);
	o.style.display = (o.currentStyle.display!='none')?'none':'block';
};

/**
* décode une chaîne codée par la fonction PHP "urlencode()"
*
* @param {string} str chaine à modifier
* @return {string} chaine modifi�e
*/
function urldecode (str)
{
	str = str.replace(/[+]/g," ");
	return unescape(str); //deprecated
	//return decodeURIComponent(str);	//n'accepte pas les caractères hors ASCII en utf-8
}

/**
* encode une chaîne décodable par la fonction PHP "urldecode()"
*
* @param {string} str chaine à modifier
* @return {string} chaine modifiée
*/
function urlencode (str)
{
	//str = escape(str); //deprecated
	str = encodeURIComponent(str);
	return str.replace(/[ ]/g,"+"); 
}

/**
* change l'url dans l'iframe 'ifmMain' depuis le menu
*
* @param {string} url url de la page
*/
function loadPage (url)
{
	if (url)
	{
		var ifm = frames['ifmMain'];
		if (ifm) ifm.location.href = urldecode(url);
	}
}

/**
* change l'url dans l'iframe 'ifmMain' depuis l'iframe elle-même
*
* @param {string} url url de la page
*/
function changePage (url)
{
	if (url)
		window.location.href = urldecode(url);
}

/**
* Ouvre une Pop-up dans une prlWindow avec une url spécifique
* 
* @param {string} url url de la page
*/
/*
function openPopUp (url)
{
	if(typeof document.getElementById('popUp') == 'undefined')
	{
		alert('popUp not found => create');
		var popUp = new prlPopUp();
		popUp.id = 'popUp';
		popUp.create();
	}
	
	var ifmPop = frames['ifmPop'];
	alert('ifmPop('+ifmPop+'), url('+url+')');
	if(url && ifmPop)
	{
		alert('setVisible');
		prlWindow.setVisible('popUp', true);
		alert('change url ('+url+')');
		ifmPop.location.href = urldecode(url);
	}
};*/

/**
* Ouvre une Pop-up avec une url spécifique
* 
* @param {string} url url de la page
*/

function openPopUp (url, title, width, height, decode)
{
	if(typeof decode == 'undefined' || decode == null)
		decode = true;
	
	url = (decode? urldecode(url): url);
	
	if(!title)
	 	title = 'Use it Flow';
		
	if(!width)
	 	width = '600';
		
	if(!height)
	 	height = '400';
		
//	if(!document.popUp || typeof document.popUp == 'undefined')// || !document.popUp.document)
		document.popUp = open('', '', 'width='+width+',height='+height+', toolbar=no, scrollbars=yes, resizable=yes');
	
	document.popUp.location.href = url;
	document.popUp.document.title = title;
	document.popUp.focus();
};

function closePopUp ()
{
	if (document.popUp.document)
		document.popUp.close();
};

/**
* retourne la valeur de l'attribut 'prlValue' d'un objet
*
* @param {object} obj objet
* @return {string} valeur de l'attribut 'prlValue'
*/
function getPrlValue (obj)
{
	return obj.attributes.getNamedItem('prlValue').value;
};

/**
* affiche un message (alert()) à partir d'une source de données
* 
* @param {string} url url de la source de données
*/
function prlExec (url, async)
{
	async = async||false;
		
	req = new Prologue.ajax.request(url);
	if(async)
		req.callBack = prlExecProcess;
	if(typeof req != 'undefined')
	{
		req.send();
		if(!async)
			return prlExecProcess(req);
	}
		
		/*
		if (resp)
		{
			//Mode Json
			for(o in resp)
			{
				if(o == "msg")
					msg = resp[o];
				if(o == "return")
					ret = resp[o]
			}
			/** /
	
			/* Mode XML * /
			var xRoot = resp.documentElement;
			if(xRoot)
			{
				var row = xRoot.firstChild;
				var datasourceNode = row.firstChild;
				if (datasourceNode)
				{
					for (var a=0; a < datasourceNode.attributes.length; a++)
					{
						var atb = datasourceNode.attributes[a];
						switch (atb.name)
						{
							case 'msg':
								msg = atb.value;
								break;
							case 'return':
								ret = parseInt(atb.value, 10);
								break;
						}
					}
				}
			}
			/ ** /	
		}
		if(msg.length != 0)
			alert(msg);			
	}
	return ret
	*/
};

function prlExecProcess (req)
{
	var msg = '';
	var buff = '';
	var ret = -1;
	var onsuccess = '';
	
	var resp = req.getJson();
		
	if (resp){
		/* Mode Json */
		for(o in resp)
		{
			if(o == "msg")
				msg = resp[o];
			if(o == "onsuccess")
				onsuccess = resp[o];
			if(o == "return")
				ret = resp[o]
			if(o == "buff")
				buff = resp[o];
		}
		if(msg.length != 0 && buff.length == 0)
		{
			// Pour supprimer les \ devant les \, les " et les ' :
			msg = msg.replace(/\\("|'|\\)/g, "$1");
			alert(msg);	
		}
		if(buff.length != 0)
			window.open("crt_actTelechargEbics.php?fic="+buff+"","pop1","width=2,height=2" );
		if(onsuccess.length != 0)
			eval(onsuccess);
	}
	return ret;
}


function repr (obj, degres) {
	
	function tabify (degres){
		var ret = '';
		while(degres--)
			ret += '    ';
		return ret;
	}
	var str = '';
	degres = degres||0;
	for(key in obj) {
		str += tabify(degres);
		str += key + ' : ';
		if(typeof obj[key] == "object") {
			str += '{\n'
			str += repr(obj[key], degres + 1);
			str += tabify(degres);
			str += '}\n';
		}
		else
			str += obj[key]+'\n';
	}
	return str;
}

function prlRapport (url)
{
	var msg = '';
	var ret = -1;
	
	req = new Prologue.ajax.request(url);
	if(typeof req != 'undefined')
	{
		req.send();
		var resp = req.getJson();
		
		if (resp)
		{
			/* Mode Json */
			for(o in resp)
			{
				if(o == "msg")
					msg = resp[o];
				if(o == "return")
					ret = resp[o]
			}
		}
		if(msg.length != 0)
			$('popUp').rows[1].cells[0].firstChild.innerHTML=urldecode(msg);
			Prologue.window.setVisible('popUp', true);
	}
	return ret
};

function prlExecGrid (url)
{
	if(prlExec(url) == 0)
		page.gridReload();
};

/**
* récupère une adresse, y ajoute tous les valeurs des input d'un form et les poste
*
* 
* @param {object} form - formulaire à analyser
* @param {string} urlPost - url de la page de destination
* @param {function} callBack - fonction qui va utiliser l'url (de type : function (url))
*/
function submitForm (form, urlPost, callBack)
{
	var parameters = '';
	for (var i = 0; i < form.elements.length; i++)
	{
		var e = form.elements[i];
		if (e.name)
		{
			if (parameters.length)
				parameters += '&';
			else
				parameters = '?';
			
			var value = '';
			
			if(e.type == 'checkbox')	
				value = (e.disabled? '': (e.checked? '1': '0'));
			else
				value = e.value;
			
			parameters += e.name+'='+encodeURIComponent(value);
		}
	}
	//alert(urlPost+parameters);
	return callBack(urlPost+parameters);
	
};

function proc_stat (div)
{
	req = new Prologue.ajax.request(Flow.path+'dataSources/dSProc_stat.php');
	if(typeof req != 'undefined')
	{
		req.tag = div;
		req.callBack = gen_proc_stat; 
		req.send();
	}
};

function gen_proc_stat(req)
{
	var tab = req.getJson();
	var tmp = '<table><tr>';
	var i = 0;
	
	for(o in tab)
	{
		if(i > 0 && i%3 == 0)
			tmp += '</tr><tr>';
			
		var icon = Flow.path+'style/imgs/icons/rond_rouge.png';
		
		var key = o;
		var val = tab[o];
		
		if(val == null)
			icon = Flow.path+'style/imgs/icons/help.png';
		else if(val)
			icon = Flow.path+'style/imgs/icons/rond_vert.png';
		
		tmp += '<td style="color: #0084BD; font-size: 10px; font-family: arial; text-decoration: none;"><img style="height: 14px; width: 14px;" src="'+icon+'"/>'+o+'</td>';
		++i;
	}
	tmp += '</tr></table>';
	document.getElementById(req.tag).innerHTML = tmp;
	window.setTimeout("proc_stat('"+req.tag+"')", 10000);
}

function $(id) {
	return document.getElementById(id)
};

function RandPWD(form, pwd, pwd2)
{
	var Lettre = "abcdefghijklmnopqrstuvwxyz";
	var Num = "0123456789";
	var Res = "";
	var i = 0;
	var k = 0;

	for (k = 0; k < 6; k++)
  	{
		i = Number(Random('A'));
		Res += Lettre.charAt(i);
	}
	for (k = 0; k < 2; k++)
	{
		i = Number(Random('N'));
		Res += Num.charAt(i);
	}
		
	document.forms[form][pwd].value= Res;
	document.forms[form][pwd2].value= Res;
	
	//var tmp = "document.forms['"+form+"'].elements['"+pwd+"'].value='"+Res+"';";
	//var tmp = "document.getElementsByName('"+form+"').elements['"+pwd+"'].value='"+Res+"';";
	//eval(tmp);
	//tmp = "document.forms['"+form+"'].elements['"+pwd2+"'].value='"+Res+"';";
	//tmp = "document.getElementsByName('"+form+"').elements['"+pwd2+"'].value='"+Res+"';";
	//eval(tmp);
}

function Random(type)
{
	var Res;

	if(type == 'A')
	{
		do
		{
			Res = Math.random()*100;
		}
		while (Res > 25);
	}
	else
	{
		do
		{
			Res = Math.random()*10;
		}
		while (Res > 9);
	}
	Res = Math.floor(Res)

	return Res;
}
/**
* cr��e une nouvelle instance de la classe prlFiltreField
*
* @classDescription cette classe cr��e un champs de filtre (formulaire) dynamique
* @param {string} nom nom du champs
* @param {prlFiltreField.types} type type du champs
* @constructor
*/
function prlFiltreField (nom, type, patern, valpatern)
{
	this.nom = nom;
	this.type = type;
	this.value = '';
	this.libelle = '';
	this.onClick = '';
	this.dataSource = '';
	this.obj = null;
	this.format = '';
	this.size = 0;
	this.dropDownWidth = '';
	this.dropDownHeight = '';
	this.maxLength = 0;
	this.loadOnDropDown = false;
	this.editable = false;
	this.defaultCaption = '';
	this.patern = patern;
	this.valpatern = valpatern;
};

/**
* créer le texte HTML pour le rendu du champs
*
* @memberOf prlFiltreField
* @return {string} le texte HTML du rendu
* @method
*/
prlFiltreField.prototype.html = function ()
{
	var tmp = '';
	if(this.type == prlFiltreField.types.newLine)
		tmp = '</tr><tr>';
	else
	{
		tmp = '<td class="fieldCaption">'+this.libelle+'</td><td class="fieldValue">';
		switch (this.type)
		{
			case prlFiltreField.types.prlComboList :
				this.obj = new prlComboList(this.nom, this.value, this.onClick);
				this.obj.dataSource = this.dataSource;
				this.obj.loadOnDropDown = this.loadOnDropDown;
				this.obj.editable = this.editable;
				this.obj.width = '150px';
				break;
			case prlFiltreField.types.prlComboImage :
				this.obj = new prlComboImage(this.nom, this.value, this.patern, this.valpatern);
				this.obj.dataSource = this.dataSource;
				this.obj.loadOnDropDown = this.loadOnDropDown;
				this.obj.editable = this.editable;
				this.obj.width = '150px';
				break;
			case prlFiltreField.types.prlComboTree :
				this.obj = new prlComboTree(this.nom, this.value, this.onClick);
				this.obj.dataSource = this.dataSource;
				this.obj.loadOnDropDown = this.loadOnDropDown;
				this.obj.defaultCaption = this.defaultCaption;
				this.obj.width = '150px';
				break;
			case prlFiltreField.types.prlComboDate :
				this.obj = new prlComboDate(this.nom, this.value, this.onClick);
				this.obj.width = '95px';
				break;
			case prlFiltreField.types.prlTextBox :
				this.obj = new prlTextBox(this.nom, this.format, this.value, this.onClick);
				if(this.size)
					this.obj.size = this.size;
				if(this.maxLength)
					this.obj.maxLength = this.maxLength;
				this.obj.width = '150px';
				break;
		}
		
		if(this.type != prlFiltreField.types.newLine & this.type != prlFiltreField.types.prlTextBox)
		{
			if(this.dropDownHeight)
				this.obj.dropDown.height = this.dropDownHeight;
			if(this.dropDownWidth)
				this.obj.dropDown.width = this.dropDownWidth;
		}
		
		tmp += this.obj.html()+'</td>';
	}
	return tmp;
}

/**
* contient les différents types de champs
*
* @memberOf prlFiltreField
* @type {array}
*/
prlFiltreField.types = 
{
	'newLine':0,
	'prlComboList':1,
	'prlComboTree':2,
	'prlComboDate':3,
	'prlTextBox':4,
	'prlComboImage':5
};
/**
* créée une nouvelle instance de la classe prlFiltre
*
* @classDescription filtre (formulaire) gérant une liste de prlFiltreField
* @constructor
*/
function prlFiltre ()
{
	this.filtres = new Array();
};

/**
* ajoute un prlFiltreField à la liste
*
* @memberOf prlFiltre
* @param {string} nom nom du champs
* @param {prlFiltreField.types} type type du champs
* @return {prlFiltreField} le prlFiltreField créée
* @method
*/
prlFiltre.prototype.add = function (nom, filtreType)
{
	this.filtres.push(new prlFiltreField(nom, filtreType));
	return this.filtres[this.filtres.length - 1];
};

/**
* créée et affiche le filtre
*
* @memberOf prlFiltre
* @method
*/
prlFiltre.prototype.create = function ()
{
	var temp = '<form name="frmFilter" action="" method=""><table class="form" cellspacing="0"><tr>';
	var f = this.filtres;
	var l = f.length;
	for(var i = 0; i < l; ++i)
		temp += f[i].html();
		
	temp += '</tr></table></form>';

	var tbr = new Prologue.toolbar();
	tbr.add(lang_prlFiltre_tbr_appliquer, Flow.path+'style/imgs/icons/valid.png','page.gridReload(); Prologue.Flow.comboPanel.setState(\'pnlFiltre\', Prologue.Flow.comboPanel.states.close);', '1');
	tbr.add(lang_prlFiltre_tbr_effacer, Flow.path+'style/imgs/icons/error.png','filList.raz(); page.gridReload(); Prologue.Flow.comboPanel.setState(\'pnlFiltre\', Prologue.Flow.comboPanel.states.close);', '1');	
	tbr.add(lang_prl_aide,				Flow.path+'style/imgs/icons/help.png', 'top.help.show(\'20040108121856\');', '1');	
	temp += '<div style="padding-top:5px;" align="right">'+tbr.html()+'</div>';
	document.write(temp);
			
/*	
	var panel = new Prologue.panel (lang_prlFiltre_title, Flow.path+'style/imgs/icons/filtre.png');
	panel.content = tbr.html();
	panel.content += '<table cellspacing=5 style="width:100%;" cellpadding=0><tr>';
	panel.onClick = 'prlPage.divGridResize();';
	for(var i = 0; i < this.filtres.length; ++i)
		panel.content += this.filtres[i].html();
	
	panel.content += '</tr></table>';
	*/
}

/**
* renvoie le nom et la valeur des champs du filtre au format d'envoie avec une url (?nom=value&...)
*
* @memberOf prlFiltre
* @return {string} chaîne contenant les informations des champs
* @method
*/
prlFiltre.prototype.getInfo = function ()
{
	var ret = '';
	
	for(var i = 0; i < this.filtres.length; ++i)
	{
		var tmp = '';
		switch (this.filtres[i].type)
		{
			case prlFiltreField.types.prlComboList :
				tmp = prlComboList.getSelected(this.filtres[i].nom).value;
				break;
				
			case prlFiltreField.types.prlComboImage :
				tmp = prlComboList.getSelected(this.filtres[i].nom).value;
				break;
				
			case prlFiltreField.types.prlComboTree :
				tmp = prlComboTree.getSelected(this.filtres[i].nom).value;
				break;
				
			case prlFiltreField.types.prlComboDate :
				tmp = prlComboDate.getSelected(this.filtres[i].nom);
				break;
				
			case prlFiltreField.types.prlTextBox :
				tmp = document.getElementById(this.filtres[i].nom).value;
				break;				
		}
		if(this.filtres[i].type != prlFiltreField.types.newLine)
			ret += '&'+this.filtres[i].nom+'='+tmp;
	}
	return ret;
};

/**
* renvoie le nom et la valeur des champs du filtre pour un résumé
*
* @memberOf prlFiltre
* @return {string} chaîne contenant les informations des champs
* @method
*/
prlFiltre.prototype.getSummary = function ()
{
	var ret = '';
	var re = new RegExp(/^-$/);
	
	function addLibel(lbl) {
		//return '<td style="font-weight:bold;>'+lbl+' :</td>';
		return '<b>'+lbl+'</b>&nbsp;:&nbsp;';
	};
	function addValue(lbl) {
		//return '<td style="font-stylet:italic;>'+lbl+'</td>'
		return lbl;
	};
	
	var sel = 0;
	for(var i = 0; i < this.filtres.length; ++i)
	{
		var libelle = addLibel(this.filtres[i].libelle);
		var value = '';
		switch (this.filtres[i].type)
		{
			case prlFiltreField.types.prlComboList :
				value = addValue(prlComboList.getSelected(this.filtres[i].nom).caption)
				break;
				
			case prlFiltreField.types.prlComboImage :
				var val = prlComboList.getSelected(this.filtres[i].nom).value;
				if(val!='none' && val!='')
				{
					var reg = new RegExp('('+this.filtres[i].valpatern+')', 'g');
					var imgsrc = this.filtres[i].patern.replace(reg, val);
					value = '<img src="'+imgsrc+'" style="vertical-align:middle;"/>';
				}
				else if(val=='none')
					value = addValue(prlComboList.getSelected(this.filtres[i].nom).caption);
				else
					value = '';
				break;
				
			case prlFiltreField.types.prlComboTree :
				value = addValue(prlComboTree.getSelected(this.filtres[i].nom).caption)
				break;
				
			case prlFiltreField.types.prlComboDate :
				value = addValue(prlComboDate.getSelected(this.filtres[i].nom))
				break;
				
			case prlFiltreField.types.prlTextBox :
				value = addValue($(this.filtres[i].nom).value)
				break;
		}

		if(this.filtres[i].type != prlFiltreField.types.newLine && value != '' && value != ' ' && !re.test(value))
		{
			//ret += ((sel == 0)?'':', ') + String.replace(new RegExp('/\s/'), '&nbsp;') libelle + value;
			ret += ((sel == 0)?'':', ') + libelle + value;
			++sel;
		}
	}
	return ret;
};

/**
* vide tous les champs du filtre
*
* @memberOf prlFiltre
* @method
*/
prlFiltre.prototype.raz = function ()
{
	for(var i = 0; i < this.filtres.length; ++i)
	{
		if(this.filtres[i].nom == "limitStep")
			continue;
		var tableCombo = document.getElementById(this.filtres[i].nom);
		switch (this.filtres[i].type)
		{
			case prlFiltreField.types.prlComboList :
				prlComboList.selectRowByIndex(tableCombo, 0, false);
				break;
					
			case prlFiltreField.types.prlComboImage :
				prlComboList.selectRowByIndex(tableCombo, 0, false);
				break;

			case prlFiltreField.types.prlComboTree :
				prlComboTree.selectNodeByIndex(tableCombo, 0, false);
				break;
				
			case prlFiltreField.types.prlComboDate :
				prlComboDate.setSelected(tableCombo, '', false);
				break;
								
			case prlFiltreField.types.prlTextBox :
				tableCombo.value = '';
				break;
		}
	}
};
prlPopUp.extend(Prologue.window);
/**
* créée une nouvelle instance de la classe prlPopUp
*
* @classDescription cette classe créée et gère l'affichage de pop-up
* @see prlWindow
* @constructor
*/
function prlPopUp ()
{
	prlPopUp.callBaseConstructor(this, lang_prlPopUp_title, Flow.path+'style/imgs/icons/info.png');
	this.id = 'popUp';
	var ifmPop = '<iframe id="ifmPop" name="ifmPop" style="width: 640px; height:480px;" src="#"></iframe>';
	this.content = ifmPop;
	this.startUpPosition = prlWindow.startUpPosition.centerScreen;
	this.visible = false;
};
/**
* créer une nouvelle instance de la classe prlPage
*
* @classDescription classe gérant l'affichage d'une page dynamique
* @constructor
*/
function prlPage ()
{
	this.url = {'grid':''};
	this.title = {'caption':'', 'icon':''};
};

/**
* récupère les informations du filte et recharge la grille
*
* @memberOf prlPage
* @method
*/
prlPage.prototype.gridReload = function ()
{
	var urlReload = this.url.grid;
	$('grid').attributes.getNamedItem('prlPageSize').value = prlComboList.getSelected('limitStep').value;
	$('grid').attributes.getNamedItem('prlPageNum').value = 1;
	if(typeof filList != 'undefined')
		urlReload += filList.getInfo();
	prlGrid.reload('grid', urlReload, true);
};

prlPage.elementCalcPosition = function()
{
	//prlPage.boxRelocate();
	prlPage.divGridResize();
}

/**
* Retaille la grille
*
* @memberOf prlPage
* @method
*/
prlPage.divGridResize = function()
{
	var div = document.getElementById('div_grid');
	var ret = 0;
	if(div) {
		var h = document.body.clientHeight;
		var w = document.body.clientWidth;
		w -= div.offsetLeft;
		w -= 15; //taille de la scrollbar
		h -= div.offsetTop;
		var sb = document.getElementById('div_state'); 
		if (sb)
		{
			h -= sb.clientHeight;
		}
		if(document.body.currentStyle) {
			h -= parseInt(document.body.currentStyle.marginTop);
			h -= parseInt(document.body.currentStyle.marginBottom);
			h -= parseInt(document.body.currentStyle.paddingTop);
			h -= parseInt(document.body.currentStyle.paddingBottom);
		}
		if(h > 0)
			div.style.height = h+'px';
		if(w > 0)
			div.style.width = w+'px';
		ret = h;
	}
	return ret;
}

prlPage.prototype.filterPanelCreate = function ()
{
	var tmp = '<span id="filList"><script language="JavaScript" type="text/javascript">';
	tmp +=	'filList.create();</script></span>';
	document.write(tmp);
	pnlFiltre = new Prologue.Flow.comboPanel('pnlFiltre', lang_prlFiltre_title, Flow.path+'style/imgs/icons/filtre.png')
	pnlFiltre.dropDownID = 'filList';
	pnlFiltre.content = filList.getSummary(); 
	pnlFiltre.onClose = function(){
		var sm = filList.getSummary();
		if($('gridTbr'))
			$('gridTbr').attributes.getNamedItem('prlPrintSubTitle').value = urlencode(sm);
		return sm;
	};
	pnlFiltre.onPlug = prlPage.divGridResize;
	pnlFiltre.create();
}

//OBSOLETE
/**
* créer le panneau de titre
*
* @memberOf prlPage
* @method
*/
prlPage.prototype.titleCreate = function () {}
if (typeof Prologue.Flow == 'undefined') Prologue.Flow = {};
Prologue.Flow.comboPanel = function(id, caption, icon, content)
{
	Prologue.Flow.comboPanel.callBaseConstructor(this, id);
	this.caption = caption||'';
	this.icon = icon||'';
	this.dropDownID = '';
	this.dropDownContent = '';
	this.className = 'prlFlowPanel';
	this.onClose = null;
	this.onPlug = null;
	this.content = '';
	this.attributes = function() {
		var tmp = Prologue.Flow.comboPanel.callBaseMethod(this, 'attributes');
		return tmp;
	};
};
Prologue.Flow.comboPanel.extend(Prologue.control);

Prologue.Flow.comboPanel.prototype.create = function()
{
	Prologue.Flow.comboPanel.callBaseMethod(this, 'create');
	var me = $(this.id);
	me.prlOnClose = this.onClose;
	me.prlOnPlug = this.onPlug;
	if (me) {
		var cnt = Prologue.Flow.comboPanel.getDropDown(me);
		if (cnt) {
			if (this.dropDownID) {
				var obj = $(this.dropDownID);
				if (obj) {
					//cnt.innerHTML = obj.innerHTML;
					//obj.removeNode(true);							
					cnt.innerHTML = '';
					cnt.appendChild(obj);
				}
			}
			else {
				cnt.innerHTML = this.dropDownContent;
			}
			Prologue.ui.setWidth(cnt.parentNode, cnt.offsetWidth);
		}
	}
};

Prologue.Flow.comboPanel.prototype.html = function() {
	var itm = new Prologue.item(this.caption, this.icon);
	var tmp = '<table cellspacing="0" cellpadding="0"'+this.attributes()+'>'
			+ '<tr onclick="Prologue.Flow.comboPanel.setState(\''+this.id+'\');"><td>'
			+ '<table class="title" style="width:100%;">'
			+ '<tr>'
			+ '<td style="width:100%;">' + itm.html() + '</td>'
			+ '<td><img id="'+this.id+'_puce" src="'+Prologue.framework.images+'/fleche_bas.png"/></td>'
			+ '<td><img id="'+this.id+'_plug" src="'+Prologue.Flow.images+'comboPanel/unplug.png" onclick="Prologue.Flow.comboPanel.setPlug(\''+this.id+'\');event.cancelBubble=true;return false;"/></td>'
			+ '</tr></table>'
			+ '<div id="'+this.id+'_dropDown" class="dropdown" onclick="event.cancelBubble=true;return false;"></div>'
			+ '</td></tr>'
			+ '<tr id="'+this.id+'_content"><td class="content" onclick="this.parentNode.previousSibling.onclick();">'+this.content+'</td></tr>'
			+ '</table>';
	return tmp;
};

Prologue.Flow.comboPanel.states = {
	 open:1
	,close:0
};

Prologue.Flow.comboPanel.getState = function(panel)
{
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
		return (($(panel.id+'_dropDown').currentStyle.visibility=='hidden')?Prologue.Flow.comboPanel.states.close:Prologue.Flow.comboPanel.states.open);
	return null;
};

Prologue.Flow.comboPanel.setState = function(panel, state)
{			
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
	{
		if (!Prologue.Flow.comboPanel.getPlug(panel.id)) {
			if (typeof state == 'undefined') {
				state = Prologue.Flow.comboPanel.getState(panel.id);
				state = ((state==Prologue.Flow.comboPanel.states.open)?Prologue.Flow.comboPanel.states.close:Prologue.Flow.comboPanel.states.open);
			}
			if (state==Prologue.Flow.comboPanel.states.open) {
				var dd = $(panel.id+'_dropDown');
				var w = dd.parentNode.offsetWidth;
				//correction pour !IE ???
				if (!Prologue.browser.ie) {
					w -= (parseInt($(panel.id).currentStyle.borderLeftWidth)||0);
					w += (parseInt($(panel.id).currentStyle.borderRightWidth)||0);
				}
				Prologue.ui.setWidth(dd, w);
				dd.style.visibility='visible';
				$(panel.id+'_puce').src = Prologue.framework.images+'/fleche_haut.png';
			}
			else {
				$(panel.id+'_dropDown').style.visibility='hidden';
				$(panel.id+'_puce').src = Prologue.framework.images+'/fleche_bas.png';
				if (typeof panel.prlOnClose == 'function') {
					var buffer = panel.prlOnClose.call(this);
					var cnt = Prologue.Flow.comboPanel.getContent(panel);
					cnt.innerHTML = buffer;
				}
			}
			return true;
		}
	}
	return false;
};

Prologue.Flow.comboPanel.getContent = function(panel)
{
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
		return $(panel.id+'_content').cells[0];
	return null;
};

Prologue.Flow.comboPanel.getDropDown = function(panel)
{
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
		return $(panel.id+'_dropDown');
	return null;
};

Prologue.Flow.comboPanel.getPlug = function(panel) {
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
		return ($(panel.id+'_dropDown').style.position == 'static');
	return false;
};

Prologue.Flow.comboPanel.setPlug = function(panel, plugged) {
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE') {
		if (typeof plugged == 'undefined')
			plugged = !(Prologue.Flow.comboPanel.getPlug(panel.id));
		if (plugged) {
			Prologue.Flow.comboPanel.setState(panel, Prologue.Flow.comboPanel.states.open);
			$(panel.id+'_plug').src = Prologue.Flow.images+'comboPanel/plug.png';						
			$(panel.id+'_puce').style.display = 'none';
			$(panel.id+'_dropDown').style.position = 'static';
			$(panel.id+'_content').style.display = 'none';						
		}
		else {
			$(panel.id+'_plug').src = Prologue.Flow.images+'comboPanel/unplug.png';						
			$(panel.id+'_puce').style.display = '';
			$(panel.id+'_dropDown').style.position = 'absolute';
			$(panel.id+'_content').style.display = '';
			Prologue.Flow.comboPanel.setState(panel, Prologue.Flow.comboPanel.states.open);
		}
		panel.prlOnPlug.call(this);
		
		// on force le redimensionnement de la zone en dessous du panel 
		if(document.createEvent)
		{
			var evt = document.createEvent("Events");
			evt.initEvent("resize", false, true);
			window.dispatchEvent(evt);
		}
		else // IE
		{
			// pas trouvé d'autre solution, car le dispatchEvent n'existe pas et fireEvent ne marche pas...
			window.resizeTo(document.body.offsetWidth, parseInt(document.body.offsetHeight)-1);
			window.resizeTo(document.body.offsetWidth, parseInt(document.body.offsetHeight)+1);
		}
	}
};

////////////////////////////////
/// help Object           ///
////////////////////////////////
Prologue.Flow.help = function(caption)
{
	this.helpFile = '';
	this.visible = false;
	
	this.object = null;
	this.helpId = 0;
	this.recurse = false;
	
	this.width = '640';
	this.height = '480';
	
	this.title = caption||lang_prl_aide;
	
	this.show = function() {
		Prologue.Flow.help.setVisible(this, true);
		//var cnt = document.help_popUp.document.getElementById('help_content');
		//if(cnt)
			//cnt.innerHTML = 'Chargement en cours...';

		var url = Prologue.framework.path+'/help.php?id='+this.helpId+'&src='+escape(this.helpFile)+'&recurse='+(this.recurse?1:0);
		var req = new Prologue.ajax.request(url);
		req.callBack = Prologue.Flow.help.callBack;
		req.send(null);
	}
};

Prologue.Flow.help.popUp = {obj:null, is_loaded:false, content:''};

//Fonctions statiques
Prologue.Flow.help.setVisible = function (help_obj, visible) {
	if(Prologue.Flow.help.popUp.obj) {
		if(!visible) {
			Prologue.Flow.help.popUp.obj.close();
			Prologue.Flow.help.popUp.obj = null;
			Prologue.Flow.help.popUp.is_loaded = false;
		}
	}
	if(visible) {
		Prologue.Flow.help.popUp.is_loaded = false;
		Prologue.Flow.help.popUp.obj = open(Prologue.Flow.path+'inc/js/help_content.php', help_obj.title, 'width='+help_obj.width+',height='+help_obj.height+', toolbar=no, scrollbars=yes, resizable=yes');
		//Prologue.Flow.help.popUp.content = lang_msg_loading;
		//Prologue.Flow.help.wait_load(30);
	}
}
Prologue.Flow.help.wait_load = function (TTL) {
	if(Prologue.Flow.help.popUp.is_loaded)
		Prologue.Flow.help.load_content();
	else if (TTL-- > 0)
		setTimeout('Prologue.Flow.help.wait_load('+TTL+');', 1000);
	return;
}

Prologue.Flow.help.load_content = function () {
	if(Prologue.Flow.help.popUp.content && Prologue.Flow.help.popUp.content.length) {
		var cnt = Prologue.Flow.help.popUp.obj.document.getElementById('help_content');
		cnt.innerHTML = Prologue.Flow.help.popUp.content;
		Prologue.Flow.help.popUp.obj.focus();
	}
}

Prologue.Flow.help.prototype.create = function() {
};

Prologue.Flow.help.callBack = function(req)
{
	var hlps = req.getJson();
	var tmp = '';
	for (var h=0; h<hlps.docs.length; h++) {
		var hlp = hlps.docs[h];
		tmp += (h?'<hr/>':'')+'<table><tr><td><img src="' + Prologue.framework.images + '/help_32.png"/></td><td class="prlHelpTitle">'+hlp.titre+'</td></tr></table><hr/>'+hlp.texte;
	}
	Prologue.Flow.help.popUp.content = tmp;
	Prologue.Flow.help.wait_load(30);
};
Prologue.Flow.help.read = function(helpFile, helpId, recurse)
//Lecture synchrone d'un chapitre de l'aide
{
	recurse = (recurse||0);
	var url = Prologue.framework.path+'/help.php?id='+helpId+'&src='+escape(helpFile)+'&recurse='+(recurse?1:0);
	var req = new Prologue.ajax.request(url);
	req.send(null);
	return req.getJson();
}
Prologue.Flow.help.show = function(help_obj, helpId, recurse)
{
	recurse = (recurse||0);
	var helpFile =  help_obj.helpFile;
	var url = Prologue.framework.path+'/help.php?id='+helpId+'&src='+escape(helpFile)+'&recurse='+(recurse?1:0);
	
	Prologue.Flow.help.setVisible(help_obj, true);
	var req = new Prologue.ajax.request(url);
	req.callBack = Prologue.Flow.help.callBack;
	req.send(null);
};
Prologue.Flow.help.resize = function(window)
{
};
var rowAction = new function() {
	var sel, selId = 0, list, params;
	var list_params = [];
	var params = null;
	//this.actions = {'length':0};
	this.actions = {};
	this.grid_id = 'grid';
	
	var action = function (act_name, page, callback, get_params) {
		this.act_name = act_name;
		this.callback = callback||openPopUp;
		this.isActivated = true;
		
		var act_url = function (page, get_params) {
			this.page = page;
			this.get_params = get_params||[];
			this.params = {};
			
			this.path = function() {
				var tmp = Flow.path + this.page;
				for(i=0; i < this.get_params.length; ++i)
					tmp += ((i==0)? '?': '&')+this.get_params[i]+'='+this.params[this.get_params[i]];
				return tmp;
			};
			
			this.toString = function () {
				return this.path();
			};
		};
		
		this.act_url = new act_url(page, get_params);
		
		this.check = function (params, list_params) {
			return true;
		}
		
		this.exec = function (params, list_params) {
			if(params && params.droits[this.act_name] && this.isActivated) {
				if(this.check(params, list_params)) {
					this.act_url.params = params;
					this.callback(this.act_url.path());
				}
			}
			else
				alert(lang_rowAction_NoRight);
		};
	};
		
	this.add = function (nom, page, callback, get_params) {
		this.actions[nom] = new action(nom, page, callback, get_params);
		//this.actions.length = this.actions.length + 1;
	};
	
	this.exec = function (name) {
		if (getSelected(this.grid_id))
			this.actions[name].exec(params, list_params);
		else
			alert(lang_rowAction_NoSelected);
		params=null;
		list_params=[];
	};
	
	function getSelected(grid_id) {
		params=null;
		list_params=[];
		var sels = Prologue.grid.getSelected(grid_id);
		if (sels instanceof Array == false)	sels = new Array(sels);
		for(var i = 0; i < sels.length; i++){
			sel = sels[i];
			if(sel && sel.value && sel.value.length && sel.index>=0)
				list_params[i] = eval('('+sel.value+')');
		}
		if(list_params && list_params.length)
			params = list_params[0];
		return (list_params && list_params.length > 0);
	};
	
	/*
	 * Active/Désactive les boutons et les actions selon les droits de la sélection courante
	 */
	this.set_state_action = function () {
		var grid = $(this.grid_id);
		if(grid) {
			var grid_toolbar_id = grid.attributes.getNamedItem('prlToolBar').value;
			var grid_toolbar = $(grid_toolbar_id);
			if(getSelected(this.grid_id)) {
				//On récupère la liste des actions programmées
				//S'il y a au moins une des lignes qui n'a pas le droit
				//alors on désactive le bouton
				for(action in this.actions) {
					var isAvailable = false;
					
					for(key in list_params) {
						isAvailable = list_params[key].droits[action];
						if(!isAvailable)
							break;
					}
					
					var td = null;
					//Recherche du bouton correspondant à l'action
					for(var i = 0; i < grid_toolbar.rows[0].cells.length; ++i)
						if(grid_toolbar.rows[0].cells[i].attributes.getNamedItem('prlValue') && grid_toolbar.rows[0].cells[i].attributes.getNamedItem('prlValue').value == action) {
							td = grid_toolbar.rows[0].cells[i];
							break;
						}
						
					if(td) {
						if(isAvailable) {
							Prologue.ui.setOpacity(td, 100);
							this.actions[action].isActivated = true;
						}
						else {
							Prologue.ui.setOpacity(td, 20);
							this.actions[action].isActivated = false;
						}
					}
				}
			}
			else {
				for(action in this.actions) {
					var td = null;
					
					//Recherche du bouton correspondant à l'action
					for(var i = 0; i < grid_toolbar.rows[0].cells.length; ++i)
						if(grid_toolbar.rows[0].cells[i].attributes.getNamedItem('prlValue') && grid_toolbar.rows[0].cells[i].attributes.getNamedItem('prlValue').value == action) {
							td = grid_toolbar.rows[0].cells[i];
							break;
						}
					if(td) {
						Prologue.ui.setOpacity(td, 20);
						this.actions[action].isActivated = false;
					}
				}
			}
		}
	};
	
	
	//Surcharge des fonctions de la grid pour ajouter la mise à jour des actions (masquage des boutons)	 
	var resync_old = Prologue.gridPageToolBar.resync;
	Prologue.gridPageToolBar.resync = function (gridId, toolBarId) {
		resync_old(gridId, toolBarId);
		rowAction.set_state_action();
	};
	 
	selectAll_old = Prologue.grid.selectAll;
	Prologue.grid.selectAll = function (grid) {
		selectAll_old(grid);
		rowAction.set_state_action();
	};
	
	var unselect_old = Prologue.grid.unselect;
	Prologue.grid.unselect = function (grid) {
		unselect_old(grid);
		rowAction.set_state_action();
	};
	
	var rowOnClick_old = Prologue.grid.rowOnClick;
	Prologue.grid.rowOnClick = function (tr) {
		rowOnClick_old(tr);
		rowAction.set_state_action();
	};
	
/*	
	function getMultiSelected(grid_id) {
		list = '';
		var sels = Prologue.grid.getSelected(grid_id);
		for(var i = 0; i < sels.length; ++i) {
			var sel = sels[i];
			if(sel.index == -1)
				break;
			params = eval('('+sel.value+')');
			list += ((list.length == 0)? params.SUI_NUMERO: '_'+params.SUI_NUMERO);
		}
		return (list.length > 0);
	};
	*/
};

// Vérification du niveau de complexité du password pwd
// le résultat est affiché dans res
// la fonction retourne le niveau de 0 à 3
function ComplexitePwd(pwd, res)
{
	var niv = 0;
	if(pwd)
	{
		if(pwd.match('^[a-zA-Z0-9@$#!%]+$'))
		{
			if(pwd.match('[a-z]+') && pwd.match('[A-Z]+') && (pwd.match('[0-9]+') && pwd.match('[@$#!%]+')))
			{
				res.value = lang_password_forte;
				res.style['color'] = 'limegreen';
				niv = 3;
			}
			else if(pwd.match('[a-zA-Z]+') && (pwd.match('[0-9]+') || pwd.match('[@$#!%]+')))
			{
				res.value = lang_password_moyenne;
				res.style['color'] = 'green';
				niv = 2;
			}
			else
			{
				res.value = lang_password_faible;
				res.style['color'] = 'maroon';
				niv = 1;
			}
		}
		else
		{
			res.value = lang_password_nonconforme;
			res.style['color'] = 'red';
		}
	}
	else
		res.value = '';
		
	return niv;
}
