Raphael.fn.connexion = function (obj1, obj2, line, type)
{
    if (obj1.line && obj1.from && obj1.to)
	{
        line = obj1;
        obj1 = line.from;
        obj2 = line.to;
    }
    var bb1 = obj1.getBBox(),
        bb2 = obj2.getBBox(),
        p = [{x: bb1.x + bb1.width / 2, y: bb1.y - 1},
        {x: bb1.x + bb1.width / 2, y: bb1.y + bb1.height + 1},
        {x: bb1.x - 1, y: bb1.y + bb1.height / 2},
        {x: bb1.x + bb1.width + 1, y: bb1.y + bb1.height / 2},
        {x: bb2.x + bb2.width / 2, y: bb2.y - 1},
        {x: bb2.x + bb2.width / 2, y: bb2.y + bb2.height + 1},
        {x: bb2.x - 1, y: bb2.y + bb2.height / 2},
        {x: bb2.x + bb2.width + 1, y: bb2.y + bb2.height / 2}],
        d = {}, dis = [];

	var angle = Math.atan2(bb1.y-bb2.y, bb2.x-bb1.x) * (180/Math.PI);

    for (var i = 0; i < 4; i++)
	{
        for (var j = 4; j < 8; j++)
		{
            var dx = Math.abs(p[i].x - p[j].x),
                dy = Math.abs(p[i].y - p[j].y);
            if ((i == j - 4) || (((i != 3 && j != 6) || p[i].x < p[j].x) && ((i != 2 && j != 7) || p[i].x > p[j].x) && ((i != 0 && j != 5) || p[i].y > p[j].y) && ((i != 1 && j != 4) || p[i].y < p[j].y)))
			{
                dis.push(dx + dy);
                d[dis[dis.length - 1]] = [i, j];
            }
        }
    }
    if (dis.length == 0)
	{
        var res = [0, 4];
    }
	else
	{
        res = d[Math.min.apply(Math, dis)];
    }
    var x1 = p[res[0]].x,
        y1 = p[res[0]].y,
        x4 = p[res[1]].x,
        y4 = p[res[1]].y;
    dx = Math.max(Math.abs(x1 - x4) / 2, 10);
    dy = Math.max(Math.abs(y1 - y4) / 2, 10);
    var x2 = [x1, x1, x1 - dx, x1 + dx][res[0]].toFixed(3),
        y2 = [y1 - dy, y1 + dy, y1, y1][res[0]].toFixed(3),
        x3 = [0, 0, 0, 0, x4, x4, x4 - dx, x4 + dx][res[1]].toFixed(3),
        y3 = [0, 0, 0, 0, y1 + dy, y1 - dy, y4, y4][res[1]].toFixed(3);
		
	var path = ["M", x1.toFixed(3), y1.toFixed(3), "C", x2, y2, x3, y3, x4.toFixed(3), y4.toFixed(3)].join(" ");
	
	var x = x4;
	var y = y4;
	
	var radius = 6;
	var centerX = x - radius * Math.cos(angle*(Math.PI/180));
	var centerY = y + radius * Math.sin(angle*(Math.PI/180));
	var topX = x;
	var topY = y;
	var leftX = centerX + radius * Math.cos((angle+120)*(Math.PI/180));
	var leftY = centerY - radius * Math.sin((angle+120)*(Math.PI/180));
	var rightX = centerX + radius * Math.cos((angle+240)*(Math.PI/180));
	var rightY = centerY - radius * Math.sin((angle+240)*(Math.PI/180));
	
	var arrowPath = ["M", topX, topY, "L", leftX, leftY, "L", centerX, centerY, "L", rightX, rightY, "L", topX, topY].join(" ");
		
	if (line && line.line)
	{
        line.line.attr({path: path});
		line.arrow.attr({path: arrowPath});
    }
	else
	{
        var color = typeof line == "string" ? line : "#000";
		if(type==undefined)
			type="";
        return {arrow: this.path(arrowPath).attr({stroke: color, fill: color, "stroke-dasharray": ""}), line: this.path(path).attr({stroke: color, fill: "none", "stroke-dasharray": type}), from: obj1, to: obj2};
    }
};

var Connexions = [];
var ImageSize = 12;
var yText = 25;
var xText = 5;
var rectHeight = 50;

Raphael.fn.Activite = function(x, y, lib, img, text, moteurTxt, color, afx_id)
{
	var width = ImageSize + Math.max(lib.length, text.length)*7;
	
	var rect = this.rect(x, y, width, rectHeight, 10);

	var title = this.text(x + width/2, y + 8, lib);
	title.attr({"text-anchor": "middle"});
	
	var desc = null;
	if(text)
	{
		desc = this.text(x + xText, y + yText, text);
		desc.attr({"text-anchor": "start"});
	}
	
	var line = this.path("M "+x+" "+(y+15)+" L "+(x+width)+" "+(y+15));
	var image = null;
	if(img)
		image = this.image(img, x+5, y+2, ImageSize, ImageSize);
		
	var start = function ()
	{
		rect.ox = rect.attr("x");
		rect.oy = rect.attr("y");
		
		rect.animate({"fill-opacity": .8}, 200);
	};
		
	var move = function (dx, dy)
	{
		rect.attr({x: rect.ox + dx, y: rect.oy + dy});
		if(image!=null)
			image.attr({x: rect.ox+5 + dx, y: rect.oy+2 + dy});
		title.attr({x: rect.ox + width/2 + dx, y: rect.oy + 8 + dy});
		line.attr({path: "M"+(rect.ox+dx)+" "+(rect.oy+dy+15)+"L"+(rect.ox+dx+width)+" "+(rect.oy+dy+15)});
		if(desc!=null)
			desc.attr({x: rect.ox + xText + dx, y: rect.oy + yText + dy});
			
		moteur.attr({x: rect.ox + width/2 - moteurTxt.length + dx, y: rect.oy + yText + 16 + dy});
		
		for (var i = Connexions.length; i--;)
			this.paper.connexion(Connexions[i]);

		this.paper.safari();
	};
	  
	var up = function ()
	{
		rect.animate({"fill-opacity": 0}, 200);
	};
	
	var dblclick = function(event)
	{
		window.parent.prlTabStrip.setSelected("tab_gest_flux", 1);
		window.parent.Prologue.treeView.selectNodeByValue('act_tree', afx_id);
	};

	rect.attr({fill: color, stroke: "#000", "fill-opacity": 0, "stroke-width": 1});
	
	var moteur = this.text(x + width/2 - moteurTxt.length, y + yText + 16, "#"+moteurTxt);
	moteur.attr({"text-anchor": "start"});
	moteur.attr({"font-weight": "bold"});
	moteur.attr({"fill": "white"});
	
	var s = this.set(rect, image, title, line, desc, moteur);
		
	s.attr({cursor: "pointer"});
	s.drag(move, start, up);
	s.dblclick(dblclick);
	
	return s;
};

var paper = null;
var datasource = null;
var maxY = 0;
var orgW = 0;
var orgH = 0;
var gapX = 40;
var gapY = 100;
var zoom_level;

function init_schema(ds)
{
	zoom_level = 1;

	datasource = ds;
	
	var colorLine = '#640';

	var req = new Prologue.ajax.request(ds);
	req.send();
	var resp = req.getXML();
	var xRoot = resp.documentElement;
	
	var minWidth = xRoot.attributes.getNamedItem('width').value * 100;
	var minHeight = (xRoot.attributes.getNamedItem('height').value * rectHeight) + (gapY * 2);
	
	if(paper==null)
		paper = Raphael('schema_grid', minWidth, minHeight);
	else
		paper.clear();
		
	var x = 10;
	var y = 10;
	
	var shapes = [];
	var precShape = null;
	var lastTrait = null;
	for (var i=0; i<xRoot.childNodes.length && i<5; i++) // on ne gre pas le rapprochement
	{
		var xNode = xRoot.childNodes[i];
		var stepX = 0;
		var lastShape = null;
		for (var n=0; n<xNode.childNodes.length; n++)
		{
			var xAct = xNode.childNodes[n];
			var actTitle = xAct.attributes.getNamedItem('caption').value;
			
			var color = "90-#00f-#fff";
			if(xAct.attributes.getNamedItem('actif').value==false)
				color = "90-#f00-#fff";
			//else if(i==5) // rapprochement
				//color = "90-#0ff-#fff";

			lastShape = paper.Activite(x, y, actTitle, xAct.attributes.getNamedItem('icon').value, xAct.attributes.getNamedItem('param').value, xAct.attributes.getNamedItem('moteur').value, color, xAct.attributes.getNamedItem('afx_id').value);
			shapes.push(lastShape);
			var newStep = actTitle.length*7 + gapX;
			if(xAct.childNodes.length>0) // activit de backup
			{
				var xBck = xAct.childNodes[0];
				
				var bColor = "90-#00f-#fff";
				if(xBck.attributes.getNamedItem('actif').value==false)
					bColor = "90-#f00-#fff";
				
				var bckShape = paper.Activite(x + newStep, y, xBck.attributes.getNamedItem('caption').value, xBck.attributes.getNamedItem('icon').value, xBck.attributes.getNamedItem('param').value, xBck.attributes.getNamedItem('moteur').value, bColor, xBck.attributes.getNamedItem('afx_id').value);
				shapes.push(bckShape);
				Connexions.push(paper.connexion(lastShape, bckShape, colorLine, '- '));
			}
			else if(i<4)
				lastTrait = lastShape;
				
			y += gapY;
			stepX = (newStep > stepX ? newStep : stepX);

			if(i>3) // = prsentation
			{
				if(xRoot.attributes.getNamedItem('block').value=='false') // non bloquante
					Connexions.push(paper.connexion(lastTrait, lastShape, colorLine));
				else
					Connexions.push(paper.connexion(precShape, lastShape, colorLine));
			}
			else if(precShape!=null)
			{
				Connexions.push(paper.connexion(precShape, shapes[shapes.length-1], colorLine));
			}
			precShape = lastShape;
		}
		x += stepX;
		if(y>maxY)
			maxY = y;
		y = 10;
	}

	orgW = x + gapX;
	orgH = maxY + gapY;

	paper.setSize(Math.max(orgW, document.body.clientWidth - gapX), Math.max(orgH, document.body.clientHeight - gapY));
}

function schema_reload()
{
	Connexions = [];
	maxY = 0;
	if(datasource!=null)
		init_schema(datasource);
}

function schema_zoom(zoom_in)
{
	if(paper==null)
		return;
		
	if(zoom_in==true)
		zoom_level += 0.1;
	else
		zoom_level -= 0.1;

	if(paper.canvas.nodeName=="svg") // pour FF, Chrome, ...
	{
		var svg = document.getElementById('schema_grid').firstChild;
		for(var i=0; i<svg.childNodes.length; i++)
			svg.childNodes[i].setAttribute("transform" , "matrix("+zoom_level+" 0 0 "+zoom_level+" 10 10)");
			
		var w = (orgW+ 4*gapX) * zoom_level;
		var h = orgH * zoom_level;
		paper.setSize(Math.max(w, document.body.clientWidth - gapX), Math.max(h, document.body.clientHeight - gapY));
	}
	else // pour IE
	{
		paper.canvas.style.zoom = zoom_level;
	}
}