<?php
function UserPreferencesRead($screenName) {
	function readPrefFile($fileName, $screenName, &$pref) {
		if (!$xDoc = @domxml_open_file($fileName,DOMXML_LOAD_DONT_KEEP_BLANKS))
			return false;
		$xCtx = $xDoc->xpath_new_context();
		$xRes = xpath_eval($xCtx,'//preferences/'.$screenName);
		if (isset($xRes->nodeset[0])) {
			$pref = '';
			$xScreen = $xRes->nodeset[0];
			foreach($xScreen->child_nodes() as $xField) {
				$pref[$xField->tagname()] = $xField->get_content();
			}
			return true;
		}
	}	
	$pref = array();
	if (isset($_SESSION['CPT_ID'])) {
		$login = $_SESSION['CPT_ID'];
		if (!readPrefFile("$login.pref", $screenName, $pref))
			readPrefFile("allUser.pref", $screenName, $pref);
	}
	return $pref;
}
function UserPreferencesSave($screenName, $pref) {
	$fileName = $_SESSION['CPT_ID'].'.pref';
	if (!$xDoc = @domxml_open_file($fileName,DOMXML_LOAD_DONT_KEEP_BLANKS)) {
		$xDoc = domxml_new_doc('1.0');
		$xRoot = $xDoc->add_root("preferences");
	}
	else
		$xRoot = $xDoc->document_element();
	
	$xCtx = $xDoc->xpath_new_context();
	$xRes = xpath_eval($xCtx,'//preferences/'.$screenName);
	if (isset($xRes->nodeset[0])) {
		$xScreen = $xRes->nodeset[0];
		$xRoot->remove_child($xScreen);
	}
	$xScreen = $xDoc->create_element($screenName);
	foreach($pref as $key => $value) {
		$xPref = $xDoc->create_element($key);
		$xPref->set_content($value);
		$xScreen->append_child($xPref);
	}
	$xRoot->append_child($xScreen);	
	$xDoc->dump_file($fileName, false, true);		
}
?>