<?php
require_once($DEFAULT_PATH."framework/mySql_Datasource.php");
require_once($DEFAULT_PATH."param.php");

/* Obsolète
function low_disp($nom) {
	return htmlspecialchars(utf8_decode($nom));
}
*/

/**
 * ajoute des caractères d'échappement avant les " et les ' si nécessaire pour des chaînes UTF-8
 *
 * @param {string} $str la chaîne à modifier en UTF-8
 * @return {string} la chaîne modifiée en UTF-8
 */
/* Obsolète
function utf8_strClean ($str)
{
	return utf8_encode(strClean(utf8_decode($str)));
}
*/
/*
function dblQ($chaine)
{
   $ret = str_replace("\\","\\\\", str_replace("'","''",$chaine));
   return $ret;
}
*/
/**
* formate une date type MySQL au format strftime donné (DD/MM/YYYY HH:MM:SS par défaut)
*
* @param {string} $SqlDate chaîne contenant la date MySQL
* @return {string} chaîne modifiée
*/
function sql2Date($SqlDate, $format="%d/%m/%Y %H:%M:%S")
{
	set_default_time_zone();
	return strftime($format, strtotime($SqlDate));
}

/**
* formate une date type DD/MM/YYYY en type MySQL
* /!\ attention ce n'est pas exactement la réciproque de sql2Date (ne gère pas HH:MM)  
*
* @param {string} $date chaîne contenant la date
* @return {string} chaîne modifiée au format MySQL
*/
function date2Sql($date, $heure="00:00:00")
{
	$mysql_format = "%Y-%m-%d %H:%M:%S";
	$tokenslash = explode('/', $date);
	$date = $tokenslash[1]."/".$tokenslash[0]."/".$tokenslash[2];
	return strftime($mysql_format, strtotime("$date $heure"));
}

/**
* calcule la date d'aujourd'hui moins un nombre de jours
*
* @param {string} $ecart nombre de jours à soustraire
* @return {string} chaîne contenant la date calculée (format DD/MM/YYYY)
*/
function getDateDefault($ecart)
{
	return date('d/m/Y', mktime(0, 0, 0, date("m"), date("d"), date("Y")) - ($ecart));
}

function encode_JSON($array)
{		
	$ret = '{';
	$is_first = true;

	foreach($array as $key => $value)
	{
		if(!$is_first)
			$ret .= ',';
		else
			$is_first = false;
		
		$ret .= "'$key':";

		if(is_null($value))
			$ret .= 'null';
		elseif(is_bool($value))
			$ret .= ($value)?'true':'false';
		elseif(is_int($value) || is_float($value))
			$ret .= $value;
		elseif(is_array($value))
			$ret .= encode_JSON($value);
		elseif(is_string($value)) {
			$value = utf8_decode($value);
			$tmp = str_replace(array('<', '>', '"'), array('\<', '\>', '\"'), $value);
			$ret .= "'".hi_disp($tmp)."'";
		}
		else
			$ret .= "''";
	}
	$ret .= '}';
	return $ret;
}


function row_encode_JSON($array)
{
	$ret = '{';
	$first = true;

	foreach($array as $key => $value)
	{
		if (is_string($key)) {
			if ($first)
				$first=false;
			else
				$ret .= ',';
			
			$ret .= "'$key':";
	
			if(is_null($value))
				$ret .= 'null';
			elseif(is_bool($value))
				$ret .= ($value)?'true':'false';
			elseif(is_int($value) || is_float($value))
				$ret .= $value;
			elseif(is_array($value))
				$ret .= row_encode_JSON($value);
			elseif(is_string($value)) {
				$value = utf8_decode($value);
				$tmp = str_replace(array('<', '>', '"'), array('\<', '\>', '\"'), $value);
				$ret .= "'".hi_disp($tmp)."'";
			}
			else
				$ret .= "''";
		}
	}
	$ret .= '}';
	return $ret;
}

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");

function mkFiltre(&$vtp, &$form, &$array)
{
	$vtp->addSession($form, "filtre_list");
	
	foreach($array as $filtre)
	{
		$vtp->addSession($form, "filtre_field");
				
		if (isset($filtre['id_filtre']) && $filtre['id_filtre'] == 'new_line')
		{
			$vtp->addSession($form, "new_line_filtre");
			$vtp->closeSession($form, "new_line_filtre");
		}
		else
		{
			
			$vtp->addSession($form, "filtre");
			
			$vtp->setVar($form, "filtre.id_filtre", (isset($filtre['type_filtre'])? $filtre['id_filtre'] : ""));
			$vtp->setVar($form, "filtre.type_filtre", (isset($filtre['type_filtre'])? $filtre['type_filtre'] : ""));
			$vtp->setVar($form, "filtre.libelle_filtre", (isset($filtre['libelle_filtre'])? addslashes($filtre['libelle_filtre']) : ""));	
			$vtp->setVar($form, "filtre.value_filtre", (isset($filtre['value_filtre'])? $filtre['value_filtre'] : ""));
				
			if(isset($filtre['ds_filtre']))
			{
				$vtp->addSession($form, "filtre_datasource");
				$vtp->setVar($form, "filtre_datasource.ds_filtre", $filtre['ds_filtre']);
				$vtp->closeSession($form, "filtre_datasource");
			}
			
			if(isset($filtre['format_filtre']))
			{
				$vtp->addSession($form, "filtre_format");
				$vtp->setVar($form, "filtre_format.format_filtre", $filtre['format_filtre']);
				$vtp->closeSession($form, "filtre_format");
			}
				
			if(isset($filtre['dd_height_filtre']) && isset($filtre['dd_width_filtre']))
			{
				$vtp->addSession($form, "filtre_dd_dimension");
				$vtp->setVar($form, "filtre_dd_dimension.dd_height_filtre", $filtre['dd_height_filtre']);
				$vtp->setVar($form, "filtre_dd_dimension.dd_width_filtre", $filtre['dd_width_filtre']);
				$vtp->closeSession($form, "filtre_dd_dimension");
			}

			if(isset($filtre['loadondropdown_filtre']))
			{
				$vtp->addSession($form, "filtre_loadondropdown");
				$vtp->setVar($form, "filtre_loadondropdown.loadondropdown_filtre", $filtre['loadondropdown_filtre']);
				$vtp->closeSession($form, "filtre_loadondropdown");
			}
			
			if(isset($filtre['editable_filtre']))
			{
				$vtp->addSession($form, "filtre_editable");
				$vtp->setVar($form, "filtre_editable.editable_filtre", $filtre['editable_filtre']);
				$vtp->closeSession($form, "filtre_editable");
			}
			
			if(isset($filtre['defaultcaption_filtre']))
			{
				$vtp->addSession($form, "filtre_defaultcaption");
				$vtp->setVar($form, "filtre_defaultcaption.defaultcaption_filtre", $filtre['defaultcaption_filtre']);
				$vtp->closeSession($form, "filtre_defaultcaption");
			}
			
			if(isset($filtre['ds_patern']))
			{
				$vtp->addSession($form, "filtre_patern");
				$vtp->setVar($form, "filtre_patern.ds_patern", $filtre['ds_patern']);
				$vtp->closeSession($form, "filtre_patern");
			}
			
			if(isset($filtre['ds_valpatern']))
			{
				$vtp->addSession($form, "filtre_valpatern");
				$vtp->setVar($form, "filtre_valpatern.ds_valpatern", $filtre['ds_valpatern']);
				$vtp->closeSession($form, "filtre_valpatern");
			}

			$vtp->closeSession($form, "filtre");
		}
		$vtp->closeSession($form, "filtre_field");
	}
}

function mkPopupMenu(&$vtp, &$form, $array)
{
	global $body_js;
	
	$sep = false;
	$popMenu = 'var menu = new PopupMenu();
	';
	foreach($array as $opt)
	{
		if(isset($opt['caption']) && $opt['caption'] != '')
		{
			if(isset($opt['action']))
			{
				if($sep)
				{
					$popMenu .= "menu.addSeparator();
					";
					$sep = false;
				}
				$name = $opt['action']['name'];
				$popMenu .= "var ${name}_Enabled = function () { return rowAction.actions['$name'].isActivated;};
				";
				$popMenu .= "menu.add('${opt['icon']}', '${opt['caption']}', ${name}_Enabled, function() { if(${name}_Enabled()) rowAction.exec('$name') });
				";
			}
		}
		else if(isset($opt['value']) && $opt['value'] == '__SEPARATOR__')
			$sep = true;
	}
	
	if(isset($array["detail"]) && $array["detail"]==true)
	{
		$popMenu .= "menu.addSeparator();";
		$icon = 'Prologue.gridPageToolBar.images.detail.toString()';
		$cmd = "function () {Prologue.gridPageToolBar.doAction(rowAction.grid_id, Prologue.gridPageToolBar.action.detail, 'grid_toolbar');}";
		$popMenu .= "menu.add($icon, lang_gridPageToolBar_lbl_detail, function() { return true; }, $cmd);
		";
	}
		
	$popMenu .= "menu.bind($(rowAction.grid_id).parentElement, true);
	";

	$vtp->insertVar($form, "global.body_javascript", $popMenu);
}

function mkToolbar(&$vtp, &$form, &$array)
{
	global $bottom_navigate;
	if ($bottom_navigate)
	{
		$vtp->addSession($form, "option_bottom_navigate");
		$vtp->closeSession($form, "option_bottom_navigate");
	}
	else
	{
		$vtp->addSession($form, "option_top_navigate");
		$vtp->closeSession($form, "option_top_navigate");
	}
	foreach($array as $key => $value) {
		if (is_numeric($key)) {
			$onClick = "";
			
			if(isset($value['action'])) {
				$name = (isset($value['action']['name'])? $value['action']['name']: "");
				$page = (isset($value['action']['page'])? $value['action']['page']: "");
				$callback = (isset($value['action']['callback'])? $value['action']['callback']: "");
				$get_params = (isset($value['action']['get_params'])? $value['action']['get_params']: "");
				$params = "";
				if(is_array($get_params)) {
					foreach($get_params as $param)
						$params .= ((empty($params))? "'$param'": ",'$param'");
					$get_params = "[$params]";
				}
				$vtp->addSession($form, "row_action_def");
				$vtp->setVar($form, "row_action_def.name", $name);
				$vtp->setVar($form, "row_action_def.page", $page);
				$vtp->setVar($form, "row_action_def.callback", $callback);
				$vtp->setVar($form, "row_action_def.get_params", $get_params);
				$vtp->closeSession($form, "row_action_def");
				
				$onClick = "rowAction.exec(\'$name\');";
				if(!isset($value['value']))
					$value['value'] = $name;
			}
			
			$vtp->addSession($form, "option_toolbar");
			$vtp->setVar($form, "option_toolbar.caption", (isset($value['caption'])? $value['caption'] : ""));
			$vtp->setVar($form, "option_toolbar.icon", (isset($value['icon'])? $value['icon'] : ""));
			
			$onClick .= (isset($value['onClick'])? $value['onClick']: "");
			$vtp->setVar($form, "option_toolbar.onClick", $onClick);
			
			$vtp->setVar($form, "option_toolbar.value", (isset($value['value'])? $value['value'] : ""));
			$vtp->closeSession($form, "option_toolbar");
		}
		else {
			switch ($key) {
				case 'select':
					$vtp->addSession($form, "selection_toolbar");
					$vtp->setVar($form, "selection_toolbar.selection", ($value?"true": "false"));
					$vtp->closeSession($form, "selection_toolbar");
					break;
				case 'detail':
					$vtp->addSession($form, "detail_toolbar");
					$vtp->setVar($form, "detail_toolbar.selection", ($value?"true": "false"));
					$vtp->closeSession($form, "detail_toolbar");
					break;
				case 'print':
					$vtp->addSession($form, "print_toolbar");
					$vtp->setVar($form, "print_toolbar.show", (isset($value['show'])?($value['show']?"true": "false"):"false"));
					$vtp->setVar($form, "print_toolbar.title", (isset($value['title'])?$value['title']:""));
					$vtp->closeSession($form, "print_toolbar");
					break;
				case 'csv':
					$vtp->addSession($form, "csv_toolbar");
					$vtp->setVar($form, "csv_toolbar.selection", ($value?"true": "false"));
					$vtp->closeSession($form, "csv_toolbar");
					break;
				case 'goBack':
					$vtp->addSession($form, "goback_toolbar");
					$vtp->setVar($form, "goback_toolbar.selection", ($value?"true": "false"));
					$vtp->closeSession($form, "goback_toolbar");
					break;
			}
		}
	}
	
	mkPopupMenu($vtp, $form, $array);
}

function mkDS(&$req, $pageNum, $pageSize)
{
	global $adrBase;
	global $portBase;
	global $loginBase;
	global $pwdBase;
	global $nomBase;
	
	$ds = new dbDataSource();
	$ds->dbServer = $adrBase;
	$ds->dbPort = $portBase;
	$ds->dbLogin = $loginBase;
	$ds->dbPassword = $pwdBase;
	$ds->dbName = $nomBase;
	$ds->encoding = 'UTF-8';

	$ds->pageSize = (isset($pageSize) ? $pageSize : 0);
	$ds->pageNum = (isset($pageNum) ? $pageNum : 1);
	$buffer = '';
	$ds->read($req, $buffer);
	return $buffer;
}

/*
 * Les fonctions suivantes permettent de manipuler les chaînes provenant
 * ou à destination de la base, notamment au niveau de l'encodage.
 * 
 * On a 2 schémas possibles sachant que:
 * - les chaînes provenant de la base peuvent être soit en ISO-8859-1, soit en UTF-8,
 * - les chaînes au niveau de l'interface sont toujours en UTF-8,
 * - les fonctions PHP effectuant des traitement sur chaînes (urlencode(), htmlspecialchars(), etc...)
 *   ne doivent pas être appliquées sur des chaînes Unicode(UTF-8).
 *   Il faut donc soit convertir les chaînes en ISO, ensuite leur appliquer les traitements
 *   et enfin les réencoder en UTF-8, soit utiliser les fonctions fournies par les modules PHP "iconv" et/ou "mbstring".
 * 
 * 1er cas : (BASE en ISO-8869-1)
 * - Il faut convertir chaque chaîne provenant de la base de l'ISO vers l'UTF-8 pour l'interface,
 * - Il faut convertir chaque chaîne provenant de l'interface de l'UTF-8 vers l'ISO pour la base.
 * 
 * 2e cas : (BASE en UTF-8)
 * - Aucune conversion n'est directement nécessaire
 *   sauf pour appliquer des fonctions PHP de traitement de chaînes.
 * 
 * Pour connaître l'encodage de la base, on se fit à la fonction isUTF8().
 * 
 * Débuggage : lorsqu'une chaîne n'est pas dans l'encodage adéquat des caractères spéciaux
 * apparaissent à la place des diacritiques. Pour l'interface on peut observer que :
 * - si ce sont des "?", en général c'est une chaîne ISO (non convertie donc) qui affichée sur l'interface,
 * - si ce sont des "Ã©", en général c'est une chaîne UTF-8 que l'on a tenté d'encoder en UTF-8 une deuxième fois,
 *   ou bien cela peut provenir d'une chaîne UTF-8 à laquelle on a appliqué une fonction PHP
 *   de traitement de chaîne (urlencode(), etc..) sans l'avoir décodée au préalable.
 */

/*
 * Détermine si la chaîne est en UTF-8
 * 
 * @param {string} $string la chaîne à vérifier
 * @return {bool} 'true' si la chaîne est en UTF-8 
 */
function isUTF8($string)
{
	return (utf8_encode(utf8_decode($string)) == $string);
}

/*
 * Selon la config de la base flow (SQL_UNICODE = true => Base en UTF-8),
 * traite une chaîne provenant de la base pour l'afficher en UTF-8
 * 
 * @param {string} $str la chaîne à traiter provenant de la base
 * @return {string} la chaîne modifiée
 */
function hi_disp($str) {
	//if(SQL_UNICODE)
	if(isUTF8($str))
		$str = utf8_decode($str);
	return utf8_encode(htmlspecialchars($str, ENT_COMPAT | ENT_HTML401, 'ISO-8859-1'));
}

/*
 * Selon la config de la base flow (SQL_UNICODE = true => Base en UTF-8),
 * traite une chaîne que l'on veut sauvegarder dans la base pour quelle soit
 * ou non en UTF-8
 * 
 * @param {string} $str la chaîne à traiter à sauver en base
 * @return {string} la chaîne modifiée
 */
function sql_disp($str) {
	//return (!SQL_UNICODE? utf8_decode($str): $str);	
	return (isUTF8($str)? utf8_decode($str): $str);
}

/*
 * Selon la config de la base flow (SQL_UNICODE = true => Base en UTF-8),
 * traite une chaîne que l'on veut sauvegarder dans la base pour quelle soit
 * ou non en UTF-8 en lui appliquant la fonction dblQ()
 * 
 * @param {string} $str la chaîne à traiter à sauver en base
 * @return {string} la chaîne modifiée et traitée avec dblQ()
 */
function sql_disp_dblQ($str) {
	//return (!SQL_UNICODE? dblQ(utf8_decode($str)): utf8_encode(dblQ(utf8_decode($str))));	
	return (isUTF8($str)? dblQ(utf8_decode($str)): dblQ($str));	
}

/*
 * Selon la config de la base flow (SQL_UNICODE = true => Base en UTF-8),
 * traite une chaîne provenant de la base pour l'afficher en UTF-8
 * en lui appliquant urlencode()
 * 
 * @param {string} $str la chaîne à traiter provenant de la base
 * @return {string} la chaîne modifiée et traitée avec urlencode()
 */
function hi_disp_urlencode($str) {
	//if(SQL_UNICODE)
	if(isUTF8($str))
		$str = utf8_decode($str);
	return utf8_encode(urlencode($str));
}

/**
* encode un string URL avec un charset UTF-8
*
* @param {string} $str la chaîne à modifier en UTF-8
* @return {string} la chaîne modifiée en UTF-8
*/
function utf8_urlencode ($str)
{
	if(isUTF8($str))
		$str = utf8_decode($str);
	return utf8_encode(urlencode($str));
}

/**
* ajoute des caractères d'échappement avant les " et les ' si nécessaire
*
* @param {string} $str la chaîne à modifier
* @return {string} la chaîne modifiée
*/
function strClean ($str) {
	//if(SQL_UNICODE)
	if(isUTF8($str))
		$str = utf8_decode($str);
	return utf8_encode(preg_replace("/((?<!\\\)['\"\\\])/", "\\\\$1" , $str));
}

function trouve_fils($ID)
{
	global $gDb;
	global $fils;
	global $cltID;
	$query = "SELECT PAR_ID, PAR_TYPE
			FROM PART WHERE GRP_ID = $ID 
			AND CLT_ID = $cltID  
			and PAR_ETAT != ".ETAT_SUPPR." order by PAR_NOM";
	$gDb->SQLQuery($query, 1);
	$nb = 0;
	 
	while ($res = $gDb->SQLNextRow(1))
	{
		if ($fils)
		$fils .= ", ".$res['PAR_ID'];
		else $fils .= $res['PAR_ID'];
		if ($res['PAR_TYPE'] == 1)
		{
			$tableauFils[$nb] = $res['PAR_ID'];
			$nb++;
		}
	}

	for($i = 0; $i < $nb; $i++) trouve_fils($tableauFils[$i]);
}

function set_default_time_zone()
{
    if (version_compare(PHP_VERSION,'5.1','>='))
    {
        $ini_timezone = ini_get('date.timezone');
        if ($ini_timezone == "")
        {
            $ini_timezone = 'Europe/Paris';
        } 
        date_default_timezone_set($ini_timezone);
    }
}

set_default_time_zone();

function getStrategiePwd($niv)
{
	global $lang_password_faible, $lang_password_moyenne, $lang_password_forte, $lang_password_libre;
	switch($niv)
	{
		case 1: return $lang_password_faible;
		case 2: return $lang_password_moyenne;
		case 3: return $lang_password_forte;
	}
	return $lang_password_libre;
}

/**
* vérifie la présence d'un type d'activité dans la base à partir de son TAC_NUM
*
* @param {string} $TACNum numéro du type d'activité (TAC_NUM)
* @return {boolean}
*/
function isTACPresent ($TACNum)
{
	global $gDb;
	$req = "SELECT TAC_NUM
			FROM TYPE_ACT
			WHERE TAC_NUM = ".$TACNum;
	
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	return ($row['TAC_NUM'] == $TACNum);
}
?>
