<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once ($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."vtemplate.class.php");

$droitRole = (droit(CTA, "xor", null, null, null, null)? CTA: CMA);
$lmcse = DROIT_LECT;
$page_courante = "suivi/alertes/sui_alt_actDetail.php";


$alt_id	= pget('alt_id');

$vtp = new VTemplate;
$form = $vtp->Open("sui_alt_actDetail.vtp");

$vtp->addSession($form, "gest");

$req = "SELECT ALT_LIBEL, ALT_ETAT, ALT_DEST_ID, AFX_ID, ALT_DATE, ALT_DEST_ID, ALT_DESTCC_ID, 
			ALT_NIVEAU, ALT_ERREUR, ALT_TXTERREUR, ALT_TXTDETAIL, SUI_ID, ALT_SUIVI, ALT_DIAGNOSTIC 
		FROM ALERTE  
		WHERE ALT_ID = '$alt_id'";

$gDb->SQLQuery($req,1);
$row = $gDb->SQLNextRow(1);

$vtp->setVar($form, "gest.alt_libel", hi_disp($row['ALT_LIBEL']));

switch($row['ALT_ETAT'])
{
	case ALT_ETAT_ATTENTE :
		$alt_etat = $lang_sui_alt_act_detail_lbl_etatalt_act;
		break;
	case ALT_ETAT_VISU :
		$alt_etat = $lang_sui_alt_act_detail_lbl_etatalt_inact;
		break;
	case ALT_ETAT_ARCHIVE :
		$alt_etat = $lang_sui_alt_act_detail_lbl_etatalt_cloture;
		break;
	default :
		$alt_etat = $lang_sui_alt_act_detail_lbl_etatalt_indeter;
}
$vtp->setVar($form, "gest.alt_etat", $alt_etat);

$req = "SELECT UTR_NOM, UTR_PRENOM 
 		FROM UTILISATEUR 
		WHERE UTR_ID = ".$row['ALT_DEST_ID'];
$gDb->SQLQuery($req, 2);
$row2 = $gDb->SQLNextRow(2);
$vtp->setVar($form, "gest.alt_dest", hi_disp($row2['UTR_NOM'])." ".hi_disp($row2['UTR_PRENOM']));
$gDb->SQLFermeQuery(2);

if ($row['ALT_DESTCC_ID'])
{
	$req = "SELECT UTR_NOM, UTR_PRENOM 
	 		FROM UTILISATEUR 
			WHERE UTR_ID = ".$row['ALT_DESTCC_ID'];
	$gDb->SQLQuery($req, 2);
	$row2 = $gDb->SQLNextRow(2);
	$vtp->setVar($form, "gest.alt_destcc", 	hi_disp($row2['UTR_NOM'])." ".hi_disp($row2['UTR_PRENOM']));
	$gDb->SQLFermeQuery(2);
}
else
	$vtp->setVar($form, "gest.alt_destcc", 	"&nbsp;");

$vtp->setVar($form, "gest.alt_date", sql2Date($row['ALT_DATE']));

$req = "SELECT AFX_LIBEL 
		FROM ACTFLUX 
		WHERE AFX_ID = ".$row['AFX_ID'];
$gDb->SQLQuery($req, 2);
$row2 = $gDb->SQLNextRow(2);
$vtp->setVar($form, "gest.afx_libel", 	hi_disp($row2['AFX_LIBEL']));
$gDb->SQLFermeQuery(2);

switch ($row['ALT_NIVEAU']) {
	case ALT_NIV_AVERT:
		$vtp->setVar($form, "gest.alt_niveau", "Avertissement");
		break;
	case ALT_NIV_ERR:
		$vtp->setVar($form, "gest.alt_niveau", "Erreur");
		break;
	default:
		$vtp->setVar($form, "gest.alt_niveau", "&nbsp;");
		break;
}

$vtp->setVar($form, "gest.alt_txterreur", 	hi_disp($row['ALT_TXTERREUR']));
$vtp->setVar($form, "gest.alt_erreur", 		$row['ALT_ERREUR']);
$vtp->setVar($form, "gest.alt_txtdetail", 	hi_disp($row['ALT_TXTDETAIL']));

$suiviBtn = false;
if ($row["SUI_ID"])
{
	$req = "SELECT SUI_TYP_NUM, SUI_NUMERO, PAR_EMET_ID, PAR_DEST_ID, TDOC_ID 
			FROM SUIVI 
			WHERE SUI_ID = ".$row['SUI_ID'];
 	$gDb->SQLQuery($req,2);
	$row2 = $gDb->SQLNextRow(2);
	if (droit(HIS, DROIT_LECT + DROIT_MODIF + DROIT_EXEC,null,null,null,null) || 
		droit(SDO, DROIT_LECT + DROIT_MODIF + DROIT_EXEC,$row2['PAR_EMET_ID'],$row2['PAR_DEST_ID'], $row2['TDOC_ID'],null))
	{
		$url_suivi = $pathFlow."suivi/historique/sui_hist.php?suiTYPE=".$row2['SUI_TYP_NUM']."&numAlt=".$row['SUI_ID'];
		$suiviBtn = true; 	
	}
	$gDb->SQLFermeQuery(2);
}
else if ($row["ALT_SUIVI"])
{
	$type_suivi = explode(":", $row["ALT_SUIVI"]);
	switch($type_suivi[0])
	{
		case "RAPPROCH" :
			$val_suivi = explode(";", $type_suivi[1]);
			$url_suivi = $pathFlow."suivi/rapproch/sui_rap_actDetail.php";
			$nb_val_suivi = 0;
			foreach ($val_suivi as $val_s)
			{
				$vs = explode(",",$val_s);
				if ($nb_val_suivi == 0) $url_suivi .= "?".$vs[0]."=".$vs[1];
				else $url_suivi .= "&".$vs[0]."=".$vs[1];
				$nb_val_suivi++;
			}
			$suiviBtn = true;
			break;
	}
}

if ($suiviBtn)
{
	$vtp->addSession($form, "suivi");
	$vtp->setVar($form, "suivi.act_detail_lbl_suivi", $lang_sui_alt_act_detail_lbl_suivi);
	$vtp->setVar($form, "suivi.pathStyle", $pathStyle);
	$vtp->setVar($form, "suivi.link_suivi", $url_suivi);
	$vtp->closeSession($form, "suivi");
}

if ($row['ALT_ETAT'] == ALT_ETAT_ATTENTE)
{
	$req = "UPDATE ALERTE 
			SET ALT_ETAT = ".ALT_ETAT_VISU.",
			ALT_DATE_SUIVI =NOW() 
			WHERE ALT_ID = $alt_id";
	$gDb->SQLQuery($req, 2);
	$gDb->SQLFermeQuery(2);
}
$url_suppr = $pathFlow.'suivi/alertes/sui_alt_actSuppr.php?liste='.$alt_id;
$msg_suppr = addslashes(str_replace("%ALERTNAME%", hi_disp($row['ALT_LIBEL']), $lang_sui_alt_act_detail_question_suppr));
//$supprUrl = "if (confirm('$msg_suppr')){";
//$supprUrl .= " openPopUp(urldecode('".urlencode($url)."'));";
//$url = $pathFlow.'suivi/alertes/sui_alt.php';
//$supprUrl .= " changePage(urldecode('".urlencode($url)."'));}";

$vtp->setVar($form, "gest.supprMsg", $msg_suppr);
$vtp->setVar($form, "gest.supprUrl", $url_suppr);

$url_cloture = $pathFlow.'suivi/alertes/sui_alt_actCloture.php?liste='.$alt_id;
$msg_cloture = addslashes(str_replace("%ALERTNAME%", hi_disp($row['ALT_LIBEL']), $lang_sui_alt_act_detail_question_cloture));

$vtp->setVar($form, "gest.clotureMsg", addslashes(hi_disp($msg_cloture)));
$vtp->setVar($form, "gest.diagnosticErr", addslashes(hi_disp($lang_sui_alt_err_diagnostic)));
$vtp->setVar($form, "gest.clotureUrl", $url_cloture);

$gDb->SQLFermeQuery(1);

$vtp->setVar($form, "gest.title", $lang_sui_alt_title);
$vtp->setVar($form, "gest.alt_id", 		$alt_id);
$vtp->setVar($form, "gest.pathStyle", $pathStyle);

include($DEFAULT_PATH."header.php");
$vtp->setVar($form, "gest.page_headers", $page_headers);
$vtp->setVar($form, "gest.act_detail_lbl_retour", $lang_sui_alt_act_detail_lbl_retour);
$vtp->setVar($form, "gest.act_detail_title_detail", $lang_sui_alt_act_detail_title_detail);
$vtp->setVar($form, "gest.act_detail_lbl_etat", $lang_sui_alt_act_detail_lbl_etat);
$vtp->setVar($form, "gest.act_detail_lbl_date", $lang_sui_alt_act_detail_lbl_date);
$vtp->setVar($form, "gest.act_detail_lbl_dest", $lang_sui_alt_act_detail_lbl_dest);
$vtp->setVar($form, "gest.act_detail_lbl_destcc", $lang_sui_alt_act_detail_lbl_destcc);
$vtp->setVar($form, "gest.act_detail_lbl_actemet", $lang_sui_alt_act_detail_lbl_actemet);
$vtp->setVar($form, "gest.act_detail_lbl_niverr", $lang_sui_alt_act_detail_lbl_niverr);
$vtp->setVar($form, "gest.act_detail_lbl_coderr", $lang_sui_alt_act_detail_lbl_coderr);
$vtp->setVar($form, "gest.act_detail_lbl_lblerr", $lang_sui_alt_act_detail_lbl_lblerr);
$vtp->setVar($form, "gest.act_detail_lbl_lblerrdet", $lang_sui_alt_act_detail_lbl_lblerrdet);
$vtp->setVar($form, "gest.act_detail_llbl_diagnostic", hi_disp($lang_sui_alt_lbl_diagnostic));
$vtp->setVar($form, "gest.alt_diagnostic", hi_disp($row['ALT_DIAGNOSTIC']));
if ($row['ALT_ETAT'] == ALT_ETAT_ARCHIVE)
	$vtp->setVar($form, "gest.diagnostic_readonly",  "readonly");
$actionBtn = false; 
if (droit(CTA,DROIT_SUPPR,null,null,null,null)) 
{
	$actionBtn = true; 
}
else if (droit(CMA,DROIT_SUPPR,null,null,null,null))
{
	$req = "SELECT UTR_ID
			FROM COMPTE 
			WHERE CPT_ID=".$_SESSION['CPT_ID'];
	$gDb->SQLQuery($req, 2);
	$row2 = $gDb->SQLNextRow(2);
	$utr_id = $row2[0];
	$gDb->SQLFermeQuery(2);
	if (($row['ALT_DEST_ID'] == $utr_id) || ($row['ALT_DESTCC_ID'] == $utr_id))
	{
		$actionBtn = true; 
	}
}

if ($actionBtn)
{
	$vtp->addSession($form, "suppr");
	$vtp->setVar($form, "suppr.act_detail_lbl_suppr", $lang_sui_alt_act_detail_lbl_suppr);
	$vtp->setVar($form, "suppr.pathStyle", $pathStyle);
	$vtp->closeSession($form, "suppr");

	if ($row['ALT_ETAT'] != ALT_ETAT_ARCHIVE)
	{
		$vtp->addSession($form, "cloture");
		$vtp->setVar($form, "cloture.act_detail_lbl_cloture", $lang_sui_alt_act_detail_lbl_cloturer);
		$vtp->setVar($form, "cloture.pathStyle", $pathStyle);
		$vtp->closeSession($form, "cloture");
	}
}

$vtp->closeSession($form, "gest");
$vtp->Display();
?>