<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");

$droitRole = SDR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

$cptID = $_SESSION['CPT_ID'];
$cltID = $_SESSION['CLT_ID'];

$pageNum 			= pget('pageNum');
$pageSize 			= pget('pageSize');
$f_tdoc 			= pget("f_tdoc");
$suiType 			= pget("suiType");
$numCol				= pget("numCol");
$numPres 			= pget("numPres");
$f_sens 			= pget('f_sens');
$f_emetteur 		= pget('f_emetteur');
$f_destinataire 	= pget('f_destinataire');
$f_date_deb 		= pget('f_date_deb');
$f_date_fin 		= pget('f_date_fin');
$f_progress 		= pget('f_progress');
$f_etat 			= pget('f_etat');
$f_date_deb 		= pget('f_date_deb');
$f_date_fin 		= pget('f_date_fin');

$where = "";

if($f_tdoc)
	$where .= " AND SUIVI.TDOC_ID = '$f_tdoc' ";

if($numCol)
	$suiType = SUI_TYPE_COL;
	
if ($numPres)
	$suiType = SUI_TYPE_PRES;
	
if (isset($suiTYPE) && $suiTYPE == SUI_TYPE_COL) {
	$type_post = "numCol";
	$from = "col";
}
else {
	$type_post = "numPres";
	$from = "pres";
}
	
Construit_restriction($droitRole, "SUIVI.PAR_EMET_ID", "SUIVI.PAR_DEST_ID", "SUIVI.TDOC_ID", null, $restrict, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);

if ($restrictFiltreEmet)
	$restrictFiltreEmet=" AND SUIVI.PAR_ID IN (".$restrictFiltreEmet.") ";
	
if ($restrictFiltreDest)
	$restrictFiltreDest=" AND SUIVI.PAR_ID IN (".$restrictFiltreDest.") ";
	
if ($restrictFiltreTdoc)
	$restrictFiltreTdoc=" AND SUIVI.TDOC_ID IN (".$restrictFiltreTdoc.") ";

if ($f_sens)
	$where .= " AND SUIVI.SUI_SENS='".$f_sens."'";
	
	// Criteres partenaires

	$f_emetteur		= pget('f_emetteur');		//filtre émetteur
	$f_destinataire	= pget('f_destinataire');	//filtre destinataire
	$fromPE 		= pget('fromPE');
	$fromPD 		= pget('fromPD');

	if ($fromPD>0 && $f_destinataire)
	{
		if ($fromPD==2)// part + fils
		{
			$fils="";
			trouve_fils($f_destinataire);
			if ($fils)
			$filsD=$f_destinataire.", ".$fils;
			else $filsD=$f_destinataire;

		}
		if ($fromPD==3) // que les fils
		{
			$fils="";
			trouve_fils($f_destinataire);
			$filsD=$fils;

		}
		if ($fromPD==4) //que le part
		{
			$filsD=$f_destinataire;
		}
	}
	if ($fromPE>0 && $f_emetteur)
	{
		if ($fromPE==2)// part + fils
		{
			$fils="";
			trouve_fils($f_emetteur);
			if ($fils)
			$filsE=$f_emetteur.", ".$fils;
			else $filsE=$f_emetteur;
		}
		if ($fromPE==3) // que les fils
		{
			$fils="";
			trouve_fils($f_emetteur);
			$filsE=$fils;
		}
		if ($fromPE==4) //que le part
		{
			$filsE=$f_emetteur;
		}
	}

	//Traitement de l'émetteur

	if ($fromPD>0){	if ($f_destinataire) $where .=" and SUIVI.PAR_DEST_ID in ($filsD)";}
	else {if ($f_destinataire) $where .= " and SUIVI.PAR_DEST_ID = '".dblQ($f_destinataire)."'";}

	if ($fromPE>0){ if ($f_emetteur) $where .=" and SUIVI.PAR_EMET_ID in ($filsE)";}
	else {if ($f_emetteur)	$where .= " and SUIVI.PAR_EMET_ID = '".dblQ($f_emetteur)."'";}

	/*
	 if ($f_emetteur)
	 $where .= " AND SUIVI.PAR_EMET_ID='".$f_emetteur."'";

	 //Traitement du destinataire

	 if ($f_destinataire)
	 $where .= " AND SUIVI.PAR_DEST_ID='".$f_destinataire."'";
	 */

// traitement des dates
if($f_date_deb) {
	if($f_date_fin) {
			//$date_deb_sql = date2Sql($f_date_deb, "00:00:00");
            //$date_fin_sql = date2Sql($f_date_fin, "23:59:59");
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND ETAT_NUM.ETN_DATE BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND ETAT_NUM.ETN_DATE BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND ETAT_NUM.ETN_DATE >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND ETAT_NUM.ETN_DATE >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND ETAT_NUM.ETN_DATE <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND ETAT_NUM.ETN_DATE <= '".date2Sql($f_date_fin, "23::59:59")."'";
	}		
}	
	
if($f_progress)
	$where .= " AND ETAT_NUM.ETN_PROGRESS = '".$f_progress."'";
	
if ($f_etat && $f_etat != -1)
	$where .= " AND ETAT_NUM.ETN_ETAT = '$f_etat' ";
else if($f_etat == -1)
	$where .= " AND ETAT_NUM.ETN_ETAT != ".SUI_ETAT_INFO." ";
	
//Récupération des détails
$tab_detail = array();
$req = "SELECT PFL_ID, PFL_LIBEL FROM PAR_FLOW";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_detail[$row['PFL_ID']] = $row['PFL_LIBEL'];
$gDb->SQLFermeQuery(1);

// Premiere requete pour obtenir le nombre d'enregistrements
$reqCount = "SELECT count(*) AS MAX_ROW
		    FROM SUIVI 
				  JOIN ETAT_NUM ON ETAT_NUM.ETN_ID = SUIVI.ETN_ID AND ETAT_NUM.ETN_ETAT != 2
				  JOIN PART AS EMET ON EMET.PAR_ID = SUIVI.PAR_EMET_ID
				  JOIN PART AS DEST ON DEST.PAR_ID = SUIVI.PAR_DEST_ID
				  LEFT JOIN TYPE_DOC ON TYPE_DOC.TDOC_ID = SUIVI.TDOC_ID
		    WHERE SUIVI.CLT_ID = $cltID
   				  AND SUIVI.SUI_REJOUE = 0  
   				  AND SUIVI.SUI_TYPE= $suiType
       			  $where 
       			  $restrict";
		    	        	
$gDb->SQLQuery($reqCount, 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

// Calcul du nombre de pages
$pagesNumber = (int)($maxRow / $pageSize);


$req = "SELECT
       SUIVI.SUI_NUMERO
     , ETN_DATE
     , SUIVI.SUI_SENS
     , SUIVI.PAR_EMET_ID
     , SUIVI.PAR_DEST_ID
     , ETAT_NUM.ETN_PROGRESS
     , ETAT_NUM.ETN_ETAT
     , ETAT_NUM.ETN_LIBEL
     , SUIVI.TDOC_ID
     , SUI_DETAIL
     , SUI_ID
     , SUIVI.FIC_ID
     , SUIVI.SUI_TYPE
     , SUIVI.FOR_ID
     , EMET.PAR_NOM AS EMET_NOM
     , DEST.PAR_NOM AS DEST_NOM
     , TYPE_DOC.TDOC_NOM
     , TYPE_DOC.TDOC_ETAT
  FROM SUIVI
  JOIN ETAT_NUM ON ETAT_NUM.ETN_ID = SUIVI.ETN_ID AND ETAT_NUM.ETN_ETAT != 2
  JOIN PART AS EMET ON EMET.PAR_ID = SUIVI.PAR_EMET_ID
  JOIN PART AS DEST ON DEST.PAR_ID = SUIVI.PAR_DEST_ID
  LEFT JOIN TYPE_DOC ON TYPE_DOC.TDOC_ID = SUIVI.TDOC_ID
 WHERE SUIVI.CLT_ID = $cltID
   AND SUIVI.SUI_REJOUE = 0  
   AND SUIVI.SUI_TYPE= $suiType
       $where 
       $restrict";

if($pageNum == 1 && $pageSize == '100000000')
{
	// Si on affiche toutes les lignes on ordonne 	
	if($ini_typeBase == "mssql")	
		$req .= " ORDER BY SUI_DATE";
	else
		$req .= " ORDER BY SUIVI.SUI_DATE";
	$gDb->SQLQuery($req, 1);
}
else
{		
	// Si la page a affichee est dans la premiere partie de l'historique
	if ($pageNum < (int)($pagesNumber / 2))
	{
		// On ordonne selon le SUI_ID inverse	
		if($ini_typeBase == "mssql")	
			$req .= " ORDER BY SUI_DATE DESC";
		else
			$req .= " ORDER BY SUIVI.SUI_DATE DESC";
		$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);
	}
	else
	{
		// Pas besoin d'ordonner selon le SUI_ID (d?j? fait)
		$lastRows = $maxRow - ($pagesNumber * $pageSize);
		//print $lastRows;
		if ($pageNum > $pagesNumber)
			$gDb->SQLQuery($req, 1, 0, $lastRows);
		else
			$gDb->SQLQuery($req, 1, $lastRows + ($pageSize*($pagesNumber-$pageNum)), $pageSize);
	}	
}	
       
$champs = array();
$champs[] = array("nom" => $lang_sui_col_grid_head_num, "toolTip" => $lang_sui_col_grid_head_num_tooltip, "sortMode" => "2");
$champs[] = array("nom" => $lang_sui_col_grid_head_doc, "toolTip" => $lang_sui_col_grid_head_doc_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_col_grid_head_date, "toolTip" => $lang_sui_col_grid_head_date, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_col_grid_head_sens, "toolTip" => $lang_sui_col_grid_head_sens, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_col_grid_head_emet, "toolTip" => $lang_sui_col_grid_head_emet_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_col_grid_head_dest, "toolTip" => $lang_sui_col_grid_head_dest_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_col_grid_head_libl, "toolTip" => $lang_sui_col_grid_head_libl, "sortMode" => "1");

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

$oldTDocID = '';

$displayedRows = array();
$index = 0;

while ($row = $gDb->SQLNextRow(1))
{
	$temp = explode(";;", $row['SUI_DETAIL']);
	$detail = "";
	$i = 0;
	foreach($temp as $tt)
	{
		$val = explode("::", $tt);
		$libel = $tab_detail[$val[0]];
		$val[1]=preg_replace("/[^\x20-\xFF]/","",$val[1]);
		if($libel)
		{
			if($i%2 == 0)
				$detail .= '<tr>';
			$detail .= "<td><b>".$libel."</b> : ".$val[1]."</td>";
			if($i%2 == 1)
				$detail .= '</tr>';
			++$i;
		}
	}
	if($detail)
	{
		if($i%2 == 0)
			$detail .= '</tr>';
		$detail = hi_disp('<table>'.$detail.'</table>');
	}
				
	$displayedRows[$index] = '<row detail="'.$detail.'">';
	
	$params = array();
	$params['sui_numero'] = $row['SUI_NUMERO'];
	$params['liste'] = $row['SUI_NUMERO'];
	$params['sui_numero'] = $row['SUI_NUMERO'];
	$params['numCol'] = $row['SUI_NUMERO'];
	$params['fic_id'] = $row['FIC_ID'];
	$params['for_id'] = $row['FOR_ID'];
	$params['typeDoc'] = $row['TDOC_ID'];
	
	//Droits
	$params['droits'] = array('visu' => droit($droitRole, DROIT_EXEC,$row['PAR_EMET_ID'], $row['PAR_DEST_ID'], $row['TDOC_ID'], null),
							'download' => droit(TEL, DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null),
							'histo' => droit(HIS, DROIT_LECT + DROIT_MODIF + DROIT_EXEC,null,null,null,null) || 
									   droit(SDO, DROIT_LECT + DROIT_MODIF + DROIT_EXEC,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null),
							'suivi' => droit(SDO, DROIT_LECT + DROIT_MODIF + DROIT_EXEC,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null),
							'rejeu' => droit($droitRole, DROIT_MODIF,$row['PAR_EMET_ID'], $row['PAR_DEST_ID'], $row['TDOC_ID'], null));
	
	
	$displayedRows[$index] .= '<item caption="'.$row['SUI_NUMERO'].'" value="'.row_encode_JSON($params).'"/>';
	
	$displayedRows[$index] .= '<item';
	
	$icon = $pathFlow."style/imgs/icons/doc_new.gif";
			
	if ($row['TDOC_ID'])
	{
		$deb = "";
		$fin = "";
		$toolTip = "";

		switch($row['ETN_PROGRESS'])
		{
			case ETN_PROGRESS_COURS :
				$icon = $pathFlow.'style/imgs/icons/progress.gif';
				$toolTip = $lang_sui_col_grid_lbl_progress_encours;
				break;
			case ETN_PROGRESS_TERMINE :
				$icon= $pathFlow.'style/imgs/icons/valid.png';
				$toolTip=$lang_sui_col_grid_lbl_progress_fin;
				break;
			default :
		}
		if ($row['TDOC_ETAT'] == ETAT_SUPPR)
		{
			$deb = AFF_SUPPR_DEB;
			$fin = " $lang_lbl_etat_suppr_ini ";
			$icon = $pathFlow."style/imgs/icons/doc_delete.gif";
		}
		
		$displayedRows[$index] .= ' caption="'.hi_disp($deb.$row['TDOC_NOM'].$fin).'" toolTip="'.$toolTip.'" icon="'.$icon.'"';
	}
			
	$displayedRows[$index] .= '/>';	
		
	$displayedRows[$index] .= '<item caption="'.sql2Date($row['ETN_DATE']).'"/>';
	
	$displayedRows[$index] .= '<item';
	if($row['SUI_SENS'] == RECEPTION)
		$displayedRows[$index] .= ' caption="'.$lang_sui_col_grid_lbl_recept.'" toolTip="'.$lang_sui_col_grid_lbl_recept_tooltip.'" icon="'.$pathFlow.'style/imgs/icons/retour.gif"';
	else if($row['SUI_SENS'] == EMISSION)
		$displayedRows[$index] .= ' caption="'.$lang_sui_col_grid_lbl_emiss.'" toolTip="'.$lang_sui_col_grid_lbl_emiss_tooltip.'" icon="'.$pathFlow.'style/imgs/icons/aller.gif"';
	$displayedRows[$index] .= '/>';
	
	$displayedRows[$index] .= '<item caption="'.hi_disp($row['EMET_NOM']).'"/>';
		
	$displayedRows[$index] .= '<item caption="'.hi_disp($row['DEST_NOM']).'"/>';
	
	$icon = "";
	$toolTip = "";
	switch($row['ETN_ETAT'])
	{
		case SUI_ETAT_OK :
			$icon=$pathFlow.'style/imgs/icons/rond_vert.png';
			$toolTip=$lang_sui_col_grid_lbl_etat_ok;
			break;
		case SUI_ETAT_INFO :
			$icon=$pathFlow.'style/imgs/icons/info.png';
			$toolTip=$lang_sui_col_grid_lbl_etat_info;
			break;
		case SUI_ETAT_AVERT :
			$icon=$pathFlow.'style/imgs/icons/alert.gif';
			$toolTip=$lang_sui_col_grid_lbl_etat_avert;
			break;
		case SUI_ETAT_ERR :
			$icon=$pathFlow.'style/imgs/icons/error.png';
			$toolTip=$lang_sui_col_grid_lbl_etat_err;
			break;
		default :
	}
	$displayedRows[$index] .= '/>';
	$displayedRows[$index] .= '<item caption="'.hi_disp($row['ETN_LIBEL']).'" icon="'.$icon.'" toolTip="'.$toolTip.'"/>';
	
	$displayedRows[$index] .= '</row>';
	$index++;
}
$gDb->SQLFermeQuery(1);

if ($pageNum < (int)($pagesNumber / 2))
	for ($i = 0; $i < $index; $i++)	echo $displayedRows[$i];		
else
	for ($i = ($index-1); $i >= 0; $i--) echo $displayedRows[$i];		

echo '</databind>';

if ((!isset($_SESSION['HISTOCOL_FILTER']['remember'])) || ($_SESSION['HISTOCOL_FILTER']['remember']))
{
	$_SESSION['HISTOCOL_FILTER'] = array (
	'remember'		=> true,
	'pageNum'		=> $pageNum,
	'pageSize' 		=> $pageSize,
	'f_tdoc'		=> $f_tdoc,
	'suiType' 		=> $suiType,
	'f_sens'		=> $f_sens,
	'f_emetteur' 	=> $f_emetteur,
	'f_destinataire'=> $f_destinataire,
	'fromPE' 		=> $fromPE,
	'fromPD'		=> $fromPD,
	'f_date_deb'	=> $f_date_deb,
	'f_date_fin' 	=> $f_date_fin,
	'f_etat' 		=> $f_etat,
	'f_progress' 	=> $f_progress);
}
?>