<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");


$page_courante = "suivi\historique\sui_hist_dSGrid.php";

$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;
if (droit(HIS,$lmcse,null,null,null,null))
	$droitRole = HIS;
else
	$droitRole = SDO;
$where = "";
$restrict = "";

$cptID = $_SESSION['CPT_ID'];
$cltID = $_SESSION['CLT_ID'];


//paramètres généraux (aussi utilisés par les autres niveaux de suivi)
$typeDoc		= pget('typeDoc'); //Type de document
$numDoc			= pget('numDoc'); //No de document
$numCol			= pget('numCol'); //No de collecte
$numPres		= pget('numPres'); //No de présentation
$numAlt			= pget('numAlt'); //No d'alerte = SUI_ID
$nivHist		= pget('nivHist'); //Histo ou Histo Détaillé : 1 = normal; 2 = détaillé
$f_afx 			= pget('f_afx');
$f_tdoc 		= pget('f_tdoc');
$f_sens 		= pget('f_sens');
$f_etat		 	= pget('f_etat');
$f_date_deb 	= pget('f_date_deb');
$f_date_fin 	= pget('f_date_fin');
$f_emetteur		= pget('f_emetteur');		//filtre émetteur
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$fromPE 		= pget('fromPE');
$fromPD 		= pget('fromPD');

if (strlen(pget('pageNum'))!=0) $pageNum = pget('pageNum'); else $pageNum=1;
if (strlen(pget('pageSize'))!=0) $pageSize = pget('pageSize'); else $pageSize=0;

$forceSort = false;
$list_doc = "";
$list_pre = "";
$list_col = "";
	
if ($numAlt)
{
	$forceSort = true;
	$req = "SELECT SUI_TYP_NUM, SUI_NUMERO 
			FROM SUIVI 
			WHERE SUI_ID = $numAlt";
	
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	
	switch ($row['SUI_TYP_NUM'])
	{
		case SUI_TYPE_DOC :
			$numDoc = $row['SUI_NUMERO'];
			break;
		case SUI_TYPE_COL :
			$numCol = $row['SUI_NUMERO'];
			break;
		case SUI_TYPE_PRES :
			$numPres = $row['SUI_NUMERO'];
			break;
	}
}

//Traitement de l'activité
if($f_afx)
{
	$req = "SELECT AFX_ID 
			FROM ACTFLUX 
			WHERE CLT_ID = $cltID 
			AND ACT_ID = $f_afx";
	$gDb->SQLQuery($req, 1);
	$nb_afx = 0;
	$som_afx = null;
	if($row = $gDb->SQLNextRow(1))
	{
		$som_afx = " AND SUIVI.AFX_ID IN (".$row['AFX_ID'];
		while($row = $gDb->SQLNextRow(1))
			$som_afx .= ",".$row['AFX_ID'];
			
		$where .= $som_afx.") ";
	}
	$gDb->SQLFermeQuery(1);
}

//Traitement du type de document
if($f_tdoc)
	$where .= " AND SUIVI.TDOC_ID = $f_tdoc ";
else
{
	// On doit egalement filtrer sur les types de documents auxquels l'utilisateur a acces
	if (!droit(HIS, $lmcse,null,null,null,null) && !droit(SDO, $lmcse,null,null,1,null))	//on verifie les droits sur tous les documents
	{
		$req = "SELECT TDOC_ID, TDOC_NOM, TDOC_ETAT  
				FROM TYPE_DOC 
				WHERE TYPE_DOC.CLT_ID =".$cltID." AND TDOC_NOM != ' TOUS'";
		$gDb->SQLQuery($req, 1);
		while ($row = $gDb->SQLNextRow(1))
		{
			if (droit(SDO, $lmcse,null,null,$row['TDOC_ID'],null))	//on verifie les droits sur le type de documents TDOC_ID
			{
				$where .= " AND SUIVI.TDOC_ID IN (".$row['TDOC_ID'];
				while($row = $gDb->SQLNextRow(1))
				{
					if (droit(SDO, $lmcse,null,null,$row['TDOC_ID'],null))	//on verifie les droits sur le type de documents TDOC_ID
						$where .= ",".$row['TDOC_ID'];
				}
				$where .= ") ";
				break;
			}
		}
		$gDb->SQLFermeQuery(1);
	}
}
// Criteres partenaires	
if ($fromPD>0 && $f_destinataire)
{
	if ($fromPD==2)// part + fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		if ($fils)
		$filsD=$f_destinataire.", ".$fils;
		else $filsD=$f_destinataire;

	}
	if ($fromPD==3) // que les fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		$filsD=$fils;

	}
	if ($fromPD==4) //que le part
	{
		$filsD=$f_destinataire;
	}
}
if ($fromPE>0 && $f_emetteur)
{
	if ($fromPE==2)// part + fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		if ($fils)
		$filsE=$f_emetteur.", ".$fils;
		else $filsE=$f_emetteur;
	}
	if ($fromPE==3) // que les fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		$filsE=$fils;
	}
	if ($fromPE==4) //que le part
	{
		$filsE=$f_emetteur;
	}
}

//Traitement de l'émetteur	
if ($fromPD>0){	if ($f_destinataire) $where .=" and SUIVI.PAR_DEST_ID in ($filsD)";}
else {if ($f_destinataire) $where .= " and SUIVI.PAR_DEST_ID = '".dblQ($f_destinataire)."'";}

if ($fromPE>0){ if ($f_emetteur) $where .=" and SUIVI.PAR_EMET_ID in ($filsE)";}
else {if ($f_emetteur)	$where .= " and SUIVI.PAR_EMET_ID = '".dblQ($f_emetteur)."'";}

if (!droit(HIS,$lmcse,null,null,null,null))
	Construit_restriction(SDO, "SUIVI.PAR_EMET_ID", "SUIVI.PAR_DEST_ID", null, null, $restrict, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);

// traitement des dates
if($f_date_deb) {
	if($f_date_fin) {
			//$date_deb_sql = date2Sql($f_date_deb, "00:00:00");
            //$date_fin_sql = date2Sql($f_date_fin, "23:59:59");
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SUI_DATE BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SUI_DATE BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SUI_DATE >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SUI_DATE >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SUI_DATE <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SUI_DATE <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}

//Traitement du sens
if ($f_sens)
	$where .= " AND SUIVI.SUI_SENS='".$f_sens."'";

//Traitement de l'état
if ($f_etat && $f_etat != -1)
	$where .= " AND SUIVI.SUI_ETAT = '$f_etat' ";
else if($f_etat == -1)
	$where .= " AND SUIVI.SUI_ETAT != ".SUI_ETAT_INFO." ";
	
$f_rejoue = pget('f_rejoue');
if($f_rejoue != '')
	$where .= " AND SUIVI.SUI_REJOUE = $f_rejoue ";
	
if ($numDoc)
{
	$forceSort = true;
	$req = "SELECT DISTINCT NDC_NUMCOL 
			FROM NUM_DOC_COL 
			WHERE NDC_NUMDOC = $numDoc 
			AND CLT_ID = $cltID";
	$gDb->SQLQuery($req, 1);
	if($row = $gDb->SQLNextRow(1))
	{
		$list_col = $row['NDC_NUMCOL'];
		while($row = $gDb->SQLNextRow(1))
			$list_col .= ",".$row['NDC_NUMCOL'];
	}
	$gDb->SQLFermeQuery(1);
	
	$list_pre = "";
	$req = "SELECT DISTINCT NDP_NUMPRE 
			FROM NUM_DOC_PRE 
			WHERE NDP_NUMDOC = $numDoc  
			AND CLT_ID = $cltID";
	$gDb->SQLQuery($req, 1);
	if($row = $gDb->SQLNextRow(1))
	{
		$list_pre = $row['NDP_NUMPRE'];
		while($row = $gDb->SQLNextRow(1))
			$list_pre .= ",".$row['NDP_NUMPRE'];
	}
	$gDb->SQLFermeQuery(1);

	$where .= " AND ((SUI_NUMERO = $numDoc AND SUI_TYP_NUM = ".SUI_TYP_NUM_DOC.") ";
	
	if ($list_col)
		$where .= " OR (SUI_NUMERO IN ($list_col) 
						and SUI_TYP_NUM = ".SUI_TYP_NUM_COL.") ";
	if ($list_pre)
		$where .= " OR (SUI_NUMERO IN ($list_pre) 
						AND SUI_TYP_NUM = ".SUI_TYP_NUM_PRE.") ";
	$where .= ") ";
}
else
{
	if ($numCol)
	{
		$forceSort = true;
		$req = "SELECT DISTINCT NDC_NUMDOC 
				FROM NUM_DOC_COL 
				WHERE NDC_NUMCOL = $numCol 
					AND CLT_ID = $cltID";
		$gDb->SQLQuery($req, 1);
		
		$list_doc = "";
		if($row = $gDb->SQLNextRow(1))
		{
			$list_doc = $row['NDC_NUMDOC'];
			while($row = $gDb->SQLNextRow(1))
				$list_doc .= ",".$row['NDC_NUMDOC'];
		}
		$gDb->SQLFermeQuery(1);
		
		if ($list_doc)
		{
			$req = "SELECT DISTINCT NDP_NUMPRE 
					FROM NUM_DOC_PRE 
					WHERE NDP_NUMDOC IN ($list_doc) 
					AND CLT_ID = $cltID";
			$gDb->SQLQuery($req, 1);
			if($row = $gDb->SQLNextRow(1))
			{
				$list_pre = $row['NDP_NUMPRE'];
				while($row = $gDb->SQLNextRow(1))
					$list_pre .= ",".$row['NDP_NUMPRE'];
			}
			$gDb->SQLFermeQuery(1);
		}

		$where .= " AND ((SUI_NUMERO = $numCol AND SUI_TYP_NUM = ".SUI_TYP_NUM_COL.") ";
		if ($list_doc)
			$where .= " OR (SUI_NUMERO IN ($list_doc) AND SUI_TYP_NUM = ".SUI_TYP_NUM_DOC.") ";
      	if ($list_pre)
           	$where .= " OR (SUI_NUMERO IN ($list_pre) AND SUI_TYP_NUM = ".SUI_TYP_NUM_PRE.") ";
    	$where .= ") ";
	}
	if ($numPres)
	{
		$forceSort = true;
		$req = "SELECT DISTINCT NDP_NUMDOC 
             	FROM NUM_DOC_PRE 
             	WHERE NDP_NUMPRE = $numPres 
              	AND CLT_ID = $cltID";
      	$gDb->SQLQuery($req, 1);
       	if($row = $gDb->SQLNextRow(1))
       	{
       		$list_doc = $row['NDP_NUMDOC'];
	       	while($row = $gDb->SQLNextRow(1))
	       		$list_doc .= ",".$row['NDP_NUMDOC'];
       	}
      	$gDb->SQLFermeQuery(1);
		if ($list_doc)
		{
	      	$req = "SELECT DISTINCT NDC_NUMCOL 
	           		FROM NUM_DOC_COL 
	              	WHERE NDC_NUMDOC in ($list_doc) 
	              	AND CLT_ID = $cltID";
	      	$gDb->SQLQuery($req, 1);
	     	if($row = $gDb->SQLNextRow(1))
	     	{
	     		$list_col = $row['NDC_NUMCOL'];
		     	while($row = $gDb->SQLNextRow(1))
		     		$list_col .= ",".$row['NDC_NUMCOL'];
	     	}
	      	$gDb->SQLFermeQuery(1);
		}

      	$where .= " AND ((SUI_NUMERO = $numPres AND SUI_TYP_NUM = ".SUI_TYP_NUM_PRE.") ";
      	if ($list_doc)
          	$where .= " OR (SUI_NUMERO IN ($list_doc) AND SUI_TYP_NUM = ".SUI_TYP_NUM_DOC.") ";
      	if ($list_col)
           	$where .= " OR (SUI_NUMERO IN ($list_col) AND SUI_TYP_NUM = ".SUI_TYP_NUM_COL.") ";
    	$where .= ") ";
	}
}

//Récupération des détails
$tab_detail = array();
$req = "SELECT PFL_ID, PFL_LIBEL FROM PAR_FLOW";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_detail[$row['PFL_ID']] = $row['PFL_LIBEL'];
$gDb->SQLFermeQuery(1);

//Récupération des types de documents
$tab_tdoc = array();
if($ini_typeBase == "mysql")	
	$req = "SELECT FOR_ID, TDOC_NOM, TDOC_ETAT, FOR_ETAT, TDOC_ID
		FROM TYPE_DOC JOIN `FORMAT` USING (TDOC_ID)";
else
	$req = "SELECT FOR_ID, TDOC_NOM, TDOC_ETAT, FOR_ETAT, TYPE_DOC.TDOC_ID
		FROM TYPE_DOC JOIN FORMAT ON TYPE_DOC.TDOC_ID=FORMAT.TDOC_ID";

$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_tdoc[$row['FOR_ID']] = array("TDOC_NOM" => $row['TDOC_NOM'],
										"TDOC_ETAT" => $row['TDOC_ETAT'],
										"FOR_ETAT" => $row['FOR_ETAT'],
										"TDOC_ID" => $row['TDOC_ID']);
$gDb->SQLFermeQuery(1);

// Premiere requete pour obtenir le nombre d'enregistrements
$reqCount = "SELECT count(*) AS MAX_ROW
		    FROM SUIVI 
			WHERE SUIVI.CLT_ID = $cltID
				AND SUIVI.SUI_TYPE <= ".(($nivHist == 2)?(SUI_TYPE_HIST_D):(SUI_TYPE_HIST))." 
	        	$where $restrict";
	        	
$gDb->SQLQuery($reqCount, 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

// Calcul du nombre de pages
if ($pageSize!=0) {
	$pagesNumber = (int)($maxRow / $pageSize);
} else {
	$pagesNumber = 1;
}

if($ini_typeBase == "mysql")	
	$req = "SELECT STRAIGHT_JOIN SUIVI.SUI_ID, SUIVI.SUI_DATE, SUIVI.SUI_SENS, SUIVI.PAR_EMET_ID,
			SUIVI.PAR_DEST_ID, SUIVI.SUI_ETAT, SUIVI.SUI_LIBEL, SUIVI.FIC_ID,
			SUIVI.SUI_TYPE, SUIVI.TDOC_ID, SUIVI.FOR_ID,
			SUIVI.AFX_ID, SUIVI.SUI_DETAIL, SUIVI.FOR_ID, SUIVI.SUI_ERR, SUIVI.SUI_REJOUE,
			SUIVI.FLX_ID, ACT_LIBEL, ACT_ETAT, TAC_NOM
		FROM SUIVI JOIN ACTFLUX USING (AFX_ID) JOIN ACTIVITE USING (ACT_ID) JOIN TYPE_ACT USING (TAC_NUM)
		WHERE SUIVI.CLT_ID = $cltID
			AND SUIVI.SUI_TYPE <= ".(($nivHist == 2)?(SUI_TYPE_HIST_D):(SUI_TYPE_HIST))." 
	        $where $restrict";
else#for MSSQL and ORACLE
	$req = "SELECT SUIVI.SUI_ID, SUIVI.SUI_DATE, SUIVI.SUI_SENS, SUIVI.PAR_EMET_ID,
            SUIVI.PAR_DEST_ID, SUIVI.SUI_ETAT, SUIVI.SUI_LIBEL, SUIVI.FIC_ID,
            SUIVI.SUI_TYPE, SUIVI.TDOC_ID, SUIVI.FOR_ID,
            SUIVI.AFX_ID, SUIVI.SUI_DETAIL, SUIVI.FOR_ID for_id1, SUIVI.SUI_ERR, SUIVI.SUI_REJOUE,
            SUIVI.FLX_ID, ACT_LIBEL, ACT_ETAT, TAC_NOM
        FROM SUIVI JOIN ACTFLUX ON SUIVI.AFX_ID=ACTFLUX.AFX_ID JOIN ACTIVITE ON ACTIVITE.ACT_ID=ACTFLUX.ACT_ID
        JOIN TYPE_ACT ON ACTIVITE.TAC_NUM=TYPE_ACT.TAC_NUM
        WHERE SUIVI.CLT_ID = $cltID
			AND SUIVI.SUI_TYPE <= ".(($nivHist == 2)?(SUI_TYPE_HIST_D):(SUI_TYPE_HIST))." 
	        $where $restrict";

if($pageNum == 1 && $pageSize == '100000000')
{
	// Si on affiche toutes les lignes on ordonne 	
	if($ini_typeBase == "mssql")	
		$req .= " ORDER BY SUI_DATE";
	else
		$req .= " ORDER BY SUIVI.SUI_DATE";
	$gDb->SQLQuery($req, 1);
}
else
{		
	// Si la page a affichee est dans la premiere partie de l'historique
	if (($forceSort) || ($pageNum < (int)($pagesNumber / 2)))
	{
		// On ordonne par date inverse	
		if($ini_typeBase == "mssql")	
			$req .= " ORDER BY SUI_DATE DESC";
		else
			$req .= " ORDER BY SUIVI.SUI_DATE DESC";
		$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);
	}
	else
	{
		// On ordonne par date inverse	
		if($ini_typeBase == "mssql")	
			$req .= " ORDER BY SUI_DATE";
		else
			$req .= " ORDER BY SUIVI.SUI_DATE";
		$lastRows = $maxRow - ($pagesNumber * $pageSize);
		//print $lastRows;
		if ($pageNum > $pagesNumber)
			$gDb->SQLQuery($req, 1, 0, $lastRows);
		else
			$gDb->SQLQuery($req, 1, $lastRows + ($pageSize*($pagesNumber-$pageNum)), $pageSize);
	}	
}

$champs = array();
$champs[] = array("nom" => $lang_sui_hist_grid_head_doc, "toolTip" => $lang_sui_hist_grid_head_doc, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_act, "toolTip" => $lang_sui_hist_grid_head_act, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_date, "toolTip" => $lang_sui_hist_grid_head_date, "sortMode" => "3");
$champs[] = array("nom" => $lang_sui_hist_grid_head_sens, "toolTip" => $lang_sui_hist_grid_head_sens, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_emet, "toolTip" => $lang_sui_hist_grid_head_emet_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_dest, "toolTip" => $lang_sui_hist_grid_head_dest_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_rejoue, "toolTip" => $lang_sui_hist_grid_head_rejoue, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_hist_grid_head_etat, "toolTip" => $lang_sui_hist_grid_head_etat, "sortMode" => "2");
$champs[] = array("nom" => $lang_sui_hist_grid_head_flux, "toolTip" => $lang_sui_hist_grid_head_flux, "sortMode" => "1");

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

$displayedRows = array();
$index = 0;

$droitHIS_MODIF = droit(HIS, DROIT_MODIF,null,null,null,null);
$droitHIS_EXEC = droit(HIS, DROIT_EXEC,null,null,null,null);

while ($row = $gDb->SQLNextRow(1))
{
	$temp = explode(";;", $row['SUI_DETAIL']);
	$detail = "";
	$i = 0;
	foreach($temp as $tt)
	{
		$val = explode("::", $tt);
        if (count($val) > 1)
        {
			$libel = $tab_detail[$val[0]];
			
			$val[1]=preg_replace("/[^\x20-\xFF]/","",$val[1]);
			
			if($libel)
			{
				if($i%2 == 0)
					$detail .= '<tr>';
				$detail .= "<td><b>".$libel."</b> : ".$val[1];
				
				$typeval = '';
				$present = false;
				$parID = 0;
				if($row['SUI_ERR']==10011) // adresse X400 ou mail de l'魥tteur inconnue
				{
					$req2 = "SELECT PAR_EMET_ID FROM FLUX WHERE FLX_ID=${row['FLX_ID']} AND FLX_ACTIF!=".ETAT_SUPPR;
					$gDb->SQLQuery($req2, 2);
					$res = $gDb->SQLNextRow(2);
					$gDb->SQLFermeQuery(2);
					if($res) // Flux toujours existant ?
					{
						$parID = $res[0];
						
						if($val[0]==171) // x400
						{
							if($ini_typeBase == "mysql")
								$req2 = 'SELECT VPA_ID FROM VAL_PAR_ADR JOIN PAR_FLOW USING (PFL_ID) JOIN ADRESSE USING (ADR_ID) WHERE PFL_ADR='.ADR_TYPE_X400." AND (PAR_ID=$parID OR PAR_ID IN (SELECT PAR_ID FROM PART WHERE GRP_ID=$parID AND PAR_ETAT!=".ETAT_SUPPR.")) AND VPA_VAL='${val[1]}'";
							else
								$req2 = 'SELECT VPA_ID FROM VAL_PAR_ADR JOIN PAR_FLOW ON VAL_PAR_ADR.PFL_ID=PAR_FLOW.PFL_ID JOIN ADRESSE ON  ADRESSE.ADR_ID=VAL_PAR_ADR.ADR_ID WHERE PFL_ADR='.ADR_TYPE_X400." AND (PAR_ID=$parID OR PAR_ID IN (SELECT PAR_ID FROM PART WHERE GRP_ID=$parID AND PAR_ETAT!=".ETAT_SUPPR.")) AND VPA_VAL='${val[1]}'";
							
							$gDb->SQLQuery($req2, 2);
							if(!$gDb->SQLNextRow(2))
								$typeval = 'x400';
							else
								$present = true;
							$gDb->SQLFermeQuery(2);
						}
						else if($val[0]==331) // mail
						{
							if($ini_typeBase == "mysql")
								$req2 = 'SELECT VPA_ID FROM VAL_PAR_ADR JOIN PAR_FLOW USING (PFL_ID) JOIN ADRESSE USING (ADR_ID) WHERE PFL_ADR='.ADR_TYPE_MAIL." AND (PAR_ID=$parID OR PAR_ID IN (SELECT PAR_ID FROM PART WHERE GRP_ID=$parID AND PAR_ETAT!=".ETAT_SUPPR.")) AND VPA_VAL='${val[1]}'";
							else
								$req2 = 'SELECT VPA_ID FROM VAL_PAR_ADR JOIN PAR_FLOW ON VAL_PAR_ADR.PFL_ID=PAR_FLOW.PFL_ID JOIN ADRESSE ON  ADRESSE.ADR_ID=VAL_PAR_ADR.ADR_ID WHERE PFL_ADR='.ADR_TYPE_MAIL." AND (PAR_ID=$parID OR PAR_ID IN (SELECT PAR_ID FROM PART WHERE GRP_ID=$parID AND PAR_ETAT!=".ETAT_SUPPR.")) AND VPA_VAL='${val[1]}'";							
								
							$gDb->SQLQuery($req2, 2);
							if(!$gDb->SQLNextRow(2))
								$typeval = 'mail';
							else
								$present = true;
							$gDb->SQLFermeQuery(2);
						}
					}
				}
				else if($row['SUI_ERR']==10022) // identifiant de l'魥tteur inconnu
				{
					if($val[0]==704)
					{
						$req2 = "SELECT PAR_ID FROM PART WHERE PAR_ID=${row['PAR_EMET_ID']} AND PAR_ETAT!=".ETAT_SUPPR;
						$gDb->SQLQuery($req2, 2);
						$res = $gDb->SQLNextRow(2);
						$gDb->SQLFermeQuery(2);
						if($res) // Part toujours existant ?
						{
							$parID = $row['PAR_EMET_ID'];
							$req2 = "SELECT IDE_ID FROM IDENT WHERE (PAR_ID=$parID OR PAR_ID IN (SELECT PAR_ID FROM PART WHERE GRP_ID=$parID AND PAR_ETAT!=".ETAT_SUPPR.")) AND IDE_VAL='${val[1]}'";
							$gDb->SQLQuery($req2, 2);
							if(!$gDb->SQLNextRow(2))
								$typeval = 'id_emet';
							else
								$present = true;
							$gDb->SQLFermeQuery(2);
						}
					}
				}
				else if($row['SUI_ERR']==10024) // identifiant du destinataire inconnu
				{
					if($val[0]==705)
					{
						$req2 = "SELECT PAR_ID FROM PART WHERE PAR_ID=${row['PAR_DEST_ID']} AND PAR_ETAT!=".ETAT_SUPPR;
						$gDb->SQLQuery($req2, 2);
						$res = $gDb->SQLNextRow(2);
						$gDb->SQLFermeQuery(2);
						if($res) // Part toujours existant ?
						{
							$parID = $row['PAR_DEST_ID'];
							$req2 = "SELECT IDE_ID FROM IDENT WHERE PAR_ID=$parID AND IDE_VAL='${val[1]}'";
							$gDb->SQLQuery($req2, 2);
							if(!$gDb->SQLNextRow(2))
								$typeval = 'id_dest';
							else
								$present = true;
							$gDb->SQLFermeQuery(2);
						}
					}
				}
				
				if($typeval!='' && $parID!=0)
				{
					$url = urlencode("${DEFAULT_PATH}actions/actSelectPart.php?type_val=$typeval&pfl_id=${val[0]}&new_val=${val[1]}&par_id=$parID");
					$detail .= " <img src='${pathStyle}imgs/icons/mini_add.png' style='vertical-align:top;cursor:pointer;' onclick=\"openPopUp('$url', '', 640, 480);\" title='$lang_lbl_ajouter'/>";
				}
				else if($present==true)
				{
					$detail .= " <img src='${pathStyle}imgs/icons/mini_info.png' style='vertical-align:top;' title='$lang_sui_hist_ds_info_modifie'/>";
				}
				
				$detail .= '</td>';
				if($i%2 == 1)
					$detail .= '</tr>';
				++$i;
			}
        }
	}
	
	if($row['SUI_REJOUE'] == 1)
	{
		$req2 = "SELECT CPT_ID FROM REJEU WHERE SUI_ID=${row['SUI_ID']}";
		$gDb->SQLQuery($req2, 2);
		$res = $gDb->SQLNextRow(2);
		$gDb->SQLFermeQuery(2);
		if($res)
			$detail .= "<tr><td><b>$lang_lbl_rejoue_par : </b>".getUserLogin($res[0]).'</td></tr>';
	}
	
	if($detail)
	{
		if($i%2 == 0)
			$detail .= '</tr>';
		$detail = hi_disp('<table>'.$detail.'</table>');
	}
	
	
	$displayedRows[$index] = '<row detail="'.$detail.'">';
	
	$caption = "";
	$icon ="";
	
	if ($row['FOR_ID'])
	{		
      	$deb = "";
		$fin = "";
		$icon = $pathFlow."style/imgs/icons/doc_new.gif";
		
		if ($tab_tdoc[$row['FOR_ID']]['TDOC_ETAT'] == ETAT_SUPPR)
		{
			$deb = AFF_SUPPR_DEB;
			$fin = " $lang_lbl_etat_suppr_ini ";
			$icon = $pathFlow."style/imgs/icons/doc_delete.gif";
		}
		
     	$caption = hi_disp($deb.$tab_tdoc[$row['FOR_ID']]['TDOC_NOM'].$fin);
      	$gDb->SQLFermeQuery(2);
	}
	
	$params = array();
	$params['sui_type'] = $row['SUI_TYPE'];
	$params['fic_id'] = $row['FIC_ID'];
	$params['for_id'] = $row['FOR_ID'];
	$params['from'] = 'his';
	$params['sui_id'] = $row['SUI_ID'];
	$params['tac_nom'] = $row['TAC_NOM'];
	
	$tab_mat_droit = false;
	$demat_cpt = "";
	$srap_id = "";
	$trap_id = "";
	
	if($row['TAC_NOM'] == "DEMAT") {
		$tab_mat_droit = ($row['SUI_TYPE'] <= SUI_TYPE_HIST && $row['SUI_DETAIL'] &&
				(droit(SDM, DROIT_EXEC+DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], null,null) || 
				droit(SDM, DROIT_EXEC+DROIT_LECT,$row['PAR_DEST_ID'],$row['PAR_EMET_ID'], null,null)));
		
		$temp = explode(";;", $row['SUI_DETAIL']);
		foreach($temp as $tt) {
			$val = explode("::", $tt);
			if ($val[0] == "2705") {
				$demat_cpt = $val[1];
				break;
			}
		}
	}
	else if($row['TAC_NOM'] == "RAPPROCH") {
		$tab_mat_droit = ($row['SUI_TYPE'] <= SUI_TYPE_HIST && $row['SUI_DETAIL'] &&
				(droit(SDO, DROIT_EXEC+DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row['TDOC_ID'],null) || 
				droit(SDO, DROIT_EXEC+DROIT_LECT,$row['PAR_DEST_ID'],$row['PAR_EMET_ID'], $row['TDOC_ID'],null)));
				
		$temp = explode(";;", $row['SUI_DETAIL']);
		foreach($temp as $tt) {
			$val = explode("::", $tt);
			if ($val[0] == "3708") $srap_id = $val[1];
			if ($val[0] == "3709") $trap_id = $val[1];
		}
	}
	$params['SRAP_ID'] = $srap_id;
	$params['TRAP_ID'] = $trap_id;
	$params['DEMAT_CPT'] = $demat_cpt;
	
	$droitVisu = $droitHIS_EXEC  || droit(SDO, DROIT_EXEC,$row['PAR_EMET_ID'], $row['PAR_DEST_ID'], $row['TDOC_ID'],null); 
	$droitRejeu = $droitHIS_MODIF || droit(SDO, DROIT_MODIF,$row['PAR_EMET_ID'], $row['PAR_DEST_ID'], $row['TDOC_ID'],null); 
	$params['droits'] = array('visu' => ($row['FIC_ID'] && $droitVisu),
							'download' => ($row['FIC_ID'] && droit(TEL, DROIT_LECT, $row['PAR_EMET_ID'], $row['PAR_DEST_ID'], $row['TDOC_ID'], null)),
							'rejeu' => $droitRejeu,
							'tab_mat' => $tab_mat_droit);
	
	$displayedRows[$index] .= '<item caption="'.$caption.'" icon="'.$icon.'" value="'.row_encode_JSON($params).'"/>';
		
	$caption = "";
	$toolTip = "";
	$icon = "";
	
	if ($row['AFX_ID'])
	{
      	$deb = "";
		$fin = "";
		$icon = $pathFlow."style/imgs/icons/exec.png";
      	
		if ($row['ACT_ETAT'] == ETAT_SUPPR)
		{
			$deb = AFF_SUPPR_DEB;
			$fin = " $lang_lbl_etat_inact_ini ";
			$icon = $pathFlow."style/imgs/icons/error.png";
		}
			
		$caption = hi_disp($deb.$row['ACT_LIBEL'].$fin);
	}	
	$displayedRows[$index] .= '<item caption="'.$caption.'" icon="'.$icon.'" toolTip="'.$toolTip.'"/>';

	$displayedRows[$index] .= '<item caption="'.sql2Date($row['SUI_DATE']).'"/>';
	
	$displayedRows[$index] .= '<item';
	if($row['SUI_SENS'] == RECEPTION)
		$displayedRows[$index] .= ' caption="'.$lang_sui_hist_grid_lbl_recept.'" toolTip="'.$lang_sui_hist_grid_lbl_recept_tooltip.'" icon="'.$pathFlow.'style/imgs/icons/retour.gif"';
	else if($row['SUI_SENS'] == EMISSION)
	$displayedRows[$index] .= ' caption="'.$lang_sui_hist_grid_lbl_emiss.'" toolTip="'.$lang_sui_hist_grid_lbl_emiss_tooltip.'" icon="'.$pathFlow.'style/imgs/icons/aller.gif"';
	$displayedRows[$index] .= '/>';
	
	$req = "SELECT PAR_NOM
			FROM PART 
				WHERE PAR_ID = ".$row['PAR_EMET_ID'];
		$gDb->SQLQuery($req, 2);
		$row2 = $gDb->SQLNextRow(2);
		$gDb->SQLFermeQuery(2);
		
	$displayedRows[$index] .= '<item caption="'.hi_disp($row2['PAR_NOM']).'"/>';
		
	$req = "SELECT PAR_NOM
			FROM PART 
				WHERE PAR_ID = ".$row['PAR_DEST_ID'];
		$gDb->SQLQuery($req, 2);
		$row2 = $gDb->SQLNextRow(2);
		$gDb->SQLFermeQuery(2);
	
	$displayedRows[$index] .= '<item caption="'.hi_disp($row2['PAR_NOM']).'"/>';
	
	$displayedRows[$index] .= '<item';
	if($row['SUI_REJOUE'] == 1)
	$displayedRows[$index] .= ' caption="'.$lang_sui_hist_grid_lbl_rejoue.'" icon="'.$pathFlow.'style/imgs/icons/maj.png"';
	else
	$displayedRows[$index] .= ' caption="" icon=""';
	$displayedRows[$index] .='/>';
	
	$displayedRows[$index] .= '<item';	
	switch($row['SUI_ETAT'])
	{
		case SUI_ETAT_OK :
			$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/rond_vert.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_ok.'"';
			break;
		case SUI_ETAT_INFO :
			$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/info.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_info.'"';
			break;
		case SUI_ETAT_AVERT :
			$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/alert.gif" toolTip="'.$lang_sui_hist_grid_lbl_etat_avert.'"';
			break;
		case SUI_ETAT_ERR :
			$displayedRows[$index] .= ' icon="'.$pathFlow.'style/imgs/icons/error.png" toolTip="'.$lang_sui_hist_grid_lbl_etat_err.'"';
			break;
		default :
	}
	$displayedRows[$index] .= ' caption="'.($row['SUI_ERR']==0?'':'('.$row['SUI_ERR'].') ').hi_disp($row['SUI_LIBEL']).'"';
	$displayedRows[$index] .= '/>';
	
//	echo '<item caption="'.hi_disp($row['SUI_LIBEL']).'"/>';
	
	$displayedRows[$index] .= '<item';
	if ($row['FLX_ID'])
	{
		$req = "SELECT FLX_LIBEL
				FROM FLUX 
				WHERE FLX_ID = ".$row['FLX_ID'];
		$gDb->SQLQuery($req, 2);
      	$row2 = $gDb->SQLNextRow(2);
      	$displayedRows[$index] .= ' caption="'.hi_disp($row2['FLX_LIBEL']).'"';
		$gDb->SQLFermeQuery(2);
	}
	$displayedRows[$index] .= '/>';
	$displayedRows[$index] .= '</row>';
	$index++;
}	
$gDb->SQLFermeQuery(1);

if (($forceSort) || ($pageNum < (int)($pagesNumber / 2)))
	for ($i = 0; $i < $index; $i++)	echo $displayedRows[$i];		
else
	for ($i = ($index-1); $i >= 0; $i--) echo $displayedRows[$i];		

echo '</databind>';

if ((!isset($_SESSION['HISTO_FILTER']['remember'])) || ($_SESSION['HISTO_FILTER']['remember']))
{
	$_SESSION['HISTO_FILTER'] = array (
	'remember'		=> true,
	'pageNum'		=> $pageNum,
	'pageSize' 		=> $pageSize,
	'nivHist'		=> $nivHist,
	'f_afx' 		=> $f_afx,
	'f_tdoc' 		=> $f_tdoc,
	'f_emetteur' 	=> $f_emetteur,
	'f_destinataire'=> $f_destinataire,
	'fromPE' 		=> $fromPE,
	'fromPD'		=> $fromPD,
	'f_date_deb'	=> $f_date_deb,
	'f_date_fin' 	=> $f_date_fin,
	'f_sens'		=> $f_sens,
	'f_etat' 		=> $f_etat,
	'f_rejoue'		=> $f_rejoue);
}
?>