<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:template match="LISTERECAP">
<HTML>
	<HEAD>
		<title>Liste Rcapitulative Invoice Manager v2</title>
		<link rel="stylesheet" href="index.css"></link>
		<script type="text/javascript" src="calc.js"></script>
	</HEAD>
	<BODY onload="calc();">
		<TABLE border="1" id="tableIndex">
			<TR>
				<TH>Date/heure constitution message</TH>
				<TH>Numro de la FACTURE</TH>
				<TH>Libell</TH>
				<TH>Date</TH>
				<TH>Type</TH>
				<TH>Fonction</TH>
				<TH>Date Emission</TH>
				<TH>Code EAN acheteur</TH>
				<TH>Nom acheteur</TH>
				
				<TH>Adresse acheteur</TH>
				<TH>SIREN acheteur</TH>
				<TH>NUM TVA acheteur</TH>
				
				<TH>Code EAN vendeur</TH>
				<TH>Nom vendeur</TH>
				
				<TH>Adresse vendeur</TH>
				<TH>SIREN vendeur</TH>
				<TH>NUM TVA vendeur</TH>
				
				<TH>Montant HT</TH>
				<TH>Montant TTC</TH>
				
				<TH>Devise</TH>
				
				<TH>Statut</TH>
				<TH>Date du Changement de Statut</TH>
				<TH>Sens</TH>
				<TH>Logiciel</TH>
				<TH>Code</TH>
				<TH>Archive</TH>
			</TR>
			<xsl:apply-templates select="FACTURE" /> 
		</TABLE>
	</BODY>
</HTML>
</xsl:template>

<xsl:template match="FACTURE">
	<TR>
		<xsl:if test="CODE!='0'">
			<xsl:attribute name="class">error</xsl:attribute>
		</xsl:if>
		<xsl:if test="CODE='0'">
			<xsl:attribute name="onmouseout">this.className=this.savClass;</xsl:attribute>
		</xsl:if>
		<TD><xsl:value-of select="DATE_INTER"/></TD>
		<TD><xsl:value-of select="NUM_FACT"/></TD>
		<TD><xsl:value-of select="LIB"/></TD>
		<TD><xsl:apply-templates select="DATE"/></TD>
		<TD>
			<xsl:choose>
   				<xsl:when test="TYPE='82'">Facture de service  compteur</xsl:when>
   				<xsl:when test="TYPE='83'">Note de crdit : Ajustements financiers</xsl:when>
   				<xsl:when test="TYPE='84'">Note de dbit</xsl:when>
   				<xsl:when test="TYPE='130'">Elments de facturation</xsl:when>
   				<xsl:when test="TYPE='325'">Facture Pro Format</xsl:when>
   				<xsl:when test="TYPE='380'">Facture commerciale</xsl:when>
   				<xsl:when test="TYPE='381'">Note de crdit : avoir</xsl:when>
   				<xsl:when test="TYPE='382'">Note de commission</xsl:when>
   				<xsl:when test="TYPE='383'">Note de crdit : Marchandises/services</xsl:when>
   				<xsl:when test="TYPE='384'">Facture corrige</xsl:when>
   				<xsl:when test="TYPE='385'">Facture consolide</xsl:when>
   				<xsl:when test="TYPE='386'">Facture d'acompte</xsl:when>
   				<xsl:when test="TYPE='389'">Facture d'autofacturation</xsl:when>
   				<xsl:when test="TYPE='390'">Facture ducroire</xsl:when>
   				<xsl:when test="TYPE='393'">Facture affactur</xsl:when>
   				<xsl:when test="TYPE='999'">Alerte Invoice Manager</xsl:when>
   				<xsl:otherwise>????</xsl:otherwise>
			</xsl:choose>
		</TD>
		<TD>
			<xsl:choose>
   				<xsl:when test="FONC='1'">Annulation</xsl:when>
   				<xsl:when test="FONC='5'">Remplacement</xsl:when>
   				<xsl:when test="FONC='7'">Duplicata</xsl:when>
   				<xsl:when test="FONC='9'">Original</xsl:when>
   				<xsl:when test="FONC='31'">Copie</xsl:when>
   				<xsl:when test="FONC='43'">Transmission supplmentaire</xsl:when>
   				<xsl:otherwise>????</xsl:otherwise>
			</xsl:choose>
		</TD>
		<TD><xsl:apply-templates select="DATE_EMI"/></TD>
		<TD><xsl:value-of select="CODE_FACT_A"/></TD>
		<TD><xsl:value-of select="NOM_FACT_A"/></TD>
		
		<TD><xsl:value-of select="ADR_FACT_A"/></TD>
		<TD><xsl:value-of select="SIREN_FACT_A"/></TD>
		<TD><xsl:value-of select="REF_TVA_FACT_A"/></TD>
		
		<TD><xsl:value-of select="CODE_FACT_PAR"/></TD>
		<TD><xsl:value-of select="NOM_FACT_PAR"/></TD>
		
		<TD><xsl:value-of select="ADR_FACT_PAR"/></TD>
		<TD><xsl:value-of select="SIREN_FACT_PAR"/></TD>
		<TD><xsl:value-of select="REF_TVA_FACT_PAR"/></TD>
		
		<TD class="money"><xsl:value-of select="MONT_HT"/></TD>
		<TD class="money"><xsl:value-of select="MONTTTC"/></TD>
		
		<TD><xsl:value-of select="DEVISE"/></TD>
		
		<TD>
			<xsl:choose>
   				<xsl:when test="STATUT='2'">Hors dmat</xsl:when>
   				<xsl:when test="STATUT='1'">En dmat</xsl:when>
   				<xsl:otherwise>????</xsl:otherwise>
			</xsl:choose>
		</TD>
		<TD>
			<xsl:choose>
   				<xsl:when test="STATUT='2'"><xsl:apply-templates select="TMA_DATE_SORTIE"/></xsl:when>
   				<xsl:when test="STATUT='1'"><xsl:apply-templates select="TMA_DATE_ENTREE"/></xsl:when>
   				<xsl:otherwise>????</xsl:otherwise>
			</xsl:choose>
		</TD>
		<TD>
			<xsl:choose>
   				<xsl:when test="SENS='2'">R</xsl:when>
   				<xsl:when test="SENS='1'">E</xsl:when>
   				<xsl:otherwise>????</xsl:otherwise>
			</xsl:choose>
		</TD>
		<TD><xsl:value-of select="LOGICIEL"/></TD>
		<TD><xsl:value-of select="CODE"/></TD>
		<TD><xsl:value-of select="FIC_ARCH"/></TD>
	</TR>
</xsl:template>

<xsl:template match="DATE">
	<xsl:call-template name="formatDate"/>
</xsl:template>
<xsl:template match="DATE_EMI">
	<xsl:call-template name="formatDate"/>
</xsl:template>
<xsl:template match="DATE_REC">
	<xsl:call-template name="formatDate"/>
</xsl:template>
<xsl:template match="CUR_DATE">
	<xsl:call-template name="formatDate"/>
</xsl:template>
<xsl:template match="TMA_DATE_ENTREE">
	<xsl:call-template name="formatDate2"/>
</xsl:template>
<xsl:template match="TMA_DATE_SORTIE">
	<xsl:call-template name="formatDate2"/>
</xsl:template>

<xsl:template name="formatDate">
	<xsl:if test="string-length(.)>=8">
		<xsl:value-of select="substring(.,7,2)"/>/<xsl:value-of select="substring(.,5,2)"/>/<xsl:value-of select="substring(.,1,4)"/>
		<xsl:if test="string-length(.)>=13">
			&#160;<xsl:value-of select="substring(.,9,2)"/>:<xsl:value-of select="substring(.,11,2)"/>:<xsl:value-of select="substring(.,13,2)"/>
		</xsl:if>
	</xsl:if>
</xsl:template>
<xsl:template name="formatDate2">
	<xsl:if test="string-length(.)>=10">
		<xsl:value-of select="substring(.,9,2)"/>/<xsl:value-of select="substring(.,6,2)"/>/<xsl:value-of select="substring(.,1,4)"/>
		<xsl:if test="string-length(.)>=19">
			&#160;<xsl:value-of select="substring(.,12,2)"/>:<xsl:value-of select="substring(.,15,2)"/>:<xsl:value-of select="substring(.,18,2)"/>
		</xsl:if>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>
