<?php
$DEFAULT_PATH = str_repeat("../", (substr_count($_SERVER["PHP_SELF"], "/") - 2));
require_once ($DEFAULT_PATH."struct.php");
$droitRole = SDO;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."suivi/rapproch/sui_rap_utils.php");

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template
$page_courante = "suivi/rapproch/sui_rap_actDetail.php";

$vtp = new VTemplate;

$srap_id = pget('srap_id');
if (strlen($srap_id)==0) $srap_id = pget('SRAP_ID');
$trap_id = pget('trap_id');
if (strlen($trap_id)==0) $trap_id = pget('TRAP_ID');
$clt_id  = $_SESSION["CLT_ID"];

if ($srap_id && !$trap_id){
	$req = "SELECT TRAP_ID 
			FROM SUI_RAPPROCH 
			WHERE SRAP_ID = $srap_id";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$trap_id = $row["TRAP_ID"];
	$gDb->SQLFermeQuery(1);
}

$form = $vtp->Open($DEFAULT_PATH."template/rapp_detail_form.vtp");
$vtp->addSession($form, "global");
$vtp->setVar($form, "global.help_id", "20040202204254");
//$vtp->setVar($form, "global.srap_id", $srap_id);

//Récupération des libellés des données
$req = "SELECT TRAP_LIBELLE, TRAP_FIC_TRAD, TRAP_SENS,
			TRAP_LIB_DG_1, TRAP_LIB_DG_2, TRAP_LIB_DG_3, TRAP_LIB_DG_4, TRAP_LIB_DG_5
		FROM TYPE_RAPPROCH 
		WHERE TRAP_ID = $trap_id";
$gDb->SQLQuery($req, 1);
$row = $gDb->SQLNextRow(1);
$gDb->SQLFermeQuery(1);

$trap_libelle 	= $row["TRAP_LIBELLE"];
$trap_fic_trad 	= $row["TRAP_FIC_TRAD"];
$trap_sens		= $row["TRAP_SENS"];

$title = str_replace(array("%TRAPLIBELLE%", "%TRAPID%"), array($trap_libelle, $srap_id), $lang_sui_rap_act_detail_title);
$vtp->setVar($form, "global.title", addslashes($title));
$vtp->setVar($form, "global.icon", $pathStyle."imgs/icons/title/sui_rap.gif");

for($i = 1; $i <= 5; ++$i)
	${"DON_GEN_$i"} = (!empty($row["TRAP_LIB_DG_$i"])? $row["TRAP_LIB_DG_$i"] : "Don gen $i");
	
if ($trap_fic_trad)
{
	$xsl_params = array();
	if (!apply_xsl("sui_rap_trad.xsl", $trap_fic_trad, $xslt_params, $result))
		$msg = $result;
	else
		eval($result);	//DON_TETE_i, DON_LIGNE_i
}

//Construction des paramètres GET pour les données des lignes
$get_don_ligne = "";
for ($i = 1; $i <= 5; $i++)
	$get_don_ligne .= "&DON_LIGNE_$i=".urlencode(${"DON_LIGNE_$i"});
	
//$vtp->setVar($form, "global.get_don_ligne", $get_don_ligne);

/*
 * ENTETE
 */

$req = "SELECT SRAP_ID, FIC_ID, SRAP_DATETRAIT, SRAP_LAST_ETAT, SRAP_LAST_LIB, SRAP_DON_1, SRAP_DON_2,
			SRAP_DON_3, SRAP_DON_4, SRAP_DON_5, SRAP_DON_6, SRAP_DON_7, SRAP_DON_8, SRAP_DON_9,
			SRAP_DON_10, PAR_EMET_ID, PAR_DEST_ID, TDOC_ID, SRAP_DATECREAT,
			PART_EMET.PAR_NOM AS PAR_EMET_NOM, PART_DEST.PAR_NOM AS PAR_DEST_NOM,
			PART_EMET.PAR_ETAT AS PAR_EMET_ETAT, PART_DEST.PAR_ETAT AS PAR_DEST_ETAT
		FROM SUI_RAPPROCH, PART AS PART_EMET, PART AS PART_DEST
		WHERE SRAP_ID = $srap_id
			AND PART_EMET.PAR_ID = PAR_EMET_ID
			AND PART_DEST.PAR_ID = PAR_DEST_ID";
//print $req;
$gDb->SQLQuery($req, 1);
$row = $gDb->SQLNextRow(1);

//Libellés container
$vtp->setVar($form, "global.lbl_entete", $lang_sui_rap_act_detail_lbl_entete);
$vtp->setVar($form, "global.lbl_ligne", $lang_sui_rap_act_detail_lbl_ligne);
$vtp->setVar($form, "global.lbl_histo", $lang_sui_rap_act_detail_lbl_histo);

if (!$row)
	$vtp->setVar($form, "global.message", $lang_sui_rap_act_detail_msgerr_nosuivi);
else
	$vtp->setVar($form, "global.message", $msg);

//Variables statiques du form (input hidden)
$vtp->addSession($form, "form_input_hidden");
$vtp->setVar($form, "form_input_hidden.name", "srap_id");
$vtp->setVar($form, "form_input_hidden.value", $srap_id);
$vtp->closeSession($form, "form_input_hidden");

$vtp->addSession($form, "form_input_hidden");
$vtp->setVar($form, "form_input_hidden.name", "trap_id");
$vtp->setVar($form, "form_input_hidden.value", $trap_id);
$vtp->closeSession($form, "form_input_hidden");


//EMETTEUR
$content = addslashes($row['PAR_EMET_NOM']);
$javascript = "";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_sui_rap_grid_head_emet);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//DESTINATAIRE
$content = addslashes($row['PAR_DEST_NOM']);
$javascript = "";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_sui_rap_grid_head_dest);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//DATE DE CREATION
$content = sql2Date($row['SRAP_DATECREAT']);
$javascript = "";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_sui_rap_grid_head_creat_tooltip);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");


//DATE DE TRAITEMENT
$content = sql2Date($row['SRAP_DATETRAIT']);
$javascript = "";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_sui_rap_grid_head_trait_tooltip);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//ETAT
$etat = get_etat_look($row['SRAP_LAST_ETAT']);
$content = "";
$javascript = "var itm = new Prologue.item('".$etat['toolTip']."','".$etat['icon']."');
				document.write(itm.html());";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_sui_rap_grid_head_etat);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//LIBELLE
$content = $row["SRAP_LAST_LIB"];
$javascript = "";

$vtp->addSession($form, "form_field");
$vtp->setVar($form, "form_field.caption", $lang_sui_rap_grid_head_libl);
$vtp->setVar($form, "form_field.javascript", $javascript);
$vtp->setVar($form, "form_field.content", $content);
$vtp->closeSession($form, "form_field");

//DON GEN

//libellé container
$vtp->setVar($form, "global.lbl_donnee_entete", addslashes($lang_sui_rap_act_detail_lbl_donnee_entete));


for ($i = 1; $i <= 10; $i++) {
	if ($row["SRAP_DON_".$i])
	{
		$libel = "";
		if ($i <= 5)
			$libel = ${"DON_GEN_$i"};
		else
			$libel = ${"DON_TETE_".($i - 5)};
		$content = $row["SRAP_DON_".$i];
				
		$javascript = "";
		$vtp->addSession($form, "form_don_gen_field");
		$vtp->setVar($form, "form_don_gen_field.caption", $libel);
		$vtp->setVar($form, "form_don_gen_field.javascript", $javascript);
		$vtp->setVar($form, "form_don_gen_field.content", $content);
		$vtp->closeSession($form, "form_don_gen_field");
	}
}


if ($row['FIC_ID'] && droit(SDO, DROIT_EXEC,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row["TDOC_ID"],null)) {
	$javascript = "var btn = new Prologue.button('$lang_lbl_visu', 'openPopUp(\'".$pathFlow."actions/actListing_fic.php?fic_id=".$row['FIC_ID']."\');', '".$pathStyle."imgs/icons/loupe.gif');
					btn.create();";
	
	$vtp->addSession($form, "form_button");
	$vtp->setVar($form, "form_button.javascript", $javascript);
	$vtp->closeSession($form, "form_button");
}

if ($row['FIC_ID'] && droit(TEL, DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row["TDOC_ID"],null)) {
	$javascript = "var btn = new Prologue.button('$lang_lbl_telecharger', 'changePage(\'".$pathFlow."actions/actTelecharge.php?fic_id=".$row['FIC_ID']."\');', '".$pathStyle."imgs/icons/save.png');
					btn.create();";
	
	$vtp->addSession($form, "form_button");
	$vtp->setVar($form, "form_button.javascript", $javascript);
	$vtp->closeSession($form, "form_button");
}

$javascript = "var btn = new Prologue.button('$lang_lbl_retour', 'history.go(-1);', '".$pathStyle."imgs/icons/retour.gif');
				btn.create();";

$vtp->addSession($form, "form_button");
$vtp->setVar($form, "form_button.javascript", $javascript);
$vtp->closeSession($form, "form_button");

$head_javascript = "
var histo_grid_dS = Prologue.Flow.path+'suivi/rapproch/sui_rap_histo_dSGrid.php?srap_id_srap=$srap_id&trap_sens=$trap_sens&trap_id=$trap_id';
var liste_grid_dS = Prologue.Flow.path+'suivi/rapproch/sui_rap_liste_dSGrid.php?srap_id_srap=$srap_id.$get_don_ligne';

function select_histo () {
	Prologue.grid.unselect('histo_grid');
	var sel = Prologue.grid.getSelected('liste_grid');
	if(sel != -1) {
		var srap_id = sel.value
	}
	Prologue.grid.selectRowByValue('histo_grid', srap_id);
}

function select_liste () {
	Prologue.grid.unselect('liste_grid');
	var sel = Prologue.grid.getSelected('histo_grid');
	if(sel != -1) {
		var srap_id = sel.value
	}
	Prologue.grid.selectRowByValue('liste_grid', srap_id)
}	
";

include($DEFAULT_PATH."header.php");
$vtp->setVar($form, "global.head_javascript", $head_javascript);
$vtp->setVar($form, "global.page_headers", $page_headers);
$vtp->closeSession($form, "global");
$vtp->Display();
?>