<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."suivi/rapproch/sui_rap_utils.php");

$droitRole = SDO;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

$cptID = $_SESSION['CPT_ID'];
$cltID = $_SESSION['CLT_ID'];

$where = "";

/********************/
/* DEBUT PARAMETRES */
/* ******************/
// param?tres
$f_emetteur		= pget('f_emetteur');		//filtre ?metteur  
$f_destinataire	= pget('f_destinataire');	//filtre destinataire

$f_etat 	= pget("f_etat");
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget("f_date_fin");

$TRAP_ID	= pget("TRAP_ID");
$SRAP_ID	= pget("SRAP_ID");
$TRAP_SENS	= pget("TRAP_SENS");

$cltID 		= $_SESSION['CLT_ID'];

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

/******************/
/* FIN PARAMETRES */
/* ****************/



/******************************************************/
/* DEBUT DONNEES SPECIFIQUES AU TYPE DE RAPPROCHEMENT */
/* ****************************************************/

//Récupération des libellés des données
$req = "SELECT TRAP_LIBELLE, TRAP_FIC_TRAD,
			TRAP_LIB_DG_1, TRAP_LIB_DG_2, TRAP_LIB_DG_3, TRAP_LIB_DG_4, TRAP_LIB_DG_5
		FROM TYPE_RAPPROCH 
		WHERE TRAP_ID = $TRAP_ID";
$gDb->SQLQuery($req, 1);
$row = $gDb->SQLNextRow(1);
$gDb->SQLFermeQuery(1);

$TRAP_LIBELLE 	= $row["TRAP_LIBELLE"];
$TRAP_FIC_TRAD 	= $row["TRAP_FIC_TRAD"];

for($i = 1; $i <= 5; ++$i)
	${"DON_GEN_$i"} = ($row["TRAP_LIB_DG_$i"]? $row["TRAP_LIB_DG_$i"] : "Don gen $i");

if ($TRAP_FIC_TRAD)
{
	$xsl_params = array();
	if (!apply_xsl("sui_rap_trad.xsl", $TRAP_FIC_TRAD, $xslt_params, $result))
		$msg = $result;
	else
		eval ($result);	//DON_TETE_i, DON_LIGNE_i
}
/****************************************************/
/* FIN DONNEES SPECIFIQUES AU TYPE DE RAPPROCHEMENT */
/* **************************************************/

Construit_restriction($droitRole, "SUI_RAPPROCH.PAR_EMET_ID", "SUI_RAPPROCH.PAR_DEST_ID", "SUI_RAPPROCH.TDOC_ID", null, $restrict, $restrictFiltreEmet, $restrictFiltreDest, $restrictFiltreTdoc, $restrictFiltreFam);


/**********************************/
/* DEBUT CONSTRUCTION DES FILTRES */
/* ********************************/
//R?cup?ration des partenaire pour filtre ?metteur
//rajout des restrictions dans le filtre (implicite)


// traitement des dates
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');

if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SRAP_DATETRAIT BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SRAP_DATETRAIT BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SRAP_DATETRAIT >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SRAP_DATETRAIT >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SRAP_DATETRAIT <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SRAP_DATETRAIT <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}

// Criteres partenaires
$f_emetteur		= pget('f_emetteur');		//filtre émetteur
$f_destinataire	= pget('f_destinataire');	//filtre destinataire
$fromPE 		= pget('fromPE');
$fromPD 		= pget('fromPD');

if ($fromPD>0 && $f_destinataire)
{
	if ($fromPD==2)// part + fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		if ($fils)
		$filsD=$f_destinataire.", ".$fils;
		else $filsD=$f_destinataire;

	}
	if ($fromPD==3) // que les fils
	{
		$fils="";
		trouve_fils($f_destinataire);
		$filsD=$fils;

	}
	if ($fromPD==4) //que le part
	{
		$filsD=$f_destinataire;
	}
}
if ($fromPE>0 && $f_emetteur)
{
	if ($fromPE==2)// part + fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		if ($fils)
		$filsE=$f_emetteur.", ".$fils;
		else $filsE=$f_emetteur;
	}
	if ($fromPE==3) // que les fils
	{
		$fils="";
		trouve_fils($f_emetteur);
		$filsE=$fils;
	}
	if ($fromPE==4) //que le part
	{
		$filsE=$f_emetteur;
	}
}

//Traitement de l'émetteur

if ($fromPD>0){	if ($f_destinataire) $where .=" and PAR_DEST_ID in ($filsD)";}
else {if ($f_destinataire) $where .= " and PAR_DEST_ID = '".dblQ($f_destinataire)."'";}

if ($fromPE>0){ if ($f_emetteur) $where .=" and PAR_EMET_ID in ($filsE)";}
else {if ($f_emetteur)	$where .= " and PAR_EMET_ID = '".dblQ($f_emetteur)."'";}

/*
if ($f_destinataire)
	$where .= " AND PARD.PAR_ID = $f_destinataire ";
	
if ($f_emetteur)
	$where .= " AND PARE.PAR_ID = $f_emetteur ";
*/

if ($f_etat==3 || $f_etat==4)  // cas particuliers ETAT_RAPPR_OK et ETAT_RAPPR_NOK
{
	// on cherche les LIGNES de rapprochement correpondantes à l'état cherché
	$req = "SELECT DISTINCT SRAP_ID_SRAP FROM SUI_RAPPROCH WHERE SUI_RAPPROCH.SRAP_LAST_ETAT = $f_etat";
	$gDb->SQLQuery($req, 1);
	$i = 0;
	while ($row = $gDb->SQLNextRow(1))
	{
		if($i>0)
			$srap_id_srap .= ",".$row['SRAP_ID_SRAP'];
		else
			$srap_id_srap = $row['SRAP_ID_SRAP'];
		$i++;
	}
	$gDb->SQLFermeQuery(1);

	$where .= " AND SUI_RAPPROCH.SRAP_ID IN ($srap_id_srap) ";
}
else if($f_etat) // autre état spécifié
{
	$where .= " AND SUI_RAPPROCH.SRAP_LAST_ETAT = $f_etat ";
}
	
if (!empty($SRAP_ID) && $SRAP_ID)
	$SRAP = " AND SRAP_ID = $SRAP_ID ";
else
	$SRAP = "";
	
//Récupération des partenaires
$tab_part = array();
$req = "SELECT PAR_ID, PAR_NOM, PAR_ETAT  
		FROM PART";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_part[$row['PAR_ID']] = array("PAR_NOM" => $row['PAR_NOM'],
									  "PAR_ETAT" => $row['PAR_ETAT']);
$gDb->SQLFermeQuery(1);

//Récupération des libellés de suivi de rapprochement
$req = "SELECT SRAP_ID, TRAP_LIBELLE 
		FROM TYPE_RAPPROCH, SUI_RAPPROCH 
		WHERE TYPE_RAPPROCH.TRAP_ID = SUI_RAPPROCH.TRAP_ID";
$gDb->SQLQuery($req, 1);
while ($row = $gDb->SQLNextRow(1))
	$tab_trap_libelle[$row['SRAP_ID']] = $row['TRAP_LIBELLE'];
$gDb->SQLFermeQuery(1);


/********************************/
/* FIN CONSTRUCTION DES FILTRES */
/* ******************************/

$req = "SELECT SQL_CALC_FOUND_ROWS SRAP_ID, FIC_ID, SRAP_DATECREAT, SRAP_LAST_ETAT, SRAP_LAST_LIB,
			SRAP_DON_1, SRAP_DON_2, SRAP_DON_3, SRAP_DON_4, SRAP_DON_5,
			SRAP_DON_6, SRAP_DON_7, SRAP_DON_8, SRAP_DON_9, SRAP_DON_10, PAR_EMET_ID,
			PAR_DEST_ID, TDOC_ID, SRAP_NB_JOURCREAT, SRAP_NB_JOURTRAIT, SRAP_DATETRAIT
		FROM SUI_RAPPROCH 
		WHERE TRAP_ID =".$TRAP_ID.$SRAP." 
			AND SRAP_TYPE = 1
			$where
			$restrict  
		ORDER BY SRAP_DATECREAT DESC";

$champs = array();
/*
$champs[] = array("nom" => " ", "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => " ", "toolTip" => "", "sortMode" => "1");
$champs[] = array("nom" => " ", "toolTip" => "", "sortMode" => "1");
*/
$champs[] = array("nom" => $lang_sui_rap_grid_head_creat, "toolTip" => $lang_sui_rap_grid_head_creat_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_rap_grid_head_trait, "toolTip" => $lang_sui_rap_grid_head_trait_tooltip, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_rap_grid_head_emet, "toolTip" => $lang_sui_rap_grid_head_emet, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_rap_grid_head_dest, "toolTip" => $lang_sui_rap_grid_head_dest, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_rap_grid_head_etat, "toolTip" => $lang_sui_rap_grid_head_etat, "sortMode" => "2");
$champs[] = array("nom" => $lang_sui_rap_grid_head_libl, "toolTip" => $lang_sui_rap_grid_head_libl, "sortMode" => "1");
for ($i = 1; $i <= 5; $i++)
	$champs[] = array("nom" =>  ${"DON_GEN_".$i}, "toolTip" =>  ${"DON_GEN_".$i}, "sortMode" => "1");

$gDb->SQLFermeQuery(1);
$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row2 = $gDb->SQLNextRow(2);
$maxRow = $row2['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{
	/*
	 * ======================
	 * Construction du détail
	 * ======================
	 */
	$detail = "";
	
	//Affiche message d'erreur
	//========================
	if($msg)
		$detail .= "<tr><td colspan=2><img src=\"${pathStyle}imgs/icons/alert.gif\"/>&nbsp;<b>$msg</b></td></tr>";
	
		
	//Affiche les entêtes
	//===================
	$cell = $tete = 0;
	
	for($i = 6; $i <= 10; ++$i)
	{
		$tete++;		
		if ($row["SRAP_DON_".$i])
		{				
			$libel = ((${"DON_TETE_".$tete})? ${"DON_TETE_".$tete}: "Donnée $tete");
			$tmp = "<b>$libel</b></td>";
			$tmp .= "<td>".hi_disp($row["SRAP_DON_".$i])."</td>";
			
			if($cell == 0)
				$detail .= "<tr><td>$tmp";
			else if($cell == 2)
				$detail .= "<td>$tmp</tr>";
			else
				$detail .= "<td>$tmp";
			$cell = ($cell + 1)%3;
		}
	}
	if($cell > 0)
		$detail .= "</tr>";

	if($detail)
		$detail = "<table>$detail</table>";

	echo '<row detail="'.hi_disp($detail).'">';
	
	$params = array();
	$params['sui_type'] = $row['SUI_TYPE'];
	$params['fic_id'] = $row['FIC_ID'];
	$params['for_id'] = $row['FOR_ID'];
	$params['srap_id'] = $row['SRAP_ID'];
	$params['trap_id'] = $TRAP_ID;
	
	$params['droits'] = array('visu' => ($row['FIC_ID'] && droit(SDO, DROIT_EXEC,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row["TDOC_ID"],null)),
							'download' => ($row['FIC_ID'] && droit(TEL, DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'], $row["TDOC_ID"],null)),
							'detail' => true);
	
	$date = sql2Date($row['SRAP_DATECREAT']);
	echo '<item caption="'.$date.'" value="'.row_encode_JSON($params).'"/>';
	
	$date = sql2Date($row['SRAP_DATETRAIT']);
	echo '<item caption="'.$date.'"/>';
	
	$emet = $tab_part[$row['PAR_EMET_ID']]["PAR_NOM"].(($tab_part[$row['PAR_EMET_ID']]["PAR_ETAT"] == ETAT_SUPPR)?(" (S)"):(""));
	
	$dest = $tab_part[$row['PAR_DEST_ID']]["PAR_NOM"].(($tab_part[$row['PAR_DEST_ID']]["PAR_ETAT"] == ETAT_SUPPR)?(" (S)"):(""));
	
	echo '<item caption="'.$emet.'"/>';
	echo '<item caption="'.$dest.'"/>';
	
	
	if ($row['SRAP_LAST_ETAT'] == ETAT_RAPPR_RAPPROCHE)
	{
		$req = "SELECT DISTINCT SRAP_LAST_ETAT FROM SUI_RAPPROCH WHERE SUI_RAPPROCH.SRAP_ID_SRAP =".$row['SRAP_ID'];
		$gDb->SQLQuery($req, 6);
		$rappOK = false;
		$rappNOK = false;
		while ($row6 = $gDb->SQLNextRow(6))
		{
			if ($row6['SRAP_LAST_ETAT'] == ETAT_RAPPR_OK)
			{
				$rappOK = true;
			}
			if ($row6['SRAP_LAST_ETAT'] == ETAT_RAPPR_NOK)
			{
				$rappNOK = true;
			}
		}
		$gDb->SQLFermeQuery(6);
		if (($rappOK) && ($rappNOK))
		{
			$row['SRAP_LAST_ETAT'] = ETAT_RAPPR_OKPARTIEL;
		}
		else
		{
			if ($rappOK)
			{
				$row['SRAP_LAST_ETAT'] = ETAT_RAPPR_OK;
			}
			if ($rappNOK)
			{
				$row['SRAP_LAST_ETAT'] = ETAT_RAPPR_NOK;
			}
		}
	}
	$etat = get_etat_look($row['SRAP_LAST_ETAT']);
	/////
	
    echo '<item icon="'.$etat['icon'].'" toolTip="'.$etat['toolTip'].'"/>';
    echo '<item caption="'.hi_disp($row['SRAP_LAST_LIB']).'"/>';
    
    for ($j = 1; $j <= 5; $j++)
		echo '<item caption="'.hi_disp($row["SRAP_DON_".$j]).'"/>';
		
	echo '</row>';
}
$gDb->SQLFermeQuery(1);
echo '</databind>';

if ((!isset($_SESSION['RAPPROCH_FILTER_'.$TRAP_ID]['remember'])) || ($_SESSION['RAPPROCH_FILTER_'.$TRAP_ID]['remember']))
{
	$_SESSION['RAPPROCH_FILTER_'.$TRAP_ID] = array (
	'remember'		=> true,
	'pageNum'		=> $pageNum,
	'pageSize' 		=> $pageSize,
	'f_emetteur' 	=> $f_emetteur,
	'f_destinataire'=> $f_destinataire,
	'fromPE' 		=> $fromPE,
	'fromPD'		=> $fromPD,
	'f_date_deb'	=> $f_date_deb,
	'f_date_fin' 	=> $f_date_fin,
	'f_etat' 		=> $f_etat);
}
?>

