<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");	//liste des define

$lmcse = DROIT_LECT;
$page_courante = "suivi/recap/sui_recap.php";

require_once($DEFAULT_PATH."flow.php"); //session_start, inclusions, créations des variables $gDb et $erreur_connect
require_once($DEFAULT_PATH."flow_tools.php"); //fonctions utilitaires (pget,...)
require_once($DEFAULT_PATH."vtemplate.class.php");
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

require_once($DEFAULT_PATH."param.php");
require_once($DEFAULT_PATH."inc/php/datasource.class.php");

if (droit(HIS,$lmcse,null,null,null,null))
	$droitRole = HIS;
else
	$droitRole = SDO;

$cltID = $_SESSION['CLT_ID'];

$vtp = new VTemplate;
$form = $vtp->Open($DEFAULT_PATH."template/page_filtre_tb.vtp");
$vtp->addSession($form, "global");

$vtp->setVar($form, "global.head_javascript", "");

//date par défaut = date d'aujourd'hui - une semaine
$dateJour = date ('d/m/Y', mktime(0, 0, 0, date('m'), date('d'), date('Y')) - (DateDefaut));
($ini_date	= pget('ini_date'))?($f_date_deb = $dateJour):($f_date_deb = pget('f_date_deb'));
$f_partenaire = pget('f_partenaire');
$f_part_crit = pget('f_part_crit');
$f_date_fin = pget('f_date_fin');
$f_sens = pget('f_sens');
$f_recurse = pget('f_recurse'); // la page pointe sur elle même

$title = $lang_menu_lbl_recap_tooltip;

if ($f_recurse || !$remember_filters)
	$_SESSION['RECAPDOC_FILTER']['remember'] = false;
else
{
	// On restaure les derniers parametres utilises pour le filtre
	$_SESSION['RECAPDOC_FILTER']['remember'] = true;

	if (isset($_SESSION['RECAPDOC_FILTER']))
	{
		if (isset($_SESSION['RECAPDOC_FILTER']['f_partenaire'])) $f_partenaire = $_SESSION['RECAPDOC_FILTER']['f_partenaire'];
		if (isset($_SESSION['RECAPDOC_FILTER']['f_part_crit'])) $f_part_crit = $_SESSION['RECAPDOC_FILTER']['f_part_crit'];
		if (isset($_SESSION['RECAPDOC_FILTER']['f_date_deb'])) $f_date_deb = $_SESSION['RECAPDOC_FILTER']['f_date_deb'];
		if (isset($_SESSION['RECAPDOC_FILTER']['f_date_fin'])) $f_date_fin = $_SESSION['RECAPDOC_FILTER']['f_date_fin'];
		if (isset($_SESSION['RECAPDOC_FILTER']['f_sens'])) $f_sens = $_SESSION['RECAPDOC_FILTER']['f_sens'];
	}
}

$vtp->setVar($form, 'global.title', addslashes($title));
$vtp->setVar($form, 'global.help_id', 'suivi_recap');
$vtp->setVar($form, 'global.icon', $pathStyle.'imgs/icons/title/recap.png');

/***  Création du filtre ***/

$filtre = array();

$sync=1;

//Date deb
$filtre[] = array("id_filtre" => "f_date_deb", "type_filtre" => "prlFiltreField.types.prlComboDate",
					"libelle_filtre" => $lang_sui_doc_filtre_lbl_datedeb,
					"value_filtre" => $f_date_deb);

//Date fin
$filtre[] = array("id_filtre" => "f_date_fin", "type_filtre" => "prlFiltreField.types.prlComboDate",
					"libelle_filtre" => $lang_sui_doc_filtre_lbl_datefin,
					"value_filtre" => $f_date_fin);

$filtre[] = array("id_filtre" => "new_line");

//Partenaire
$filtre[] = array("id_filtre" => "f_partenaire", "type_filtre" => "prlFiltreField.types.prlComboTree",
					"libelle_filtre" => $lang_lbl_partenaire,
					"value_filtre" => $f_partenaire,
					"defaultcaption_filtre" => getPartnerName($f_partenaire),
					"loadondropdown_filtre" => true,
					"ds_filtre" => $pathFlow."dataSources/dSPartenaires.php?droitRole=$droitRole&showNull=1");

//Criteres Partenaire
require $DEFAULT_PATH."dataSources/dSCriteres.php";
$filtre[] = array("id_filtre" => "f_part_crit", "type_filtre" => "prlFiltreField.types.prlComboList",
					"libelle_filtre" => $lang_lbl_critere,
					"value_filtre" => $f_part_crit,
					"ds_filtre" => $dataSrc);

$filtre[] = array("id_filtre" => "new_line");

//Sens
$showNull = "1";
require $DEFAULT_PATH."dataSources/dSComboSens.php";
$filtre[] = array("id_filtre" => "f_sens", "type_filtre" => "prlFiltreField.types.prlComboList",
					"libelle_filtre" => $lang_sui_hist_filtre_lbl_sens,
					"value_filtre" => $f_sens,
					"ds_filtre" => $dataSrc);

mkFiltre($vtp, $form, $filtre);

/*** Javascript pour le contenu de la page ***/

$javascript = "
	function addDocPanel(obj, title, content)
	{
		var div = document.createElement('div');
		div.style.padding = '15px';
		div.style.position = 'relative';
		div.style.styleFloat = 'left'; // pour IE
		div.style.cssFloat = 'left'; // pour le reste des navigateurs
		var docPanel = new prlPanel (title, '".$pathStyle."imgs/icons/document.png');
		docPanel.content = content;
		docPanel.open = true;
		div.innerHTML = docPanel.html();
		obj.appendChild(div);
	}
	
	function page_refresh()
	{
		var param = filList.getInfo();  // on récupère la sélection du filtre
		
		var obj = document.getElementById('recapitulatif');
		obj.innerHTML = '';
		
		var req = new Prologue.ajax.request('".$pathFlow."suivi/recap/sui_recap_dSPart.php?'+param);
		req.send();
		var resp = req.getXML();
		var xRoot = resp.documentElement;
		for (var i=0; i<xRoot.childNodes.length; i++)
		{
			var xNode = xRoot.childNodes[i];
			var partNom = urldecode(xNode.attributes.getNamedItem('caption').value);
			var partId = xNode.attributes.getNamedItem('id').value;
			
			var content = new Prologue.grid('grid');
			content.async = false;
			content.multiSelect = false;
			content.checkBoxes = false;
			content.columns.addLastColumn = false;
			content.dataSource = Flow.path+'suivi/recap/sui_recap_dSTDoc.php?par_id='+partId+param;
			content.load();
			
			addDocPanel(obj, partNom, content.html());
		}		
	}
	
	function page_print()
	{
		window.parent.frames['ifmMain'].print();
	}

	// on surcharge car il n'y a pas de grid dans cette page, mais on veut utiliser les filtres...
	prlPage.prototype.gridReload = function ()
	{
		page_refresh();
	}
";
$vtp->setVar($form, "global.javascript", $javascript);

$vtp->addSession($form, "option_page_refresh");
$vtp->setVar($form, "option_page_refresh.label_refresh", $lang_ds_action_reload_caption);
$vtp->setVar($form, "option_page_refresh.function_refresh", "page_refresh();");

$vtp->addSession($form, "option_page_print");
$vtp->setVar($form, "option_page_print.label_print", $lang_lbl_print);
$vtp->setVar($form, "option_page_print.function_print", "page_print();");

if($f_recurse)
{
	$vtp->addSession($form, "option_page_goback");
	$vtp->setVar($form, "option_page_goback.label_goback", $lang_lbl_retour);
	$vtp->setVar($form, "option_page_goback.function_goback", "history.go(-1);");
}

/***	Contenu de la page  ***/

$content = "<center><div id='recapitulatif' style='margin:15px;'/></center>";
$vtp->setVar($form, "global.content", $content);

/*** Javascript global ***/

$body_js = "
page_refresh();
";

$vtp->setVar($form, "global.body_javascript", $body_js);

include($DEFAULT_PATH."header.php");
$page_headers .= "<link href='".$pathStyle."recap.css' rel='stylesheet' type='text/css'/>";
$vtp->setVar($form, "global.page_headers", $page_headers);
$vtp->closeSession($form, "global");
$vtp->Display();
?>