<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow_tools.php");


$page_courante = "suivi\recap\sui_recap_dSTDoc.php";


$droitRole = DOC;//droit de gestion des types de documents
$lmcse = DROIT_LECT;//droits en lecture

$partId = pget('par_id');
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
$f_sens = pget('f_sens');

$cltID = $_SESSION['CLT_ID'];

$champs = array();
$champs[] = array("nom" => "$lang_lbl_document ($lang_lbl_format)", "toolTip" => $lang_flux_tdoc_grid_head_nom, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_as2_grid_lbl_etat_traite, "toolTip" => $lang_sui_as2_grid_lbl_etat_traite, "sortMode" => "1");
$champs[] = array("nom" => $lang_ds_progress_progress, "toolTip" => $lang_ds_progress_progress, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_erreur, "toolTip" => $lang_lbl_erreur, "sortMode" => "1");

echo '<?xml version="1.0" encoding="UTF-8"?><databind>';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

$req = "SELECT DISTINCT SUIVI.TDOC_ID, TYPE_DOC.TDOC_NOM
		FROM SUIVI, TYPE_DOC 
			WHERE TYPE_DOC.CLT_ID = $cltID 
			AND TYPE_DOC.TDOC_NOM != ' TOUS'
			AND TYPE_DOC.TDOC_MASQUE = 0
			AND TYPE_DOC.TDOC_ETAT != ".ETAT_SUPPR." 
			AND SUIVI.SUI_TYPE = ".SUI_TYPE_DOC." 
			AND SUIVI.TDOC_ID = TYPE_DOC.TDOC_ID 
			AND (SUIVI.PAR_DEST_ID = '$partId' OR SUIVI.PAR_EMET_ID = '$partId')
		ORDER BY TYPE_DOC.TDOC_NOM";

$gDb->SQLQuery($req, 1);

while ($row = $gDb->SQLNextRow(1))
{
	if (!droit(SDO, $lmcse,null,null,$row['TDOC_ID'],null))	//on vrifie les droits sur le type de documents TDOC_ID
		continue;
		
	$req = "SELECT FOR_ID, FOR_NOM
			FROM `FORMAT` 
			WHERE TDOC_ID = ".$row['TDOC_ID']." 
				AND FOR_ETAT != ".ETAT_SUPPR;
				
	$items = array();
	$nb = 0;
		
	$gDb->SQLQuery($req, 2);
	while ($row_format = $gDb->SQLNextRow(2))
	{
		$items[$nb++] = array('TDOC_ID' => $row['TDOC_ID'],
					'TDOC_NOM' => $row['TDOC_NOM'],
					'FOR_ID' => $row_format['FOR_ID'],
					'FOR_NOM' => $row_format['FOR_NOM']);
	}
	$gDb->SQLFermeQuery(2);
	
	foreach($items as $item)
	{
		echo '<row>';
		echo '<item caption="'.hi_disp("<a title='$lang_menu_lbl_docs_tooltip'>".$item['TDOC_NOM'].'</a>');
		if($nb>1)
			echo ' ('.$item['FOR_NOM'].')';
			
		$crit = '';
		switch($f_sens)
		{
			case EMISSION:
				$crit = "&f_emetteur=$partId&fromPE=".$_SESSION['RECAPDOC_FILTER']['f_part_crit'];
			break;
			
			case RECEPTION:
				$crit = "&f_destinataire=$partId&fromPD=".$_SESSION['RECAPDOC_FILTER']['f_part_crit'];
			break;
		}
			
		$p = $pathFlow.'suivi/documents/sui_doc.php?recap=1&typeDoc='.$item['TDOC_ID']."&f_date_deb=$f_date_deb&f_date_fin=$f_date_fin&f_sens=$f_sens";
		$p .= $crit;
		$p = hi_disp($p);
		echo "\" onClick=\"changePage('$p');\"/>";
		
		$traite = 0;
		$encours = 0;
		$erreur = 0;
		
		$where = "WHERE SUIVI.CLT_ID=$cltID 
					AND SUIVI.SUI_REJOUE!=1
					AND SUIVI.TDOC_ID=".$item['TDOC_ID']." 
					AND SUIVI.FOR_ID=".$item['FOR_ID']." 
					AND (SUIVI.PAR_DEST_ID=$partId OR SUIVI.PAR_EMET_ID=$partId)";
					
		if ($f_sens)
			$where .= " AND SUIVI.SUI_SENS='".$f_sens."'";


		// traitement des dates
		if($f_date_deb) {
			if($f_date_fin) {
				if($ini_typeBase == "oracle"){
						$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
						$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
						$where .= " AND ETAT_NUM.ETN_DATE BETWEEN $date_deb_sql AND $date_fin_sql";
				}
				else{
					$where .= " AND ETAT_NUM.ETN_DATE BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
				}
			}
			else{
				if($ini_typeBase == "oracle"){
					$where .= " AND ETAT_NUM.ETN_DATE >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
				}
				else{
					$where .= " AND ETAT_NUM.ETN_DATE >= '".date2Sql($f_date_deb, "00:00:00")."'";
				}
			}
		}
		else if($f_date_fin) {
			if($ini_typeBase == "oracle"){
				$where .= " AND ETAT_NUM.ETN_DATE <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
			}
			else{
				$where .= " AND ETAT_NUM.ETN_DATE <= '".date2Sql($f_date_fin, "23:59:59")."'";
			}		
		}
		
		if($ini_typeBase == "mysql")	
			$from ="FROM SUIVI
					JOIN (ETAT_NUM, ACTFLUX) ON (SUIVI.ETN_ID = ETAT_NUM.ETN_ID AND SUIVI.AFX_ID = ACTFLUX.AFX_ID)
					JOIN (ACTIVITE) USING (ACT_ID)
					JOIN (TYPE_ACT) USING (TAC_NUM)";
		else
			$from ="FROM SUIVI
					JOIN ETAT_NUM ON SUIVI.ETN_ID = ETAT_NUM.ETN_ID
					JOIN ACTFLUX  ON SUIVI.AFX_ID = ACTFLUX.AFX_ID
					JOIN ACTIVITE ON ACTIVITE.ACT_ID = ACTFLUX.ACT_ID
					JOIN TYPE_ACT ON ACTIVITE.TAC_NUM = TYPE_ACT.TAC_NUM";
		
		// nb en erreur
		$req = "SELECT count(SUIVI.SUI_ID) AS nb $from $where AND SUIVI.SUI_TYP_NUM=".SUI_TYP_NUM_DOC." AND SUIVI.SUI_ETAT=".SUI_ETAT_ERR;
		$gDb->SQLQuery($req, 3);
		$row = $gDb->SQLNextRow(3);
		
		$rowname = 'nb';
		
		if($row[$rowname])
			$erreur = $row[$rowname];
		$gDb->SQLFermeQuery(3);

		//  rpartion Trait / En cours
		$req = "SELECT ETAT_NUM.ETN_PROGRESS AS TYPE, count(ETAT_NUM.ETN_PROGRESS) AS nb $from $where AND SUIVI.SUI_TYPE=".SUI_TYPE_DOC." AND ETAT_NUM.ETN_ETAT!=".ETN_ETAT_ERR." GROUP BY ETAT_NUM.ETN_PROGRESS";
		$gDb->SQLQuery($req, 3);
		while ($row_prog = $gDb->SQLNextRow(3))
		{
			if($row_prog['TYPE']==ETN_PROGRESS_COURS)
				$encours = $row_prog[$rowname];
			else
				$traite = $row_prog[$rowname];
		}
		$gDb->SQLFermeQuery(3);
		
		echo "<item caption='$traite'/>";
		echo "<item caption='$encours'/>";
		echo "<item caption='$erreur'/>";
		
		echo '</row>';
	}
}	
$gDb->SQLFermeQuery(1);

echo '</databind>';
?>