<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$cltID 	= $_SESSION['CLT_ID'];
$cptID 	= $_SESSION['CPT_ID'];
$droitRole = SDR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

$where = "";

/********************/
/* DEBUT PARAMETRES */
/* ******************/

// paramètres
$f_etat = pget('f_etat');
$f_res = pget('f_res');
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget("f_date_fin");
$detail		= pget('detail');

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

/******************/
/* FIN PARAMETRES */
/* ****************/

/**********************************/
/* DEBUT CONSTRUCTION DES FILTRES */
/* ********************************/
//Récupération des partenaire pour filtre émetteur
//rajout des restrictions dans le filtre (implicite)

$tmp = explode("FF", $f_etat);
if (isset($tmp[1]) && $tmp[1] != "") $where .= " AND SA2_ETATTRAIT = ".$tmp[1]." ";
	
if ($f_res)
	$where .= " AND SA2_RESULT = '$f_res' ";


// traitement des dates
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SA2_DATECREAT BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SA2_DATECREAT BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SA2_DATECREAT >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SA2_DATECREAT >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SA2_DATECREAT <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SA2_DATECREAT <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}	
		
//Requête principale
$req = "SELECT SQL_CALC_FOUND_ROWS SA2_ID, SA2_RESULT, SA2_LIBELLE, SA2_ETATTRAIT, SA2_DATECREAT, SA2_DATETRAIT,
		SA2_ALIAS_EMET, SA2_ALIAS_DEST, SA2_SUJET, SA2_NUMERR, SA2_DATE, SA2_MDN,
		SA2_MDN_SIGN, SA2_MDN_ASYNC, SA2_FIC_SIGN, SA2_FIC_CRYPT, SA2_FIC_COMPR,
		SA2_CONTENT_TYP, SA2_ALGO, SA2_ENCODAGE, SA2_MESSAGE_ID, FIC_ID 
		FROM SERVAS2  
		WHERE CLT_ID = '$cltID' 
		$where
		ORDER BY SA2_DATECREAT DESC";

$champs = array();
$champs[] = array("nom" => $lang_sui_as2_grid_head_etat, "toolTip" => $lang_sui_as2_grid_head_etat, "sortMode" => "2");
$champs[] = array("nom" => $lang_sui_as2_grid_head_sujet, "toolTip" => $lang_sui_as2_grid_head_sujet, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_as2_grid_head_emet, "toolTip" => $lang_sui_as2_grid_head_emet, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_as2_grid_head_dest, "toolTip" => $lang_sui_as2_grid_head_dest, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_as2_grid_head_date, "toolTip" => $lang_sui_as2_grid_head_date, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_as2_grid_head_libl, "toolTip" => $lang_sui_as2_grid_head_libl, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

function format_detail($val, $date=false) {
	return ((is_null($val) || "" == $val)? "N.A.": ($date? sql2Date($val): $val));
}

while ($row = $gDb->SQLNextRow(1))
{
	$detail = "<table>";
	
	$detail .= "<tr><td><b>$lang_sui_alt_act_detail_lbl_coderr</b> : ".format_detail($row['SA2_NUMERR'])."</td>";
	$detail .= "<td><b>$lang_sui_inv_grid_head_datet_tooltip</b> : ".format_detail($row['SA2_DATETRAIT'], true)."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_datedoc</b> : ".format_detail($row['SA2_DATE'], true)."</td></tr>";
	
	$detail .= "<tr><td><b>$lang_sui_as2_act_detail_lbl_ficsign</b> : ".format_detail($row['SA2_FIC_SIGN'])."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_ficcrypt</b> : ".format_detail($row['SA2_FIC_CRYPT'])."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_ficcomp</b> : ".format_detail($row['SA2_FIC_COMPR'])."</td></tr>";
	
	$detail .= "<tr><td><b>$lang_sui_as2_act_detail_lbl_msg_id</b> : ".hi_disp(format_detail($row['SA2_MESSAGE_ID']))."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_encoding</b> : ".format_detail($row['SA2_ENCODAGE'])."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_sign_algo</b> : ".format_detail($row['SA2_ALGO'])."</td></tr>";
	
	$detail .= "<tr><td><b>$lang_sui_as2_act_detail_lbl_mdn</b> : ".format_detail($row['SA2_MDN'])."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_mdnsign</b> : ".format_detail($row['SA2_MDN_SIGN'])."</td>";
	$detail .= "<td><b>$lang_sui_as2_act_detail_lbl_mdnasync</b> : ".format_detail($row['SA2_MDN_ASYNC'])."</td></tr>";
	
	$detail .= "<tr><td><b>$lang_sui_as2_act_detail_lbl_fictype</b> : ".format_detail($row['SA2_CONTENT_TYP'])."</td></tr>";
	
	$detail .= "</table>";
	echo '<row detail="'.hi_disp($detail).'">';
	
	$etat = array('caption' => "", 'icon' => "", 'toolTip' => "", 'onClick' => "");
	switch($row['SA2_ETATTRAIT'])
	{
		case ETAT_TRAIT :
			$etat['icon'] = $pathFlow."style/imgs/icons/valid.png";
			$etat['toolTip'] =  $lang_sui_as2_grid_lbl_etat_traite;
			break;
		case ETAT_ATRAITER :
			$etat['icon'] = $pathFlow."style/imgs/icons/clock.png";
			$etat['toolTip'] =  $lang_sui_as2_grid_lbl_etat_atraiter;
			break;
		default :
			$etat['icon'] = $pathFlow."style/imgs/icons/help.png";
			$etat['toolTip'] =  $lang_sui_as2_grid_lbl_etat_indeter;
	}
	$params = array();
	$params['sa2_id'] = $row['SA2_ID'];
	$params['fic_id'] = $row['FIC_ID'];
	$params['droits'] = array('mark_trait' => (($row['SA2_ETATTRAIT'] == ETAT_ATRAITER) && (droit($droitRole,DROIT_MODIF + DROIT_EXEC,null,null,null,null))),
							'visu' => ($row['FIC_ID'] && droit(SDO, DROIT_EXEC, null, null, null, null)));
							
    echo '<item icon="'.$etat['icon'].'" toolTip="'.$etat['toolTip'].'" value="'.row_encode_JSON($params).'"/>';
    
	$detail   = array('icon' => "", 'toolTip' => "", 'onClick' => "");
	
	switch($row['SA2_RESULT'])
	{
		case NIV_OK :
			$detail['icon'] = $pathFlow."style/imgs/icons/rond_vert.png";
			$detail['toolTip'] =  $lang_sui_as2_grid_lbl_result_ok;
			break;
		case NIV_ERR :
			$detail['icon'] = $pathFlow."style/imgs/icons/error.png";
			$detail['toolTip'] =  $lang_sui_as2_grid_lbl_result_err;
			break;
		default :
			$detail['icon'] = $pathFlow."style/imgs/icons/help.png";
			$detail['toolTip'] =  $lang_sui_as2_grid_lbl_result_indeter;
	}	
	echo '<item caption="'.hi_disp($row['SA2_SUJET']).'" icon="'.$detail['icon'].'"  toolTip="'.$detail['toolTip'].'"/>';	
	
	echo '<item caption="'.hi_disp($row['SA2_ALIAS_EMET']).'"/>';
	echo '<item caption="'.hi_disp($row['SA2_ALIAS_DEST']).'"/>';

	$date = sql2Date($row['SA2_DATECREAT']);
	echo '<item caption="'.$date.'"/>';
	
	echo '<item caption="'.hi_disp($row['SA2_LIBELLE']).'"/>';
	
		
	echo '</row>';
}
$gDb->SQLFermeQuery(1);

echo '</databind>';
?>