<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$cltID 	= $_SESSION['CLT_ID'];
$cptID 	= $_SESSION['CPT_ID'];
$droitRole = SDR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

$where = "";

/********************/
/* DEBUT PARAMETRES */
/* ******************/

// paramètres
$f_sens = pget('f_sens');
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget("f_date_fin");
$f_part_emet = pget("f_part_emet");
$f_part_dest = pget("f_part_dest");
$f_fichier = pget("f_fichier");

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

/******************/
/* FIN PARAMETRES */
/* ****************/

/**********************************/
/* DEBUT CONSTRUCTION DES FILTRES */
/* ********************************/
//Récupération des partenaire pour filtre émetteur
//rajout des restrictions dans le filtre (implicite)

if ($f_sens)
	$where .= " AND SPF_MODE = $f_sens ";

if ($f_part_emet)
	$where .= " AND PAR_EMET_ID = $f_part_emet ";

if ($f_part_dest)
	$where .= " AND PAR_DEST_ID = $f_part_dest ";

if($f_fichier)
	$where .= " AND SPF_NOM LIKE '%$f_fichier%'";

// traitement des dates
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SPF_DATE_CREATION BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SPF_DATE_CREATION BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SPF_DATE_CREATION >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SPF_DATE_CREATION >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SPF_DATE_CREATION <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SPF_DATE_CREATION <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}


//Requête principale
$req = "SELECT SQL_CALC_FOUND_ROWS SPF_ID, PAR_EMET_ID, PAR_DEST_ID, FIC_ID, SPF_ETAT, SPF_MODE, SPF_NOM, SPF_DATE_CREATION, SPF_NB_ARTICLE, SPF_LONG_ARTICLE, SPF_TAILLE_FICHIER, SPF_PI99 
		FROM SRVPESIT_FICHIER  
		WHERE CLT_ID = '$cltID' AND SPF_ETAT != ".ETAT_SUPPR." 
		$where
		ORDER BY SPF_ID DESC";

$champs = array();

$champs[] = array("nom" => $lang_sui_pesit_grid_head_acces, "toolTip" => $lang_sui_rap_grid_lbl_etat_emisrecu, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_etat, "toolTip" => $lang_flux_pargen_inv_part_aff_lbl_etat, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_datecreat, "toolTip" => $lang_lbl_datecreat, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_part_emet, "toolTip" => $lang_sui_pesit_grid_head_part_emet, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_part_dest, "toolTip" => $lang_sui_pesit_grid_head_part_dest, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_fichier, "toolTip" => $lang_sui_pesit_grid_head_fichier, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_detail_PI99, "toolTip" => $lang_sui_pesit_grid_detail_PI99, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';

echo '</header>';

function format_detail($val)
{
	return (is_null($val) || "" == $val)? "N.A." : $val;
}

while ($row = $gDb->SQLNextRow(1))
{
	$detail = "<table>";
	$detail .= "<tr><td><b>$lang_sui_pesit_grid_detail_taille</b> : ".format_detail($row['SPF_TAILLE_FICHIER'])."</td></tr>";
	$detail .= "<tr><td><b>$lang_sui_pesit_grid_detail_longueur</b> : ".format_detail($row['SPF_LONG_ARTICLE'])."</td>";
	$detail .= "<td><b>$lang_sui_pesit_grid_detail_article</b> : ".format_detail($row['SPF_NB_ARTICLE'])."</td></tr>";
	$detail .= "</table>";
	echo '<row detail="'.hi_disp($detail).'">';
	
	$sens = array('caption' => "", 'icon' => "", 'toolTip' => "");
	switch($row['SPF_MODE'])
	{
		case EMISSION :
			$sens['icon'] = $pathFlow."style/imgs/icons/aller.gif";
			$sens['caption'] = $lang_lbl_emiss_ini;
			$sens['toolTip'] = $lang_lbl_emiss;
			break;
		case RECEPTION :
			$sens['icon'] = $pathFlow."style/imgs/icons/retour.gif";
			$sens['caption'] = $lang_lbl_recep_ini;
			$sens['toolTip'] = $lang_lbl_recep;
			break;
	}
	
	switch($row['SPF_ETAT'])
	{
		case 0: // En cours ou non terminé
			$etat['icon'] = $pathFlow."style/imgs/icons/rond_jaune.png";
			$etat['toolTip'] = $lang_ds_progress_progress;
			break;
			
		case 1: // Terminé
			$etat['icon'] = $pathFlow."style/imgs/icons/valid_ok.png";
			$etat['toolTip'] = $lang_ds_progress_fin;
			break;
	}

	$droitVisu = droit($droitRole, DROIT_LECT,null,null,null,null) || droit(SDO, DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'],null,null); 
	$params['fic_id'] = $row['FIC_ID'];
	$params['droits'] = array('visu' => ($row['FIC_ID'] && $droitVisu),
							'download' => ($row['FIC_ID'] && droit(TEL, DROIT_LECT, $row['PAR_EMET_ID'],$row['PAR_DEST_ID'],null, null)));
	
	$date = sql2Date($row['SPF_DATE_CREATION']);

    echo '<item icon="'.$sens['icon'].'" caption="'.$sens['caption'].'" toolTip="'.$sens['toolTip'].'" value="'.row_encode_JSON($params).'"/>';
	
	echo '<item icon="'.$etat['icon'].'" caption="" toolTip="'.$etat['toolTip'].'"/>';

	echo '<item caption="'.$date.'"/>';

	echo '<item caption="'.getPartnerName($row['PAR_EMET_ID']).'"/>';

	echo '<item caption="'.getPartnerName($row['PAR_DEST_ID']).'"/>';

	echo '<item caption="'.hi_disp($row['SPF_NOM']).'"/>';
	
	echo '<item caption="'.hi_disp($row['SPF_PI99']).'"/>';

	echo '</row>';
}
$gDb->SQLFermeQuery(1);

echo '</databind>';
?>