<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$cltID 	= $_SESSION['CLT_ID'];
$cptID 	= $_SESSION['CPT_ID'];
$droitRole = SDR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_EXEC;

$where = "";

/********************/
/* DEBUT PARAMETRES */
/* ******************/

// paramètres
$f_sens = pget('f_sens');
$f_etat = pget('f_etat');
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget("f_date_fin");
$f_part_emet = pget("f_part_emet");
$f_part_dest = pget("f_part_dest");
$f_fichier = pget("f_fichier");

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

/******************/
/* FIN PARAMETRES */
/* ****************/

/**********************************/
/* DEBUT CONSTRUCTION DES FILTRES */
/* ********************************/
//rajout des restrictions dans le filtre (implicite)

if ($f_sens)
{
	if($f_sens==EMISSION)
		$where .= " AND SPT_ACCES = 1 ";
	else if($f_sens==RECEPTION)
		$where .= " AND SPT_ACCES = 0 ";
}

if ($f_etat)
	$where .= " AND SPT_CODE_RET = $f_etat ";
	
if ($f_part_emet)
	$where .= " AND PAR_EMET_ID = $f_part_emet ";
	
if ($f_part_dest)
	$where .= " AND PAR_DEST_ID = $f_part_dest ";
	
if($f_fichier)
	$where .= " AND SPT_FIC_NOM LIKE '%$f_fichier%'";

// traitement des dates
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SPT_DATE_TRANS BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SPT_DATE_TRANS BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SPT_DATE_TRANS >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SPT_DATE_TRANS >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SPT_DATE_TRANS <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SPT_DATE_TRANS <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}

// traitement des dates
$f_date_deb = pget('f_date_deb');
$f_date_fin = pget('f_date_fin');
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND SPT_DATE_TRANS BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND SPT_DATE_TRANS BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND SPT_DATE_TRANS >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND SPT_DATE_TRANS >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND SPT_DATE_TRANS <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND SPT_DATE_TRANS <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}
	
		
//Requête principale
$req = "SELECT SQL_CALC_FOUND_ROWS SPT_ID, SPT_ID_TRANS, SPT_DATE_TRANS, PAR_EMET_ID, PAR_DEST_ID, SPF_ID, SPT_FIC_NOM, SPT_ACCES, SPT_CODE_RET, SPT_LIB_RET, SPT_PI99 
		FROM SRVPESIT  
		WHERE CLT_ID = '$cltID' 
		$where
		ORDER BY SPT_ID DESC";

$champs = array();

$champs[] = array("nom" => $lang_sui_pesit_grid_head_acces, "toolTip" => $lang_sui_rap_grid_lbl_etat_emisrecu, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_date_trait, "toolTip" => $lang_sui_pesit_grid_head_date_trait, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_part_emet, "toolTip" => $lang_sui_pesit_grid_head_part_emet, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_part_dest, "toolTip" => $lang_sui_pesit_grid_head_part_dest, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_fichier, "toolTip" => $lang_sui_pesit_grid_head_fichier, "sortMode" => "1");
$champs[] = array("nom" => $lang_sui_pesit_grid_head_etat, "toolTip" => $lang_sui_pesit_grid_head_etat, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

function format_detail($val)
{
	return (is_null($val) || "" == $val)? "N.A." : $val;
}

function get_synchro($id)
{
	global $gDb;
	$req = "SELECT SPS_POINT_SYNCHRO FROM SRVPESIT_SYNCHRO WHERE SPT_ID_TRANS = $id";
	$gDb->SQLQuery($req, 2);
	$res = $gDb->SQLNextRow(2);
	$gDb->SQLFermeQuery(2);
	
	return format_detail($res['SPS_POINT_SYNCHRO']);
}

while ($row = $gDb->SQLNextRow(1))
{
	$detail = "<table>";
	
	$detail .= "<tr><td><b>$lang_sui_pesit_grid_detail_id</b> : ".format_detail($row['SPT_ID_TRANS'])."</td>";

	$detail .= "<td><b>$lang_sui_pesit_grid_detail_synchro</b> : ".get_synchro($row['SPT_ID_TRANS'])."</td></tr>";

	$detail .= "<tr><td><b>$lang_sui_pesit_grid_detail_code</b> : ".format_detail($row['SPT_CODE_RET'])."</td>";
	
	$detail .= "<td><b>$lang_sui_pesit_grid_detail_PI99</b> : ".format_detail($row['SPT_PI99'])."</td></tr>";

	$detail .= "</table>";
	echo '<row detail="'.hi_disp($detail).'">';
	
	$sens = array('caption' => "", 'icon' => "", 'toolTip' => "");
	switch($row['SPT_ACCES'])
	{
		case 0 :	// PeSIT mode Ecriture => Réception
			$sens['icon'] = $pathFlow."style/imgs/icons/retour.gif";
			$sens['caption'] = $lang_lbl_recep_ini;
			$sens['toolTip'] = $lang_lbl_recep;
			break;
		case 1 : 	// PeSIT mode Lecture => Emission
			$sens['icon'] = $pathFlow."style/imgs/icons/aller.gif";
			$sens['caption'] = $lang_lbl_emiss_ini;
			$sens['toolTip'] = $lang_lbl_emiss;
			break;
		case 2 : 	// PeSIT mode Mixte (forcé en émission ou réception lors du traitement)
			break;
	}
	
	$droitVisu = droit($droitRole, DROIT_LECT,null,null,null,null) || droit(SDO, DROIT_LECT,$row['PAR_EMET_ID'],$row['PAR_DEST_ID'],null,null); 
	$gDb->SQLQuery("SELECT FIC_ID FROM SRVPESIT_FICHIER WHERE SPF_ID=${row['SPF_ID']}", 3);
	$fic_id = $gDb->SQLNextRow(3);
	$params['fic_id'] = $fic_id['FIC_ID'];
	$gDb->SQLFermeQuery(3);
	$params['droits'] = array('visu' => ($params['fic_id'] && $droitVisu),
							'download' => ($params['fic_id'] && droit(TEL, DROIT_LECT, $row['PAR_EMET_ID'],$row['PAR_DEST_ID'],null, null)));
	
    echo '<item icon="'.$sens['icon'].'" caption="'.$sens['caption'].'" toolTip="'.$sens['toolTip'].'" value="'.row_encode_JSON($params).'"/>';
	
	$etat = array('caption' => "", 'icon' => "", 'toolTip' => "");
	switch($row['SPT_CODE_RET'])
	{
		case SUI_ETAT_OK:
			$etat['icon'] = $pathFlow."style/imgs/icons/rond_vert.png";
			$etat['toolTip'] = $lang_lbl_ok;
			break;
		case SUI_ETAT_INFO:
			$etat['icon'] = $pathFlow."style/imgs/icons/info.png";
			$etat['toolTip'] = $lang_lbl_info;
			break;
		case SUI_ETAT_AVERT:
		case SUI_ETAT_ERR:
			$etat['icon'] = $pathFlow."style/imgs/icons/error.png";
			$etat['toolTip'] = $lang_lbl_erreur;
			break;
	}
    
	$date = sql2Date($row['SPT_DATE_TRANS']);
	echo '<item caption="'.$date.'"/>';
	
	echo '<item caption="'.getPartnerName($row['PAR_EMET_ID']).'"/>';
	
	echo '<item caption="'.getPartnerName($row['PAR_DEST_ID']).'"/>';

	echo '<item caption="'.hi_disp($row['SPT_FIC_NOM']).'"/>';
	
	echo '<item caption="'.hi_disp($row['SPT_LIB_RET']).'" icon="'.$etat['icon'].'" toolTip="'.$etat['toolTip'].'"/>';
	
	echo '</row>';
}
$gDb->SQLFermeQuery(1);

echo '</databind>';
?>