<?php
/*%%%F=====================================================================
                          Class Tableau
===========================================================================
Class permettant de cre un tableau HTML
Fonctionnalits
 - Bouton de navigation pour n'afficher qu'un nombre nbr limit d'enregistrement
      Le lien des boutons n'est pas cre si le bouton ne doit pas fonctionner
         i.e : si on est au debut du tableau, le bouton precedent n'a pas de lien
      Si le nombre total d'enreg est inferieur au nombre a afficher les boutons
         ne sont pas affichs
 - Affichage du nombre total d'enregistrement et de la position du tableau
 - Possibilit d'afficher des info supplementaires a cot du tableau
 - Tri croissant ou dcroissant sur les colonnes avec affichage dans l'en-tete
      d'une image indiquant le sens de tri
      Tri croissant ou decroissant par defaut
 - Alternance de couleurs pour le tableau
 - Possibilit d'afficher une ligne d'une couleur differentes
 - Affichage des totaux de bas de tableau, avec le nombre de colonne parametrable
 - Reaffichage des boutons de navigation en bas de la page
 - Bufferisation du tableau pour un affichage plus rapide


Exemple de fonctionnement

   $gTableau = new Tableau("images/", "tableau.php");
   $enTete[0]['enTete']   ="champ 1";  //affichage de l'en-tete
   $enTete[0]['tri']      ="champ1";   //tri sur le champ1
   $enTete[0]['affJS']    ="Trier le champ 1";   //affichage dans la barre de statut
   $enTete[x]['colspan']  = Le nombre de colonne a crer dans la meme en-tete
   $enTete[x]['classUrl'] = Le nom de la classe pour l'URL

   //Pour ce champ on ne desire pas le trier
   $enTete[1][0]="champ 2";  //affichage de l'en-tete

   //Si on veut trier le champ1 dans l'ordre decroissant par defaut
   $ordre="champ1".$gTableau->desc;

   Si l'on desire utiliser la navigation
      $gTableau->affEnTete(40,$enTete,"&param1=2&param2=2","champ1",30,2);
   sinon
      $gTableau->affEntTableau($enTete,"champ1",&param1=2&param2=2");

      On genere la requete SQL de tri grace a la fonction creeOrdre($ordre);
      $ordre = $gTableau->creeOrdre($ordre);

      Libell de l'affichage
      $Donnees[0]['Donnees'] = "valChamp1";
      $Donnees[2]['Donnees']= "valChamp2";

      Pour spcifier un type reserv de donnes et qui aura un traitement supplmentaire dans la fonction affDonnees
      $Donnees[0]['Monnaie'] = "TEU";
      $Donnees[2]['Monnaie']= "FRF";

      Pour cree un lien sur une case du tableau
      $Donnees[x]['Url'] = "fichier.php?var=1"; //Url du lien
      $Donnees[x]['affJS'] = "texte";           //Affichage du texte dans la barre de statut
      $Donnees[x]['Target'] = "principal";      //Target de l'url
      $Donnees[x]['image'] = "image.jpg";       //Nom du fichier image
      $Donnees[x]['alt'] = "commentaire image"  //Alt de l'image
      $Donnees[x]['iBulle'] = "afficher les renseignements"  //Bulle d'aide sur l'Url
      $Donnees[x]['class']   = "colonne"             //Le nom de la class du lien

   $gTableau->affDonnees($Donnees, 1); //on met cette ligne d'une couleur differente pour mettre en evidence une ligne
   $gTableau->affDonnees($Donnees);    //celle la sera alterne

   $gTableau->affTotaux($Donnees,4) //si l'on veut afficher une colonne de totaux dont la 1ere colonne prend 4 colonne du tableau
   $gTableau->piedPage(); //on met cette ligne d'une couleur differente

paramtreS

Champ de la feuille de style
   th.tableau //style de l'entete de tableau

   td.tableau  //style des cellules du tableau
   td.totaux   //style des cellules de la ligne des totaux
   td.nbEnreg  //Phrase specifiant le nombre d'enregistrement ainsi que la position

   tr.premier  {  background-color: #DDDDDD;}  // Alternance des lignes dans le tableau
   tr.deuxieme {  background-color: #CCCCCC;}  // Alternance des lignes dans le tableau
   tr.verif    { background-color: #FFCC00;}   // Erreurs des lignes dans le tableau
   tr.totaux   { background-color: #00DCDC;}   // Totaux

   A:link.enTete,A:visited.enTete,A:hover.enTete //Lien d'entete
   A:link.colonne,A:visited.colonne,A:hover.colonne  //Lien sur les colonnes

Images
   navdeb.gif   //image de debut de tableau      |<
   navprec.gif  //image de navigation precedente  <
   navsuiv.gif  //image de navigation suivante    >
   navfin.gif   //image de fin de tableau         >|
   trihaut.gif  //image de tri d'en-tete croissant /\
   tribas.gif  //image de tri d'en-tete decroissant \/

Champs
   nbr   : Nombre d'enregistrement a afficher
           defaut 30
   $aURL : Rajout de liens a cot de la phrase d'enreg
   $asc, $desc : Pour rajouter un tri par defaut, concatener a la variable $ordre
                 a passer dans la fonction affEnTete, une de ses 2 variables suivant
                 si le tri doit etre croissant ou decroissant

Variables globales
$StyleTableau : pour definir le style du tableau
    i.e : $styleTableau="BORDER=1 CELLSPACING=1 BORDERCOLORLIGHT='#C0C0C0' BORDERCOLORDARK='#FFFFFF'";

$styleUrl     : pour definir les couleurs de la case quand on passe dessus
    i.e :
    - Pour l'alternance des couleurs du tableau
    $styleUrl['premier']['debut']  = "#F0F0F0";
    $styleUrl['premier']['fin']    = "#DDDDDD";
    $styleUrl['deuxieme']['debut'] = "#F0F0F0";
    $styleUrl['deuxieme']['fin']   = "#CCCCCC";
    - Pour les couleurs du tableau
    $styleUrl['couleur1']['debut'] = "#FFAA00";
    $styleUrl['couleur1']['fin']   = "#FFCC00";
    - Pour l'en-tete
    $styleUrl['entete']['debut'] = "#E1E8ED";
    $styleUrl['entete']['fin']   = "#D3DCE3";

Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
=========================================================================*/
class Tableau
{
   var $buf;   //buffer d'affichage [priv]
   var $bufB;  //Affichage des boutons [priv]
   var $coul;  //Alternance des couleurs [priv]
   var $page;  //page de lien
   var $chemImages;  //Chemin des images
   var $asc = "%";   //Caractere indiquant l'ordre de tri ascendant
   var $desc = "!";  //Caractere indiquant l'ordre de tri descendant
   var $nbr=30; //Nombre a afficher
   var $aURL;   //Pour afficher des infos supplementaires a cot du nb d'enreg
   var $positionTableau=array('debut'=>'','fin'=>'');
   var $classPremier="premier";    //Class Premier pour affichage des lignes du tableau
   var $classDeuxieme="deuxieme";  //Class Premier pour affichage des lignes du tableau

/*%%%F=====================================================================
                           Tableau
===========================================================================
Instanciation de la classe Tableau
Entrees -------------------------------------------------------------------
~~~~~~~
$chemImages : Le chemin du repertoire image
$page       : La page sur laquelle doivent pointer les liens pour pouvoir
              avancer sur le tableau ou bien pouvoir trier ce tableau
$position   : Position du tableau dans la page
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
LC 30/01/2001 Ajout du paramtre positionnement de tableau
=========================================================================*/
   function Tableau($chemImages,$page='',$position='')
   {
      $this->page=$page;
      $this->chemImages=$chemImages;
      if (preg_match("/centre/i",$position)) {$this->positionTableau['debut']="<CENTER>"; $this->positionTableau['fin']="</CENTER>";}
   }
/*%%%F=====================================================================
                           affEnTete
===========================================================================
Cration de l'entete de tableau
Entrees -------------------------------------------------------------------
~~~~~~~
$nbTotal : Nombre total d'enregistrement du tableau
$enTete  : Tableau d'enTete
           enTete[x][0] = affichage de l'entete a la position x du tableau
           enTete[x][1] = le nom du champ a trier
           enTete[x][2] = la phrase a afficher dans la barre de statut lorsque l'on survole le lien
           Remarque : les 2 derniers paramtres ne sont pas obligatoires, a ce moment la l'en-tete
                      ne sera pas un lien
$url     : L'url  passer, pour faire passer les paramtres de tri du Tableau
$ordre   : Le champ tri
$pos     : La position sur le Tableau
$sens    : Le sens de navigation
           0 : debut du tableau
           1 : Precedent
           2 : Suivant
           3 : Fin du tableau
Sortie -------------------------------------------------------------------
~~~~~~~
Retourne la prochaine position
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
LC 24/04/2001 Renvoi de la position
=========================================================================*/
   function affEnTete($nbTotal,$enTete,$url,$ordre,$pos,$sens)
   {
      if (!isset($pos)) $pos=0;

     //On effectue une premiere fois la requete pour connaitre le nombre total d'enregistrement
     if ($nbTotal ==0)
     {
        echo "<CENTER><TABLE><TR><TD CLASS='nbEnreg'>Aucun rsultat  afficher</TD></TR></TABLE></CENTER>";
        return;
     }

      switch($sens)   //Suivant le sens de navigation
      {
         case 0:    //Debut du tableau
            $debut=0; //On se repositionne au debut
            break;
         case 1:    //Precedent
            if ($pos<$this->nbr) $debut=0; //Si position actuelle - nombre a afficher est negatif on part de zero
            else $debut=$pos-$this->nbr;    //Sinon on decremente
            break;
         case 2:    //suivant
            if (($pos + $this->nbr) >= $nbTotal) $debut=$pos;    //Si on est au bout de l'affichage on reste comme on est
            else $debut=$pos+$this->nbr;
            break;
         case 3:    //fin
            if ($nbTotal < $this->nbr) $debut=0;   //S'il y a moins de ligne que le total on part de zero
            else $debut=$nbTotal-$this->nbr;       //Sinon on affiche les nbr derniers enregsitrements
            break;
         case 4:   //Pas boug
            $debut=$pos;
            break;
      }

      //Cration de l'url des boutons et des en-tetes
      $urlBT= $this->page.(preg_match("/\?/",$this->page) ? "&":"?").$url."&ordre=$ordre";
      //$urlET= $this->page.(preg_match("/\?/",$this->page) ? "&":"?").$url."&ordre=";

      //Construction du tableau
      $buf = $this->positionTableau['debut']."<TABLE width=100%><TR><TD ALIGN=CENTER><TABLE>\n";

      if ($nbTotal > $this->nbr) $buf.=$this->affBtNavig($debut,$nbTotal,$urlBT); //Si le nbr> nbr total on affiche pas les boutons

      //affichage du nombre d'enreg et de la position du tableau
      if(($debut+$this->nbr)>$nbTotal) $fin=$nbTotal;  //Si la position + le nombre a afficher depasse le nombre total la fin est egale au nombre total
      else $fin=($debut+$this->nbr);   //Sinon on incremente du nombre a afficher
      $buf.= "<TR ALIGN=CENTER><TD CLASS='nbEnreg'>";
      if ($nbTotal == 1)  $buf.= "Un rsultat trouv";
      elseif ($nbTotal < $this->nbr) $buf.= $nbTotal." rsultats trouvs";
      else $buf.= "Rsultats ".($debut+1). "  ".$fin." sur ".$nbTotal;

      $buf.=$this->aURL;  //Pour permettre d'afficher des infos a cot du nb d'enreg
      $buf.="</TD></TR></TABLE></TD></TR>\n";

      $this->buf.=$buf;
      $this->buf.=$this->affEntTableau($enTete,$ordre,$url);
      return $debut;
   }/*eof*/
/*%%%F=====================================================================
                           affBtNavig
===========================================================================
Fonction crant les boutons de navigations ainsi que leurs liens
Cette fonction est une fonction prive
Entrees -------------------------------------------------------------------
~~~~~~~
$pos     : position du tableau
$nbTotal : nombre total d'enregistrement du tableau
$urlBT   : URL a passer aux boutons pour regenerer le filtre
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
LC 24/04/2001 modification du calcul de position (le calcul se fait maintenant uniquement dans affEnTete)
=========================================================================*/
   function affBtNavig($pos,$nbTotal,$urlBT)
   {
                   if (!isset($pos)) $pos=0;
      $this->bufB.= "       <TR>\n";
      $this->bufB.= "         <TD ALIGN=CENTER>";
      //Bouton debut
      if ($pos!=0)
         $this->bufB.= "<A HREF='".$urlBT."&pos=0&sens=0' onMouseOver=\"return mOver('Debut du tableau')\" onMouseOut=\"mOut()\">\n";
      $this->bufB.= "<IMG SRC='".$this->chemImages."navdeb.gif' BORDER=0 alt='Debut du tableau'></A>\n";

      //Bouton precedent
      if ($pos>0)
         $this->bufB.= "<A HREF='".$urlBT."&pos=$pos&sens=1' onMouseOver=\"return mOver('Reculer sur les rsultats')\" onMouseOut=\"mOut()\">\n";
      $this->bufB.= "<IMG SRC='".$this->chemImages."navprec.gif' BORDER=0 alt='Reculer sur les rsultats'></A>\n";

      //Bouton suivant
      if (($pos + $this->nbr) < $nbTotal)
         $this->bufB.= "<A HREF='".$urlBT."&pos=$pos&sens=2'  onMouseOver=\"return mOver('Avancer sur les rsultats')\" onMouseOut=\"mOut()\">\n";
                        $this->bufB.= "<IMG SRC='".$this->chemImages."navsuiv.gif' BORDER=0 alt='Avancer sur les rsultats'></A>\n";
      //Bouton fin
      if (($pos + $this->nbr) < $nbTotal and $this->nbr < $nbTotal)
         $this->bufB.= "<A HREF='".$urlBT."&pos=".($nbTotal-$this->nbr)."&sens=3' onMouseOver=\"return mOver('Fin du tableau')\" onMouseOut=\"mOut()\">\n";
      $this->bufB.= "<IMG SRC='".$this->chemImages."navfin.gif' BORDER=0 alt='Fin du tableau'></A>\n";
      $this->bufB.= "         </TD>\n";

      $this->bufB.= "       </TR>\n";
      return $this->bufB;
   }
/*%%%F=====================================================================
                           affEntTableau
===========================================================================
Fonction crant les en-tete de tableau et generant les liens de en-tetes pour
les tri de colonne et affichant l'image permettant de savoir quel est le lien
tri et son sens de tri
Entrees -------------------------------------------------------------------
~~~~~~~
$enTete  : Tableau d'enTete
           enTete[x]['enTete']   = affichage de l'entete a la position x du tableau
           enTete[x]['tri']      = le nom du champ a trier
           enTete[x]['affJS']    = la phrase a afficher dans la barre de statut lorsque l'on survole le lien
           enTete[x]['image']    = Le nom de l'image a afficher dans l'en-tete
           enTete[x]['colspan']  = Le nombre de colonne a crer dans la meme en-tete

           Remarque : les 2 derniers paramtres ne sont pas obligatoires, a ce moment la
                      l'en-tete ne sera pas un lien
$ordre   : Champ a tri, optionnel si on ne desire pas tri un tableau
$url     : URL de l'en-tete pour recrer le filtre sur le tableau, optionnel
paramtres ----------------------------------------------------------------
$StyleTableau : pour definir le style du tableau
$styleUrl     : pour definir les couleurs de la case quand on passe dessus
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
LC 07/05/2001 Passage des paramtres du tableau par des libells a la place des chiffres
JR 28/01/2002 Ajout du paramtre image dans l'URL
LC 30/01/2002 Ajout du changement de couleur sur les en-tetes
LC 01/02/2002 Ajout des bulles d'aide sur les en-tetes
LC 03/05/2002 Ajout du colspan
LC 13/06/2002 Ajout du style d'en-tete parametrable
=========================================================================*/
   function affEntTableau($enTete,$ordre='',$url='')
   {
      global $styleTableau;
      global $styleUrl;
      $urlET= $this->page.(preg_match("/\?/",$this->page) ? "&":"?").$url."&ordre=";
      //En tete du tableau
      $buf =  $this->positionTableau['debut']."<table><TR><TD><TABLE $styleTableau>\n";
      $buf.=  "  <TR>\n";
      if ($ordre!='')
      {
         $tri=$ordre[strlen($ordre)-1]; //On recupere la valeur de tri
         if ($tri!=$this->asc and $tri!=$this->desc) unset($tri);
      }
      for($i=0; $i < count($enTete);$i++)  //On affiche l'en-tete
      {
         $jTexte="";
         $image="";
         if (isset($enTete[$i]['image']))  $image="<IMG SRC=\"".$enTete[$i]['image']."\" ALT=\"".$enTete[$i]['alt']."\" BORDER=0>\n";
         if (isset($enTete[$i]['affJS'])) $jTexte = " onMouseOver=\"return mOver('".$enTete[$i]['affJS']."')\" onMouseOut=\"mOut()\"";

         $buf.= "    <TH CLASS='tableau'".(isset($enTete[$i]['align']) ? (" align=".$enTete[$i]['align']." ") : " align=left ").(isset($enTete[$i]['Monnaie']) ? " COLSPAN=2" : "").((isset($enTete[$i]['colspan']) && $enTete[$i]['colspan']>0) ? " COLSPAN=".$enTete[$i]['colspan'] : "").((isset($enTete[$i]['width']))?(" width='".$enTete[$i]['width']."'"):(""));
         if (!isset($enTete[$i]['tri']))  //Si la colonne est trie on n'a pas besoin de faire des traitements sur le tri
            $buf.=">".$enTete[$i]['enTete'].$image;
         else
         {
            $buf.= " ".$this->construcStyleUrl($styleUrl['entete']['debut'],$styleUrl['entete']['fin']).">";
            $buf.= "<A CLASS='";
            if (isset($enTete[$i]['classUrl']))
               $buf.=$enTete[$i]['classUrl'];
            else
               $buf.="enTete";
            $buf.="' HREF='$urlET";
            if (substr($ordre,0,strlen($ordre)-1)==$enTete[$i]['tri'] and isset($tri))
            {
               if ($tri== $this->asc)
                  $buf.=$enTete[$i]['tri'].$this->desc."'$jTexte TITLE=\"".$enTete[$i]['affJS']."\">".$enTete[$i]['enTete']."</A>&nbsp;<img src='".$this->chemImages."trihaut.gif'>"; //le tri passe de asc a desc
               else  //Tri desc
                  $buf.=$enTete[$i]['tri'].$this->asc."'$jTexte TITLE=\"".$enTete[$i]['affJS']."\">".$enTete[$i]['enTete']."</A>&nbsp;<img src='".$this->chemImages."tribas.gif'>"; //le tri passe de asc a desc
            }
            else
               if ($ordre==$enTete[$i]['tri'])  //Sinon on rajoute l'en-tete au tri
                  $buf.=$enTete[$i]['tri'].$this->desc."'$jTexte TITLE=\"".$enTete[$i]['affJS']."\">".$enTete[$i]['enTete']."</A>&nbsp;<img src='".$this->chemImages."trihaut.gif'>";
               else $buf.=$enTete[$i]['tri']."'$jTexte TITLE=\"".$enTete[$i]['affJS']."\">".$enTete[$i]['enTete']."</A>";
         }
         $buf.="&nbsp;</TH>\n";
      }
      $buf.=  "  </TR>\n";
      //echo $buf;
      $this->buf.=$buf;
   }

/*%%%F=====================================================================
                           creeOrdre
===========================================================================
Cree la requete de tri
Entrees -------------------------------------------------------------------
~~~~~~~
$ordre : La champ  trier
Sortie -------------------------------------------------------------------
~~~~~~~
$ordre
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 21/03/2001 Cration
=========================================================================*/
function creeOrdre($ordre)
{
   if ($ordre[strlen($ordre)-1]== $this->asc)  $ordre=substr($ordre,0,strlen($ordre)-1);
   if ($ordre[strlen($ordre)-1]== $this->desc) $ordre=substr($ordre,0,strlen($ordre)-1)." desc";
   return $ordre;
}

/*%%%F=====================================================================
                           affDonnees
===========================================================================
Affiche les donnes passs dans un tableau de donnes
Entrees -------------------------------------------------------------------
~~~~~~~
$Donnes : Tableau de donnes $Donnees[x] = la donne a afficher et x sa position du tableau
           $Donnees[0]['Donnees'] = "valChamp1";
           $Donnees[2]['Donnees'] = "valChamp2";

           Pour faire une case qui calcule la conversion Euro->Franc
           $Donnees[x]['Monnaie'] = "TEU";
           $Donnees[x]['Monnaie'] = "FRF";

           Pour cree un lien sur une case du tableau
           $Donnees[x]['Url']     = "fichier.php?var=1";  //Url du lien
           $Donnees[x]['affJS']   = "texte";              //Affichage du texte dans la barre de statut
           $Donnees[x]['Target']  = "principal";          //Target de l'url
           $Donnees[x]['image']   = "image.jpg";          //Nom du fichier image
           $Donnees[x]['alt']     = "commentaire image"   //Alt de l'image
           $Donnees[x]['iBulle']  = "afficher"            //Bulle d'aide sur l'Url
           $Donnees[x]['class']   = "colonne"             //Le nom de la class du lien

$verif   : booleen pour savoir si on affiche une ligne de couleur differente, 1 couleur differente, optionnel
paramtres ----------------------------------------------------------------
$styleUrl : pour definir les couleurs de la case quand on passe dessus
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
LC 25/05/2001 Remplacement de <TD CLASS='tableau'> par <TD> pour optimisation
LC 19/10/2001 Ajout du paramtre Monnaie
LC 21/12/2001 Ajout du paramtre URL
LC 16/01/2002 Ajout du paramtre image dans l'URL
LC 01/02/2002 Ajout des bulles d'aide sur l'url
LC 11/06/2002 Ajout du paramtre class dans l'URL
=========================================================================*/
   function affDonnees($Donnees, $couleur='')
   {
      global $styleUrl;
      if ($couleur) $this->buf.="  <TR CLASS='$couleur'>\n";
      else
      {
         if ($this->coul)  { $this->buf.= "  <TR CLASS='".$this->classPremier."'>\n";$this->coul = !$this->coul;}
         else            { $this->buf.= "  <TR CLASS='".$this->classDeuxieme."'>\n";$this->coul = !$this->coul;}
      }

      for($j=0; $j <count($Donnees);$j++)  //On affiche les resultats
      {
         if (isset($Donnees[$j]['Monnaie']))
         {  //Donnes Monnaie
            if ($Donnees[$j]['Monnaie']=="TEU")
            {
               $this->buf.= "    <TD>&nbsp;".number_format($Donnees[$j]['Donnees'],2,"."," ")."&nbsp;</TD>\n";
               $this->buf.= "    <TD>&nbsp;".number_format($Donnees[$j]['Donnees']*6.55957,2,"."," ")."F&nbsp;</TD>\n";
            }
            else
            {
               $this->buf.= "    <TD>&nbsp;".number_format($Donnees[$j]['Donnees']/6.55957,2,"."," ")."&nbsp;</TD>\n";
               $this->buf.= "    <TD>&nbsp;".number_format($Donnees[$j]['Donnees'],2,"."," ")."F&nbsp;</TD>\n";
            }
            continue;
         }
         if (isset($Donnees[$j]['Url']))
         {  //Donnes URL
            $image='';
            $jTexte='';
            $target='';
            $class='';
            if (isset($Donnees[$j]['affJS']))  $jTexte = " onMouseOver=\"return mOver('".$Donnees[$j]['affJS']."')\" onMouseOut=\"mOut()\"";
            if (isset($Donnees[$j]['Target'])) $target=" TARGET='".$Donnees[$j]['Target']."'";
            if (isset($Donnees[$j]['image']))  $image="<IMG SRC=\"".$Donnees[$j]['image']."\" ALT=\"".$Donnees[$j]['alt']."\" BORDER=0>";
            if (isset($Donnees[$j]['class']))  $class=$Donnees[$j]['class'];
            else $class="colonne";
            if ($couleur) $this->buf.= "       <TD ".$this->construcStyleUrl($styleUrl[$couleur]['debut'],$styleUrl[$couleur]['fin']).(isset($Donnees[$j]['align']) ? (" align=".$Donnees[$j]['align']." ") : " align=left ").">";
            else        $this->buf.= "       <TD ".(!$this->coul ? $this->construcStyleUrl($styleUrl['premier']['debut'],$styleUrl['premier']['fin']):$this->construcStyleUrl($styleUrl['deuxieme']['debut'],$styleUrl['deuxieme']['fin'])).(isset($Donnees[$j]['align']) ? (" align=".$Donnees[$j]['align']." ") : " align=left ").">";
            $this->buf.="<A class='$class' HREF=\"".$Donnees[$j]['Url']."\"".$target.$jTexte;
            $this->buf.=" TITLE=\"".(isset($Donnees[$j]['iBulle']) ? $Donnees[$j]['iBulle']:$Donnees[$j]['affJS'])."\">";
            $this->buf.=$image.$Donnees[$j]['Donnees']."</A>&nbsp;</TD>\n";
            continue;
         }
         $this->buf.= "    <TD ".(isset($Donnees[$j]['align']) ? (" align=".$Donnees[$j]['align']." ") : " align=left ").">".$Donnees[$j]['Donnees']."&nbsp;</TD>\n";//CLASS='tableau'*/
      }
      $this->buf.= "  </TR>\n";
   }

/*%%%F=====================================================================
                           affTotaux
===========================================================================
Affiche les totaux du tableau, d'une couleur differente
Entrees -------------------------------------------------------------------
~~~~~~~
$Donnes : Tableau de donnes $Donnees[x] = la donne a afficher et x sa position du tableau
$verif   : Nombre de colonne a afficher dans la ligne de totaux, optionnel
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 07/03/2001 Cration
LC 18/02/2003 Ajout du paramtre noSpace pour ne pas afficher les espaces
BP 14/05/2003 ajour $couleur
========================================================================*/
   function affTotaux($Donnees,$colspan='', $couleur = "totaux")
   {
      global $styleUrl;

      $this->buf.="  <TR CLASS='".$couleur."'>\n";
      $deb=0;
      if (isset($colspan))
      {
	     if (isset($Donnees[0]['noSpace']))
            $this->buf.= "    <TD CLASS='".$couleur."' COLSPAN=$colspan>".$Donnees[0]['Donnees']."</TD>\n";
         else
         	$this->buf.= "    <TD CLASS='".$couleur."' COLSPAN=$colspan>&nbsp;".$Donnees[0]['Donnees']."&nbsp;</TD>\n";

         $deb=1;
      }
      for($j=1; $j <=count($Donnees);$j++)  //On affiche les resultats
      {		 	  		
        if (isset($Donnees[$j]['Monnaie']))
        {
            if ($Donnees[$j]['Monnaie']=="TEU")
            {
               $this->buf.= "    <TD CLASS='".$couleur."'>&nbsp;".number_format($Donnees[$j]['Donnees'],2,"."," ")."&nbsp;</TD>\n";
               $this->buf.= "    <TD CLASS='".$couleur."'>&nbsp;".number_format($Donnees[$j]['Donnees']*6.55957,2,"."," ")."F&nbsp;</TD>\n";
            }
            else
            {
               $this->buf.= "    <TD CLASS='".$couleur."'>&nbsp;".number_format($Donnees[$j]['Donnees']/6.55957,2,"."," ")."&nbsp;</TD>\n";
               $this->buf.= "    <TD CLASS='".$couleur."'>&nbsp;".number_format($Donnees[$j]['Donnees'],2,"."," ")."F&nbsp;</TD>\n";
            }
            continue;
         }
         if (isset($Donnees[$j]['Url']))
         {  //Donnes URL
            $image='';
            $jTexte='';
            $target='';
            if (isset($Donnees[$j]['affJS']))  $jTexte = " onMouseOver=\"return mOver('".$Donnees[$j]['affJS']."')\" onMouseOut=\"mOut()\"";
            if (isset($Donnees[$j]['Target'])) $target=" TARGET='".$Donnees[$j]['Target']."'";
            if (isset($Donnees[$j]['image']))  $image="<IMG SRC=\"".$Donnees[$j]['image']."\" ALT=\"".$Donnees[$j]['alt']."\" BORDER=0>";
            $this->buf.= "       <TD ".(!$this->coul ? $this->construcStyleUrl($styleUrl['total']['debut'],$styleUrl['total']['fin']):$this->construcStyleUrl($styleUrl['total']['debut'],$styleUrl['total']['fin'])).">\n&nbsp;";
            $this->buf.="<A class='colonne' HREF=".$Donnees[$j]['Url'].$target.$jTexte;
            $this->buf.=" TITLE=\"".(isset($Donnees[$j]['iBulle']) ? $Donnees[$j]['iBulle']:$Donnees[$j]['affJS'])."\">";
            $this->buf.=$image.$Donnees[$j]['Donnees']."</A>&nbsp;</TD>\n";
            continue;
         } 
         if (isset($Donnees[$j]['noSpace']))
             $this->buf.= "    <TD CLASS='".$couleur."'>".$Donnees[$j]['Donnees']."</TD>\n";
         else
             $this->buf.= "    <TD CLASS='".$couleur."'>&nbsp;".$Donnees[$j]['Donnees']."&nbsp;</TD>\n";
      }	
      $this->buf.= "  </TR>\n";
   }

   
   function affLigne($Donnees,$colspan='', $couleur = "totaux")
   {
      global $styleUrl;

      $this->buf.="  <TR CLASS='".$couleur."'>\n";
      $deb=0;
      if (isset($colspan))
      {
	     if (isset($Donnees[0]['noSpace']))
            $this->buf.= "    <TD CLASS='".$couleur."' COLSPAN=$colspan>".$Donnees[0]['Donnees']."</TD>\n";
         else
         	$this->buf.= "    <TD CLASS='".$couleur."' COLSPAN=$colspan>&nbsp;".$Donnees[0]['Donnees']."&nbsp;</TD>\n";

         $deb=1;
      }
      $this->buf.= "  </TR>\n";
   }
/*%%%F=====================================================================
                           piedPage
===========================================================================
Affichage du buffer de donnes, du bas du tableau et des boutons de navigation
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 01/03/2001 Cration
=========================================================================*/
   function piedPage($ret = false)
   {
      $this->buf.="</TABLE></TD></TR>";
      $this->buf.=$this->bufB."</TABLE>"; //On affiche le buffer des boutons
      $this->buf.=$this->positionTableau['fin']; //Position du tableau
      if (!$ret) echo $this->buf;
	  else return $this->buf;
   }

/*%%%F=====================================================================
                           construcStyleUrl
===========================================================================
Construction du style Url
Fonction prive
Modifications -------------------------------------------------------------
~~~~~~~~~~~~~
LC 22/01/2002 Cration
=========================================================================*/
   function construcStyleUrl($couleur1, $couleur2)
   {
      if ($couleur1=="" && $couleur2=="") return "";
      return "onMouseOver=\"this.style.backgroundColor='".$couleur1."';\" onMouseOut=\"this.style.backgroundColor='".$couleur2."';\"";
   }
}

?>