<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";

require_once($DEFAULT_PATH."struct.php");
$droitRole = DRO;//droit de gestion des droits
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "utilisateurs/droits/utr_drt_actAction.php";

$action = pget('action');
$clt_id = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************************************************/
/* DEBUT ACTION = SUPPRESSION		 						*/
/************************************************************/
if ($action == "suppr")
{
	$rol_id = pget('rol_id');
	
	$req = "UPDATE ROLE 
			SET ROL_ETAT = ".ETAT_SUPPR." 
			WHERE ROL_ID = $rol_id";
			
	if (!$gDb->SQLQuery($req, 1))
	{
		$msg = $lang_utr_drt_act_suppr_msg_err;
		$return = 1;
	}
	else
	{
		$msg = $lang_utr_drt_act_suppr_msg_ok;
		$return = 0;
	}			
	$gDb->SQLFermeQuery(1);
}
/************************************************************/
/* FIN ACTION = SUPPRESSION 								*/
/************************************************************/

/************************************************************/
/* DEBUT ACTION = MODIFICATION/CREATION						*/
/************************************************************/
else if ($action == "modif" || $action == "create")
{
	$date = date("Y-m-d H:i:s");
	$rol_id = pget("rol_id");
	$rol_nom = pget("rol_nom");
	$rol_etat = pget('rol_etat');
	$rol_trol = pget('rol_trol');
	
	$rol_fam  = ((pget("rol_fam")  == null)? "NULL": pget("rol_fam"));
	$rol_tdoc = ((pget("rol_tdoc") == null)? "NULL": pget("rol_tdoc"));
	$rol_dest = ((pget("rol_dest") == null)? "NULL": pget("rol_dest"));
	$rol_exp  = ((pget("rol_exp")  == null)? "NULL": pget("rol_exp"));
	
	$roles = array('l', 'm', 'c', 's', 'e');
	
	foreach ($roles as $lettre)
	{
		switch(pget("rol_".$lettre))
		{
			case "1":
				$lmcse = LMCSE_OUI;
				break;
			case "0":
				$lmcse = LMCSE_NON;
				break;
			default:
				$lmcse = LMCSE_NA;
		}
		${"rol_".$lettre} = $lmcse; 
	}
	$fatal = false;
	
	if($action == "modif")
	{
		if($ini_typeBase != 'oracle')	
			$req = "UPDATE ROLE
				SET ROL_DATE_TRAIT 	= '$date', 
					ROL_NOM 		= '".dblQ($rol_nom)."', 
					ROL_ETAT 		= $rol_etat,
	  				FAM_ID 			= $rol_fam, 
					TDOC_ID 		= $rol_tdoc, 
					DESTINATAIRE 	= $rol_dest,
	  				EXPEDITEUR 		= $rol_exp, 
					ROL_LECTURE 	= $rol_l, 
	  				ROL_MODIF 		= $rol_m, 
					ROL_CREAT 		= $rol_c, 
					ROL_SUPPR 		= $rol_s,
					ROL_EXEC 		= $rol_e,
					TROL_ID         = $rol_trol
					where ROL_ID 	= $rol_id";
		else
			$req = "UPDATE ROLE
				SET ROL_DATE_TRAIT 	= TO_DATE ('$date', 'YYYY/MM/DD HH24:MI:SS'), 
					ROL_NOM 		= '".dblQ($rol_nom)."', 
					ROL_ETAT 		= $rol_etat,
	  				FAM_ID 			= $rol_fam, 
					TDOC_ID 		= $rol_tdoc, 
					DESTINATAIRE 	= $rol_dest,
	  				EXPEDITEUR 		= $rol_exp, 
					ROL_LECTURE 	= $rol_l, 
	  				ROL_MODIF 		= $rol_m, 
					ROL_CREAT 		= $rol_c, 
					ROL_SUPPR 		= $rol_s,
					ROL_EXEC 		= $rol_e,
					TROL_ID         = $rol_trol
					where ROL_ID 	= $rol_id";
	}
	else if ($action == "create")
	{
	
		if($ini_typeBase != 'oracle')
			$req = "INSERT INTO ROLE (ROL_NOM, ROL_DATE_CREAT, ROL_DATE_TRAIT,
					ROL_LECTURE, ROL_MODIF, ROL_CREAT, ROL_SUPPR, ROL_EXEC,  
					TDOC_ID, ROL_ETAT, CLT_ID, TROL_ID, 
					EXPEDITEUR, DESTINATAIRE, FAM_ID)
				VALUES ('".dblQ($rol_nom)."',
						'$date',
						'$date',
						$rol_l,
						$rol_m,
						$rol_c,
						$rol_s,
						$rol_e,
						$rol_tdoc,
						$rol_etat,
						$clt_id,
						$rol_trol,
						$rol_exp,
						$rol_dest,
						$rol_fam)";
		else				
			$req = "INSERT INTO ROLE (ROL_NOM, ROL_DATE_CREAT, ROL_DATE_TRAIT,
					ROL_LECTURE, ROL_MODIF, ROL_CREAT, ROL_SUPPR, ROL_EXEC,  
					TDOC_ID, ROL_ETAT, CLT_ID, TROL_ID, 
					EXPEDITEUR, DESTINATAIRE, FAM_ID)
				VALUES ('".dblQ($rol_nom)."',
						TO_DATE ('$date', 'YYYY/MM/DD HH24:MI:SS'),
						TO_DATE ('$date', 'YYYY/MM/DD HH24:MI:SS'),
						$rol_l,
						$rol_m,
						$rol_c,
						$rol_s,
						$rol_e,
						$rol_tdoc,
						$rol_etat,
						$clt_id,
						$rol_trol,
						$rol_exp,
						$rol_dest,
						$rol_fam)";
	}
	
	$gDb->SQLTransact();
	$res = $gDb->SQLQuery($req, 1);
	
	if ($res[0] == SQL_DUP_CHAMP)
	{
		$msg = $lang_utr_drt_act_create_msg_mm_nom;
		$return = 1;
		$fatal = true;
	}
		
	if ($res==null)
	{
		$msg=$lang_utr_drt_act_modif_msg_err;
		if ($action=="create") {
			$msg = $lang_utr_drt_act_create_msg_err;
		}
		$return = 1;
		$fatal = true;
	}
	
	if ($fatal)
		$gDb->SQLRollBack();
	else
	{
		$gDb->SQLCommit();
		$msg=$lang_utr_drt_act_modif_msg_ok;
		if ($action=="create") {
			$msg = $lang_utr_drt_act_create_msg_ok;
		} 
		$return = 0;
	}
	$gDb->SQLFermeQuery(1);
}

/************************************************************/
/* FIN ACTION = MODIFICATION/CREATION						*/
/************************************************************/

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
echo encode_JSON($reponse);
?>