<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");

$droitRole = DRO;//droit de gestion des droits
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once ($DEFAULT_PATH."inc/php/utils.php");

$where = "";

//recuperation des donnees du filtre
$f_etat = pget('f_etat');
$f_nom = pget('f_nom');
$f_date_deb = pget('f_date');
$f_date_fin = pget('f_dateF');
$f_type = pget('f_type');
$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

if ($f_nom)
	$where .= " AND ROL_NOM like '%".dblQ($f_nom)."%' ";
	
if ($f_etat)
	$where .= " AND ROL_ETAT = '$f_etat' ";

	
// traitement des dates
if($f_date_deb) {
	if($f_date_fin) {
		if($ini_typeBase == "oracle"){
				$date_deb_sql = "TO_DATE('$f_date_deb','DD/MM/YYYY HH24:MI:SS')";
				$date_fin_sql = "TO_DATE('$f_date_fin 23:59:59','DD/MM/YYYY HH24:MI:SS')";
				$where .= " AND ROL_DATE_TRAIT BETWEEN $date_deb_sql AND $date_fin_sql";
		}
		else{
			$where .= " AND ROL_DATE_TRAIT BETWEEN '".date2Sql($f_date_deb, "00:00:00")."' AND '".date2Sql($f_date_fin, "23:59:59")."'";
		}
	}
	else{
		if($ini_typeBase == "oracle"){
			$where .= " AND ROL_DATE_TRAIT >= TO_DATE('$f_date_deb', 'DD/MM/YYYY HH24:MI:SS')";
		}
		else{
			$where .= " AND ROL_DATE_TRAIT >= '".date2Sql($f_date_deb, "00:00:00")."'";
		}
	}
}
else if($f_date_fin) {
	if($ini_typeBase == "oracle"){
		$where .= " AND ROL_DATE_TRAIT <= TO_DATE('$f_date_fin 23:59:59', 'DD/MM/YYYY HH24:MI:SS')";
	}
	else{
		$where .= " AND ROL_DATE_TRAIT <= '".date2Sql($f_date_fin, "23:59:59")."'";
	}		
}	

	
if ($f_type)
	$where .=" AND ROLE.TROL_ID = ".$f_type." ";

$cltID 	= $_SESSION['CLT_ID'];

$req = "SELECT SQL_CALC_FOUND_ROWS ROL_NOM, ROL_ID, ROL_ETAT, ROL_DATE_CREAT, ROL_DATE_TRAIT
   		FROM ROLE 
			WHERE CLT_ID = $cltID
			AND ROL_ETAT != ".ETAT_SUPPR." 
			$where
		ORDER BY ROL_NOM";

$gDb->SQLQuery($req, 1,($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

$champs = array();
$champs[] = array("nom" => $lang_utr_drt_grid_head_nom, "toolTip" => $lang_utr_drt_grid_head_nom, "sortMode" => "1");
$champs[] = array("nom" => $lang_utr_drt_grid_head_etat, "toolTip" => $lang_utr_drt_grid_head_etat, "sortMode" => "1");
$champs[] = array("nom" => $lang_utr_drt_grid_head_datecreat, "toolTip" => $lang_utr_drt_grid_head_datecreat, "sortMode" => "1");
$champs[] = array("nom" => $lang_utr_drt_grid_head_datemodif, "toolTip" => $lang_utr_drt_grid_head_datemodif, "sortMode" => "1");

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';

echo '</header>';

	while($row = $gDb->SQLNextRow(1))
	{
		
		$params = array();
		$params['rol_id'] = $row['ROL_ID'];
		$params['droits'] = array('modif' => (droit($droitRole, DROIT_MODIF,null,null,null,null)),
		'detail' => (droit($droitRole, DROIT_LECT,null,null,null,null)),
		'suppr' => (droit($droitRole, DROIT_SUPPR,null,null,null,null)));

		echo '<row>';
		$caption = hi_disp($row['ROL_NOM']);
		$toolTip="";
		
		echo '<item caption="'.$caption.'" icon="'.$pathFlow.'style/imgs/icons/right.png" toolTip="'.$toolTip.'" value="'.row_encode_JSON($params).'"/>';
		
		$icon = "";
		$toolTip = "";	
		switch($row['ROL_ETAT'])
		{
			case ETAT_ACTIF:
				$icon = $pathFlow.'style/imgs/icons/lamp_on.png';
				$toolTip = "Actif";
				break;
			case ETAT_INACTIF:
				$icon = $pathFlow.'style/imgs/icons/lamp_off.png';
				$toolTip = "Inactif";
				break;
			case ETAT_SUPPR:
				$icon = $pathFlow.'style/imgs/icons/trash.png';
				$toolTip = "Supprim�";
				break;
		}
		echo '<item icon="'.$icon.'" toolTip="'.$toolTip.'"/>';
		
		echo '<item caption="'.sql2Date($row['ROL_DATE_CREAT']).'"/>';
		
		$date = "";
		if ($row['ROL_DATE_TRAIT'])
			$date = sql2Date($row['ROL_DATE_TRAIT']);
		echo '<item caption="'.$date.'"/>';
		
		
	
		echo '</row>';
	}
	$gDb->SQLFermeQuery(1);

echo '</databind>';
?>