<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";

require_once($DEFAULT_PATH."struct.php");
$droitRole = FAM; //droit de gestion des familles
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs
$where = "";

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$page_courante = "utilisateurs/familles/utr_fam_actAction.php";

$action = pget('action');
$clt_id = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

/************************************************************/
/* DEBUT ACTION = SUPPRESSION		 						*/
/************************************************************/
if ($action == "suppr")
{
	$fam_id = pget('fam_id');
	$res = $gDb->SQLQuery ("SELECT UTR_ID
							FROM UTILISATEUR
								WHERE FAM_ID = $fam_id
								AND UTR_ETAT != ".ETAT_SUPPR, 1);
	if ($res == null)
	{
		$msg = $lang_utr_fam_act_suppr_msg_err;
		$return = 1;
	}
	else
	{
		$res = $gDb->SQLNextRow(1);
		if ($res[0] != null)
		{
			$msg = "$lang_utr_fam_act_suppr_msg_utrlink $lang_utr_fam_act_suppr_msg_beforesuppr";
			$return = 1;
		}
		else
		{
			$res = $gDb->SQLQuery ("SELECT ROL_ID
									FROM ROLE
										WHERE FAM_ID = $fam_id
										AND ROL_ETAT != ".ETAT_SUPPR, 1);
			if ($res==null)
			{
				$msg = $lang_utr_fam_act_suppr_msg_err;
				$return = 1;
			}
			else
			{
				$res = $gDb->SQLNextRow(1);
				if ($res[0] != null)
				{
					$msg = "$lang_utr_fam_act_suppr_msg_drtlink $lang_utr_fam_act_suppr_msg_beforesuppr";
					$return = 1;
				}
				else
				{
					$req = "UPDATE FAMILLE
							SET FAM_ETAT = ".ETAT_SUPPR."
								WHERE FAM_ID = $fam_id";		
					if (!$gDb->SQLQuery($req, 1))
					{
						$msg = $lang_utr_fam_act_suppr_msg_err;
						$return = 1;
					}
					else
					{
						$msg = $lang_utr_fam_act_suppr_msg_ok;
						$return = 0;
					}
				}
			}
		}
	}
	$gDb->SQLFermeQuery(1);
	//$action = null;
}
/************************************************************/
/* FIN ACTION = SUPPRESSION 								*/
/************************************************************/
/************************************************************/
/* DEBUT ACTION = MODIFICATION/CREATION						*/
/************************************************************/
else if ($action == "modif" || $action == "create")
{
	$date = date("Y-m-d H:i:s");
	$fam_nom = pget("fam_nom");
	$fam_etat = pget('fam_etat');
	$fam_id = pget("fam_id");	
	$utr_inactif = pget ('utr_inactif');
	
	$fatal = false;
	
	if($action == "modif")
	{
		if($ini_typeBase == 'oracle')
			$req = "UPDATE FAMILLE
				SET FAM_DATE_TRAIT=TO_DATE ('".$date."', 'YYYY/MM/DD HH24:MI:SS'), FAM_NOM='".dblQ($fam_nom)."', FAM_ETAT='".$fam_etat."'
				WHERE FAM_ID='".$fam_id."'";
		else
			$req = "UPDATE FAMILLE
				SET FAM_DATE_TRAIT='".$date."', FAM_NOM='".dblQ($fam_nom)."', FAM_ETAT='".$fam_etat."'
				WHERE FAM_ID='".$fam_id."'";
		
		if ($utr_inactif=="true") {
			$req2="UPDATE UTILISATEUR
					SET UTR_ETAT='".ETAT_INACTIF."'
					WHERE FAM_ID='".$fam_id."'";
		}
	}
	else if ($action == "create")
	{
	
		if($ini_typeBase != 'oracle')
			$req = "INSERT INTO FAMILLE (FAM_ETAT, FAM_NOM, FAM_DATE_CREAT, FAM_DATE_TRAIT, CLT_ID)
				VALUES(".$fam_etat.",'".dblQ($fam_nom)."', '".$date."', '".$date."', ".$clt_id.")";
		else
			$req = "INSERT INTO FAMILLE (FAM_ETAT, FAM_NOM, FAM_DATE_CREAT, FAM_DATE_TRAIT, CLT_ID)
				VALUES(".$fam_etat.",'".dblQ($fam_nom)."', TO_DATE ('".$date."', 'YYYY/MM/DD HH24:MI:SS'), TO_DATE ('".$date."', 'YYYY/MM/DD HH24:MI:SS'), ".$clt_id.")";
	}
		
	$gDb->SQLTransact();
	$res = $gDb->SQLQuery($req, 1);
	if ($utr_inactif=="true") {
		$gDb->SQLQuery($req2, 2);
	}
	
	if ($res[0] == SQL_DUP_CHAMP)
	{
		$msg = $lang_utr_fam_act_create_msg_mm_nom;
		$return = 1;
		$fatal = true;
	}
		
	if ($res==null)
	{
		$msg = (($action == "modif") ? $lang_utr_fam_act_modif_msg_err : $lang_utr_fam_act_create_msg_err);
		$return = 1;
		$fatal = true;
	}
	if ($fatal)
		$gDb->SQLRollBack();
	else
	{
		$gDb->SQLCommit();
		$msg = (($action == "modif") ? $lang_utr_fam_act_modif_msg_ok : $lang_utr_fam_act_create_msg_ok);
		$return = 0;
	}
	$gDb->SQLFermeQuery(1);
	$gDb->SQLFermeQuery(2);
}

/************************************************************/
/* FIN ACTION = MODIFICATION/CREATION						*/
/************************************************************/
$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
echo encode_JSON($reponse);
?>