<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");

$droitRole = UTR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; //lmcs

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$page_courante = "utilisateurs/ldap/utr_ldap_import_actAction.php";

$cltID = $_SESSION['CLT_ID'];	//identifiant du client connect

//Variables pour la rponse en JSON
$reponse = array();
$msg = '';
$return = -1;

$action = pget('action');

//donnes encodes en json
$liste = json_decode(pget('liste'), true);

function insert_utilisateur($util)
{
	global $gDb, $cltID;
	$dateModif 		= date("Y-m-d H:i:s");
	$utr_civilite 	= UTR_CIVILITE_MR;
	$utr_nom 		= dblQ($util['nom']);
	$utr_etat 		= ETAT_ACTIF;
	$utr_fam 		= $util['fam_id'];
	
	if(strtolower($util['prenom'])=='null')
		$utr_prenom = '';
	else
		$utr_prenom = dblQ($util['prenom']);
		
	if(strtolower($util['telephone'])=='null')
		$utr_tel 	= '';
	else
		$utr_tel 	= dblQ($util['telephone']);
		
	if(strtolower($util['mail'])=='null')
		$utr_mail	= '';
	else
		$utr_mail 	= dblQ($util['mail']);
 	
	$req = "select count(*) AS nb 
			from UTILISATEUR 
			where UTR_NOM = '$utr_nom' 
			and UTR_PRENOM = '$utr_prenom' 
			and CLT_ID = $cltID";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	
	if ($row['nb'] > 0)
		return -1;
	
	$req = "INSERT INTO UTILISATEUR 
			(UTR_ETAT, UTR_NOM, UTR_DATE_CREAT, UTR_DATE_TRAIT, FAM_ID, UTR_CIVILITE, 
			UTR_PRENOM, UTR_MAIL, UTR_TEL, CLT_ID)
			VALUES ($utr_etat,
			'$utr_nom', 
			'$dateModif',
			'$dateModif',
			$utr_fam,
			$utr_civilite,
			'$utr_prenom',
			'$utr_mail',
			'$utr_tel', 
			$cltID)";

	if(!$gDb->SQLQuery($req, 1))
		$ret = 0;
	else
		$ret = $gDb->SQLlastID();
	
	$gDb->SQLFermeQuery(1);
	
	return $ret;
}

function insert_compte($utr_id, $util)
{
	global $gDb, $cltID;
	$req = "select ROL_ID 
			from ROLE, TYPE_ROLE 
			where ROLE.TROL_ID = TYPE_ROLE.TROL_ID 
			and ROLE.CLT_ID = $cltID 
			and TYPE_ROLE.CLT_ID = $cltID 
			and ROL_ETAT != ".ETAT_SUPPR." 
			and TROL_NUM = ".CPT;
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	if ($row['ROL_ID']) $profil = $row['ROL_ID'];
	$gDb->SQLFermeQuery(1);
	
	$cpt_etat 		= ETAT_ACTIF;
	$dateModif 		= date("Y-m-d H:i:s");
	$cpt_login		= dblQ($util['login']);
	$cpt_pwd		= $util['pwd'];
	if($cpt_pwd=='' || strtolower($cpt_pwd)=='null')
	{
		$cpt_change_pwd	= 1;
		$cpt_pwd = '';
	}
	else
	{
		$cpt_change_pwd	= $util['changepwd'];
		if (strlen($cpt_pwd)<32)
			$cpt_pwd = dblQ(md5($cpt_pwd));
		else
			$cpt_pwd = dblQ($cpt_pwd);
	}
	$cpt_pwd_periode= $util['pwdperiode'];
	
	$req = "select count(*) AS nb 
			from COMPTE 
			where CPT_LOGIN = '$cpt_login'";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$nb = $row['nb'];
	$gDb->SQLFermeQuery(1);
	if ($nb > 0)
		return -1;
	
	$gDb->SQLTransact();

	$req = "insert into COMPTE 
			(CPT_LOGIN, CPT_PWD, CPT_DATE_CREAT, CPT_DATE_TRAIT, UTR_ID, 
			CPT_ETAT, CLT_ID, CPT_CHANGE_PWD, CPT_PWD_PERIODE, CPT_NBRE_LIGNE, 
			CPT_DELAI_PROC, CPT_TYPELECT, CPT_NOMLECT, CPT_NUMCARTE, CPT_IDNAT,CPT_NOMLECTEBX, CPT_SLOT)
			values ('$cpt_login', 
			'$cpt_pwd', 
			'$dateModif', 
			'$dateModif', 
			$utr_id, 
			'$cpt_etat', 
			'$cltID', 
			'$cpt_change_pwd', 
			'$cpt_pwd_periode', 
			'30', 
			'30',
			'1',
			'',
			'',
			'',
			'0',
			'0')";

	$ret = $gDb->SQLQuery($req, 1);
	if (!$ret)
	{
		$gDb->SQLFermeQuery(1);
		$gDb->SQLRollBack();
		return -2;
	}
		
	$cpt_id = $gDb->SQLlastID();
	$gDb->SQLFermeQuery(1);
	
	$req = "insert into COMPTE_ROLE (CPT_ID, ROL_ID, CLT_ID) 
			values ($cpt_id, $profil, $cltID)";
			
	$ret = $gDb->SQLQuery($req, 1);
	$gDb->SQLFermeQuery(1);
	
	if (!$ret)
	{
		$gDb->SQLRollBack();
		return -3;
	}

	$gDb->SQLCommit();
	return 0;
}

if (droit($droitRole, DROIT_CREAT,null,null,null,null))
{
	$token = array('%login', '%prenom%', '%nom%');
	
	foreach($liste as $utils)
	{
		foreach($utils as $util)
		{
			$fam_id = $util['fam_id']; // c'est le mme pr tous
			$ret = insert_utilisateur($util);
			if($ret==-1)
			{
				$msg .= str_replace($token, array($util['login'], $util['prenom'], $util['nom']), $lang_utr_ldap_act_create_msg_mm_nom);
			}
			else if($ret==0)
				$msg .= str_replace($token, array($util['login'], $util['prenom'], $util['nom']), $lang_utr_ldap_act_create_msg_err);
			else
			{
				$utr_id = $ret;
				$ret = insert_compte($utr_id, $util);
				if($ret==-1)
					$msg .= str_replace($token, array($util['login'], $util['prenom'], $util['nom']), $lang_utr_ldap_act_cptmodif_msg_mm_nom);
				else if($ret==-2)
					$msg .= str_replace($token, array($util['login'], $util['prenom'], $util['nom']), $lang_utr_ldap_act_cptcreate_msg_err);
				else if($ret==-3)
					$msg .= str_replace($token, array($util['login'], $util['prenom'], $util['nom']), $lang_utr_ldap_act_cptcreate_msg_droit_err);
			}
		}
	}

	if($action=='multi')
	{
		if($msg=='')
		{
			$return = 0;
			$msg = $lang_utr_fam_act_modif_msg_ok;
		}
		else
			$return = 1;

		$url = hi_disp_urlencode($DEFAULT_PATH."utilisateurs/familles/utr_fam_actAffich.php?action=modif&fam_id=$fam_id");
		$onsuccess = "changePage(\'$url\');"; // on change de page quoiqu'il arrive pour voir ceux qui auraient t imports
	}
	else // import d'un seul utilisateur
	{
		if($msg=='')
		{
			$return = 0;
			$msg = $lang_utr_utr_act_create_msg_ok;
			$url = hi_disp_urlencode($DEFAULT_PATH."utilisateurs/utilisateurs/utr_utr_actAffich.php?action=modif&utr_id=$utr_id");
			$onsuccess = "changePage(\'$url\');";
		}
		else
		{
			$return = 1;
			$onsuccess = ""; // erreur on reste sur le grid ldap
		}
	}
}
else
{
	$return = 1;
	$msg = $lang_msg_err_droit;
}

$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['onsuccess'] = $onsuccess;

echo encode_JSON($reponse);
?>