<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
require_once ($DEFAULT_PATH."XPath.class.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

$maxRow=1;

// paramtres LDAP
$ldapHost = pget('adresse');
$ldapPort = pget('port');
$ldapDN = pget('dn');
//$filtre = "(&(objectclass=mailattrs)(!(usertype=1))(!(cn=root)))";
$filtre = pget('filtre');

// variables au format champ;regex
$field_nom = explode(';', pget('nom'));
$field_pnom = explode(';', pget('prenom'));
$field_tel = explode(';', pget('telephone'));
$field_mail = explode(';', pget('mail'));
$field_login = explode(';', pget('login'));
$field_pwd = explode(';', pget('pwd'));

$changepwd = pget('changepwd');
$pwdperiode = pget('pwdperiode');
$fam_id = pget('fam_id');

$ds = @ldap_connect($ldapHost, $ldapPort);
if($ds)
{
	// Version 3 du protocole
	ldap_set_option ($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
		
	// Compatibilit pour Active Directory
	ldap_set_option($ds, LDAP_OPT_REFERRALS, 0);
		
	if(@ldap_bind($ds))
	{
		$sr = ldap_search($ds, $ldapDN, $filtre);
		if($sr)
		{
			$info = ldap_get_entries($ds, $sr);
			
			$maxRow = $info['count'];

			$deb = $pageSize * ($pageNum - 1);
			$end = $pageSize * $pageNum;

			$line = '<header>';
			$line .= '<item caption="'.$lang_lbl_admin_ldap_nom.'" icon="" onClick="" toolTip="" sortMode="1"/>';
			$line .= '<item caption="'.$lang_lbl_admin_ldap_prenom.'" icon="" onClick="" toolTip="" sortMode="1"/>';
			$line .= '<item caption="'.$lang_lbl_admin_ldap_telephone.'" icon="" onClick="" toolTip="" sortMode="1"/>';
			$line .= '<item caption="'.$lang_lbl_admin_ldap_mail.'" icon="" onClick="" toolTip="" sortMode="1"/>';
			$line .= '<item caption="'.$lang_lbl_admin_ldap_login.'" icon="" onClick="" toolTip="" sortMode="1"/>';
			$line .= '</header>';

			// construction de l'affichage
			for ($i=$deb; $i<$end && $i<$info['count']; $i++)
			{
				$params = array();
				if($field_nom[1]!='' && preg_match("/${field_nom[1]}/", $info[$i][$field_nom[0]][0], $match))
					$params['nom'] = $match[1];
				else
					$params['nom'] = $info[$i][$field_nom[0]][0];
					
				if($params['nom']!='')
				{
					if($field_pnom[1]!='' && preg_match("/${field_pnom[1]}/", $info[$i][$field_pnom[0]][0], $match))
						$params['prenom'] = $match[1];
					else
						$params['prenom'] = $info[$i][$field_pnom[0]][0];
					
					if($field_tel[1]!='' && preg_match("/${field_tel[1]}/", $info[$i][$field_tel[0]][0], $match))
						$params['telephone'] = $match[1];
					else
						$params['telephone'] = $info[$i][$field_tel[0]][0];
					
					if($field_mail[1]!='' && preg_match("/${field_mail[1]}/", $info[$i][$field_mail[0]][0], $match))
						$params['mail'] = $match[1];
					else
						$params['mail'] = $info[$i][$field_mail[0]][0];
					
					if($field_login[1]!='' && preg_match("/${field_login[1]}/", $info[$i][$field_login[0]][0], $match))
						$params['login'] = $match[1];
					else
						$params['login'] = $info[$i][$field_login[0]][0];
					
					if($field_pwd[1]!='' && preg_match("/${field_pwd[1]}/", $info[$i][$field_pwd[0]][0], $match))
						$params['pwd'] = $match[1];
					else
						$params['pwd'] = $info[$i][$field_pwd[0]][0];
					
					$params['changepwd'] = $changepwd;
					$params['pwdperiode'] = $pwdperiode;
					$params['fam_id'] = $fam_id;
					$params['droits'] = array('import_ldap' => ($params['nom']!='')?true:false);
					
					$line .= '<row>';
					$line .= '<item caption="'.hi_disp($params['nom']).'" icon="'.$pathStyle.'/imgs/icons/user.png" value="'.row_encode_JSON($params).'"/>';
					$line .= '<item caption="'.hi_disp($params['prenom']).'"/>';
					$line .= '<item caption="'.$params['telephone'].'"/>';
					$line .= '<item caption="'.$params['mail'].'"/>';
					$line .= '<item caption="'.hi_disp($params['login']).'"/>';
					$line .= '</row>';
				}
			}
		}
		else
		{
			$line = "<header><item caption=' '/></header><row><item caption='$lang_utr_lbl_import_ldap_err_filtre'/></row>";
			$line = str_replace("%filtre%", $line, $filtre);
			$line = str_replace("%ldapDN%", $line, $ldapDN);
		}
		// dconnexion
		ldap_unbind($ds);
	}
	else
	{
		$line = "<header><item caption=' '/></header><row><item caption='$lang_utr_lbl_import_ldap_err_host'/></row>";
		$line = str_replace("%filtre%", $line, $ldapHost);
	}
}
else
{
	$line = "<header><item caption=' '/></header><row><item caption='$lang_utr_lbl_import_ldap_err_host'/></row>";
	$line = str_replace("%filtre%", $line, $ldapHost);
}

$xml = '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">'; 
$xml .= $line.'</databind>';

echo $xml;
?>