<?php
$DEFAULT_PATH = "../../";
require_once ($DEFAULT_PATH."struct.php");

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
require_once($DEFAULT_PATH."vtemplate.class.php");	//class template

$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$page_courante = "utilisateurs/ldap/utr_ldap_list.php";

$clt_id = $_SESSION['CLT_ID'];	//identifiant du client connect
$import = pget('import');

include($DEFAULT_PATH."header.php");			//en_tete et javascript

$vtp = new VTemplate;
$form = $vtp->Open($DEFAULT_PATH."template/listing.vtp");
$vtp->addSession($form, "global");
$vtp->setVar($form, "global.page_headers", $page_headers);
$vtp->setVar($form, "global.title", addslashes($lang_menu_lbl_admin_ldap_caption));
$vtp->setVar($form, "global.icon", $pathStyle."imgs/icons/title/ldap.png");
$vtp->setVar($form, "global.help_id", "import_ldap");

$paramUrl = '';
foreach($_GET as $key => $val)
{
	if($paramUrl == '')
		$paramUrl = "?$key=".hi_disp_urlencode($val);
	else
		$paramUrl .= "&$key=".hi_disp_urlencode($val);
}

$vtp->setVar($form, "global.url_grid",$pathFlow."utilisateurs/ldap/utr_ldap_importdSXmlGrid.php".$paramUrl);
$vtp->setVar($form, "global.grid_async", "true");
$vtp->setVar($form, "global.grid_multiSelect", $import=="multi"?"true":"false");
$vtp->setVar($form, "global.grid_checkBoxes", $import!="false"?"true":"false");
$vtp->setVar($form, "global.grid_pageSize", "5");

//*
//* Cration du filtre
//*
$filtre = array();

//Nombre de lignes
$filtre[] = array("id_filtre" => "limitStep", "type_filtre" => "prlFiltreField.types.prlComboList",
					"libelle_filtre" => $lang_sui_proc_filtre_lbl_afficher,
					"value_filtre" => $ini_taille_page_suivi,
					"ds_filtre" => $pathFlow."dataSources/dSComboRow.php");

mkFiltre($vtp, $form, $filtre);

//*
//* Actions de la toolbar
//*
$option_toolbar = array("select" => $import=="multi"?true:false,
						"detail" => false,
						"print" => array("show" => false,
										"title" => ""),
						"csv" => false);

if($import!='false')
{
	$option_toolbar[] = array("caption" => $lang_lbl_retour,
								"icon" => $pathFlow."style/imgs/icons/retour.gif",
								"onClick" => "history.go(-1);");

	$option_toolbar[] = array("caption" => '',
								"icon" => '',
								"onClick" => '',
								"value" => '__SEPARATOR__');
}

if($import!='false')
{
	// Importer
	$option_toolbar[] = array("caption" => $lang_utr_lbl_import_ldap,
								"icon" => $pathFlow."style/imgs/icons/import.gif",
								"action" => array("name" => "import_ldap",
												"page" => "utilisateurs/ldap/utr_ldap_import_actAction.php",
												"callback" => "prlExecGrid",
												"get_params" => array('action', 'liste')));
}

mkToolbar($vtp, $form, $option_toolbar);

$body_js = "
rowAction.actions.import_ldap.check = function (params, list_params)
{
	params.liste = '{\"utilisateurs\": [';
	for(var i=0; i<list_params.length; i++)
	{
		if(i>0)
			params.liste += ',';
			
		params.liste += '{\"nom\":\"' + list_params[i].nom + '\",\"prenom\":\"' + list_params[i].prenom + '\",\"telephone\":\"' + list_params[i].telephone + '\",\"mail\":\"' + list_params[i].mail + '\",\"login\":\"' + list_params[i].login + '\",\"pwd\":\"' + list_params[i].pwd + '\",\"changepwd\":\"' + list_params[i].changepwd + '\",\"pwdperiode\":\"' + list_params[i].pwdperiode + '\",\"fam_id\":\"' + list_params[i].fam_id +'\"}';
	}
	params.liste += ']}';
	
	params.action = '$import';
	
	return true;
};
";

$vtp->setVar($form, "global.body_javascript", $body_js);

$vtp->closeSession($form, "global");
$vtp->Display();
?>