<?php
$DEFAULT_PATH = "../../";
$culture_content_type = "plain/text; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";

require_once($DEFAULT_PATH."struct.php");
$droitRole = UTR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR;
$where = "";

require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");

$page_courante = "utilisateurs/utilisateurs/utr_utr_actAction.php";

$action = pget('action');
$evenement = pget('evenement');
$onsuccess="";
$utr_id = pget('utr_id');

$cptID = $_SESSION['CPT_ID'];
$cltID = $_SESSION['CLT_ID'];

//Variables pour la réponse en JSON
$reponse = array();
$msg = '';
$return = -1;

if ($action == "mail")
{
	//Sujet du mail
	$sujet = $lang_utr_utr_act_mail_title;
	$req = "SELECT UTR_MAIL
			FROM UTILISATEUR, COMPTE
			WHERE CPT_ID = $cptID
				AND COMPTE.UTR_ID=UTILISATEUR.UTR_ID";
	$gDb->SQLQuery($req, 1);
   	$row = $gDb->SQLNextRow(1);
	$mail_from		= $row['UTR_MAIL'];
	$gDb->SQLFermeQuery(1);
	
	//entetes du mail
	$headers = "MIME-Version: 1.0\r\n".
				"From: $mail_from\r\n".
				"Reply-To: $mail_administrateur <Admin Flow-Manager>\r\n".
				"X-Priority: 1\r\n".
				"X-MSMail-Priority: High\r\n".
				"Content-Type: text/plain; charset=UTF-8\r\n".
				"X-Mailer: Just My Server";
	
	//Message de presentation standart
	
	$tete  = "\r\n ".str_replace("%ADDR%", "http://".getenv(HTTP_HOST).$pathFlow, $lang_utr_utr_act_mail_entete_addr);		
	$tete .= "\r\n$lang_utr_utr_act_mail_entete_info";
	
	//Recuperation des informations de l'utilisateur
	$req = "SELECT UTR_CIVILITE, UTR_NOM, UTR_PRENOM, UTR_MAIL, UTR_TEL, FAM_ID  
			FROM UTILISATEUR 
			WHERE UTR_ID = $utr_id";
	$gDb->SQLQuery($req, 1);
   	$row = $gDb->SQLNextRow(1);
	if ($row['UTR_CIVILITE'] == UTR_CIVILITE_MLLE) 	$utr_civilite = $lang_utr_utr_act_mail_msg_lbl_mlle;
	if ($row['UTR_CIVILITE'] == UTR_CIVILITE_MME) 	$utr_civilite = $lang_utr_utr_act_mail_msg_lbl_mme;
	if ($row['UTR_CIVILITE'] == UTR_CIVILITE_MR) 	$utr_civilite = $lang_utr_utr_act_mail_msg_lbl_mr;
	$utr_nom 	= $row['UTR_NOM'];
	$utr_prenom = $row['UTR_PRENOM'];
	$utr_tel 	= $row['UTR_TEL'];
	$utr_mail	= $row['UTR_MAIL'];
	$fam_id		= $row['FAM_ID'];
	$gDb->SQLFermeQuery(1);
	
	//R�cup�ration de la famille de l'utilisateur
	$req = "select FAM_NOM 
			from FAMILLE 
			where FAM_ID = $fam_id";
	$gDb->SQLQuery($req, 1);
   	$row = $gDb->SQLNextRow(1);
	$fam_nom 	= $row['FAM_NOM'];
	$gDb->SQLFermeQuery(1);
	
	//Message a afficher concernant l'utilisateur
	$util = "\r\n\r\n$utr_civilite  $utr_nom  $utr_prenom".
			"\r\n".($lang_utr_utr_act_mail_msg_lbl_tel)." : $utr_tel".
			"\r\n$lang_utr_utr_act_mail_msg_lbl_grp : $fam_nom".
			"\r\n";

	//Recuperation des comptes de l'utilsateur
	$req = "SELECT CPT_LOGIN
			FROM COMPTE 
			WHERE UTR_ID = $utr_id 
			AND CPT_ETAT != ".ETAT_SUPPR."  
			ORDER by CPT_ID ";
	$gDb->SQLQuery($req, 1);
	$compte = "";
	while ($row = $gDb->SQLNextRow(1))
	{
		//Message a afficher concernant les comptes de l'utilisateur
 		$compte .= "\r\n\r\n$lang_utr_utr_act_mail_msg_lbl_cpt : ".
					"\r\n      $lang_utr_utr_act_mail_msg_lbl_login :\t\t".$row['CPT_LOGIN'].
					"\r\n";
	}
	$gDb->SQLFermeQuery(1);
	
	//Message de conclusion standart	
	$pied = "\r\n\r\n$lang_utr_utr_act_mail_pied_info";

	//Contenu du mail
	$mail = $tete.$util.$compte.$pied;
	
	if (!@mail($utr_mail, $sujet, $mail, $headers))
	{
		//Une erreur s'est produite
		$msg = $lang_utr_utr_act_mail_msg_err;
		$return = 1;
	}
	else
	{
		$msg = $lang_utr_utr_act_mail_msg_ok;
		$return = 0;
	}
}

if ($action == "suppr" && droit($droitRole, DROIT_SUPPR,null,null,null,null))
{		
	//L'utilisateur ne peut etre supprime s'il correspond a la personne connecte
	$req = "SELECT CPT_ID 
			FROM COMPTE where 
			UTR_ID = $utr_id";
	
	$gDb->SQLQuery($req, 1);
	while($row = $gDb->SQLNextRow(1))
	{
		if ($row['CPT_ID'] == $cptID)
		{
			$msg = $lang_utr_utr_act_suppr_utr_msg_selfsuppr;
			$return = 1;
			$fatal = true;
		}
	}
	$gDb->SQLFermeQuery(1);
	
	//L'utilisateur ne peut etre supprime si des alertes (table TYP_ALERTE) y font reference
	if (!$fatal)
	{
		$req = "SELECT COUNT(*) AS nb 
				FROM TYP_ALERTE 
				WHERE (TAL_DEST_ID = $utr_id 
				OR TAL_DESTCC_ID = $utr_id) 
				AND TAL_ETAT != ".ETAT_SUPPR;
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$nb = $row['nb'];
		$gDb->SQLFermeQuery(1);
		if ($nb > 0)
		{
			$msg = $lang_utr_utr_act_suppr_utr_msg_alertlink;
			$return = 1;
			$fatal = true;
		}
	}

	//Tout est OK pour la suppression
	if (!$fatal)
	{
		$gDb->SQLTransact();	
		
		//Mise � jour de l'utilisateur --> ETAT_SUPPR
		$req = "UPDATE UTILISATEUR 
				SET UTR_ETAT = ".ETAT_SUPPR." 
				WHERE UTR_ID = $utr_id";
		if (!$gDb->SQLQuery($req, 1))
			$fatal = true;
	
		//Mise � jour des comptes de l'utilisateur --> ETAT_SUPPR
		$req = "UPDATE COMPTE 
				SET CPT_ETAT = ".ETAT_SUPPR." 
				WHERE UTR_ID = $utr_id";
		if (!$gDb->SQLQuery($req, 1))
			$fatal = true;
	
		if ($fatal == false) 
		{
			$gDb->SQLCommit();
			$msg = $lang_utr_utr_act_suppr_utr_msg_ok;
			$return = 0;
		}
		else 
		{
			$gDb->SQLRollBack(); 
			$msg = $lang_utr_utr_act_suppr_utr_msg_err;
			$return = 1;
		}
		$gDb->SQLFermeQuery(1);
	}
}

if ($action == "modif" && droit($droitRole, DROIT_MODIF,null,null,null,null))
{
	if ($evenement == "suppr")
	{
		$cpt_id = pget('cpt_id');
		$fatal = false;
		
		if ($cpt_id == $cptID)
		{
			$msg = $lang_utr_utr_act_suppr_cpt_msg_selfsuppr;
			$return = 1;
			$fatal = true;
		}
		
		if (!$fatal)
		{
			$gDb->SQLTransact();	
			$req = "UPDATE COMPTE 
					SET COMPTE.CPT_ETAT = ".ETAT_SUPPR." 
					WHERE COMPTE.CPT_ID = $cpt_id";
			if (!$gDb->SQLQuery($req, 1)) $fatal = true;	
			
			if ($fatal == false) 
			{
				$gDb->SQLCommit();
				$msg = $lang_utr_utr_act_suppr_cpt_msg_ok;
				$return = 0;
			}
			else 
			{
				$gDb->SQLRollBack(); 
				$msg = $lang_utr_utr_act_suppr_cpt_msg_err;
				$return = 1;				
			}
			$gDb->SQLFermeQuery(1);	
		}
		else
		{
			$msg = $lang_utr_utr_act_suppr_cpt_msg_err;
			$return = 1;
		}
	}
	else
	//if ($evenement == "valid")
	{	
		
		$dateModif 		= date("Y-m-d H:i:s");
  		$utr_civilite 	= pget('utr_civilite');
  		$utr_nom 		= pget("utr_nom");
  		$utr_prenom 	= pget("utr_prenom");
  		$utr_etat 		= pget('utr_etat');
  		$utr_tel 		= pget("utr_tel");
 		$utr_fam 		= pget('utr_fam');
  		$utr_mail 		= pget("utr_mail");
  		$utr_id 		= pget('utr_id');
  		$fatal 			= false;
		
		$req = "select count(*) AS nb 
				from UTILISATEUR 
				where UTR_NOM = '".dblQ($utr_nom)."' 
				and UTR_PRENOM = '".dblQ($utr_prenom)."' 
				and CLT_ID = $cltID 
				and UTR_ID != $utr_id";
		$gDb->SQLQuery($req,1);
		$row = $gDb->SQLNextRow(1);
		if ($row['nb'] > 0)
		{
			$msg = $lang_utr_utr_act_modif_msg_mm_nom;
			$return = 1;
			$evenement = null;
		}
		$gDb->SQLFermeQuery(1);
		if (!$fatal)
		{
			if($ini_typeBase != 'oracle')
				$req = "UPDATE UTILISATEUR SET 
					UTR_ETAT 		= $utr_etat, 
					UTR_NOM 		= '".dblQ($utr_nom)."',
	 				UTR_DATE_TRAIT 	= '".dblQ($dateModif)."', 
					FAM_ID 			= $utr_fam, 
					UTR_CIVILITE 	= $utr_civilite, 
					UTR_PRENOM 		= '".dblQ($utr_prenom)."',
	 				UTR_MAIL 		= '".dblQ($utr_mail)."', 
					UTR_TEL 		= '".dblQ($utr_tel)."' 
					WHERE UTR_ID = $utr_id";
			else
				$req = "UPDATE UTILISATEUR SET 
					UTR_ETAT 		= $utr_etat, 
					UTR_NOM 		= '".dblQ($utr_nom)."',
	 				UTR_DATE_TRAIT 	= TO_DATE ('".dblQ($dateModif)."', 'YYYY/MM/DD HH24:MI:SS'), 
					FAM_ID 			= $utr_fam, 
					UTR_CIVILITE 	= $utr_civilite, 
					UTR_PRENOM 		= '".dblQ($utr_prenom)."',
	 				UTR_MAIL 		= '".dblQ($utr_mail)."', 
					UTR_TEL 		= '".dblQ($utr_tel)."' 
					WHERE UTR_ID = $utr_id";
			
			if (! $gDb->SQLQuery($req, 1))
				$fatal = true;
			
			if (!$fatal)
			{
					$msg = $lang_utr_utr_act_modif_msg_ok;
					$return = 0; 
			}
			else 
			{
				$msg = $lang_utr_utr_act_modif_msg_err;
				$return = 1;
			}
			$evenement = null;
			$gDb->SQLFermeQuery(1);
		}
	}
}
if ($action == "create" && droit($droitRole, DROIT_CREAT,null,null,null,null))
{
	$fatal 			= false;
	$dateModif 		= date("Y-m-d H:i:s");
	$utr_civilite 	= pget('utr_civilite');
	$utr_nom 		= pget("utr_nom");
	$utr_prenom 	= pget("utr_prenom");
	$utr_etat 		= pget('utr_etat');
	$utr_tel 		= pget("utr_tel");
	$utr_fam 		= pget('utr_fam');
	$utr_mail 		= pget("utr_mail");
 	
	$req = "select count(*) AS nb 
			from UTILISATEUR 
			where UTR_NOM = '".dblQ($utr_nom)."' 
			and UTR_PRENOM = '".dblQ($utr_prenom)."' 
			and CLT_ID = $cltID";
	$gDb->SQLQuery($req,1);
	$row = $gDb->SQLNextRow(1);
	if ($row['nb'] > 0)
	{
		$msg = $lang_utr_utr_act_create_msg_mm_nom;
		$return = 1;
		$fatal = true;
		$evenement = null;
	}
	
	if (!$fatal)
	{
	
		if($ini_typeBase != 'oracle')
			$req = "INSERT INTO UTILISATEUR 
				(UTR_ETAT, UTR_NOM, UTR_DATE_CREAT, UTR_DATE_TRAIT, FAM_ID, UTR_CIVILITE, 
				UTR_PRENOM, UTR_MAIL, UTR_TEL, CLT_ID)
 				VALUES ($utr_etat,
				'".dblQ($utr_nom)."', 
				'".$dateModif."',
				'".$dateModif."',
				$utr_fam,
				$utr_civilite,
				'".dblQ($utr_prenom)."',
				'".dblQ($utr_mail)."',
				'".dblQ($utr_tel)."', 
				$cltID)";
		else
			$req = "INSERT INTO UTILISATEUR 
				(UTR_ETAT, UTR_NOM, UTR_DATE_CREAT, UTR_DATE_TRAIT, FAM_ID, UTR_CIVILITE, 
				UTR_PRENOM, UTR_MAIL, UTR_TEL, CLT_ID)
 				VALUES ($utr_etat,
				'".dblQ($utr_nom)."', 
				TO_DATE ('".$dateModif."', 'YYYY/MM/DD HH24:MI:SS'),
				TO_DATE ('".$dateModif."', 'YYYY/MM/DD HH24:MI:SS'),
				$utr_fam,
				$utr_civilite,
				'".dblQ($utr_prenom)."',
				'".dblQ($utr_mail)."',
				'".dblQ($utr_tel)."', 
				$cltID)";
							
		$plop = $req;
		
		if (!$gDb->SQLQuery($req, 1))
		{
			$fatal = true;
			$msg = $lang_utr_utr_act_create_msg_err;
			$return = 1;
		}
		else
		{
			$msg = $lang_utr_utr_act_create_msg_ok;
			$return = 0;
		}
	}
	else 
	{
		$msg = $lang_utr_utr_act_create_msg_err;
		$return = 1;
	}
}
$reponse['msg'] = addslashes($msg);
$reponse['return'] = $return;
$reponse['action'] = $action;
echo encode_JSON($reponse);
?>