<?php
$DEFAULT_PATH = "../../";
require_once($DEFAULT_PATH."struct.php");
$droitRole = UTR;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR;

require_once($DEFAULT_PATH."flow.php");
include($DEFAULT_PATH."flow_tools.php");

$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

$utr_id = pget('utr_id');
$pageSize = pget('pageSize');
$pageNum = pget('pageNum');

$req = "SELECT SQL_CALC_FOUND_ROWS CPT_LOGIN, CPT_DATE_CREAT, CPT_DATE_TRAIT, CPT_ETAT, CPT_PWD, CPT_ID, CPT_TYPELECT, CPT_NOMLECT, CPT_NUMCARTE, CPT_IDNAT, CPT_NOMLECTEBX 
		FROM COMPTE 
		WHERE UTR_ID = $utr_id 
			AND CPT_ETAT != ".ETAT_SUPPR."
		ORDER BY CPT_ID";

$champs = array();
$champs[] = array("nom" => $lang_lbl_login, "toolTip" => $lang_lbl_login, "sortMode" => "1");
$champs[] = array("nom" => $lang_lbl_etat, "toolTip" => $lang_lbl_etat, "sortMode" => "1");
$champs[] = array("nom" => $lang_utr_utr_ds_cpt_lbl_droits, "toolTip" => $lang_utr_utr_ds_cpt_lbl_droits, "sortMode" => "1");

$gDb->SQLQuery($req, 1, ($pageNum-1)*$pageSize, $pageSize);

$gDb->SQLQuery('SELECT FOUND_ROWS() AS MAX_ROW', 2);
$row = $gDb->SQLNextRow(2);
$maxRow = $row['MAX_ROW'];
$gDb->SQLFermeQuery(2);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';

foreach ($champs as $col)
	echo '<item caption="'.$col['nom'].'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';
	
echo '</header>';

while ($row = $gDb->SQLNextRow(1))
{
	switch($row['CPT_TYPELECT'])
	{
		case 0 :
			$typelect = $lang_utr_utr_aff_lbl_typelect_del;
			break;
		case 1 :
			$typelect = $lang_utr_utr_aff_lbl_typelect_pc;
			break;
		default : 					
			$typelect = $lang_utr_utr_aff_lbl_typelect_inconnu;
	}
	
	switch($row['CPT_NOMLECTEBX'])
	{
		case 0 :
			$typelectebx = $lang_utr_utr_act_cptcreate_lbl_lecteur_ksign;
			break;
		case 1 :
			$typelectebx = $lang_utr_utr_act_cptcreate_lbl_lecteur_3skey;
			break;
		default : 					
			$typelectebx = $lang_utr_utr_aff_lbl_typelect_inconnu;
	}

	$detail = "<table>";
	$detail .= "<tr><td><b>$lang_utr_utr_aff_lbl_datecreat :</b></td><td>".sql2Date($row['CPT_DATE_CREAT']).'</td>';
	$detail .= "<td style='padding-left:20px;'><b>$lang_utr_utr_aff_lbl_datemodif :</b></td><td>".sql2Date($row['CPT_DATE_TRAIT']).'</td>';
	$detail .= "<td></td></tr><tr><td colspan='3'><u>$lang_utr_utr_lbl_signet5</u></td></tr>";
	$detail .= "<tr><td><b>$lang_utr_utr_lbl_typelect :</b></td><td>$typelect</td>";
	$detail .= "<td style='padding-left:10px;'><b>$lang_utr_utr_lbl_nomport :</b></td><td>".$row['CPT_NOMLECT'].'</td>';
	$detail .= "<td style='padding-left:10px;'><b>$lang_utr_utr_lbl_numcarte :</b></td><td>".$row['CPT_NUMCARTE'].'</td>';
	$detail .= "</tr><tr><td colspan='3'><u>$lang_utr_utr_lbl_ident_cps</u></td></tr>";
	$detail .= "<tr><td><b>$lang_utr_utr_lbl_ident_idnat :</b></td><td>".$row['CPT_IDNAT'].'</td>';
	$detail .= "<td></td><td></td></tr><tr><td colspan='3'><u>$lang_menu_lbl_signebxts_caption</u></td></tr>";
	$detail .= "<tr><td><b>$lang_utr_utr_lbl_typelect :</b></td><td>$typelectebx</td>";
	$detail .= '<td></td><td></td></tr></table>';
	
	echo '<row detail="'.hi_disp($detail).'">';
	
	$params = array();
	$params['cpt_id'] = $row['CPT_ID'];
	$params['cpt_login'] = $row['CPT_LOGIN'];
	$params['droits'] = array('id_modif' => droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null),
							  'id_remove' => droit($droitRole, DROIT_CREAT + DROIT_MODIF,null,null,null,null));
	
	echo '<item caption="'.hi_disp($row['CPT_LOGIN']).'" value="'.row_encode_JSON($params).'"/>';
	
	$caption = "";
	switch($row['CPT_ETAT'])
	{
		case ETAT_ACTIF :
			$caption = "Actif";
			break;
		case ETAT_INACTIF :
			$caption = "Inactif";
			break;
		default :
			$caption = "Supprim�";
	}
	echo '<item caption="'.$caption.'"/>';
	
	$req2 = "select ROLE.ROL_NOM, ROLE.ROL_ID, ROLE.ROL_ETAT 
				from ROLE, COMPTE_ROLE 
				where COMPTE_ROLE.CPT_ID = ".$row['CPT_ID']." 
				and ROL_ETAT != ".ETAT_SUPPR." 
				and COMPTE_ROLE.ROL_ID = ROLE.ROL_ID 
				order by ROL_NOM";
	$gDb->SQLQuery($req2,2);
	$j = 0;
	$list_droit = null;
	while ($row2 = $gDb->SQLNextRow(2)) 
	{
		$deb = $fin = null;
		if ($row2['ROL_ETAT'] == ETAT_INACTIF)
		{
			$deb = AFF_INACTIF_DEB;
			$fin = " $lang_lbl_etat_inact_ini ";
		}
		if($j == 0)
			$list_droit = $deb.hi_disp($row2['ROL_NOM']).$fin;
		else
		$list_droit .= " / ".$deb.hi_disp($row2['ROL_NOM']).$fin;
		$j++;
		
		if($j > 4)
		{
			$list_droit .= " /...";
			break;
		}
	}
	echo '<item caption="'.$list_droit.'"/>';
	$gDb->SQLFermeQuery(2);

	echo '</row>';
}
$gDb->SQLFermeQuery(1);
echo '</databind>';
?>