<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="TYPE_OS"/>
<xsl:param name="TYPE_INSTALL"/>
<xsl:param name="TYPE_DB"/>
<xsl:param name="VERSION_UIF"/>
<xsl:param name="ODBC_DRIVERS"/>
<xsl:param name="DB_SPECIF_XML"/>

<xsl:template match="/SETUP">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<link href="setup.css" rel="stylesheet" type="text/css"/>
<link rel="icon" href="favicon.ico" type="image/x-icon"/>
<link rel="shortcut icon" href="favicon.ico" type="image/x-icon"/>
<!--Construction des controles javascript-->
<script language="javascript">
function verifForm()
{
	var mandatoryStr = "<xsl:value-of select="DISPLAY/@MANDATORYERR"/>";
	var formatStr = "<xsl:value-of select="DISPLAY/@FORMATERR"/>";
	var reg = new RegExp("(%PARAM%)","g");
	<xsl:for-each select="descendant::VAR[contains(@TYPE,$TYPE_INSTALL) and contains(@OS,$TYPE_OS) and (contains(@TYPE_DB, $TYPE_DB) or not(@TYPE_DB))]">
		<xsl:if test="@OBL='1'">
			if (document.formul.<xsl:value-of select="@NAME"/>.value.length == 0) 
			{
				alert(mandatoryStr.replace(reg, "<xsl:value-of select="@LIB"/>"));
				document.formul.<xsl:value-of select="@NAME"/>.focus();
				return false;
			}
		</xsl:if>
		<xsl:if test="@FOR!=''">
			var expr = /<xsl:value-of select="@FOR"/>/;
			if (expr.exec(document.formul.<xsl:value-of select="@NAME"/>.value) == null) 
			{
				alert(formatStr.replace(reg, "<xsl:value-of select="@LIB"/>"));
				document.formul.<xsl:value-of select="@NAME"/>.focus();
				return false;
			}
		</xsl:if>
	</xsl:for-each>
	document.formul.submit();
}
</script>
</head>
<body class="i-fond">
	<form name="formul" method="POST">
		<input type="hidden" name="action" value="valid"/>
		<center><span class="h-stitre"><b><u><xsl:value-of select="DISPLAY/@TITLE"/><xsl:value-of select="$VERSION_UIF"/></u></b></span></center>
		<a class="aide" href="Site/flow/help/sommaire.php?installation=on&#38;id=page_install" target="_blank"><img src="images/help.png" style="border:none;margin-right:5px;vertical-align:bottom;"/><xsl:value-of select="DISPLAY/@HELPBTN"/></a>
		<br/>
		<xsl:apply-templates/>
		<hr/>
		<center>
		<xsl:element name="INPUT">
			<xsl:attribute name="CLASS">h-bout</xsl:attribute>
			<xsl:attribute name="TYPE">button</xsl:attribute>
			<xsl:attribute name="VALUE"><xsl:value-of select="DISPLAY/@BACKBTN"/></xsl:attribute>
			<xsl:attribute name="ONCLICK">javascript:history.back();</xsl:attribute>
		</xsl:element>
		<xsl:element name="INPUT">
			<xsl:attribute name="CLASS">h-bout</xsl:attribute>
			<xsl:attribute name="TYPE">button</xsl:attribute>
			<xsl:attribute name="VALUE"><xsl:value-of select="DISPLAY/@VALIDBTN"/></xsl:attribute>
			<xsl:attribute name="ONCLICK">javascript:if (verifForm()) true;</xsl:attribute>
		</xsl:element>
		</center>
	</form>
</body>
</html>
</xsl:template>

<xsl:template match="VAR">
<xsl:if test="contains(@TYPE,$TYPE_INSTALL) and contains(@OS,$TYPE_OS) and (contains(@TYPE_DB, $TYPE_DB) or not(@TYPE_DB))">
	<table border="0" cellspacing="0" cellpadding="0"><tr>
	<td width="320" class="h-txt">
	<xsl:value-of select="@LIB"/>
	<xsl:if test="@OBL='1'"> (*) </xsl:if>
	 : 
	</td>
	<td>
	<xsl:element name="INPUT">
		<xsl:attribute name="NAME"><xsl:value-of select="@NAME"/></xsl:attribute>
		<xsl:attribute name="SIZE">40</xsl:attribute>
		<xsl:attribute name="CLASS">h-input</xsl:attribute>
		<xsl:attribute name="TYPE">TEXT</xsl:attribute>
		<xsl:attribute name="VALUE"><xsl:value-of select="@DEFAUT"/></xsl:attribute>
	</xsl:element>
	</td>
	<td class="h-txt"><xsl:if test="@REM!=''"> - <xsl:value-of select="@REM"/></xsl:if></td>
	</tr></table>
</xsl:if>
</xsl:template>

<xsl:template match="VARSELECT">
<xsl:if test="contains(@TYPE,$TYPE_INSTALL) and contains(@OS,$TYPE_OS) and (contains(@TYPE_DB, $TYPE_DB) or not(@TYPE_DB))">
	<table border="0" cellspacing="0" cellpadding="0"><tr>
	<td width="320" class="h-txt">
	<xsl:value-of select="@LIB"/>
	<xsl:if test="@OBL='1'"> (*) </xsl:if>
	 : 
	</td>
	<td>
	<xsl:element name="SELECT">
		<xsl:attribute name="NAME"><xsl:value-of select="@NAME"/></xsl:attribute>
		<xsl:attribute name="VALUE"><xsl:value-of select="@DEFAUT"/></xsl:attribute>
		<xsl:apply-templates/>
	</xsl:element>
	</td>
	<td class="h-txt"><xsl:if test="@REM!=''">&#160;- <xsl:value-of select="@REM"/></xsl:if></td>
	</tr></table>
</xsl:if>
</xsl:template>

<xsl:template match="EXTERNRESOURCE">
	<xsl:if test="contains(@NAME, 'ODBC_DRIVERS')">
		<xsl:value-of select="$ODBC_DRIVERS" disable-output-escaping="yes"/>
	</xsl:if>
</xsl:template>

<xsl:template match="SELECTOPTION">
	<xsl:element name="OPTION">
		<xsl:attribute name="VALUE"><xsl:value-of select="@VALUE"/></xsl:attribute>
		<xsl:value-of select="@NAME"/>
	</xsl:element>
</xsl:template>

<xsl:template match="CONST">
<xsl:if test="contains(@TYPE,$TYPE_INSTALL) and contains(@OS,$TYPE_OS) and (contains(@TYPE_DB, $TYPE_DB) or not(@TYPE_DB))">
	<xsl:element name="INPUT">
		<xsl:attribute name="NAME"><xsl:value-of select="@NAME"/></xsl:attribute>
		<xsl:attribute name="TYPE">HIDDEN</xsl:attribute>
		<xsl:attribute name="VALUE"><xsl:value-of select="@VALUE"/></xsl:attribute>
	</xsl:element>
</xsl:if>
</xsl:template>

<xsl:template match="LIB">
<xsl:if test="(contains(@OS,$TYPE_OS) or not(@OS)) and (contains(@TYPE_DB, $TYPE_DB) or not(@TYPE_DB))">
	<hr/>
	<center><span class="h-stitre"><b><xsl:value-of select="@TITLE"/></b></span></center><br/>
</xsl:if>
</xsl:template>

</xsl:stylesheet>