<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="ISO-8859-1"/>

<xsl:param name="TYPE_OS"/>
<xsl:param name="TYPE_INSTALL"/>
<xsl:param name="INI_LIST_ACTIVITE"/>

<xsl:template match="/SCRIPT">
	require_once("culture.php");
	$msg_err = null;
	$eval_ok = true;
	<xsl:apply-templates select="SECTION[contains(@TYPE,$TYPE_INSTALL) and contains(@OS,$TYPE_OS) and contains($INI_LIST_ACTIVITE, @TABLE)]"/>
</xsl:template>

<xsl:template match="SECTION">
	<xsl:apply-templates />
</xsl:template>

<xsl:template match="FIC">
	<xsl:if test="@ACTION='C'">
		if (!($file = @fopen("<xsl:value-of select="@DEST"/><xsl:value-of select="@NAME"/>", "w"))) {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_ouverture_fichier_err)."&lt;br&gt;\r\n"; return;}
		$res = dblS("<xsl:apply-templates select="TEXT"/>");
		if (!@fwrite($file, $res))  {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_creation_fichier_err)."&lt;br&gt;\r\n"; return;}
		@fclose($file);
		unset($file); unset($res);
	</xsl:if>
	<xsl:if test="@ACTION='A'">
		if (!($file = @fopen("<xsl:value-of select="@DEST"/><xsl:value-of select="@NAME"/>", "a"))) {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_ouverture_fichier_err)."&lt;br&gt;\r\n"; return;}
		$res = dblS("<xsl:apply-templates select="TEXT"/>");
		if (!@fwrite($file, $res))  {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_modification_fichier_err)."&lt;br&gt;\r\n"; return;}
		@fclose($file);
		unset($file); unset($res);
	</xsl:if>
</xsl:template>

<xsl:template match="CMD|TEXT">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="EXEC">
	<xsl:choose>
		<xsl:when test="@ERR='no'">
			$cmd = "<xsl:apply-templates/>";
			$res_cmd = exec($cmd, $tab, $res);
			if ($res != 0) 
			{
				$msg_err .= str_replace("%CMD%",$cmd,$lang_lbl_warning_commande_err)."&lt;br&gt;\r\n";
			}
		</xsl:when>
		<xsl:otherwise>
			$cmd = "<xsl:apply-templates/>";
			$res_cmd = exec($cmd, $tab, $res);
			if ($res != 0) {$eval_ok = false; $msg_err .= str_replace("%CMD%",$cmd,$lang_lbl_erreur_commande_err)."&lt;br&gt;\r\n"; return;}
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="SQL|MYSQL|MSSQL|ORACLE">
    if (!apply_sql("<xsl:apply-templates />","<xsl:value-of select="name(.)"/>")) return;
</xsl:template>

</xsl:stylesheet>