<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="TYPE_OS"/>
<xsl:param name="TYPE_INSTALL"/>
<xsl:param name="LEVEL_INSTALL"/>

<xsl:template match="/SETUP">
	require_once('Site/flow/generated_version.php');
	$INI_VERSION_FLOW = $versionFM;
	<xsl:apply-templates select="STATION[@ID=$TYPE_INSTALL]"/>
</xsl:template>

<xsl:template match="STATION">
	<xsl:param name="FIRST_LEVEL_INSTALL"><xsl:value-of select="NIV/@ID"/></xsl:param>
	$count_level = <xsl:value-of select="count(NIV)"/>;
	<xsl:if test="$LEVEL_INSTALL!=''">
		$lib_cur_level = "<xsl:value-of select="NIV[@ID=$LEVEL_INSTALL]/@LIB"/>";
		<xsl:apply-templates select="NIV[@ID=$LEVEL_INSTALL]"/>
		<xsl:if test="NIV[@ID>$LEVEL_INSTALL]">
			$lib_next_level = "<xsl:value-of select="NIV[@ID>$LEVEL_INSTALL]/@LIB"/>";
			$next_level = "<xsl:value-of select="NIV[@ID>$LEVEL_INSTALL]/@ID"/>";
		</xsl:if>
	</xsl:if>
	<xsl:if test="$LEVEL_INSTALL=''">
		$level = "<xsl:value-of select="$FIRST_LEVEL_INSTALL"/>";
		$lib_cur_level = "<xsl:value-of select="NIV[@ID=$FIRST_LEVEL_INSTALL]/@LIB"/>";
		<xsl:apply-templates select="NIV[@ID=$FIRST_LEVEL_INSTALL]"/>
		<xsl:if test="NIV[@ID>$FIRST_LEVEL_INSTALL]">
			$lib_next_level = "<xsl:value-of select="NIV[@ID>$FIRST_LEVEL_INSTALL]/@LIB"/>";
			$next_level = "<xsl:value-of select="NIV[@ID>$FIRST_LEVEL_INSTALL]/@ID"/>";
		</xsl:if>
	</xsl:if>
</xsl:template>

<xsl:template match="XML">
	$fic_xml = "<xsl:value-of select="@FIC"/>";
</xsl:template>

<xsl:template match="XSL">
	$fic_xsl = "<xsl:value-of select="@FIC"/>";
</xsl:template>

<xsl:template match="PARAM">
	$param["<xsl:value-of select="@NAME"/>"] = "<xsl:value-of select="@VALUE"/>";
</xsl:template>

</xsl:stylesheet>