<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="ISO-8859-1"/>

<xsl:param name="TYPE_OS"/>
<xsl:param name="TYPE_INSTALL"/>

<xsl:template match="/SCRIPT">
	$eval_ok = true;
	$msg_err = null;
	<xsl:apply-templates select="SECTION[contains(@TYPE,$TYPE_INSTALL) and contains(@OS,$TYPE_OS)]"/>
</xsl:template>

<xsl:template match="FIC">
	<xsl:if test="@ACTION='C'">
		if (!($file = @fopen("<xsl:value-of select="@DEST"/><xsl:value-of select="@NAME"/>", "w"))) {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_ouverture_fichier_err)."&lt;br&gt;\r\n"; return;}
		$res = dblS("<xsl:apply-templates select="TEXT"/>");
		if (!@fwrite($file, $res))  {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_creation_fichier_err)."&lt;br&gt;\r\n"; return;}
		@fclose($file);
		unset($file); unset($res);
	</xsl:if>
	<xsl:if test="@ACTION='A'">
		if (!($file = @fopen("<xsl:value-of select="@DEST"/><xsl:value-of select="@NAME"/>", "a"))) {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_ouverture_fichier_err)."&lt;br&gt;\r\n"; return;}
		$res = dblS("<xsl:apply-templates select="TEXT"/>");
		if (!@fwrite($file, $res))  {$eval_ok = false; $msg_err .= str_replace(array("%DEST%","%NAME%"),array('<xsl:value-of select="@DEST"/>','<xsl:value-of select="@NAME"/>'),$lang_lbl_modification_fichier_err)."&lt;br&gt;\r\n"; return;}
		@fclose($file);
		unset($file); unset($res);
	</xsl:if>
</xsl:template>

<xsl:template match="CMD|TEXT">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="EXEC">
	<xsl:choose>
		<xsl:when test="@ERR='no'">
			$cmd = "<xsl:apply-templates/>";
			$res_cmd = exec($cmd, $tab, $res);
			if ($res != 0) 
			{
				$msg_err .= str_replace("%CMD%",$cmd,$lang_lbl_warning_commande_err)."&lt;br&gt;\r\n";
			}
		</xsl:when>
		<xsl:otherwise>
			$cmd = "<xsl:apply-templates/>";
			$res_cmd = exec($cmd, $tab, $res);
			if ($res != 0) {$eval_ok = false; $msg_err .= str_replace("%CMD%",$cmd,$lang_lbl_erreur_commande_err)."&lt;br&gt;\r\n"; return;}
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="MOTEURACT">
    <xsl:choose>
        <xsl:when test="@ERR='no'">
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=1 AND PRO_NOM NOT LIKE '%as2%' AND PRO_NOM NOT LIKE '%srvpesit%' AND PRO_NOM NOT LIKE '%flowwatch%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
	            while ($row = $gDb->SQLNextRow(1))
	            {
	                $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
	                $res_cmd = exec($cmd_pro, $tab, $res);
	                if ($res != 0) 
	                {
	                    $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_warning_commande_err)."&lt;br&gt;\r\n";
	                }
	            }
                $gDb->SQLFermeQuery(1);
	        }
	        else
	        {
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
	        }
        </xsl:when>
        <xsl:otherwise>
            $cmd = "<xsl:apply-templates/>";
			$req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=1 AND PRO_NOM NOT LIKE '%as2%' AND PRO_NOM NOT LIKE '%srvpesit%'  AND PRO_NOM NOT LIKE '%flowwatch%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $eval_ok = false; 
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_erreur_commande_err)."&lt;br&gt;\r\n";
                        $gDb->SQLFermeQuery(1);
                        return;
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $eval_ok = false; 
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
                return;
            }
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="MOTEURAS2">
    <xsl:choose>
        <xsl:when test="@ERR='no'">
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=3 AND PRO_NOM LIKE '%as2%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_warning_commande_err)."&lt;br&gt;\r\n";
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
            }
        </xsl:when>
        <xsl:otherwise>
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=3 AND PRO_NOM LIKE '%as2%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $eval_ok = false; 
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_erreur_commande_err)."&lt;br&gt;\r\n";
                        $gDb->SQLFermeQuery(1);
                        return;
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $eval_ok = false; 
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
                return;
            }
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="MOTEURPESIT">
    <xsl:choose>
        <xsl:when test="@ERR='no'">
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=4 AND PRO_NOM LIKE '%srvpesit%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_warning_commande_err)."&lt;br&gt;\r\n";
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
            }
        </xsl:when>
        <xsl:otherwise>
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=4 AND PRO_NOM LIKE '%srvpesit%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $eval_ok = false; 
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_erreur_commande_err)."&lt;br&gt;\r\n";
                        $gDb->SQLFermeQuery(1);
                        return;
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $eval_ok = false; 
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
                return;
            }
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="MOTEURWATCH">
    <xsl:choose>
        <xsl:when test="@ERR='no'">
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=5 AND PRO_NOM LIKE '%flowwatch%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_warning_commande_err)."&lt;br&gt;\r\n";
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
            }
        </xsl:when>
        <xsl:otherwise>
            $cmd = "<xsl:apply-templates/>";
            $req = "SELECT PRO_NOM FROM PROCESSUS WHERE PRO_TYPE_MOTEUR=5 AND PRO_NOM LIKE '%flowwatch%'";
            if ($gDb->SQLQuery($req, 1)) 
            {
                while ($row = $gDb->SQLNextRow(1))
                {
                    $cmd_pro = str_replace("[@PRO_NOM]", $row['PRO_NOM'], $cmd);
                    $res_cmd = exec($cmd_pro, $tab, $res);
                    if ($res != 0) 
                    {
                        $eval_ok = false; 
                        $msg_err .= str_replace("%CMD%",$cmd_pro,$lang_lbl_erreur_commande_err)."&lt;br&gt;\r\n";
                        $gDb->SQLFermeQuery(1);
                        return;
                    }
                }
                $gDb->SQLFermeQuery(1);
            }
            else
            {
                $eval_ok = false; 
                $msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n";             
                return;
            }
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="SQL|MYSQL|MSSQL|ORACLE">
    <xsl:choose>
        <xsl:when test="@DIRECT='1'">
		if (!apply_sql("<xsl:apply-templates />","<xsl:value-of select="name(.)"/>","1")) return;
	</xsl:when>
        <xsl:otherwise>
		if (!apply_sql("<xsl:apply-templates />","<xsl:value-of select="name(.)"/>","0" )) return;
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

</xsl:stylesheet>