function isFirefox()
{
	var uaTests =
	{
		op:/opera/i
		,chrome:/chrome/i
		,safari:/safari/i
		,ie:/MSIE/
		,moz:/gecko/i
		,ns:/netscape/i
	};
	var type = '';
	for (var n in uaTests)
	{
		if (uaTests[n].test(navigator.userAgent))
		{
			type = n;
			break;
		}
	}
	if(type=='moz')
		return true;
	return false;
}

function addStyles()
{	// On ajoute les styles ncessaires
	//	Pour le div encapsulant la liste
	document.styleSheets[0].addRule("div.optionsList", "position:absolute; display:block; z-index:1000; padding:0; margin:0; outline:none;", 0);
	//	Pour la liste, avec spcifique pour webkit (Chrome)
	document.styleSheets[0].addRule(".optionsList ul", "border:1px solid #7F9DB9; padding:0; margin-left:0; margin-bottom:0; -webkit-margin-before:0; -webkit-margin-after:0;", 0);
	// 	Pour les lments de la liste
	document.styleSheets[0].addRule(".optionsList li", "cursor:pointer; list-style:none; padding-right:2px; padding-left:2px;", 0);
	// 	Pour l'option slectionne
	document.styleSheets[0].addRule(".optionsList li.hover", "background-color:#3399FF; color:white;", 0);
	//	Pour le passage de la souris sur un lment de la liste
	document.styleSheets[0].addRule(".optionsList li.selected", "background-color:#316AC5; color:white;", 0);
}

// Variable globale pour la liste ouverte en cours
var currentOptionsList = null;
// L'objet principal
optionsList = function(obj)
{
	this.currentSelect = null;
	this.isDisplayed = false;
	this.parent = obj;

	this.list = document.createElement('div');
	this.list.className = 'optionsList';
	// Pour chrome il doit y avoir un tabIndex, sinon le focus n'est jamais pris
	this.list.tabIndex = obj.tabIndex ? obj.tabIndex : 1;

	// On recopie la fonte utilise et les couleurs
	var ffamily = fsize = fstyle = fvariant = fweight = fheight = '';
	var bckColor = 'white';
	var txtColor = 'black';
	if (document.defaultView && document.defaultView.getComputedStyle) // Opera et Chrome
	{
		var computedStyle = document.defaultView.getComputedStyle(obj, null );
		if(computedStyle)
		{
			ffamily = computedStyle.fontFamily;
			fsize = computedStyle.fontSize;
			fstyle = computedStyle.fontStyle;
			fvariant = computedStyle.fontVariant;
			fweight = computedStyle.fontWeight;
			fheight = computedStyle.lineHeight;
			bckColor = computedStyle.backgroundColor;
			txtColor = computedStyle.color;
		}
	}
	else if (obj.currentStyle) //IE
	{
		ffamily = obj.currentStyle['fontFamily'];
		fsize = obj.currentStyle['fontSize'];
		fstyle = obj.currentStyle['fontStyle'];
		fvariant = obj.currentStyle['fontVariant'];
		fweight = obj.currentStyle['fontWeight'];
		fheight = obj.currentStyle['lineHeight'];
		bckColor = obj.currentStyle['backgroundColor'];
		txtColor = obj.currentStyle['color'];
	}
	this.list.style.cssText = "font: " + fstyle + " " + fvariant + " " + fweight + " " + fsize + "/" + fheight + " " + ffamily + ";";
	
	// On positionne la nouvelle liste  la place de l'ancienne
	this.list.style.left = obj.offsetLeft + 'px';
	this.list.style.top = obj.offsetTop + obj.offsetHeight + 'px';
	
	// On peuple la liste
	var ul = document.createElement('ul');
	ul.style.backgroundColor = bckColor;
	ul.style.color = txtColor;
	for (var i=0; i<obj.options.length; i++)
	{
		var li = document.createElement('li');
		li.className = obj.options[i].className;
		if(i==obj.selectedIndex)
		{
			li.className += ' selected';
			this.currentSelect = li;
		}
		var txt = document.createTextNode(obj.options[i].text);
		li.appendChild(txt);
		li.selIndex = i;
		li.selectID = obj.id;
		li.onmouseover = function()
		{
			this.className += ' hover';
		};
		li.onmouseout = function()
		{
			this.className = this.className.replace(new RegExp(" hover\\b"), '');
		};
		li.onclick = function()
		{	// Dslection de l'ancien
			currentOptionsList.resetSelect();						
			// Slection du nouveau
			var obj = document.getElementById(this.selectID);
			obj.selectedIndex = this.selIndex;
			currentOptionsList.currentSelect = this;
			this.className = this.className.replace(new RegExp(" hover\\b"), ' selected');
			currentOptionsList.hideList();
			// On simule le onchange sur l'objet de base
			obj.onchange();
		};
		ul.appendChild(li);
	}
	this.list.appendChild(ul);
}

optionsList.prototype.resetSelect = function()
{
	if(this.currentSelect)
	{
		this.currentSelect.className = this.currentSelect.className.replace(new RegExp(" selected\\b"), '');
		this.currentSelect = null;
	}
}

optionsList.prototype.onBlur = function()
{
	currentOptionsList.hideList();
}

optionsList.prototype.displayList = function()
{	// Si la liste est dj affiche on la supprime du DOM
	if(this.isDisplayed)
		this.hideList();
	else
	{	// Si il y a une autre liste ouverte on la ferme avant d'ouvrir la nouvelle
		if(currentOptionsList)
			currentOptionsList.hideList();
		
		// Ajout dans le DOM de la liste
		var div = this.parent.parentNode.insertBefore(this.list, this.parent.nextSibling);
		currentOptionsList = this;
		this.isDisplayed = true;
		div.style.height = div.firstChild.offsetHeight;
		div.onblur = this.onBlur;
		div.focus();
	}
}

optionsList.prototype.hideList = function()
{
	if(this.isDisplayed)
	{
		this.list.onblur = null;
		this.parent.parentNode.removeChild(this.list);
		this.isDisplayed = false;
		currentOptionsList = null;
	}
}

// Fonction pour stopper la propagation d'un vnement
function stopEvent(evt)
{
	var e = evt ? evt : window.event;

	e.srcElement.disabled = true;
	setTimeout('document.getElementById("'+e.srcElement.id+'").disabled = false;', 10);
	
	//e.stopPropagation ne marche que sous gecko (Firefox).
	if (e.stopPropagation)
	{
		e.preventDefault();
		e.stopPropagation();
	}

	//e.cancelBubble pour IE - kill du bubbling process.
	e.cancelBubble = true;
	e.returnValue = false;

	return false;
}

function localOnMousedown(evt)
{
	var e = evt ? evt : window.event;
	e.srcElement.optionsList.displayList();
	// Stop de la propagation pour ne pas ouvrir la liste d'origine
	return stopEvent(e);
}

function selectReplacement(obj)
{	// On remplace par notre gestionnaire d'vennement et on masque ceux qui pourraient parasiter
	if(obj.addEventListener)
	{	// Pour gecko et webkit
		obj.addEventListener("mousedown", localOnMousedown, true);
		obj.addEventListener("mouseup", stopEvent, true);
		obj.addEventListener("click", stopEvent, true);
		obj.addEventListener("dblclick", stopEvent, true);
	}
	else if (document.attachEvent)
	{	// Pour IE
		obj.attachEvent("onmousedown", localOnMousedown);
		obj.attachEvent("onmouseup", stopEvent);
		obj.attachEvent("onclick", stopEvent);
		obj.attachEvent("ondblclick", stopEvent);
	}
	else
	{	// Pour les autres
		obj.onmousedown = localOnMousedown;
		obj.onmouseup = stopEvent;
		obj.onclick = stopEvent;
		obj.ondblclick = stopEvent;
	}
	
	obj.optionsList = new optionsList(obj);
}

// Fonction principale  appeler dans la page aprs chargement du fichier JS
//	en paramtre : 
//		soit un id unique d'une liste  prendre en charge
//		soit un tableau contenant les id de plusieurs listes
function initSelectImage(objs)
{
	window.onload = function()
	{
		// Sous Firefox c'est pris en charge par la gestion des CSS, donc on ne fait rien
		if(!isFirefox())
		{
			// On ajoute les styles ncessaires
			addStyles();
			if(typeof(objs)=='Array')
			{
				for(var i=0; i<objs.length; i++)
				{
					var s = document.getElementById(objs[i]);
					selectReplacement(s);
				}
			}
			else
			{
				var s = document.getElementById(objs);
				selectReplacement(s);
			}
		}
	};
}