<?php
require_once("culture.php");

// Modif LTK le 12/02/08 : PHP5
// Include wrappers domxml et xslt si PHP5
if (version_compare(PHP_VERSION,'5','>='))
{
	// Ne charger les wrappers domxml que si l'extension domxml n'est pas presente
	if (!extension_loaded("domxml"))
	{
		require("domxml-php4-to-php5.php");
	}
	require("xslt-php4-to-php5.php");
}
/*
* V2.0 --> V2.1 :
* 	- Ajout de la gestion du TYPE de STATION pour les mises a jour depuis la 3.5
* V2.1 --> V2.2 :
*   - Modif LM le 02/10/13 Supression des tests lies à php 4,x.x
*   - Modif BG le 02/10/13 Fonction pour contrôle des prerequis ORACLE et MSSQL
*/
@define ('SETUP_VER',"2.2");
//--------------------------PHP--------------------------
@define ('PHP_VERSION_MIN',               "5.3.0");
@define ('PHP_VERSION_MIN_RECOMMANDED',   "5.4.0");
@define ('PHP_VERSION_WARNING',           "5.3.14");
//--------------------------APACHE-----------------------
@define ('APACHE_VERSION_MIN',            "2.0.0");
@define ('APACHE_VERSION_MIN_RECOMMANDED',"2.2.0");
@define ('APACHE_VERSION_WARNING',        "3.0.0");
//--------------------------MYSQL------------------------
@define ('MYSQL_VERSION_MIN',             "5.0.10");
@define ('MYSQL_VERSION_MIN_RECOMMANDED', "5.1.0");
@define ('MYSQL_VERSION_WARNING',         "");
//--------------------------ORACLE-----------------------
@define ('ORACLE_VERSION_MIN',			  "10.0");
@define ('ORACLE_VERSION_MIN_RECOMMANDED',"11.2");
@define ('ORACLE_VERSION_WARNING',	      ""); 
//--------------------------MSSQL-----------------------
@define ('MSSQL_VERSION_MIN',			  "10.0");
@define ('MSSQL_VERSION_MIN_RECOMMANDED', "10.0");
@define ('MSSQL_VERSION_WARNING',	      ""); 

@define ('OS_WIN',      1);
@define ('OS_LINUX',    2);
@define ('OS_SOLARIS',  3);
@define ('OS_AIX',      4);

$var_reserve = array(
	"TYPE_OS" 			=> version_mot($msg),
	"SEP_CAR"			=> sep_car(),
	"RACINE"			=> (version_mot($msg) == OS_WIN)?("c:"):(""),
	"SEP_CAR_JS"		=> (version_mot($msg) == OS_WIN)?(sep_car().sep_car()):(sep_car()),
	"SEP_CAR_DBL"		=> (version_mot($msg) == OS_WIN)?(sep_car().sep_car()):(sep_car()),
	"VERSION_OS"		=> version_os(),	//1 = windows, 2 = le reste
);

$var_macro = array(
	"MACRO_LIST_ACTIVITES"	=> "",	//Macro SQL à n'utiliser qu'en mise à jour
	"MACRO_NOM_CLIENT"		=> "",	//Macro SQL à n'utiliser qu'en mise à jour
	"MACRO_MAIL_ADMIN"		=> "",	//Macro SQL à n'utiliser qu'en mise à jour
	"MACRO_PATH_LOG_SQL"	=> ""	//Macro SQL à n'utiliser qu'en mise à jour
);

function pget($nom)
{
	if ((version_compare(PHP_VERSION,'5.3','<')) and (get_magic_quotes_gpc()))
	{
		if (isset($_POST[$nom])) $ret = StripSlashes($_POST[$nom]);
		else $ret = StripSlashes($_GET[$nom]);
		if ($ret == "" || $ret == null || !isset($ret)) return null;
		else return $ret;
	}
	else
	{
		if (isset($_POST[$nom])) $ret = $_POST[$nom];
		else if (isset($_GET[$nom])) $ret = $_GET[$nom];
		if (!isset($ret) || $ret == null || $ret == "") return null;
		else return $ret;
	}
}

//Double la quote
function dblQ($chaine)
{
   $ret = str_replace("\\","\\\\", str_replace("'","''",$chaine));
	
   return $ret;
}

//Double le slash
function dblS($chaine)
{

   $ret = str_replace("\\","\\\\", $chaine);
   return $ret;
}

function version_os()
{
	if (preg_match("/Win/", $_SERVER["SERVER_SOFTWARE"])) return 1;
	else return 2;
}

function version_mot(&$msg)
{
	if (version_os() == OS_WIN) return OS_WIN;
	else
	{
		@exec("uname", $buf, $res);
		if ($res == 1)
		{
			$msg = $lang_lbl_systeme_inconnu_msg;
			return OS_LINUX;
		}
		$msg = $lang_lbl_systeme_detecte_msg.$buf[0];
		switch ($buf[0])
		{
			case "SunOS" : 	return OS_SOLARIS;
			case "AIX" : 	return OS_AIX;
			default :		return OS_LINUX;
		}
	}
}

function sep_car()
{
	if (version_os() == OS_WIN) return "\\";
	else return "/";
}

function page_html($type, $msg, $lien = "index.php")
{
	global $lang_lbl_retour_msg;
	return "<html><head>
			<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">
			<link href=\"setup.css\" rel=\"stylesheet\" type=\"text/css\"/>
			</head>
			<body class=\"i-fond\">
			<center>
				<span class=\"$type\"><b>$msg</b></span>
				<br/><br/>
				<input class=\"h-bout\" value=\"$lang_lbl_retour_msg\" type=\"button\" onClick=\"javascript:window.location.href='$lien'\">
				<input class=\"h-bout\" value=\"Logs\" type=\"button\" onClick=\"javascript:window.open('logs.php', '_blank');\">
			</center>
			</body>
			</html>";
}

function msg_err($type, $msg)
{
	return "<center><span class=\"$type\"><b>$msg</b></span></center>";
}

function current_version(&$version, &$msg)
{
	global $gDb, $lang_lbl_acces_flowconf_err, $lang_lbl_version_flowconf_err;
	$req = "select FCO_VERSION from FLOWCONF";
	if (!$gDb->SQLQuery($req, 1))
	{
		$msg = $lang_lbl_acces_flowconf_err;
		return false;
	}
	$row = $gDb->SQLNextRow(1);
	if (!$row["FCO_VERSION"])
	{
		$msg = $lang_lbl_version_flowconf_err;
		return false;
	}
	$version = $row["FCO_VERSION"];
	$gDb->SQLFermeQuery(1);
	return true;
}

function current_station($defaut, &$msg)
{
	global $gDb, $lang_lbl_acces_flowconf_err;

	$station = $defaut;

	$req = "select FCO_STATION_TYPE from FLOWCONF";
	if (!$gDb->SQLQuery($req, 1))
	{
		$msg = $lang_lbl_acces_flowconf_err;
		return false;
	}
	$row = $gDb->SQLNextRow(1);
	if ($row["FCO_STATION_TYPE"]) $station = $row["FCO_STATION_TYPE"];
	$gDb->SQLFermeQuery(1);
	return $station;
}

// pour gestion du short_open_tag (UiF < 4.0.0) si celui-ci est désactivé dans PHP.ini
function include_var($file, $varname, $default)
{
	if ((bool) @ini_get('short_open_tag') === FALSE)
	{
		$content = file_get_contents($file);
		if(preg_match("/<\?[^php]/", $content)==1)
		{
			$inc = preg_replace("/\?>/", "", preg_replace("/<\?[^php]/", "", $content));
			eval($inc);
		}
		else
			include($file);
	}
	else
		include($file);
	
	if(isset(${$varname}))
		return ${$varname};
	else
		return $default;
}

function mail_admin(&$mailAdmin, $pathSite)
{
	$mailAdmin = include_var($pathSite.'flow.ini.php', 'ini_mail_administrateur', 'admin@xxxxx.fr');
}

function path_log_sql(&$pathLog, $pathSite)
{
	$pathLog = include_var($pathSite.'flow.ini.php', 'ini_path_log_sql', $pathSite.'temp'.DIRECTORY_SEPARATOR);
}

// MYSQL //
function pre_requis_mysql(&$msg)
{
	global 	$gDb,
			$lang_lbl_innodb_err,
			$lang_lbl_mysql_version_err,
			$lang_lbl_strict_mode_err,
			$lang_lbl_dates_mode_err,
			$lang_lbl_mysql_version,
			$lang_lbl_recommanded_version,
            $lang_lbl_warning_version,
            $mySQLVersion;
            
	$ret = true;

//verification de la version
	$req = "SHOW variables like 'version'";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$mysql_version_min = MYSQL_VERSION_MIN;
	$mysql_version = $row['Value'];
	if (issup_version($mysql_version_min, $mysql_version))
	{
		$msg = "<br>".str_replace(array("%MYSQLVERSION%","%MYSQLVERSIONMIN%"),array($mysql_version,$mysql_version_min),$lang_lbl_mysql_version_err);
		$ret = false;
	}
    $mySQLVersion = $row['Value'];
	$gDb->SQLFermeQuery(1);

//Verification de InnoDB
	$req = "SHOW variables like 'have_innodb'";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	if ($row['Value'] != "YES")
	{
		$msg = "<br>".$lang_lbl_innodb_err;
		$ret = false;
	}
    $gDb->SQLFermeQuery(1);
	
// Ajout LTK le 24/02/09
// Si MySQL 5, verification du mode
    if (issup_version($mySQLVersion, $mysql_version_min))
    {
    	// Recuperer le mode
	    $req = "SELECT @@GLOBAL.sql_mode";
	    $gDb->SQLQuery($req, 1);
	    $row = $gDb->SQLNextRow(1);
	    // Verifier qu'on est pas en mode strict
	    if (preg_match('/STRICT_/', $row['@@GLOBAL.sql_mode']))
	    {
	        $msg = "<br>".$lang_lbl_strict_mode_err;
	        $ret = false;
	    }
	    else if (!preg_match('/ALLOW_INVALID_DATES/',$row['@@GLOBAL.sql_mode']))
        {
            $msg = "<br>".$lang_lbl_dates_mode_err;
            $ret = false;
        }
	    $gDb->SQLFermeQuery(1);
    }

    if ($ret)
    {
        // Ajout LTK le 08/12/09
        // Affichage des versions utilisees
        // Ajout d'un warning si les versions ne sont 
        // pas celles recommandees
        $msgVersion = "<b>".$lang_lbl_mysql_version.$mysql_version."</b>";
        if (issup_version(MYSQL_VERSION_MIN_RECOMMANDED, $mysql_version))
        {
           $msgVersion .= " (".$lang_lbl_recommanded_version.MYSQL_VERSION_MIN_RECOMMANDED.")";
        }
        if (MYSQL_VERSION_WARNING==$mysql_version)
        {
       	   $msgVersion .= " (".$lang_lbl_warning_version.MYSQL_VERSION_WARNING.")";
        }
        $msg = "<br>".$msgVersion;
    }
	return $ret;
}

// ORACLE //
function pre_requis_oracle(&$msg)
{
	global 	$gDb,
			$lang_lbl_oracle_version_err,
			$lang_lbl_oracle_version,
			$lang_lbl_recommanded_version,
			$lang_lbl_warning_version;

	$ret = true;
	
	//verification de la version
	$req = 'SELECT VERSION FROM v$instance';
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$oracle_version_min = ORACLE_VERSION_MIN;
	
	// la version exacte (ex '11.2.0.2.0')
	$oracle_version = $row['VERSION'];
	// la version majeure : les 4 premiers caractères (ex '11.2')
	$oracle_version = substr($oracle_version,0,4);
	
	if (issup_version($oracle_version_min, $oracle_version))
	{
		$msg = "<br>".str_replace(array("%ORACLEVERSION%","%ORACLEVERSIONMIN%"),array($oracle_version,$oracle_version_min),$lang_lbl_oracle_version_err);
		$ret = false;
	}

	$gDb->SQLFermeQuery(1);

    if ($ret)
    {	
		// Affichage des versions utilisees
		// Ajout d'un warning si les versions ne sont 
		// pas celles recommandees
		$msgVersion = "<b>".$lang_lbl_oracle_version.$oracle_version."</b>";
		if (issup_version(ORACLE_VERSION_MIN_RECOMMANDED , $oracle_version))
		{
		   $msgVersion .= " (".$lang_lbl_recommanded_version.ORACLE_VERSION_MIN_RECOMMANDED.")";
		}
		if (ORACLE_VERSION_WARNING==$oracle_version)
		{
		   $msgVersion .= " (".$lang_lbl_warning_version.ORACLE_VERSION_WARNING.")";
		}
		$msg = "<br>".$msgVersion;
	}
	return $ret;
	
}
// MSSQL //
function pre_requis_mssql(&$msg)
{
	global 	$gDb,
			$lang_lbl_mssql_version_err,
			$lang_lbl_mssql_version,
			$lang_lbl_recommanded_version,
			$lang_lbl_warning_version;

	$ret = true;
	
	//verification de la version
	$req = "SELECT CAST(SERVERPROPERTY('productversion') AS VARCHAR) + ' - ' + CAST(SERVERPROPERTY('productlevel') AS VARCHAR) + ' (' + CAST(SERVERPROPERTY('edition') AS VARCHAR) + ')' AS VERSION";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$mssql_version_min = MSSQL_VERSION_MIN;
	
	// la version exacte (ex '10.0.1600.22')
	$mssql_version = $row['VERSION'];
	// la version majeure : les 4 premiers caractères (ex '10.0')
	$mssql_version = substr($mssql_version,0,4);
	
	if (issup_version($mssql_version_min, $mssql_version))
	{
		$msg = "<br>".str_replace(array("%MSSQLVERSION%","%MSSQLVERSIONMIN%"),array($mssql_version,$mssql_version_min),$lang_lbl_mssql_version_err);
		$ret = false;
	}

	$gDb->SQLFermeQuery(1);
	
    if ($ret)
    {	
		// Affichage des versions utilisees
		// Ajout d'un warning si les versions ne sont 
		// pas celles recommandees
		$msgVersion = "<b>".$lang_lbl_mssql_version.$oracle_version."</b>";
		if (issup_version(MSSQL_VERSION_MIN_RECOMMANDED , $mssql_version))
		{
		   $msgVersion .= " (".$lang_lbl_recommanded_version.MSSQL_VERSION_MIN_RECOMMANDED.")";
		}
		if (MSSQL_VERSION_WARNING==$mssql_version)
		{
		   $msgVersion .= " (".$lang_lbl_warning_version.MSSQL_VERSION_WARNING.")";
		}
		$msg = "<br>".$msgVersion;
	}
	
	return $ret;
	
}


/************************************************************************/
/* apply_xsl()                                                    		*/
/* Applique une feuille de style XSL � un fichier XML                   */
/************************************************************************/
/*  entr�e :															*/
/*		$xsl_file : le nom du fichier XSL (pr�sent dans le rep courant)	*/
/*		$xml_file : le nom du fichier XML (pr�sent dans le rep courant)	*/
/*		$xslt_params : parametre � passer au XSL (array(...))			*/
/************************************************************************/
/*  retour : 							                            	*/
/*		$result : r�sultat du parsing ou message d'erreur				*/
/************************************************************************/
/*  sortie : 								                            */
/*		true : ok														*/
/*		false : erreur													*/
/************************************************************************/
function apply_xsl($xsl_file, $xml_file, $xslt_params, &$result)
{
	global $lang_lbl_fichier_xml_introuvable_err,
		   $lang_lbl_fichier_xsl_introuvable_err,
		   $lang_lbl_fichier_illisible_err,
		   $lang_lbl_init_xsl_err,
		   $lang_lbl_xsl_to_xml_err;
	if (!($xml_handle = @fopen($xml_file, "r"))) {$result = $lang_lbl_fichier_xml_introuvable_err.$xml_file; return false;}
	if (!($xsl_handle = @fopen($xsl_file, "r"))) {$result = $lang_lbl_fichier_xsl_introuvable_err.$xsl_file; return false;}
	if (!($xml_content 	= @fread($xml_handle, @filesize($xml_file))))  {$result = $lang_lbl_fichier_illisible_err.$xml_file; return false;}
	if (!($xsl_content 	= @fread($xsl_handle, @filesize($xsl_file))))  {$result = $lang_lbl_fichier_illisible_err.$xsl_file; return false;}
	@fclose($xml_handle);
	@fclose($xsl_handle);
	$xslt_args = array('/_xml' => $xml_content, '/_xsl' => $xsl_content);
	if (!($xh = @xslt_create()))  {$result = $lang_lbl_init_xsl_err; return false;}
	if (!($result = @xslt_process($xh, 'arg:/_xml', 'arg:/_xsl', NULL, $xslt_args, $xslt_params)))
		 {$result = str_replace(array("%XSLFILE%","%XMLFILE%"),array($xsl_file,$xml_file),$lang_lbl_xsl_to_xml_err); return false;}
	@xslt_free($xh);
	return true;
}

function issup_version($ver1, $ver2)
{
	$tab_ver1 = explode(".", trim($ver1));
	$tab_ver2 = explode(".", trim($ver2));

	if ($tab_ver1[0] > $tab_ver2[0])
		return true;
	else
	{
		if ($tab_ver1[0] == $tab_ver2[0] && $tab_ver1[1] > $tab_ver2[1])
		return true;
		else
		{
			if ($tab_ver1[0] == $tab_ver2[0] && $tab_ver1[1] == $tab_ver2[1] && $tab_ver1[2] > $tab_ver2[2])
				return true;
		}
	}

	return false;
}

function prerequis(&$msg,$type_db)
{
	global 	$lang_lbl_apache_version_err,
			$lang_lbl_php_version_err,
			$lang_lbl_sessions_err,
			$lang_lbl_xml_err,
			$lang_lbl_xslt_err,
			$lang_lbl_gd2_err,
			$lang_lbl_mysql_err,
			$lang_lbl_curl_err,
			$lang_lbl_domxml_err,
			$lang_lbl_dom_err,
			$lang_lbl_xsl_err,
            $lang_lbl_ldap_err,
            $lang_lbl_soap_err,
			$lang_lbl_pdo_err,
			$lang_lbl_pdo_odbc_err,
			$lang_lbl_domxml_a_supprimer_err,
			$lang_lbl_register_globals_err,
			$lang_lbl_innodb_err,
			$lang_lbl_mysql_version_err,
			$lang_lbl_session_path_err,
			$lang_lbl_session_path_ecriture_err,
			$lang_lbl_prerequis_err,
			$lang_lbl_prerequis_ok_msg,
			$lang_lbl_php_version,
			$lang_lbl_apache_version,
			$lang_lbl_recommanded_version,
            $lang_lbl_warning_version,
			$mySQLVersion;

//V�rification des pr�requis
	$msg_err = null;

//Version d'Apache
	$apache_version_min = APACHE_VERSION_MIN;
	// LT le 12/02/08 : Modif Apache 2.2.8
	// La variable SERVER_SIGNATURE n'est pas renseignee
	// Verifier egalement avec SERVER_SOFTWARE
	if ($_SERVER['SERVER_SIGNATURE'] != "")
	{
		$tmp = explode("/", $_SERVER['SERVER_SIGNATURE']);
		$apache_version = explode("S", $tmp[1]);
		if (issup_version($apache_version_min, $apache_version[0]))
			$msg_err .= str_replace(array("%APACHEVERSION%","%APACHEVERSIONMIN%"),array($apache_version[0],$apache_version_min),$lang_lbl_apache_version_err);
	}
	else
	{
		$tmp = explode("/", $_SERVER['SERVER_SOFTWARE']);
		$apache_version = explode(" ", $tmp[1]);
		if (issup_version($apache_version_min, $apache_version[0]))
			$msg_err .= str_replace(array("%APACHEVERSION%","%APACHEVERSIONMIN%"),array($apache_version[0],$apache_version_min),$lang_lbl_apache_version_err);
	}
//Version PHP
	$php_version_min 	= PHP_VERSION_MIN;
	$php_version 		= phpversion();
	if (issup_version($php_version_min, $php_version))
		$msg_err .= "<br>".str_replace(array("%PHPVERSION%","%PHPVERSIONMIN%"),array($php_version,$php_version_min),$lang_lbl_php_version_err);
	
	if($type_db == "1") //mysql
	{
        $funct = array(
            "session" 	=> array("nom" => "session","string" => "session_save_path","status" => false, "msg_err" => $lang_lbl_sessions_err),
            "xml" 		=> array("nom" => "xml", 	"string" => "xml_parser_create","status" => false, "msg_err" => $lang_lbl_xml_err),
            "mysql" 	=> array("nom" => "mysql",	"string" => "mysql_connect", 	"status" => false, "msg_err" => $lang_lbl_mysql_err),
            "curl" 		=> array("nom" => "curl",	"string" => "curl_init", 		"status" => false, "msg_err" => $lang_lbl_curl_err),
            "dom" 		=> array("nom" => "dom",	"string" => "dom_import_simplexml", "status" => false, "msg_err" => $lang_lbl_dom_err),
            "gd2" 	    => array("nom" => "gd2",	"string" => "gd_info",  		"status" => false, "msg_err" => $lang_lbl_gd2_err)
        );
        // On ne peut pas tester la presence de XSL avec cette methode car
        // cette extension ne contient que des classes (pas de fonctions)
        // On verifier juste la presence du module
        if (!extension_loaded("xsl"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_xsl_err;
        }
        if (!extension_loaded("ldap"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_ldap_err;
        }
        if (!extension_loaded("soap"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_soap_err;
        }
        // Tester la non presence du module domxml (incompatible avec dom)
        if (extension_loaded("domxml"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_domxml_a_supprimer_err;
        }
	}
	else
	{
        $funct = array(
            "session" 	=> array("nom" => "session","string" => "session_save_path","status" => false, "msg_err" => $lang_lbl_sessions_err),
            "xml" 		=> array("nom" => "xml", 	"string" => "xml_parser_create","status" => false, "msg_err" => $lang_lbl_xml_err),
            //"mysql" 	=> array("nom" => "mysql",	"string" => "mysql_connect", 	"status" => false, "msg_err" => $lang_lbl_mysql_err),
            "curl" 		=> array("nom" => "curl",	"string" => "curl_init", 		"status" => false, "msg_err" => $lang_lbl_curl_err),
            "dom" 		=> array("nom" => "dom",	"string" => "dom_import_simplexml", "status" => false, "msg_err" => $lang_lbl_dom_err),
            "gd2" 	    => array("nom" => "gd2",	"string" => "gd_info",  		"status" => false, "msg_err" => $lang_lbl_gd2_err)
        
        );
        // On ne peut pas tester la presence de XSL avec cette methode car
        // cette extension ne contient que des classes (pas de fonctions)
        // On verifier juste la presence du module
        if (!extension_loaded("xsl"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_xsl_err;
        }
        if (!extension_loaded("ldap"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_ldap_err;
        }
        if (!extension_loaded("soap"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_soap_err;
        }
        // Tester la non presence du module domxml (incompatible avec dom)
        if (extension_loaded("domxml"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_domxml_a_supprimer_err;
        }
        
        // On ne peut pas tester la presence de PDO avec cette methode car
        // cette extension ne contient que des classes (pas de fonctions)
        // On verifier juste la presence du module
        if (!extension_loaded("pdo"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_pdo_err;
        }		
        
        if (!extension_loaded("pdo_odbc"))
        {
            $msg_err .= "<br/><li/>".$lang_lbl_pdo_odbc_err;
        }		
	}
	$arr = get_defined_functions();
	#var_dump($arr);
	foreach($arr["internal"] as $func_int)
		{foreach($funct as $ff) {if ($ff["string"] == $func_int) $funct[$ff["nom"]]["status"] = true;}}
	foreach($funct as $ff)
		{if ($ff["status"] == false) $msg_err .= "<br/><li/>".$ff["msg_err"];}

//Register global = OFF
	if (ini_get("register_globals"))
		$msg_err .= "<br><li/>".$lang_lbl_register_globals_err;

//Le repertoire des cookies de session est present et accessible en ecriture
	$path_session = ini_get("session.save_path");
	if (!is_dir($path_session))
		$msg_err .= "<br><li/>".str_replace("%SESSIONPATH%",$path_session,$lang_lbl_session_path_err);
	else
		if (!is_writeable($path_session))
			$msg_err .= "<br><li/>".str_replace("%SESSIONPATH%",$path_session,$lang_lbl_session_path_ecriture_err);

	if ($msg_err)
	{
		$msg .= "<br><br><b>".$lang_lbl_prerequis_err."</b><br>".$msg_err;
		return false;
	}
	else 
	{
		// Ajout LTK le 08/12/09
		// Affichage des versions utilisees
		// Ajout d'un warning si les versions ne sont 
		// pas celles recommandees
		$msgVersion = "<b>".$lang_lbl_php_version.$php_version."</b>";
		if (issup_version(PHP_VERSION_MIN_RECOMMANDED, $php_version))
        {
       	   $msgVersion .= " (".$lang_lbl_recommanded_version.PHP_VERSION_MIN_RECOMMANDED.")";
        }
        if (PHP_VERSION_WARNING==$php_version)
        {
       	   $msgVersion .= " (".$lang_lbl_warning_version.PHP_VERSION_WARNING.")";
        }
        $msg .= "<br>".$msgVersion;
        $msgVersion = "<b>".$lang_lbl_apache_version.$apache_version[0]."</b>";
        if (issup_version(APACHE_VERSION_MIN_RECOMMANDED, $apache_version[0]))
        {
           $msgVersion .= " (".$lang_lbl_recommanded_version.APACHE_VERSION_MIN_RECOMMANDED.")";
        }
        if (APACHE_VERSION_WARNING==$apache_version[0])
        {
       	   $msgVersion .= " (".$lang_lbl_warning_version.APACHE_VERSION_WARNING.")";
        }
        $msg .= "<br>".$msgVersion;
        return true;
	}
}

function version_to_int($version)
{
	$i_ver = str_replace(".", "0", $version);
	if (strlen($i_ver) == 2) $i_ver .= "0000";
	else if (strlen($i_ver) == 3) $i_ver .= "000";
	else if (strlen($i_ver) == 4) $i_ver .= "00";
	else if (strlen($i_ver) == 5) $i_ver .= "0";

	return $i_ver;
}

function liste_activite(&$activites, $nom_bdd)
{
	global $gDb, $lang_lbl_liste_tables_err, $var_ini;
	$req = "SHOW TABLES from $nom_bdd";
 	if (!$gDb->SQLQuery($req, 1))
	{
		$activites = str_replace("%REQ%",$req,$lang_lbl_liste_tables_err);
		return false;
	}
	
	if ($var_ini['TYPE_DB_NAME'] == 'mysql')
	{
	 	while($row = $gDb->SQLNextRow(1))
		{
			if (preg_match("/^E_/", strtoupper($row["Tables_in_".$nom_bdd]))) $activites .= strtoupper($row["Tables_in_".$nom_bdd])."|";
		}
	}
	else
	{
		if ($var_ini['TYPE_DB_NAME'] == 'mssql')
			$table_name="name";
		else
			$table_name="TABLE_NAME";
		
		while($row = $gDb->SQLNextRow(1))
		{
			if (preg_match("/^E_/", strtoupper($row[$table_name]))) $activites .= strtoupper($row[$table_name])."|";
		}
	}	
	
	$gDb->SQLFermeQuery(1);
	if (!$activites) $activites = "vide";
	return true;
}

function nom_client(&$client)
{
	global $gDb, $lang_lbl_nom_client_err;
	$req = "select CLT_NOM from CLIENT";
 	if (!$gDb->SQLQuery($req, 1))
	{
		$client = str_replace("%REQ%",$req,$lang_lbl_nom_client_err);
		return false;
	}
 	$row = $gDb->SQLNextRow(1);
	$client = $row["CLT_NOM"];
	$gDb->SQLFermeQuery(1);
	return true;
}

function sauve_level($level)
{
	$file = @fopen("log_level.php","w");
	if (!$file) return false;
	@fwrite($file, "<?php\n \$LOG_ID_LEVEL = \"$level\";\n?>");
	@fclose($file);
	return true;
}
function erase_level()
{
	$file = @fopen("log_level.php","w");
	if (!$file) return false;
	@fwrite($file, "<?php\n?>");
	@fclose($file);
	return true;
}

function erase_ini()
{
	$file = @fopen("ini.php","w");
	if (!$file) return false;
	@fwrite($file, "<?php\n?>");
	@fclose($file);
	return true;
}

function log_erreur($msg, $level)
{
	$fp = @fopen("erreur.log", "a");
	if (!$fp)
	{
		echo "<script language=\"JavaScript\">
				alert(\"".$lang_lbl_ecriture_log_err."\");
				</script>";
		return false;
	}

	$msg_ini = 	"ERR**********************************************************\r\n".
				"Date    : ".date("Y/m/d H:i")."\r\n".
				"Level	: $level\r\n".
				$msg."\r\n";
	@fwrite($fp, $msg_ini);
	@fclose($fp);
}

function addr($type=1){
 if (getenv('HTTP_X_FORWARDED_FOR')) {
  $ip = getenv('HTTP_X_FORWARD_FOR');
  if ($type == 0)
  return $ip;
  else
  return gethostbyaddr($ip);
 } else {
  $ip = getenv('REMOTE_ADDR');
  if ($type == 0)
  return $ip;
  else
  return gethostbyaddr($ip);
 }

}

// - Ajout LTK le 27/05/11 : Bugzilla #3996
// Appliquer une requete issue d'un template  
// - Ajout BG le 10/08/2012 : Bugzilla #4615   Modifié par FG le 21/09/2012
// Execution directe de la requête sans analyse si balise <SQL DIRECT="1">
function apply_sql($template_req,$typeDB,$direct="0")
{
	global $var_ini, $gDb, $eval_ok, $msg_err, $lang_lbl_requete_sql_err;
	$return = true;
	// TypeDB = SQL --> a faire pour chaque type de base
	// sinon tester si on est sur le meme type de base
	if (($typeDB == 'SQL') || (strtolower($typeDB) == $var_ini['TYPE_DB_NAME']))
	{
		// Doubler les antislash pour MySQL
		if ($var_ini['TYPE_DB_NAME'] == 'mysql')
		{
			$req = str_replace("\\", "\\\\", $template_req);
		}
		else
		{
			$req = $template_req;
		}
		// Executer la requete 
		if ($direct == "1")
		{
			if (!$gDb->SQLQueryDirect($req, 1)) 
			{
				// Retour en erreur
				$eval_ok = false;
				$return = false;
				$msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n"; 
			}
		}
        else
		{
			if (!$gDb->SQLQuery($req, 1)) 
			{
				// Retour en erreur
				$eval_ok = false;
				$return = false;
				$msg_err .= str_replace("%REQ%",$req,$lang_lbl_requete_sql_err)."&lt;br&gt;\r\n"; 
			}
		}
	}
	// Fermeture de la requete
	$gDb->SQLFermeQuery(1);

	// remise à zéro    
	$direct = "0";   
        
	return $return;	
}
?>