#

ERROR=0
ARGV="$@"
if [ "x$ARGV" = "x" ] ; then 
    ARGS="help"
fi

for ARG in $@ 
do
    # check for pidfile
    if [ -f $PIDFILE ] ; then
	PID=`cat $PIDFILE`
	if [ "x$PID" != "x" ] && kill -0 $PID 2>/dev/null ; then
	    STATUS="$PRG (pid $PID) demarre"
	    RUNNING=1
	else
	    STATUS="$PRG (pid $PID?) arrete"
	    RUNNING=0
	fi
    else
	STATUS="$PRG arrete"
	RUNNING=0
    fi

    case $ARG in
    start)
	if [ $RUNNING -eq 1 ]; then
	    echo "$0 $ARG: $PRG (pid $PID) deja demarre"
	    continue
	fi
	if $PRG ; then
	    echo "$0 $ARG: $PRG started"
	else
	    echo "$0 $ARG: $PRG ne peut etre demarre"
	    ERROR=3
	fi
	;;
    stop)
	if [ $RUNNING -eq 0 ]; then
	    echo "$0 $ARG: $STATUS"
	    continue
	fi
	if kill -15 $PID ; then
	    echo "$0 $ARG: $PRG arrete"
	else
	    echo "$0 $ARG: $PRG ne peut etre arrete"
	    ERROR=4
	fi
	;;
    status)
	echo "$STATUS"
	;; 
    *)
	echo "usage: $0 (start|stop|status)"

    ;;

    esac

done

exit $ERROR
