if (typeof Prologue == 'undefined') Prologue = {} //Namespace

Prologue.framework = {
	path : 'framework'
	,images : {
		name : 'images'
		,path : function() {
			return Prologue.framework.path + '/' + this.name;
		}
		,toString : function() {
			return this.path();
		}
	}
	,version : '1.7'
};

Prologue.browser = new function()
{
	var uaTests = {
		op:/opera/i
		,chrome:/chrome/i
		,safari:/safari/i
		,ie:/MSIE/
		,moz:/gecko/i
		,ns:/netscape/i
	};
	this.type = '';
	this.userAgent = navigator.userAgent;
	for (var n in uaTests) {
		if (uaTests[n].test(navigator.userAgent)) {
			this.type = n;
			break;
		}
	}
	this.moz = (this.type=='moz');
	this.ie = (this.type=='ie');
	this.chrome = (this.type=='chrome');
	this.safari = (this.type=='safari');
	this.op = (this.type=='op');

	function getLanguage() {
		var tmp='fr-FR';
		if (window.navigator){
			if (window.navigator.browserLanguage)
				tmp=window.navigator.browserLanguage;
			else if (window.navigator.language) {
				tmp=window.navigator.language;
			}
			var re=/([a-z]{2})(?:-([a-z]{2}))?/gi;
			var ar=re.exec(tmp);
			if (ar) {
				if (!ar[2])
					ar[2] = ar[1];
				tmp = ar[1].toLowerCase() + '-' + ar[2].toUpperCase()
			}
		}
		return tmp
	};
	this.language = getLanguage();
}
///////////////////////////////////////////
/// IE Emulation for Firefox ///
///////////////////////////////////////////
if (typeof XMLHttpRequest == 'undefined') {
	XMLHttpRequest = function() {
		return new ActiveXObject("Microsoft.XMLHTTP");
	}
}

if ((Prologue.browser.chrome) || (Prologue.browser.safari) || (Prologue.browser.op))
{
	
	Node.prototype.removeNode = function( bRemoveChildren )
	{
		var parent = this.parentNode;
		if ( parent && !bRemoveChildren )
		{
			var df = document.createDocumentFragment();
			for( var i=0; i < this.childNodes.length; i++ )
				df.appendChild( this.childNodes[i] );
			parent.insertBefore(df,this)
		}
		return parent ? parent.removeChild( this ) : this;
	};

	HTMLElement.prototype.attachEvent = function (sType, fHandler)
	{
	    var shortTypeName = sType.replace(/on/, "");
	    
		fHandler._ieEmuEventHandler = function (e)
		{
			window.event = e;
			return fHandler();
	    };
	    
		this.addEventListener(shortTypeName, fHandler._ieEmuEventHandler, false);
	};
	
	window.attachEvent = HTMLElement.prototype.attachEvent;
	HTMLDocument.prototype.attachEvent = HTMLElement.prototype.attachEvent;
	 
	HTMLElement.prototype.detachEvent = function (sType, fHandler)
	{
	    var shortTypeName = sType.replace(/on/, "");
	    if (typeof fHandler._ieEmuEventHandler == "function")
			this.removeEventListener(shortTypeName, fHandler._ieEmuEventHandler, false);
	    else  
			this.removeEventListener(shortTypeName, fHandler, true);
	};
	
	window.detachEvent = HTMLElement.prototype.detachEvent;
	HTMLDocument.prototype.detachEvent = HTMLElement.prototype.detachEvent;

	HTMLElement.prototype.insertAdjacentHTML = function (sWhere, sHTML)
	{
        if (this.ownerDocument)
        {
		  var df, r = this.ownerDocument.createRange();
		}
		else
        {
          var df, r = this.createRange();
        }
		
		switch (String(sWhere).toLowerCase())
		{
			case "beforebegin":
				r.setStartBefore(this);
				df = r.createContextualFragment(sHTML);
				this.parentNode.insertBefore(df, this);
				break;
				
			case "afterbegin":
				r.selectNodeContents(this);
				r.collapse(true);
				df = r.createContextualFragment(sHTML);
				this.insertBefore(df, this.firstChild);
				break;
				
			case "beforeend":
				r.selectNodeContents(this);
				r.collapse(false);
				df = r.createContextualFragment(sHTML);
				this.appendChild(df);
				break;
				
			case "afterend":
				r.setStartAfter(this);
				df = r.createContextualFragment(sHTML);
				this.parentNode.insertBefore(df, this.nextSibling);
				break;
		}
	};	
	
	HTMLDocument.prototype.insertAdjacentHTML = HTMLElement.prototype.insertAdjacentHTML;
	HTMLElement.prototype.__defineGetter__("currentStyle", function()
	{
		return window.getComputedStyle(this, null);
	});
}

//Si  Moz on rajoute les fonctions presentent dans IE
if (Prologue.browser.moz)
{
		Navigator.prototype.__defineGetter__("browserLanguage", function ()
		{
			return this.language;
		});
		
	Node.prototype.removeNode = function( bRemoveChildren )
	{
		var parent = this.parentNode;
		if ( parent && !bRemoveChildren )
		{
			var df = document.createDocumentFragment();
			for( var i=0; i < this.childNodes.length; i++ )
				df.appendChild( this.childNodes[i] );
			parent.insertBefore(df,this)
		}
		return parent ? parent.removeChild( this ) : this;
	};

	HTMLElement.prototype.attachEvent = function (sType, fHandler)
	{
	    var shortTypeName = sType.replace(/on/, "");
	    
		fHandler._ieEmuEventHandler = function (e)
		{
			window.event = e;
			return fHandler();
	    };
	    
		this.addEventListener(shortTypeName, fHandler._ieEmuEventHandler, false);
	};
	
	Window.prototype.attachEvent = HTMLElement.prototype.attachEvent;
	HTMLDocument.prototype.attachEvent = HTMLElement.prototype.attachEvent;
	 
	HTMLElement.prototype.detachEvent = function (sType, fHandler)
	{
	    var shortTypeName = sType.replace(/on/, "");
	    if (typeof fHandler._ieEmuEventHandler == "function")
			this.removeEventListener(shortTypeName, fHandler._ieEmuEventHandler, false);
	    else  
			this.removeEventListener(shortTypeName, fHandler, true);
	};
	
	Window.prototype.detachEvent = HTMLElement.prototype.detachEvent; 
	HTMLDocument.prototype.detachEvent = HTMLElement.prototype.detachEvent;

		Event.prototype.__defineGetter__("srcElement", function ()
		{
			var node = this.target;
			while (node && node.nodeType != 1) node = node.parentNode;
			return node;
		});
	    
		Event.prototype.__defineGetter__("toElement", function ()
		{
			var node;
			if (this.type == "mouseout")
				node = this.relatedTarget;
			else if (this.type == "mouseover")
				node = this.target;
			if (node)
			{
				var nt = 0;
				while (nt!=1)
				{
					try
					{
						nt = node.nodeType;
						if (nt != 1) node = node.parentNode;
					}
					catch(e)
					{
						node=null;
						break;
					}
				}
			}
			return node;
		});
	
	HTMLElement.prototype.contains = function (oEl)
	{
		if (oEl == this) return true;
		if (oEl == null) return false;
		return this.contains(oEl.parentNode);
	};
	
	HTMLElement.prototype.__defineGetter__("currentStyle", function()
	{
		return window.getComputedStyle(this, null);
	});
	
	HTMLElement.prototype.__defineGetter__("outerHTML", function ()
	{
				return getOuterHTML(this);
	});

	function getOuterHTML(node)
	{
		var str = '';		
		switch (node.nodeType)
		{
			case 1: // ELEMENT_NODE
				str += '<' + node.nodeName;
				for (var i=0; i<node.attributes.length; i++)
				{
					if (node.attributes.item(i).nodeValue != null)
					{
						str += ' ';
						str += node.attributes.item(i).nodeName;
						str += '="';
						str += node.attributes.item(i).nodeValue;
						str += '"';
					}
				}

				if (node.childNodes.length == 0)
					str += '/ >';
				else
				{
					str += '>';
					str += node.innerHTML;
					str += '</' + node.nodeName + '>';
				}
				break;
					
			case 3:	//TEXT_NODE
				str += node.nodeValue;
				break;
				
			case 4: // CDATA_SECTION_NODE
				str += '<![CDATA[' + node.nodeValue + ']]>';
				break;
						
			case 5: // ENTITY_REFERENCE_NODE
				str += '&' + node.nodeName + ';';
				break;

			case 8: // COMMENT_NODE
				str += '<!--' + node.nodeValue + '-->';
				break;
		}

		return str;
	};

	HTMLElement.prototype.insertAdjacentHTML = function (sWhere, sHTML)
	{
		var df, r = this.ownerDocument.createRange();
		
		switch (String(sWhere).toLowerCase())
		{
			case "beforebegin":
				r.setStartBefore(this);
				df = r.createContextualFragment(sHTML);
				this.parentNode.insertBefore(df, this);
				break;
				
			case "afterbegin":
				r.selectNodeContents(this);
				r.collapse(true);
				df = r.createContextualFragment(sHTML);
				this.insertBefore(df, this.firstChild);
				break;
				
			case "beforeend":
				r.selectNodeContents(this);
				r.collapse(false);
				df = r.createContextualFragment(sHTML);
				this.appendChild(df);
				break;
				
			case "afterend":
				r.setStartAfter(this);
				df = r.createContextualFragment(sHTML);
				this.parentNode.insertBefore(df, this.nextSibling);
				break;
		}
	};	
}


//////////////////////
/// Fonctions ///
//////////////////////
Prologue.ui = {
	getGUID : function() {
		var uid;
		var evChars='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		var ret=false;
		while(!ret)
		{
			uid = '';
			for(var t=1;t<=10;t++) uid+=evChars.charAt(Math.floor(52*Math.random()));
			ret = (document.getElementById(uid)==null);
		}
		return uid;
	}
	,clientToScreen : function(oElm) {
		var px = oElm.offsetLeft;
		var py = oElm.offsetTop;
		var p = oElm.offsetParent;
		while (p && p.tagName !='HTML')
		{
			px += parseInt(p.offsetLeft, 10);
			py += parseInt(p.offsetTop, 10);
			p = p.offsetParent;
		}
		if (!Prologue.browser.ie) {
			p = oElm.parentNode
			while (p && p.tagName !='BODY')
			{
				if (p.scrollTop) py -= p.scrollTop;
				if (p.scrollLeft) px -= p.scrollLeft;
				p = p.parentNode;
			}
		}
		return {'left':px, 'top':py};
	}
	,screenToClient : function(obj, point) {
		function getParent(oElm)
		{
			var p = oElm.offsetParent;
			while (p && p.tagName !=' BODY')
			{
				if (p.currentStyle.position!='static' || p.currentStyle.overflow!='visible')
					break;
				p = p.offsetParent;
			}
			return p;
		};
		var p = getParent(obj);
		if (p)
		{
			var pPos = Prologue.ui.clientToScreen(p);
			point.top -= pPos.top;
			point.left -= pPos.left;					
		}
	}
	,moveTo : function(obj, point) {
		if(Prologue.browser.ie) Prologue.ui.screenToClient(obj, point);
		obj.style.top = point.top;
		obj.style.left = point.left;
	}
	,setSize : function(oElm, width, height) {
		Prologue.ui.setWidth(oElm, width);
		Prologue.ui.setHeight(oElm, height);
	}
	,setWidth : function(oElm, width) {
		if (oElm)
		{
			if (width)
			{
				if (Prologue.browser.moz)
				{
					var cs = oElm.currentStyle;
					width -= (cs.marginLeft) ? parseInt(cs.marginLeft, 10) : 0;
					width -= (cs.marginRight) ? parseInt(cs.marginRight, 10) : 0;
					width -= (cs.paddingLeft) ? parseInt(cs.paddingLeft, 10) : 0;
					width -= (cs.paddingRight) ? parseInt(cs.paddingRight, 10) : 0;
					width -= (cs.borderLeftWidth) ? parseInt(cs.borderLeftWidth, 10) : 0;
					width -= (cs.borderRightWidth) ? parseInt(cs.borderRightWidth, 10) : 0;
				}
				oElm.style.width = width;
			}
		}
	}
	,setHeight : function(oElm, height) {
		if (oElm)
		{
			if (height)
			{
				if (!Prologue.browser.ie)
				{
					var cs = oElm.currentStyle;
					height -= (cs.marginTop) ? parseInt(cs.marginTop, 10) : 0;
					height -= (cs.marginBottom) ? parseInt(cs.marginBottom, 10) : 0;
					height -= (cs.paddingTop) ? parseInt(cs.paddingTop, 10) : 0;
					height -= (cs.paddingBottom) ? parseInt(cs.paddingBottom, 10) : 0;
					height -= (cs.borderTopWidth) ? parseInt(cs.borderTopWidth, 10) : 0;
					height -= (cs.borderBottomWidth) ? parseInt(cs.borderBottomWidth, 10) : 0;
				}
				oElm.style.height = height;
			}
		}
	}
	,setOpacity : function(obj, iOpacity) {
		if (Prologue.browser.ie)
			obj.style.filter='progid:DXImageTransform.Microsoft.Alpha(opacity=' + iOpacity + ')';
		else
			obj.style.opacity = (iOpacity/100);
	}
	,getOpacity : function(obj) {
		var opc = 0;
		if (Prologue.browser.ie) {
			for (o in obj.filters) {
				if (o=='DXImageTransform.Microsoft.Alpha') {
					opc = obj.filters[o].opacity;
					break;
				}
			}
		}
		else
			opc = obj.style.opacity*100;
		return opc;
	}
	,stopEvent : function(evt) // Fonction pour stopper la propagation d'un évènement
	{
		var e = evt ? evt : window.event;

		if(e.srcElement && e.srcElement.id)
		{
			e.srcElement.disabled = true;
			setTimeout('document.getElementById("'+e.srcElement.id+'").disabled = false;', 10);
		}
		
		//e.stopPropagation ne marche que sous gecko (Firefox).
		if (e.stopPropagation)
		{
			e.preventDefault();
			e.stopPropagation();
		}

		//e.cancelBubble pour IE - kill du bubbling process.
		e.bubbles = false;
		e.cancelBubble = true;
		e.returnValue = false;

		return false;
	}
};

Date.prototype.add = function(part, nbr)
{
	var millisecond=1;
	var second=millisecond*1000;
	var minute=second*60;
	var hour=minute*60;
	var day=hour*24;
	var year=day*365;
	parts =
	{
		'ms':function(){return millisecond*nbr},
		's':function(){return second*nbr},
		'mi':function(){return minute*nbr},
		'h':function(){return hour*nbr},
		'd':function(){return day*nbr},
		'mo':function(){return day*nbr},
		'y':function(){return year*nbr}
	};
	return new Date(this.getTime()+(parts[part]?parts[part]():0));
};

Number.decimalChar = function()
{
	var dc = parseFloat(1/2).toString().substr(1,1);
	return dc;
};

function isDate(value)
{
	var rx = new RegExp(/^(\d{1,2})([^\d])(\d{1,2})\2(\d{2})(\d{2})?$/);
	var ar = rx.exec(value);
	var ret = false;
	if (ar)
	{
		ar[3]=parseInt(ar[3],10)-1;
		ar[1]=parseInt(ar[1],10);
		ar[4]=parseInt((ar[4]+ar[5]),10);
		var dte = new Date(ar[4], ar[3], ar[1]);
		ret = (dte.getDate()==ar[1] && dte.getMonth()==ar[3] && dte.getFullYear()==ar[4]);
	}
	return ret;
};

function str2Date(value)
{
	var rx = new RegExp(/^(\d{1,2})([^\d])(\d{1,2})\2(\d{2})(\d{2})?$/);
	var ar = rx.exec(value);
	if (ar)
		var date = new Date(parseInt((ar[4]+ar[5]),10), parseInt(ar[3],10) - 1, parseInt(ar[1],10));
	else
		var date = new Date();
	return date;
};

function date2Str(date)
{
	var day = parseInt(date.getDate(),10);
	var month = parseInt(date.getMonth(),10) + 1;
	var year = parseInt(date.getFullYear(),10);
	return ((day < 10)?'0':'') + day + '/' + ((month < 10)?'0':'') + month + '/' + year;
};

function getKeyInfo (evnt)
{
	var key = 0;
	var tgt = null;
	var vkey = false;
	
	if (!Prologue.browser.ie)
	{
		key=evnt.which;
		tgt=evnt.target;
		if (key==0)
		{
			key=evnt.keyCode;
			vkey=true;
		}
	}
	else
	{
		key=event.keyCode;
		tgt=event.srcElement;
	}
	return {'key':key, 'tgt':tgt, 'vkey':vkey};
};

function setKeyCode (evnt, keyCode)
{
	if (!Prologue.browser.ie)
		if(!(evnt.which = keyCode))
			evnt.keyCode = keyCode;
	else
		evnt.keyCode = keyCode;
};

function SetCaretTo(Field, Pos)
{
	if (Prologue.browser.moz)
	{
		Field.setSelectionRange(Pos,Pos); 
		return true;
	}
	else if (Prologue.browser.ie)
	{
		var range = Field.createTextRange();
		range.collapse(true);
		range.moveEnd('character', Pos);
		range.moveStart('character', Pos);
		range.select();
		return true;
	}
	return false;
};

function bindXmlToObj(instance, xNde)
{
	if (xNde)
	{
		for (var pAtb=0; pAtb<xNde.attributes.length; pAtb++)
		{
			var atb = xNde.attributes[pAtb];
			switch (typeof instance[atb.name])
			{
				case 'boolean':
					instance[atb.name]=new Boolean(atb.value);
					break;
				case 'number':
					instance[atb.name]=parseInt(atb.value, 10);
					break;
				case 'undefined':
					break;
				default:
					instance[atb.name]=atb.value;
					break;
			}
		}
	}
};

Function.prototype.extend = function(baseClass)
{
	this.prototype = new baseClass();
	this.prototype.constructor = this;
	this.baseConstructor = baseClass;
	this.base = baseClass.prototype;
	this.callBaseConstructor = function(instance) {
		for(var a=1,args=[];a<arguments.length;args.push(arguments[a]),a++);
		this.base['constructor'].apply(instance, args);
	};
	this.callBaseMethod = function(instance, method) {
		for(var a=2,args=[];a<arguments.length;args.push(arguments[a]),a++);
		return this.base[method].apply(instance, args);
	};
};

$ = function(id) {
	return document.getElementById(id);
}

Prologue.chrono = new function () {
	this.deb = null;
	this.msec = 0;
	this.sec = 0;
	
	this.start_me = function () {
		this.deb = new Date();
	};
		
	this.stop_me = function () {
		var fin = new Date();
		var delta_millisec = fin.getTime() - this.deb.getTime();
		this.msec = delta_millisec%1000;
		this.sec = parseInt(delta_millisec/1000);
	}
	
	this.raz_me = function () {
		this.msec = 0;
		this.sec = 0;
		this.deb = null;
	}
};
Prologue.ajax = {
	request : function(url, method) {
		var _req = new XMLHttpRequest();
		var _self = this;
		var _responseXML='undefined';
		var _callBack = function() {
			if (_req.readyState==4) {
				_self.callBack(_self);
			}
		};
		this.tag = '';
		this.callBack = null;
		this.url = (url||'');
		this.method = (method||'GET');
		this.send = function(data) {
			data = (data||null);
			if (this.url && this.method) {
				if(this.url.substr(0,5)!="<?xml")
				{
					_req.open(this.method, this.url, ((this.callBack)?true:false));
					if (this.method.toLowerCase()=='post')
						_req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
					if (this.callBack) _req.onreadystatechange = _callBack;
					_req.send(data);
					if (!this.callBack) _responseXML = _req.responseXML;
				}
				else
				{
					if (window.ActiveXObject)
					{
						_responseXML = new ActiveXObject("Microsoft.XMLDOM");
						_responseXML.async=false;
   						_responseXML.loadXML(this.url);
   					}
   					else
   					{	
						_responseXML=(new DOMParser()).parseFromString(this.url,"text/xml");
					}
				}
				
			}
		};
		this.getStatus = function() {
			try{if(_req)return _req.status}catch(e){}
		};
		this.getText = function() {
			return _req.responseText;
		};
		this.getXML = function() {
			return (this.callBack)?_req.responseXML:_responseXML;
		};
		this.getJson = function() {
			if (_req.responseText) {
				try {
					return eval('('+_req.responseText+')');
				}
				catch (e) {return null;};
			}
			else
				return null;
		};
	}
	,form2Req : function(form) {
		var data = '';
		var atb = form.attributes.getNamedItem('action');
		if (atb) {
			var action = atb.value;
			atb = form.attributes.getNamedItem('method');
			var method = 'POST';
			if (atb) method = atb.value.toUpperCase();
			for (var e,i=0; e=form.elements[i++];) {
				if (e.name) {
					var param = '';
					switch (e.tagName) {
						case 'INPUT':
							switch (e.type) {
								case 'radio':
								case 'checkbox':
									if (e.checked)
										param = e.name + '=' + encodeURIComponent(e.value);
									break;
								case 'button':
								case 'hidden':								
								case 'image':								
								case 'password':								
								case 'text':							
									param = e.name + '=' + encodeURIComponent(e.value);
									break;
								default:
									param = e.name + '=' + encodeURIComponent(e.value);
									break;
							}								
							break;
						case 'SELECT':
							for (var o=0; o<e.options.length; o++) {
								var opt = e.options[o];
								if (opt.selected)
									param += ((param.length)?'&':'') + e.name + '=' + encodeURIComponent(opt.value);									
							}
							break;
						case 'TEXTAREA':
							param = e.name + '=' + encodeURIComponent(e.value);
							break;
						default:
							break;
					}
					if(param) data += ((data.length)?'&':'') + param;
				}
			}
		}
		return data;
	}
	,postForm : function(form) {
		var atb = form.attributes.getNamedItem('action');
		if (atb) {
			var action = atb.value;
			atb = form.attributes.getNamedItem('method');
			var method = 'POST';
			if (atb) method = atb.value.toUpperCase();
			var data = Prologue.ajax.form2Req(form);
			var req = new Prologue.ajax.request();
			req.url = action;
			req.method = method;
			req.send(data);
			return req;
		}
		return null;
	}
};

//*******************************************************
//***** Obsolete utilisez Prologue.ajax.request
//*******************************************************
Prologue.ajax.jsonGet = function(uri, method, parameters)
{
	var req = Prologue.ajax.ajaxReq(uri, method, parameters);
	return req.getJson();
};
//*******************************************************
//***** Obsolete utilisez Prologue.ajax.request
//*******************************************************
Prologue.ajax.ajaxGet = function(uri, method, parameters)
{
	var req = Prologue.ajax.ajaxReq(uri, method, parameters);
	return req.getXML();
};
//*******************************************************
//***** Obsolete utilisez Prologue.ajax.request
//*******************************************************
Prologue.ajax.ajaxReq = function(uri, method, parameters)
{	
	method = (method||'GET').toUpperCase();
	parameters = (parameters||'');

	if (method=='GET' && parameters) {
		uri +='?'+parameters;
		parameters = null;
	}
	var req = new Prologue.ajax.request();
	req.url = uri
	req.method = method;
	req.send(parameters);
	var rt = req.getText();
	return req;
};


/////////////////////////////////
/// collection Object ///
/////////////////////////////////
Prologue.collection = function()
{
	this.items = [];	
};

Prologue.collection.prototype.item = function(index)
{
	return this.items[index];
};

Prologue.collection.prototype.remove = function(index)
{
};

Prologue.collection.prototype.count = function()
{
	return this.items.length;
};

Prologue.collection.sortDir =
{
	none:0
	,ascending:1
	,descending:-1
};

Prologue.collection.prototype.sort = function(sortDir, compareFunction)
{
	function sortCompare(n1, n2)
	{
		if (n1.toString() < n2.toString())
			return -1;
		if (n2.toString() < n1.toString())
			return 1;
		return 0;
	};	
	if (typeof sortDir == 'undefined') sortDir = Prologue.collection.sortDir.ascending;
	if (sortDir==Prologue.collection.sortDir.ascending || sortDir==Prologue.collection.sortDir.descending) {
		if (typeof compareFunction == 'function')
			this.items.sort(compareFunction);
		else
			this.items.sort(sortCompare);
		if (sortDir==Prologue.collection.sortDir.descending) this.items.reverse();
	}	
};


/////////////////////////////
/// control Object ///
/////////////////////////////
Prologue.control = function(id, className, toolTip, onClick)
{
	var _self = this;
	this.id = (id||Prologue.ui.getGUID());
	this.className = (className||'');
	this.toolTip = (toolTip||'');
	this.onClick = (onClick||'');
	this.enable = true;
	this.visible = true;
	this.defaultWidth = 280;
};

Prologue.control.prototype.attributes = function()
{
	var tmp = '';		
	if (this.id) tmp+=' id="'+this.id+'"';
	if (this.className) tmp+=' class="'+this.className+'"';
	if (this.toolTip) tmp+=' title="'+this.toolTip+'"';
	if (this.onClick) tmp+=' onclick="'+this.onClick+'"';
	return tmp;
};

Prologue.control.prototype.html = function()
{
	return '';
};

Prologue.control.prototype.create = function()
{
	document.write(this.html());
};

////////////////////////
/// class Item ///
////////////////////////
Prologue.item = function(caption, icon, className)
{
	this.caption = (caption||'');
	this.icon = (icon||'');
	this.className = (className||'prlItem');
	this.toolTip = '';
	this.alignment = Prologue.item.alignment.left;
	this.attributes = [];
	this.toString = function()
	{
		return this.caption;
	};
};

Prologue.item.alignment =
{
	left:0
	,center:1
	,right:2
};

Prologue.item.prototype.html = function()
{
	var caption = this.caption;
	if (!caption && !this.icon)
		caption = 'sans titre';
	var tmp = '<table summary="" class="'+this.className+'" cellspacing="0"';
	if (this.title)
		tmp += 'title="'+this.toolTip+'"';
	//gestion de l'alignement
	tmp += ' align="';
	switch (this.alignment) {
		case Prologue.item.alignment.center:
			tmp += 'center';
			break;
		case Prologue.item.alignment.right:
			tmp += 'right';
			break;
		default:
			tmp += 'left';		
	}
	tmp += '"';
	//gestion des attributs
	for (var a in this.attributes)
	{
		tmp += ' '+a+'="'+this.attributes[a]+'"';
	}
	tmp += '><tr>';
	if (this.icon)
		tmp += '<td class="prlIcon"><img src="'+this.icon+'"/></td>';
	if (caption)
		tmp += '<td class="prlCaption">'+caption+'</td>';
	tmp += '</tr></table>';
	return tmp;
};

Prologue.item.getItem = function(table)
{
	var itm = new Prologue.item();
	
	if (table && table.nodeName=='TABLE')
	{
		if (table.attributes.getNamedItem('title'))
			itm.toolTip = table.attributes.getNamedItem('title').value;
		if (table.attributes.getNamedItem('class'))
			itm.className = table.attributes.getNamedItem('class').value;
		for (var c=0; c<table.rows[0].cells.length; c++)
		{
			var cell = table.rows[0].cells[c];
			switch (cell.className)
			{
				case 'prlIcon':
					itm.icon = cell.firstChild.src;
					break;
				case 'prlCaption':
					itm.caption = cell.innerHTML;
					break;
			}
		}
	}
	return itm;
};

Prologue.item.setText = function(item, text) {
	if (item && item.nodeName=='TABLE')
	{
		var found = false;
		for (var c=0; c<item.rows[0].cells.length; c++)
		{
			var cell = item.rows[0].cells[c];
			if (cell.className=='prlCaption') {
				found=true;
				cell.innerHTML = text;
				break;
			}
		}
		if (!found) {
			var cell = document.createElement('TD');
			cell.className = 'prlCaption';
			cell.innerHTML = text;
			item.rows[0].appendChild(cell);
		}
	}	
};

Prologue.item.setIcon = function(item, icon) {	
	if (item && item.nodeName=='TABLE')
	{
		var found = false;
		for (var c=0; c<item.rows[0].cells.length; c++)
		{
			var cell = item.rows[0].cells[c];
			if (cell.className=='prlIcon') {
				found=true;
				cell.firstChild.src = icon;
				break;
			}
		}
		if (!found) {
			var cell = document.createElement('TD');
			cell.className = 'prlIcon';
			cell.innerHTML = '<img src="'+icon+'"/>';
			item.rows[0].insertBefore(cell, item.rows[0].cells[0]);
		}
	}	
}

////////////////////////////////
/// container Object ///
////////////////////////////////
Prologue.container = function(caption, icon, content)
{
	Prologue.container.callBaseConstructor(this, '', 'prlContainer', '', '');
	this.title = new Prologue.item(caption||'sans titre', icon);
	this.title.alignment = Prologue.item.alignment.center;
	this.titlePosition = Prologue.container.titlePosition.top;
	this.content = content||'&nbsp';
	this.contentID = '';
	this.clientWidth = '';
	this.clientHeight = '';
};
Prologue.container.extend(Prologue.control);

Prologue.container.prototype.attributes = function() {
	var tmp = Prologue.container.callBaseMethod(this, 'attributes');
	tmp += ' prlTitlePosition="'+this.titlePosition+'"';
	tmp += ' summary=""';
	return tmp;
};

Prologue.container.titlePosition =
{
	 top : 0
	,bottom : 1
};

Prologue.container.prototype.html = function()
{
	var tmp = '';
	var title = '<tr><td class="prlTitle">'+this.title.html()+'</td></tr>';

	tmp += '<table'+this.attributes()+'>';
	if (this.titlePosition == Prologue.container.titlePosition.top) tmp += title;
	tmp += '<tr><td class="prlContainerContent"><div';
	if (this.clientHeight || this.clientWidth)
	{
		tmp += ' style="overflow:auto;';
		if (this.clientHeight) tmp += 'height:'+this.clientHeight+';';
		if (this.clientWidth) tmp += 'width:'+this.clientWidth+';"';
		tmp += '"';
	}
	tmp += '>'+this.content+'</div></td></tr>';
	if (this.titlePosition == Prologue.container.titlePosition.bottom) tmp += title;
	tmp += '</table>';
	return tmp;
};

Prologue.container.getContent = function(container)
{
	var cnt = null;
	if (typeof container == 'string') container = document.getElementById(container);
	if (container && container.nodeName=='TABLE')
	{
		var titlePosition = parseInt(container.attributes.getNamedItem('prlTitlePosition').value);
		cnt = container.rows[(titlePosition==Prologue.container.titlePosition.top)?1:0].cells[0].firstChild;
	}
	return cnt;
};

Prologue.container.setContent = function(container, content)
{
	var cnt = Prologue.container.getContent(container);
	cnt.innerHTML = content;
};

Prologue.container.prototype.create = function()
{
	Prologue.container.callBaseMethod(this, 'create');
	var me = document.getElementById(this.id);	
	if (me && this.contentID)
	{
		var obj = document.getElementById(this.contentID);
		if (obj)
		{
			var cnt = Prologue.container.getContent(me);
			if (cnt)
			{
				//suppression des fils actuels du container
				cnt.innerHTML = '';
				//rattachement du fils
				cnt.appendChild(obj);
				
				//cnt.innerHTML = obj.innerHTML;
				//obj.removeNode(true);
			}
		}
	}
};

Prologue.container.setHeight = function(container, height) {
	if (typeof container == 'string') container = document.getElementById(container);
	if (container && container.nodeName=='TABLE')
	{
		var titlePosition = parseInt(container.attributes.getNamedItem('prlTitlePosition').value);
		if (titlePosition==Prologue.container.titlePosition.top) {
			height -= container.rows[0].offsetHeight;
			container.rows[1].cells[0].firstChild.style.height = height;
		}
		else {
			height -= container.rows[1].offsetHeight;
			container.rows[0].cells[0].firstChild.style.height = height;
		}
	}
};

//////////////////////////
/// Panel Object ///
//////////////////////////
Prologue.panel = function(caption, icon, content)
{
	Prologue.panel.callBaseConstructor(this, caption, icon, content);
	this.className = 'prlPanel';
	this.title.alignment = Prologue.item.alignment.left;
	this.open = true;
	this.onTitleClick = 'Prologue.panel.titleClick(this);'; //cette propriete devrait �tre protected
	this.attributes = function() {
		var tmp = Prologue.panel.callBaseMethod(this, 'attributes');
		tmp += ' prlTitlePosition="'+this.titlePosition+'"';
		return tmp;
	};
};
Prologue.panel.extend(Prologue.container);
//inherit static functions
Prologue.panel.getContent = Prologue.container.getContent;


Prologue.panel.prototype.html = function()
{
	var toolTip = this.toolTip;
	var title = '<tr onclick="' + this.onTitleClick + '"><td class="prlTitle">'
			+ '<table summary="" width="100%" title="'+toolTip+'"><tr>'
			+ '<td width="100%">'+this.title.html()+'</td>'
			+ '<td><img src="' + ((this.open)?Prologue.panel.images.close:Prologue.panel.images.open) + '" alt=""/></td>'
			+ '</tr></table>'
			+ '</td></tr>';	
	this.toolTip = '';
	var tmp = '<table '+this.attributes()+' cellspacing="0" cellpadding="0" summary="">'
			+ ((this.titlePosition == Prologue.container.titlePosition.top)?title:'')
			+ '<tr style="display:'+((this.open)?'table-row':'none')+';"><td colspan="2" class="prlPanelContent"><div class="prlPanelContentDiv" style="'
			+ ((this.clientWidth)?'width:'+this.clientWidth+';':'')
			+ ((this.clientHeight)?'height:'+this.clientHeight+';':'')
			+ '">'+this.content+'</div></td></tr>'
			+ ((this.titlePosition == Prologue.container.titlePosition.bottom)?title:'')
			+ '</table>';
	this.toolTip = toolTip;
	return tmp;
};

Prologue.panel.setTitle = function(panel, title)
{
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
	{
		var titlePosition = parseInt(panel.attributes.getNamedItem('prlTitlePosition').value);
		var itm = panel.rows[(titlePosition==Prologue.container.titlePosition.top)?0:1].cells[0].firstChild.rows[0].cells[0].firstChild;
		for (var pTd=0; pTd<itm.rows[0].cells.length; pTd++) {
			var td = itm.rows[0].cells[pTd];
			if (td.className=='prlCaption') {
				td.innerHTML = title;
				break;
			}
		}
	}
};

Prologue.panel.images =
{
	close : {
		name : 'fleche_haut.png',
		toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	},
	open : {
		name : 'fleche_bas.png',
		toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
};

Prologue.panel.titleClick = function(tr)
{
	var panel = tr.parentNode.parentNode;
	Prologue.panel.setState(panel);
};

Prologue.panel.states =
{
	 open:1
	,close:0
};

Prologue.panel.getState = function(panel)
{
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
	{
		var cnt = Prologue.container.getContent(panel).parentNode.parentNode;
		var state = (cnt.style.display!='none')?Prologue.panel.states.open:Prologue.panel.states.close;
		return state;
	}
	return null;
};

Prologue.panel.setState = function(panel, state)
{
	if (typeof panel == 'string')
		panel = document.getElementById(panel);
	if (panel && panel.nodeName=='TABLE')
	{
		var titlePosition = parseInt(panel.attributes.getNamedItem('prlTitlePosition').value);
		if (typeof state == 'undefined') state = (Prologue.panel.getState(panel)==Prologue.panel.states.open)?Prologue.panel.states.close:Prologue.panel.states.open;
		var visible = (state==Prologue.panel.states.open);
		var tr = panel.rows[(titlePosition==Prologue.container.titlePosition.top)?0:1];
		tr.cells[0].firstChild.rows[0].cells[1].firstChild.src = ((visible)?Prologue.panel.images.close:Prologue.panel.images.open);
		
		tr = panel.rows[(titlePosition==Prologue.container.titlePosition.top)?1:0];
		tr.style.display = ((visible)?'':'none');
		return true;
	}
	return false;
};

////////////////////////////////
/// prlButton Object ///
////////////////////////////////
Prologue.button = function(caption, onClick, icon, skin)
{
	Prologue.button.callBaseConstructor(this, '', 'prlButton' , '', onClick);
	this.title = new Prologue.item(caption, icon);
	this.skin = (skin||Prologue.framework.images+'/button_bleu');
	this.skinExt = 'gif';
	this.tabNomFic = Array(	'TopLeft',		'TopMiddle',	'TopRight',
							'MiddleLeft',	'MiddleMiddle',	'MiddleRight',
							'BottomLeft',	'BottomMiddle',	'BottomRight');
	this.offset = 2;
};
Prologue.button.extend(Prologue.control);

Prologue.button.prototype.html = function ()
{
	var onclick = this.onClick;
	this.onClick='';
	var tmp = '<table summary="" cellspacing="0" cellpadding="0" prlOffset="'+this.offset+'" prlIsDown="0"'+this.attributes();
	tmp += ' onselectstart="return false;"';
	tmp += ' style="margin:'+this.offset+'px;"';
	tmp += ' onmousedown="Prologue.button.chgSkin(this, \''+this.skin+'\', true);return false;"';
	tmp += ' onmouseout="if(!this.contains(event.toElement)){Prologue.button.chgSkin(this, \''+this.skin+'\', false);return false;}"';
	tmp += ' onmouseup="';
	if (onclick)
		tmp += 'if(this.attributes.getNamedItem(\'prlIsDown\').value==\'1\'){'+onclick+'}';
	tmp += 'Prologue.button.chgSkin(this, \''+this.skin+'\', false);"';
	tmp += ' cellspacing="0" cellpadding="0">';
			
	for(var i = 0; i < 9;)
	{		
		if(0 == i % 3)
			tmp += '<tr'+((i==0||i==6)?' style="height:1px;"':'')+'>';
		
		tmp += (( 1 == i % 3) || (3 == i) || (5 == i))
			?'<td style="background-image:url('+this.skin+'/Up/'+this.tabNomFic[i]+'.'+this.skinExt+');">'
			:'<td>';
		
		if(4 != i)
			tmp += '<img src="'+this.skin+'/Up/'+this.tabNomFic[i]+'.'+this.skinExt+'" alt=""/></td>';
		else
			tmp += this.title.html()+'</td>';
		
		 ++i;
		 
		 if(0 == i % 3)
			tmp += '</tr>';
	}
	tmp += '</table>' ;
	return tmp;
};

Prologue.button.chgSkin = function (table, skin, goDown)
{	
	if (table.attributes.getNamedItem('prlIsDown').value == ((goDown)?'1':'0')) return;
	table.attributes.getNamedItem('prlIsDown').value = ((goDown)?'1':'0');
	
	var offset = parseInt(table.attributes.getNamedItem('prlOffset').value, 10);
	offset = (isNaN(offset)? 2: offset);
	if(goDown)
	{
		table.style.margin = (offset + offset)+'px '+(offset - offset)+'px '+(offset - offset)+'px '+(offset + offset)+'px';
		var state = '/Down';
	}
	else
	{
		table.style.margin = offset+'px '+offset+'px '+offset+'px '+offset+'px';
		var state = '/Up';
	}
	
	var i = 0;
	
	for(var r = 0; r < table.rows.length; r++)
	{
		var row = table.rows[r];
		for(var c = 0; c < row.cells.length; c++)
		{
			var cell = row.cells[c];
			var fullPath;
			
			if (4 != i)
			{
				fullPath = cell.firstChild.src;
				var p = fullPath.lastIndexOf('/');
				var fic = fullPath.substring(p);
				var path = fullPath.substring(0, fullPath.lastIndexOf('/', p - 1));
				cell.firstChild.src = path + state + fic;
			}
			if (( 1 == i % 3) || (3 == i) || (5 == i) )
			{
				fullPath = cell.style.backgroundImage;
				var p = fullPath.lastIndexOf('/');
				var fic = fullPath.substring(p);
				var path = fullPath.substring(0, fullPath.lastIndexOf('/', p - 1));
				cell.style.backgroundImage = path + state + fic;
			}
			
			++i;
		}
	}
};

/////////////////////////////
/// TextBox Object ///
/////////////////////////////
Prologue.textBox = function(id, format, value, onClick)
{
	Prologue.textBox.callBaseConstructor(this, id, 'textBox', '', onClick);	
	this.value = (typeof value != 'undefined')?value:'';
	this.format = Prologue.textBox.formats.any;
	if (typeof format != 'undefined')
	{
		if (typeof format == 'string')
		{
			if (Prologue.textBox.formats[format])
				this.format = Prologue.textBox.formats[format];
		}
		if (typeof format.name != 'undefined' && typeof format.key != 'undefined' && typeof format.validate != 'undefined' && typeof format.maxLength != 'undefined' && typeof format.align != 'undefined')
			this.format = format;
	}
	this.maxLength = '';
	this.errMesg = lang_msg_wrong_format;
	this.onError = '';
	this.readOnly = false;
	this.password = false;
	this.size = '';
	this.width = '';
	this.caseMode = Prologue.textBox.caseMode.none;
	this.trim = Prologue.textBox.trimMode.none;
	this.onKeyPress = 'return Prologue.textBox.checkKey(this, event);';
	this.onKeyUp = '';
	this.onBlur = '';
	this.onMouseUp = '';
};
Prologue.textBox.extend(Prologue.control);

Prologue.textBox.caseMode = 
{
	'none':0,
	'lower':1,
	'upper':2,
	'firstUpper':3,
	'name':4
}
Prologue.textBox.trimMode = 
{
	'none':0,
	'left':1,
	'right':2,
	'both':3
}
Prologue.textBox.formats =
{
	'any':{
		'name':'any',
		'key':/./,
		'validate':/^.*$/,
		'maxLength':0,
		'align':'left'
	},
	
	'alpha':{
		'name':'alpha',
		'key':/[a-zA-Z]/,		
		'validate':/^[a-zA-Z]*$/,
		'maxLength':0,
		'align':'left'
	},
	
	'integer':{
		'name':'integer',
		'key':/[0-9]|-/,
		'validate':/^-?\d+$/,
		'maxLength':0,
		'align':'right'		
	},
	
	'uinteger':{
		'name':'uinteger',
		'key':/[0-9]/,
		'validate':/^[0-9]*$/,
		'maxLength':0,
		'align':'right'
	},
	
	'decimal':{
		'name':'decimal',
		'key':new RegExp('[0-9]|-|\\'+Number.decimalChar()),
		'validate':/^-?\d+(\.\d+)?$/,
		'maxLength':0,
		'align':'right'
	},
	
	'udecimal':{
		'name':'udecimal',
		'key':new RegExp('[0-9]|\\'+Number.decimalChar()),
		'validate':/^\d+(\.\d+)?$/,
		'maxLength':0,
		'align':'right'
	},
	
	'email':{
		'name':'email',
		'key':/[\.@a-zA-Z0-9_-]/,
		'validate':/^([a-zA-Z0-9_\-])([a-zA-Z0-9_\-\.]*)@(\[((25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}|((([a-zA-Z0-9\-]+)\.)+))([a-zA-Z]{2,}|(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\])$/,
		'maxLength':0,
		'align':'left'		
	},
	
	'date':{
		'name':'date',
		'key':/[\d\/-]/,
		'validate':/^\d{1,2}([-\/\.])\d{1,2}\1\d{2}(\d{2})?$/,
		'maxLength':10,
		'align':'left'
	},
	
	'ip':{
		'name':'ip',
		'key':/[\d\.]/,
		'validate':/^((25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])$/,
		'maxLength':15,
		'align':'left'
	},
	
	'phone':{
		'name':'phone',
		'key':/[\d\s\.-]/,
		'validate':/^\+\d{1,3}\s?\d{9}$|^\d{2}([-\.\s])(\d{2}\1){3}\d{2}$|(^\d{10}$)/,
		'maxLength':14,
		'align':'left'
	},
	
	'url':{
		'name':'url',
		'key':/[\.@a-zA-Z0-9_\+=\-\?&\/:%]/,
		'validate':/^(http(?:s?)|ftp):\/\/(?:([^\s@]+)@)?([^\s@\/\:]+)(?:\:(\d+))?(?:\/([^\s\.]*?))?(?:\/([^\s\/\.]+\.[^\s\?]+)(?:\?([^\s]*))?)?\s*$/,
		'maxLength':0,
		'align':'left'
	},
	
	'winpath':{
		'name':'winpath',
		'key':/[^\*\"\?\<\>\|]/,
		'validate':/(([a-zA-Z]:)|(\\{2}\w+)\$?)((?:\\.*)*\\)([^\/\\\:\*\"\?\<\>\|]+(\.\w{2,4})?)?$/,
		'maxLength':0,
		'align':'left'
	},

	'nixpath':{
		'name':'nixpath',
		'key':/[^\*\"\?\<\>\|]/,
		'validate':/^((?:\/[^\/\\\:\*\"\?\<\>\|]*)*\/)([^\/\\\:\*\"\?\<\>\|]+(\.\w{2,4})?)?$/,
		'maxLength':0,
		'align':'left'
	},

	'path':{
		'name':'path',
		'key':/[^\*\"\?\<\>\|]/,
		'validate':/(^(([a-zA-Z]:)|(\\{2}\w+)\$?)((?:\\[^\/\\\:\*\"\?\<\>\|]*)*\\)([^\/\\\:\*\"\?\<\>\|]+(\.\w{2,4})?)?$)|(^((?:\/[^\/\\\:\*\"\?\<\>\|]*)*\/)([^\/\\\:\*\"\?\<\>\|]+(\.\w{2,4})?)?$)/,
		'maxLength':0,
		'align':'left'
	}
};

Prologue.textBox.prototype.html = function ()
{
	var onChange = 'if(this.value == \'\') { '+this.onClick+' } else { if(Prologue.textBox.checkFormat(this)) { '+this.onClick+' } else {';
	if(this.errMesg != '') onChange += ' alert(\''+this.errMesg+'\');';
	if(this.onError != '') onChange += ' '+this.onError;
	onChange += ' }};';
	this.onClick = '';
	this.maxLength = ((this.format.maxLength == 0)?this.maxLength:this.format.maxLength);
	
	var tmp = '<input type='+((this.password)?'password':'text')+((this.id == 'UIFpwd' || this.id == 'UIFlogin')?'':' autocomplete="off" ')+' '+this.attributes()+' onfocus="this.select();"';
	if(this.id != '')
		tmp += ' name="'+this.id+'"';
	tmp += ' value="'+this.value+'"';
	tmp += ' onchange="'+onChange+'" onkeypress="'+this.onKeyPress+'" onkeyup="'+this.onKeyUp+'" onblur="'+this.onBlur+'" onmouseup="'+this.onMouseUp+'"';
	
	var tmpstyle = ' style="';
	if(this.readOnly)
	{
		tmp += ' readOnly onmousedown="return false;" onselectstart="return false;"';
		tmpstyle += 'cursor:pointer;';
	}

	if (this.format.align != 'left')
		tmpstyle += 'text-align:'+this.format.align+';';

	if (this.width != '')
		tmpstyle += 'width:'+this.width+';';
	else
		tmpstyle += 'width:'+this.defaultWidth+'px;';
		
	tmp += tmpstyle + '"';
		
	if (typeof this.format == 'string')
	{
		if (Prologue.textBox.formats[this.format])
			this.format = Prologue.textBox.formats[this.format];
	}
	if (this.size != '') tmp += ' size='+this.size;
	tmp += ' trim="'+this.trim+'" caseMode="'+this.caseMode+'" defaultValue="'+this.value+'" maxLength="'+this.maxLength+'" format="'+this.format.name+'"';
	if (!Prologue.textBox.formats[this.format.name]) {
		tmp += ' key="' + this.format.key.source + '"';
		tmp += ' validate="' + this.format.validate.source + '"';
	}
	tmp += '/>';
	
	return tmp;
};

Prologue.textBox.checkKey = function (input, evnt)
{
	var key = 0;
	var vkey = false;
	var tgt = null;
	var format = input.attributes.getNamedItem('format').value;
	
	var keyInfo = getKeyInfo(evnt);
	
	key = keyInfo.key;
	tgt = keyInfo.tgt;
	vkey = keyInfo.vkey;

	if (vkey==false && key!=8)
	{
		
		var decimal_char = Number.decimalChar();
		if (Prologue.textBox.formats[format])
			var re = Prologue.textBox.formats[format].key;
		else
			var re = new RegExp(input.attributes.getNamedItem('key').value);
		
		switch (format)
		{
			//case 'integer' :
			case Prologue.textBox.formats.integer.name :
				if (!re.test(String.fromCharCode(key)))
					key=0;
				else
				{
					if (key==45)  //Minus sign
					{
						if (tgt.value.indexOf('-')!=-1)
							key=0; //Already Exists
						else
							SetCaretTo(tgt, 0);
					}
				}
				break;
				
			case Prologue.textBox.formats.udecimal.name :
				if (!re.test(String.fromCharCode(key)))
					key=0;
				else if (key==decimal_char.charCodeAt(0) && tgt.value.indexOf(decimal_char)!=-1)
					key=0;
				break;
				
			case Prologue.textBox.formats.decimal.name :
				if (!re.test(String.fromCharCode(key)))
					key=0;
				else if (key==decimal_char.charCodeAt(0) && tgt.value.indexOf(decimal_char)!=-1) 
					key=0;
				else
				{
					if (key==45) //Minus sign
					{ 
						if (tgt.value.indexOf("-")!=-1)
							key=0; //Already Exists
						else
							SetCaretTo(tgt, 0);
					}
				}
				break;
				
			case Prologue.textBox.formats.email.name :
				if (re.test(String.fromCharCode(key))==false)
					key=0;
				else if (key==64 && tgt.value.indexOf('@')!=-1)
					key=0;
				break;

			default:
				if (!re.test(String.fromCharCode(key)))
					key=0;
				break;
		}
	}
			
	return (key!=0);
};

Prologue.textBox.checkFormat = function (input)
{
	var CheckOk=true;
		
	var caseMode = parseInt(input.attributes.getNamedItem('caseMode').value);
	switch (caseMode)
	{
	
		case Prologue.textBox.caseMode.lower:
			var curValue = input.value;
			input.value = curValue.toLowerCase();
			break;
			
		case Prologue.textBox.caseMode.upper:
			var curValue = input.value;
			input.value = curValue.toUpperCase();
			break;
			
		case Prologue.textBox.caseMode.firstUpper:
		case Prologue.textBox.caseMode.name:	
			var curValue = input.value;
			var ma = curValue.match(/(\W*)(\w*)(\W*)/g);
			var first = true;
			curValue='';
			for (var t=0; t<ma.length; t++) {
				var sub = ma[t].match(/(\W*)(\w*)(\W*)/);
				curValue+=sub[1];
				if (caseMode==Prologue.textBox.caseMode.firstUpper || first==true)
					curValue+=sub[2].substr(0,1).toUpperCase()+sub[2].substr(1).toLowerCase();
				else
					curValue+=sub[2].toLowerCase();
				curValue+=sub[3];
				first=false;
			}
			input.value=curValue;
			break;

		case 'default':
			break;
	}
	
	var trim = parseInt(input.attributes.getNamedItem('trim').value);
	switch (trim)
	{
	
		case Prologue.textBox.trimMode.both:
		case Prologue.textBox.trimMode.left:
			var curValue = input.value;
			curValue = curValue.replace(/(\s*)(.*)/, "$2");
			input.value = curValue;
			if (trim != Prologue.textBox.trimMode.both) break;
			
		case Prologue.textBox.trimMode.right:
			var curValue = input.value;
			curValue = curValue.replace(/(.*?)\s*$/, "$1");
			input.value = curValue;
			break;
			
		case 'default':
			break;
	}

	var format = input.attributes.getNamedItem('format').value;
	if (Prologue.textBox.formats[format]) {
		if (format == Prologue.textBox.formats.date.name)
		{
			CheckOk = false;
			if(Prologue.textBox.formats[format].validate.test(input.value))
			{		
				var arrayDate = input.value.split(RegExp.$1);
				if (arrayDate[0].substring(0,1)=='0')
					arrayDate[0]=arrayDate[0].substring(2,1);
					
				var intDay = parseInt(arrayDate[0]);
				if (arrayDate[1].substring(0,1)=='0')
					arrayDate[1]=arrayDate[1].substring(2,1);
					
				var intMonth = parseInt(arrayDate[1]);
				if (arrayDate[2].substring(0,1)=='0')
					arrayDate[2]=arrayDate[2].substring(2,1);
					
				var intYear = parseInt(arrayDate[2]);
				
				if (intYear<100)
				{
					if (intYear<60)
						intYear+=2000;
					else
						intYear+=1900;
				}
	
				if (intMonth > 0 && intMonth < 13)
				{
					var arMonth = new Array(31,0,31,30,31,30,31,31,30,31,30,31);
	
					if(arMonth[intMonth-1] != 0)
					{
						if(intDay <= arMonth[intMonth-1] && intDay != 0)
							CheckOk = true;
					}
					else
					{
						var booLeapYear = (intYear % 4 == 0 && (intYear % 100 != 0 || intYear % 400 == 0));
						if( ((booLeapYear && intDay <= 29) || (!booLeapYear && intDay <=28)) && intDay !=0)
							CheckOk = true;
					}
				}
			}
		}
		else 
			CheckOk=Prologue.textBox.formats[format].validate.test(input.value);
	}
	else {
		var re = new RegExp(input.attributes.getNamedItem('validate').value);
		CheckOk=re.test(input.value);
	}

	return (CheckOk);
};

///////////////////////////
/// imageTextBox Object ///
///////////////////////////
// pour combo avec Image et affichage de l'image choisie à la place du textbox
Prologue.imageTextBox = function(id, patern, valpatern)
{
	this.className = 'prlImageTextBox';
	this.divId = id; // le id est regénéré par le constructeur de base
	this.patern = patern;
	this.valpatern = valpatern;
	Prologue.imageTextBox.callBaseConstructor(id, 'any', '', 'Prologue.combo.inputUpdate(this);');
}
Prologue.imageTextBox.extend(Prologue.textBox);

Prologue.imageTextBox.updateImage = function(obj, divid, patern, valpatern, table)
{
	var val = Prologue.list.getSelected(obj).value;
	Prologue.combo.result(Prologue.list.getSelected(obj).caption, val, table);
	if(val!='none' && val!='')
	{
		var reg = new RegExp('('+valpatern+')', 'g');
		var imgsrc = patern.replace(reg, val);
		$(divid).innerHTML = "<img src='"+imgsrc+"' style='margin-top:1px;margin-bottom:2px;'/>";
	}
	else if(val=='none')
		$(divid).innerHTML = '&nbsp;';
	else
		$(divid).innerHTML = '&nbsp;-';
}

Prologue.imageTextBox.prototype.html = function ()
{
	var tmpstyle = ' style="';
	if (this.width != '')
		tmpstyle += 'width:'+this.width+';';
	else
		tmpstyle += 'width:280px;';
	tmpstyle += '"';
		
	if(this.value!="" && this.value!="-" && this.value!=lang_lbl_aucun)
	{
		var reg = new RegExp('('+this.valpatern+')', 'g');
		var imgsrc = this.patern.replace(reg, this.value);
		return "<div "+tmpstyle+" id='"+this.divId+"'><img src='"+imgsrc+"'/></div>";
	}
	else if(this.value=="")
		return "<div "+tmpstyle+" id='"+this.divId+"'>&nbsp;</div>";
	else
		return "<div "+tmpstyle+" id='"+this.divId+"'>&nbsp;-</div>";
}

///////////////////////////
/// Combo Object ///
///////////////////////////
Prologue.combo = function(value, onClick)
{
	Prologue.combo.callBaseConstructor(this, '', 'prlCombo', '', onClick);
	this.value = (typeof value != 'undefined')?value:'';
	this.caption = '';
	this.icon = Prologue.framework.images;
	this.dropDown = new Prologue.dropDown();
	this.readOnly = false;
	this.editable = true;
	this.width = this.defaultWidth+'px';
	this.onDropDown = '';
	this.hiddenValue = '';
	this.dataSource='';
	this.textBox = new Prologue.textBox('', 'any', '', 'Prologue.combo.inputUpdate(this);');
	
	// en cas d'erreur on remet la valeur precedente de l'input cache dans le textbox
	var onError = 'var inputHidden = this.parentNode.childNodes[2];';		//Sous IE des balises #text peuvent s'inserer entre les input et le div
	onError += ' while(inputHidden.nodeName!=\'INPUT\') {inputHidden = inputHidden.nextSibling;}';
	onError += ' this.value = inputHidden.value;';
	this.textBox.onError = onError;
};
Prologue.combo.extend(Prologue.control);

Prologue.combo.prototype.html = function ()
{
 //le onClick est attribué au onChange puis onClick est remis a blanc pour ne pas etre utilise par attibutes()
	var onChange = this.onClick;
	this.onClick = '';
	if(!this.caption)
		this.caption = this.value;
	this.textBox.value = this.caption;
	this.textBox.id = '';
	
//si une combo est readOnly alors elle n'est pas editable non plus !
	if(this.readOnly)
		this.editable = false;
	
	this.textBox.readOnly = !(this.editable);
	this.hiddenValue = this.value;
	
	var tmp = '<table border="0" summary="" cellpadding="0" cellspacing="0" dataSource="'+this.dataSource+'" '+this.attributes();
	if(this.readOnly)
		tmp += ' onmousedown="return false;"';
	else if(!this.editable)	//si une combo n'est pas editable on place le onClick sur toute la table de la combo sinon seulement sur le td bouton
		tmp += ' onmousedown="'+this.onDropDown+'Prologue.combo.open(this);event.cancelBubble=true;"';
	tmp += ' style="width:'+this.width+';"><tr>';
	tmp += '<td class="prlInput">';
	this.textBox.width = this.width;
	tmp += this.textBox.html();
	tmp += this.dropDown.html();
	tmp += '<input type="hidden" name="'+this.id+'" value="'+this.hiddenValue+'" onchange="'+onChange+'"/>';
	tmp += '</td>';
	tmp += '<td class="prlButtonUp"';
	tmp += ' onmousedown ="Prologue.combo.img(this, true);';
	if(this.editable)	//si une combo est editable on place le onclick seulement sur le td du bouton et pas a la table entiere
		tmp += ' '+this.onDropDown+'Prologue.combo.open(this.parentNode.parentNode.parentNode);event.cancelBubble=true;';
	tmp += '"';
	tmp += ' onmouseup="Prologue.combo.img(this, false);"';
	tmp += ' onmouseout="if(!this.contains(event.toElement))this.onmouseup();"';
	tmp += '><img src="'+this.icon+'/combo.gif"/></td>';
	tmp += '</tr></table>';
	
	return tmp;
};

Prologue.combo.keydown = function()
{
	if (window.currentCombo)
	{
		var keyinfo = getKeyInfo(window.event);
		
		if(keyinfo.key==27) // Esc
		{
			Prologue.combo.open(window.currentCombo);
			return false;
		}
		else if(keyinfo.key==13) // Enter
		{
			Prologue.combo.open(window.currentCombo);
			return false;
		}
		
		var attr = window.currentCombo.attributes.getNamedItem('objectExt');
		if(attr && attr.value!='')
		{
			var obj = eval(attr.value); // transforme le text en instance d'objet
			if(obj && obj.keydown)
			{
				window.currentCombo.keepOpen = true;
				return obj.keydown.call(this, keyinfo); // binding vers la fonction keydown de l'objet dérivé
			}
		}
	}
	return true; // sinon on propage l'evènement
};

//fonction qui ouvre ou ferme la combo : fait apparaitre le dropDown div en calculant sa position,
//ou le fait disparaitre si une combo est deja ouverte
Prologue.combo.open = function (table)
{
	if (window.currentCombo) // une combo est deja ouverte => on la ferme
	{
		var needBreak = (window.currentCombo===table);
		var div = window.currentCombo.rows[0].cells[0].childNodes[1];		//Sous IE une balise #text change la localisation du div
		while (div.nodeName!='DIV')
			div = div.nextSibling;
		div.style.visibility = 'hidden';
		div.style.overflow = 'hidden';
		document.detachEvent('onmousedown', Prologue.combo.open);
		document.detachEvent('onkeydown', Prologue.combo.keydown);
		window.currentCombo = null;
		if (needBreak) return;
	}
	if (!window.currentCombo && table && table.nodeName && table.nodeName=='TABLE') // il n'y a pas de combo deja ouverte
	{
		var td = table.rows[0].cells[0];
		var div = td.childNodes[1];			//Sous IE une balise #text change la localisation du div
		while (div.nodeName!='DIV')
			div = div.nextSibling;
		var divPosition = { 'top':'0', 'left':'0'};
	
		//si div depasse en bas => positionner au dessus de la Prologue.combo
		if(Prologue.ui.clientToScreen(table).top + table.offsetHeight + div.offsetHeight - document.body.scrollTop > document.body.clientHeight)
			if(Prologue.ui.clientToScreen(table).top - div.offsetHeight > 0)
				divPosition.top = (parseInt(Prologue.ui.clientToScreen(table).top, 10) - parseInt(div.offsetHeight, 10));
			else{
				// le div depasse en haut et en bas
				var topHeight = parseInt(Prologue.ui.clientToScreen(table).top, 10);
				var bottomHeight = document.body.clientHeight - (parseInt(Prologue.ui.clientToScreen(table).top, 10) + parseInt(table.offsetHeight, 10));
				// S'il y a plus de place au dessus
				if (topHeight > bottomHeight){
					// On positionne au dessus avec la taille max					
					Prologue.ui.setHeight(div, topHeight);
					divPosition.top = 0;
				}else{ 
					// On positionne au dessous avec la taille max					
					Prologue.ui.setHeight(div, bottomHeight);
					divPosition.top = (parseInt(Prologue.ui.clientToScreen(table).top, 10) + parseInt(table.offsetHeight, 10));
				}
			}
		else 
			divPosition.top = (parseInt(Prologue.ui.clientToScreen(table).top, 10) + parseInt(table.offsetHeight, 10));
		
		if(!div.style.width || div.offsetWidth < table.offsetWidth)
			Prologue.ui.setWidth(div, table.offsetWidth);
		
		//si div depasse a droite => positionner a gauche de la Prologue.combo
		if(Prologue.ui.clientToScreen(table).left + div.offsetWidth - document.documentElement.scrollLeft > document.body.clientWidth)
			divPosition.left = (parseInt(Prologue.ui.clientToScreen(table).left, 10) - (parseInt(div.offsetWidth, 10) - parseInt(table.offsetWidth, 10)));
		else
			divPosition.left = parseInt(Prologue.ui.clientToScreen(table).left, 10);

		if (!Prologue.browser.ie)
			Prologue.ui.screenToClient(div, divPosition);

		Prologue.ui.moveTo(div, divPosition);
		div.style.visibility = 'visible';
		div.style.overflow = 'auto';
		
		document.attachEvent('onmousedown', Prologue.combo.open);
		document.attachEvent('onkeydown', Prologue.combo.keydown);
		
		window.currentCombo = table;		
	}
};

//fonction qui change l'apparence du bouton :  �tat enfonc� (open == true) ou normal (open == false)
Prologue.combo.img = function (td, open)
{
	if (open)
		td.className = 'prlButtonDown';
	else
		td.className = 'prlButtonUp';
};

//fonction qui met a jour la valeur cachee de la combo (input hidden) : soit table est value (table d'une combo)
//soit la fonction utilise window.currentCombo (la combo actuellement ouverte).
//onClick (booleen) : si vrai (valeur par defaut) on execute le onClick de la combo une fois la valeur changee,
//si faux, on change la valeur sans declencher le onClick de la combo.
Prologue.combo.result = function (caption, value, table, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (window.currentCombo || table)
	{
		var closeCombo = false;
		if(!table) {
			table = window.currentCombo;
			if(window.currentCombo.keepOpen!=true)
				closeCombo = true;
			else
				window.currentCombo.keepOpen = false;
		}
		
		var td = table.rows[0].cells[0];
		var inputText = td.firstChild;
		var inputHidden = td.childNodes[2];		//Sous IE une balise #text change la localisation de l'input
		while (inputHidden.nodeName!='INPUT')
		{
			inputHidden = inputHidden.nextSibling;
		}
		inputText.value = (typeof caption != 'undefined')?caption:'';
		
		if(closeCombo)
			Prologue.combo.open(table);
			
		var newHiddenValue = (typeof value != 'undefined')?value:'';
		if (inputHidden.value != newHiddenValue)
		{
			inputHidden.value = newHiddenValue;
			if(onClick)
				inputHidden.onchange();
		}
	}
};

//fonction qui met a jour l'input cache a partir du textbox de la combo
Prologue.combo.inputUpdate = function (inputText)
{
	var inputHidden = inputText.nextSibling.nextSibling;	//Sous IE une balise #text change la localisation de l'input
	while (inputHidden.nodeName!='INPUT')
		inputHidden = inputHidden.nextSibling;
	
	if (inputHidden.value != inputText.value) // si la valeur de l'input a change, on la remplace et on fire son onchange
	{
		inputHidden.value = inputText.value;
		inputHidden.onchange();
	}
};
///////////////////////////////
/// DropDown Object ///
///////////////////////////////
Prologue.dropDown = function(width, height)
{	
	this.height = height||0;
	this.width = width||0;
	this.content = '';
	this.className = 'prlDropDown';
};

Prologue.dropDown.prototype.html = function()
{		
		var tmp = '<div class="'+this.className+'" onmousedown="event.cancelBubble=true;return false;"';
		if(this.height || this.width)
		{
			tmp += ' style="';
			if(this.height > 0) tmp += 'height:'+this.height+'px;';
			if(this.width > 0) tmp += 'width:'+this.width+'px;';
			tmp += 'overflow:hidden;"';
		}
		tmp += '>';
		tmp += this.content+'</div>';
		
		return tmp;
};
/////////////////////////////
/// listItemObject ///
/////////////////////////////
Prologue.listItem = function(caption, icon, onClick, value)
{
	Prologue.listItem.callBaseConstructor(this, caption, icon);
	this.onClick = onClick||'';
	this.value = value||'';
	this.selected = false;
};
Prologue.listItem.extend(Prologue.item);

Prologue.listItem.prototype.bind = function(datasourceNode)
{
	if (datasourceNode && datasourceNode.attributes)
	{
		for (var a=0; a<datasourceNode.attributes.length; a++)
		{
			var atb = datasourceNode.attributes[a];
			switch (typeof this[atb.name])
			{
				case 'boolean':
					this[atb.name]=new Boolean(atb.value);
					break;
				case 'number':
					this[atb.name]=new Number(atb.value, 10);
					break;
				case 'undefined':
					break;					
				default:
					this[atb.name]=atb.value;
					break;
			}
		}
	}
};

Prologue.listItem.prototype.html = function()
{
	var toolTip = this.toolTip;
	this.toolTip = '';
	var tmp = '<td class="'+((this.selected)?'prlRowSelected':'prlRow')+'" prlSelected="'+((this.selected)?'1':'0')+'" prlValue="'+this.value+'"';
	tmp += ' onmouseover="this.className=\'prlRowOver\';"';
	tmp += ' onmousedown="this.className=\'prlRowDown\';"';
	tmp += ' onmouseup="this.onmouseover();"';
	tmp += ' onmouseout="this.className=((this.attributes.getNamedItem(\'prlSelected\').value==\'1\')?\'prlRowSelected\':\'prlRow\');"';
	tmp += ' onclick="'+this.onClick+'"';
	if (toolTip) tmp += ' title="'+toolTip+'"';
	tmp += '>';
	tmp += Prologue.listItem.callBaseMethod(this, 'html');
	tmp += '</td>';
	return tmp;
};

Prologue.listItem.prototype.createElement = function(use_function_for_event)
{
	var td = document.createElement('td');
	var toolTip = this.toolTip;
	this.toolTip = '';
	td.className = (this.selected)?'prlRowSelected':'prlRow';
	td.setAttribute("prlSelected",((this.selected)?'1':'0'));
	td.setAttribute("prlValue",this.value);
	
	if (use_function_for_event)
	{
		td.onmouseover = function() { this.className='prlRowOver';}; 
		td.onmouseout = function() { this.className=((this.attributes.getNamedItem('prlSelected').value=='1')?'prlRowSelected':'prlRow');}; 
		td.onmousedown = function() { this.className='prlRowDown';}; 
		td.onmouseup = function() { this.onmouseover();}; 
	}
	else
	{
		td.setAttribute('onmouseover',"this.className=\'prlRowOver\'");
		td.setAttribute('onmousedown',"this.className=\'prlRowDown\'");
		td.setAttribute('onmouseup',"this.onmouseover()");
		td.setAttribute('onmouseout',"this.className=((this.attributes.getNamedItem(\'prlSelected\').value==\'1\')?\'prlRowSelected\':\'prlRow\')");
	}
	td.setAttribute('onclick',this.onClick);
	if (toolTip) td.setAttribute("title",toolTip);
	td.innerHTML = Prologue.listItem.callBaseMethod(this, 'html');
	
	return td;
};

////////////////////////////////////////////
/// ListItemCollection Object ///
////////////////////////////////////////////
Prologue.listItemCollection = function()
{
	Prologue.listItemCollection.callBaseConstructor(this);
};
Prologue.listItemCollection.extend(Prologue.collection);

Prologue.listItemCollection.prototype.add = function(caption, icon, onClick, value)
{
	var pos = this.items.length;
	this.items[pos] = new Prologue.listItem(caption, icon, onClick, value);
	return this.items[pos];
};

Prologue.listItemCollection.prototype.html = function()
{
	var tmp = '';
	for (var c=0; c<this.count(); c++)
		tmp += '<tr onclick="Prologue.list.click(this);">' + this.items[c].html() + '</tr>';
	return tmp;
};

Prologue.listItemCollection.prototype.bind = function(xRoot)
{
	for (var pRow=0; pRow<xRoot.childNodes.length; pRow++)
	{
		var row = xRoot.childNodes[pRow];
		var li = new Prologue.listItem();
		li.bind(row.firstChild);
		this.items.push(li);
	}
};

/////////////////////////
/// list Object ///
/////////////////////////
Prologue.list = function(id, onClick, className)
{
	Prologue.list.callBaseConstructor(this, id, (className||'prlList'), '', onClick);
	this.items = new Prologue.listItemCollection();
	this.value = '';
	this.dataSource = '';
};
Prologue.list.extend(Prologue.control);

Prologue.list.prototype.add = function(caption, icon, onClick, value)
{
	return this.items.add(caption, icon, onClick, value);
};

Prologue.list.prototype.count = function()
{
	return this.items.count();
};

Prologue.list.prototype.load = function()
{
	var ret = false;
	if (this.dataSource)
	{
		var req = new Prologue.ajax.request(this.dataSource);
		req.send();
		var resp = req.getXML();
		if (resp)
		{
			var xRoot = resp.documentElement;
			if(xRoot)
				this.items.bind(xRoot);
			return true;
		}
	}
	return ret;
};

Prologue.list.reload = function(list, dataSource)
{
	var ret = false;
	if (typeof list == 'string')
		list = document.getElementById(list);
	if (list && dataSource)
	{
		var onclick = '';
		if (list.onclick) {
			var buffer = list.onclick.toString().replace(/[\r\n]/g,'');
			var rx = new RegExp(/\{(.*)\}/g);
			onclick = rx.exec(buffer)[1];
			onclick = onclick.replace(/"/g, '\'');
		}		
		var lst = new Prologue.list(list.id, onclick, list.className);
		lst.dataSource = dataSource;
		list.insertAdjacentHTML('afterend', lst.html());
		list.removeNode(true);
		ret=true;
	}
	return ret;
};

Prologue.list.prototype.html = function()
{
	if (this.dataSource) this.load();
	if (this.value.length>0)
	{
		for (var pRow=0; pRow<this.items.count(); pRow++)
		{
			if (this.items.item(pRow).value == this.value)
			{
				this.items.item(pRow).selected=true;
				break;
			}
		}
	}
	var tmp = '<table summary=""'+this.attributes()+' cellspacing="0" cellpadding="2">';
	tmp += this.items.html();
	tmp += '</table>';
	return tmp;
};

Prologue.list.click = function(tr)
{
	var tbl = tr.parentNode.parentNode;
	if (tbl)
	{
		var curRow = Prologue.list.getSelected(tbl).index;
		if (curRow>=0)
		{
			var row = tbl.rows[curRow];
			row.cells[0].attributes.getNamedItem('prlSelected').value = '0';
			row.cells[0].className = 'prlRow';
		}
		tr.cells[0].attributes.getNamedItem('prlSelected').value = '1';
		tr.cells[0].className = 'prlRowSelected';
	}
};

Prologue.list.getSelected = function(table)
{
	var itm = 
	{
		'caption':'',
		'value':'',
		'index':-1,
		'toString':function(){return this.index;}
	};
	if (typeof table == 'string') table = document.getElementById(table);
	if (table && table.nodeName=='TABLE')
	{
		for (var r=0; r < table.rows.length; r++)
		{
			var row = table.rows[r];
			if (row.cells[0].attributes.getNamedItem('prlSelected').value == '1')
			{
				var pItm = Prologue.item.getItem(row.cells[0].firstChild);
				itm.caption = pItm.caption;
				itm.value = row.cells[0].attributes.getNamedItem('prlValue').value;
				itm.index = r;
				break;
			}
		}
	}
	return itm;
};

Prologue.list.scrollToElement = function(list, item)
{
	// scrolling de la liste si nécessaire pour que l'item soit visible
	var h = list.scrollTop + list.offsetHeight;
	if(item.offsetTop>h || item.offsetTop+item.offsetHeight>h || item.offsetTop<list.scrollTop)
		list.scrollTop = item.offsetTop - list.offsetTop;
};

/**
 * Obsolete utilisez selectByIndex.
 * @deprecated
 */
Prologue.list.selectRowByIndex = function(list, index)
{
	return Prologue.list.selectByIndex(list, index);
}
Prologue.list.selectByIndex = function(list, index)
{
	var ret = false;
	if (typeof list == 'string') list = document.getElementById(list);
	if (list && list.nodeName=='TABLE' && index < list.rows.length)
	{
		if (index>=0)
		{
			var tr = list.rows[index];
			Prologue.list.scrollToElement(list.parentNode, tr);
			tr.onclick();
			if (list.onclick) list.onclick();
			ret = true;
		}
		else //deselection de la ligne courante
		{		
			var curRow = Prologue.list.getSelected(list).index;
			if (curRow>=0)
			{
				var row = list.rows[curRow];
				row.cells[0].attributes.getNamedItem('prlSelected').value = '0';
				row.cells[0].className = 'prlRow';
				if (list.onclick) list.onclick();
			}
		}
	}
	return ret;
};

/**
 * Obsolete utilisez selectByValue.
 * @deprecated
 */
Prologue.list.selectRowByValue = function(list, value)
{
	return Prologue.list.selectByValue(list, value);
}
Prologue.list.selectByValue = function(list, value)
{
	var ret = false;
	if (typeof value != 'undefined')
	{
		if (typeof list == 'string') list = document.getElementById(list);
		if (list && list.nodeName=='TABLE')
		{
			for (var r=0; r<list.rows.length; r++)
			{
				var tr = list.rows[r];
				if (tr.cells[0].attributes.prlValue.value == value)
				{
					Prologue.list.scrollToElement(list.parentNode, tr);
					tr.onclick();
					if (list.onclick) list.onclick();
					ret = true;
					break;
				}
			}
		}
	}
	return ret;
};

Prologue.list.selectByLikeValue = function(list, value, selected)
{
	var ret = false;
	if (typeof value != 'undefined')
	{
		if (typeof list == 'string') list = document.getElementById(list);
		if (list && list.nodeName=='TABLE')
		{
			if (value == String.fromCharCode(13))
			{
				if (list.onclick) list.onclick();
			} else {
			
				var ffound = '';
				var away = true;
				var tr = '';
				for (var r=0; r<list.rows.length; r++)
				{
					tr = list.rows[r];
					var tmp = '';
					if (tr.cells[0].textContent)
					{	
						tmp = tr.cells[0].textContent.substr(0,1); // for moz
					}
					else if(tr.firstChild.innerText)
					{	
						tmp = tr.firstChild.innerText.substr(0,1); // for i.e.
					}
					if (tmp.toLowerCase() == value.toLowerCase())
					{
						if (selected.caption.substr(0,1).toLowerCase() == value.toLowerCase() && away  == true)
						{
							if (ffound == '') ffound = r;
							if (selected.value == tr.cells[0].attributes.prlValue.value)
							{
								away = false;
								if (r == (list.rows.length - 1))
								{
									tr = list.rows[ffound];
									tr.onclick();
									ret = true;
									break;	
								}
							} else {
								away = true;
							}
						} else {
							tr.onclick();
							ret = true;
							break;
						}	
					} else {
						if (r == (list.rows.length - 1) && away == false)
						{
							tr = list.rows[ffound];
							tr.onclick();
							ret = true;
							break;	
						}
					}
				}
				if(ret)
				{
					Prologue.list.scrollToElement(list.parentNode, tr);
				}
			}	
		}
	}
	return ret;
};

Prologue.list.keydown = function(list, keyinfo)
{
	var bContinue = true;
	var sel = Prologue.list.getSelected(list);
	var max = list.rows.length - 1;
	switch(keyinfo.key)
	{
		case 33: // pgup
			var nb = Math.floor(list.parentNode.clientHeight / list.rows[0].offsetHeight);
			var index = sel.index - nb;
			if(index<0)
				index = 0;
			Prologue.list.selectByIndex(list, index);
			bContinue = false;
			break;
		case 34: // pgdn
			var nb = Math.floor(list.parentNode.clientHeight / list.rows[0].offsetHeight);
			var index = sel.index + nb;
			if(index>max)
				index = max;
			Prologue.list.selectByIndex(list, index);
			bContinue = false;
			break;
		case 35: // fin
			Prologue.list.selectByIndex(list, max);
			bContinue = false;
			break;
		case 36: // début
			Prologue.list.selectByIndex(list, 0);
			bContinue = false;
			break;
		case 37: // gauche
		case 38: // haut
			var index = sel.index - 1;
			if(index<0)
				index = 0;
			Prologue.list.selectByIndex(list, index);
			bContinue = false;
			break;
		case 39: // droite
		case 40: // bas
			var index = sel.index + 1;
			if(index>max)
				index = max;
			Prologue.list.selectByIndex(list, index);
			bContinue = false;
			break;
		default:
			ret = String.fromCharCode(keyinfo.key);
			var selected = Prologue.list.getSelected(list);
			Prologue.list.selectByLikeValue(list, ret, selected);
			bContinue = false;
			break;
	}
	if(!bContinue)
		Prologue.ui.stopEvent(); // pour éviter le décallage haut/bas de la fenêtre
		
	return bContinue;
};

////////////////////////////////
/// ComboList Object ///
////////////////////////////////
Prologue.comboList = function(id, value, onClick, className)
{
	Prologue.comboList.callBaseConstructor(this, value, onClick);
	this.id = id||'';
	this.className = (className||'prlCombo');
	this.dropDown.width = 220;
	this.list = new Prologue.list('list'+id);
	this.list.onClick = 'Prologue.combo.result(Prologue.list.getSelected(this).caption, Prologue.list.getSelected(this).value);';
	this.editable = false;
    this.loadOnDropDown = false;
	this.objectExt = 'Prologue.comboList';
};
Prologue.comboList.extend(Prologue.combo);

Prologue.comboList.keydown = function(keyinfo)
{
	if (window.currentCombo) 
	{
		var list = Prologue.comboList.getListTable(window.currentCombo);
		return Prologue.list.keydown(list, keyinfo);
	}
	return true;
}

Prologue.comboList.prototype.attributes = function()
{
	var tmp = Prologue.comboList.callBaseMethod(this, 'attributes');
	tmp += ' objectExt="'+this.objectExt+'"';
	return tmp;
};

Prologue.comboList.prototype.add = function(caption, icon, onClick, value)
{
	return this.list.add(caption, icon, onClick, value);
};

Prologue.comboList.prototype.count = function()
{
	return this.list.count();
};

Prologue.comboList.prototype.html = function ()
{	
    if (this.loadOnDropDown)
    {
        this.list.dataSource = '<?xml version="1.0" encoding="UTF-8"?><databind>';
        this.list.dataSource += '<row><item caption="-" value=""/></row>';
        if ((this.caption.length) && (this.value.length))
            this.list.dataSource += '<row><item caption="'+this.caption+'" value="'+this.value+'"/></row>';
        this.list.dataSource += '</databind>';
    }
    else
    {
        this.list.dataSource = this.dataSource;
    }
	this.list.load();
	this.list.dataSource = ''; //On ne veut pas que la dataSource soit rechargee lors du html()
	//this.dataSource = '';

	var hasFound = false;
	for(var i = 0; i < this.list.items.count(); ++i)
	{
		if(this.list.items.item(i).value == this.value)
		{
			hasFound = true;
			this.caption = this.list.items.item(i).caption;
			this.value = this.list.items.item(i).value;
			this.list.items.item(i).selected = true;
			break;
		}
	}	
		
	//Si on a pas trouve l'element de la liste correspondant a this.value,
	//on selectionne le premier element de la liste (s'il en existe)
	if(!this.editable && !hasFound && typeof this.list.items.item(0) != 'undefined')
	{
		this.caption = this.list.items.item(0).caption;
		this.value = this.list.items.item(0).value;
		this.list.items.item(0).selected=true;
	}
	this.list.value = this.value;	
	this.dropDown.content = this.list.html();
	
    if (this.loadOnDropDown)
    {
        var ddF='var tableCombo = ((this.nodeName ==\'TD\')?this.parentNode.parentNode.parentNode:this);';
        ddF+='var ds = tableCombo.getAttribute(\'dataSource\');';
        ddF+='var cb = document.getElementById(tableCombo.id);';
        ddF+='var val = Prologue.comboList.getSelected(cb).value;';
        ddF+='var ret = Prologue.list.reload(Prologue.comboList.getListTable(cb), ds);';
        ddF+='if(ret) { if (val) Prologue.comboList.selectByValue(cb, val);';
        ddF+='          else Prologue.comboList.selectByIndex(cb,0,true);}';
        ddF+='tableCombo.setAttribute(\'dataSource\',\'\');';
        this.onDropDown=ddF;    
    }
	else
	{
	   this.dataSource = '';
	}
	return Prologue.comboList.callBaseMethod(this, 'html');
};

Prologue.comboList.getSelected = function(comboList)
{
	var itm = Prologue.list.getSelected(Prologue.comboList.getListTable(comboList));
	var cb = document.getElementById(comboList);
	if (cb){
		var td = cb.rows[0].cells[0];
		var inputText = td.firstChild;
		var inputHidden = td.childNodes[2];		//Sous IE une balise #text change la localisation de l'input
		while(inputHidden.nodeName!='INPUT') {inputHidden = inputHidden.nextSibling;};
		if (itm.value != inputHidden.value)
		{
			itm.value = inputHidden.value;
			itm.caption = inputHidden.value;
		}
	}
	return itm; 
};

/**
 * Obsolète utilisez selectByIndex.
 * @deprecated
 */
Prologue.comboList.selectRowByIndex = function(comboList, index, onClick)
{
	return Prologue.comboList.selectByIndex(comboList, index, onClick);
}

Prologue.comboList.selectByIndex = function(comboList, index, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboList == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboList = document.getElementById(comboList);
		
	var listTable = Prologue.comboList.getListTable(comboList);	
	var ret = Prologue.list.selectByIndex(listTable, index);
	
	var selected = Prologue.list.getSelected(listTable);
	Prologue.combo.result(selected.caption, selected.value, comboList, onClick);
	return ret;
};

/**
 * Obsolète utilisez selectByValue.
 * @deprecated
 */
Prologue.comboList.selectRowByValue = function(comboList, value, onClick)
{
	return Prologue.comboList.selectByValue (comboList, value, onClick);	
}

Prologue.comboList.selectByValue = function(comboList, value, onClick)
{	
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboList == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboList = document.getElementById(comboList);
		
	var listTable = Prologue.comboList.getListTable(comboList);	
	var ret = Prologue.list.selectByValue(listTable, value);
	
	var selected = Prologue.list.getSelected(listTable);
	Prologue.combo.result(selected.caption, selected.value, comboList, onClick);
	return ret;
};

Prologue.comboList.selectByLikeValue = function(comboList, value, onClick)
{	
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboList == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboList = document.getElementById(comboList);
		
	var listTable = Prologue.comboList.getListTable(comboList);	
	
	var selected = Prologue.list.getSelected(listTable);
	var ret = Prologue.list.selectByLikeValue(listTable, value, selected);
	
	var selected = Prologue.list.getSelected(listTable);
	Prologue.combo.result(selected.caption, selected.value, comboList, onClick);
	return ret;
};

Prologue.comboList.reload = function(comboList, dataSource, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboList == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboList = document.getElementById(comboList);
		
	var ret = Prologue.list.reload(Prologue.comboList.getListTable(comboList), dataSource);
	
	if(ret)
		Prologue.combo.result('', '', comboList, onClick);
	return ret;
};

Prologue.comboList.getListTable = function (table)
{
	if (typeof table == 'string')
		table = document.getElementById(table);
	
	if (table) {
		var dropDownDiv = table.rows[0].cells[0].childNodes[1];
		while (dropDownDiv.nodeName!='DIV')
			dropDownDiv = dropDownDiv.nextSibling;
			
		return dropDownDiv.firstChild;
	}
	return null;
};

///////////////////////
/// comboImage Object ///
///////////////////////
Prologue.comboImage = function(id, value, patern, valpatern)
{
	this.className = 'prlComboImage';
	this.divId = 'img_'+id;
	this.patern = patern;
	this.valpatern = valpatern;
	Prologue.comboImage.callBaseConstructor(this, id, value);
	this.textBox = new Prologue.imageTextBox(this.divId, patern, valpatern);
	this.list.onClick = "Prologue.imageTextBox.updateImage(this, '"+this.divId+"', '"+patern+"', '"+valpatern+"')";
	this.objectExt = 'Prologue.comboImage';
}
Prologue.comboImage.extend(Prologue.comboList);

Prologue.comboImage.prototype.attributes = function()
{
	var tmp = Prologue.comboImage.callBaseMethod(this, 'attributes');
	tmp += ' divId="'+this.divId+'"';
	tmp += ' patern="'+this.patern+'"';
	tmp += ' valpatern="'+this.valpatern+'"';
	return tmp;
};

Prologue.comboImage.keydown = function(keyinfo)
{
	if(window.currentCombo)
	{
		var bRet = Prologue.comboList.keydown(keyinfo);
		var list = Prologue.comboList.getListTable(window.currentCombo);
		var divId = window.currentCombo.attributes.getNamedItem('divId');
		var patern = window.currentCombo.attributes.getNamedItem('patern');
		var valpatern = window.currentCombo.attributes.getNamedItem('valpatern');
		
		if(list && divId && patern && valpatern)
		{
			Prologue.imageTextBox.updateImage(list, divId.value, patern.value, valpatern.value, window.currentCombo);
		}
		return bRet;
	}
	return true;
}

///////////////////////
/// calendar Object ///
///////////////////////
Prologue.calendar = function(id, value, onClick, className)
{
	Prologue.calendar.callBaseConstructor(this, id, (className||'prlCalendar'), '', onClick);
	this.icon = Prologue.framework.images;
	this.value = value;
};
Prologue.calendar.extend(Prologue.control);

Prologue.calendar.data =
{
	'day' 	:	[ lang_calendar_lbl_lundi, lang_calendar_lbl_mardi, lang_calendar_lbl_mercredi, lang_calendar_lbl_jeudi, lang_calendar_lbl_vendredi, lang_calendar_lbl_samedi, lang_calendar_lbl_dimanche],
	'month'	:	[lang_calendar_lbl_janvier, lang_calendar_lbl_fevrier, lang_calendar_lbl_mars, lang_calendar_lbl_avril, lang_calendar_lbl_mai, lang_calendar_lbl_juin,
				 lang_calendar_lbl_juillet, lang_calendar_lbl_aout, lang_calendar_lbl_septembre, lang_calendar_lbl_octobre, lang_calendar_lbl_novembre, lang_calendar_lbl_decembre],
	'calButtons' : ['first', 'previous', 'stop', 'next', 'last'],
	'calToolTip' : [lang_calendar_lbl_prev_year, lang_calendar_lbl_prev_month, lang_calendar_lbl_today, lang_calendar_lbl_next_month, lang_calendar_lbl_next_year]
};

Prologue.calendar.prototype.html = function()
{
	var tmp = '';
	tmp += '<input type="hidden"'+((this.id)?' id="'+this.id+'" name="'+this.id+'"':'')+' value="'+this.value+'" onchange="'+this.onClick+'"/>';
	tmp += '<table summary="" title="'+this.toolTip+'" curDte="" cellspacing="0" cellpadding="0" class="'+this.className+'"';
	tmp += ' onmouseover="Prologue.calendar.mouseover(event);" onmouseout="Prologue.calendar.mouseout(event);" onclick="Prologue.calendar.mousedown(event);">';
	tmp += '<colgroup span="5" class="prlWeek"></colgroup><colgroup span="2" class="prlEnd"></colgroup>';
	tmp += '<thead><tr><td colspan="7" class="prlTitle">';
	tmp += '</td></tr>';
	tmp += '<tr class="prlDays">';
	
	for(var i = 0; i < Prologue.calendar.data.day.length; ++i)
		tmp += '<td>' + Prologue.calendar.data.day[i] + '</td>';
		
	tmp += '</tr></thead>';
	tmp += '<tbody>';
	
	for(var i = 0; i < 6; ++i)
	{
		tmp += '<tr>';
		var maxcells = ((5 == i)?2:7);
		
		for(var j = 0; j < maxcells; ++j)
			tmp += '<td></td>';

		tmp += ((5 == i)?'':'</tr>');
	}
		
	for(var i = 0; i < Prologue.calendar.data.calButtons.length; i++)
	{
		tmp += '<td class="prlCalendarButtonUp"';
		tmp += ' onmousedown ="Prologue.calendar.action(this, ' + (i - 2) + ');event.cancelBubble=true;return false;"';
		tmp += ' onmouseup="Prologue.calendar.img(this, false);"';
		tmp += ' onmouseout="if(!this.contains(event.toElement))this.onmouseup();"';
		tmp += '><img src="'+this.icon+'/' + Prologue.calendar.data.calButtons[i] + '.png" title="'+Prologue.calendar.data.calToolTip[i]+'" alt=""/></td>';	
	}
	
	tmp += '</tr></tbody>';
	tmp += '</table>';
	
	var div=document.createElement('DIV');
	div.className = this.className;
	div.innerHTML = tmp;
	Prologue.calendar.setDate(div, this.value);
	return div.outerHTML;
};

Prologue.calendar.img = function (td, open)
{
	if (open)
	{
		td.className = 'prlCalendarButtonDown';
	}
	else
	{
		td.className = 'prlCalendarButtonUp';
	}
};

Prologue.calendar.action = function(btn, act)
{
	Prologue.calendar.img(btn, true);
	var table = btn.parentNode.parentNode.parentNode;
	var dateStr = table.attributes.getNamedItem('curDte').value;
	
	var dateParam = str2Date(dateStr);
	var month = parseInt(dateParam.getMonth(),10);
	var year = parseInt(dateParam.getFullYear(),10);
	
	var newDate;
	
	if (act == 0)
	{
		var newDate = new Date();
		var input = table.parentNode.firstChild;
		input.value = date2Str(newDate);
		input.onchange();
	}
	else
	{
		switch(act)
		{
			case -2:
				year--;
				break;
			case -1:
				if (month == 0)
				{
					month=11;
					year--;
				}
				else month--;
				break;
			case 1:
				if (month == 11)
				{
					month=0;
					year++;
				}
				else month++;
				break;
			case 2:
				year++;
				break;
			default:
				break;
		}
		newDate = new Date(year, month, 1);
	}
	
	var newCurDate = date2Str(newDate);
	Prologue.calendar.setDate(table.parentNode, newCurDate);
};
	

Prologue.calendar.setSelected = function (input, date)
{
	if (typeof input == 'string')
		input = document.getElementById(input);
	
	var ret = ''
	var table = input.nextSibling;
	var div = input.parentNode;
	while (table.nodeName!='TABLE')
	{
		table = table.nextSibling;
	}
	
	if(isDate(date))
	{
		input.value = date;
		input.onchange();
		ret = Prologue.calendar.setDate(div, date);
	}
	
	return ret;
};
	
Prologue.calendar.setDate = function (div, date)
{
	if (typeof div == 'string')
		div = document.getElementById(div).parentNode;
	
	var oneMinute	= 60 * 1000;
	var oneHour		= 60 * oneMinute;
	var oneDay		= 24 * oneHour;
	
	var day;
	var month;
	var year;
	if (!isDate(date))
	{
		var newDate = new Date();			
		day = parseInt(newDate.getDate(),10);
		month = parseInt(newDate.getMonth(),10) + 1;
		year = parseInt(newDate.getFullYear(),10);
	}
	else
	{
		var dateParam = str2Date(date);
		day = parseInt(dateParam.getDate(),10);
		month = parseInt(dateParam.getMonth() + 1,10);
		year = parseInt(dateParam.getFullYear(),10);
	}
	

	date = ((day < 10)?'0':'') + day + '/' + ((month < 10)?'0':'') + month + '/' + year;
	var inpt = div.firstChild;
	var table = inpt.nextSibling;
	
	while (table.nodeName!='TABLE')
		table = table.nextSibling;
	
	var dateParam = str2Date(inpt.value);
	var selDay = parseInt(dateParam.getDate(),10);
	var selMonth = parseInt(dateParam.getMonth() + 1,10);
	var selYear = parseInt(dateParam.getFullYear(),10);
	
	var curDteAttr = table.attributes.getNamedItem('curDte');
	curDteAttr.value = date;
	
	//affichage titre mmmm yyyy
	table.rows[0].cells[0].innerHTML = Prologue.calendar.data.month[month - 1] + ' ' + year;

	var dateDeb = new Date(year, month - 1, 1);		
	var dateFin = new Date(year, month, 1);

	dateFin.setTime(dateFin.getTime() - oneDay);
	
	var nbDay = dateFin.getDate();
	
	var k = 1;
	
	for(var i = 2; i < 8; ++i)
	{		
		var maxcells = ((7 == i)?2:7);
		
		for(var j = 0; j < maxcells; ++j)
		{
			var classname = ((k == selDay && month == selMonth && year == selYear)? 'prlCellToday' : 'prlCell');
			
			if (2 == i)
			{
					if(j >= ( (dateDeb.getDay() == 0)? 7 - dateDeb.getDay() - 1:dateDeb.getDay() - 1) % 7)
					{
						if (k <= nbDay)
						{
							table.rows[i].cells[j].className = classname;
							table.rows[i].cells[j].innerHTML = k++;
						}
					}
					else
					{
						table.rows[i].cells[j].className = 'prlEmpty';
						table.rows[i].cells[j].innerHTML = '&nbsp;';
					}
			}
			else
			{
				if (k <= nbDay)
				{
					table.rows[i].cells[j].className = classname;
					table.rows[i].cells[j].innerHTML = k++;
				}
				else
				{
					table.rows[i].cells[j].className = 'prlEmpty';
					table.rows[i].cells[j].innerHTML = '&nbsp;';
				}
			}
		}
	}
	return date;
};


Prologue.calendar.getSelected = function (input)
{
	if (typeof input == 'string')
		input = document.getElementById(input);
		
	return input.value
};

Prologue.calendar.mouseout = function (evnt)
{
	var src = evnt.srcElement;
	
	if(src.className == 'prlCellOver' || src.className == 'prlCellTodayOver')
		src.className = ((src.className == 'prlCellOver')?'prlCell':'prlCellToday');
};

Prologue.calendar.mouseover = function (evnt)
{
	var src = evnt.toElement;
	
	if(src.className == 'prlCell' || src.className == 'prlCellToday')
		src.className += 'Over';
};

Prologue.calendar.mousedown = function (evnt)
{
	var src = evnt.srcElement;
	
	if(src.className == 'prlCellOver' || src.className == 'prlCellTodayOver')
	{
		if(src.className == 'prlCellOver' || src.className == 'prlCellTodayOver')
			src.className = 'prlCellSelect';

		var table = src.parentNode.parentNode.parentNode;
		var curDte = table.attributes.getNamedItem('curDte').value;
		
		var dateParam = curDte.split('/');
		var	month = parseInt(dateParam[1],10);
		var year = parseInt(dateParam[2],10);
		var newDay = parseInt(src.innerHTML,10);
		
		curDte = ((newDay < 10)?'0':'') + newDay + '/' + ((month < 10)?'0':'') + month + '/' + year;
		
		var input = table.parentNode.firstChild;
		input.value = curDte;
		Prologue.calendar.setDate(table.parentNode, curDte);
		input.onchange();
	}
};

Prologue.calendar.keydown = function(input, keyinfo)
{
	var bContinue = true;
	var val = Prologue.calendar.getSelected(input);
	var date = str2Date(val);
	switch(keyinfo.key)
	{
		case 33: // pgup
			var month = date.getMonth();
			month--;
			date.setMonth(month);
			bContinue = false;
			break;
		case 34: // pgdn
			var month = date.getMonth();
			month++;
			date.setMonth(month);
			bContinue = false;
			break;
		case 35: // fin
			var month = date.getMonth();
			date.setMonth(month+1);
			date.setDate(0);
			bContinue = false;
			break;
		case 36: // début
			date.setDate(1);
			bContinue = false;
			break;
		case 37: // gauche
			var day = date.getDate();
			day--;
			date.setDate(day);
			bContinue = false;
			break;
		case 38: // haut
			var day = date.getDate();
			day -= 7;
			date.setDate(day);
			bContinue = false;
			break;
		case 39: // droite
			var day = date.getDate();
			day++;
			date.setDate(day);
			bContinue = false;
			break;
		case 40: // bas
			var day = date.getDate();
			day += 7;
			date.setDate(day);
			bContinue = false;
			break;
		default:
			break;
	}
	var strdate = date2Str(date);
	Prologue.calendar.setSelected(input, strdate);
	if(!bContinue)
		Prologue.ui.stopEvent(); // pour éviter le décallage haut/bas de la fenêtre
		
	return bContinue;
};

////////////////////////////////
/// ComboDate Object ///
////////////////////////////////
Prologue.comboDate = function(id, value, onClick, className)
{
	if(this.value != '')
		value = (isDate(value))? value : date2Str(new Date());
	Prologue.comboDate.callBaseConstructor(this, value, onClick);
	if(id)
		this.id = id;
	this.className = (className||'prlCombo');
	this.calendar = new Prologue.calendar('', value, 'Prologue.combo.result(this.value, this.value, window.currentCombo);'); 
	
	var setDate = 'var tableCombo = ((this.nodeName ==\'TD\')?this.parentNode.parentNode.parentNode:this);';
	setDate += ' var dropDownDiv = tableCombo.rows[0].cells[0].childNodes[1];';		// Sous IE une balise #text change la localisation du div !
	setDate += ' while (dropDownDiv.nodeName!=\'DIV\') {dropDownDiv = dropDownDiv.nextSibling;}';
	setDate += ' var calDiv = dropDownDiv.childNodes[0];';
	setDate += ' var inpt = tableCombo.rows[0].cells[0].childNodes[0];';
	setDate += ' var inptCal = calDiv.childNodes[0];';
	setDate += ' inptCal.value = inpt.value;';
	this.onDropDown = setDate;
	
	var onChange = 'if(this.value != \'\') { var tableCombo = ((this.nodeName ==\'TD\')?this.parentNode.parentNode.parentNode:this);';
	onChange += ' var dropDownDiv = tableCombo.parentNode.childNodes[1];';		// Sous IE une balise #text change la localisation du div !
	onChange += ' while (dropDownDiv.nodeName!=\'DIV\') {dropDownDiv = dropDownDiv.nextSibling;}';
	onChange += ' var calDiv = dropDownDiv.childNodes[0];';
	onChange += ' var inptCal = calDiv.childNodes[0];';
	onChange += ' inptCal.value = this.value;';
	onChange += ' this.value = Prologue.calendar.setDate(calDiv, this.value); }';
	onChange += ' Prologue.combo.inputUpdate(this); ';
	this.textBox.onClick += onChange;
	
	this.dropDown.className = 'prlDropDownCalendar';
	this.width = '95px';
	this.dropDown.width = 220;
	this.textBox.format = Prologue.textBox.formats.date;
	this.textBox.errMesg = lang_comboDate_msg_date_invalide;
	this.objectExt = 'Prologue.comboDate';
};
Prologue.comboDate.extend(Prologue.combo);

Prologue.comboDate.prototype.html = function ()
{
	this.calendar.id = '';
	if(this.value != '')
		this.calendar.value = this.value;
	this.dropDown.content = this.calendar.html();
	return Prologue.comboDate.callBaseMethod(this, 'html');
};

Prologue.comboDate.prototype.attributes = function()
{
	var tmp = Prologue.comboDate.callBaseMethod(this, 'attributes');
	tmp += ' objectExt="'+this.objectExt+'"';
	return tmp;
};

Prologue.comboDate.keydown = function(keyinfo)
{
	if (window.currentCombo) 
	{
		var input = Prologue.comboDate.getCalInput(window.currentCombo);
		return Prologue.calendar.keydown(input, keyinfo);
	}
	return true;
};

Prologue.comboDate.setSelected = function (comboDate, date, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboDate == 'string')
		comboDate = document.getElementById(comboDate);
	
	date = Prologue.calendar.setSelected(Prologue.comboDate.getCalInput(comboDate), date);
	Prologue.combo.result(date, date, comboDate, onClick);
	
	return date;
};

Prologue.comboDate.getSelected = function (comboDate)
{
	if (typeof comboDate == 'string')
		comboDate = document.getElementById(comboDate);
	
	var inputHidden = comboDate.rows[0].cells[0].childNodes[comboDate.rows[0].cells[0].childNodes.length - 1];
	while (inputHidden.nodeName!='INPUT')
		inputHidden = inputHidden.nextSibling;
		
	return inputHidden.value; 
};

Prologue.comboDate.getCalInput = function (table)
{
	if (typeof table == 'string')
		table = document.getElementById(table);
		
	var dropDownDiv = table.rows[0].cells[0].childNodes[1];
	while (dropDownDiv.nodeName!='DIV')
		dropDownDiv = dropDownDiv.nextSibling;
		
	var calDiv = dropDownDiv.childNodes[0];
	var CalInput = calDiv.childNodes[0];
	
	return CalInput;
};
///////////////////////////////
/// tabStrip Object ///
///////////////////////////////
Prologue.tabStrip = function(id, onClick, className)
{
	Prologue.tabStrip.callBaseConstructor(this, id, (className||'prlTabStrip'), '', onClick);
	this.pages = [];
	this.value = '';
	this.skin = Prologue.framework.images + '/tab';
	this.clientHeight = '200px';
	this.clientWidth = '';
};
Prologue.tabStrip.extend(Prologue.control);

Prologue.tabStrip.images =
{
	 topLeft      : 'topLeft.gif'
	,topMiddle    : 'topMiddle.gif'
	,topRight     : 'topRight.gif'
	,middleLeft   : 'middleLeft.gif'
	,middleMiddle : 'middleMiddle.gif'
	,middleRight  : 'middleRight.gif'
};

Prologue.tabStrip.prototype.add = function(caption, icon, onClick)
{
	var pos = this.pages.length;
	this.pages[pos] = new Prologue.container(caption, icon, onClick);
	return this.pages[pos];
};

Prologue.tabStrip.prototype.count = function()
{
	return this.pages.length;
};

//statut d'une page
Prologue.tabStrip.tabState =
{
	unSelected:0
	,selected:1
};

//genere le fragment HTML des onglets
Prologue.tabStrip.prototype.html = function()
{
	var self = this;
	function makeTab(tab, state)
	{
		state = (typeof state != 'undefined') ? state : Prologue.tabStrip.tabState.unSelected;
		tab.className = (state)?"prlTabSelected":"prlTabUnSelected";
		var skin = self.skin + ((state==Prologue.tabStrip.tabState.selected)?'/selected':'/unSelected');
		var tmp = '<table'+tab.attributes()+' cellspacing="0" style="z-index:'+ ((state==Prologue.tabStrip.tabState.selected)?'1':'0') + ';" cellpadding="0" onmousedown="Prologue.tabStrip.pageClick(this);return false;" onselectstart="return false;"><tr>';
		tmp += '<td><img src="'+skin+'/'+Prologue.tabStrip.images.topLeft+'"/></td>';
		tmp += '<td style="background-image:url('+skin+'/'+Prologue.tabStrip.images.topMiddle+');"><img src="'+skin+'/'+Prologue.tabStrip.images.topMiddle+'"/></td>';
		tmp += '<td><img src="'+skin+'/'+Prologue.tabStrip.images.topRight+'"/></td>';
		tmp += '</tr><tr style="height:100%;">';
		tmp += '<td style="background-image:url('+skin+'/'+Prologue.tabStrip.images.middleLeft+');"><img src="'+skin+'/'+Prologue.tabStrip.images.middleLeft+'"/></td>';
		tmp += '<td style="background-image:url('+skin+'/'+Prologue.tabStrip.images.middleMiddle+');">'+tab.title.html()+'</td>';
		tmp += '<td style="background-image:url('+skin+'/'+Prologue.tabStrip.images.middleRight+');"><img src="'+skin+'/'+Prologue.tabStrip.images.middleRight+'"/></td>';
		tmp += '</tr></table>';
		return tmp;
	};
	var tmp = '<table border="0"'+this.attributes()+' cellspacing="0" cellpadding="0" prlSkin="'+this.skin+'"'+((this.clientWidth)?'':' style="left:0px;width:100%;"')+'>';
	tmp += '<tr><td class="prlTabStripTabs"><div style="width:100%;">'; //le div sert de parent positionn� pour les tab relatifs
	for (var p=0; p<this.pages.length; p++)
	{
		var page = this.pages[p];
		var selected = (p==this.value);
		tmp += makeTab(page, selected);
	}
	tmp += '</div></td></tr>';
	tmp += '<tr><td class="prlTabStripContent">';
	tmp += '<div class="prlTabStripPages" style="height:'+this.clientHeight+';';
	if (this.clientWidth) tmp += 'width:'+this.clientWidth+';';
	tmp += '">';
	for (var p=0; p<this.pages.length; p++)
	{
		var page = this.pages[p];
		var selected = (p==this.value);
		tmp += '<div';
		if (!selected) tmp += ' style="display:none;"';
		tmp += '>'+page.content+'</div>';		
	}	
	tmp += '</div></td></tr>';
	tmp += '</table>';
	return tmp;
};
Prologue.tabStrip.setClientHeight = function(tabStrip, height) {
	if (typeof tabStrip == 'string')
		tabStrip = document.getElementById(tabStrip);
	if (tabStrip && tabStrip.nodeName=='TABLE')
	{
		var cnt = tabStrip.rows[1].cells[0].firstChild;
		var h = parseInt(height) - tabStrip.rows[0].offsetHeight;
		cnt.style.height = h+'px';
	}
};
Prologue.tabStrip.prototype.create = function()
{
	Prologue.tabStrip.callBaseMethod(this, 'create');
	var me = document.getElementById(this.id);
	if (me)
	{
		for (var t=0; t<this.pages.length; t++)
		{
			var tab = this.pages[t];
			if (tab && tab.contentID)
			{
				var obj = document.getElementById(tab.contentID);
				if (obj)
				{
					var cnt = Prologue.tabStrip.getContent(me, t);
					cnt.innerHTML = obj.innerHTML;
					obj.removeNode(true);
				}
			}
		}
	}
};

Prologue.tabStrip.pageClick = function(tab)
{
	var tr = tab.parentNode.parentNode.parentNode;
	var ts = tr.parentNode.parentNode;
	var skin = ts.attributes.getNamedItem('prlSkin').value;
	for (var c=0; c<tr.cells[0].firstChild.childNodes.length; c++)
	{
		var tbl = tr.cells[0].firstChild.childNodes[c];
		var selected = (tbl===tab);
		var tabSkin = skin + ((selected) ? '/selected' : '/unSelected');
		tbl.className = ((selected)?'prlTabSelected':'prlTabUnSelected');
		tbl.rows[0].cells[0].firstChild.src = tabSkin + '/topLeft.gif';
		tbl.rows[0].cells[1].firstChild.src = tabSkin + '/topMiddle.gif';
		tbl.rows[0].cells[1].style.backgroundImage = 'url('+tabSkin + '/topMiddle.gif)';
		tbl.rows[0].cells[2].firstChild.src = tabSkin + '/topRight.gif';
		tbl.rows[1].cells[0].firstChild.src = tabSkin + '/middleLeft.gif';
		tbl.rows[1].cells[0].style.backgroundImage = 'url('+tabSkin + '/middleLeft.gif)';
		tbl.rows[1].cells[1].style.backgroundImage = 'url('+tabSkin + '/middleMiddle.gif)';
		tbl.rows[1].cells[2].firstChild.src = tabSkin + '/middleRight.gif';
		tbl.rows[1].cells[2].style.backgroundImage = 'url('+tabSkin + '/middleRight.gif)';
		tbl.style.zIndex = (selected)?1:0;
		ts.rows[1].cells[0].firstChild.childNodes[c].style.display = ((selected) ? '' : 'none');
	}
};

Prologue.tabStrip.getContent = function(object, index)
{
	var cnt = null;
	if (typeof object == 'string')
		object = document.getElementById(object);
	if (object && object.nodeName=='TABLE')
		cnt = object.rows[1].cells[0].firstChild.childNodes[index||0];
	return cnt;
};

Prologue.tabStrip.getSelected = function(object)
{
	var ret = -1;
	if (typeof object == 'string') object = document.getElementById(object);
	if (object && object.nodeName=='TABLE')
	{
		var tblTabs = object.rows[0].cells[0].firstChild;
		for (var t=0; t<tblTabs.childNodes.length; t++)
		{
			if (tblTabs.childNodes[t].className=='prlTabSelected')
			{
				ret=t;
				break;
			}
		}
	}
	return ret;
};

Prologue.tabStrip.setSelected = function(object, index)
{
	var ret = false;
	if (typeof object == 'string')
		object = document.getElementById(object);
	if (object && object.nodeName=='TABLE')
	{
		if (typeof index == 'undefined' || isNaN(index))
			index = '0';
		index = new Number(index, 10);
		var tblTabs = object.rows[0].cells[0].firstChild;
		if (index<=tblTabs.childNodes.length)
		{
			if (tblTabs.onclick) tblTabs.onclick();
			Prologue.tabStrip.pageClick(tblTabs.childNodes[index]);
			ret = true;
		}
	}
	return ret;
};

Prologue.tabStrip.setText = function(object, index, text) {
	if (typeof object == 'string')
		object = document.getElementById(object);
	if (object && object.nodeName=='TABLE')
	{
		var tblTabs = object.rows[0].cells[0].firstChild;
		var tab = tblTabs.childNodes[index];
		var itm = tab.rows[1].cells[1].firstChild;
		Prologue.item.setText(itm, text);		
	}
}
Prologue.tabStrip.setIcon = function(object, index, icon) {
	if (typeof object == 'string')
		object = document.getElementById(object);
	if (object && object.nodeName=='TABLE')
	{
		var tblTabs = object.rows[0].cells[0].firstChild;
		var tab = tblTabs.childNodes[index];
		var itm = tab.rows[1].cells[1].firstChild;
		Prologue.item.setIcon(itm, icon);		
	}
}
/////////////////////////
/// Node Object ///
/////////////////////////
Prologue.node = function(treeid, caption, icon, onClick, value)
{
	Prologue.node.callBaseConstructor(this, caption, icon, onClick, value);
	this.childs = new Prologue.nodeCollection(treeid);
	this.open = false;
	this.treeid = treeid;
	this.childasync = '';
	this.nextasync = '';
};
Prologue.node.extend(Prologue.listItem);

Prologue.node.prototype.add = function(caption, icon, onClick, value)
{
	return this.childs.add(caption, icon, onClick, value);
};

Prologue.node.prototype.count = function()
{
	return this.childs.count();
};

Prologue.node.prototype.bind = function(datasourceNode)
{
	var itmNode = datasourceNode.firstChild;
	Prologue.node.callBaseMethod(this, 'bind', itmNode);
	this.childs.bind(datasourceNode);
	if (itmNode && itmNode.attributes)
	{
		for (var a=0; a<itmNode.attributes.length; a++)
		{
			var atb = itmNode.attributes[a];
			if (atb.name=='childasync')
			{
				this.childasync = atb.value;
			}
			if (atb.name=='nextasync')
			{
				this.nextasync = atb.value;
			}
		}
	}
};

Prologue.node.prototype.html = function()
{
	var tmp = '<tr';
	//if (this.childs.count()>0)
	tmp += ' id="'+this.treeid+this.value+'"';
	if (this.childasync)
	{
		tmp += ' childasync="'+this.childasync+'"';
	}
	if (this.nextasync)
	{
		tmp += ' nextasync="'+this.nextasync+'"';
		var req = new Prologue.ajax.request(this.nextasync);
		req.tag = {
			 id:this.treeid+this.value
			,dataSource:this.nextasync
			,asyncType:"next"
			,treeid:this.treeid
		};
		req.callBack = Prologue.treeView.asyncLoad;
		req.send();
	}
	tmp += ' onclick="Prologue.treeView.click(this);" ondblclick="return Prologue.treeView.nodeClick(event, this.parentNode);" treeLeaf="1" treeChildren="'+((this.childs.count() || this.childasync)?'1':'0')+'">';
	if ((this.childs.count()>0) || (this.childasync))
		tmp += '<td style="text-align:center;" onclick="return Prologue.treeView.nodeClick(event, this.parentNode);"><img src="' + ((this.open)?Prologue.treeView.images.close:Prologue.treeView.images.open)+'"/></td>';
	else
		tmp += '<td><img src="' + Prologue.framework.images + '/empty.gif"/></td>';
	tmp += Prologue.node.callBaseMethod(this, 'html')+'</tr>';
	if (this.childs.count()>0)
		tmp += '<tr treeLeaf="0" treeChildren="0"'+((this.open)?'':' style="display:none;"')+'><td></td><td><table class="prlTreeChilds" treeRoot="0" cellspacing="0" cellpadding="0">'+this.childs.html()+'</table></td></tr>';
	else if (this.childasync)
		tmp += '<tr treeLeaf="0" treeChildren="0"'+((this.open)?'':' style="display:none;"')+'><td></td><td><table class="prlTreeChilds" treeRoot="0" cellspacing="0" cellpadding="0"></table></td></tr>';
	
	return tmp;
};

Prologue.node.prototype.createElement = function(use_function_for_event)
{
	var tr = document.createElement('tr');
	tr.setAttribute("id",this.treeid+this.value);
	if (this.childasync)
	{
		tr.setAttribute("childasync",this.childasync);
	}
	if (this.nextasync)
	{
		tr.setAttribute("nextasync",this.nextasync);
		var req = new Prologue.ajax.request(this.nextasync);
		req.tag = {
			 id:this.treeid+this.value
			,dataSource:this.nextasync
			,asyncType:"next"
			,treeid:this.treeid
		};
		req.callBack = Prologue.treeView.asyncLoad;
		req.send();
	}
	if (use_function_for_event)
	{
		tr.onclick = function(){Prologue.treeView.click(this);};
		tr.ondblclick = function(){Prologue.treeView.nodeClick(event, this.parentNode);};
	}
	else
	{
		tr.setAttribute("onclick","Prologue.treeView.click(this);");
		tr.setAttribute("ondblclick","return Prologue.treeView.nodeClick(event, this.parentNode)");
	}
	tr.setAttribute("treeLeaf","1");
	tr.setAttribute("treeChildren",((this.childs.count() || this.childasync)?'1':'0'));

	var td = document.createElement('td');
	if ((this.childs.count()>0) || (this.childasync))
	{
		td.style.textAlign = "center";
		if (use_function_for_event)
		{
			td.onclick = function(){Prologue.treeView.nodeClick(event, this.parentNode);};
		}
		else
		{
			td.setAttribute("onclick","return Prologue.treeView.nodeClick(event, this.parentNode);");
		}
		td.innerHTML = '<img src="' + ((this.open)?Prologue.treeView.images.close:Prologue.treeView.images.open)+'"/>';
	}
	else
	{
		td.innerHTML = '<img src="' + Prologue.framework.images + '/empty.gif"/>';
	}
	tr.appendChild(td);
	var tdlistitem = Prologue.node.callBaseMethod(this, 'createElement',use_function_for_event);
	tr.appendChild(tdlistitem);
	
	return tr;
}
	
Prologue.node.prototype.createChildElements = function()
{
	if ((this.childs.count()>0) || (this.childasync))
	{
		var trchilds = document.createElement('tr');
		trchilds.setAttribute("treeLeaf","0");
		trchilds.setAttribute("treeChildren","0");
		if (!this.open) trchilds.style.display = "none";
		var tdempty = document.createElement('td');
		trchilds.appendChild(tdempty);
		var tdchilds = document.createElement('td');
		if (this.childs.count()>0)
			tdchilds.innerHTML = '<table class="prlTreeChilds" treeRoot="0" cellspacing="0" cellpadding="0">'+this.childs.html()+'</table>';
		else if (this.childasync)
			tdchilds.innerHTML = '<table class="prlTreeChilds" treeRoot="0" cellspacing="0" cellpadding="0"></table>';
		trchilds.appendChild(tdchilds);
	
		return trchilds;
	}
	else return null;
};

///////////////////////////////////////
/// NodeCollection Object ///
///////////////////////////////////////
Prologue.nodeCollection = function(treeid)
{
	this.treeid = treeid;
	Prologue.nodeCollection.callBaseConstructor(this);	
};
Prologue.nodeCollection.extend(Prologue.collection);

Prologue.nodeCollection.prototype.add = function(caption, icon, onClick, value)
{
	var pos = this.items.length;
	this.items[pos] = new Prologue.node(this.treeid, caption, icon, onClick, value);
	return this.items[pos];
};

Prologue.nodeCollection.prototype.html = function()
{
	var tmp = '';	
	for (var n=0; n<this.items.length; n++)
	{
		var node = this.items[n];
		tmp += node.html();
	}
	return tmp;
};

Prologue.nodeCollection.prototype.bind = function(xRoot)
{
	if (xRoot) {
	 	for (var pRow=0; pRow<xRoot.childNodes.length; pRow++)
		{
			var row = xRoot.childNodes[pRow];
			if (row.nodeName=='row')
			{
				var nde = new Prologue.node(this.treeid);
				nde.bind(row);
				this.items.push(nde);
			}
		}
	}
};

/////////////////////////
/// tree Object ///
/////////////////////////
Prologue.treeView = function(id, onClick, className)
{
	Prologue.treeView.callBaseConstructor(this, id, (className||'prlTree'), '', onClick);
	this.nodes = new Prologue.nodeCollection(id);
	this.value = '';
	this.dataSource = '';
	this.async = true;
	this.hasKeydown = false;
};
Prologue.treeView.extend(Prologue.control);

Prologue.treeView.prototype.attributes = function()
{
	var tmp = Prologue.treeView.callBaseMethod(this, 'attributes');
	tmp += " hasKeydown="+((this.hasKeydown==true)?1:0);
	return tmp;
};

Prologue.treeView.images =
{
	close: {
		name : 'minus.gif'
		,toString : function(){
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,open : {
		name : 'plus.gif'
		,toString : function(){
			return Prologue.framework.images + '/' + this.name;
		}
	}
};

Prologue.treeView.prototype.add = function(caption, icon, onClick, value)
{
	return this.nodes.add(caption, icon, onClick, value);
};

Prologue.treeView.prototype.count = function()
{
	return this.nodes.count();
};

//charge la collection de noeuds a partir d'un source de donnees en Ajax
Prologue.treeView.prototype.load = function()
{
	var ret = false;
	if (this.dataSource)
	{
		var req = new Prologue.ajax.request(this.dataSource);
		req.send();
		var resp = req.getXML();
		if (resp)
		{
			var xRoot = resp.documentElement;
			this.nodes.bind(xRoot);
			ret= true;
		}
	}
	return ret;
};

//genere le fragment HTML de l'arbre
Prologue.treeView.prototype.html = function()
{
	function recurseNode(value, nodes)
	{
		var ret = false;
		for (var n=0; n<nodes.count(); n++)
		{
			var node = nodes.item(n);
			if (node.value==value)
			{
				node.selected = true;
				ret=true;
				break;
			}
			if (node.childs.count()>0)
			{
				if (recurseNode(value, node.childs))
				{
					node.open = true;
					ret=true;
					break;
				}
			}
		}
		return ret;
	};

	if (this.dataSource)
	{
		if (this.value.length)
		{
			if (this.dataSource.indexOf('?') == -1)
			{
				this.dataSource += '?show='+this.value;
			}
			else
			{
				this.dataSource += '&show='+this.value;
			}
	    }
		if (!this.async) // Async ?
		{
			this.load();
		}
		else
		{
			this.add(lang_msg_loading, Prologue.grid.images['wait']);
			var req = new Prologue.ajax.request(this.dataSource);
			req.tag = {
				 id:this.id
				,dataSource:this.dataSource
			};
			req.callBack = Prologue.treeView.asyncLoad;
			req.send();
		}
	}
	if (this.value.length)
	{
		recurseNode(this.value, this.nodes);
	}
	var tmp = '<table treeRoot="1"'+this.attributes()+' cellspacing="0" cellpadding="0"'+((this.hasKeydown==true)?' tabindex="1" onkeydown="return Prologue.treeView.onkeydown(this, event);"':'')+'>'+this.nodes.html()+'</table>';
	
	return tmp;
};

//ouvre ou ferme un noeud de l'arbre
Prologue.treeView.nodeExpandStatus =
{
	auto:-1
	,open:1
	,close:0
};

Prologue.treeView.expandNode = function(row, status)
{
	status = (typeof status == 'undefined') ? Prologue.treeView.nodeExpandStatus.auto : status;
	if (row && row.attributes.getNamedItem('treeChildren') && row.attributes.getNamedItem('treeChildren').value=='1')
	{
		var c = row.nextSibling;
		var h = false;
		switch (status)
		{
			case Prologue.treeView.nodeExpandStatus.open:
				h = false;
				break;
			case Prologue.treeView.nodeExpandStatus.close:
				h = true;
				break;
			default:
				h = (c.style.display=='none');
				break;
		}
		row.firstChild.firstChild.src = ((h)?Prologue.treeView.images.close:Prologue.treeView.images.open);
		c.style.display = (h)?'':'none';
		if ((h) && (row.attributes.getNamedItem('childasync')))
		{
			var req = new Prologue.ajax.request(row.attributes.getNamedItem('childasync').value);
			req.tag = {
				 id:row.id
				,dataSource:row.attributes.getNamedItem('childasync').value
				,asyncType:"child"
			};
			req.callBack = Prologue.treeView.asyncLoad;
			req.send();
		}
	}
};

Prologue.treeView.nodeClick = function(evt, tr)
{
	Prologue.treeView.expandNode(tr);
	evt.cancelBubble=true;
	return false;
};

Prologue.treeView.unselect = function(tbl)
{
	var callBack = function(currentRow)
	{
		currentRow.cells[1].attributes.getNamedItem('prlSelected').value = '0';
		currentRow.cells[1].className = 'prlRow';
		return false;
	};
	if (tbl && tbl.attributes.getNamedItem('treeRoot') && tbl.attributes.getNamedItem('treeRoot').value == '1')
		Prologue.treeView.recurseRow(tbl, callBack);
};

Prologue.treeView.click = function(tr)
{
	//recherche du tableau racine
	var tbl = tr.parentNode.parentNode;
	while (tbl && tbl.attributes.getNamedItem('treeRoot').value != '1')
		tbl = tbl.parentNode.parentNode.parentNode.parentNode;
	//deselection de la ligne active
	Prologue.treeView.unselect(tbl);
	//selection de la ligne courante;
	tr.cells[1].attributes.getNamedItem('prlSelected').value = '1';
	tr.cells[1].className = 'prlRowSelected';
};

Prologue.treeView.ensureVisible = function(tr)
{
	var tl =  tr.attributes.getNamedItem('treeLeaf').value;
	if (tl==1)
	{
		var tbl = tr.parentNode.parentNode;
		if (tbl && tbl.attributes.getNamedItem('treeRoot') && tbl.attributes.getNamedItem('treeRoot').value == '0')
		{
			var rl = tbl.parentNode.parentNode.previousSibling;
			if (rl)
			{
				Prologue.treeView.expandNode(rl, Prologue.treeView.nodeExpandStatus.close);
				Prologue.treeView.ensureVisible(rl);
			}
		}
	}
};

Prologue.treeView.getSelected = function(tree)
{
	var callBack = function(currentRow)
	{
		index++;
		if (currentRow.cells[1].attributes.getNamedItem('prlSelected').value=='1')
		{
			var pItm = Prologue.item.getItem(currentRow.cells[1].firstChild);
			itm.caption = pItm.caption;
			itm.value = currentRow.cells[1].attributes.getNamedItem('prlValue').value;
			itm.index = index;
			return true;
		}
		return false;
	};
	var index = -1;
	var itm =
	{
		'caption':'',
		'value':'',
		'index': index,
		'toString':function(){return this.index;}
	};
	if (typeof tree == 'string')
		tree = document.getElementById(tree);
	if (tree && tree.nodeName=='TABLE')
		Prologue.treeView.recurseRow(tree, callBack);
	return itm;
};

Prologue.treeView.scrollToElement = function(tree, node)
{
	// scrolling de l'arbre si nécessaire pour que le noeud soit visible
	var top = node.offsetTop;
	var tmpParent = node.offsetParent;
	while(tmpParent!=null && tmpParent.className!='prlTree')
	{
		if(tmpParent.style.display!='none')
			top += tmpParent.offsetTop;
		tmpParent = tmpParent.offsetParent;
	}
	
	var bottom = top + node.offsetHeight;
	var h = tree.scrollTop + tree.offsetHeight;
	if(top>h || bottom>h || top<tree.scrollTop)
	{
		tree.scrollTop = top - tree.offsetTop;
	}
};

Prologue.treeView.selectNodeByIndex = function(tree, index)
{
	index = ((typeof index == 'undefined')?'-1':index);
	index = parseInt(index, 10);
	var recurseIndex = -1;
	var row = null;
	var ret = false;
	var callBack = function(currentRow)
	{
		recurseIndex++;
		if (recurseIndex == index)
		{
			row = currentRow;
			return true;
		}
		return false;
	};
	if (typeof tree == 'string')
		tree = document.getElementById(tree);
	if (tree && tree.attributes.getNamedItem('treeRoot') && tree.attributes.getNamedItem('treeRoot').value == '1')
	{
		Prologue.treeView.unselect(tree);
		if (index>=0 && Prologue.treeView.recurseRow(tree, callBack))
		{
			Prologue.treeView.ensureVisible(row);		
			var lstItem = row.cells[1];
			Prologue.treeView.scrollToElement(tree.parentNode, lstItem);
			if (lstItem.onclick) lstItem.onclick();
			row.onclick();
		}
		if (tree.onclick) 
			tree.onclick();
		ret = true;
	}
	return ret;
};

Prologue.treeView.selectNodeByValue = function(tree, value)
{
	var ret = false;
	var row = null;
	var callBack = function(currentRow)
	{
		if (value == currentRow.cells[1].attributes.getNamedItem('prlValue').value)
		{
			row = currentRow;
			return true;
		}
		return false;
	};
	if (typeof tree == 'string')
		tree = document.getElementById(tree);
	if (tree && tree.attributes.getNamedItem('treeRoot') && tree.attributes.getNamedItem('treeRoot').value == '1')
	{
		if (value)
		{
			ret =  Prologue.treeView.recurseRow(tree, callBack);
			if (ret)
			{
				Prologue.treeView.unselect(tree);
				Prologue.treeView.ensureVisible(row);		
				var lstItem = row.cells[1];
				Prologue.treeView.scrollToElement(tree.parentNode, lstItem);
				if (lstItem.onclick)
					lstItem.onclick();
				row.onclick();
				if (tree.onclick)
					tree.onclick();
			}
		}
	}
	return ret;
};

Prologue.treeView.selectNodeByLikeValue = function(tree, value, selected)
{
	var ret = false;
	var row = null;
	ffound = '';
	away = true;
	rchoose = 0;
	var callBackLike = function(currentRow, tbl, value, selected)
	{
		
		if (currentRow.cells[1].textContent)
		{	
			var tmp = currentRow.cells[1].textContent.substr(0,1); // for moz
		} else {	
			var tmp = currentRow.innerText.substr(0,1); // for i.e.
		}
		
		if (value.toLowerCase() == tmp.toLowerCase())
		{
		if (selected.caption.substr(0,1).toLowerCase() == value.toLowerCase() && away  == true)
		{
			if (ffound == '') ffound = rchoose;
			if (selected.value == currentRow.cells[1].attributes.prlValue.value)
			{
				away = false;
				var ttbl=tbl.rows.length-2;
				if (rchoose == ttbl)
				{
					row = tbl.rows[ffound];
					return true;
				}
			} else {
				away = true;
			}
		} else {
			row = tbl.rows[rchoose];
			return true;
		}	
	} else {
		var ttbl=tbl.rows.length-2;
		if (rchoose == ttbl && away == false)
		{
			row = tbl.rows[ffound];
			return true;	
		}
	}
		return false;
	};
	
	if (typeof tree == 'string')
		tree = document.getElementById(tree);
	if (tree && tree.attributes.getNamedItem('treeRoot') && tree.attributes.getNamedItem('treeRoot').value == '1')
	{
		if (value)
		{
			ret =  Prologue.treeView.recurseLikeRow(tree, callBackLike, value, selected);
			if (ret)
			{
				Prologue.treeView.unselect(tree);
				Prologue.treeView.ensureVisible(row);
				var lstItem = row.cells[1];
				Prologue.treeView.scrollToElement(tree.parentNode, row);
				if (lstItem.onclick)
					lstItem.onclick();
				row.onclick();
			} 
		}
	}
	return ret;
};

Prologue.treeView.recurseLikeRow = function(tbl, callBackLike, value, selected)
{
	var found = false;
	if (tbl && callBackLike)
	{
		for (rchoose; rchoose<tbl.rows.length; rchoose++)
		
		{
			var row = tbl.rows[rchoose];
			if (row.attributes.getNamedItem('treeLeaf').value=='1')
			{
				found = callBackLike(row, tbl, value, selected);
				
				if (!found && row.attributes.getNamedItem('treeChildren').value=='1') {
					row=tbl.rows[rchoose];
				}
				
			}
			if (found)
				break;
		}
	}
	return found;
};

Prologue.treeView.recurseRow = function(tbl, callBack)
{
	var found = false;
	if (tbl && callBack)
	{
		for (var r=0; r<tbl.rows.length; r++)
		{
			var row = tbl.rows[r];
			if (row.attributes.getNamedItem('treeLeaf').value=='1')
			{
				found = callBack(row);
				if (!found && row.attributes.getNamedItem('treeChildren').value=='1')
					found = Prologue.treeView.recurseRow(row.nextSibling.cells[1].firstChild, callBack);
			}
			if (found)
				break;
		}
	}
	return found;
};

//charge la collection de noeuds a partir d'un source de donnees en Ajax
Prologue.treeView.reload_async = function(tree, dataSource, childasync, req)
{
	var ret = false;
	if (typeof tree == 'string')
		tree = document.getElementById(tree);
	if (tree && dataSource)
	{
		if (tree.attributes.getNamedItem('treeRoot'))
		{
			var onclick = '';
			if (tree.onclick) {
				var buffer = tree.onclick.toString().replace(/[\r\n]/g,'');
				var rx = new RegExp(/\{(.*)\}/g);
				onclick = rx.exec(buffer)[1];
				onclick = onclick.replace(/"/g, '\'');
			}		
			var tvw = new Prologue.treeView(tree.id, onclick, tree.className);
			tvw.async = tree.async;
			tvw.childasync = childasync;
			tvw.hasKeydown = parseInt(tree.attributes.getNamedItem('hasKeyDown').value);
			if (req)
			{
				var resp = req.getXML();
				if (resp)
				{
					var xRoot = resp.documentElement;
					tvw.nodes.bind(xRoot);
				}
			}
			else
			{
				tvw.dataSource = dataSource;
			}
			tree.insertAdjacentHTML('afterend', tvw.html());		
			tree.removeNode(true);
			ret=true;
		}
		else
		{
			if (req)
			{
				var treeid = tree.parentNode.parentNode.id;
				if (req.tag.asyncType == 'child')
				{
					var tvw = new Prologue.node(treeid);
					var resp = req.getXML();
					if (resp)
					{
						var xRoot = resp.documentElement;
						tvw.bind(xRoot.childNodes[0]);
					}
					tvw.open = true;
					var tbody = tree.parentNode;
					tbody.replaceChild(tvw.createChildElements(),tree.nextSibling);
					tree.removeAttribute("childasync");
					ret=true;
				}
				else
				{
					var use_function_for_event = false;
					if (Prologue.browser.ie)
					{
						use_function_for_event = true;
						if ((dataSource.search("f_ieexcept=1") != -1) && (dataSource.search("f_next=0") != -1))
						{
							use_function_for_event = false;
						}
					}
					var resp = req.getXML();
					if (resp)
					{
						var xRoot = resp.documentElement;
						if ((xRoot) && (xRoot.childNodes))
						{
							var tbody = tree.parentNode;
						 	for (var pRow=0; pRow<xRoot.childNodes.length; pRow++)
							{
								var tvw = new Prologue.node(treeid);
								tvw.bind(xRoot.childNodes[pRow]);
								tbody.appendChild(tvw.createElement(use_function_for_event));
								var trchilds = tvw.createChildElements();
								if (trchilds)
								{
									tbody.appendChild(trchilds);
								}
							}
						}
					}
					ret=true;
				}
			}
		}
	}
	return ret;
};

Prologue.treeView.reload = function(tree, dataSource)
{
	return Prologue.treeView.reload_async(tree, dataSource, true) 
}

Prologue.treeView.asyncLoad = function(req) 
{
	return Prologue.treeView.reload_async(req.tag.id,req.tag.dataSource, false, req) 
};
	
Prologue.treeView.getTreeNodeByIndex = function(tree, index)
{
	index = ((typeof index == 'undefined')?'-1':index);
	index = parseInt(index, 10);
	var recurseIndex = -1;
	var row = null;
	var callBack = function(currentRow)
	{
		recurseIndex++;
		if (recurseIndex == index)
		{
			row = currentRow;
			return true;
		}
		return false;
	};
	if (tree && tree.attributes.getNamedItem('treeRoot') && tree.attributes.getNamedItem('treeRoot').value == '1')
	{
		if (index>=0 && Prologue.treeView.recurseRow(tree, callBack))
		{
			return row;
		}
	}
	return row;
}

// pour appel depuis fonction html ou code javascript de la page (pour rerouter l'évènement du div père par exemple)
Prologue.treeView.onkeydown = function(tree, event)
{
	var evt = event ? event : window.event;
	var keyinfo = getKeyInfo(evt);
	return Prologue.treeView.keydown(tree, keyinfo);
}

Prologue.treeView.keydown = function(tree, keyinfo)
{
	var bContinue = true;
	var sel = Prologue.treeView.getSelected(tree);
	if(sel.index == -1)
		Prologue.treeView.selectNodeByIndex(tree, 0);

	switch(keyinfo.key)
	{
		case 33: // pgup
			var nb = Math.floor(tree.parentNode.clientHeight / tree.rows[0].offsetHeight);
			var node = Prologue.treeView.getTreeNodeByIndex(tree, sel.index);
			var recurseNb = -1;
			var prevCallback = function(currentNode)
			{
				recurseNb++;

				if(recurseNb == nb || node==tree.rows[0])
					return true;
		
				while(node && node.previousSibling==null && node!=tree.rows[0])
				{
					node = node.parentNode.parentNode;
				}
				
				if(node)
				{
					node = node.previousSibling;
					
					if((node.style.display=='none' || node.attributes.getNamedItem('treeLeaf')==null || node.attributes.getNamedItem('treeLeaf').value=='0') && node!=tree.rows[0])
					{
						node = node.previousSibling;
					}
				}
				return false;
			};
			Prologue.treeView.recurseRow(tree, prevCallback);
			if(node && node.cells)
			{
				var val = node.cells[1].attributes.getNamedItem('prlValue');
				if(val)
				{
					Prologue.treeView.selectNodeByValue(tree, val.value);
					bContinue = false;
				}
			}
			break;
		case 34: // pgdn
			var nb = Math.floor(tree.parentNode.clientHeight / tree.rows[0].offsetHeight);
			var node = Prologue.treeView.getTreeNodeByIndex(tree, sel.index);
			var recurseNb = -1;
			var nextCallback = function(currentNode)
			{
				recurseNb++;

				if(recurseNb == nb || node==tree.rows[tree.rows.length - 1])
					return true;

				var bOk = false;
				while(node && node.attributes && node.attributes.getNamedItem('treeChildren') && node.attributes.getNamedItem('treeChildren').value=='1' && node!=tree.rows[tree.rows.length - 1])
				{
					node = node.nextSibling;
					if(node.style.display!='none')
					{
						bOk = true;
						node = node.firstChild.nextSibling.firstChild.rows[0];
					}
				}
				if(!bOk)
				{
					while(node && node.nextSibling==null && node!=tree.rows[0])
					{
						node = node.parentNode.parentNode;
					}
					if(node)
						node = node.nextSibling;
				}
				
				return false;
			};
			Prologue.treeView.recurseRow(tree, nextCallback);
			if(node && node.cells)
			{
				var val = node.cells[1].attributes.getNamedItem('prlValue');
				if(val)
				{
					Prologue.treeView.selectNodeByValue(tree, val.value);
					bContinue = false;
				}
			}
			break;
		case 35: // fin
			var node = tree.rows[tree.rows.length - 1];
			if(node && node.cells)
			{
				var val = node.cells[1].attributes.getNamedItem('prlValue');
				if(val)
				{
					Prologue.treeView.selectNodeByValue(tree, val.value);
					bContinue = false;
				}
			}
			break;
		case 36: // début
			Prologue.treeView.selectNodeByIndex(tree, 0);
			bContinue = false;
			break;
		case 37: // gauche : on ferme le noeud si c'est un arbre ouvert et on remonte sur le noeud parent
			var node = Prologue.treeView.getTreeNodeByIndex(tree, sel.index);
			if(node.attributes.getNamedItem('treeChildren') && node.attributes.getNamedItem('treeChildren').value=='1')
			{
				Prologue.treeView.expandNode(node, Prologue.treeView.nodeExpandStatus.open);
			}
			node = node.parentNode.parentNode;
			if(node && node!=tree) // on remonte sur le noeud parent si on n'est pas à la racine
			{
				while(node.previousSibling==null && node!=tree.rows[0])
				{
					node = node.parentNode.parentNode;
				}
				node = node.previousSibling;
				if(node.attributes.getNamedItem('treeChildren') && node.attributes.getNamedItem('treeChildren').value=='1')
				{
					Prologue.treeView.expandNode(node, Prologue.treeView.nodeExpandStatus.open);
				}
				var val = node.cells[1].attributes.getNamedItem('prlValue').value;
				Prologue.treeView.selectNodeByValue(tree, val);
				bContinue = false;
			}
			break;
		case 38: // haut
			var node = Prologue.treeView.getTreeNodeByIndex(tree, sel.index);
			if(node && node!=tree.rows[0])
			{
				while(node.previousSibling==null && node!=tree.rows[0])
				{
					node = node.parentNode.parentNode;
				}
				node = node.previousSibling;
				
				if((node.style.display=='none' || node.attributes.getNamedItem('treeLeaf')==null || node.attributes.getNamedItem('treeLeaf').value=='0') && node!=tree.rows[0])
				{
					node = node.previousSibling;
				}
			}
			if(node && node!=tree.rows[0])
			{
				var val = node.cells[1].attributes.getNamedItem('prlValue').value;
				Prologue.treeView.selectNodeByValue(tree, val);
			}
			else
				Prologue.treeView.selectNodeByIndex(tree, 0);
			bContinue = false;
			break;
		case 39: // droite : on ouvre le noeud si c'est un arbre
			var node = Prologue.treeView.getTreeNodeByIndex(tree, sel.index);
			if(node.attributes.getNamedItem('treeChildren') && node.attributes.getNamedItem('treeChildren').value=='1')
			{
				Prologue.treeView.expandNode(node, Prologue.treeView.nodeExpandStatus.close);
				bContinue = false;
			}
			break;
		case 40: // bas
			var node = Prologue.treeView.getTreeNodeByIndex(tree, sel.index);
			var val = '';
			if(node!=tree.rows[tree.rows.length - 1])
			{
				// on cherche dans les fils
				while(node && node.attributes.getNamedItem('treeChildren') && node.attributes.getNamedItem('treeChildren').value=='1' && node!=tree.rows[tree.rows.length - 1])
				{
					node = node.nextSibling;
					if(node && node.style.display!='none')
					{
						val = node.firstChild.nextSibling.firstChild.rows[0].cells[1].attributes.getNamedItem('prlValue').value;
					}
				}
				if(node && val=='') // on a pas trouvé de fils
				{
					while(node.nextSibling==null && node!=tree.rows[0])
					{
						node = node.parentNode.parentNode;
					}
					if(node.nextSibling && node.nextSibling.cells)
					{
						var valNode = node.nextSibling.cells[1].attributes.getNamedItem('prlValue');
						if(valNode)
							val = valNode.value;
					}
				}
			}
			Prologue.treeView.selectNodeByValue(tree, val);
			bContinue = false;
			break;
		default:
			var ret = String.fromCharCode(keyinfo.key);
			Prologue.treeView.selectNodeByLikeValue(tree, ret, sel);
			bContinue = false;
			break;
	}
	
	if(!bContinue)
		Prologue.ui.stopEvent();
		
	return bContinue;
};

////////////////////////////////
/// ComboTree Object ///
////////////////////////////////
Prologue.comboTree = function(id, value, onClick, className)
{
	Prologue.comboTree.callBaseConstructor(this, value, onClick);
	this.id = id||'';
	this.className = (className||'prlCombo');
	this.width = this.defaultWidth+'px';
	this.dropDown.className = 'prlDropDownTree';
	this.dropDown.width = 320;
	this.dropDown.height = 150;
	this.tree = new Prologue.treeView('tr'+id);
	this.tree.async = false;
	this.tree.onClick = 'Prologue.combo.result(Prologue.treeView.getSelected(this).caption, Prologue.treeView.getSelected(this).value);';
	this.editable = false;
	this.loadOnDropDown = false;
	this.defaultCaption = '';
	this.objectExt = 'Prologue.comboTree';
};
Prologue.comboTree.extend(Prologue.combo);

Prologue.comboTree.keydown = function(keyinfo)
{
	if (window.currentCombo) 
	{
		var tree = Prologue.comboTree.getTreeTable(window.currentCombo);
		return Prologue.treeView.keydown(tree, keyinfo);
	}
	return true;
}

Prologue.comboTree.prototype.attributes = function()
{
	var tmp = Prologue.comboTree.callBaseMethod(this, 'attributes');
	tmp += ' objectExt="'+this.objectExt+'"';
	return tmp;
};

Prologue.comboTree.prototype.add = function(caption, icon, onClick, value)
{
	return this.tree.add(caption, icon, onClick, value);
};

Prologue.comboTree.prototype.count = function()
{
	return this.tree.count();
};

Prologue.comboTree.prototype.html = function ()
{	
	function recurseNode(value, nodes)
	{
		var ret;
		for (var n = 0; n < nodes.count(); n++)
		{
			var node = nodes.item(n);
			if (node.value == value)
			{
				ret = node;
				break;
			}
			if (node.childs.count()>0)
			{
				var childRet = recurseNode(value, node.childs);
				if (typeof childRet != 'undefined')
				{
					ret = childRet; 
					break;
				}
			}
		}
		return ret;
	};
	
	if (this.value)
	{
		if (this.dataSource.indexOf('?') == -1)
		{
			this.dataSource += "?show="+this.value;
		}
		else
		{
			this.dataSource += "&show="+this.value;
		}
	}
	if (this.loadOnDropDown)
	{
		this.tree.dataSource = '<?xml version="1.0" encoding="UTF-8"?><databind>';
		this.tree.dataSource += '<row><item caption="-" value=""/></row>';
		if ((this.defaultCaption.length) && (this.value.length))
			this.tree.dataSource += '<row><item caption="'+this.defaultCaption+'" value="'+this.value+'"/></row>';
		this.tree.dataSource += '</databind>';
	}
	else
	{
		this.tree.dataSource = this.dataSource;
	}
	this.tree.load();
	this.tree.dataSource = ''; //On ne veut pas que la dataSource soit rechargee lors du html()
	var hasFound = false;
	
	if (this.value.length)
	{
		var item = recurseNode(this.value, this.tree.nodes);
		if(typeof item != 'undefined')
		{
			this.value = item.value;
			this.caption = item.caption;
			item.selected = true;
			hasFound = true;
		}
	}
	//Si on a pas trouve l'element de l'arbre correspondant a this.value,
	//on selectionne le premier element de la liste (s'il en existe)
	if(!hasFound && typeof this.tree.nodes.item(0) != 'undefined')
	{
		this.value = this.tree.nodes.item(0).value;
		this.caption = this.tree.nodes.item(0).caption;
		this.tree.nodes.item(0).selected = true;
	}
	this.tree.value = this.value;
	this.dropDown.content = this.tree.html();
	if (this.loadOnDropDown)
	{
		var ddF='var tableCombo = ((this.nodeName ==\'TD\')?this.parentNode.parentNode.parentNode:this);';
		ddF+='var ds = tableCombo.getAttribute(\'dataSource\');';
		ddF+='var cb = document.getElementById(tableCombo.id);';
		ddF+='var val = Prologue.comboTree.getSelected(cb).value;';
		ddF+='var ret = Prologue.treeView.reload(Prologue.comboTree.getTreeTable(cb), ds);';
		ddF+='if(ret) { if (val) Prologue.comboTree.selectNodeByValue(cb, val);';
		ddF+='			else Prologue.comboTree.selectNodeByIndex(cb,0,true);}';
		ddF+='tableCombo.setAttribute(\'dataSource\',\'\');';
		this.onDropDown=ddF;	
	}
	return Prologue.comboTree.callBaseMethod(this, 'html');
};

Prologue.comboTree.getSelected = function(comboTree)
{	
	if (typeof comboTree == 'string')
		comboTree = document.getElementById(comboTree);
		
	return Prologue.treeView.getSelected(Prologue.comboTree.getTreeTable(comboTree));
};

Prologue.comboTree.selectNodeByIndex = function(comboTree, index, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboTree == 'string')
		comboTree = document.getElementById(comboTree);
		
	var treeTable = Prologue.comboTree.getTreeTable(comboTree);
	var ret = Prologue.treeView.selectNodeByIndex(treeTable, index);
	var selected = Prologue.treeView.getSelected(treeTable);
	
	Prologue.combo.result(selected.caption, selected.value, comboTree, onClick);
	return ret;
};

Prologue.comboTree.selectNodeByValue = function(comboTree, value, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
				
	if (typeof comboTree == 'string')
		comboTree = document.getElementById(comboTree);
		
	var treeTable = Prologue.comboTree.getTreeTable(comboTree);
	var ret = Prologue.treeView.selectNodeByValue(treeTable, value);
	var selected = Prologue.treeView.getSelected(treeTable);
	
	Prologue.combo.result(selected.caption, selected.value, comboTree, onClick);
	return ret;
};

Prologue.comboTree.selectNodeByLikeValue = function(comboTree, value, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
				
	if (typeof comboTree == 'string')
		comboTree = document.getElementById(comboTree);
		
	var treeTable = Prologue.comboTree.getTreeTable(comboTree);
	var selected = Prologue.treeView.getSelected(treeTable);
	var ret = Prologue.treeView.selectNodeByLikeValue(treeTable, value, selected);
	var selected = Prologue.treeView.getSelected(treeTable);
	
	Prologue.combo.result(selected.caption, selected.value, comboTree, onClick);
	return ret;
};

Prologue.comboTree.reload = function(comboTree, dataSource, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboTree == 'string')
		comboTree = document.getElementById(comboTree);
		
	var ret = Prologue.treeView.reload(Prologue.comboTree.getTreeTable(comboTree), dataSource);
	
	if(ret)
	{
		Prologue.combo.result('', '', comboTree, onClick);
	}
	return ret;
};

Prologue.comboTree.getTreeTable = function (table)
{
	var dropDownDiv = table.rows[0].cells[0].childNodes[1];
	while (dropDownDiv.nodeName!='DIV')
		dropDownDiv = dropDownDiv.nextSibling;
		
	return dropDownDiv.firstChild;
};
////////////////////////////////
/// ComboPath Object ///
////////////////////////////////
Prologue.comboPath = function(id, value, onClick, className)
{
	Prologue.comboPath.callBaseConstructor(this, value, onClick);
	this.id = id||'';
	this.className = (className||'prlCombo');
	this.width = this.defaultWidth+'px';
	this.dropDown.className = 'prlDropDownPath';
	this.dropDown.height = 225;
	this.path = new Prologue.treeView();
	this.path.onClick = 'Prologue.combo.result(Prologue.treeView.getSelected(this).value, Prologue.treeView.getSelected(this).value);';
	this.dataSource = '';
	this.textBox.format = Prologue.textBox.formats.path;
	this.editable = false;
	this.objectExt = 'Prologue.comboPath';
};
Prologue.comboPath.extend(Prologue.combo);

Prologue.comboPath.keydown = function(keyinfo)
{
	if (window.currentCombo) 
	{
		var tree = Prologue.comboPath.getPathTable(window.currentCombo);
		return Prologue.treeView.keydown(tree, keyinfo);
	}
	return true;
}

Prologue.comboPath.prototype.attributes = function()
{
	var tmp = Prologue.comboPath.callBaseMethod(this, 'attributes');
	tmp += ' objectExt="'+this.objectExt+'"';
	return tmp;
};

Prologue.comboPath.prototype.html = function ()
{	
	this.path.dataSource = this.dataSource;
	this.path.value = this.value;
	
	this.dropDown.content = this.path.html();
	
	for(var i = 0; i < this.path.nodes.count(); ++i)
	{
		if(this.path.nodes.item(i).value == this.value)
		{
			this.value = this.path.nodes.item(i).value;
			break;
		}
	}
	
	return Prologue.comboPath.callBaseMethod(this, 'html');
};

Prologue.comboPath.getSelected = function(comboPath)
{
	return Prologue.treeView.getSelected(Prologue.comboPath.getPathTable(comboPath));
};

Prologue.comboPath.selectNodeByIndex = function(comboPath, index, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboPath == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboPath = document.getElementById(comboPath);
		
	var pathTable = Prologue.comboPath.getPathTable(comboPath);
	var ret = Prologue.treeView.selectNodeByIndex(pathTable, index);
	var selected = Prologue.treeView.getSelected(pathTable);
	
	Prologue.combo.result(selected.value, selected.value, comboPath, onClick);
	return ret;
};

Prologue.comboPath.selectNodeByValue = function(comboPath, value, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboPath == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboPath = document.getElementById(comboPath);
		
	var pathTable = Prologue.comboPath.getPathTable(comboPath);
	var ret = Prologue.treeView.selectNodeByValue(pathTable, value);
	var selected = Prologue.treeView.getSelected(pathTable);
	
	Prologue.combo.result(selected.value, selected.value, comboPath, onClick);
	return ret;
};

Prologue.comboPath.reload = function(comboPath, dataSource, onClick)
{
	if (typeof onClick == 'undefined')
		onClick = true;
		
	if (typeof comboPath == 'string')					//On a besoin de l'objet table pour l'utiliser avec Prologue.combo.result()
		comboPath = document.getElementById(comboPath);
		
	var ret = Prologue.treeView.reload(Prologue.comboPath.getPathTable(comboPath), dataSource);
	
	if(ret)
		Prologue.combo.result('', '', comboPath, onClick);
		
	return ret;
};

Prologue.comboPath.getPathTable = function (table)
{
	if (typeof table == 'string')
		table = document.getElementById(table);
		
	var dropDownDiv = table.rows[0].cells[0].childNodes[1];
	while (dropDownDiv.nodeName!='DIV')
		dropDownDiv = dropDownDiv.nextSibling;
		
	return dropDownDiv.firstChild;
};
//////////////////////////////////
/// GridCell Object ///
//////////////////////////////////
Prologue.gridCell = function(caption, icon, value, onClick)
{
	Prologue.gridCell.callBaseConstructor(this, caption, icon);
	this.onClick = (onClick||'');
	this.value = (value||'');
};
Prologue.gridCell.extend(Prologue.item);

Prologue.gridCell.prototype.bind = function(xItem)
{
	bindXmlToObj(this, xItem);
	if (this.icon=='' && this.caption=='') this.caption = '&nbsp;';
};

Prologue.gridCell.getCell = function(cell)
{
	var ret = new Prologue.gridCell();
	
	if (cell && cell.nodeName=='TD')
	{
		if (cell.attributes.getNamedItem('title'))
			ret.toolTip = cell.attributes.getNamedItem('title').value;
		if (cell.attributes.getNamedItem('class'))
			ret.className = cell.attributes.getNamedItem('class').value;
		if (cell.attributes.getNamedItem('prlValue'))
			ret.value = cell.attributes.getNamedItem('prlValue').value;
		var chld = cell.firstChild.firstChild;
		if (parseInt(cell.attributes.getNamedItem('prlCheckBox').value))
			chld = chld.rows[0].cells[1].firstChild;
		var itm = Prologue.item.getItem(chld);
		ret.icon = itm.icon;
		ret.caption = itm.caption;
	}
	return ret;
};
///////////////////////////////////
/// GridCellCollection Object ///
///////////////////////////////////
Prologue.gridRow = function()
{
	Prologue.gridRow.callBaseConstructor(this);
	this.onClick = '';
	this.selected = false;
	this.detail = '';
	this.toString = function() {
		return this.items[0].toString();
	};
};
Prologue.gridRow.extend(Prologue.collection);

Prologue.gridRow.prototype.add = function(caption, icon, value, onClick)
{
	var pos = this.items.length;
	this.items[pos] = new Prologue.gridCell(caption, icon, value, onClick);
	return this.items[pos];
};

Prologue.gridRow.prototype.bind = function(xRow)
{
	bindXmlToObj(this, xRow);
	if (xRow)
	{
		for (var pItem=0; pItem<xRow.childNodes.length; pItem++)
		{
			var xItem = xRow.childNodes[pItem];
			if (xItem.nodeName=='item')
			{
				var item = new Prologue.gridCell();
				item.bind(xItem);
				this.items.push(item);
			}
		}
	}
};

///////////////////////////////////
/// GridRowCollection Object ///
///////////////////////////////////
Prologue.gridRowCollection = function()
{
	Prologue.gridRowCollection.callBaseConstructor(this);
};
Prologue.gridRowCollection.extend(Prologue.collection);

Prologue.gridRowCollection.prototype.add = function()
{
	var pos = this.items.length;
	this.items[pos] = new Prologue.gridRow();
	return this.items[pos];
};

Prologue.gridRowCollection.prototype.html = function(columns, check, detail,columnsWidth)
{
	check=(check||false);
	detail=(detail||false);
	var rr = this.count();
	var rowsHtml = Array();
	var columnsHtml = Array();
	for (var r=0; r<rr; r++)
	{
		var row = this.items[r];
		var rowClass = ((row.selected)?'prlGridRowSelected':((r%2)?'prlGridRowOdd':'prlGridRowEven'));
		//***** affiche des cellules
		var cnb = columns.count();
		for (var c=0, cell; c<cnb; c++)
		{
			if ((columnsWidth) && (columnsWidth.length>c) && (columnsWidth[c] != "100%"))
			{
				hidden = true;
			}
			else
			{
				hidden = false;
			}
			if (c<row.items.length) {
				cell = row.items[c];
				//cell.alignment = columns.item(c).alignment;
			}
			else
				cell = new Prologue.gridCell();
			//***** affichage d'un cellule
			var toolTip = cell.toolTip;
			cell.toolTip = '';
			var columnHtml = '<td class="prlGridCell" prlValue="'+cell.value+'" ';
			if (toolTip)
				columnHtml += ' title="'+toolTip+'"';
			if (cell.onClick)
				columnHtml += ' onclick="'+cell.onClick+'"';
			if (c==0 && check) {
				columnHtml += ' prlCheckBox="1">';
				(hidden)?columnHtml += '<div style="overflow:hidden;width:'+columnsWidth[c]+';">':columnHtml += '<div>';
				columnHtml += '<table cellspacing="0" cellpadding="0"><tr><td><input style="float:left;" type="checkbox"'+((row.selected)?' checked':'')+'/></td><td>' + cell.html() + '</td></tr></table></div></td>';
			} else	{
				columnHtml += ' prlCheckBox="0">';
				(hidden)?columnHtml += '<div style="overflow:hidden;width:'+columnsWidth[c]+';">':columnHtml += '<div>';
				columnHtml += cell.html() + '</div></td>';
			}
			cell.toolTip = toolTip;
			columnsHtml[c] = columnHtml; 
		}
		if (columns.addLastColumn) 
			rowsHtml[r] = ['<tr prlDetail="0" class="',rowClass,'" prlSelected="',((row.selected)?'1':'0'),
						 '" onclick="Prologue.grid.rowOnClick(this);',((row.onClick)?row.onClick:''),
						 '" onmouseover="this.classSave=this.className;this.className=((this.attributes.getNamedItem(\'prlSelected\').value==\'1\')?\'prlGridRowOverSelected\':\'prlGridRowOver\');this.nextSibling.className=this.className;" onmouseout="this.className=((this.attributes.getNamedItem(\'prlSelected\').value==\'1\')?\'prlGridRowSelected\':this.classSave);this.nextSibling.className=this.className;this.classSave=\'\';">', 
						  columnsHtml.join('') , '<td>&nbsp;</td></tr><tr prlDetail="1" class="',rowClass,
						 '" style="',((detail)?'':'display:none;'),'" onmouseover="this.previousSibling.onmouseover();" onmouseout="this.previousSibling.onmouseout();" onclick="this.previousSibling.onclick();"><td class="prlGridCellDetail" colspan="',
						 (cnb+1),'">', (row.detail||'&nbsp;'), '</td></tr>'].join('');
		else
			rowsHtml[r] = ['<tr prlDetail="0" class="',rowClass,'" prlSelected="',((row.selected)?'1':'0'),
						 '" onclick="Prologue.grid.rowOnClick(this);',((row.onClick)?row.onClick:''),
						 '" onmouseover="this.classSave=this.className;this.className=((this.attributes.getNamedItem(\'prlSelected\').value==\'1\')?\'prlGridRowOverSelected\':\'prlGridRowOver\');this.nextSibling.className=this.className;" onmouseout="this.className=((this.attributes.getNamedItem(\'prlSelected\').value==\'1\')?\'prlGridRowSelected\':this.classSave);this.nextSibling.className=this.className;this.classSave=\'\';">', 
						  columnsHtml.join(''),'</tr><tr prlDetail="1" class="',rowClass,
						 '" style="',((detail)?'':'display:none;'),'" onmouseover="this.previousSibling.onmouseover();" onmouseout="this.previousSibling.onmouseout();" onclick="this.previousSibling.onclick();"><td class="prlGridCellDetail" colspan="',
						 cnb,'">', (row.detail||'&nbsp;'), '</td></tr>'].join('');
	}
	var tmp = ['<tbody>',rowsHtml.join(''),'</tbody>'].join('');
	return tmp;
};

Prologue.gridRowCollection.prototype.bind = function(xRoot)
{
	var nbR = xRoot.childNodes.length;
	for (var pRow=0; pRow<nbR; pRow++)
	{			
		var xRow = xRoot.childNodes[pRow];
		if (xRow.nodeName=='row')
		{
			var row = new Prologue.gridRow();
			row.bind(xRow);
			this.items.push(row);
		}
	}
};
//////////////////////////////////
/// GridColumn Object ///
/////////////////////////////////
Prologue.gridColumn = function(caption, icon, onClick)
{
	Prologue.gridColumn.callBaseConstructor(this, caption, icon);
	this.onClick = onClick||'';
	this.sortMode = Prologue.grid.columnSortMode.alpha;
	this.alignment = Prologue.item.alignment.center;
};
Prologue.gridColumn.extend(Prologue.item);

Prologue.gridColumn.prototype.html = function(columnIndex, columnWidth, divWidth)
{
	var toolTip = this.toolTip;
	this.toolTip = '';
	if (columnWidth != "100%")
	{
		var tmp = '<th style="width:'+columnWidth+';" class="prlGridColumn" onselectstart="return false;" onmousedown="return false;" prlSortMode="'+this.sortMode+'" prlColumnIndex="'+columnIndex+'"';
	}
	else
	{
		var tmp = '<th class="prlGridColumn" onselectstart="return false;" onmousedown="return false;" prlSortMode="'+this.sortMode+'" prlColumnIndex="'+columnIndex+'"';
	}
	if (this.sortMode == Prologue.grid.columnSortMode.none)
		tmp += ' style="cursor:default;"'
	if (toolTip)
		tmp += ' title="'+toolTip+'"';
	tmp += '>';
	tmp += '<table cellspacing="0" cellpadding="0" width="100%"><tr';
	if (divWidth != "100%")
	{
		tmp += '><td width="100%"><div style="overflow:hidden;width:'+divWidth+';" onclick="Prologue.grid.columnOnClick(this);'+this.onClick+'">'+Prologue.gridColumn.callBaseMethod(this, 'html')+'</div></td>';
	}
	else
	{
		tmp += '><td width="100%"><div onclick="Prologue.grid.columnOnClick(this);'+this.onClick+'">'+Prologue.gridColumn.callBaseMethod(this, 'html')+'</div></td>';
	}
	tmp += '<td class="prlGridColumnSort" onmousedown="Prologue.grid.columnOnStartResize(event,this);" ondblclick="Prologue.grid.columnOnFit(event,this);" ><img src="'+Prologue.grid.images.empty+'"/></td>';
	tmp += '</tr></table>';
	tmp += '</th>';
	
	return tmp;
};

Prologue.gridColumn.prototype.bind = function(xItem)
{
	bindXmlToObj(this, xItem);
};
///////////////////////////////////
/// GridColumnCollection Object ///
///////////////////////////////////
Prologue.gridColumnCollection = function()
{
	this.addLastColumn = true;
	Prologue.gridColumnCollection.callBaseConstructor(this);
};
Prologue.gridColumnCollection.extend(Prologue.collection);

Prologue.gridColumnCollection.prototype.add = function(caption, icon)
{
	var pos = this.items.length;
	this.items[pos] = new Prologue.gridColumn(caption, icon);
	return this.items[pos];
};

Prologue.gridColumnCollection.prototype.html = function(columnsWidth, divWidth)
{
	var tmp = '<tr>';
	for (var c=0; c<this.count(); c++) 
	{
		if ((columnsWidth) && (columnsWidth.length>c))
		{
			tmp += this.items[c].html(c,columnsWidth[c],divWidth[c]);
		}
		else
		{
			tmp += this.items[c].html(c,"100%","100%");
		}
	}
	if (this.addLastColumn) tmp += '<th style="width:100%;">&nbsp;</th>';
	tmp += '</tr>';
	return '<thead>'+tmp+'</thead>';
};

Prologue.gridColumnCollection.prototype.bind = function(xHeader)
{
	for (var pColumn=0; pColumn<xHeader.childNodes.length; pColumn++)
	{			
		var xColumn = xHeader.childNodes[pColumn];
		if (xColumn.nodeName=='item')
		{
			var column = new Prologue.gridColumn();
			column.bind(xColumn);
			this.items.push(column);
		}
	}
};
/////////////////////////
/// grid Object ///
/////////////////////////
Prologue.grid = function(id, onClick, className)
{
	Prologue.grid.callBaseConstructor(this, id, (className||'prlGrid'), '', onClick);
	this.columns = new Prologue.gridColumnCollection();
	this.rows = new Prologue.gridRowCollection();
	this.value = '';
	this.dataSource = '';
	this.dataSourceMaxRow = 0;
	this.async = false;
	this.sortCol = -1;
	this.sortDir = Prologue.grid.columnSortDir.ascending;
	this.multiSelect = false;
	this.checkBoxes = false;
	this.pageSize = 0;
	this.pageNum = 1;
	this.selectedNum = 0;
	this.pageToolBarId = '';
	this.stateToolBarId = '';
	this.noRefresh = 0;
	this.showDetail = false;
	this.setFocus = false;
	this.attributes = function() {
		var tmp = Prologue.grid.callBaseMethod(this, 'attributes')
			+ ' prlSortCol="-1"'
			+ ' prlSortDir="'+Prologue.grid.columnSortDir.ascending+'"'
			+ ' prlMaxRow="'+this.dataSourceMaxRow+'"'
			+ ' prlMulti="'+((this.multiSelect)?1:0)+'"'
			+ ' prlCheckBox="'+((this.checkBoxes)?1:0)+'"'
			+ ' prlPageSize="'+this.pageSize+'"'
			+ ' prlPageNum="'+this.pageNum+'"'
			+ ' prlSelectedNum="'+this.selectedNum+'"'
			+ ' prlDataSource="'+this.dataSource+'"'
			+ ' prlToolBar="'+this.pageToolBarId+'"'
			+ ' prlStateToolBar="'+this.stateToolBarId+'"'
			+ ' noRefresh="'+this.noRefresh+'"'
			+ ' prlDetail="'+((this.showDetail)?1:0)+'"'
			+ ' prlLastColumn="'+((this.columns.addLastColumn)?1:0)+'"'
			+ ' cellspacing="0"'
			+ ' cellpadding="0"'
			+ ' prlSetFocus="'+((this.setFocus)?1:0)+'"';
		return tmp;
	};
};
Prologue.grid.extend(Prologue.control);

Prologue.grid.columnSortMode = {
	 none:0
	,alpha:1
	,numeric:2
	,date:3
};

Prologue.grid.columnSortDir = {
	 ascending:0
	,descending:1
};

//genere le fragment HTML de la grille
Prologue.grid.prototype.html = function(columnsWidth, divWidth, cellWidth)
{
	if (!this.dataSource || this.async==false) {
		if (this.dataSource)
			this.load();

		if (this.value.length>0)
		{
			var value = this.value;			
			if (/function Array/.test(value.constructor)==false)
				value = new Array(value);
			for (var pRow=1, row; row = this.rows.item(pRow);pRow++)
			{
				for (var v=0; v<value.length; v++) {
					if (row.items.length>0 && row.items[0].value == value[v])
					{
						row.selected=true;
						value.splice(v,1);
						break;
					}
				}
				if (value.length==0) break;
			}
		}
	}
	else {
		this.columns.items = [];
		var col = this.columns.add('&nbsp;');
		col.sortMode = Prologue.grid.columnSortMode.none;
		this.rows.items = [];
		var row = this.rows.add();
		row.add(lang_msg_loading, Prologue.grid.images['wait']);
		var ds = this.dataSource;
		if (this.pageSize) {
			var already = (ds.indexOf('pageSize=')!=-1);
			if (already)
			{
				ds = ds.replace(/(pageSize=([0-9]{1,}))&(pageNum=([0-9]{1,}))/gi,'pageSize=' + this.pageSize + '&pageNum=' + this.pageNum );
			}
			else
			{
				var other = (ds.indexOf('?')!=-1);
				ds += (other?'&':'?') + 'pageSize=' + this.pageSize + '&pageNum=' + this.pageNum;
				if (this.noRefresh == 1)
				{
					ds += 'noRefresh=1';
				}
			}
		}
		var req = new Prologue.ajax.request(ds);
		req.tag = {
			 id:this.id
			,dataSource:ds
			,columnsWidth:columnsWidth
			,divWidth:divWidth
			,cellWidth:cellWidth
		};
		req.callBack = Prologue.grid.asyncLoad;
		req.send();
	}
	var tmp = '<table'+this.attributes()+' style="overflow:hidden;width:100%" tabindex="0" onkeydown="return Prologue.grid.keydown(this, event);">';
	tmp += this.columns.html(columnsWidth, divWidth);
	tmp += this.rows.html(this.columns, this.multiSelect && this.checkBoxes, this.showDetail, cellWidth);
	tmp += '</table>';
	return tmp;
};

//charge la collection de noeuds a partir d'une source de donnees en Ajax
Prologue.grid.prototype.load = function()
{
	var ret = false;
	if (this.dataSource) {
		//modif BM
		this.columns.items = [];
		this.rows.items = [];
		var ds = this.dataSource;
		if (this.pageSize) {
			var already = (ds.indexOf('pageSize=')!=-1);
			if (already)
			{
				ds = ds.replace(/(pageSize=([0-9]{1,}))&(pageNum=([0-9]{1,}))/gi,'pageSize=' + this.pageSize + '&pageNum=' + this.pageNum );
			}
			else
			{
				var other = (ds.indexOf('?')!=-1);
				ds += (other?'&':'?') + 'pageSize=' + this.pageSize + '&pageNum=' + this.pageNum;
				if (this.noRefresh == 1)
				{
					ds += 'noRefresh=1';
				}
			}
		}
		var req = new Prologue.ajax.request(ds);
		req.send();
		ret = this.fill(req.getXML());
	}
	return ret;
};

Prologue.grid.prototype.fill = function(xml) {
	var ret = false;
	if (xml) {
		var xRoot = xml.documentElement;
		if (xRoot) {
			var atb = xRoot.attributes.getNamedItem('maxRow');
			if (atb && typeof atb != 'undefined')
				this.dataSourceMaxRow = atb.value;
			atb = xRoot.attributes.getNamedItem('pageSize');
			if (atb && typeof atb != 'undefined')
				this.pageSize = atb.value;
			atb = xRoot.attributes.getNamedItem('pageNum');
			if (atb && typeof atb != 'undefined')
				this.pageNum = atb.value;
			this.columns.bind(xRoot.firstChild);
			this.rows.bind(xRoot);
			ret = true;
		}
	}
	return ret;
};

Prologue.grid.asyncLoad = function(req) {
	
	var ret = false;
	var grid = req.tag.id;
	grid = document.getElementById(grid);
	if (grid) {
		var onclick = '';
		if (grid.onclick) {
			var buffer = grid.onclick.toString().replace(/[\t\r\n]/g,'');
			var rx = new RegExp(/\{\s*(.*)\s*\}/g);
			var ar = rx.exec(buffer);
			if (ar) {
				onclick = ar[1];
				onclick = onclick.replace(/"/g, '\'');
			}
		}
		var gd = new Prologue.grid(grid.id, onclick, grid.className);
		gd.sortCol = grid.attributes.prlSortCol.value;
		gd.sortDir = grid.attributes.prlSortDir.value;
		gd.multiSelect = parseInt(grid.attributes.getNamedItem('prlMulti').value);
		gd.checkBoxes = parseInt(grid.attributes.getNamedItem('prlCheckBox').value);
		gd.showDetail = parseInt(grid.attributes.getNamedItem('prlDetail').value);
		gd.pageToolBarId = grid.attributes.getNamedItem('prlToolBar').value;
		gd.stateToolBarId = grid.attributes.getNamedItem('prlStateToolBar').value;
		gd.columns.addLastColumn = parseInt(grid.attributes.getNamedItem('prlLastColumn').value);
		gd.setFocus=parseInt(grid.attributes.getNamedItem('prlSetFocus').value);
		gd.fill(req.getXML());
		grid.insertAdjacentHTML('afterend', gd.html(req.tag.columnsWidth, req.tag.divWidth, req.tag.cellWidth));
		grid.removeNode(true);
		//reaffecte la data source dans le html de la grid
		grid = document.getElementById(gd.id);
		grid.attributes.getNamedItem('prlDataSource').value = req.url;
		//resync toolbar
		if (gd.pageToolBarId) Prologue.gridPageToolBar.resync(gd.id);
		if (gd.stateToolBarId) Prologue.gridPageToolBar.resync(gd.id, gd.stateToolBarId);
		ret=true;
		if(gd.setFocus==1)
			grid.focus();
	}
};

Prologue.grid.prototype.reload = function(dataSource, async) {
	this.dataSource = (dataSource||this.dataSource);
	if (typeof async!='undefined') this.async=async;
	var o = document.getElementById(this.id);
	o.insertAdjacentHTML('afterend', this.html())
	o.removeNode(true);
};

Prologue.grid.reload = function(grid, dataSource, async, noRefresh)
{
	async = (async||false);
	var ret = false;
	if (typeof grid == 'string')
		grid = document.getElementById(grid);
	if (grid)
	{
		dataSource = (dataSource||grid.attributes.getNamedItem('prlDataSource').value);
		if (dataSource) {
			var onclick = '';
			if (grid.onclick) {
				var buffer = grid.onclick.toString().replace(/[\t\r\n]/g,'');
				var rx = new RegExp(/\{\s*(.*)\s*\}/g);
				var ar = rx.exec(buffer);
				if (ar)
				{
					onclick = ar[1];
					onclick = onclick.replace(/"/g, '\'');
				}
			}
			var gd = new Prologue.grid(grid.id, onclick, grid.className);
			gd.sortCol = grid.attributes.prlSortCol.value;
			gd.sortDir = grid.attributes.prlSortDir.value;		
			gd.dataSourceMaxRow = grid.attributes.prlMaxRow.value;
			gd.multiSelect = parseInt(grid.attributes.getNamedItem('prlMulti').value);
			gd.checkBoxes = parseInt(grid.attributes.getNamedItem('prlCheckBox').value);
			gd.pageSize = parseInt(grid.attributes.getNamedItem('prlPageSize').value);
			gd.pageNum = parseInt(grid.attributes.getNamedItem('prlPageNum').value);
			gd.pageToolBarId = grid.attributes.getNamedItem('prlToolBar').value;
			gd.stateToolBarId = grid.attributes.getNamedItem('prlStateToolBar').value;
			gd.showDetail = parseInt(grid.attributes.getNamedItem('prlDetail').value);
			gd.columns.addLastColumn = parseInt(grid.attributes.getNamedItem('prlLastColumn').value);
			gd.setFocus=parseInt(grid.attributes.getNamedItem('prlSetFocus').value);
			gd.dataSource = dataSource;
			gd.noRefresh = noRefresh;
			gd.async = async;
			columnWidth = [];
			divWidth = [];
			cellWidth = [];
			for (i=0;i<grid.rows[0].cells.length;i++)
			{
				if (grid.rows[0].cells[i].nodeName == 'TH')
				{
					columnWidth[i] = grid.rows[0].cells[i].offsetWidth;
					//lorsque la grille est cachee (cas de formulaire avec plusieurs onglets) la taille "offsetWidth" est nulle
					if (grid.rows[0].cells[i].firstChild.nodeName == 'TABLE' && grid.rows[0].cells[i].firstChild.offsetWidth != 0)
					{
						divWidth[i] = grid.rows[0].cells[i].firstChild.rows[0].cells[0].firstChild.offsetWidth;
					}
					else
					{
						divWidth[i] = "100%";
						columnWidth[i] = "100%";
					}
					if (grid.rows.length > 1)
					{
						cellWidth[i] = 	grid.rows[1].cells[i].firstChild.offsetWidth;
						if (cellWidth[i] == 0){ //lorsque la grille est cachee (cas de formulaire avec plusieurs onglets)
							cellWidth[i] = 	"100%";
							divWidth[i] = "100%";
							columnWidth[i] = "100%";
						}
						else
						{
							for (j=3;j<grid.rows.length;j+=2)
							{
								if (grid.rows[j].cells[i].firstChild.offsetWidth > cellWidth[i])
								{
									cellWidth[i] = 	grid.rows[j].cells[i].firstChild.offsetWidth;
								}
							}
						}
					}
					else
					{
						cellWidth[i] = 	"100%";
						divWidth[i] = "100%";
						columnWidth[i] = "100%";
					}
				}
			}			
			grid.insertAdjacentHTML('afterend', gd.html(columnWidth, divWidth, cellWidth));
			grid.removeNode(true);
			//resync toolbar
			if (gd.pageToolBarId) Prologue.gridPageToolBar.resync(gd.id);
			if (gd.stateToolBarId) Prologue.gridPageToolBar.resync(gd.id, gd.stateToolBarId);
			ret=true;
		}
	}
	return ret;
};

Prologue.grid.keydown = function(grid, event)
{
	var keyinfo = getKeyInfo(event);
	var sel = Prologue.grid.getSelected(grid);
	var multi = parseInt(grid.attributes.prlMulti.value);
	var pageSize = parseInt(grid.attributes.getNamedItem('prlPageSize').value);
	var maxRow = parseInt(grid.attributes.getNamedItem('prlMaxRow').value);
	var pageCount = Math.ceil(maxRow/pageSize); 
	var start = 0;
	var end = 0;
	switch(keyinfo.key)
	{
		case 33: // pgup
			if(pageCount>1)
			{
				Prologue.ui.stopEvent(event); // pour éviter le décallage haut/bas de la fenêtre
				var gridStateTbr = grid.attributes.getNamedItem('prlstatetoolbar');
				if(gridStateTbr)
				{
					Prologue.gridPageToolBar.doAction(grid.id, -1, gridStateTbr.value);
					return false;
				}
			}
			return true;
		case 34: // pgdn
			if(pageCount>1)
			{
				Prologue.ui.stopEvent(event); // pour éviter le décallage haut/bas de la fenêtre
				var gridStateTbr = grid.attributes.getNamedItem('prlstatetoolbar');
				if(gridStateTbr)
				{
					Prologue.gridPageToolBar.doAction(grid.id, 1, gridStateTbr.value);
					return false;
				}
			}
			return true;
		case 35: // fin
			end = grid.rows.length/2 - 1;
			if(!multi || !event.shiftKey)
				start = end;
			else if(multi && event.shiftKey)
				start = sel[0];
			break;
		case 36: // début
			start = 0;
			if(!multi || !event.shiftKey)
				end = start;
			else if(multi && event.shiftKey)
				end = sel[sel.length - 1];
			break;
		//case 37: // gauche
		case 38: // haut
			if(multi)
			{
				if(event.shiftKey)
				{
					start = sel[0] - 1;
					end = sel[sel.length - 1];
				}
				else
					start = end = sel[0] - 1;
			}
			else
				start = end = sel - 1;
			if(start<0) start = 0;
			if(end<0) end = 0;
			break;
		//case 39: // droite
		case 40: // bas
			if(multi)
			{
				if(event.shiftKey)
				{
					start = sel[0];
					end = sel[sel.length - 1] + 1;
				}
				else
					start = end = sel[0] + 1;
			}
			else
				start = end = sel + 1;
			if(start>grid.rows.length/2 - 1) start = grid.rows.length/2 - 1;
			if(end>grid.rows.length/2 - 1) end = grid.rows.length/2 - 1;
			break;
		default:
			return true;
	}
	Prologue.ui.stopEvent(event); // pour éviter le décallage haut/bas de la fenêtre
	var oldClick = grid.onclick;
	grid.onclick = ''; // on masque le onclick
	
	if(multi==0 || event.shiftKey==0)
	{
		Prologue.grid.unselect(grid);
		Prologue.grid.selectRowByIndex(grid, start);
	}
	else
		Prologue.grid.selectRowByIndex(grid, start, end);

	sel = Prologue.grid.getSelected(grid);
	var row;
	if(multi)
		row = grid.rows[(sel[0].index+1)*2];
	else
		row = grid.rows[(sel.index+1)*2];

	Prologue.grid.scrollToElement(grid.parentNode, row.previousSibling);
	grid.onclick = oldClick;
	return false;
};

Prologue.grid.scrollToElement = function(grid, row)
{
	// scrolling du grid si nécessaire pour que la ligne soit visible
	var h = grid.scrollTop + grid.offsetHeight;
	if(row.offsetTop>h || row.offsetTop+row.offsetHeight>h || row.offsetTop<grid.scrollTop)
		grid.scrollTop = row.offsetTop - grid.offsetTop;
};

Prologue.grid.prototype.create = function()
{
	Prologue.grid.callBaseMethod(this, 'create');
	if (this.sortCol>=0)
		Prologue.grid.sort(this.id, this.sortCol, this.sortDir);
};

Prologue.grid.images =
{
	up : {
		name : 'sortUp.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,down : {
		name : 'sortDown.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,empty : {
		name : 'sortNone.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,wait : {
		name : 'load_img.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
};

Prologue.grid.rowOnClick = function(tr)
{
	var grid = tr.parentNode.parentNode;
	var selected = false;
	if (grid)
	{
		//calc row index
		for (var rowIndex=1, row;row=grid.rows[rowIndex];rowIndex+=2) {
			if (tr==row) break;
		}
		rowIndex = (rowIndex+1)/2;
		var selectedNum = 0;
		if (parseInt(grid.attributes.getNamedItem('prlMulti').value)) {
			selected = (parseInt(tr.attributes.getNamedItem('prlSelected').value)?false:true);
			tr.classSave=(((rowIndex-1)%2)?'prlGridRowOdd':'prlGridRowEven');
			selectedNum = parseInt(grid.attributes.getNamedItem('prlSelectedNum').value);
			selectedNum += ((selected)?1:-1);
		}
		else {
			selected = (parseInt(tr.attributes.getNamedItem('prlSelected').value)?false:true);
			tr.classSave=(((rowIndex-1)%2)?'prlGridRowOdd':'prlGridRowEven');
			Prologue.grid.unselect(grid);
			selectedNum = ((selected)?1:0);
		}
		Prologue.grid.rowSelect(grid, rowIndex, selected);
		grid.attributes.getNamedItem('prlSelectedNum').value = selectedNum;
		//resync toolbar
		var pageToolBarId = grid.attributes.getNamedItem('prlToolBar').value;
		var stateToolBarId = grid.attributes.getNamedItem('prlStateToolBar').value;
		if (pageToolBarId) Prologue.gridPageToolBar.resyncSelected(pageToolBarId, selectedNum);
		if (stateToolBarId) Prologue.gridPageToolBar.resyncSelected(stateToolBarId, selectedNum);
		
	}
};

Prologue.grid.rowSelect = function(grid, index, selected)
{
	if (typeof grid == 'string')
		grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE')
	{
		var checkBoxes = parseInt(grid.attributes.prlCheckBox.value);
		var row = grid.rows[(index*2)-1];
		row.attributes.getNamedItem('prlSelected').value = ((selected)?1:0);
		row.className = ((selected)?((row.className == 'prlGridRowOver')?'prlGridRowOverSelected':'prlGridRowSelected'):(((index-1)%2)?'prlGridRowOdd':'prlGridRowEven'));
		row.nextSibling.className = row.className;
		if (checkBoxes)
			row.cells[0].firstChild.firstChild.rows[0].cells[0].firstChild.checked = selected;
	}
};

Prologue.grid.selectAll = function(grid)
{
	if (typeof grid == 'string')
		grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE')
	{
		var multi = parseInt(grid.attributes.getNamedItem('prlMulti').value);
		if (multi) {
			Prologue.grid.unselect(grid);
			for (var r=1;r<grid.rows.length;r+=2) {
				grid.rows[r].onclick();
			}
		}
	}
};

Prologue.grid.unselect = function(grid)
{
	if (typeof grid == 'string')
		grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE')
	{
		var multi = parseInt(grid.attributes.getNamedItem('prlMulti').value);
		var sels = Prologue.grid.getSelected(grid);
		if (multi) {
			for (var r=0;r<sels.length;r++) {
				var sel = sels[r];
				if (sel.index>=0) Prologue.grid.rowSelect(grid, sel.index+1, false);
			}
		}
		else
			if (sels.index>=0) Prologue.grid.rowSelect(grid, sels.index+1, false);
		grid.attributes.getNamedItem('prlSelectedNum').value = 0;
		//resync toolbar
		var pageToolBarId = grid.attributes.getNamedItem('prlToolBar').value;
		var stateToolBarId = grid.attributes.getNamedItem('prlStateToolBar').value;
		if (pageToolBarId) Prologue.gridPageToolBar.resyncSelected(pageToolBarId, 0);
		if (stateToolBarId) Prologue.gridPageToolBar.resyncSelected(stateToolBarId, 0);	}
};

Prologue.grid.selectRowByIndex = function(grid, index, index2)
{
	var ret = false;

	if (typeof index == 'undefined') index = -1;
	if (typeof index2 == 'undefined') index2 = index;
	index = parseInt(index)+1;
	index2 = parseInt(index2)+1;
	if (index2<index) {var i=index;index=index2;index2=i;}

	if (typeof grid == 'string') grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE' && index < grid.rows.length/2)
	{
		var multi = parseInt(grid.attributes.prlMulti.value);
		if (multi) Prologue.grid.unselect(grid);
		
		if (index>0) {
			for (var r=index;r<=index2;r++) {
				grid.rows[(r*2)-1].onclick();
			}
		}
		else
			Prologue.grid.unselect(grid);
		if (grid.onclick) grid.onclick();
		ret = true;
	}
	return ret;
};

Prologue.grid.selectRowByValue = function(grid, value)
{
	var ret = false;
	if (typeof value != 'undefined')
	{
		if (typeof grid == 'string') grid = document.getElementById(grid);
		if (grid && grid.nodeName=='TABLE')
		{
			var multi = parseInt(grid.attributes.getNamedItem('prlMulti').value);
			if (multi) Prologue.grid.unselect(grid);

			if (/function Array/.test(value.constructor)==false)
				value = new Array(value);
			
			for (var r=1, tr; tr = grid.rows[r]; r+=2)
			{
				for (var v=0; v<value.length; v++) {
					if (tr.cells[0].attributes.prlValue.value == value[v]) {
						tr.onclick();
						value.splice(v,1);
						break;
					}
				}
				if (value.length==0) {
					ret=true;
					break;
				}
			}
		}
	}
	return ret;
};

Prologue.grid.getSelected = function(grid)
{
	var cItm = function() {
		this.caption='';
		this.value='';
		this.index=-1;
		this.toString = function(){return this.index;}
	};

	var selected = new Array();
	
	if (typeof grid == 'string') grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE')
	{
		for (var r=1; r < grid.rows.length; r+=2)
		{
			var row = grid.rows[r];
			if (row.attributes.getNamedItem('prlSelected').value == '1')
			{
				var pItm = Prologue.gridCell.getCell(row.cells[0]);
				var itm = new cItm();
				itm.caption = pItm.caption;
				itm.value = pItm.value;
				itm.index = (r-1)/2;
				selected.push(itm);
			}
		}
	}
	if (selected.length==0)	selected.push(new cItm());

	var multi = parseInt(grid.attributes.getNamedItem('prlMulti').value);
	if (multi)
		return selected;
	else
		return selected[0];
};

Prologue.grid.sort = function(grid, sortCol, sortDir)
{
	if (typeof sortDir == 'undefined') sortDir = Prologue.grid.columnSortDir.ascending;
	if (typeof sortCol == 'undefined') sortCol = 0;
	if (typeof grid == 'string')
		grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE')
	{
		if (sortCol<grid.rows[0].cells.length)
		{
			return Prologue.grid.columnOnClick(grid.rows[0].cells[sortCol], sortDir);
		}
	}
	return false;
};

Prologue.grid.columnOnClick = function(div, sortDir)
{	
	if (div.tagName == 'DIV')
		var column = div.parentNode.parentNode.parentNode.parentNode.parentNode;
	else var column = div;
	
	var sortMode = parseInt(column.attributes.getNamedItem('prlSortMode').value, 10);
	if (sortMode == Prologue.grid.columnSortMode.none) return false;
	
	function sortCompare(n1, n2)
	{	
		if (n1.value < n2.value)
			return -1;
		if (n2.value < n1.value)
			return 1;
		return 0;
	};	
	var sortCol=0;
	var pCol = column;
	while (pCol.previousSibling)
	{
		sortCol++;
		pCol = pCol.previousSibling;
	}
	var grid = column.parentNode.parentNode.parentNode;
	if (grid)
	{
		if (typeof sortDir == 'undefined')
		{
			sortDir = grid.attributes.prlSortDir.value;
			if (parseInt(grid.attributes.prlSortCol.value)==sortCol) 
				sortDir=(sortDir==Prologue.grid.columnSortDir.ascending)?Prologue.grid.columnSortDir.descending:Prologue.grid.columnSortDir.ascending;
			else
				sortDir=Prologue.grid.columnSortDir.ascending;
		}
		grid.attributes.prlSortCol.value=sortCol;
		grid.attributes.prlSortDir.value=sortDir;
		//Changement de l'icone de tri
		var th = grid;
		for (var c=0; c<th.rows[0].cells.length; c++)
		{
			if (th.rows[0].cells[c].firstChild.nodeName.toLowerCase()=='table') {
				var img = th.rows[0].cells[c].firstChild.rows[0].cells[1].firstChild;
				img.src = Prologue.grid.images[((c==sortCol)?((sortDir==Prologue.grid.columnSortDir.ascending)?'up':'down'):'empty')];
			}
		};
		//Construction du tableau pour tri
		var tb = grid.tBodies[grid.tBodies.length-1];
		//workaround pour opera 9
		//normalement ce serai grid.tBodies[0] puisque la grid n'as qu'un body
		//mais opera voit les tableau des entetes de colonnes comme un tbody...		
		var ar = new Array(tb.rows.length/2);
		for (var r=0; r<tb.rows.length; r+=2)
		{
			var item = Prologue.item.getItem(tb.rows[r].cells[sortCol].firstChild.firstChild);
			var colValue = item.caption;	
			switch (sortMode) {
				case Prologue.grid.columnSortMode.numeric : 
					colValue = parseFloat(colValue, 10);
					if (isNaN(colValue)) colValue=0;
					break;
				case Prologue.grid.columnSortMode.date : 
					var frmtlg=true;
					var re = new RegExp(/(\d{2})\/(\d{2})\/(\d{4}) (\d{2}):(\d{2}):(\d{2})/);
					var dateMatch = re.exec(colValue);
					if (!dateMatch){
						var re = new RegExp(/(\d{2})\/(\d{2})\/(\d{4})/);
						var dateMatch = re.exec(colValue);
						frmtlg=false;
					}
					if (frmtlg) colValue = (dateMatch)?parseInt(dateMatch[3]+dateMatch[2]+dateMatch[1]+dateMatch[4]+dateMatch[5]+dateMatch[6], 10):0;
					else colValue = (dateMatch)?parseInt(dateMatch[3]+dateMatch[2]+dateMatch[1], 10):0;
					break;
				default :
					break;
			}			
			ar[r/2] =
			{
				 value   : colValue
				,element : tb.rows[r]
				,detail  : tb.rows[r+1]
			};
		}
		//tri
		ar.sort(sortCompare);
		if (sortDir==Prologue.grid.columnSortDir.descending) ar.reverse();
		//recontruction de la grid
		var nextSibling = tb.nextSibling;
		grid.removeChild(tb);
		for (var row=0; row<ar.length; row++) {
			var selected = (ar[row].element.attributes.getNamedItem('prlSelected').value=='1');
			ar[row].element.className=((selected)?'prlGridRowOver':((row%2)?'prlGridRowOdd':'prlGridRowEven'));
			tb.appendChild(ar[row].element);
			ar[row].detail.className=ar[row].element.className;
			tb.appendChild(ar[row].detail);
		}
		grid.insertBefore(tb, nextSibling);
		return true;
	}
	return false;
};

Prologue.grid.setHiddenColumns = function(grid, columnIndex, columnWidth)
{
	var div = grid.rows[0].cells[columnIndex].firstChild.rows[0].cells[0].firstChild;
    div.style.overflow = "hidden";
	for (i=1;i<grid.rows.length;i+=2)
	{
		grid.rows[i].cells[columnIndex].firstChild.style.overflow = "hidden";
	}
}

Prologue.grid.columnOnStartResize = function(event, resize)
{
	Prologue.grid.currentResizingColumnHeader = resize.parentNode.parentNode.parentNode.parentNode;
	var grid = Prologue.grid.currentResizingColumnHeader.parentNode.parentNode.parentNode;
	var columnIndex = parseInt(Prologue.grid.currentResizingColumnHeader.attributes.getNamedItem('prlColumnIndex').value, 10);

	Prologue.grid.setHiddenColumns(grid, columnIndex, Prologue.grid.currentResizingColumnHeader.offsetWidth);
	Prologue.grid.currentStartResizingX = event.clientX;
	Prologue.grid.currentResizingColumnWidth = Prologue.grid.currentResizingColumnHeader.offsetWidth;
	Prologue.grid.currentResizingDivWidth = Prologue.grid.currentResizingColumnHeader.firstChild.rows[0].cells[0].firstChild.offsetWidth;
	if (grid.rows.length > 1)
	{
		Prologue.grid.currentResizingCellWidth = grid.rows[1].cells[columnIndex].firstChild.offsetWidth;
	}
	else
	{
		Prologue.grid.currentResizingCellWidth = 0;
	}

	document.attachEvent('onmousemove', Prologue.grid.columnOnResize);
	document.attachEvent('onmouseup', Prologue.grid.columnOnEndResize);
	document.body.style.cursor = 'e-resize';
	grid.style.cursor =  'e-resize';

	return false;
}

Prologue.grid.columnOnFit = function(event, resize)
{
	var header = resize.parentNode.parentNode.parentNode.parentNode;
	var grid = header.parentNode.parentNode.parentNode;
	var columnIndex = parseInt(header.attributes.getNamedItem('prlColumnIndex').value, 10);
	
	for (i=1;i<grid.rows.length;i+=2)
	{
		grid.rows[i].cells[columnIndex].firstChild.style.width = "";
		grid.rows[i].cells[columnIndex].firstChild.style.overflow = "";
	}
	header.firstChild.rows[0].cells[0].firstChild.style.width = "";
	header.firstChild.rows[0].cells[0].firstChild.style.overflow = "";
	header.style.width = "";
}

Prologue.grid.columnOnEndResize = function()
{
	if (Prologue.grid.currentResizingColumnHeader) {
		var grid = Prologue.grid.currentResizingColumnHeader.parentNode.parentNode.parentNode;
		Prologue.grid.currentResizingColumnHeader = null;
		grid.style.cursor =  '';
	}
	document.detachEvent('onmousemove', Prologue.grid.columnOnResize);
	document.detachEvent('onmouseup', Prologue.grid.columnOnEndResize);
	document.body.style.cursor= '';

}

Prologue.grid.columnOnResize = function()
{
	if ((Prologue.browser.ie) && (event.button != 1))
	{
		Prologue.grid.columnOnEndResize();
		return false;
	}
	if (Prologue.grid.currentResizingColumnHeader) {
		var deltaX = event.clientX - Prologue.grid.currentStartResizingX;
		columnWidth = Prologue.grid.currentResizingColumnWidth + deltaX;
		if (columnWidth > 0) 
		{
			var header = Prologue.grid.currentResizingColumnHeader;
			var col_index = header.attributes.getNamedItem('prlColumnIndex').value;
			var div = header.firstChild.rows[0].cells[0].firstChild;
			var grid = header.parentNode.parentNode.parentNode;

			var divWidth = Prologue.grid.currentResizingDivWidth + deltaX;

			if (divWidth > 0)
			{
				var cellWidth = 0;
				if (grid.rows.length > 1)
				{
					cellWidth = Prologue.grid.currentResizingColumnWidth + deltaX 
								- parseInt(grid.rows[1].cells[col_index].currentStyle.paddingLeft, 10)
								- parseInt(grid.rows[1].cells[col_index].currentStyle.paddingRight, 10);
				}
				Prologue.ui.setWidth(header, columnWidth);
				Prologue.ui.setWidth(div, divWidth);
				if (cellWidth > 0)
				{
					for(var i = 1; i < grid.rows.length; i += 2) {
						var cell_td = grid.rows[i].cells[col_index].firstChild;
						Prologue.ui.setWidth(cell_td, cellWidth);
					}
				}
			}
		}
	}
	return false;
}

Prologue.grid.showDetail = function(grid, bVisible) {
	if (typeof grid == 'string') grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE' && grid.rows.length>1)
	{
		//On veut mémoriser l'état demandée
		var etat_demande = bVisible;
		
		//Recherche si au moins un détail est affiché
		var at_least_one_detail = false
		for (var r=2, row; row=grid.rows[r]; r+=2)
			if (row.style.display == '') {
				at_least_one_detail = true;
				break;
			}
		
		grid.attributes.getNamedItem('prlDetail').value = '0';
		
		//Y a t il au moins une ligne sélectionnée ?
		var none_selected = true;
		for (var r=1, row; row=grid.rows[r]; r+=2)
			if (row.attributes.getNamedItem('prlSelected').value == '1') {
				none_selected = false;
				break;
			}
			
		//Si aucune ligne n'est selectionnée et que l'on a pas d'état demandé
		//alors on prend l'inverse de l'état de la première ligne
		if(none_selected && (typeof etat_demande == 'undefined'))
			etat_demande = (grid.rows[2].style.display=='none');

		if(none_selected && etat_demande)
			grid.attributes.getNamedItem('prlDetail').value = '1';
		
		for (var r=2, row; row=grid.rows[r]; r+=2) {
			//Si l'état n'a pas été donné on le cherche
			if(typeof etat_demande == 'undefined') {
				//Si au moins un détail est déjà affiché dans ce cas bVisible est true
				bVisible = (row.style.display=='none');
			}
			else
				bVisible = etat_demande;
				
			if(!bVisible || none_selected)
				row.style.display = ((bVisible)?'':'none');
			else if (grid.rows[r-1].attributes.getNamedItem('prlSelected').value == '1' || none_selected)
				row.style.display = ((bVisible)?'':'none');
		}
	}
}

//Obsolete utilisez getGridCell
Prologue.grid.getCellItem = function(grid, rowIndex, cellIndex) {
	return Prologue.grid.getGridCell(grid, rowIndex, cellIndex);
}
Prologue.grid.getGridCell = function(grid, rowIndex, cellIndex) {
	rowIndex = (rowIndex||0);
	cellIndex = (cellIndex||0);
	var pItm;
	if (typeof grid == 'string') grid = document.getElementById(grid);
	if (grid && grid.nodeName=='TABLE')
	{
		var row = grid.rows[(rowIndex*2)+1];
		if (row) {
			var cell = row.cells[cellIndex];
			if (cell) {
				var pItm = Prologue.gridCell.getCell(cell);
			}
		}
	}
	return pItm;
};

//////////////////////////
/// gridToolBar Object ///
//////////////////////////

Prologue.gridPageToolBar = function(id, className) {
	Prologue.grid.callBaseConstructor(this, id, (className||'prlToolBar'), '');
	this.gridId = null;
	this.toolbar = new Prologue.toolbar();
	this.btnRefresh = true;
	this.btnDetail = false;
	this.btnSelect = false;
	this.print = {
		 show : false
		,template : Prologue.framework.path + '/gridActions/gridDsPrint.php'
		,title : ''
		,subTitle : ''
	};
	this.csv = {
		 show : false
		,template : Prologue.framework.path + '/gridActions/gridDsCsv.php'
	}
	this.showPageCaption = false;	
	this.showNavigate = true;	
	this.showTotal = false;	
	this.showSelected = false;	
	this.showGoBack = false;	
	this.navigateToRight = false;
	this.attributes = function() {
		var tmp = Prologue.grid.callBaseMethod(this, 'attributes')
			+ ' prlGridId="'+this.gridId+'"'
			+ ' prlPrint="'+escape(this.print.template)+'"'
			+ ' prlPrintTitle="'+escape(this.print.title)+'"'
			+ ' prlPrintSubTitle="'+escape(this.print.subTitle)+'"'
			+ ' prlCsv="'+escape(this.csv.template)+'"';
		return tmp;
	};
}
Prologue.gridPageToolBar.extend(Prologue.control);

Prologue.gridPageToolBar.prototype.add = function(caption, icon, onClick, value)
{
	return this.toolbar.add(caption, icon, onClick, value);
};
Prologue.gridPageToolBar.hideCombo = function()
{
	if (window.currentToolbarCombo) {
		window.currentToolbarCombo.style.visibility = 'hidden';
		window.currentToolbarCombo = null;
		window.detachEvent('onmousedown', Prologue.gridPageToolBar.hideCombo);
	}
};

Prologue.gridPageToolBar.images =
{
	first : {
		name : 'first.png'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,previous : {
		name : 'previous.png'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,next : {
		name : 'next.png'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,last : {
		name : 'last.png'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,refresh : {
		name : 'refresh.png'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,detail : {
		name : 'detail.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,selectAll : {
		name : 'sel_all.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,drop : {
		name : 'toolbar_drop.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,print : {
		name : 'printer.png'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,csv : {
		name : 'export.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,back : {
		name : 'back.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
};

Prologue.gridPageToolBar.action = {
	 first:-2
	,previous:-1
	,select:0
	,next:1
	,last:2
	,detail:3
	,selectAll : 4
	,print : 5
	,csv : 6
	,goBack : 7
};

Prologue.gridPageToolBar.doAction = function(gridId, action, toolBar) {
	var grid = document.getElementById(gridId);
	var pageSize = parseInt(grid.attributes.getNamedItem('prlPageSize').value);
	var aPageNum = grid.attributes.getNamedItem('prlPageNum');
	var pageNum = parseInt(aPageNum.value);
	var maxRow = parseInt(grid.attributes.getNamedItem('prlMaxRow').value);
	var pageCount = Math.ceil(maxRow/pageSize);
	if (!toolBar) toolBar = grid.attributes.getNamedItem('prlToolBar').value;
	
	var pageDest = 0;
	var noRefresh = 0;
	var url = '';
	switch (action) {
		case Prologue.gridPageToolBar.action.first:
			pageDest = 1;
			noRefresh = 1;
			break;
		case Prologue.gridPageToolBar.action.previous:
			pageDest = ((pageNum>1)?pageNum-1:1);
			noRefresh = 1;
			break;
		case Prologue.gridPageToolBar.action.select:
			value = parseInt(document.getElementById(toolBar+'_txt').value);
			pageDest = ((value<=pageCount || pageCount==0)?value:pageCount);
			if (pageDest!=pageNum)
			{
				noRefresh = 1;
			}
			break;
		case Prologue.gridPageToolBar.action.next:
			pageDest = (pageNum<pageCount)?pageNum+1:pageCount;
			noRefresh = 1;
			break;
		case Prologue.gridPageToolBar.action.last:
			pageDest = pageCount;
			noRefresh = 1;
			break;
		case Prologue.gridPageToolBar.action.detail:
			Prologue.grid.showDetail(grid);
			break;
		case Prologue.gridPageToolBar.action.selectAll:
			Prologue.grid.selectAll(grid);
			break;
		case Prologue.gridPageToolBar.action.print:
			var req = new Prologue.ajax.request();
			var ds = grid.attributes.getNamedItem('prldatasource').value;
			var detail = grid.attributes.getNamedItem('prlDetail').value;
			var tbr = document.getElementById(toolBar);			
			var url = tbr.attributes.getNamedItem('prlPrint').value;
			var title = tbr.attributes.getNamedItem('prlPrintTitle').value;
			var subTitle = tbr.attributes.getNamedItem('prlPrintSubTitle').value;
			ds = ds.replace(new RegExp(/\+/g),' ');
			ds = ds.replace(new RegExp(/\s/g),'%20');
 			url += '?ds='+escape(ds)+'&detail='+detail+'&title='+title+'&subTitle='+subTitle+'&pn='+pageNum+'&pc='+pageCount;
			var opt = 'toolbar=no,location=no, directories=no,status=no,scrollbars=no,resizable=1';
			window.open(url,null,opt);
			break;
		case Prologue.gridPageToolBar.action.csv:
			var ds = grid.attributes.getNamedItem('prldatasource').value
			var tbr = document.getElementById(toolBar);			
			var url = tbr.attributes.getNamedItem('prlCsv').value
			ds = ds.replace(new RegExp(/\+/g),' ');
			ds = ds.replace(new RegExp(/\s/g),'%20');
 			url += '?ds='+escape(ds);
			var opt = 'toolbar=no,location=no, directories=no,status=no,scrollbars=no,resizable=1';
			window.open(url,null,opt);
			break;
		case Prologue.gridPageToolBar.action.goBack:
			history.go(-1)
			break;
	}
	if (pageDest!=0 && (pageDest!=pageNum || action == Prologue.gridPageToolBar.action.select)) {
		aPageNum.value = pageDest;
		Prologue.grid.reload(gridId, '', true, noRefresh);
	}
};

Prologue.gridPageToolBar.resync = function(gridId, tbrId) {
	var grid = document.getElementById(gridId);
	var pageNum = parseInt(grid.attributes.getNamedItem('prlPageNum').value);
	var pageSize = parseInt(grid.attributes.getNamedItem('prlPageSize').value);	
	var totalCount = parseInt(grid.attributes.getNamedItem('prlMaxRow').value);
	var pageCount = Math.ceil(totalCount / pageSize);
	if (!tbrId) tbrId = grid.attributes.getNamedItem('prlToolBar').value;
	var tbr = document.getElementById(tbrId);
	if ($(tbrId+'_txt')) $(tbrId+'_txt').value = pageNum;
	if ($(tbrId+'_max')) $(tbrId+'_max').innerHTML = pageCount;
	if ($(tbrId+'_total')) $(tbrId+'_total').innerHTML = totalCount + lang_gridPageToolBar_lbl_total;
	if ($(tbrId+'_selected')) $(tbrId+'_selected').innerHTML = '0' + lang_gridPageToolBar_lbl_selected;
};

Prologue.gridPageToolBar.resyncSelected = function(tbrId, selectedNum) {
	var tbr = document.getElementById(tbrId);
	if ($(tbrId+'_selected')) $(tbrId+'_selected').innerHTML = selectedNum + lang_gridPageToolBar_lbl_selected;
};

Prologue.gridPageToolBar.prototype.html = function() {
	function htmlItem(thisId, gridId, itm) {
		var tmp = '';
		//itm.onClick = itm.onClick.replace(new RegExp('\{gridId\}'), gridId);
		switch (itm.value) {
			case '__TOTAL__':
				 tmp += '<td class="prlRow" nowrap id="'+thisId+'_total'+'">0'+lang_gridPageToolBar_lbl_total+'</td>';
				 break;
			case '__SELECTED__':
				 tmp += '<td class="prlRow" nowrap id="'+thisId+'_selected'+'">0'+lang_gridPageToolBar_lbl_selected+' </td>';
				 break;
			case '__PAGE__':
				var txt = new Prologue.textBox(thisId+'_txt', Prologue.textBox.formats.uinteger);
				txt.value='1';
				txt.width='30px';
				txt.onKeyPress = 'if(event.keyCode==13)'
					+'Prologue.gridPageToolBar.doAction(\''+gridId+'\','+Prologue.gridPageToolBar.action.select+',\''+thisId+'\');'
					+ txt.onKeyPress;
				tmp += '<td class="prlRow" nowrap style="vertical-align:center;">'+lang_gridPageToolBar_lbl_page+'&nbsp;'+txt.html()+'&nbsp;/</td>'
					 + '<td class="prlRow" id="'+thisId+'_max'+'">1</td>';
				break;
			case '__SEPARATOR__':
				tmp += '<td style="background:url('+Prologue.framework.images+'/toolbar_separator.gif) repeat-y center;">&nbsp;</td>'
				break;
			case '__RIGHT__':
				tmp += '<td style="width:100%;">&nbsp;</td>'
				break;
			case '__CMBSEL__':
				tmp += '<td class="prlRow"'
					+ ' onmouseover="this.className=\'prlRowOver\';"'
					+ ' onmouseout="this.className=\'prlRow\';"'
					+ ' onclick="var m=this.childNodes[1];'
						+ 'var v = m.style.visibility==\'visible\';'
						+ 'if(!v){'
							+ 'window.currentToolbarCombo=m;'
							+ 'window.attachEvent(\'onmousedown\', Prologue.gridPageToolBar.hideCombo);'
							+ 'm.style.visibility=\'visible\';'
						+ '}'
						+ 'else'
							+ ' Prologue.gridPageToolBar.hideCombo();'
						+ '"'
				+ '>'
					+ '<table class="prlItem" cellspacing="0">'
					+ '<tr>'
					+ '<td class="prlCaption">'+lang_gridPageToolBar_lbl_select
					+ '</td>'
					+ '<td class="prlIcon"><img src="' + Prologue.gridPageToolBar.images.drop + '"/></td>'
					+ '</tr></table>'
					+ '<table class="prlList" style="width:100px;position:absolute;overflow:visible;visibility:hidden;background-color:#FFF;border:1px solid #000;"'
					+ ' onmousedown="event.cancelBubble=true;return false;"'
					+ '>'
					+ '<tr onclick="Prologue.grid.selectAll(\''+gridId+'\');"><td class="prlRow" onmouseover="this.className=\'prlRowOver\';" onmouseout="this.className=\'prlRow\';">'+lang_gridPageToolBar_lbl_tous+'</td></tr>'
					+ '<tr onclick="Prologue.grid.unselect(\''+gridId+'\');"><td class="prlRow" onmouseover="this.className=\'prlRowOver\';" onmouseout="this.className=\'prlRow\';">'+lang_gridPageToolBar_lbl_aucun+'</td></tr>'
					+ '</table>'
					+ '</td>';
				break;
			default:
				tmp += itm.html();
		}
		return tmp;
	}
	

	var tmp = '<table'+this.attributes()+' cellspacing="2" cellpadding="2"><tr>';

	var	addSeparator = false;
	if (this.toolbar.items.count()) {
		for (var c=0; c<this.toolbar.items.count(); c++) {
			var item = this.toolbar.items.item(c);
			tmp += htmlItem(this.id, this.gridId, item);
		}
		addSeparator = true;
	}

	if (this.showTotal) {
		if (addSeparator) tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__SEPARATOR__'));
		tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__TOTAL__'));
		addSeparator = true;
	}
	if (this.showSelected) {
		if (addSeparator) tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__SEPARATOR__'));
		tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__SELECTED__'));
		addSeparator = true;
	}

	if (this.showNavigate) {
		if (this.navigateToRight) 
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__RIGHT__'));
		if (addSeparator) tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__SEPARATOR__'));
		if (this.showPageCaption) {
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_first, Prologue.gridPageToolBar.images.first, 'Prologue.gridPageToolBar.doAction(\''+this.gridId+'\','+Prologue.gridPageToolBar.action.first+',\''+this.id+'\');'))
				+  htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_prev, Prologue.gridPageToolBar.images.previous, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.previous+',\''+this.id+"\');"))
				+  htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__PAGE__'))
				+  htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_next, Prologue.gridPageToolBar.images.next, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.next+',\''+this.id+"\');"))
				+  htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_last, Prologue.gridPageToolBar.images.last, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.last+',\''+this.id+"\');"));
		}
		else {
			var itm = new Prologue.listItem('', Prologue.gridPageToolBar.images.first, 'Prologue.gridPageToolBar.doAction(\''+this.gridId+'\','+Prologue.gridPageToolBar.action.first+',\''+this.id+'\');');
			itm.toolTip = lang_gridPageToolBar_lbl_first;
			tmp += htmlItem(this.id, this.gridId, itm);
			var itm = new Prologue.listItem('', Prologue.gridPageToolBar.images.previous, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.previous+',\''+this.id+"\');");
			itm.toolTip = lang_gridPageToolBar_lbl_prev;
			tmp	+= htmlItem(this.id, this.gridId, itm);
			tmp +=  htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__PAGE__'))
			var itm = new Prologue.listItem('', Prologue.gridPageToolBar.images.next, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.next+',\''+this.id+"\');");
			itm.toolTip = lang_gridPageToolBar_lbl_next;
			tmp +=  htmlItem(this.id, this.gridId, itm);
			var itm = new Prologue.listItem('', Prologue.gridPageToolBar.images.last, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.last+',\''+this.id+"\');");
			itm.toolTip = lang_gridPageToolBar_lbl_last;
			tmp +=  htmlItem(this.id, this.gridId, itm);
		}
		addSeparator = true;
	}
	
	if (this.btnRefresh || this.btnDetail || this.btnSelect){
		if (addSeparator) tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__SEPARATOR__'));
		if (this.btnRefresh) 
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_refresh, Prologue.gridPageToolBar.images.refresh, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.select+',\''+this.id+"\');"));
		if (this.btnDetail)
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_detail, Prologue.gridPageToolBar.images.detail, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.detail+',\''+this.id+"\');"));
		if (this.btnSelect)
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__CMBSEL__'));
		addSeparator = true;
	}
	if (this.print.show || this.csv.show) {
		if (addSeparator) tmp += htmlItem(this.id, this.gridId, new Prologue.listItem('', '', '', '__SEPARATOR__'));
		if (this.print.show) 
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_print, Prologue.gridPageToolBar.images.print, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.print+',\''+this.id+"\');"));
		if (this.csv.show) 
			tmp += htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_export, Prologue.gridPageToolBar.images.csv, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.csv+',\''+this.id+"\');"));
		addSeparator = true;
	}
	if (this.showGoBack) 
		tmp += htmlItem(this.id, this.gridId, new Prologue.listItem(lang_gridPageToolBar_lbl_back, Prologue.gridPageToolBar.images.back, "Prologue.gridPageToolBar.doAction('"+this.gridId+"',"+Prologue.gridPageToolBar.action.goBack+',\''+this.id+"\');"));

	tmp += '</tr></table>';
	return tmp;
};

Prologue.window = function(caption, icon, content)
{
	Prologue.window.callBaseConstructor(this, caption, icon, content);
	this.className = 'prlWindow';
	this.title.alignment = Prologue.item.alignment.left;
	this.visible = true;
	this.moveable = true;
	this.closeButton = true;
	this.skin = '';
	this.startUpPosition = Prologue.window.startUpPosition.centerScreen;
	this.titlePosition = Prologue.container.titlePosition.top;
	this.left = 0;
	this.top = 0;
	this.modal = true;
	this.attributes = function() {
		return Prologue.window.callBaseMethod(this, 'attributes')
			+ ' prlModal="' + ((this.modal)?1:0) + '"'
			+ ' cellspacing="0"'
			+ ' cellpadding="0"';
	};
};
Prologue.window.extend(Prologue.container);

Prologue.window.startUpPosition = {
	 htmlDefault:0
	,manual:1
	,centerScreen:2
};

Prologue.window.images =
{
	titleLeft : {
		name : 'coin_onglet_gauche.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,titleBkg : {
		name : 'pixel_onglet_haut.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,titleRight : {
		name : 'coin_onglet_droit.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
	,closeButton : {
		name : 'windowClose.gif'
		,toString : function() {
			return Prologue.framework.images + '/' + this.name;
		}
	}
};

Prologue.window.prototype.html = function()
{
	var skinPath = (this.skin || Prologue.framework.images) + '/';
	
	var tmp = '<table'+this.attributes()
		+ ' style="z-index:9999;'
		+ ((!this.visible)?'display:none;':'')
		+ '">'
		+ '<tr><td' + ((this.moveable)?' onmousedown="Prologue.window.dragStart(event, this);"':'') + '>';
		
	tmp += '<table cellspacing="0" cellpadding="0" width="100%"><tr>';
	tmp += '<td><img src="'+skinPath+Prologue.window.images.titleLeft.name+'"/></td>';
	tmp += '<td class="prlTitle" style="background-image:url('+skinPath+Prologue.window.images.titleBkg.name+');background-repeat:repeat-x;">'+this.title.html()+'</td>';
	if (this.closeButton) {
		tmp += '<td onclick="Prologue.window.close(\''+this.id+'\');"';
		tmp += ' style="cursor:pointer;background-image:url('+skinPath+Prologue.window.images.titleBkg.name+');background-repeat:repeat-x;"><img src="'+Prologue.window.images.closeButton+'"/></td>';
	}
	tmp += '<td><img src="'+skinPath+Prologue.window.images.titleRight.name+'"/></td>';
	tmp += '</tr></table>';
	tmp += '</td></tr>';
	tmp += '<tr><td class="prlWindowContent"><div class="prlWindowContentDiv" style="';
	if (this.clientHeight || this.clientWidth) {
		tmp += 'overflow:auto;';
		if (this.clientHeight) tmp += 'height:'+this.clientHeight+';';
		if (this.clientWidth) tmp += 'width:'+this.clientWidth+';"';
	}	
	tmp += '">'+this.content+'</div></td></tr>';
	tmp += '</table>';
	
	return tmp;
};

Prologue.window.prototype.create = function()
 {
 	Prologue.window.callBaseMethod(this, 'create');
	switch(this.startUpPosition){
		case Prologue.window.startUpPosition.manual:
			Prologue.window.moveTo(this.id, {'left':this.left,'top':this.top});
			break;
		case Prologue.window.startUpPosition.centerScreen:
			Prologue.window.centerScreen(this.id);
			break;
		case Prologue.window.startUpPosition.htmlDefault:
		default:
			break;
	}
 }

Prologue.window.drag = function() {
	if (Prologue.window.activeWindow) {
		var table = Prologue.window.activeWindow;
		table.style.left = event.clientX - table.xOffset;
		table.style.top = event.clientY - table.yOffset;
	}
};
			
Prologue.window.dragStart = function(evt, td) {
	var table = td.parentNode.parentNode.parentNode;
	table.style.position = 'absolute';
	table.xOffset = evt.clientX+document.body.scrollLeft-table.offsetLeft;
	table.yOffset = evt.clientY+document.body.scrollTop-table.offsetTop;
	table.style.cursor = 'move';
	Prologue.window.activeWindow = table;
	document.attachEvent('onmouseup', Prologue.window.dragEnd);
	document.attachEvent('onmousemove', Prologue.window.drag);
	//masquage des iframe  pour eviter la perte des events souris durant le drag
	var ifs = document.getElementsByTagName('IFRAME');
	Prologue.window.hiddenIframes = new Array();
	for (var pIf=0, ifm; ifm=ifs[pIf++];) {
		if (ifm.style.visibility!='hidden') {
			Prologue.window.hiddenIframes.push(ifm);
			ifm.style.visibility='hidden';
		}
	}
};

Prologue.window.dragEnd = function() {
	if (Prologue.window.activeWindow) {
		Prologue.window.activeWindow.style.cursor = 'default';
		document.attachEvent('onmouseup', Prologue.window.dragEnd);
		document.detachEvent('onmousemove', Prologue.window.drag);
		Prologue.window.activeWindow = null;
		//affichage de tous les iframes pour eviter la perte des events souris durant le drag
		for (var pIf=0, ifm; ifm=Prologue.window.hiddenIframes[pIf++];)	ifm.style.visibility='visible';
		Prologue.window.hiddenIframes = null;
	}
};

Prologue.window.centerScreen = function(window)
{
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE')
	{
		var h = document.body.clientHeight;
		var w = document.body.clientWidth;
		return Prologue.window.moveTo(window, {'left':(w - window.offsetWidth)/2,'top':(h - window.offsetHeight)/2});
	}
	return false;
};

Prologue.window.moveTo = function(window, point)
{
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE')
	{
		window.style.top = point.top;
		window.style.left = point.left;
		return true;
	}
	return false;
}

Prologue.window.isVisible = function(window){
	var ret = false;
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE')	ret = (window.style.display!='none');
	return ret;
}
Prologue.window.setVisible = function(window, visible)
{
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE') {		
		if (typeof visible == 'undefined') visible = !(window.style.display!='none');
		if (visible)
			Prologue.window.open(window, false);
		else
			Prologue.window.close(window);
	}
};

Prologue.window.open = function(wnd, modal)
{
	modal = (modal||false);
	if (typeof wnd == 'string') wnd = document.getElementById(wnd);
	if (wnd && wnd.nodeName=='TABLE') {
		if (modal) {
			var tmp = '<div id="'+wnd.id+'_modal" style="display:none;z-index:9998;background-color:#A0A0A0;position:absolute;top:0px;left:0px;width:800px;height:600px;"></div>';			
			document.body.insertAdjacentHTML('afterbegin', tmp);
			var m = $(wnd.id+'_modal');
			m.style.width = document.body.clientWidth+'px';
			m.style.height = document.body.clientHeight+'px';
			Prologue.ui.setOpacity(m, 30);
			m.style.display = '';
			document.body.appendChild(wnd);
			wnd.style.zIndex=9999;
			wnd.style.display = '';
			Prologue.window.centerScreen(wnd);
		}
		else
			wnd.style.display = '';
	}
};

Prologue.window.close = function(window)
{
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE') {
		var m = $(window.id+'_modal');
		if (m)
			document.body.removeChild(m);
		window.style.display = 'none';
	}
};
/////////////////////////
/// toolBar Object ///
/////////////////////////
Prologue.toolbar = function(id, onClick, className)
{
	Prologue.toolbar.callBaseConstructor(this, id, onClick, (className||'prlToolBar'));
	this.style = Prologue.toolbar.style.button;
};
Prologue.toolbar.extend(Prologue.list);

Prologue.toolbar.style =
{
	buttonGroup:0
	,button:1
};


Prologue.toolbar.reload = function(toolbar, dataSource)
{
	var ret = false;
	if (typeof toolbar == 'string')
		toolbar = document.getElementById(toolbar);
	if (toolbar && dataSource)
	{
		var onclick = '';
		if (toolbar.onclick) {
			var buffer = toolbar.onclick.toString().replace(/[\r\n]/g,'');
			var rx = new RegExp(/\{(.*)\}/g);
			onclick = rx.exec(buffer)[1];
			onclick = onclick.replace(/"/g, '\'');
		}		
		var tbr = new Prologue.toolbar(toolbar.id, onclick, toolbar.className);
		tbr.dataSource = dataSource;
		$(tbr.id).insertAdjacentHTML('afterend', tbr.html());
		toolbar.removeNode(true);
		ret=true;
	}
	return ret;
};

Prologue.toolbar.prototype.html = function()
{
	if (this.dataSource) this.load();
	if (this.value.length>0 && this.style==Prologue.toolbar.style.buttonGroup)
	{
		for (var pRow=0; pRow<this.items.count(); pRow++)
		{
			if (this.items.item(pRow).value == this.value)
			{
				this.items.item(pRow).selected=true;
				break;
			}
		}
	}
	var tmp = '<table prlToolBarStyle="'+this.style+'" summary=""'+this.attributes()+' cellspacing="2" cellpadding="2"><tr>';
	for (var c=0; c<this.items.count(); c++) {
		var item = this.items.item(c);
		switch (item.value) {
			case '__SEPARATOR__':
				tmp += '<td style="background:url('+Prologue.framework.images+'/toolbar_separator.gif) repeat-y center;">&nbsp;</td>'
				break;
			default:
				item.onClick = "Prologue.toolbar.click(this);"+item.onClick;
				tmp += item.html();
				break;
		}
	}		
	tmp += '</tr></table>';
	return tmp;
};

Prologue.toolbar.click = function(td)
{
	var tbl = td.parentNode.parentNode.parentNode;
	if (tbl)
	{
		var style=tbl.attributes.getNamedItem('prlToolBarStyle').value;
		if (style==Prologue.toolbar.style.buttonGroup) {
			var curCell = Prologue.toolbar.getSelected(tbl).index;
			if (curCell>=0)
			{
				var cell = tbl.rows[0].cells[curCell];
				cell.attributes.getNamedItem('prlSelected').value = '0';
				cell.className = 'prlRow';
			}
			td.attributes.getNamedItem('prlSelected').value = '1';
			td.className = 'prlRowSelected';
		}
	}
};

Prologue.toolbar.getSelected = function(table)
{
	var itm = 
	{
		'caption':'',
		'value':'',
		'index':-1,
		'toString':function(){return this.index;}
	};
	if (typeof table == 'string') table = document.getElementById(table);
	if (table && table.nodeName=='TABLE')
	{
		for (var r=0; r < table.rows[0].cells.length; r++)
		{
			var cell = table.rows[0].cells[r];
			if (cell.attributes.getNamedItem('prlSelected').value == '1')
			{
				var pItm = Prologue.item.getItem(cell.firstChild);
				itm.caption = pItm.caption;
				itm.value = cell.attributes.getNamedItem('prlValue').value;
				itm.index = r;
				break;
			}
		}
	}
	return itm;
};

Prologue.toolbar.selectByIndex = function(toolBar, index)
{
	var ret = false;
	if (typeof toolBar == 'string') toolBar = document.getElementById(toolBar);
	if (toolBar && toolBar.nodeName=='TABLE' && index < toolBar.rows[0].cells.length)
	{
		if (index>=0)
		{
			var td = toolBar.rows[0].cells[index];
			td.onclick();
			if (toolBar.onclick) toolBar.onclick();
			ret = true;
		}
		else //deselection de la ligne courante
		{		
			var curCell = Prologue.toolbar.getSelected(toolBar).index;
			if (curCell>=0)
			{
				var cell = toolBar.rows[0].cells[curCell];
				cell.attributes.getNamedItem('prlSelected').value = '0';
				cell.className = 'prlRow';
				if (toolBar.onclick) toolBar.onclick();
			}
		}			
	}
	return ret;
};

Prologue.toolbar.selectByValue = function(toolBar, value)
{
	var ret = false;
	if (typeof value != 'undefined')
	{
		if (typeof toolBar == 'string') toolBar = document.getElementById(toolBar);
		if (toolBar && toolBar.nodeName=='TABLE')
		{
			for (var r=0; r<toolBar.tBodies[0].rows[0].cells.length; r++)
			{
				var td = toolBar.tBodies[0].rows[0].cells[r];
				if (td.attributes.prlValue.value == value)
				{
					td.onclick();
					if (toolBar.onclick) toolBar.onclick();
					ret = true;
					break;
				}
			}
		}
	}
	return ret;
};

////////////////////////////////
/// help Object           ///
////////////////////////////////
Prologue.help = function(caption, icon)
{
	Prologue.help.callBaseConstructor(this, caption, icon);
	this.className = 'prlHelp';
	this.helpFile = '';
	this.visible = false;
	this.moveable = true;
	this.attributes = function() {
		var tmp = Prologue.help.callBaseMethod(this, 'attributes');
		tmp += ' prlHelpFile="'+this.helpFile+'"';	
		return tmp;
	};
	this.object = null;
	this.helpId = 0;
	this.recurse = false;
	this.show = function() {
		if (this.object) {
			var cnt = Prologue.container.getContent(this.object);
			cnt.innerHTML = lang_msg_loading;
			Prologue.help.resize(this.object);
			Prologue.help.setVisible(this.object, true);
			Prologue.help.centerScreen(this.object);
	
			var url = Prologue.framework.path+'/help.php?id='+this.helpId+'&src='+escape(this.helpFile)+'&recurse='+(this.recurse?1:0);
			var req = new Prologue.ajax.request(url);
			req.tag = this.object;
			req.callBack = Prologue.help.callBack;
			req.send(null);
		}
	}
};
Prologue.help.extend(Prologue.window);
//inherit static functions
Prologue.help.setVisible = Prologue.window.setVisible;
Prologue.help.centerScreen = Prologue.window.centerScreen;
Prologue.help.moveTo = Prologue.window.moveTo;
Prologue.help.isVisible = Prologue.window.isVisible;
Prologue.help.setVisible = Prologue.window.setVisible;

Prologue.help.prototype.create = function() {
	Prologue.help.callBaseMethod(this, 'create');
	this.object = document.getElementById(this.id);
};

Prologue.help.callBack = function(req)
{
	var wnd = req.tag;
	var hlps = req.getJson();
	if (typeof wnd == 'string') wnd = document.getElementById(wnd);
	if (wnd && wnd.nodeName=='TABLE') {
		var cnt = Prologue.container.getContent(wnd);
		var tmp = '';
		for (var h=0; h<hlps.docs.length; h++) {
			var hlp = hlps.docs[h];
			tmp += (h?'<hr/>':'')+'<table><tr><td><img src="' + Prologue.framework.images + '/help_32.png"/></td><td class="prlHelpTitle">'+hlp.titre+'</td></tr></table><hr/>'+hlp.texte;
		}
		cnt.innerHTML = tmp;
	}
};
Prologue.help.read = function(helpFile, helpId, recurse)
//Lecture synchrone d'un chapitre de l'aide
{
	recurse = (recurse||0);
	var url = Prologue.framework.path+'/help.php?id='+helpId+'&src='+escape(helpFile)+'&recurse='+(recurse?1:0);
	var req = new Prologue.ajax.request(url);
	req.send(null);
	return req.getJson();
}
Prologue.help.show = function(window, helpId, recurse)
{
	recurse = (recurse||0);
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE' && helpId) {
		var helpFile =  window.attributes.getNamedItem('prlHelpFile').value;		
		var url = Prologue.framework.path+'/help.php?id='+helpId+'&src='+escape(helpFile)+'&recurse='+(recurse?1:0);
		var cnt = Prologue.container.getContent(window);
		cnt.innerHTML = 'Chargement en cours...';
		Prologue.help.resize(window);
		Prologue.help.setVisible(window, true);
		Prologue.help.centerScreen(window);
		var req = new Prologue.ajax.request(url);
		req.tag = window;
		req.callBack = Prologue.help.callBack;
		req.send(null);
	}
};
Prologue.help.resize = function(window)
{
	if (typeof window == 'string') window = document.getElementById(window);
	if (window && window.nodeName=='TABLE') {
		var cnt = Prologue.container.getContent(window);
		cnt.style.width = document.body.clientWidth * 3 / 4;
		cnt.style.height = document.body.clientHeight * 3 / 4;
	}	
};

//////////////////////////
/// Rss Object ///
//////////////////////////
Prologue.rss = function(caption, icon)
{
	caption = (caption||'Flux d\'information');
	icon = (icon||Prologue.framework.images+'/rss.gif');
	Prologue.rss.callBaseConstructor(this, caption, icon, '<img align="left" src="'+Prologue.framework.images+'/load_img.gif'+'"/>Chargement en cours...');
	this.className = 'prlRss';
	this.title.alignment = Prologue.item.alignment.left;
	this.open = true;
	this.url = '';
	this.itemsQty = 10;
};
Prologue.rss.extend(Prologue.panel);
//inherit static functions
Prologue.rss.getContent = Prologue.panel.getContent;
Prologue.rss.getState = Prologue.panel.getState;
Prologue.rss.setState = Prologue.panel.setState;
Prologue.rss.setTitle = Prologue.panel.setTitle;

Prologue.rss.callBack = function(req) {
	var xItem;
	var feed = '';
	var rssTitle = 'Erreur de chargement';
	if (req.getStatus()==200) {	
		var rss = req.getJson();
		if (rss) {
			rssTitle = rss.title;
			if (rss.items.length) {
				var feed = '<ul>';
				for (var i=0; i<rss.items.length && i<req.tag.qty; i++) {
					feed += '<li>';
					jItem = rss.items[i];
					var title = jItem.title;
					var link = jItem.link;
					if (link) 
						feed += '<a href="' + jItem.link + '" target="_blank" title="'+jItem.pubDate+'" style="text-decoration:none;color:#000;font-family:arial;font-size:12px;">' + title + '</a>';
					else
						feed += title;
					//if (i>=9) break;
				}
				feed += '</ul>';									
			}
		}
		else feed = 'Erreur';
	}
	else feed = 'Erreur';
	var cnt = Prologue.rss.getContent(req.tag.id);
	if (cnt) cnt.innerHTML = feed;
	Prologue.rss.setTitle(req.tag.id, rssTitle);
};

Prologue.rss.prototype.create = function() {
	Prologue.rss.callBaseMethod(this, 'create');
	var url = Prologue.framework.path + '/rss/rssReader.php?path='+escape(this.url);
	var req = new Prologue.ajax.request(url);
	req.tag = {id:this.id,qty:this.itemsQty};
	req.callBack = Prologue.rss.callBack;
	req.send(null);
};

/**
* Classe de gestion d'un onglet du menu principal
* @author HPG
* @classDescription Classe de gestion d'un onglet du menu principal
* @extends {Prologue.panel};
* @constructor
* @param {String} color Couleur de l'onget a creer (#hhhhhh)
* @param {String} caption Libelle de l'onglet a creer
* @param {String} [icon] Icone de l'onglet a creer
*/
Prologue.mainMenuItem = function(color, caption, icon)
{
	Prologue.mainMenuItem.callBaseConstructor(this, caption, icon);
	this.color = (color||'#EFE7E7');
	this.treeview = new Prologue.treeView();
	this.onTitleClick = 'Prologue.mainMenu.titleClick(this);';
	this.ThemeID = '';
};
Prologue.mainMenuItem.extend(Prologue.panel);

Prologue.mainMenuItem.prototype.html = function()
{
	var tvwOnClick = this.treeview.onClick;
	this.treeview.onClick = 'Prologue.mainMenu.treeViewClick(this);' + tvwOnClick;
	var tmp = '<tr>';
	tmp += '<td style="vertical-align:top;padding-right:2px;width:9px;">';
	tmp += '<img src="'+Prologue.framework.images+'/puce_panel.gif" style="background-color:' + this.color + ';"/>';
	tmp += '</td>';
	tmp += '<td style="vertical-align:top;padding-bottom:3px;">';
	this.content = this.treeview.html();
	tmp += Prologue.mainMenuItem.callBaseMethod(this, 'html');
	tmp += '</td>';
	tmp += '</tr>';
	this.treeview.onClick = tvwOnClick;
	return tmp;
};

Prologue.mainMenuItem.prototype.bind = function(xNde)
{
	bindXmlToObj(this.title, xNde.firstChild);
	bindXmlToObj(this, xNde.firstChild);
	this.treeview.nodes.bind(xNde);
};
/**
 * Classe de gestion du menu principal
 * @author HPG
 * @classDescription Classe de gestion du menu principal
 * @extends {Prologue.control}
 * @constructor
 * @param {String} id Numero unique identifiant le menu dans la page HTML
 * @param {String} onClick (Javascript) Action a realiser lors du click sur le menu 
 * @param {String} className (Css) Style du menu 'prlMainMenu' par defaut
 */
Prologue.mainMenu = function(id, onClick, className)
{
	Prologue.mainMenu.callBaseConstructor(this, id, (className||'prlMainMenu'), '', onClick);
	this.items = [];
	this.dataSources = [];
	this.value = '';
	this.clientHeight = '200px';
	this.clientWidth = '100%';
	//this.itemOnClick = 'menuOnClick(Prologue.treeView.getSelected(this).value);';
	this.itemOnClick = '';
	this.colors = ['#EE8100','#FCC41E','#B54075','#CECB00','#00B2E7','#7BC5BC','#E3DED9','#D9D3CC','#C5BEB4'];
};
Prologue.mainMenu.extend(Prologue.control);
/**
 * Ajoute un nouvel onglet au menu principal
 * @param {String} color Couleur de l'onget a creer (#hhhhhh)
 * @param {String} caption Libelle de l'onglet a creer
 * @param {String} [icon] Icone de l'onglet a creer
 * @return {Prologue.mainMenuItem} retourne la nouvelle instance de l'onglet cree
 * @memberOf {Prologue.mainMenu}
 * @method
 */
Prologue.mainMenu.prototype.add = function(caption, color, themeID, icon)
{
	var pos = this.items.length;
	color = (color||this.colors[pos%9]);
	themeID = (themeID||pos+1);
	this.items[pos] = new Prologue.mainMenuItem(color, caption, icon);
	this.items[pos].themeID = themeID;
	this.items[pos].clientHeight = this.clientHeight;
	this.items[pos].treeview.onClick = this.itemOnClick;
	return this.items[pos];
};
Prologue.mainMenu.prototype.addSource = function(menuUrl, menuRoot, method, parameters)
{
	var ds = {
		'url':menuUrl,
		'method':(method||'GET'),
		'parameters':(parameters||''),
		'menuRoot':(menuRoot||'')
	};
	this.dataSources[this.dataSources.length] = ds;
}
/**
 * Retourne le nombre d'onglets dans le menu
 * @return {Number} Nombre d'onglets dans le menu
 * @memberOf {Prologue.mainMenu}
 * @method
 */
Prologue.mainMenu.prototype.count = function()
{
	return this.items.length;
};
/**
 * Enumeration de l'etat d'un onglet ouvert/ferme
 * @memberOf {Prologue.mainMenu}
 */
Prologue.mainMenu.itemState =
{
	'unSelected':0,
	'selected':1
};
/**
 * Retourne le fragment HTML correspondant au menu principal
 * @return {String} Fragment HTML correspondant au menu principal
 * @memberOf {Prologue.mainMenu}
 * @method
 */
Prologue.mainMenu.prototype.html = function()
{
	function getItemByID(items, id) {
		for (var pItem=0; pItem<items.length; pItem++) {
			if (items[pItem].themeID == id) return items[pItem];
		}
		return null;
	};
	function affectRootMenu(item, root) {
		if (root) {
			if (item.value) item.value = root+'/'+item.value;
			if (item.icon) item.icon = root+'/'+item.icon;
			for (var pSub=0; pSub<item.childs.count(); pSub++) {
				affectRootMenu(item.childs.item(pSub), root);
			}
		}
	};
	//chargement des datasources
	for (var pDs=0; pDs<this.dataSources.length; pDs++) {
		var ds = this.dataSources[pDs];
		var req = new Prologue.ajax.request(ds.url, ds.method);
		req.send(ds.parameters);
		var resp = req.getXML();
		if (resp)
		{
			var xRoot = resp.documentElement;
			for (var pItem=0; pItem<xRoot.childNodes.length; pItem++)
			{
				var xItem = xRoot.childNodes[pItem];
				if (xItem.nodeName=='section')
				{
					var atb = xItem.attributes.getNamedItem('name');
					if (atb) {
						var itm = getItemByID(this.items,atb.value);
						if (!itm) {
							var atbs = {
								 caption:lang_lbl_unamed
								,color:this.colors[this.items.length%this.colors.length]
								,icon:''
								,name:''
							}
							bindXmlToObj(atbs, xItem);
							itm = this.add(atbs.caption, atbs.color, atbs.name, atbs.icon);
						}
						if (itm) {
							for (var xRow,pRow=0; xRow=xItem.childNodes[pRow++];) {
								if (xRow.nodeName=='row') {
									var tvw = itm.treeview;
									var nde = new Prologue.node();
									nde.bind(xRow);
									//correction de l'url de destination
									affectRootMenu(nde, ds.menuRoot);
									tvw.nodes.items.push(nde);
								}
							}
						}
					}
				}
			}
		}
	}
	//creation du html
	var tmp = '<table cellspacing="0" cellpadding="0" summary=""'+this.attributes()+' style="width:'+this.clientWidth+';">';
	for (var p=0; p<this.items.length; p++)
	{
		var item = this.items[p];
		item.open = (p==this.value);
		tmp += item.html();
	}
	tmp += '</table>';
	return tmp;
};

/**
 * (statique) Action click sur un onglet du menu
 * @memberOf {Prologue.mainMenu}
 * @param {TR} item titre de l'onget 
 */
Prologue.mainMenu.titleClick = function(item)
{
	var tr = item.parentNode.parentNode.parentNode.parentNode;
	var mm = tr.parentNode.parentNode;
	var index = -1;
	do
	{
		index++;
		tr = tr.previousSibling;	
	} while (tr);
	Prologue.mainMenu.setSelected(mm, index);
};
/**
 * (statique) Selectionne un onglet dans le menu
 * @memberOf {Prologue.mainMenu}
 * @param {String, TABLE} mainMenu
 * @param {Number} index
 */
Prologue.mainMenu.setSelected = function(mainMenu, index)
{
	if (typeof mainMenu == 'string')
		mainMenu = document.getElementById(mainMenu);
	if (mainMenu && mainMenu.nodeName=='TABLE')
	{
		for (var r = 0; r < mainMenu.rows.length; r++)
		{
			var pnl = mainMenu.rows[r].cells[1].firstChild;
			Prologue.panel.setState(pnl, (r==index)?Prologue.panel.states.open:Prologue.panel.states.close);			
		}
	}
}
/**
 * (statique) Retourne l'onglet et l'item selectionne dans le menu
 * @param {String, TABLE} mainMenu
 * @return {Number}
 */
Prologue.mainMenu.getSelected = function(mainMenu)
{
	var iPnl = -1;
	var tvwItem = null;
	if (typeof mainMenu == 'string')
		mainMenu = document.getElementById(mainMenu);
	if (mainMenu && mainMenu.nodeName=='TABLE')
	{
		for (var r = 0; r < mainMenu.rows.length; r++)
		{
			var pnl = mainMenu.rows[r].cells[1].firstChild;
			var st = Prologue.panel.getState(pnl);
			if (st==Prologue.panel.states.open)
			{
				iPnl = r;
				var cnt = Prologue.panel.getContent(pnl);
				if (cnt) {
					var tvw = cnt.firstChild;
					tvwItem = Prologue.treeView.getSelected(tvw);
				}
				break;
			}
		}
	}
	return {index:iPnl,item:tvwItem};
};

Prologue.mainMenu.treeViewClick = function(tree)
{
	var cItem = Prologue.treeView.getSelected(tree);
	if (cItem.index>=0)
	{
		var panel = tree.parentNode.parentNode.parentNode.parentNode.parentNode;
		var mm = panel.parentNode.parentNode.parentNode.parentNode;
		for (var r=0; r<mm.rows.length; r++)
		{
			var rTree = mm.rows[r].cells[1].firstChild.rows[1].cells[0].firstChild.firstChild;
			if (rTree!=tree) Prologue.treeView.unselect(rTree);
		}
	}
};
/**
 * Definir la hauteur du menu principal
 * @param {String, TABLE} mainMenu Id ou HtmlTableElement du Menu principal
 * @param {Number, String} height Hauteur du menu principal
 */
Prologue.mainMenu.setHeight = function(mainMenu, height)
{
	if (typeof mainMenu == 'string')
		mainMenu = document.getElementById(mainMenu);
	if (mainMenu && mainMenu.nodeName=='TABLE')
	{
		var h = parseInt(height, 10);
		for (var r = 0; r < mainMenu.rows.length; r++)
		{
			var cell = mainMenu.rows[r].cells[1];
			h -= (parseInt(cell.currentStyle.borderTopWidth)||0);
			h -= (parseInt(cell.currentStyle.borderBottomWidth)||0);					
			h -= (parseInt(cell.currentStyle.paddingTop)||0);
			h -= (parseInt(cell.currentStyle.paddingBottom)||0);			
			var pnl = cell.firstChild;
			h -= pnl.rows[0].offsetHeight;
		}
		for (var r = 0; r < mainMenu.rows.length; r++)
		{
			var pnl = mainMenu.rows[r].cells[1].firstChild;
			var div = pnl.rows[1].cells[0].firstChild;
			var dh = h;
			if (!Prologue.browser.ie) {
				dh -= (parseInt(div.currentStyle.borderTopWidth)||0);
				dh -= (parseInt(div.currentStyle.borderBottomWidth)||0);					
				dh -= (parseInt(div.currentStyle.paddingTop)||0);
				dh -= (parseInt(div.currentStyle.paddingBottom)||0);			
			}
			div.style.height = dh;
		}
	}
};
////////////////////////////////
/// prlSideBar Object ///
////////////////////////////////
Prologue.sideBar = function(id, className, toolTip, onClick)
{
	Prologue.sideBar.callBaseConstructor(this, id, (className||'prlSideBar') , toolTip, onClick);
	this.skin = (Prologue.framework.images+'/sideBar');
	this.images = {
		 topLeft:'topLeft.gif'
		,topMiddle:'topMiddle.gif'
		,topRight:'topRight.gif'
		,middleLeft:'middleLeft.gif'
		,middleMiddle:'middleMiddle.gif'
		,middleRight:'middleRight.gif'
		,bottomLeft:'bottomLeft.gif'
		,bottomMiddle:'bottomMiddle.gif'
		,bottomRight:'bottomRight.gif'
		,hHandle:'hHandle.gif'
		,vHandle:'vHandle.gif'
	}
	this.content = '&nbsp';
	this.contentID = '';
	this.anchor = Prologue.sideBar.ANCHOR.top;
	this.attributes = function() {
		var tmp = Prologue.grid.callBaseMethod(this, 'attributes')
			+ ' prlAnchor="'+this.anchor+'"'
			+ ' prlMargin="'+parseInt(this.margin||'0')+'"'
			+ ' cellspacing="0"'
			+ ' cellpadding="0"';
		return tmp;
	};
	this.margin = 25;
	this.onresize = null;
};
Prologue.sideBar.extend(Prologue.control);

Prologue.sideBar.prototype.create = function()
{
	Prologue.sideBar.callBaseMethod(this, 'create');
	var me = document.getElementById(this.id);	
	if (me) {
		if (this.contentID) {
			var obj = document.getElementById(this.contentID);
			if (obj) {
				var cnt = Prologue.sideBar.getContent(me);
				if (cnt) {
					cnt.innerHTML = obj.innerHTML;
					obj.removeNode(true);
				}
			}
		}
		me.prlResize = this.onresize;
		me.attachEvent('onmouseout',Prologue.sideBar.hide);
		me.prlClosed = false;
		me.prlCloseRequired = false;
		me.prlAttachHide=true;
		me.prlAttachShow=false;
		me.prlPlugged = false;
		window.attachEvent('onresize',new Function("Prologue.sideBar.resize('"+this.id+"');"));
		window.attachEvent('onload',new Function("Prologue.sideBar.resize('"+this.id+"');"));
	}
};

Prologue.sideBar.prototype.html = function () {
	return '<table'+this.attributes()+'>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.top)?'<tr>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.left)?'<td><img src="'+this.skin+'/'+this.images.topLeft+'"/></td>':'')
		 + '<td style="background:url('+this.skin+'/'+this.images.topMiddle+') repeat-x;text-align:center;vertical-align:middle;"><img src="'+this.skin+'/'+((this.anchor!=Prologue.sideBar.ANCHOR.bottom)?this.images.topMiddle:this.images.hHandle)+'"/></td>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.right)?'<td><img src="'+this.skin+'/'+this.images.topRight+'"/></td>':'')
		 + '</tr>':'')
		 + '<tr>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.left)?'<td style="background:url('+this.skin+'/'+this.images.middleLeft+') repeat-y;text-align:center;vertical-align:middle;"><img src="'+this.skin+'/'+((this.anchor!=Prologue.sideBar.ANCHOR.right)?this.images.middleLeft:this.images.vHandle)+'"/></td>':'')
		 + '<td class="prlSideBarContent" style="background-image:url('+this.skin+'/'+this.images.middleMiddle+');background-repeat:repeat;">'+(this.content||'&nbsp;')+'</td>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.right)?'<td style="background:url('+this.skin+'/'+this.images.middleRight+') repeat-y;text-align:center;vertical-align:middle;"><img src="'+this.skin+'/'+((this.anchor!=Prologue.sideBar.ANCHOR.left)?this.images.middleRight:this.images.vHandle)+'"/></td>':'')
		 + '</tr>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.bottom)?'<tr>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.left)?'<td><img src="'+this.skin+'/'+this.images.bottomLeft+'"/></td>':'')
		 + '<td style="background:url('+this.skin+'/'+this.images.bottomMiddle+') repeat-x;text-align:center;vertical-align:middle;"><img src="'+this.skin+'/'+((this.anchor!=Prologue.sideBar.ANCHOR.top)?this.images.bottomMiddle:this.images.hHandle)+'"/></td>'
		 + ((this.anchor!=Prologue.sideBar.ANCHOR.right)?'<td><img src="'+this.skin+'/'+this.images.bottomRight+'"/></td>':'')
		 + '</tr>':'')
		 + '</table>';
};

Prologue.sideBar.ANCHOR = {
	 top:0
	,right:1
	,bottom:2
	,left:3
};

Prologue.sideBar.getContent = function(sideBar) {
	var cnt = null;
	if (typeof sideBar == 'string') sideBar = document.getElementById(sideBar);
	if (sideBar && sideBar.nodeName=='TABLE') {
		var anchor = sideBar.attributes.getNamedItem('prlAnchor').value;
		switch (parseInt(anchor)) {
			case Prologue.sideBar.ANCHOR.top:
				cnt = sideBar.rows[0].cells[1];
				break;
			case Prologue.sideBar.ANCHOR.bottom:
				cnt = sideBar.rows[1].cells[1];
				break;
			case Prologue.sideBar.ANCHOR.left:
				cnt = sideBar.rows[1].cells[0];
				break;
			case Prologue.sideBar.ANCHOR.right:
				cnt = sideBar.rows[1].cells[1];
				break;
		}
	}
	return cnt;
};

Prologue.sideBar.setContent = function(sideBar, content) {
	var cnt = Prologue.sideBar.getContent(sideBar);
	if (cnt) cnt.innerHTML = content;
};

Prologue.sideBar.resize = function(sideBar) {
	if (typeof sideBar == 'string') sideBar = document.getElementById(sideBar);
	if (sideBar && sideBar.nodeName=='TABLE' && sideBar.attributes.getNamedItem('prlAnchor'))
	{
		var closed = sideBar.prlClosed;
		var anchor = sideBar.attributes.getNamedItem('prlAnchor').value;
		var margin = parseInt(sideBar.attributes.getNamedItem('prlMargin').value)||0;
		var newHeight = 0, newWidth = 0, cell;
		try {
			switch (parseInt(anchor)) {
				case Prologue.sideBar.ANCHOR.top:
					sideBar.style.top='0px';
					sideBar.style.left=margin+'px';
					cell = sideBar.rows[0].cells[1];
					newWidth = document.body.clientWidth-sideBar.rows[0].cells[0].offsetWidth-sideBar.rows[0].cells[2].offsetWidth-(2*margin);
					newHeight = parseInt(cell.style.height);
					break;
				case Prologue.sideBar.ANCHOR.bottom:
					sideBar.style.top=(document.body.clientHeight-sideBar.offsetHeight)+'px';
					sideBar.style.left=margin+'px';
					cell = sideBar.rows[1].cells[1];
					newWidth = document.body.clientWidth-sideBar.rows[1].cells[0].offsetWidth-sideBar.rows[1].cells[2].offsetWidth-(2*margin);
					newHeight = parseInt(cell.style.height);
					break;
				case Prologue.sideBar.ANCHOR.left:
					sideBar.style.top=margin+'px';
					sideBar.style.left=((closed)?-sideBar.rows[0].cells[0].offsetWidth:0)+'px';
					cell = sideBar.rows[1].cells[0];
					newWidth = parseInt(cell.style.width);
					newHeight = document.body.clientHeight-sideBar.rows[0].cells[1].offsetHeight-sideBar.rows[2].cells[1].offsetHeight-(2*margin);
					break;
				case Prologue.sideBar.ANCHOR.right:
					sideBar.style.top=margin+'px';
					sideBar.style.left=(document.body.clientWidth-((closed)?sideBar.rows[1].cells[0].offsetWidth:sideBar.offsetWidth))+'px';
					cell = sideBar.rows[1].cells[1];
					newWidth = parseInt(cell.style.width);
					newHeight = document.body.clientHeight-sideBar.rows[0].cells[1].offsetHeight-sideBar.rows[2].cells[1].offsetHeight-(2*margin);
					break;
			}
			if (cell) {
				if (typeof sideBar.prlResize == 'function')
					sideBar.prlResize.call(cell, newWidth, newHeight)
				cell.style.width=newWidth+'px';
				cell.style.height=newHeight+'px';
			}
		}
		catch (e) {};
	}
};

Prologue.sideBar.show = function(sideBar) {
	if (typeof sideBar == 'undefined' || typeof sideBar.srcElement != 'undefined') {
		sideBar = event.srcElement;
		while (!sideBar.attributes.getNamedItem('prlAnchor')) sideBar = sideBar.parentNode;
	}
	else if (typeof sideBar == 'string')
		sideBar = document.getElementById(sideBar);
	if (sideBar && sideBar.nodeName=='TABLE' && sideBar.attributes.getNamedItem('prlAnchor')) {
		
		var anchor = sideBar.attributes.getNamedItem('prlAnchor').value;//alert('show');
		try {
			switch (parseInt(anchor)) {
				case Prologue.sideBar.ANCHOR.top:
					sideBar.style.top='0px';
					break;
				case Prologue.sideBar.ANCHOR.bottom:
					sideBar.style.top=(document.body.clientHeight-sideBar.offsetHeight)+'px';
					break;
				case Prologue.sideBar.ANCHOR.left:
					sideBar.style.left='0px';
					break;
				case Prologue.sideBar.ANCHOR.right:
					sideBar.style.left=(document.body.clientWidth-sideBar.offsetWidth)+'px';
					break;
			}
		}
		catch (e) {};
		Prologue.animator.stop();
		sideBar.prlCloseRequired = false;
		sideBar.prlClosed = false;
	
		if (sideBar.prlAttachHide==false) {
			sideBar.attachEvent('onmouseout',Prologue.sideBar.hide);
			sideBar.prlAttachHide=true;
		}
		if (sideBar.prlAttachShow==true) {
			sideBar.detachEvent('onmouseover',Prologue.sideBar.show);
			sideBar.prlAttachShow=false;
		}
		
	}
};

Prologue.sideBar.hide = function(sideBar) {
	if (typeof sideBar == 'undefined' || typeof sideBar.srcElement != 'undefined') {
		sideBar = event.srcElement;
		while (!sideBar.attributes.getNamedItem('prlAnchor')) sideBar = sideBar.parentNode;
		if (sideBar.contains(event.toElement)) return;
	}
	else if (typeof sideBar == 'string')
		sideBar = document.getElementById(sideBar);
	if (sideBar && sideBar.nodeName=='TABLE' && sideBar.attributes.getNamedItem('prlAnchor')) {
		if (sideBar.prlPlugged == false) {
			sideBar.detachEvent('onmouseout',Prologue.sideBar.hide);	
			sideBar.attachEvent('onmouseover',Prologue.sideBar.show);
			if (!sideBar.prlCloseRequired) {
				sideBar.prlCloseRequired = true;
				window.setTimeout('Prologue.sideBar.hideTimeOut(\''+sideBar.id+'\');', 400);
			}
		if (sideBar.prlAttachHide==true) {
			sideBar.detachEvent('onmouseout',Prologue.sideBar.hide);
			sideBar.prlAttachHide=false;
		}
		if (sideBar.prlAttachShow==false) {
			sideBar.attachEvent('onmouseover',Prologue.sideBar.show);
			sideBar.prlAttachShow=true;
		}
		
		}
	}
};

Prologue.sideBar.hideTimeOut = function(sideBar) {
	if (typeof sideBar == 'string')
		sideBar = document.getElementById(sideBar);
	if (sideBar.prlPlugged == false) {
		if (sideBar && sideBar.nodeName=='TABLE' && sideBar.attributes.getNamedItem('prlAnchor')) {
			if (sideBar.prlCloseRequired) {
				sideBar.prlCloseRequired = false;
				Prologue.animator.add(sideBar, Prologue.sideBar.hideProgress, sideBar.id);
				Prologue.animator.start(5);
				sideBar.prlClosed = true;
			}
		}
	}
};

Prologue.sideBar.plug = function(sideBar) {
	if (typeof sideBar == 'string') sideBar = document.getElementById(sideBar);
	if (sideBar) {
		if (sideBar.prlPlugged ) {
			sideBar.prlPlugged = false;
			Prologue.sideBar.hide(sideBar);
		} else {
			sideBar.prlPlugged = true;
		}
		return sideBar.prlPlugged;
	} else {
		return false;
	}
};

Prologue.sideBar.isPlugged = function(sideBar)
{
	if (typeof sideBar == 'string') sideBar = document.getElementById(sideBar);
	if (sideBar) {
		return sideBar.prlPlugged;
	} else {
		return false;
	}
};


Prologue.sideBar.hideProgress = function(sideBar) {
	if (typeof sideBar == 'string')
		sideBar = document.getElementById(sideBar);
	if (sideBar && sideBar.nodeName=='TABLE' && sideBar.attributes.getNamedItem('prlAnchor')) {
		var anchor = sideBar.attributes.getNamedItem('prlAnchor').value;
		var theEnd = false;
		var step = 8;
		var pos = 0;
		var max = 0;
		try {
			switch (parseInt(anchor)) {
				case Prologue.sideBar.ANCHOR.top:
					max = -sideBar.rows[0].cells[1].offsetHeight;
					pos = parseInt(sideBar.style.top)-step;
					if (pos < max) pos = max;
					theEnd = (pos == max);
					sideBar.style.top=pos+'px';
					break;
				case Prologue.sideBar.ANCHOR.bottom:
					max = document.body.clientHeight-sideBar.rows[0].cells[0].offsetHeight;
					pos = parseInt(sideBar.style.top)+step;
					if (pos > max) pos = max;
					theEnd = (pos == max);
					sideBar.style.top=pos+'px';
					break;
				case Prologue.sideBar.ANCHOR.left:
					max = -sideBar.rows[0].cells[0].offsetWidth;
					pos = parseInt(sideBar.style.left)-step;
					if (pos < max) pos = max;
					theEnd = (pos == max);
					sideBar.style.left=pos+'px';
					break;
				case Prologue.sideBar.ANCHOR.right:
					max = document.body.clientWidth-sideBar.rows[0].cells[0].offsetWidth;
					pos = parseInt(sideBar.style.left)+step;
					if (pos > max) pos = max;
					theEnd = (pos == max);
					sideBar.style.left=pos+'px';
					break;
			}			
		}
		catch (e) {};
		return !theEnd;
	}
};

Prologue.animator = new function() {
	//Private
	var _timer = null;
	var _active = false;
	var _methods = [];
	function _stop() {
		if (_timer) {
			window.clearInterval(_timer);
			_timer = null;
			_active = false;
		}
	};
	function _reset() {
		_methods = [];
	};
	function _animate(e) {
		if (!_active) return false;
		var active = false;
		for (var i=_methods.length; i--;) {
			var evt = _methods[i];
			if (evt) {
				if (evt.func(evt.object, evt.params))
					active = true;
				else {
					_methods.splice(i,1);
				}
			}
		}
		if (!active) {
			_stop();
			_reset();
		}
	};
  	//Public
  	return {
		start : function(interval) {
			if (_active==true) return false;
			_active = true;
			_timer = window.setInterval(_animate,(interval||10));
		}
		,add : function(obj, func ,parameters) {
			var evt = {
				func:func
				,params:parameters
				,object:obj
			};
			//if (typeof obj == 'string') 
			//	evt.object = document.getElementById(obj);
			if (evt.object && evt.func)
				_methods[_methods.length] = evt;
		}
		,stop : _stop
		,reset : _reset
		,animate : _animate
	}
};
