<?php
$DEFAULT_PATH = "../../../";
require_once($DEFAULT_PATH."struct.php");

$droitRole = SAD;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs

require_once($DEFAULT_PATH."flow.php");
require_once($DEFAULT_PATH."flow_tools.php");
$culture_content_type = "text/xml; charset=utf-8";
$culture_folder = $DEFAULT_PATH."culture";
require_once("$culture_folder/culture.php");
require_once($DEFAULT_PATH."inc/php/utils.php");

require_once($DEFAULT_PATH."flow.ini.php");

require_once($DEFAULT_PATH."inc/phpsvnclient/phpsvnclient.php");

$typeRef = pget('typeRef');
$refDir = pget('refDir');
$maxRow = 0;
$pageNum = pget('pageNum');
$pageSize = pget('pageSize');

if(!isset($pageNum) || $pageNum=='') $pageNum = 1;

// L'execution de ce script ne doit pas etre stoppe par le timeout php
set_time_limit(0);

$req = 'SELECT REF_URL_SVN, REF_LOGIN_SVN, REF_PASS_SVN FROM REFERENTIEL';

$gDb->SQLQuery($req,1);
$row = $gDb->SQLNextRow(1);
$gDb->SQLFermeQuery(1);

$url_svn = $row['REF_URL_SVN'];

$phpsvnclient = new phpsvnclient($url_svn, $row['REF_LOGIN_SVN'], $row['REF_PASS_SVN']);

function getRefFiles($dir, $type)
{
	global $url_svn, $phpsvnclient, $pathFlow, $maxRow;
	
	switch($type)
	{
		case REF_TYPE_STYLE:
			$icon=$pathFlow.'style/imgs/icons/menu/xml.png';
		break;

		case REF_TYPE_FORM:
			$icon=$pathFlow.'style/imgs/icons/menu/form.png';
		break;

		case REF_TYPE_SCRIPT:
			$icon=$pathFlow.'style/imgs/icons/menu/python.png';
		break;

		case REF_TYPE_TRAD:
			$icon=$pathFlow.'style/imgs/icons/menu/invoice.gif';
		break;

		case REF_TYPE_MAPPING:
			$icon=$pathFlow.'style/imgs/icons/menu/mapping.png';
		break;

		case REF_TYPE_TBORD:
			$icon=$pathFlow.'style/imgs/icons/menu/control.gif';
		break;

		case REF_TYPE_BATCH:
			$icon=$pathFlow.'style/imgs/icons/menu/traitement.gif';
		break;
	}

	$ret = '';
	$ref_content = $phpsvnclient->getDirectoryFiles($dir);
	$nbRow = count($ref_content);
	
	$params = array();
	$params['droits'] = array('download' => true,
							'visu' => true);
	$maxRow = 0;
	for($i=1; $i<$nbRow; $i++) // le premier lment est le rpertoire lui-mme donc on le saute
	{
		if($ref_content[$i]['type']!='directory')
		{
			$name = substr(strrchr($ref_content[$i]['path'], '/'), 1);
			$params['url'] = $ref_content[$i]['path'];
			$ret .= '<row><item caption="'.hi_disp($name).'" icon="'.$icon.'" value="'.row_encode_JSON($params).'"/>';
			$ret .= '<item caption="'.$ref_content[$i]['version'].'" icon="" toolTip=""/>';
			$size = $phpsvnclient->getFileSize($ref_content[$i]['path'], $ref_content[$i]['version'], $ref_content[$i]['version']);
			$ret .= '<item caption="'.$size.'" icon="" toolTip=""/>';
			$date = date("d/m/Y H:i:s", strtotime($ref_content[$i]['last-mod']));
			$ret .= '<item caption="'.hi_disp($date).'" icon="" toolTip=""/>';
			$comment = $phpsvnclient->getFileLogs($ref_content[$i]['path'], $ref_content[$i]['version'], $ref_content[$i]['version']);
			$ret .= '<item caption="'.hi_disp($comment[0]['comment']).'" icon="" toolTip=""/>';
			$ret .= '</row>';
			$maxRow++;
		}
	}
	return $ret;
}

if(!isset($typeRef) || $typeRef=='') $typeRef = 0; // tous

$champs = array();
$champs[] = array("nom" => $lang_lbl_nom, "toolTip" => $lang_sui_pesit_grid_head_fichier, "sortMode" => "1");
$champs[] = array("nom" => $lang_admin_exp_ref_libel_revision, "toolTip" => $lang_admin_exp_ref_libel_revision, "sortMode" => "2");
$champs[] = array("nom" => $lang_admin_exp_ref_libel_taille, "toolTip" => $lang_admin_exp_ref_libel_taille_tooltip, "sortMode" => "2");
$champs[] = array("nom" => $lang_lbl_date, "toolTip" => $lang_lbl_datemodif, "sortMode" => "3");
$champs[] = array("nom" => $lang_admin_exp_ref_libel_comment, "toolTip" => $lang_admin_exp_ref_libel_comment, "sortMode" => "1");

$pos = strpos($refDir, ';') + 1;
$type = substr($refDir, 0, $pos);
$dir = substr($refDir, $pos);
$contenu = getRefFiles($dir, $type);

echo '<?xml version="1.0" encoding="UTF-8"?><databind maxRow="'.$maxRow.'" pageSize="'.$pageSize.'" pageNum="'.$pageNum.'">';
echo '<header>';	
foreach ($champs as $col)
	echo '<item caption="'.hi_disp($col['nom']).'" icon="" onClick="" toolTip="'.$col['toolTip'].'" sortMode="'.$col['sortMode'].'"/>';	
echo '</header>';

echo $contenu;

echo '</databind>';

?>