<?php
$DEFAULT_PATH = "../../../";
require_once ($DEFAULT_PATH."/inc/php/pclzip.lib.php");
require_once ($DEFAULT_PATH."struct.php");	//liste des define
$droitRole = SAD;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php"); //session_start, inclusions, créations des variables $gDb et $erreur_connect
include($DEFAULT_PATH."flow_tools.php"); //fonctions utilitaires (pget,...)

set_time_limit(0); // L'execution ne doit pas etre stoppe par le timeout php

$msg = '';

function delete_dir($path)
{
	return is_file($path) ? @unlink($path) : array_map('delete_dir',glob($path.'/*'))==@rmdir($path);
}

function read_line($f)
{
	$ret = '';
	do{
		$l = fgets($f);
		$ret .= $l;
	}while(!feof($f) && $l[strlen($l)-2]!=';' && substr($l, strlen($l)-3, 2)!='*/');
	return $ret;
}

function importSQL($file, $canCreate)
{
	global $gDb;
	
	$ret = true;
	
	$f = fopen($file, 'rb');
	if($f)
	{
		while(!feof($f) && ($req = read_line($f))!='')
		{
			if(substr($req, 0, 2)=='/*')
				continue;
			if($canCreate==false && substr($req, 0, 6)=='CREATE')
				continue;
			if($gDb->SQLQueryDirect($req, 1)==false)
				break;
			$gDb->SQLFermeQuery(1);
		}
		if(!feof($f))
			$ret = false;
		fclose($f);
	}
	return $ret;
}

if(isset($_FILES['file_name']['tmp_name']))
{
	$req = "SELECT FCO_VERSION, FCO_REPTMP_IHM  FROM FLOWCONF";
	$gDb->SQLQuery($req, 1);
	$row = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	$date = date("Y-m-d-H-i-s");
	$version_base = $row['FCO_VERSION'];
	$dirTmp = $row['FCO_REPTMP_IHM'].DIRECTORY_SEPARATOR.$date.DIRECTORY_SEPARATOR;
	if(mkdir($dirTmp))
	{
		$dest = $dirTmp.basename($_FILES['file_name']['name']);

		if(@move_uploaded_file($_FILES['file_name']['tmp_name'], $dest))
		{
			$archive = new PclZip($dest);
			if(($list=$archive->listContent())!=0)
			{
				$hasSQL = false;
				$hasXML = false;
				// on détermine ce qu'il y a à faire
				foreach($list as $file)
				{
					if($file['filename']=='archiveDB.sql') // Fichier SQL complet avec ou sans structure des tables
					{
						$hasSQL = true;
						break;
					}
					else if($file['filename']=='flux_export.xml') // import partiel
					{
						$hasXML = true;
						break;
					}
				}
				
				if($hasSQL) // import SQL complet
				{
					$fileSQL = $archive->extract(PCLZIP_OPT_BY_NAME, 'archiveDB.sql', PCLZIP_OPT_PATH, $dirTmp);
					$content = file_get_contents($fileSQL[0]['filename'], false, NULL, 0, 100);
					
					if(substr($content, 0, 15)!='/* Use it Flow ')
						$msg = $lang_admin_exp_restauration_error_not_uif_file;
					else
					{
						if(substr($content, 15, strpos($content, ' */') - 15)!=$version_base)
							$msg = $lang_admin_exp_restauration_error_not_version;
						else
						{
							$canCreate = true;
							$pos = strpos($content, '/* Installé sur ') +17;
							if(substr($content, $pos, strpos($content, ' */', $pos) - $pos)!=$ini_typeBase)
							{
								$canCreate = false;
								$msg = $lang_admin_exp_restauration_differentDB;
							}
							
							if(importSQL($fileSQL[0]['filename'], $canCreate))
							{
								$req = 'SELECT FCO_REPBIN_IHM, FCO_REPCOM_IHM, FCO_REP_STOCK_IHM FROM FLOWCONF';
								$gDb->SQLQuery($req, 1);
								$row = $gDb->SQLNextRow(1);
								$gDb->SQLFermeQuery(1);
								
								// pretrait.cnf
								$res = $archive->extract(PCLZIP_OPT_BY_NAME, 'pretrait.cnf', PCLZIP_OPT_PATH, $row['FCO_REPBIN_IHM']);
								
								// Fichiers/*.*  (non obligatoire)
								if($res)
									$archive->extract(PCLZIP_OPT_BY_EREG, '^fichiers[/\\]', PCLZIP_OPT_REMOVE_PATH, 'fichiers', PCLZIP_OPT_PATH, $row['FCO_REP_STOCK_IHM']);
								
								if($res)// Cli/*.*
								{
									$dirDest = substr($row['FCO_REPCOM_IHM'], 0, strrpos($row['FCO_REPCOM_IHM'], DIRECTORY_SEPARATOR));
									$res = $archive->extract(PCLZIP_OPT_BY_EREG, '^cli[/\\]', PCLZIP_OPT_REMOVE_PATH, 'cli', PCLZIP_OPT_PATH, $dirDest);
								}

								if($res)
									$msg .= $lang_admin_exp_restauration_ok;
								else
									$msg .= $lang_admin_exp_restauration_nok.' '.$archive->errorInfo(true);
							}
							else
								$msg .= $lang_admin_exp_restauration_nok;
						}
					}
				}
				else if($hasXML) // import de flux
				{
					$fileXML = $archive->extract(PCLZIP_OPT_BY_NAME, 'flux_export.xml', PCLZIP_OPT_PATH, $dirTmp);
					$_GET['action'] = 'import_flux';	// action
					$_GET['import_chem'] = $fileXML[0]['filename'];	// chemin du xml a importer
					$_GET['id_clt'] = $_SESSION['CLT_ID'];	// id client
					//$_GET['liste'] = ;	// liste des FLX_ID à importer non nécessaire
					$restore = 1;
					require_once ($DEFAULT_PATH."flux/avance/import/flux_import/flux_importAction.php");
					$msg = str_ireplace(array('<br>', '<br/>'), '\\n', $msg);
					$msg = str_ireplace(array('<b>', '</b>'), '', $msg);
					if($transaction)
					{
						$req = 'SELECT FCO_REPBIN_IHM, FCO_REPCOM_IHM FROM FLOWCONF';
						$gDb->SQLQuery($req, 1);
						$row = $gDb->SQLNextRow(1);
						$gDb->SQLFermeQuery(1);
						
						// pretrait.cnf
						$res = $archive->extract(PCLZIP_OPT_BY_NAME, 'pretrait.cnf', PCLZIP_OPT_PATH, $row['FCO_REPBIN_IHM']);

						if($res)// Cli/*.*
						{
							$dirDest = substr($row['FCO_REPCOM_IHM'], 0, strrpos($row['FCO_REPCOM_IHM'], DIRECTORY_SEPARATOR));
							$res = $archive->extract(PCLZIP_OPT_BY_EREG, '^cli[/\\]', PCLZIP_OPT_REMOVE_PATH, 'cli', PCLZIP_OPT_PATH, $dirDest);
						}

						if($res)
							$msg .= $lang_admin_exp_restauration_ok;
						else
							$msg .= $lang_admin_exp_restauration_nok.' '.$archive->errorInfo(true);
					}
					else
						$msg .= $lang_admin_exp_restauration_nok;
				}
				else // ni fichier sql ni fichier xml => c'est une erreur !
					$msg = $lang_admin_exp_restauration_error_not_uif_file;
			}
			else
				$msg = $lang_admin_exp_restauration_error_zip.$archive->errorInfo(true);
		}
		else
			$msg = $lang_admin_exp_restauration_error_file;
			
		delete_dir($dirTmp); // on supprime les fichiers extraits et le répertoire temporaire de travail
	}
	else
		$msg = $lang_admin_exp_restauration_error_tmp;
}
else
	$msg = $lang_admin_exp_restauration_error_file;
?>

<script language="javascript" type="text/javascript">window.parent.window.endUpload("<?php echo $msg; ?>");</script>