<?php
$DEFAULT_PATH = "../../../";
require_once ($DEFAULT_PATH."/inc/php/pclzip.lib.php");
require_once ($DEFAULT_PATH."struct.php");	//liste des define
$droitRole = SAD;
$lmcse = DROIT_LECT + DROIT_MODIF + DROIT_CREAT + DROIT_SUPPR; 	//droits en lmcs
require_once($DEFAULT_PATH."inc/php/utils.php");
require_once($DEFAULT_PATH."flow.php"); //session_start, inclusions, créations des variables $gDb et $erreur_connect
include($DEFAULT_PATH."flow_tools.php"); //fonctions utilitaires (pget,...)

require_once($DEFAULT_PATH."duplication.inc.php"); // pour la génération du CREATE TABLE pour MSSQL

set_time_limit(0); // L'execution ne doit pas etre stoppe par le timeout php

$file = pget('file');
$create = pget('create');
$save_blob = pget('blob');

$reponse['msg'] = '';

function escape($str)
{
	$search=array("\\","\0","\n","\r","\x1a","'",'"');
	$replace=array("\\\\","\\0","\\n","\\r","\Z","\'",'\"');
	return str_replace($search,$replace,$str);
}

function sql_create($table)
{
	global $gDb, $ini_typeBase;
	switch($ini_typeBase)
	{
		case 'mysql':
		{
			$req = "SHOW CREATE TABLE `$table`";
			$gDb->SQLQueryDirect($req, 2);
			$tableau = $gDb->SQLNextRow(2);
			$gDb->SQLFermeQuery(2);
			if($tableau)
			{
				$tableau[1] .= ";";
				return str_replace("CREATE TABLE", "CREATE TABLE IF NOT EXISTS", $tableau[1]);
			}
		}
		break;
		
		case 'mssql':
		{
			$exist = "IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[$table]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1) ";
			$champsList = getColumns($gDb, $table);
			
			$sep = '';
			$decl = '';
			foreach($champsList as $champ)
			{
				$secuIns = '';
				$decl .= $sep.formatCreate($champ, $gDb->TypeBase, $secuIns);
				$sep = ',';
			}
			$tableau = 'CREATE TABLE '.$secuIns.$table.$secuIns.' ('.$decl.');';
			return $exist.$tableau;
		}
		break;
		
		case 'oracle':
		{
			// Pas de clause IF NOT EXISTS avec Oracle...
			$req = "select dbms_metadata.get_ddl('TABLE', '$table') from dual";
			$gDb->SQLQueryDirect($req, 2);
			$tableau = $gDb->SQLNextRow(2);
			$gDb->SQLFermeQuery(2);
			if($tableau)
				return $tableau[1].';';
		}
		break;
	}
	return '';
}

function sql_export($create)
{
	global $gDb, $nomBase, $ini_typeBase;
	
	$version_base ='';
	$req = "SELECT FCO_VERSION FROM FLOWCONF";
	$gDb->SQLQuery($req,1);
	$version_base = $gDb->SQLNextRow(1);
	$gDb->SQLFermeQuery(1);
	// on récupère le champ binaire FCO_VALID // BG 28/02/2013 :commenté et laissé à vide pour l'instant
	$fco_valid ='';
	if($ini_typeBase=='mysql')
	{
		/*
        $req = "SELECT  CONVERT(FCO_VALID USING utf8) FROM FLOWCONF";
        $gDb->SQLQuery($req,1);
        $fco_valid = $gDb->SQLNextRow(1);
        $gDb->SQLFermeQuery(1);
        */
	}  
	if($ini_typeBase=='mssql')
	{
        /*
        $req = "SELECT convert(varbinary,FCO_VALID) AS FCO_VALID FROM FLOWCONF";
        $gDb->SQLQuery($req,1);
        $fco_valid = $gDb->SQLNextRow(1);
        $gDb->SQLFermeQuery(1);
        */
	}
	if($ini_typeBase=='oracle')
	{
        /*
        $req = "SELECT DBMS_LOB.substr(FCO_VALID) AS FCO_VALID FROM FLOWCONF;";
        $gDb->SQLQuery($req,1);
        $fco_valid = $gDb->SQLNextRow(1);
        $gDb->SQLFermeQuery(1);
        */
	}

	$secuIns = '';
	if($ini_typeBase=='mysql')
		$secuIns = '`';
	else
		$secuIns = '"';
	
	try
	{
		$dumpsql = fopen('archiveDB.sql', 'w');
		fwrite($dumpsql, "/* Use it Flow ${version_base[0]} */\n");
		fwrite($dumpsql, "/* Installé sur $ini_typeBase */\n");
		fwrite($dumpsql, "/* Sauvegarde de la base $nomBase */\n");

		$req = 'SHOW TABLES FROM '.$nomBase;
		$gDb->SQLQuery($req, 1);

		while ($donnees = $gDb->SQLNextRow(1))
		{
			$table = $donnees[0];
			$insertions = "";
			
			if($create)
				fwrite($dumpsql, sql_create($table)."\n");

			$req = 'SELECT * FROM '.$secuIns.$table.$secuIns;
			$gDb->SQLQuery($req, 2);
			while ($ligne = $gDb->SQLNextRow(2))
			{
				$insertions .= 'INSERT IGNORE INTO '.$secuIns.$table.$secuIns.' VALUES(';
				$sep = '';
				$flagFCO = false;
				foreach($ligne as $key => $row) // liste champs nommés /champs numérique !!
				{
					// gestion du FCO_VALID
					if ($ini_typeBase=='oracle' or $ini_typeBase=='mssql')
					{
						if(strval($key) == 'FCO_VALID') //  ORACLE et SQL Server : champ nommé FCO_VALID avant champ numérique FCO_VALID
							$flagFCO = true;
					}
					if($ini_typeBase=='mysql')
					{
						if(strval($key) =='FCO_MODE_STOCK') //  MySQL : champ nommé FCO_MODE_STOCK avant champ numérique FCO_VALID
							$flagFCO = true;
					}

					// values
					if(is_numeric($key))
					{
						if($flagFCO)
						{
							$insertions .= $sep."'".$fco_valid[0]."'";
							$flagFCO = false;
						}
						else
						{
							if(is_numeric($row))
								$insertions .= $sep.$row;
							else if($row===null)
								$insertions .= $sep.'NULL';
							else
								$insertions .= $sep."'".dblQ($row)."'";
							$sep = ', ';
						}
					} 
				}

				$insertions .= ");\n";
			}
			$gDb->SQLFermeQuery(2);
			if ($insertions != "")
				fwrite($dumpsql, $insertions);
		}
		$gDb->SQLFermeQuery(1);
		
		fclose($dumpsql);
	}
	catch(Exception $e)
	{
		return false;
	}

	return true;
}

// On ne fait le travail que si l'export de la base a fonctionné
if(sql_export($create=='1'))
{
	$archive = new PclZip($DEFAULT_PATH.$file);
	
	// compression de l'export de la base
	$v_list = $archive->create('archiveDB.sql', PCLZIP_OPT_REMOVE_ALL_PATH);
	if ($v_list == 0)
	{
		$reponse['msg'] = $lang_admin_exp_sauvegarde_nok;
		$reponse['return'] = 1;
	}
	else
	{
		@unlink('archiveDB.sql');
		
		$req = 'SELECT FCO_REPBIN_IHM, FCO_REPCOM_IHM, FCO_REP_STOCK_IHM FROM FLOWCONF';
		$gDb->SQLQuery($req, 1);
		$row = $gDb->SQLNextRow(1);
		$gDb->SQLFermeQuery(1);
		
		// Sauvegarde du pretrait.cnf
		$fileToSave = $row['FCO_REPBIN_IHM'].DIRECTORY_SEPARATOR.'pretrait.cnf';
		if (is_file($fileToSave))
		{
			$archive->add($fileToSave, PCLZIP_OPT_REMOVE_ALL_PATH);
		}

		if($save_blob=='1')
		{
			// Sauvegarde des Fichiers blobs
			$dirToSave = $row['FCO_REP_STOCK_IHM'];
			if(is_dir($dirToSave))
			{
				$archive->add($dirToSave, PCLZIP_OPT_REMOVE_PATH, $dirToSave, PCLZIP_OPT_ADD_PATH, 'fichiers'); // on sauvegarde Fichiers/*.*
			}
		}
		
		// Sauvegarde de l'arborescence /fmoteur/cli/
		$dirToSave = substr($row['FCO_REPCOM_IHM'], 0, strrpos($row['FCO_REPCOM_IHM'], DIRECTORY_SEPARATOR));
		if(is_dir($dirToSave))
		{
			$archive->add($dirToSave, PCLZIP_OPT_REMOVE_PATH, $dirToSave, PCLZIP_OPT_ADD_PATH, 'cli'); // on sauvegarde Cli/*.*
		}
		
		$reponse['msg'] = $lang_admin_exp_sauvegarde_ok;
		$reponse['return'] = 0;
	}
}
else
{
	$reponse['msg'] = $lang_admin_exp_sauvegarde_nok;
	$reponse['return'] = 1;
}

echo encode_JSON($reponse);
?>